import "./chunk-SFKV34FB.js";
import "./chunk-YNQN4LE7.js";
import "./chunk-ME2U4GBS.js";
import "./chunk-BEFPUR3G.js";
import {
  AdminApi
} from "./chunk-AP5GHUBV.js";
import "./chunk-Z7XVYGD6.js";
import {
  banner_default
} from "./chunk-WJSRKCWV.js";
import "./chunk-FNV26V2B.js";
import {
  grid_default
} from "./chunk-XCEM2TDB.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import "./chunk-6EEUFVIO.js";
import "./chunk-7EEXBAZ4.js";
import "./chunk-4L2VSKMK.js";
import "./chunk-DIMKLXAP.js";
import "./chunk-FH6YELOW.js";
import "./chunk-AX3TXADI.js";
import "./chunk-ZKRIRKRW.js";
import "./chunk-SACHAYPZ.js";
import "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import {
  Form
} from "./chunk-PSPR3SUN.js";
import "./chunk-2G3GM457.js";
import "./chunk-OATKFZXF.js";
import "./chunk-KNLDGZQ5.js";
import "./chunk-6KRH5U5H.js";
import {
  form_default
} from "./chunk-GOIBY4UW.js";
import {
  list_default
} from "./chunk-WPHOZTKQ.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import "./chunk-7XZT6QXJ.js";
import {
  form_control_default
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  button_default,
  content_default,
  e,
  first,
  n,
  page_default,
  patternfly_base_default,
  r,
  t
} from "./chunk-EOF5OWT7.js";
import {
  T,
  msg,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/admin-settings/AdminSettingsForm.ts
var AdminSettingsForm = class extends Form {
  //
  // Custom property accessors in Lit 2 require a manual call to requestUpdate(). See:
  // https://lit.dev/docs/v2/components/properties/#accessors-custom
  //
  set settings(value) {
    this._settings = value;
    this.requestUpdate();
  }
  get settings() {
    return this._settings;
  }
  static get styles() {
    return super.styles.concat(list_default);
  }
  getSuccessMessage() {
    return msg("Successfully updated settings.");
  }
  async send(data) {
    const result = await new AdminApi(DEFAULT_CONFIG).adminSettingsUpdate({
      settingsRequest: data
    });
    this.dispatchEvent(new CustomEvent("ak-admin-setting-changed"));
    return result;
  }
  renderForm() {
    return x`
            <ak-text-input
                name="avatars"
                label=${msg("Avatars")}
                value="${o(this._settings?.avatars)}"
                .bighelp=${x`
                    <p class="pf-c-form__helper-text">
                        ${msg(
      "Configure how authentik should show avatars for users. The following values can be set:"
    )}
                    </p>
                    <ul class="pf-c-list">
                        <li class="pf-c-form__helper-text">
                            <code>none</code>:
                            ${msg(
      "Disables per-user avatars and just shows a 1x1 pixel transparent picture"
    )}
                        </li>
                        <li class="pf-c-form__helper-text">
                            <code>gravatar</code>:
                            ${msg("Uses gravatar with the user's email address")}
                        </li>
                        <li class="pf-c-form__helper-text">
                            <code>initials</code>:
                            ${msg("Generated avatars based on the user's name")}
                        </li>
                        <li class="pf-c-form__helper-text">
                            ${msg(
      "Any URL: If you want to use images hosted on another server, you can set any URL. Additionally, these placeholders can be used:"
    )}
                            <ul class="pf-c-list">
                                <li class="pf-c-form__helper-text">
                                    <code>%(username)s</code>: ${msg("The user's username")}
                                </li>
                                <li class="pf-c-form__helper-text">
                                    <code>%(mail_hash)s</code>:
                                    ${msg("The email address, md5 hashed")}
                                </li>
                                <li class="pf-c-form__helper-text">
                                    <code>%(upn)s</code>:
                                    ${msg("The user's UPN, if set (otherwise an empty string)")}
                                </li>
                            </ul>
                        </li>
                        <li class="pf-c-form__helper-text">
                            ${msg(
      x`An attribute path like
                                    <code>attributes.something.avatar</code>, which can be used in
                                    combination with the file field to allow users to upload custom
                                    avatars for themselves.`
    )}
                        </li>
                    </ul>
                    <p class="pf-c-form__helper-text">
                        ${msg(
      "Multiple values can be set, comma-separated, and authentik will fallback to the next mode when no avatar could be found."
    )}
                        ${msg(
      x`For example, setting this to <code>gravatar,initials</code> will
                                attempt to get an avatar from Gravatar, and if the user has not
                                configured on there, it will fallback to a generated avatar.`
    )}
                    </p>
                `}
                required
            >
            </ak-text-input>
            <ak-switch-input
                name="defaultUserChangeName"
                label=${msg("Allow users to change name")}
                ?checked="${this._settings?.defaultUserChangeName}"
                help=${msg("Enable the ability for users to change their name.")}
            >
            </ak-switch-input>
            <ak-switch-input
                name="defaultUserChangeEmail"
                label=${msg("Allow users to change email")}
                ?checked="${this._settings?.defaultUserChangeEmail}"
                help=${msg("Enable the ability for users to change their email.")}
            >
            </ak-switch-input>
            <ak-switch-input
                name="defaultUserChangeUsername"
                label=${msg("Allow users to change username")}
                ?checked="${this._settings?.defaultUserChangeUsername}"
                help=${msg("Enable the ability for users to change their username.")}
            >
            </ak-switch-input>
            <ak-text-input
                name="eventRetention"
                label=${msg("Event retention")}
                required
                value="${o(this._settings?.eventRetention)}"
                .bighelp=${x`<p class="pf-c-form__helper-text">
                        ${msg("Duration after which events will be deleted from the database.")}
                    </p>
                    <p class="pf-c-form__helper-text">
                        ${msg(
      'When using an external logging solution for archiving, this can be set to "minutes=5".'
    )}
                    </p>
                    <p class="pf-c-form__helper-text">
                        ${msg(
      "This setting only affects new Events, as the expiration is saved per-event."
    )}
                    </p>
                    <ak-utils-time-delta-help></ak-utils-time-delta-help>`}
            >
            </ak-text-input>
            <ak-form-element-horizontal label=${msg("Footer links")} name="footerLinks">
                <ak-codemirror
                    mode=${"yaml" /* YAML */}
                    .value="${first(this._settings?.footerLinks, [])}"
                ></ak-codemirror>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "This option configures the footer links on the flow executor pages. It must be a valid YAML or JSON list and can be used as follows:"
    )}
                    <code>[{"name": "Link Name","href":"https://goauthentik.io"}]</code>
                </p>
            </ak-form-element-horizontal>
            <ak-switch-input
                name="gdprCompliance"
                label=${msg("GDPR compliance")}
                ?checked="${this._settings?.gdprCompliance}"
                help=${msg(
      "When enabled, all the events caused by a user will be deleted upon the user's deletion."
    )}
            >
            </ak-switch-input>
            <ak-switch-input
                name="impersonation"
                label=${msg("Impersonation")}
                ?checked="${this._settings?.impersonation}"
                help=${msg("Globally enable/disable impersonation.")}
            >
            </ak-switch-input>
            <ak-text-input
                name="defaultTokenDuration"
                label=${msg("Default token duration")}
                required
                value="${o(this._settings?.defaultTokenDuration)}"
                .bighelp=${x`<p class="pf-c-form__helper-text">
                        ${msg("Default duration for generated tokens")}
                    </p>
                    <ak-utils-time-delta-help></ak-utils-time-delta-help>`}
            >
            </ak-text-input>
            <ak-number-input
                label=${msg("Default token length")}
                required
                name="defaultTokenLength"
                value="${first(this._settings?.defaultTokenLength, 60)}"
                help=${msg("Default length of generated tokens")}
            ></ak-number-input>
        `;
  }
};
__decorateClass([
  n({ type: Object })
], AdminSettingsForm.prototype, "settings", 1);
AdminSettingsForm = __decorateClass([
  t("ak-admin-settings-form")
], AdminSettingsForm);

// src/admin/admin-settings/AdminSettingsPage.ts
var AdminSettingsPage = class extends AKElement {
  static get styles() {
    return [
      patternfly_base_default,
      button_default,
      page_default,
      grid_default,
      content_default,
      card_default,
      description_list_default,
      form_default,
      form_control_default,
      banner_default
    ];
  }
  constructor() {
    super();
    AdminSettingsPage.fetchSettings().then((settings) => {
      this.settings = settings;
    });
    this.save = this.save.bind(this);
    this.reset = this.reset.bind(this);
    this.addEventListener("ak-admin-setting-changed", this.handleUpdate.bind(this));
  }
  static async fetchSettings() {
    return await new AdminApi(DEFAULT_CONFIG).adminSettingsRetrieve();
  }
  async handleUpdate() {
    this.settings = await AdminSettingsPage.fetchSettings();
  }
  async save() {
    if (!this.form) {
      return;
    }
    await this.form.submit(new Event("submit"));
    this.settings = await AdminSettingsPage.fetchSettings();
  }
  async reset() {
    this.form?.resetForm();
  }
  render() {
    if (!this.settings) {
      return T;
    }
    return x`
            <ak-page-header icon="fa fa-cog" header="" description="">
                <span slot="header"> ${msg("System settings")} </span>
            </ak-page-header>
            <section class="pf-c-page__main-section pf-m-no-padding-mobile pf-l-grid pf-m-gutter">
                <div class="pf-c-card">
                    <div class="pf-c-card__body">
                        <ak-admin-settings-form id="form" .settings=${this.settings}>
                        </ak-admin-settings-form>
                    </div>
                    <div class="pf-c-card__footer">
                        <ak-spinner-button .callAction=${this.save} class="pf-m-primary"
                            >${msg("Save")}</ak-spinner-button
                        >
                        <ak-spinner-button .callAction=${this.reset} class="pf-m-secondary"
                            >${msg("Cancel")}</ak-spinner-button
                        >
                    </div>
                </div>
            </section>
        `;
  }
};
__decorateClass([
  e("ak-admin-settings-form#form")
], AdminSettingsPage.prototype, "form", 2);
__decorateClass([
  r()
], AdminSettingsPage.prototype, "settings", 2);
AdminSettingsPage = __decorateClass([
  t("ak-admin-settings")
], AdminSettingsPage);
export {
  AdminSettingsPage
};
//# sourceMappingURL=AdminSettingsPage-U6MZZMAS.js.map
