import {
  DefaultBrand
} from "./chunk-KSSYYYDR.js";
import "./chunk-GOSS526A.js";
import "./chunk-KAVSWSBX.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-EALY7PEX.js";
import "./chunk-Z7XVYGD6.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-XX4MPIVG.js";
import {
  TablePage
} from "./chunk-R63EXIDN.js";
import "./chunk-MCK5P3JY.js";
import "./chunk-O7KILHL6.js";
import "./chunk-DP47YJ62.js";
import "./chunk-TGYIXJOL.js";
import "./chunk-FOQO4NRV.js";
import "./chunk-JMBXTRNL.js";
import "./chunk-ZZAG5J6S.js";
import "./chunk-ZKRIRKRW.js";
import "./chunk-SACHAYPZ.js";
import {
  browser_default
} from "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import {
  ModelForm
} from "./chunk-ZVKXJXN6.js";
import "./chunk-PSPR3SUN.js";
import {
  FlowsInstancesListDesignationEnum
} from "./chunk-2G3GM457.js";
import "./chunk-OATKFZXF.js";
import "./chunk-KNLDGZQ5.js";
import "./chunk-6KRH5U5H.js";
import "./chunk-GOIBY4UW.js";
import "./chunk-WPHOZTKQ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-7XZT6QXJ.js";
import {
  TableColumn,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  CoreApi,
  DEFAULT_CONFIG,
  first,
  n,
  t
} from "./chunk-EOF5OWT7.js";
import {
  msg,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/brands/BrandForm.ts
var BrandForm = class extends ModelForm {
  loadInstance(pk) {
    return new CoreApi(DEFAULT_CONFIG).coreBrandsRetrieve({
      brandUuid: pk
    });
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated brand.") : msg("Successfully created brand.");
  }
  async send(data) {
    if (this.instance?.brandUuid) {
      return new CoreApi(DEFAULT_CONFIG).coreBrandsUpdate({
        brandUuid: this.instance.brandUuid,
        brandRequest: data
      });
    } else {
      return new CoreApi(DEFAULT_CONFIG).coreBrandsCreate({
        brandRequest: data
      });
    }
  }
  renderForm() {
    return x` <ak-form-element-horizontal
                label=${msg("Domain")}
                ?required=${true}
                name="domain"
            >
                <input
                    type="text"
                    value="${first(this.instance?.domain, window.location.host)}"
                    class="pf-c-form-control"
                    required
                />
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Matching is done based on domain suffix, so if you enter domain.tld, foo.domain.tld will still match."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal name="_default">
                <label class="pf-c-switch">
                    <input
                        class="pf-c-switch__input"
                        type="checkbox"
                        ?checked=${first(this.instance?._default, false)}
                    />
                    <span class="pf-c-switch__toggle">
                        <span class="pf-c-switch__toggle-icon">
                            <i class="fas fa-check" aria-hidden="true"></i>
                        </span>
                    </span>
                    <span class="pf-c-switch__label">${msg("Default")}</span>
                </label>
                <p class="pf-c-form__helper-text">
                    ${msg("Use this brand for each domain that doesn't have a dedicated brand.")}
                </p>
            </ak-form-element-horizontal>

            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Branding settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Title")}
                        ?required=${true}
                        name="brandingTitle"
                    >
                        <input
                            type="text"
                            value="${first(
      this.instance?.brandingTitle,
      DefaultBrand.brandingTitle
    )}"
                            class="pf-c-form-control"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg("Branding shown in page title and several other places.")}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Logo")}
                        ?required=${true}
                        name="brandingLogo"
                    >
                        <input
                            type="text"
                            value="${first(this.instance?.brandingLogo, DefaultBrand.brandingLogo)}"
                            class="pf-c-form-control"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg("Icon shown in sidebar/header and flow executor.")}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Favicon")}
                        ?required=${true}
                        name="brandingFavicon"
                    >
                        <input
                            type="text"
                            value="${first(
      this.instance?.brandingFavicon,
      DefaultBrand.brandingFavicon
    )}"
                            class="pf-c-form-control"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg("Icon shown in the browser tab.")}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>
            <ak-form-group>
                <span slot="header"> ${msg("Default flows")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Authentication flow")}
                        name="flowAuthentication"
                    >
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.Authentication}
                            .currentFlow=${this.instance?.flowAuthentication}
                        ></ak-flow-search>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Flow used to authenticate users. If left empty, the first applicable flow sorted by the slug is used."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Invalidation flow")}
                        name="flowInvalidation"
                    >
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.Invalidation}
                            .currentFlow=${this.instance?.flowInvalidation}
                        ></ak-flow-search>

                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Flow used to logout. If left empty, the first applicable flow sorted by the slug is used."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal label=${msg("Recovery flow")} name="flowRecovery">
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.Recovery}
                            .currentFlow=${this.instance?.flowRecovery}
                        ></ak-flow-search>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Recovery flow. If left empty, the first applicable flow sorted by the slug is used."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Unenrollment flow")}
                        name="flowUnenrollment"
                    >
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.Unenrollment}
                            .currentFlow=${this.instance?.flowUnenrollment}
                        ></ak-flow-search>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "If set, users are able to unenroll themselves using this flow. If no flow is set, option is not shown."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("User settings flow")}
                        name="flowUserSettings"
                    >
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.StageConfiguration}
                            .currentFlow=${this.instance?.flowUserSettings}
                        ></ak-flow-search>
                        <p class="pf-c-form__helper-text">
                            ${msg("If set, users are able to configure details of their profile.")}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Device code flow")}
                        name="flowDeviceCode"
                    >
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.StageConfiguration}
                            .currentFlow=${this.instance?.flowDeviceCode}
                        ></ak-flow-search>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "If set, the OAuth Device Code profile can be used, and the selected flow will be used to enter the code."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>
            <ak-form-group>
                <span slot="header"> ${msg("Other global settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Web Certificate")}
                        name="webCertificate"
                    >
                        <ak-crypto-certificate-search
                            .certificate=${this.instance?.webCertificate}
                        ></ak-crypto-certificate-search>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal label=${msg("Attributes")} name="attributes">
                        <ak-codemirror
                            mode=${"yaml" /* YAML */}
                            value="${browser_default.stringify(first(this.instance?.attributes, {}))}"
                        >
                        </ak-codemirror>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Set custom attributes using YAML or JSON. Any attributes set here will be inherited by users, if the request is handled by this brand."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
BrandForm = __decorateClass([
  t("ak-brand-form")
], BrandForm);

// src/admin/brands/BrandListPage.ts
var BrandListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "domain";
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Brands");
  }
  pageDescription() {
    return msg("Configure visual settings and defaults for different domains.");
  }
  pageIcon() {
    return "pf-icon pf-icon-tenant";
  }
  async apiEndpoint(page) {
    return new CoreApi(DEFAULT_CONFIG).coreBrandsList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || ""
    });
  }
  columns() {
    return [
      new TableColumn(msg("Domain"), "domain"),
      new TableColumn(msg("Brand name"), "branding_title"),
      new TableColumn(msg("Default?"), "default"),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Brand(s)")}
            .objects=${this.selectedElements}
            .metadata=${(item) => {
      return [{ key: msg("Domain"), value: item.domain }];
    }}
            .usedBy=${(item) => {
      return new CoreApi(DEFAULT_CONFIG).coreBrandsUsedByList({
        brandUuid: item.brandUuid
      });
    }}
            .delete=${(item) => {
      return new CoreApi(DEFAULT_CONFIG).coreBrandsDestroy({
        brandUuid: item.brandUuid
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    return [
      x`${item.domain}`,
      x`${item.brandingTitle}`,
      x`<ak-status-label ?good=${item._default}></ak-status-label>`,
      x`<ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg("Update Brand")} </span>
                    <ak-brand-form slot="form" .instancePk=${item.brandUuid}> </ak-brand-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>

                <ak-rbac-object-permission-modal
                    model=${RbacPermissionsAssignedByUsersListModelEnum.BrandsBrand}
                    objectPk=${item.brandUuid}
                >
                </ak-rbac-object-permission-modal>`
    ];
  }
  renderObjectCreate() {
    return x`
            <ak-forms-modal>
                <span slot="submit"> ${msg("Create")} </span>
                <span slot="header"> ${msg("Create Brand")} </span>
                <ak-brand-form slot="form"> </ak-brand-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-forms-modal>
        `;
  }
};
__decorateClass([
  n()
], BrandListPage.prototype, "order", 2);
BrandListPage = __decorateClass([
  t("ak-brand-list")
], BrandListPage);
export {
  BrandListPage
};
//# sourceMappingURL=BrandListPage-FVUEVY66.js.map
