import "./chunk-GOSS526A.js";
import "./chunk-KAVSWSBX.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-EALY7PEX.js";
import "./chunk-Z7XVYGD6.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-XX4MPIVG.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import "./chunk-Y5HTBO47.js";
import {
  TablePage
} from "./chunk-R63EXIDN.js";
import "./chunk-O7KILHL6.js";
import "./chunk-DP47YJ62.js";
import {
  AlgEnum,
  CryptoApi
} from "./chunk-FOQO4NRV.js";
import "./chunk-SACHAYPZ.js";
import "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import {
  ModelForm
} from "./chunk-ZVKXJXN6.js";
import {
  Form
} from "./chunk-PSPR3SUN.js";
import "./chunk-6KRH5U5H.js";
import "./chunk-GOIBY4UW.js";
import "./chunk-WPHOZTKQ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-7XZT6QXJ.js";
import {
  TableColumn,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  DEFAULT_CONFIG,
  n,
  t
} from "./chunk-EOF5OWT7.js";
import {
  msg,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/crypto/CertificateGenerateForm.ts
var CertificateKeyPairForm = class extends Form {
  getSuccessMessage() {
    return msg("Successfully generated certificate-key pair.");
  }
  async send(data) {
    return new CryptoApi(DEFAULT_CONFIG).cryptoCertificatekeypairsGenerateCreate({
      certificateGenerationRequest: data
    });
  }
  renderForm() {
    return x`<ak-form-element-horizontal
                label=${msg("Common Name")}
                name="commonName"
                ?required=${true}
            >
                <input type="text" class="pf-c-form-control" required />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Subject-alt name")} name="subjectAltName">
                <input class="pf-c-form-control" type="text" />
                <p class="pf-c-form__helper-text">
                    ${msg("Optional, comma-separated SubjectAlt Names.")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Validity days")}
                name="validityDays"
                ?required=${true}
            >
                <input class="pf-c-form-control" type="number" value="365" />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Private key Algorithm")}
                ?required=${true}
                name="alg"
            >
                <ak-radio
                    .options=${[
      {
        label: msg("RSA"),
        value: AlgEnum.Rsa,
        default: true
      },
      {
        label: msg("ECDSA"),
        value: AlgEnum.Ecdsa
      }
    ]}
                >
                </ak-radio>
                <p class="pf-c-form__helper-text">
                    ${msg("Algorithm used to generate the private key.")}
                </p>
            </ak-form-element-horizontal> `;
  }
};
CertificateKeyPairForm = __decorateClass([
  t("ak-crypto-certificate-generate-form")
], CertificateKeyPairForm);

// src/admin/crypto/CertificateKeyPairForm.ts
var CertificateKeyPairForm2 = class extends ModelForm {
  loadInstance(pk) {
    return new CryptoApi(DEFAULT_CONFIG).cryptoCertificatekeypairsRetrieve({
      kpUuid: pk
    });
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated certificate-key pair.") : msg("Successfully created certificate-key pair.");
  }
  async send(data) {
    if (this.instance) {
      return new CryptoApi(DEFAULT_CONFIG).cryptoCertificatekeypairsPartialUpdate({
        kpUuid: this.instance.pk || "",
        patchedCertificateKeyPairRequest: data
      });
    } else {
      return new CryptoApi(DEFAULT_CONFIG).cryptoCertificatekeypairsCreate({
        certificateKeyPairRequest: data
      });
    }
  }
  renderForm() {
    return x` <ak-form-element-horizontal label=${msg("Name")} name="name" ?required=${true}>
                <input
                    type="text"
                    value="${o(this.instance?.name)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Certificate")}
                name="certificateData"
                ?writeOnly=${this.instance !== void 0}
                ?required=${true}
            >
                <textarea class="pf-c-form-control" required></textarea>
                <p class="pf-c-form__helper-text">${msg("PEM-encoded Certificate data.")}</p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                name="keyData"
                ?writeOnly=${this.instance !== void 0}
                label=${msg("Private Key")}
            >
                <textarea class="pf-c-form-control"></textarea>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Optional Private Key. If this is set, you can use this keypair for encryption."
    )}
                </p>
            </ak-form-element-horizontal>`;
  }
};
CertificateKeyPairForm2 = __decorateClass([
  t("ak-crypto-certificate-form")
], CertificateKeyPairForm2);

// src/admin/crypto/CertificateKeyPairListPage.ts
var CertificateKeyPairListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.expandable = true;
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Certificate-Key Pairs");
  }
  pageDescription() {
    return msg(
      "Import certificates of external providers or create certificates to sign requests with."
    );
  }
  pageIcon() {
    return "pf-icon pf-icon-key";
  }
  static get styles() {
    return super.styles.concat(description_list_default);
  }
  async apiEndpoint(page) {
    return new CryptoApi(DEFAULT_CONFIG).cryptoCertificatekeypairsList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || ""
    });
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Private key available?")),
      new TableColumn(msg("Expiry date")),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Certificate-Key Pair(s)")}
            .objects=${this.selectedElements}
            .metadata=${(item) => {
      return [
        { key: msg("Name"), value: item.name },
        { key: msg("Expiry"), value: item.certExpiry?.toLocaleString() }
      ];
    }}
            .usedBy=${(item) => {
      return new CryptoApi(DEFAULT_CONFIG).cryptoCertificatekeypairsUsedByList({
        kpUuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new CryptoApi(DEFAULT_CONFIG).cryptoCertificatekeypairsDestroy({
        kpUuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    let managedSubText = msg("Managed by authentik");
    if (item.managed && item.managed.startsWith("goauthentik.io/crypto/discovered")) {
      managedSubText = msg("Managed by authentik (Discovered)");
    }
    let color = "pf-m-green" /* Green */;
    if (item.certExpiry) {
      const now = /* @__PURE__ */ new Date();
      const inAMonth = /* @__PURE__ */ new Date();
      inAMonth.setDate(inAMonth.getDate() + 30);
      if (item.certExpiry <= inAMonth) {
        color = "pf-m-orange" /* Orange */;
      }
      if (item.certExpiry <= now) {
        color = "pf-m-red" /* Red */;
      }
    }
    return [
      x`<div>${item.name}</div>
                ${item.managed ? x`<small>${managedSubText}</small>` : x``}`,
      x`<ak-status-label
                type="info"
                ?good=${item.privateKeyAvailable}
                good-label=${msg(str`Yes (${item.privateKeyType?.toUpperCase()})`)}
            >
            </ak-status-label>`,
      x`<ak-label color=${color}> ${item.certExpiry?.toLocaleString()} </ak-label>`,
      x`<ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg("Update Certificate-Key Pair")} </span>
                    <ak-crypto-certificate-form slot="form" .instancePk=${item.pk}>
                    </ak-crypto-certificate-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                <ak-rbac-object-permission-modal
                    model=${RbacPermissionsAssignedByUsersListModelEnum.CryptoCertificatekeypair}
                    objectPk=${item.pk}
                >
                </ak-rbac-object-permission-modal>`
    ];
  }
  renderExpanded(item) {
    return x`<td role="cell" colspan="4">
                <div class="pf-c-table__expandable-row-content">
                    <dl class="pf-c-description-list pf-m-horizontal">
                        <div class="pf-c-description-list__group">
                            <dt class="pf-c-description-list__term">
                                <span class="pf-c-description-list__text"
                                    >${msg("Certificate Fingerprint (SHA1)")}</span
                                >
                            </dt>
                            <dd class="pf-c-description-list__description">
                                <div class="pf-c-description-list__text">
                                    ${item.fingerprintSha1}
                                </div>
                            </dd>
                        </div>
                        <div class="pf-c-description-list__group">
                            <dt class="pf-c-description-list__term">
                                <span class="pf-c-description-list__text"
                                    >${msg("Certificate Fingerprint (SHA256)")}</span
                                >
                            </dt>
                            <dd class="pf-c-description-list__description">
                                <div class="pf-c-description-list__text">
                                    ${item.fingerprintSha256}
                                </div>
                            </dd>
                        </div>
                        <div class="pf-c-description-list__group">
                            <dt class="pf-c-description-list__term">
                                <span class="pf-c-description-list__text"
                                    >${msg("Certificate Subject")}</span
                                >
                            </dt>
                            <dd class="pf-c-description-list__description">
                                <div class="pf-c-description-list__text">${item.certSubject}</div>
                            </dd>
                        </div>
                        <div class="pf-c-description-list__group">
                            <dt class="pf-c-description-list__term">
                                <span class="pf-c-description-list__text">${msg("Download")}</span>
                            </dt>
                            <dd class="pf-c-description-list__description">
                                <div class="pf-c-description-list__text">
                                    <a
                                        class="pf-c-button pf-m-secondary"
                                        target="_blank"
                                        href=${item.certificateDownloadUrl}
                                    >
                                        ${msg("Download Certificate")}
                                    </a>
                                    ${item.privateKeyAvailable ? x`<a
                                              class="pf-c-button pf-m-secondary"
                                              target="_blank"
                                              href=${item.privateKeyDownloadUrl}
                                          >
                                              ${msg("Download Private key")}
                                          </a>` : x``}
                                </div>
                            </dd>
                        </div>
                    </dl>
                </div>
            </td>
            <td></td>
            <td></td>`;
  }
  renderObjectCreate() {
    return x`
            <ak-forms-modal>
                <span slot="submit"> ${msg("Create")} </span>
                <span slot="header"> ${msg("Create Certificate-Key Pair")} </span>
                <ak-crypto-certificate-form slot="form"> </ak-crypto-certificate-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-forms-modal>
            <ak-forms-modal>
                <span slot="submit"> ${msg("Generate")} </span>
                <span slot="header"> ${msg("Generate Certificate-Key Pair")} </span>
                <ak-crypto-certificate-generate-form slot="form">
                </ak-crypto-certificate-generate-form>
                <button slot="trigger" class="pf-c-button pf-m-secondary">
                    ${msg("Generate")}
                </button>
            </ak-forms-modal>
        `;
  }
};
__decorateClass([
  n()
], CertificateKeyPairListPage.prototype, "order", 2);
CertificateKeyPairListPage = __decorateClass([
  t("ak-crypto-certificate-list")
], CertificateKeyPairListPage);
export {
  CertificateKeyPairListPage
};
//# sourceMappingURL=CertificateKeyPairListPage-FMZHMCUX.js.map
