import {
  EnterpriseApi
} from "./chunk-DLC2SRWI.js";
import "./chunk-T5SCNNG6.js";
import "./chunk-GOSS526A.js";
import "./chunk-KAVSWSBX.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-EALY7PEX.js";
import "./chunk-Z7XVYGD6.js";
import {
  banner_default
} from "./chunk-WJSRKCWV.js";
import "./chunk-FNV26V2B.js";
import {
  grid_default
} from "./chunk-XCEM2TDB.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import "./chunk-Y5HTBO47.js";
import {
  TablePage
} from "./chunk-R63EXIDN.js";
import "./chunk-O7KILHL6.js";
import "./chunk-DP47YJ62.js";
import "./chunk-SACHAYPZ.js";
import "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import {
  ModelForm
} from "./chunk-ZVKXJXN6.js";
import "./chunk-PSPR3SUN.js";
import "./chunk-6KRH5U5H.js";
import "./chunk-GOIBY4UW.js";
import "./chunk-WPHOZTKQ.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-7XZT6QXJ.js";
import {
  TableColumn,
  form_control_default,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  DEFAULT_CONFIG,
  EVENT_REFRESH_ENTERPRISE,
  button_default,
  getRelativeTime,
  n,
  r,
  t
} from "./chunk-EOF5OWT7.js";
import {
  i,
  msg,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/enterprise/EnterpriseLicenseForm.ts
var EnterpriseLicenseForm = class extends ModelForm {
  loadInstance(pk) {
    return new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseRetrieve({
      licenseUuid: pk
    });
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated license.") : msg("Successfully created license.");
  }
  async load() {
    this.installID = (await new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseGetInstallIdRetrieve()).installId;
  }
  async send(data) {
    return (this.instance ? new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicensePartialUpdate({
      licenseUuid: this.instance.licenseUuid || "",
      patchedLicenseRequest: data
    }) : new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseCreate({
      licenseRequest: data
    })).then((data2) => {
      window.dispatchEvent(new CustomEvent(EVENT_REFRESH_ENTERPRISE));
      return data2;
    });
  }
  renderForm() {
    return x`
            <ak-form-element-horizontal label=${msg("Install ID")}>
                <input class="pf-c-form-control" readonly type="text" value="${o(this.installID)}" />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal name="key" ?writeOnly=${this.instance !== void 0} label=${msg("License key")}>
                <textarea class="pf-c-form-control"></textarea>
            </ak-form-element-horizontal>`;
  }
};
__decorateClass([
  r()
], EnterpriseLicenseForm.prototype, "installID", 2);
EnterpriseLicenseForm = __decorateClass([
  t("ak-enterprise-license-form")
], EnterpriseLicenseForm);

// src/admin/enterprise/EnterpriseLicenseListPage.ts
var EnterpriseLicenseListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Licenses");
  }
  pageDescription() {
    return msg("Manage enterprise licenses");
  }
  pageIcon() {
    return "pf-icon pf-icon-key";
  }
  static get styles() {
    return super.styles.concat(
      description_list_default,
      grid_default,
      banner_default,
      form_control_default,
      button_default,
      card_default,
      i`
                .pf-m-no-padding-bottom {
                    padding-bottom: 0;
                }
                .install-id {
                    word-break: break-all;
                }
            `
    );
  }
  async apiEndpoint(page) {
    this.forecast = await new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseForecastRetrieve();
    this.summary = await new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseSummaryRetrieve();
    this.installID = (await new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseGetInstallIdRetrieve()).installId;
    return new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || ""
    });
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Users")),
      new TableColumn(msg("Expiry date")),
      new TableColumn(msg("Actions"))
    ];
  }
  // TODO: Make this more generic, maybe automatically get the plural name
  // of the object to use in the renderEmpty
  renderEmpty(inner) {
    return super.renderEmpty(x`
            ${inner ? inner : x`<ak-empty-state
                      icon=${this.pageIcon()}
                      header="${msg("No licenses found.")}"
                  >
                      <div slot="body">
                          ${this.searchEnabled() ? this.renderEmptyClearSearch() : x``}
                      </div>
                      <div slot="primary">${this.renderObjectCreate()}</div>
                  </ak-empty-state>`}
        `);
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("License(s)")}
            .objects=${this.selectedElements}
            .metadata=${(item) => {
      return [
        { key: msg("Name"), value: item.name },
        { key: msg("Expiry"), value: item.expiry?.toLocaleString() }
      ];
    }}
            .usedBy=${(item) => {
      return new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseUsedByList({
        licenseUuid: item.licenseUuid
      });
    }}
            .delete=${(item) => {
      return new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseDestroy({
        licenseUuid: item.licenseUuid
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  renderSectionBefore() {
    return x`
            <section class="pf-c-page__main-section pf-m-no-padding-bottom">
                <div
                    class="pf-l-grid pf-m-gutter pf-m-all-6-col-on-sm pf-m-all-4-col-on-md pf-m-all-3-col-on-lg pf-m-all-3-col-on-xl"
                >
                    ${this.renderGetLicenseCard()}
                    <ak-aggregate-card
                        class="pf-l-grid__item"
                        icon="pf-icon pf-icon-user"
                        header=${msg("Forecast internal users")}
                        subtext=${msg(
      str`Estimated user count one year from now based on ${this.forecast?.internalUsers} current internal users and ${this.forecast?.forecastedInternalUsers} forecasted internal users.`
    )}
                    >
                        ~&nbsp;${(this.forecast?.internalUsers || 0) + (this.forecast?.forecastedInternalUsers || 0)}
                    </ak-aggregate-card>
                    <ak-aggregate-card
                        class="pf-l-grid__item"
                        icon="pf-icon pf-icon-user"
                        header=${msg("Forecast external users")}
                        subtext=${msg(
      str`Estimated user count one year from now based on ${this.forecast?.externalUsers} current external users and ${this.forecast?.forecastedExternalUsers} forecasted external users.`
    )}
                    >
                        ~&nbsp;${(this.forecast?.externalUsers || 0) + (this.forecast?.forecastedExternalUsers || 0)}
                    </ak-aggregate-card>
                    <ak-aggregate-card
                        class="pf-l-grid__item"
                        icon="pf-icon pf-icon-user"
                        header=${msg("Expiry")}
                        subtext=${msg("Cumulative license expiry")}
                    >
                        ${this.summary?.hasLicense ? x`<div>${getRelativeTime(this.summary.latestValid)}</div>
                                  <small>${this.summary.latestValid.toLocaleString()}</small>` : "-"}
                    </ak-aggregate-card>
                </div>
            </section>
        `;
  }
  row(item) {
    let color = "pf-m-green" /* Green */;
    if (item.expiry) {
      const now = /* @__PURE__ */ new Date();
      const inAMonth = /* @__PURE__ */ new Date();
      inAMonth.setDate(inAMonth.getDate() + 30);
      if (item.expiry <= inAMonth) {
        color = "pf-m-orange" /* Orange */;
      }
      if (item.expiry <= now) {
        color = "pf-m-red" /* Red */;
      }
    }
    return [
      x`<div>${item.name}</div>`,
      x`<div>${msg(str`Internal: ${item.internalUsers}`)}</div>
                <div>${msg(str`External: ${item.externalUsers}`)}</div>`,
      x`<ak-label color=${color}> ${item.expiry?.toLocaleString()} </ak-label>`,
      x`<ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg("Update License")} </span>
                    <ak-enterprise-license-form slot="form" .instancePk=${item.licenseUuid}>
                    </ak-enterprise-license-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                <ak-rbac-object-permission-modal
                    model=${RbacPermissionsAssignedByUsersListModelEnum.EnterpriseLicense}
                    objectPk=${item.licenseUuid}
                >
                </ak-rbac-object-permission-modal> `
    ];
  }
  renderGetLicenseCard() {
    const renderSpinner = () => x` <div class="pf-c-card__body">
                <ak-spinner></ak-spinner>
            </div>`;
    const installURL = (installID) => [
      "https://customers.goauthentik.io/from_authentik/purchase/?install_id=",
      encodeURIComponent(installID),
      "&authentik_url=",
      encodeURI(window.location.origin)
    ].join("");
    const renderCard = (installID) => x`
            <div class="pf-c-card__title">${msg("Get a license")}</div>
            <div class="pf-c-card__body">
                <a
                    target="_blank"
                    href="${installURL(installID)}"
                    class="pf-c-button pf-m-primary pf-m-block"
                    >${msg("Go to Customer Portal")}</a
                >
            </div>
            <div class="pf-c-card__title">${msg("Your Install ID")}</div>
            <div class="pf-c-card__body install-id">${installID}</div>
        `;
    return x`<div class="pf-l-grid__item pf-c-card">
            ${this.installID ? renderCard(this.installID) : renderSpinner()}
        </div> `;
  }
  renderObjectCreate() {
    return x`
            <ak-forms-modal>
                <span slot="submit"> ${msg("Install")} </span>
                <span slot="header"> ${msg("Install License")} </span>
                <ak-enterprise-license-form slot="form"> </ak-enterprise-license-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Install")}</button>
            </ak-forms-modal>
        `;
  }
};
__decorateClass([
  n()
], EnterpriseLicenseListPage.prototype, "order", 2);
__decorateClass([
  r()
], EnterpriseLicenseListPage.prototype, "forecast", 2);
__decorateClass([
  r()
], EnterpriseLicenseListPage.prototype, "summary", 2);
__decorateClass([
  r()
], EnterpriseLicenseListPage.prototype, "installID", 2);
EnterpriseLicenseListPage = __decorateClass([
  t("ak-enterprise-license-list")
], EnterpriseLicenseListPage);
export {
  EnterpriseLicenseListPage
};
//# sourceMappingURL=EnterpriseLicenseListPage-HXHEZVPX.js.map
