import "./chunk-VEOO3EVI.js";
import "./chunk-NXBNBE6T.js";
import "./chunk-Q54K5KGS.js";
import {
  StagesApi
} from "./chunk-6L2VIJJF.js";
import {
  Diagram
} from "./chunk-I4DDVBVK.js";
import "./chunk-TEDVXOVK.js";
import "./chunk-P6KUVHV4.js";
import "./chunk-LKZJBMFY.js";
import "./chunk-RYAWZLUH.js";
import "./chunk-G5F4IS6Y.js";
import "./chunk-SFKV34FB.js";
import "./chunk-TESI44EG.js";
import "./chunk-JUAKJGB5.js";
import "./chunk-JSMKLBKU.js";
import "./chunk-KAVSWSBX.js";
import "./chunk-6CKD6XNN.js";
import "./chunk-7V5SMFL5.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-EALY7PEX.js";
import "./chunk-YNQN4LE7.js";
import "./chunk-ME2U4GBS.js";
import "./chunk-BEFPUR3G.js";
import "./chunk-AP5GHUBV.js";
import "./chunk-Z7XVYGD6.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-FNV26V2B.js";
import {
  grid_default
} from "./chunk-XCEM2TDB.js";
import "./chunk-XX4MPIVG.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import "./chunk-WGDMKZIG.js";
import "./chunk-HDTBIKDJ.js";
import "./chunk-W4RSYEXS.js";
import "./chunk-4L2VSKMK.js";
import "./chunk-DIMKLXAP.js";
import "./chunk-MCK5P3JY.js";
import "./chunk-O7KILHL6.js";
import "./chunk-IZQSSDOF.js";
import "./chunk-DP47YJ62.js";
import "./chunk-AX3TXADI.js";
import "./chunk-G6FYWANS.js";
import "./chunk-JMBXTRNL.js";
import {
  DesignationToLabel
} from "./chunk-ZZAG5J6S.js";
import "./chunk-KANCX4AI.js";
import "./chunk-ZKRIRKRW.js";
import "./chunk-4TARICXF.js";
import "./chunk-SACHAYPZ.js";
import "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import {
  ModelForm
} from "./chunk-ZVKXJXN6.js";
import "./chunk-PSPR3SUN.js";
import "./chunk-XSB422CX.js";
import "./chunk-X5TC2QXY.js";
import "./chunk-ZBQTYGSF.js";
import "./chunk-3CKWSC2S.js";
import {
  FlowsApi,
  FlowsInstancesListDesignationEnum,
  InvalidResponseActionEnum
} from "./chunk-2G3GM457.js";
import "./chunk-OATKFZXF.js";
import "./chunk-KNLDGZQ5.js";
import "./chunk-6KRH5U5H.js";
import "./chunk-GOIBY4UW.js";
import "./chunk-WPHOZTKQ.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-7XZT6QXJ.js";
import {
  Table,
  TableColumn,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  AKElement,
  AndNext,
  DEFAULT_CONFIG,
  PolicyEngineMode,
  button_default,
  content_default,
  first,
  groupBy,
  n,
  page_default,
  patternfly_base_default,
  r,
  t
} from "./chunk-EOF5OWT7.js";
import {
  i,
  msg,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/flows/StageBindingForm.ts
var StageBindingForm = class extends ModelForm {
  constructor() {
    super(...arguments);
    this.defaultOrder = 0;
  }
  async loadInstance(pk) {
    const binding = await new FlowsApi(DEFAULT_CONFIG).flowsBindingsRetrieve({
      fsbUuid: pk
    });
    this.defaultOrder = await this.getOrder();
    return binding;
  }
  getSuccessMessage() {
    if (this.instance?.pk) {
      return msg("Successfully updated binding.");
    } else {
      return msg("Successfully created binding.");
    }
  }
  send(data) {
    if (this.instance?.pk) {
      return new FlowsApi(DEFAULT_CONFIG).flowsBindingsPartialUpdate({
        fsbUuid: this.instance.pk,
        patchedFlowStageBindingRequest: data
      });
    } else {
      if (this.targetPk) {
        data.target = this.targetPk;
      }
      return new FlowsApi(DEFAULT_CONFIG).flowsBindingsCreate({
        flowStageBindingRequest: data
      });
    }
  }
  async getOrder() {
    if (this.instance?.pk) {
      return this.instance.order;
    }
    const bindings = await new FlowsApi(DEFAULT_CONFIG).flowsBindingsList({
      target: this.targetPk || ""
    });
    const orders = bindings.results.map((binding) => binding.order);
    if (orders.length < 1) {
      return 0;
    }
    return Math.max(...orders) + 1;
  }
  renderTarget() {
    if (this.instance?.target || this.targetPk) {
      return x``;
    }
    return x`<ak-form-element-horizontal
            label=${msg("Target")}
            ?required=${true}
            name="target"
        >
            <ak-flow-search
                flowType=${FlowsInstancesListDesignationEnum.Authorization}
                .currentFlow=${this.instance?.target}
                required
            ></ak-flow-search>
        </ak-form-element-horizontal>`;
  }
  renderForm() {
    return x` ${this.renderTarget()}
            <ak-form-element-horizontal label=${msg("Stage")} ?required=${true} name="stage">
                <ak-search-select
                    .fetchObjects=${async (query) => {
      const args = {
        ordering: "name"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const stages = await new StagesApi(DEFAULT_CONFIG).stagesAllList(args);
      return stages.results;
    }}
                    .groupBy=${(items) => {
      return groupBy(items, (stage) => stage.verboseNamePlural);
    }}
                    .renderElement=${(stage) => {
      return stage.name;
    }}
                    .value=${(stage) => {
      return stage?.pk;
    }}
                    .selected=${(stage) => {
      return stage.pk === this.instance?.stage;
    }}
                >
                </ak-search-select>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Order")} ?required=${true} name="order">
                <input
                    type="number"
                    value="${first(this.instance?.order, this.defaultOrder)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal name="evaluateOnPlan">
                <label class="pf-c-switch">
                    <input
                        class="pf-c-switch__input"
                        type="checkbox"
                        ?checked=${first(this.instance?.evaluateOnPlan, false)}
                    />
                    <span class="pf-c-switch__toggle">
                        <span class="pf-c-switch__toggle-icon">
                            <i class="fas fa-check" aria-hidden="true"></i>
                        </span>
                    </span>
                    <span class="pf-c-switch__label">${msg("Evaluate when flow is planned")}</span>
                </label>
                <p class="pf-c-form__helper-text">
                    ${msg("Evaluate policies during the Flow planning process.")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal name="reEvaluatePolicies">
                <label class="pf-c-switch">
                    <input
                        class="pf-c-switch__input"
                        type="checkbox"
                        ?checked=${first(this.instance?.reEvaluatePolicies, true)}
                    />
                    <span class="pf-c-switch__toggle">
                        <span class="pf-c-switch__toggle-icon">
                            <i class="fas fa-check" aria-hidden="true"></i>
                        </span>
                    </span>
                    <span class="pf-c-switch__label">${msg("Evaluate when stage is run")}</span>
                </label>
                <p class="pf-c-form__helper-text">
                    ${msg("Evaluate policies before the Stage is present to the user.")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Invalid response behavior")}
                ?required=${true}
                name="invalidResponseAction"
            >
                <ak-radio
                    .options=${[
      {
        label: "RETRY",
        value: InvalidResponseActionEnum.Retry,
        default: true,
        description: x`${msg(
          "Returns the error message and a similar challenge to the executor"
        )}`
      },
      {
        label: "RESTART",
        value: InvalidResponseActionEnum.Restart,
        description: x`${msg("Restarts the flow from the beginning")}`
      },
      {
        label: "RESTART_WITH_CONTEXT",
        value: InvalidResponseActionEnum.RestartWithContext,
        description: x`${msg(
          "Restarts the flow from the beginning, while keeping the flow context"
        )}`
      }
    ]}
                    .value=${this.instance?.invalidResponseAction}
                >
                </ak-radio>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Configure how the flow executor should handle an invalid response to a challenge given by this bound stage."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Policy engine mode")}
                ?required=${true}
                name="policyEngineMode"
            >
                <ak-radio
                    .options=${[
      {
        label: "any",
        value: PolicyEngineMode.Any,
        default: true,
        description: x`${msg("Any policy must match to grant access")}`
      },
      {
        label: "all",
        value: PolicyEngineMode.All,
        description: x`${msg("All policies must match to grant access")}`
      }
    ]}
                    .value=${this.instance?.policyEngineMode}
                >
                </ak-radio>
            </ak-form-element-horizontal>`;
  }
};
__decorateClass([
  n()
], StageBindingForm.prototype, "targetPk", 2);
__decorateClass([
  r()
], StageBindingForm.prototype, "defaultOrder", 2);
StageBindingForm = __decorateClass([
  t("ak-stage-binding-form")
], StageBindingForm);

// src/admin/flows/BoundStagesList.ts
var BoundStagesList = class extends Table {
  constructor() {
    super(...arguments);
    this.expandable = true;
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "order";
  }
  async apiEndpoint(page) {
    return new FlowsApi(DEFAULT_CONFIG).flowsBindingsList({
      target: this.target || "",
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage
    });
  }
  columns() {
    return [
      new TableColumn(msg("Order"), "order"),
      new TableColumn(msg("Name"), "stage__name"),
      new TableColumn(msg("Type")),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Stage binding(s)")}
            .objects=${this.selectedElements}
            .metadata=${(item) => {
      return [
        { key: msg("Stage"), value: item.stageObj?.name || "" },
        { key: msg("Stage type"), value: item.stageObj?.verboseName || "" }
      ];
    }}
            .usedBy=${(item) => {
      return new FlowsApi(DEFAULT_CONFIG).flowsBindingsUsedByList({
        fsbUuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new FlowsApi(DEFAULT_CONFIG).flowsBindingsDestroy({
        fsbUuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    return [
      x`<pre>${item.order}</pre>`,
      x`${item.stageObj?.name}`,
      x`${item.stageObj?.verboseName}`,
      x` <ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg(str`Update ${item.stageObj?.verboseName}`)} </span>
                    <ak-proxy-form
                        slot="form"
                        .args=${{
        instancePk: item.stage
      }}
                        type=${o(item.stageObj?.component)}
                    >
                    </ak-proxy-form>
                    <button slot="trigger" class="pf-c-button pf-m-secondary">
                        ${msg("Edit Stage")}
                    </button>
                </ak-forms-modal>
                <ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg("Update Stage binding")} </span>
                    <ak-stage-binding-form slot="form" .instancePk=${item.pk}>
                    </ak-stage-binding-form>
                    <button slot="trigger" class="pf-c-button pf-m-secondary">
                        ${msg("Edit Binding")}
                    </button>
                </ak-forms-modal>`
    ];
  }
  renderExpanded(item) {
    return x` <td></td>
            <td role="cell" colspan="4">
                <div class="pf-c-table__expandable-row-content">
                    <div class="pf-c-content">
                        <p>
                            ${msg(
      "These bindings control if this stage will be applied to the flow."
    )}
                        </p>
                        <ak-bound-policies-list .target=${item.policybindingmodelPtrId}>
                        </ak-bound-policies-list>
                    </div>
                </div>
            </td>`;
  }
  renderEmpty() {
    return super.renderEmpty(
      x`<ak-empty-state header=${msg("No Stages bound")} icon="pf-icon-module">
                <div slot="body">${msg("No stages are currently bound to this flow.")}</div>
                <div slot="primary">
                    <ak-forms-modal>
                        <span slot="submit"> ${msg("Create")} </span>
                        <span slot="header"> ${msg("Create Stage binding")} </span>
                        <ak-stage-binding-form slot="form" targetPk=${o(this.target)}>
                        </ak-stage-binding-form>
                        <button slot="trigger" class="pf-c-button pf-m-primary">
                            ${msg("Bind stage")}
                        </button>
                    </ak-forms-modal>
                </div>
            </ak-empty-state>`
    );
  }
  renderToolbar() {
    return x`
            <ak-stage-wizard
                createText=${msg("Create and bind Stage")}
                ?showBindingPage=${true}
                bindingTarget=${o(this.target)}
            ></ak-stage-wizard>
            <ak-forms-modal>
                <span slot="submit"> ${msg("Create")} </span>
                <span slot="header"> ${msg("Create Stage binding")} </span>
                <ak-stage-binding-form slot="form" targetPk=${o(this.target)}>
                </ak-stage-binding-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">
                    ${msg("Bind existing stage")}
                </button>
            </ak-forms-modal>
            ${super.renderToolbar()}
        `;
  }
};
__decorateClass([
  n()
], BoundStagesList.prototype, "target", 2);
BoundStagesList = __decorateClass([
  t("ak-bound-stages-list")
], BoundStagesList);

// src/admin/flows/FlowDiagram.ts
var FlowDiagram = class extends Diagram {
  constructor() {
    super(...arguments);
    this.refreshHandler = () => {
      this.diagram = void 0;
      new FlowsApi(DEFAULT_CONFIG).flowsInstancesDiagramRetrieve({
        slug: this.flowSlug || ""
      }).then((data) => {
        this.diagram = data.diagram;
        this.requestUpdate();
      });
    };
  }
};
__decorateClass([
  n()
], FlowDiagram.prototype, "flowSlug", 2);
FlowDiagram = __decorateClass([
  t("ak-flow-diagram")
], FlowDiagram);

// src/admin/flows/FlowViewPage.ts
var FlowViewPage = class extends AKElement {
  static get styles() {
    return [patternfly_base_default, page_default, description_list_default, button_default, card_default, content_default, grid_default].concat(i`
            img.pf-icon {
                max-height: 24px;
            }
            ak-tabs {
                height: 100%;
            }
        `);
  }
  fetchFlow(slug) {
    new FlowsApi(DEFAULT_CONFIG).flowsInstancesRetrieve({ slug }).then((flow) => {
      this.flow = flow;
    });
  }
  willUpdate(changedProperties) {
    if (changedProperties.has("flowSlug") && this.flowSlug) {
      this.fetchFlow(this.flowSlug);
    }
  }
  render() {
    if (!this.flow) {
      return x``;
    }
    return x`<ak-page-header
                icon="pf-icon pf-icon-process-automation"
                header=${this.flow.name}
                description=${this.flow.title}
            >
            </ak-page-header>
            <ak-tabs>
                <div
                    slot="page-overview"
                    data-tab-title="${msg("Flow Overview")}"
                    class="pf-c-page__main-section pf-m-no-padding-mobile"
                >
                    <div class="pf-l-grid pf-m-gutter">
                        <div
                            class="pf-c-card pf-l-grid__item pf-m-12-col pf-m-2-col-on-xl pf-m-2-col-on-2xl"
                        >
                            <div class="pf-c-card__title">${msg("Flow Info")}</div>
                            <div class="pf-c-card__body">
                                <dl class="pf-c-description-list">
                                    <div class="pf-c-description-list__group">
                                        <dt class="pf-c-description-list__term">
                                            <span class="pf-c-description-list__text"
                                                >${msg("Name")}</span
                                            >
                                        </dt>
                                        <dd class="pf-c-description-list__description">
                                            <div class="pf-c-description-list__text">
                                                ${this.flow.name}
                                            </div>
                                        </dd>
                                        <dt class="pf-c-description-list__term">
                                            <span class="pf-c-description-list__text"
                                                >${msg("Slug")}</span
                                            >
                                        </dt>
                                        <dd class="pf-c-description-list__description">
                                            <div class="pf-c-description-list__text">
                                                <code>${this.flow.slug}</code>
                                            </div>
                                        </dd>
                                        <dt class="pf-c-description-list__term">
                                            <span class="pf-c-description-list__text"
                                                >${msg("Designation")}</span
                                            >
                                        </dt>
                                        <dd class="pf-c-description-list__description">
                                            <div class="pf-c-description-list__text">
                                                ${DesignationToLabel(this.flow.designation)}
                                            </div>
                                        </dd>
                                        <dt class="pf-c-description-list__term">
                                            <span class="pf-c-description-list__text"
                                                >${msg("Related actions")}</span
                                            >
                                        </dt>
                                        <dd class="pf-c-description-list__description">
                                            <div class="pf-c-description-list__text">
                                                <ak-forms-modal>
                                                    <span slot="submit"> ${msg("Update")} </span>
                                                    <span slot="header">
                                                        ${msg("Update Flow")}
                                                    </span>
                                                    <ak-flow-form
                                                        slot="form"
                                                        .instancePk=${this.flow.slug}
                                                    >
                                                    </ak-flow-form>
                                                    <button
                                                        slot="trigger"
                                                        class="pf-c-button pf-m-block pf-m-secondary"
                                                    >
                                                        ${msg("Edit")}
                                                    </button>
                                                </ak-forms-modal>
                                            </div>
                                        </dd>
                                        <dt class="pf-c-description-list__term">
                                            <span class="pf-c-description-list__text"
                                                >${msg("Execute flow")}</span
                                            >
                                        </dt>
                                        <dd class="pf-c-description-list__description">
                                            <div class="pf-c-description-list__text">
                                                <button
                                                    class="pf-c-button pf-m-block pf-m-primary"
                                                    @click=${() => {
      const finalURL = `${window.location.origin}/if/flow/${this.flow.slug}/${AndNext(
        `${window.location.pathname}#${window.location.hash}`
      )}`;
      window.open(finalURL, "_blank");
    }}
                                                >
                                                    ${msg("Normal")}
                                                </button>
                                                <button
                                                    class="pf-c-button pf-m-block pf-m-secondary"
                                                    @click=${() => {
      new FlowsApi(DEFAULT_CONFIG).flowsInstancesExecuteRetrieve({
        slug: this.flow.slug
      }).then((link) => {
        const finalURL = `${link.link}${AndNext(
          `${window.location.pathname}#${window.location.hash}`
        )}`;
        window.open(finalURL, "_blank");
      });
    }}
                                                >
                                                    ${msg("with current user")}
                                                </button>
                                                <button
                                                    class="pf-c-button pf-m-block pf-m-secondary"
                                                    @click=${() => {
      new FlowsApi(DEFAULT_CONFIG).flowsInstancesExecuteRetrieve({
        slug: this.flow.slug
      }).then((link) => {
        const finalURL = `${link.link}?${encodeURI(
          `inspector&next=/#${window.location.hash}`
        )}`;
        window.open(finalURL, "_blank");
      }).catch((exc) => {
        window.open(
          exc.response.url,
          "_blank"
        );
      });
    }}
                                                >
                                                    ${msg("with inspector")}
                                                </button>
                                            </div>
                                        </dd>
                                        <dt class="pf-c-description-list__term">
                                            <span class="pf-c-description-list__text"
                                                >${msg("Export flow")}</span
                                            >
                                        </dt>
                                        <dd class="pf-c-description-list__description">
                                            <div class="pf-c-description-list__text">
                                                <a
                                                    class="pf-c-button pf-m-block pf-m-secondary"
                                                    href=${this.flow.exportUrl}
                                                >
                                                    ${msg("Export")}
                                                </a>
                                            </div>
                                        </dd>
                                    </div>
                                </dl>
                            </div>
                        </div>
                        <div
                            class="pf-c-card pf-l-grid__item pf-m-12-col pf-m-10-col-on-xl pf-m-10-col-on-2xl"
                        >
                            <div class="pf-c-card__title">${msg("Diagram")}</div>
                            <div class="pf-c-card__body">
                                <ak-flow-diagram flowSlug=${this.flow.slug}> </ak-flow-diagram>
                            </div>
                        </div>
                        <div
                            class="pf-c-card pf-l-grid__item pf-m-12-col pf-m-12-col-on-xl pf-m-12-col-on-2xl"
                        >
                            <div class="pf-c-card__title">${msg("Changelog")}</div>
                            <div class="pf-c-card__body">
                                <ak-object-changelog
                                    targetModelPk=${this.flow.pk || ""}
                                    targetModelApp="authentik_flows"
                                    targetModelName="flow"
                                >
                                </ak-object-changelog>
                            </div>
                        </div>
                    </div>
                </div>
                <div
                    slot="page-stage-bindings"
                    data-tab-title="${msg("Stage Bindings")}"
                    class="pf-c-page__main-section pf-m-no-padding-mobile"
                >
                    <div class="pf-c-card">
                        <div class="pf-c-card__body">
                            <ak-bound-stages-list .target=${this.flow.pk}> </ak-bound-stages-list>
                        </div>
                    </div>
                </div>
                <div
                    slot="page-policy-bindings"
                    data-tab-title="${msg("Policy / Group / User Bindings")}"
                    class="pf-c-page__main-section pf-m-no-padding-mobile"
                >
                    <div class="pf-c-card">
                        <div class="pf-c-card__title">
                            ${msg("These bindings control which users can access this flow.")}
                        </div>
                        <div class="pf-c-card__body">
                            <ak-bound-policies-list .target=${this.flow.policybindingmodelPtrId}>
                            </ak-bound-policies-list>
                        </div>
                    </div>
                </div>
                <ak-rbac-object-permission-page
                    slot="page-permissions"
                    data-tab-title="${msg("Permissions")}"
                    model=${RbacPermissionsAssignedByUsersListModelEnum.FlowsFlow}
                    objectPk=${this.flow.pk}
                ></ak-rbac-object-permission-page>
            </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], FlowViewPage.prototype, "flowSlug", 2);
__decorateClass([
  r()
], FlowViewPage.prototype, "flow", 2);
FlowViewPage = __decorateClass([
  t("ak-flow-view")
], FlowViewPage);
export {
  FlowViewPage
};
//# sourceMappingURL=FlowViewPage-YWGHCSVP.js.map
