import "./chunk-3WAQYJUF.js";
import "./chunk-6L2VIJJF.js";
import {
  sizing_default
} from "./chunk-RYS6P77X.js";
import {
  display_default
} from "./chunk-R2JM5IAT.js";
import "./chunk-G5F4IS6Y.js";
import "./chunk-SFKV34FB.js";
import "./chunk-TESI44EG.js";
import "./chunk-KAVSWSBX.js";
import "./chunk-6CKD6XNN.js";
import "./chunk-7V5SMFL5.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-EALY7PEX.js";
import "./chunk-YNQN4LE7.js";
import "./chunk-ME2U4GBS.js";
import "./chunk-BEFPUR3G.js";
import "./chunk-Z7XVYGD6.js";
import {
  banner_default
} from "./chunk-WJSRKCWV.js";
import "./chunk-FNV26V2B.js";
import {
  grid_default
} from "./chunk-XCEM2TDB.js";
import "./chunk-EGRHWZRV.js";
import "./chunk-XX4MPIVG.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import "./chunk-4L2VSKMK.js";
import "./chunk-O7KILHL6.js";
import "./chunk-IZQSSDOF.js";
import "./chunk-DP47YJ62.js";
import "./chunk-SACHAYPZ.js";
import "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import "./chunk-ZVKXJXN6.js";
import {
  Form
} from "./chunk-PSPR3SUN.js";
import "./chunk-X5TC2QXY.js";
import {
  WithCapabilitiesConfig
} from "./chunk-3CKWSC2S.js";
import "./chunk-2G3GM457.js";
import "./chunk-OATKFZXF.js";
import "./chunk-KNLDGZQ5.js";
import "./chunk-6KRH5U5H.js";
import "./chunk-GOIBY4UW.js";
import {
  list_default
} from "./chunk-WPHOZTKQ.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import "./chunk-XPFXHVQV.js";
import "./chunk-EEANTJCZ.js";
import {
  alert_default,
  showMessage
} from "./chunk-7XZT6QXJ.js";
import {
  Table,
  TableColumn,
  getURLParam,
  uiConfig,
  updateURLParams
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  AKElement,
  CapabilitiesEnum,
  CoreApi,
  CoreUsersListTypeEnum,
  DEFAULT_CONFIG,
  EVENT_REFRESH,
  WithBrandConfig,
  button_default,
  content_default,
  getRelativeTime,
  me,
  n,
  page_default,
  patternfly_base_default,
  r,
  t
} from "./chunk-EOF5OWT7.js";
import {
  T,
  msg,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/elements/user/utils.ts
function UserOption(user) {
  let finalString = user.username;
  if (user.name || user.email) {
    finalString += " (";
    if (user.name) {
      finalString += user.name;
      if (user.email) {
        finalString += ", ";
      }
    }
    if (user.email) {
      finalString += user.email;
    }
    finalString += ")";
  }
  return finalString;
}

// src/admin/groups/RelatedUserList.ts
var RelatedUserAdd = class extends Form {
  constructor() {
    super(...arguments);
    this.usersToAdd = [];
  }
  getSuccessMessage() {
    return msg("Successfully added user(s).");
  }
  async send(data) {
    await Promise.all(
      data.users.map((user) => {
        return new CoreApi(DEFAULT_CONFIG).coreGroupsAddUserCreate({
          groupUuid: this.group?.pk || "",
          userAccountRequest: {
            pk: user
          }
        });
      })
    );
    return data;
  }
  renderForm() {
    return x` <ak-form-element-horizontal label=${msg("Users to add")} name="users">
            <div class="pf-c-input-group">
                <ak-group-member-select-table
                    .confirm=${(items) => {
      this.usersToAdd = items;
      this.requestUpdate();
      return Promise.resolve();
    }}
                >
                    <button slot="trigger" class="pf-c-button pf-m-control" type="button">
                        <pf-tooltip position="top" content=${msg("Add users")}>
                            <i class="fas fa-plus" aria-hidden="true"></i>
                        </pf-tooltip>
                    </button>
                </ak-group-member-select-table>
                <div class="pf-c-form-control">
                    <ak-chip-group>
                        ${this.usersToAdd.map((user) => {
      return x`<ak-chip
                                .removable=${true}
                                value=${o(user.pk)}
                                @remove=${() => {
        const idx = this.usersToAdd.indexOf(user);
        this.usersToAdd.splice(idx, 1);
        this.requestUpdate();
      }}
                            >
                                ${UserOption(user)}
                            </ak-chip>`;
    })}
                    </ak-chip-group>
                </div>
            </div>
        </ak-form-element-horizontal>`;
  }
};
__decorateClass([
  n({ attribute: false })
], RelatedUserAdd.prototype, "group", 2);
__decorateClass([
  r()
], RelatedUserAdd.prototype, "usersToAdd", 2);
RelatedUserAdd = __decorateClass([
  t("ak-user-related-add")
], RelatedUserAdd);
var RelatedUserList = class extends WithBrandConfig(WithCapabilitiesConfig(Table)) {
  constructor() {
    super(...arguments);
    this.expandable = true;
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "last_login";
    this.hideServiceAccounts = getURLParam("hideServiceAccounts", true);
  }
  searchEnabled() {
    return true;
  }
  static get styles() {
    return super.styles.concat(description_list_default, alert_default, banner_default);
  }
  async apiEndpoint(page) {
    const users = await new CoreApi(DEFAULT_CONFIG).coreUsersList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || "",
      groupsByPk: this.targetGroup ? [this.targetGroup.pk] : [],
      type: this.hideServiceAccounts ? [CoreUsersListTypeEnum.External, CoreUsersListTypeEnum.Internal] : void 0,
      includeGroups: false
    });
    this.me = await me();
    return users;
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "username"),
      new TableColumn(msg("Active"), "is_active"),
      new TableColumn(msg("Last login"), "last_login"),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("User(s)")}
            actionLabel=${msg("Remove Users(s)")}
            action=${msg("removed")}
            actionSubtext=${msg(
      str`Are you sure you want to remove the selected users from the group ${this.targetGroup?.name}?`
    )}
            .objects=${this.selectedElements}
            .metadata=${(item) => {
      return [
        { key: msg("Username"), value: item.username },
        { key: msg("ID"), value: item.pk.toString() },
        { key: msg("UID"), value: item.uid }
      ];
    }}
            .delete=${(item) => {
      return new CoreApi(DEFAULT_CONFIG).coreGroupsRemoveUserCreate({
        groupUuid: this.targetGroup?.pk || "",
        userAccountRequest: {
          pk: item.pk
        }
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Remove")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    const canImpersonate = this.can(CapabilitiesEnum.CanImpersonate) && item.pk !== this.me?.user.pk;
    return [
      x`<a href="#/identity/users/${item.pk}">
                <div>${item.username}</div>
                <small>${item.name}</small>
            </a>`,
      x`<ak-status-label ?good=${item.isActive}></ak-status-label>`,
      x`${item.lastLogin ? x`<div>${getRelativeTime(item.lastLogin)}</div>
                      <small>${item.lastLogin.toLocaleString()}</small>` : msg("-")}`,
      x`<ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg("Update User")} </span>
                    <ak-user-form slot="form" .instancePk=${item.pk}> </ak-user-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                ${canImpersonate ? x`
                          <ak-action-button
                              class="pf-m-tertiary"
                              .apiRequest=${() => {
        return new CoreApi(DEFAULT_CONFIG).coreUsersImpersonateCreate({
          id: item.pk
        }).then(() => {
          window.location.href = "/";
        });
      }}
                          >
                              ${msg("Impersonate")}
                          </ak-action-button>
                      ` : x``}`
    ];
  }
  renderExpanded(item) {
    return x`<td role="cell" colspan="3">
                <div class="pf-c-table__expandable-row-content">
                    <dl class="pf-c-description-list pf-m-horizontal">
                        <div class="pf-c-description-list__group">
                            <dt class="pf-c-description-list__term">
                                <span class="pf-c-description-list__text"
                                    >${msg("User status")}</span
                                >
                            </dt>
                            <dd class="pf-c-description-list__description">
                                <div class="pf-c-description-list__text">
                                    ${item.isActive ? msg("Active") : msg("Inactive")}
                                </div>
                                <div class="pf-c-description-list__text">
                                    ${item.isSuperuser ? msg("Superuser") : msg("Regular user")}
                                </div>
                            </dd>
                        </div>
                        <div class="pf-c-description-list__group">
                            <dt class="pf-c-description-list__term">
                                <span class="pf-c-description-list__text"
                                    >${msg("Change status")}</span
                                >
                            </dt>
                            <dd class="pf-c-description-list__description">
                                <div class="pf-c-description-list__text">
                                    <ak-user-active-form
                                        .obj=${item}
                                        objectLabel=${msg("User")}
                                        .delete=${() => {
      return new CoreApi(
        DEFAULT_CONFIG
      ).coreUsersPartialUpdate({
        id: item.pk || 0,
        patchedUserRequest: {
          isActive: !item.isActive
        }
      });
    }}
                                    >
                                        <button slot="trigger" class="pf-c-button pf-m-warning">
                                            ${item.isActive ? msg("Deactivate") : msg("Activate")}
                                        </button>
                                    </ak-user-active-form>
                                </div>
                            </dd>
                        </div>
                        <div class="pf-c-description-list__group">
                            <dt class="pf-c-description-list__term">
                                <span class="pf-c-description-list__text">${msg("Recovery")}</span>
                            </dt>
                            <dd class="pf-c-description-list__description">
                                <div class="pf-c-description-list__text">
                                    <ak-forms-modal>
                                        <span slot="submit">${msg("Update password")}</span>
                                        <span slot="header">${msg("Update password")}</span>
                                        <ak-user-password-form
                                            slot="form"
                                            .instancePk=${item.pk}
                                        ></ak-user-password-form>
                                        <button slot="trigger" class="pf-c-button pf-m-secondary">
                                            ${msg("Set password")}
                                        </button>
                                    </ak-forms-modal>
                                    ${this.brand?.flowRecovery ? x`
                                              <ak-action-button
                                                  class="pf-m-secondary"
                                                  .apiRequest=${() => {
      return new CoreApi(DEFAULT_CONFIG).coreUsersRecoveryCreate({
        id: item.pk
      }).then((rec) => {
        showMessage({
          level: "success" /* success */,
          message: msg(
            "Successfully generated recovery link"
          ),
          description: rec.link
        });
      }).catch((ex) => {
        ex.response.json().then(() => {
          showMessage({
            level: "error" /* error */,
            message: msg(
              "No recovery flow is configured."
            )
          });
        });
      });
    }}
                                              >
                                                  ${msg("Copy recovery link")}
                                              </ak-action-button>
                                              ${item.email ? x`<ak-forms-modal
                                                        .closeAfterSuccessfulSubmit=${false}
                                                    >
                                                        <span slot="submit">
                                                            ${msg("Send link")}
                                                        </span>
                                                        <span slot="header">
                                                            ${msg("Send recovery link to user")}
                                                        </span>
                                                        <ak-user-reset-email-form
                                                            slot="form"
                                                            .user=${item}
                                                        >
                                                        </ak-user-reset-email-form>
                                                        <button
                                                            slot="trigger"
                                                            class="pf-c-button pf-m-secondary"
                                                        >
                                                            ${msg("Email recovery link")}
                                                        </button>
                                                    </ak-forms-modal>` : x`<span
                                                        >${msg(
      "Recovery link cannot be emailed, user has no email address saved."
    )}</span
                                                    >`}
                                          ` : x` <p>
                                              ${msg(
      "To let a user directly reset a their password, configure a recovery flow on the currently active brand."
    )}
                                          </p>`}
                                </div>
                            </dd>
                        </div>
                    </dl>
                </div>
            </td>
            <td></td>
            <td></td>`;
  }
  renderToolbar() {
    return x`
            ${this.targetGroup ? x`<ak-forms-modal>
                      <span slot="submit"> ${msg("Add")} </span>
                      <span slot="header"> ${msg("Add User")} </span>
                      ${this.targetGroup.isSuperuser ? x`
                                <div class="pf-c-banner pf-m-warning" slot="above-form">
                                    ${msg(
      "Warning: This group is configured with superuser access. Added users will have superuser access."
    )}
                                </div>
                            ` : x``}
                      <ak-user-related-add .group=${this.targetGroup} slot="form">
                      </ak-user-related-add>
                      <button slot="trigger" class="pf-c-button pf-m-primary">
                          ${msg("Add existing user")}
                      </button>
                  </ak-forms-modal>` : x``}
            <ak-dropdown class="pf-c-dropdown">
                <button class="pf-m-secondary pf-c-dropdown__toggle" type="button">
                    <span class="pf-c-dropdown__toggle-text">${msg("Create user")}</span>
                    <i class="fas fa-caret-down pf-c-dropdown__toggle-icon" aria-hidden="true"></i>
                </button>
                <ul class="pf-c-dropdown__menu" hidden>
                    <li>
                        <ak-forms-modal>
                            <span slot="submit"> ${msg("Create")} </span>
                            <span slot="header"> ${msg("Create User")} </span>
                            ${this.targetGroup ? x`
                                      <div class="pf-c-banner pf-m-info" slot="above-form">
                                          ${msg(
      str`This user will be added to the group "${this.targetGroup.name}".`
    )}
                                      </div>
                                  ` : T}
                            <ak-user-form .group=${this.targetGroup} slot="form"> </ak-user-form>
                            <a slot="trigger" class="pf-c-dropdown__menu-item">
                                ${msg("Create user")}
                            </a>
                        </ak-forms-modal>
                    </li>
                    <li>
                        <ak-forms-modal
                            .closeAfterSuccessfulSubmit=${false}
                            .cancelText=${msg("Close")}
                        >
                            <span slot="submit"> ${msg("Create")} </span>
                            <span slot="header"> ${msg("Create Service account")} </span>
                            ${this.targetGroup ? x`
                                      <div class="pf-c-banner pf-m-info" slot="above-form">
                                          ${msg(
      str`This user will be added to the group "${this.targetGroup.name}".`
    )}
                                      </div>
                                  ` : T}
                            <ak-user-service-account-form .group=${this.targetGroup} slot="form">
                            </ak-user-service-account-form>
                            <a slot="trigger" class="pf-c-dropdown__menu-item">
                                ${msg("Create Service account")}
                            </a>
                        </ak-forms-modal>
                    </li>
                </ul>
            </ak-dropdown>
            ${super.renderToolbar()}
        `;
  }
  renderToolbarAfter() {
    return x`&nbsp;
            <div class="pf-c-toolbar__group pf-m-filter-group">
                <div class="pf-c-toolbar__item pf-m-search-filter">
                    <div class="pf-c-input-group">
                        <label class="pf-c-switch">
                            <input
                                class="pf-c-switch__input"
                                type="checkbox"
                                ?checked=${this.hideServiceAccounts}
                                @change=${() => {
      this.hideServiceAccounts = !this.hideServiceAccounts;
      this.page = 1;
      this.fetch();
      updateURLParams({
        hideServiceAccounts: this.hideServiceAccounts
      });
    }}
                            />
                            <span class="pf-c-switch__toggle">
                                <span class="pf-c-switch__toggle-icon">
                                    <i class="fas fa-check" aria-hidden="true"></i>
                                </span>
                            </span>
                            <span class="pf-c-switch__label">${msg("Hide service-accounts")}</span>
                        </label>
                    </div>
                </div>
            </div>`;
  }
};
__decorateClass([
  n({ attribute: false })
], RelatedUserList.prototype, "targetGroup", 2);
__decorateClass([
  n()
], RelatedUserList.prototype, "order", 2);
__decorateClass([
  n({ type: Boolean })
], RelatedUserList.prototype, "hideServiceAccounts", 2);
__decorateClass([
  r()
], RelatedUserList.prototype, "me", 2);
RelatedUserList = __decorateClass([
  t("ak-user-related-list")
], RelatedUserList);

// src/admin/groups/GroupViewPage.ts
var GroupViewPage = class extends AKElement {
  set groupId(id) {
    new CoreApi(DEFAULT_CONFIG).coreGroupsRetrieve({
      groupUuid: id
    }).then((group) => {
      this.group = group;
    });
  }
  static get styles() {
    return [
      patternfly_base_default,
      page_default,
      button_default,
      display_default,
      grid_default,
      list_default,
      content_default,
      card_default,
      description_list_default,
      sizing_default
    ];
  }
  constructor() {
    super();
    this.addEventListener(EVENT_REFRESH, () => {
      if (!this.group?.pk)
        return;
      this.groupId = this.group?.pk;
    });
  }
  render() {
    return x`<ak-page-header
                icon="pf-icon pf-icon-users"
                header=${msg(str`Group ${this.group?.name || ""}`)}
                description=${this.group?.name || ""}
            >
            </ak-page-header>
            ${this.renderBody()}`;
  }
  renderBody() {
    if (!this.group) {
      return x``;
    }
    return x`<ak-tabs>
            <section
                slot="page-overview"
                data-tab-title="${msg("Overview")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div
                        class="pf-c-card pf-l-grid__item pf-m-12-col pf-m-3-col-on-xl pf-m-3-col-on-2xl"
                    >
                        <div class="pf-c-card__title">${msg("Group Info")}</div>
                        <div class="pf-c-card__body">
                            <dl class="pf-c-description-list">
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Name")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.group.name}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Superuser")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            <ak-status-label
                                                type="info"
                                                ?good=${this.group.isSuperuser}
                                            ></ak-status-label>
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Roles")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            <ul class="pf-c-list">
                                                ${this.group.rolesObj.map((role) => {
      return x`<li>
                                                        <a href=${`#/identity/roles/${role.pk}`}
                                                            >${role.name}
                                                        </a>
                                                    </li>`;
    })}
                                            </ul>
                                        </div>
                                    </dd>
                                </div>
                            </dl>
                        </div>
                        <div class="pf-c-card__footer">
                            <ak-forms-modal>
                                <span slot="submit"> ${msg("Update")} </span>
                                <span slot="header"> ${msg("Update Group")} </span>
                                <ak-group-form slot="form" .instancePk=${this.group.pk}>
                                </ak-group-form>
                                <button slot="trigger" class="pf-m-primary pf-c-button">
                                    ${msg("Edit")}
                                </button>
                            </ak-forms-modal>
                        </div>
                    </div>
                    <div
                        class="pf-c-card pf-l-grid__item pf-m-12-col pf-m-9-col-on-xl pf-m-9-col-on-2xl"
                    >
                        <div class="pf-c-card__title">${msg("Notes")}</div>
                        <div class="pf-c-card__body">
                            ${Object.hasOwn(this.group?.attributes || {}, "notes") ? x`${this.group.attributes?.notes}` : x`
                                      <p>
                                          ${msg(
      "Edit the notes attribute of this group to add notes here."
    )}
                                      </p>
                                  `}
                        </div>
                    </div>
                    <div
                        class="pf-c-card pf-l-grid__item pf-m-12-col pf-m-12-col-on-xl pf-m-12-col-on-2xl"
                    >
                        <div class="pf-c-card__title">${msg("Changelog")}</div>
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this.group.pk}
                                targetModelApp="authentik_core"
                                targetModelName="group"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-users"
                data-tab-title="${msg("Users")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-c-card">
                    <div class="pf-c-card__body">
                        <ak-user-related-list .targetGroup=${this.group}> </ak-user-related-list>
                    </div>
                </div>
            </section>

            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.CoreGroup}
                objectPk=${this.group.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], GroupViewPage.prototype, "groupId", 1);
__decorateClass([
  n({ attribute: false })
], GroupViewPage.prototype, "group", 2);
GroupViewPage = __decorateClass([
  t("ak-group-view")
], GroupViewPage);
export {
  GroupViewPage
};
//# sourceMappingURL=GroupViewPage-O3QRCFMU.js.map
