import {
  StagesApi
} from "./chunk-6L2VIJJF.js";
import "./chunk-GOSS526A.js";
import "./chunk-KAVSWSBX.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-EALY7PEX.js";
import "./chunk-Z7XVYGD6.js";
import {
  banner_default
} from "./chunk-WJSRKCWV.js";
import "./chunk-XCEM2TDB.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import "./chunk-Y5HTBO47.js";
import {
  TablePage
} from "./chunk-R63EXIDN.js";
import "./chunk-MCK5P3JY.js";
import "./chunk-O7KILHL6.js";
import "./chunk-DP47YJ62.js";
import "./chunk-JMBXTRNL.js";
import "./chunk-ZZAG5J6S.js";
import "./chunk-SACHAYPZ.js";
import {
  browser_default
} from "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import {
  ModelForm
} from "./chunk-ZVKXJXN6.js";
import "./chunk-PSPR3SUN.js";
import "./chunk-X5TC2QXY.js";
import {
  FlowsInstancesListDesignationEnum
} from "./chunk-2G3GM457.js";
import {
  FlowDesignationEnum
} from "./chunk-OATKFZXF.js";
import "./chunk-KNLDGZQ5.js";
import "./chunk-6KRH5U5H.js";
import {
  form_default
} from "./chunk-GOIBY4UW.js";
import {
  m
} from "./chunk-WPHOZTKQ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-7XZT6QXJ.js";
import {
  TableColumn,
  form_control_default,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  dateTimeLocal,
  first,
  n,
  patternfly_base_default,
  r,
  t
} from "./chunk-EOF5OWT7.js";
import {
  msg,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/stages/invitation/InvitationForm.ts
var InvitationForm = class extends ModelForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesInvitationInvitationsRetrieve({
      inviteUuid: pk
    });
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated invitation.") : msg("Successfully created invitation.");
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesInvitationInvitationsUpdate({
        inviteUuid: this.instance.pk || "",
        invitationRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesInvitationInvitationsCreate({
        invitationRequest: data
      });
    }
  }
  renderForm() {
    return x` <ak-form-element-horizontal
                ?slugMode=${true}
                label=${msg("Name")}
                ?required=${true}
                name="name"
            >
                <input
                    type="text"
                    value="${this.instance?.name || ""}"
                    class="pf-c-form-control"
                    required
                    data-ak-slug="true"
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Expires")} ?required=${true} name="expires">
                <input
                    type="datetime-local"
                    data-type="datetime-local"
                    class="pf-c-form-control"
                    required
                    value="${dateTimeLocal(first(this.instance?.expires, /* @__PURE__ */ new Date()))}"
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Flow")} name="flow">
                <ak-flow-search
                    flowType=${FlowsInstancesListDesignationEnum.Enrollment}
                    .currentFlow=${this.instance?.flow}
                ></ak-flow-search>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "When selected, the invite will only be usable with the flow. By default the invite is accepted on all flows with invitation stages."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Custom attributes")} name="fixedData">
                <ak-codemirror
                    mode=${"yaml" /* YAML */}
                    value="${browser_default.stringify(first(this.instance?.fixedData, {}))}"
                >
                </ak-codemirror>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Optional data which is loaded into the flow's 'prompt_data' context variable. YAML or JSON."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal name="singleUse">
                <label class="pf-c-switch">
                    <input
                        class="pf-c-switch__input"
                        type="checkbox"
                        ?checked=${first(this.instance?.singleUse, true)}
                    />
                    <span class="pf-c-switch__toggle">
                        <span class="pf-c-switch__toggle-icon">
                            <i class="fas fa-check" aria-hidden="true"></i>
                        </span>
                    </span>
                    <span class="pf-c-switch__label">${msg("Single use")}</span>
                </label>
                <p class="pf-c-form__helper-text">
                    ${msg("When enabled, the invitation will be deleted after usage.")}
                </p>
            </ak-form-element-horizontal>`;
  }
};
InvitationForm = __decorateClass([
  t("ak-invitation-form")
], InvitationForm);

// src/admin/stages/invitation/InvitationListLink.ts
var InvitationListLink = class extends AKElement {
  static get styles() {
    return [patternfly_base_default, form_default, form_control_default, description_list_default];
  }
  renderLink() {
    if (this.invitation?.flowObj) {
      this.selectedFlow = this.invitation.flowObj?.slug;
    }
    return `${window.location.protocol}//${window.location.host}/if/flow/${this.selectedFlow}/?itoken=${this.invitation?.pk}`;
  }
  renderFlowSelector() {
    return x`<div class="pf-c-description-list__group">
            <dt class="pf-c-description-list__term">
                <span class="pf-c-description-list__text">${msg("Select an enrollment flow")}</span>
            </dt>
            <dd class="pf-c-description-list__description">
                <div class="pf-c-description-list__text">
                    <select
                        class="pf-c-form-control"
                        @change=${(ev) => {
      const current = ev.target.value;
      this.selectedFlow = current;
    }}
                    >
                        ${m(
      new StagesApi(DEFAULT_CONFIG).stagesInvitationStagesList({
        ordering: "name",
        noFlows: false
      }).then((stages) => {
        if (!this.selectedFlow && stages.results.length > 0 && stages.results[0].flowSet) {
          this.selectedFlow = stages.results[0].flowSet[0].slug;
        }
        const seenFlowSlugs = [];
        return stages.results.map((stage) => {
          return stage.flowSet?.map((flow) => {
            if (seenFlowSlugs.includes(flow.slug)) {
              return x``;
            }
            seenFlowSlugs.push(flow.slug);
            return x`<option
                                                value=${flow.slug}
                                                ?selected=${flow.slug === this.selectedFlow}
                                            >
                                                ${flow.slug}
                                            </option>`;
          });
        });
      }),
      x`<option>${msg("Loading...")}</option>`
    )}
                    </select>
                </div>
            </dd>
        </div>`;
  }
  render() {
    return x`<dl class="pf-c-description-list pf-m-horizontal">
            ${this.invitation?.flow === void 0 ? this.renderFlowSelector() : x``}
            <div class="pf-c-description-list__group">
                <dt class="pf-c-description-list__term">
                    <span class="pf-c-description-list__text"
                        >${msg("Link to use the invitation.")}</span
                    >
                </dt>
                <dd class="pf-c-description-list__description">
                    <div class="pf-c-description-list__text">
                        <input
                            class="pf-c-form-control"
                            readonly
                            type="text"
                            value=${this.renderLink()}
                        />
                    </div>
                </dd>
            </div>
        </dl>`;
  }
};
__decorateClass([
  n({ attribute: false })
], InvitationListLink.prototype, "invitation", 2);
__decorateClass([
  n()
], InvitationListLink.prototype, "selectedFlow", 2);
InvitationListLink = __decorateClass([
  t("ak-stage-invitation-list-link")
], InvitationListLink);

// src/admin/stages/invitation/InvitationListPage.ts
var InvitationListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.expandable = true;
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "expires";
    this.invitationStageExists = false;
    this.multipleEnrollmentFlows = false;
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Invitations");
  }
  pageDescription() {
    return msg(
      "Create Invitation Links to enroll Users, and optionally force specific attributes of their account."
    );
  }
  pageIcon() {
    return "pf-icon pf-icon-migration";
  }
  static get styles() {
    return super.styles.concat(banner_default);
  }
  async apiEndpoint(page) {
    try {
      const stages = await new StagesApi(DEFAULT_CONFIG).stagesInvitationStagesList({
        noFlows: false
      });
      this.invitationStageExists = stages.pagination.count > 0;
      this.expandable = this.invitationStageExists;
      stages.results.forEach((stage) => {
        const enrollmentFlows = (stage.flowSet || []).filter(
          (flow) => flow.designation === FlowDesignationEnum.Enrollment
        );
        if (enrollmentFlows.length > 1) {
          this.multipleEnrollmentFlows = true;
        }
      });
    } catch {
    }
    return new StagesApi(DEFAULT_CONFIG).stagesInvitationInvitationsList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || ""
    });
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Created by"), "created_by"),
      new TableColumn(msg("Expiry")),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Invitation(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new StagesApi(DEFAULT_CONFIG).stagesInvitationInvitationsUsedByList({
        inviteUuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new StagesApi(DEFAULT_CONFIG).stagesInvitationInvitationsDestroy({
        inviteUuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    return [
      x`<div>${item.name}</div>
                ${!item.flowObj && this.multipleEnrollmentFlows ? x`
                          <ak-label color=${"pf-m-orange" /* Orange */}>
                              ${msg(
        "Invitation not limited to any flow, and can be used with any enrollment flow."
      )}
                          </ak-label>
                      ` : x``}`,
      x`${item.createdBy?.username}`,
      x`${item.expires?.toLocaleString() || msg("-")}`,
      x` <ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg("Update Invitation")} </span>
                    <ak-invitation-form slot="form" .instancePk=${item.pk}> </ak-invitation-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                <ak-rbac-object-permission-modal
                    model=${RbacPermissionsAssignedByUsersListModelEnum.StagesInvitationInvitation}
                    objectPk=${item.pk}
                >
                </ak-rbac-object-permission-modal>`
    ];
  }
  renderExpanded(item) {
    return x` <td role="cell" colspan="3">
                <div class="pf-c-table__expandable-row-content">
                    <ak-stage-invitation-list-link
                        .invitation=${item}
                    ></ak-stage-invitation-list-link>
                </div>
            </td>
            <td></td>
            <td></td>
            <td></td>`;
  }
  renderObjectCreate() {
    return x`
            <ak-forms-modal>
                <span slot="submit"> ${msg("Create")} </span>
                <span slot="header"> ${msg("Create Invitation")} </span>
                <ak-invitation-form slot="form"> </ak-invitation-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-forms-modal>
        `;
  }
  render() {
    return x`<ak-page-header
                icon=${this.pageIcon()}
                header=${this.pageTitle()}
                description=${o(this.pageDescription())}
            >
            </ak-page-header>
            ${this.invitationStageExists ? x`` : x`
                      <div class="pf-c-banner pf-m-warning">
                          ${msg(
      "Warning: No invitation stage is bound to any flow. Invitations will not work as expected."
    )}
                      </div>
                  `}
            <section class="pf-c-page__main-section pf-m-no-padding-mobile">
                <div class="pf-c-card">${this.renderTable()}</div>
            </section>`;
  }
};
__decorateClass([
  n()
], InvitationListPage.prototype, "order", 2);
__decorateClass([
  r()
], InvitationListPage.prototype, "invitationStageExists", 2);
__decorateClass([
  r()
], InvitationListPage.prototype, "multipleEnrollmentFlows", 2);
InvitationListPage = __decorateClass([
  t("ak-stage-invitation-list")
], InvitationListPage);
export {
  InvitationListPage
};
//# sourceMappingURL=InvitationListPage-JHGZ5K3V.js.map
