import "./chunk-CRCFAAYI.js";
import "./chunk-ZAJ4I4EK.js";
import "./chunk-QPYNOECS.js";
import {
  OutpostTypeEnum,
  OutpostsApi
} from "./chunk-VVP3K3IZ.js";
import "./chunk-GOSS526A.js";
import "./chunk-KAVSWSBX.js";
import "./chunk-7V5SMFL5.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-EALY7PEX.js";
import "./chunk-Z7XVYGD6.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-XCEM2TDB.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import "./chunk-Y5HTBO47.js";
import {
  TablePage
} from "./chunk-R63EXIDN.js";
import "./chunk-4L2VSKMK.js";
import "./chunk-O7KILHL6.js";
import "./chunk-IZQSSDOF.js";
import "./chunk-DP47YJ62.js";
import "./chunk-ZKRIRKRW.js";
import "./chunk-SACHAYPZ.js";
import {
  browser_default
} from "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import {
  ModelForm
} from "./chunk-ZVKXJXN6.js";
import "./chunk-PSPR3SUN.js";
import {
  ProvidersApi
} from "./chunk-SFAGFFHP.js";
import "./chunk-ZBQTYGSF.js";
import {
  o as o2
} from "./chunk-6KRH5U5H.js";
import {
  ModalButton
} from "./chunk-GOIBY4UW.js";
import "./chunk-WPHOZTKQ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-7XZT6QXJ.js";
import {
  TableColumn,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  EVENT_REFRESH,
  docLink,
  groupBy,
  n,
  patternfly_base_default,
  r,
  t
} from "./chunk-EOF5OWT7.js";
import {
  msg,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/outposts/OutpostDeploymentModal.ts
var OutpostDeploymentModal = class extends ModalButton {
  renderModalInner() {
    return x`<div class="pf-c-modal-box__header">
                <h1 class="pf-c-title pf-m-2xl">${msg("Outpost Deployment Info")}</h1>
            </div>
            <div class="pf-c-modal-box__body">
                <p>
                    <a
                        target="_blank"
                        href="${docLink("/docs/outposts?utm_source=authentik#deploy")}"
                        >${msg("View deployment documentation")}</a
                    >
                </p>
                <form class="pf-c-form">
                    <div class="pf-c-form__group">
                        <label class="pf-c-form__label">
                            <span class="pf-c-form__label-text">AUTHENTIK_HOST</span>
                        </label>
                        <input
                            class="pf-c-form-control"
                            readonly
                            type="text"
                            value="${document.location.origin}"
                        />
                    </div>
                    <div class="pf-c-form__group">
                        <label class="pf-c-form__label">
                            <span class="pf-c-form__label-text">AUTHENTIK_TOKEN</span>
                        </label>
                        <div>
                            <ak-token-copy-button
                                class="pf-m-primary"
                                identifier="${o(this.outpost?.tokenIdentifier)}"
                            >
                                ${msg("Click to copy token")}
                            </ak-token-copy-button>
                        </div>
                    </div>
                    <h3>
                        ${msg(
      "If your authentik Instance is using a self-signed certificate, set this value."
    )}
                    </h3>
                    <div class="pf-c-form__group">
                        <label class="pf-c-form__label">
                            <span class="pf-c-form__label-text">AUTHENTIK_INSECURE</span>
                        </label>
                        <input class="pf-c-form-control" readonly type="text" value="true" />
                    </div>
                    ${this.outpost?.type == OutpostTypeEnum.Proxy ? x`
                              <h3>
                                  ${msg(
      "If your authentik_host setting does not match the URL you want to login with, add this setting."
    )}
                              </h3>
                              <div class="pf-c-form__group">
                                  <label class="pf-c-form__label">
                                      <span class="pf-c-form__label-text"
                                          >AUTHENTIK_HOST_BROWSER</span
                                      >
                                  </label>
                                  <input
                                      class="pf-c-form-control"
                                      readonly
                                      type="text"
                                      value="${document.location.origin}"
                                  />
                              </div>
                          ` : x``}
                </form>
            </div>
            <footer class="pf-c-modal-box__footer pf-m-align-left">
                <button
                    class="pf-c-button pf-m-primary"
                    @click=${() => {
      this.open = false;
    }}
                >
                    ${msg("Close")}
                </button>
            </footer>`;
  }
};
__decorateClass([
  n({ attribute: false })
], OutpostDeploymentModal.prototype, "outpost", 2);
OutpostDeploymentModal = __decorateClass([
  t("ak-outpost-deployment-modal")
], OutpostDeploymentModal);

// src/admin/outposts/OutpostForm.ts
var api = () => new ProvidersApi(DEFAULT_CONFIG);
var providerListArgs = (page, search = "") => ({
  ordering: "name",
  applicationIsnull: false,
  pageSize: 20,
  search: search.trim(),
  page
});
var dualSelectPairMaker = (item) => {
  const label = item.assignedBackchannelApplicationName ? item.assignedBackchannelApplicationName : item.assignedApplicationName;
  return [
    `${item.pk}`,
    x`<div class="selection-main">${label}</div>
            <div class="selection-desc">${item.name}</div>`,
    label
  ];
};
var provisionMaker = (results) => ({
  pagination: results.pagination,
  options: results.results.map(dualSelectPairMaker)
});
var proxyListFetch = async (page, search = "") => provisionMaker(await api().providersProxyList(providerListArgs(page, search)));
var ldapListFetch = async (page, search = "") => provisionMaker(await api().providersLdapList(providerListArgs(page, search)));
var radiusListFetch = async (page, search = "") => provisionMaker(await api().providersRadiusList(providerListArgs(page, search)));
var racListProvider = async (page, search = "") => provisionMaker(await api().providersRacList(providerListArgs(page, search)));
function providerProvider(type) {
  switch (type) {
    case OutpostTypeEnum.Proxy:
      return proxyListFetch;
    case OutpostTypeEnum.Ldap:
      return ldapListFetch;
    case OutpostTypeEnum.Radius:
      return radiusListFetch;
    case OutpostTypeEnum.Rac:
      return racListProvider;
    default:
      throw new Error(`Unrecognized OutputType: ${type}`);
  }
}
var OutpostForm = class extends ModelForm {
  constructor() {
    super(...arguments);
    this.type = OutpostTypeEnum.Proxy;
    this.embedded = false;
  }
  async loadInstance(pk) {
    const o3 = await new OutpostsApi(DEFAULT_CONFIG).outpostsInstancesRetrieve({
      uuid: pk
    });
    this.type = o3.type || OutpostTypeEnum.Proxy;
    return o3;
  }
  async load() {
    this.defaultConfig = await new OutpostsApi(
      DEFAULT_CONFIG
    ).outpostsInstancesDefaultSettingsRetrieve();
    this.providers = providerProvider(this.type);
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated outpost.") : msg("Successfully created outpost.");
  }
  async send(data) {
    if (this.instance) {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsInstancesUpdate({
        uuid: this.instance.pk || "",
        outpostRequest: data
      });
    } else {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsInstancesCreate({
        outpostRequest: data
      });
    }
  }
  renderForm() {
    const typeOptions = [
      [OutpostTypeEnum.Proxy, msg("Proxy")],
      [OutpostTypeEnum.Ldap, msg("LDAP")],
      [OutpostTypeEnum.Radius, msg("Radius")],
      [OutpostTypeEnum.Rac, msg("RAC")]
    ];
    return x` <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${o(this.instance?.name)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Type")} ?required=${true} name="type">
                <select
                    class="pf-c-form-control"
                    @change=${(ev) => {
      const target = ev.target;
      this.type = target.selectedOptions[0].value;
      this.load();
    }}
                >
                    ${o2(
      typeOptions,
      ([instanceType, label]) => x` <option
                                value=${instanceType}
                                ?selected=${this.instance?.type === instanceType}
                            >
                                ${label}
                            </option>`
    )}
                </select>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Integration")} name="serviceConnection">
                <ak-search-select
                    .fetchObjects=${async (query) => {
      const args = {
        ordering: "name"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const items = await new OutpostsApi(
        DEFAULT_CONFIG
      ).outpostsServiceConnectionsAllList(args);
      return items.results;
    }}
                    .renderElement=${(item) => {
      return item.name;
    }}
                    .value=${(item) => {
      return item?.pk;
    }}
                    .groupBy=${(items) => {
      return groupBy(items, (item) => item.verboseName);
    }}
                    .selected=${(item, items) => {
      let selected = this.instance?.serviceConnection === item.pk;
      if (items.length === 1 && !this.instance) {
        selected = true;
      }
      return selected;
    }}
                    ?blankable=${true}
                >
                </ak-search-select>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Selecting an integration enables the management of the outpost by authentik."
    )}
                </p>
                <p class="pf-c-form__helper-text">
                    See
                    <a target="_blank" href="${docLink("/docs/outposts?utm_source=authentik")}"
                        >documentation</a
                    >.
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Applications")}
                ?required=${!this.embedded}
                name="providers"
            >
                <ak-dual-select-provider
                    .provider=${this.providers}
                    .selected=${(this.instance?.providersObj ?? []).map(dualSelectPairMaker)}
                    available-label="${msg("Available Applications")}"
                    selected-label="${msg("Selected Applications")}"
                ></ak-dual-select-provider>
            </ak-form-element-horizontal>
            <ak-form-group aria-label="Advanced settings">
                <span slot="header"> ${msg("Advanced settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal label=${msg("Configuration")} name="config">
                        <ak-codemirror
                            mode=${"yaml" /* YAML */}
                            value="${browser_default.stringify(
      this.instance ? this.instance.config : this.defaultConfig?.config
    )}"
                        ></ak-codemirror>
                        <p class="pf-c-form__helper-text">
                            ${msg("Set custom attributes using YAML or JSON.")}
                        </p>
                        <p class="pf-c-form__helper-text">
                            ${msg("See more here:")}&nbsp;
                            <a
                                target="_blank"
                                href="${docLink(
      "/docs/outposts?utm_source=authentik#configuration"
    )}"
                                >${msg("Documentation")}</a
                            >
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
__decorateClass([
  n()
], OutpostForm.prototype, "type", 2);
__decorateClass([
  n({ type: Boolean })
], OutpostForm.prototype, "embedded", 2);
__decorateClass([
  r()
], OutpostForm.prototype, "providers", 2);
OutpostForm = __decorateClass([
  t("ak-outpost-form")
], OutpostForm);

// src/admin/outposts/OutpostHealthSimple.ts
var OutpostHealthSimpleElement = class extends AKElement {
  constructor() {
    super();
    this.loaded = false;
    this.showVersion = true;
    window.addEventListener(EVENT_REFRESH, () => {
      this.outpostHealth = void 0;
      this.firstUpdated();
    });
  }
  static get styles() {
    return [patternfly_base_default];
  }
  firstUpdated() {
    if (!this.outpostId)
      return;
    new OutpostsApi(DEFAULT_CONFIG).outpostsInstancesHealthList({
      uuid: this.outpostId
    }).then((health) => {
      this.loaded = true;
      if (health.length >= 1) {
        this.outpostHealth = health[0];
      }
    });
  }
  render() {
    if (!this.outpostId || !this.loaded) {
      return x`<ak-spinner></ak-spinner>`;
    }
    if (!this.outpostHealth) {
      return x`<ak-label color=${"" /* Grey */}>${msg("Not available")}</ak-label>`;
    }
    return x`<ak-label color=${"pf-m-green" /* Green */}>
            ${msg(str`Last seen: ${this.outpostHealth.lastSeen?.toLocaleTimeString()}`)}</ak-label
        >`;
  }
};
__decorateClass([
  n()
], OutpostHealthSimpleElement.prototype, "outpostId", 2);
__decorateClass([
  n({ attribute: false })
], OutpostHealthSimpleElement.prototype, "outpostHealth", 2);
__decorateClass([
  n({ attribute: false })
], OutpostHealthSimpleElement.prototype, "loaded", 2);
__decorateClass([
  n({ attribute: false })
], OutpostHealthSimpleElement.prototype, "showVersion", 2);
OutpostHealthSimpleElement = __decorateClass([
  t("ak-outpost-health-simple")
], OutpostHealthSimpleElement);

// src/admin/outposts/OutpostListPage.ts
function TypeToLabel(type) {
  if (!type)
    return "";
  switch (type) {
    case OutpostTypeEnum.Proxy:
      return msg("Proxy");
    case OutpostTypeEnum.Ldap:
      return msg("LDAP");
    case OutpostTypeEnum.Radius:
      return msg("Radius");
    case OutpostTypeEnum.Rac:
      return msg("RAC");
    case OutpostTypeEnum.UnknownDefaultOpenApi:
      return msg("Unknown type");
  }
}
var OutpostListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.expandable = true;
    this.health = {};
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  pageTitle() {
    return msg("Outposts");
  }
  pageDescription() {
    return msg(
      "Outposts are deployments of authentik components to support different environments and protocols, like reverse proxies."
    );
  }
  pageIcon() {
    return "pf-icon pf-icon-zone";
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint(page) {
    const outposts = await new OutpostsApi(DEFAULT_CONFIG).outpostsInstancesList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || ""
    });
    Promise.all(
      outposts.results.map((outpost) => {
        return new OutpostsApi(DEFAULT_CONFIG).outpostsInstancesHealthList({
          uuid: outpost.pk
        }).then((health) => {
          this.health[outpost.pk] = health;
        });
      })
    );
    return outposts;
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Type"), "type"),
      new TableColumn(msg("Providers")),
      new TableColumn(msg("Integration"), "service_connection__name"),
      new TableColumn(msg("Health and Version")),
      new TableColumn(msg("Actions"))
    ];
  }
  static get styles() {
    return super.styles.concat(description_list_default);
  }
  row(item) {
    return [
      x`<div>${item.name}</div>
                ${item.config.authentik_host === "" ? x`<ak-label color=${"pf-m-orange" /* Orange */} ?compact=${true}>
                          ${msg(
        "Warning: authentik Domain is not configured, authentication will not work."
      )}
                      </ak-label>` : x`<ak-label color=${"pf-m-green" /* Green */} ?compact=${true}>
                          ${msg(str`Logging in via ${item.config.authentik_host}.`)}
                      </ak-label>`}`,
      x`${TypeToLabel(item.type)}`,
      x`<ul>
                ${item.providersObj?.map((p) => {
        return x`<li>
                        <a href="#/core/providers/${p.pk}">${p.name}</a>
                    </li>`;
      })}
            </ul>`,
      x`${item.serviceConnectionObj?.name || msg("No integration active")}`,
      x`<ak-outpost-health-simple
                outpostId=${o(item.pk)}
            ></ak-outpost-health-simple>`,
      x`<ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg("Update Outpost")} </span>
                    <ak-outpost-form
                        slot="form"
                        .instancePk=${item.pk}
                        .embedded=${item.managed === "goauthentik.io/outposts/embedded"}
                    >
                    </ak-outpost-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                <ak-rbac-object-permission-modal
                    model=${RbacPermissionsAssignedByUsersListModelEnum.OutpostsOutpost}
                    objectPk=${item.pk}
                >
                </ak-rbac-object-permission-modal>
                ${item.managed !== "goauthentik.io/outposts/embedded" ? x`<ak-outpost-deployment-modal .outpost=${item} size=${"pf-m-md" /* Medium */}>
                          <button slot="trigger" class="pf-c-button pf-m-tertiary">
                              ${msg("View Deployment Info")}
                          </button>
                      </ak-outpost-deployment-modal>` : x``}`
    ];
  }
  renderExpanded(item) {
    return x`<td role="cell" colspan="5">
            <div class="pf-c-table__expandable-row-content">
                <h3>
                    ${msg(
      "Detailed health (one instance per column, data is cached so may be out of date)"
    )}
                </h3>
                <dl class="pf-c-description-list pf-m-3-col-on-lg">
                    ${this.health[item.pk].map((h) => {
      return x`<div class="pf-c-description-list__group">
                            <dd class="pf-c-description-list__description">
                                <div class="pf-c-description-list__text">
                                    <ak-outpost-health .outpostHealth=${h}></ak-outpost-health>
                                </div>
                            </dd>
                        </div>`;
    })}
                </dl>
            </div>
        </td>`;
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Outpost(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsInstancesUsedByList({
        uuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsInstancesDestroy({
        uuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  renderObjectCreate() {
    return x`
            <ak-forms-modal>
                <span slot="submit"> ${msg("Create")} </span>
                <span slot="header"> ${msg("Create Outpost")} </span>
                <ak-outpost-form slot="form"> </ak-outpost-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-forms-modal>
        `;
  }
};
__decorateClass([
  r()
], OutpostListPage.prototype, "health", 2);
__decorateClass([
  n()
], OutpostListPage.prototype, "order", 2);
OutpostListPage = __decorateClass([
  t("ak-outpost-list")
], OutpostListPage);
export {
  OutpostListPage,
  TypeToLabel
};
//# sourceMappingURL=OutpostListPage-FUYGTFLU.js.map
