import "./chunk-RJXXGELO.js";
import "./chunk-GOSS526A.js";
import "./chunk-JUAKJGB5.js";
import {
  PoliciesApi
} from "./chunk-JSMKLBKU.js";
import "./chunk-KAVSWSBX.js";
import "./chunk-EALY7PEX.js";
import "./chunk-AP5GHUBV.js";
import "./chunk-Z7XVYGD6.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-4JTEFESU.js";
import "./chunk-XX4MPIVG.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import "./chunk-WGDMKZIG.js";
import "./chunk-Y5HTBO47.js";
import {
  TablePage
} from "./chunk-R63EXIDN.js";
import "./chunk-O7KILHL6.js";
import "./chunk-DP47YJ62.js";
import "./chunk-KANCX4AI.js";
import "./chunk-ZKRIRKRW.js";
import "./chunk-4TARICXF.js";
import "./chunk-SACHAYPZ.js";
import {
  browser_default
} from "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import "./chunk-ZVKXJXN6.js";
import {
  Form
} from "./chunk-PSPR3SUN.js";
import "./chunk-KNLDGZQ5.js";
import "./chunk-6KRH5U5H.js";
import "./chunk-GOIBY4UW.js";
import "./chunk-WPHOZTKQ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-7XZT6QXJ.js";
import {
  TableColumn,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  CoreApi,
  DEFAULT_CONFIG,
  first,
  n,
  r,
  t
} from "./chunk-EOF5OWT7.js";
import {
  msg,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/policies/PolicyTestForm.ts
var PolicyTestForm = class extends Form {
  getSuccessMessage() {
    return msg("Successfully sent test-request.");
  }
  async send(data) {
    this.request = data;
    const result = await new PoliciesApi(DEFAULT_CONFIG).policiesAllTestCreate({
      policyUuid: this.policy?.pk || "",
      policyTestRequest: data
    });
    return this.result = result;
  }
  static get styles() {
    return super.styles.concat(description_list_default);
  }
  renderResult() {
    return x`
            <ak-form-element-horizontal label=${msg("Passing")}>
                <div class="pf-c-form__group-label">
                    <div class="c-form__horizontal-group">
                        <span class="pf-c-form__label-text">
                            <ak-status-label ?good=${this.result?.passing}></ak-status-label>
                        </span>
                    </div>
                </div>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Messages")}>
                <div class="pf-c-form__group-label">
                    <div class="c-form__horizontal-group">
                        <ul>
                            ${(this.result?.messages || []).length > 0 ? this.result?.messages?.map((m) => {
      return x`<li>
                                          <span class="pf-c-form__label-text">${m}</span>
                                      </li>`;
    }) : x`<li>
                                      <span class="pf-c-form__label-text">-</span>
                                  </li>`}
                        </ul>
                    </div>
                </div>
            </ak-form-element-horizontal>

            <ak-form-element-horizontal label=${msg("Log messages")}>
                <div class="pf-c-form__group-label">
                    <div class="c-form__horizontal-group">
                        <dl class="pf-c-description-list pf-m-horizontal">
                            <ak-log-viewer .logs=${this.result?.logMessages}></ak-log-viewer>
                        </dl>
                    </div>
                </div>
            </ak-form-element-horizontal>
        `;
  }
  renderForm() {
    return x`<ak-form-element-horizontal label=${msg("User")} ?required=${true} name="user">
                <ak-search-select
                    .fetchObjects=${async (query) => {
      const args = {
        ordering: "username"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const users = await new CoreApi(DEFAULT_CONFIG).coreUsersList(args);
      return users.results;
    }}
                    .renderElement=${(user) => {
      return user.username;
    }}
                    .renderDescription=${(user) => {
      return x`${user.name}`;
    }}
                    .value=${(user) => {
      return user?.pk;
    }}
                    .selected=${(user) => {
      return this.request?.user.toString() === user.pk.toString();
    }}
                >
                </ak-search-select>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Context")} name="context">
                <ak-codemirror
                    mode=${"yaml" /* YAML */}
                    value=${browser_default.stringify(first(this.request?.context, {}))}
                >
                </ak-codemirror>
                <p class="pf-c-form__helper-text">
                    ${msg("Set custom attributes using YAML or JSON.")}
                </p>
            </ak-form-element-horizontal>
            ${this.result ? this.renderResult() : x``}`;
  }
};
__decorateClass([
  n({ attribute: false })
], PolicyTestForm.prototype, "policy", 2);
__decorateClass([
  r()
], PolicyTestForm.prototype, "result", 2);
__decorateClass([
  n({ attribute: false })
], PolicyTestForm.prototype, "request", 2);
PolicyTestForm = __decorateClass([
  t("ak-policy-test-form")
], PolicyTestForm);

// src/admin/policies/PolicyListPage.ts
var PolicyListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Policies");
  }
  pageDescription() {
    return msg(
      "Allow users to use Applications based on properties, enforce Password Criteria and selectively apply Stages."
    );
  }
  pageIcon() {
    return "pf-icon pf-icon-infrastructure";
  }
  async apiEndpoint(page) {
    return new PoliciesApi(DEFAULT_CONFIG).policiesAllList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || ""
    });
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Type")),
      new TableColumn(msg("Actions"))
    ];
  }
  row(item) {
    return [
      x`<div>${item.name}</div>
                ${(item.boundTo || 0) > 0 ? x`<ak-label color=${"pf-m-green" /* Green */} ?compact=${true}>
                          ${msg(str`Assigned to ${item.boundTo} object(s).`)}
                      </ak-label>` : x`<ak-label color=${"pf-m-orange" /* Orange */} ?compact=${true}>
                          ${msg("Warning: Policy is not assigned.")}
                      </ak-label>`}`,
      x`${item.verboseName}`,
      x` <ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg(str`Update ${item.verboseName}`)} </span>
                    <ak-proxy-form
                        slot="form"
                        .args=${{
        instancePk: item.pk
      }}
                        type=${o(item.component)}
                    >
                    </ak-proxy-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>

                <ak-rbac-object-permission-modal model=${item.metaModelName} objectPk=${item.pk}>
                </ak-rbac-object-permission-modal>
                <ak-forms-modal .closeAfterSuccessfulSubmit=${false}>
                    <span slot="submit"> ${msg("Test")} </span>
                    <span slot="header"> ${msg("Test Policy")} </span>
                    <ak-policy-test-form slot="form" .policy=${item}> </ak-policy-test-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Test")}>
                            <i class="fas fa-vial" aria-hidden="true"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>`
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Policy / Policies")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new PoliciesApi(DEFAULT_CONFIG).policiesAllUsedByList({
        policyUuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new PoliciesApi(DEFAULT_CONFIG).policiesAllDestroy({
        policyUuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  renderObjectCreate() {
    return x`<ak-policy-wizard> </ak-policy-wizard>`;
  }
  renderToolbar() {
    return x` ${super.renderToolbar()}
            <ak-forms-confirm
                successMessage=${msg("Successfully cleared policy cache")}
                errorMessage=${msg("Failed to delete policy cache")}
                action=${msg("Clear cache")}
                .onConfirm=${() => {
      return new PoliciesApi(DEFAULT_CONFIG).policiesAllCacheClearCreate();
    }}
            >
                <span slot="header"> ${msg("Clear Policy cache")} </span>
                <p slot="body">
                    ${msg(
      "Are you sure you want to clear the policy cache? This will cause all policies to be re-evaluated on their next usage."
    )}
                </p>
                <button slot="trigger" class="pf-c-button pf-m-secondary" type="button">
                    ${msg("Clear cache")}
                </button>
                <div slot="modal"></div>
            </ak-forms-confirm>`;
  }
};
__decorateClass([
  n()
], PolicyListPage.prototype, "order", 2);
PolicyListPage = __decorateClass([
  t("ak-policy-list")
], PolicyListPage);
export {
  PolicyListPage
};
//# sourceMappingURL=PolicyListPage-HYVFJ3K3.js.map
