import "./chunk-NXBNBE6T.js";
import {
  StagesApi
} from "./chunk-6L2VIJJF.js";
import "./chunk-P6KUVHV4.js";
import "./chunk-LKZJBMFY.js";
import "./chunk-GOSS526A.js";
import "./chunk-KAVSWSBX.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-EALY7PEX.js";
import "./chunk-Z7XVYGD6.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-XCEM2TDB.js";
import {
  TablePage
} from "./chunk-R63EXIDN.js";
import "./chunk-4L2VSKMK.js";
import "./chunk-O7KILHL6.js";
import "./chunk-DP47YJ62.js";
import "./chunk-SACHAYPZ.js";
import "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import "./chunk-ZVKXJXN6.js";
import "./chunk-PSPR3SUN.js";
import "./chunk-X5TC2QXY.js";
import "./chunk-3CKWSC2S.js";
import "./chunk-OATKFZXF.js";
import "./chunk-6KRH5U5H.js";
import "./chunk-GOIBY4UW.js";
import "./chunk-WPHOZTKQ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-7XZT6QXJ.js";
import {
  TableColumn,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  DEFAULT_CONFIG,
  n,
  t
} from "./chunk-EOF5OWT7.js";
import {
  msg,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/stages/prompt/PromptListPage.ts
var PromptListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Prompts");
  }
  pageDescription() {
    return msg("Single Prompts that can be used for Prompt Stages.");
  }
  pageIcon() {
    return "pf-icon pf-icon-plugged";
  }
  async apiEndpoint(page) {
    return new StagesApi(DEFAULT_CONFIG).stagesPromptPromptsList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || ""
    });
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Field"), "field_key"),
      new TableColumn(msg("Type"), "type"),
      new TableColumn(msg("Order"), "order"),
      new TableColumn(msg("Stages")),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Prompt(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new StagesApi(DEFAULT_CONFIG).stagesPromptPromptsUsedByList({
        promptUuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new StagesApi(DEFAULT_CONFIG).stagesPromptPromptsDestroy({
        promptUuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    return [
      x`${item.name}`,
      x`<code>${item.fieldKey}</code>`,
      x`${item.type}`,
      x`${item.order}`,
      x`${item.promptstageSet?.map((stage) => {
        return x`<li>${stage.name}</li>`;
      })}`,
      x`<ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg("Update Prompt")} </span>
                    <ak-prompt-form slot="form" .instancePk=${item.pk}> </ak-prompt-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                <ak-rbac-object-permission-modal
                    model=${RbacPermissionsAssignedByUsersListModelEnum.StagesPromptPrompt}
                    objectPk=${item.pk}
                >
                </ak-rbac-object-permission-modal> `
    ];
  }
  renderObjectCreate() {
    return x`
            <ak-forms-modal>
                <span slot="submit"> ${msg("Create")} </span>
                <span slot="header"> ${msg("Create Prompt")} </span>
                <ak-prompt-form slot="form"> </ak-prompt-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-forms-modal>
        `;
  }
};
__decorateClass([
  n()
], PromptListPage.prototype, "order", 2);
PromptListPage = __decorateClass([
  t("ak-stage-prompt-list")
], PromptListPage);
export {
  PromptListPage
};
//# sourceMappingURL=PromptListPage-FHJQR4SH.js.map
