import "./chunk-GOSS526A.js";
import "./chunk-KAVSWSBX.js";
import "./chunk-EALY7PEX.js";
import "./chunk-Z7XVYGD6.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-XCEM2TDB.js";
import {
  WizardPage
} from "./chunk-WGDMKZIG.js";
import "./chunk-HDTBIKDJ.js";
import {
  WithLicenseSummary
} from "./chunk-W4RSYEXS.js";
import {
  TablePage
} from "./chunk-R63EXIDN.js";
import "./chunk-DIMKLXAP.js";
import "./chunk-O7KILHL6.js";
import "./chunk-DP47YJ62.js";
import {
  PropertymappingsApi
} from "./chunk-G6FYWANS.js";
import "./chunk-KANCX4AI.js";
import "./chunk-ZKRIRKRW.js";
import "./chunk-4TARICXF.js";
import {
  radio_default
} from "./chunk-SACHAYPZ.js";
import {
  browser_default
} from "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import {
  ModelForm
} from "./chunk-ZVKXJXN6.js";
import {
  Form
} from "./chunk-PSPR3SUN.js";
import "./chunk-6KRH5U5H.js";
import {
  form_default
} from "./chunk-GOIBY4UW.js";
import "./chunk-WPHOZTKQ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-7XZT6QXJ.js";
import {
  TableColumn,
  getURLParam,
  uiConfig,
  updateURLParams
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  AKElement,
  CoreApi,
  DEFAULT_CONFIG,
  button_default,
  docLink,
  first,
  n,
  patternfly_base_default,
  r,
  t
} from "./chunk-EOF5OWT7.js";
import {
  T,
  msg,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/property-mappings/BasePropertyMappingForm.ts
var BasePropertyMappingForm = class extends ModelForm {
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated mapping.") : msg("Successfully created mapping.");
  }
};

// src/admin/property-mappings/PropertyMappingLDAPForm.ts
var PropertyMappingLDAPForm = class extends BasePropertyMappingForm {
  loadInstance(pk) {
    return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsLdapRetrieve({
      pmUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsLdapUpdate({
        pmUuid: this.instance.pk || "",
        lDAPPropertyMappingRequest: data
      });
    } else {
      return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsLdapCreate({
        lDAPPropertyMappingRequest: data
      });
    }
  }
  renderForm() {
    return x` <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${o(this.instance?.name)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Object field")}
                ?required=${true}
                name="objectField"
            >
                <input
                    type="text"
                    value="${o(this.instance?.objectField)}"
                    class="pf-c-form-control"
                    required
                />
                <p class="pf-c-form__helper-text">
                    ${msg("Field of the user object this value is written to.")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Expression")}
                ?required=${true}
                name="expression"
            >
                <ak-codemirror
                    mode=${"python" /* Python */}
                    value="${o(this.instance?.expression)}"
                >
                </ak-codemirror>
                <p class="pf-c-form__helper-text">
                    ${msg("Expression using Python.")}
                    <a
                        target="_blank"
                        href="${docLink("/docs/property-mappings/expression?utm_source=authentik")}"
                    >
                        ${msg("See documentation for a list of all variables.")}
                    </a>
                </p>
            </ak-form-element-horizontal>`;
  }
};
PropertyMappingLDAPForm = __decorateClass([
  t("ak-property-mapping-ldap-form")
], PropertyMappingLDAPForm);

// src/admin/property-mappings/PropertyMappingNotification.ts
var PropertyMappingNotification = class extends ModelForm {
  loadInstance(pk) {
    return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsNotificationRetrieve({
      pmUuid: pk
    });
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated mapping.") : msg("Successfully created mapping.");
  }
  async send(data) {
    if (this.instance) {
      return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsNotificationUpdate({
        pmUuid: this.instance.pk || "",
        notificationWebhookMappingRequest: data
      });
    } else {
      return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsNotificationCreate({
        notificationWebhookMappingRequest: data
      });
    }
  }
  renderForm() {
    return x` <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${o(this.instance?.name)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Expression")}
                ?required=${true}
                name="expression"
            >
                <ak-codemirror
                    mode=${"python" /* Python */}
                    value="${o(this.instance?.expression)}"
                >
                </ak-codemirror>
                <p class="pf-c-form__helper-text">
                    ${msg("Expression using Python.")}
                    <a
                        target="_blank"
                        href="${docLink("/docs/property-mappings/expression?utm_source=authentik")}"
                    >
                        ${msg("See documentation for a list of all variables.")}
                    </a>
                </p>
            </ak-form-element-horizontal>`;
  }
};
PropertyMappingNotification = __decorateClass([
  t("ak-property-mapping-notification-form")
], PropertyMappingNotification);

// src/admin/property-mappings/PropertyMappingRACForm.ts
var staticSettingOptions = [
  {
    label: msg("Unconfigured"),
    value: void 0,
    default: true,
    description: x`${msg("This option will not be changed by this mapping.")}`
  },
  {
    label: msg("Enabled"),
    value: "true"
  },
  {
    label: msg("Disabled"),
    value: "false"
  }
];
var PropertyMappingLDAPForm2 = class extends ModelForm {
  loadInstance(pk) {
    return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsRacRetrieve({
      pmUuid: pk
    });
  }
  getSuccessMessage() {
    if (this.instance) {
      return msg("Successfully updated mapping.");
    } else {
      return msg("Successfully created mapping.");
    }
  }
  async send(data) {
    if (this.instance) {
      return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsRacUpdate({
        pmUuid: this.instance.pk || "",
        rACPropertyMappingRequest: data
      });
    } else {
      return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsRacCreate({
        rACPropertyMappingRequest: data
      });
    }
  }
  renderForm() {
    return x`
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${o(this.instance?.name)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("General settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Username")}
                        name="staticSettings.username"
                    >
                        <input
                            type="text"
                            value="${o(this.instance?.staticSettings.username)}"
                            class="pf-c-form-control"
                            required
                        />
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Password")}
                        name="staticSettings.password"
                    >
                        <input
                            type="password"
                            value="${o(this.instance?.staticSettings.password)}"
                            class="pf-c-form-control"
                            required
                        />
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>
            <ak-form-group>
                <span slot="header"> ${msg("RDP settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Ignore server certificate")}
                        name="staticSettings.ignore-cert"
                    >
                        <ak-radio
                            .options=${staticSettingOptions}
                            .value=${this.instance?.staticSettings["ignore-cert"]}
                        >
                        </ak-radio>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Enable wallpaper")}
                        name="staticSettings.enable-wallpaper"
                    >
                        <ak-radio
                            .options=${staticSettingOptions}
                            .value=${this.instance?.staticSettings["enable-wallpaper"]}
                        >
                        </ak-radio>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Enable font-smoothing")}
                        name="staticSettings.enable-font-smoothing"
                    >
                        <ak-radio
                            .options=${staticSettingOptions}
                            .value=${this.instance?.staticSettings["enable-font-smoothing"]}
                        >
                        </ak-radio>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Enable full window dragging")}
                        name="staticSettings.enable-full-window-drag"
                    >
                        <ak-radio
                            .options=${staticSettingOptions}
                            .value=${this.instance?.staticSettings["enable-full-window-drag"]}
                        >
                        </ak-radio>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>
            <ak-form-group>
                <span slot="header"> ${msg("Advanced settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Expression")}
                        ?required=${true}
                        name="expression"
                    >
                        <ak-codemirror
                            mode=${"python" /* Python */}
                            value="${o(this.instance?.expression)}"
                        >
                        </ak-codemirror>
                        <p class="pf-c-form__helper-text">
                            ${msg("Expression using Python.")}
                            <a
                                target="_blank"
                                href="${docLink(
      "/docs/property-mappings/expression?utm_source=authentik"
    )}"
                            >
                                ${msg("See documentation for a list of all variables.")}
                            </a>
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>
        `;
  }
};
PropertyMappingLDAPForm2 = __decorateClass([
  t("ak-property-mapping-rac-form")
], PropertyMappingLDAPForm2);

// src/admin/property-mappings/PropertyMappingSAMLForm.ts
var PropertyMappingSAMLForm = class extends BasePropertyMappingForm {
  loadInstance(pk) {
    return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsSamlRetrieve({
      pmUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsSamlUpdate({
        pmUuid: this.instance.pk || "",
        sAMLPropertyMappingRequest: data
      });
    } else {
      return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsSamlCreate({
        sAMLPropertyMappingRequest: data
      });
    }
  }
  renderForm() {
    return x` <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${o(this.instance?.name)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("SAML Attribute Name")}
                ?required=${true}
                name="samlName"
            >
                <input
                    type="text"
                    value="${o(this.instance?.samlName)}"
                    class="pf-c-form-control"
                    required
                />
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Attribute name used for SAML Assertions. Can be a URN OID, a schema reference, or a any other string. If this property mapping is used for NameID Property, this field is discarded."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Friendly Name")} name="friendlyName">
                <input
                    type="text"
                    value="${o(this.instance?.friendlyName || "")}"
                    class="pf-c-form-control"
                />
                <p class="pf-c-form__helper-text">
                    ${msg("Optionally set the 'FriendlyName' value of the Assertion attribute.")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Expression")}
                ?required=${true}
                name="expression"
            >
                <ak-codemirror
                    mode=${"python" /* Python */}
                    value="${o(this.instance?.expression)}"
                >
                </ak-codemirror>
                <p class="pf-c-form__helper-text">
                    ${msg("Expression using Python.")}
                    <a
                        target="_blank"
                        href="${docLink("/docs/property-mappings/expression?utm_source=authentik")}"
                    >
                        ${msg("See documentation for a list of all variables.")}
                    </a>
                </p>
            </ak-form-element-horizontal>`;
  }
};
PropertyMappingSAMLForm = __decorateClass([
  t("ak-property-mapping-saml-form")
], PropertyMappingSAMLForm);

// src/admin/property-mappings/PropertyMappingSCIMForm.ts
var PropertyMappingSCIMForm = class extends BasePropertyMappingForm {
  loadInstance(pk) {
    return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsScimRetrieve({
      pmUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsScimUpdate({
        pmUuid: this.instance.pk || "",
        sCIMMappingRequest: data
      });
    } else {
      return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsScimCreate({
        sCIMMappingRequest: data
      });
    }
  }
  renderForm() {
    return x` <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${o(this.instance?.name)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Expression")}
                ?required=${true}
                name="expression"
            >
                <ak-codemirror
                    mode=${"python" /* Python */}
                    value="${o(this.instance?.expression)}"
                >
                </ak-codemirror>
                <p class="pf-c-form__helper-text">
                    ${msg("Expression using Python.")}
                    <a
                        target="_blank"
                        href="${docLink("/docs/property-mappings/expression?utm_source=authentik")}"
                    >
                        ${msg("See documentation for a list of all variables.")}
                    </a>
                </p>
            </ak-form-element-horizontal>`;
  }
};
PropertyMappingSCIMForm = __decorateClass([
  t("ak-property-mapping-scim-form")
], PropertyMappingSCIMForm);

// src/admin/property-mappings/PropertyMappingScopeForm.ts
var PropertyMappingScopeForm = class extends BasePropertyMappingForm {
  loadInstance(pk) {
    return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsScopeRetrieve({
      pmUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsScopeUpdate({
        pmUuid: this.instance.pk || "",
        scopeMappingRequest: data
      });
    } else {
      return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsScopeCreate({
        scopeMappingRequest: data
      });
    }
  }
  renderForm() {
    return x` <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${o(this.instance?.name)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Scope name")}
                ?required=${true}
                name="scopeName"
            >
                <input
                    type="text"
                    value="${o(this.instance?.scopeName)}"
                    class="pf-c-form-control"
                    required
                />
                <p class="pf-c-form__helper-text">
                    ${msg("Scope which the client can specify to access these properties.")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Description")} name="description">
                <input
                    type="text"
                    value="${o(this.instance?.description)}"
                    class="pf-c-form-control"
                />
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Description shown to the user when consenting. If left empty, the user won't be informed."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Expression")}
                ?required=${true}
                name="expression"
            >
                <ak-codemirror
                    mode=${"python" /* Python */}
                    value="${o(this.instance?.expression)}"
                >
                </ak-codemirror>
                <p class="pf-c-form__helper-text">
                    ${msg("Expression using Python.")}
                    <a
                        target="_blank"
                        href="${docLink("/docs/property-mappings/expression?utm_source=authentik")}"
                    >
                        ${msg("See documentation for a list of all variables.")}
                    </a>
                </p>
            </ak-form-element-horizontal>`;
  }
};
PropertyMappingScopeForm = __decorateClass([
  t("ak-property-mapping-scope-form")
], PropertyMappingScopeForm);

// src/admin/property-mappings/PropertyMappingTestForm.ts
var PolicyTestForm = class extends Form {
  getSuccessMessage() {
    return msg("Successfully sent test-request.");
  }
  async send(data) {
    this.request = data;
    const result = await new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsAllTestCreate({
      pmUuid: this.mapping?.pk || "",
      policyTestRequest: data,
      formatResult: true
    });
    return this.result = result;
  }
  renderResult() {
    return x`<ak-form-element-horizontal label=${msg("Result")}>
            ${this.result?.successful ? x`<ak-codemirror
                      mode=${"javascript" /* JavaScript */}
                      ?readOnly=${true}
                      value="${o(this.result?.result)}"
                  >
                  </ak-codemirror>` : x` <div class="pf-c-form__group-label">
                      <div class="c-form__horizontal-group">
                          <span class="pf-c-form__label-text">${this.result?.result}</span>
                      </div>
                  </div>`}
        </ak-form-element-horizontal>`;
  }
  renderExampleButtons() {
    const header = x`<p>${msg("Example context data")}</p>`;
    switch (this.mapping?.metaModelName) {
      case "authentik_sources_ldap.ldappropertymapping":
        return x`${header}${this.renderExampleLDAP()}`;
      default:
        return x``;
    }
  }
  renderExampleLDAP() {
    return x`
            <button
                class="pf-c-button pf-m-secondary"
                role="button"
                @click=${() => {
      this.request = {
        user: this.request?.user || 0,
        context: {
          ldap: {
            displayName: "authentik test user",
            distinguishedName: "cn=user,ou=users,dc=goauthentik,dc=io",
            givenName: "test",
            name: "test-user",
            objectClass: "person",
            objectSid: "S-1-5-21-2611707862-2219215769-354220275-1137",
            sAMAccountName: "sAMAccountName",
            sn: "user"
          }
        }
      };
    }}
            >
                ${msg("Active Directory User")}
            </button>
            <button
                class="pf-c-button pf-m-secondary"
                role="button"
                @click=${() => {
      this.request = {
        user: this.request?.user || 0,
        context: {
          ldap: {
            name: "test-group",
            objectSid: "S-1-5-21-2611707862-2219215769-354220275-1137",
            objectClass: "group",
            distinguishedName: "cn=group,ou=groups,dc=goauthentik,dc=io"
          }
        }
      };
    }}
            >
                ${msg("Active Directory Group")}
            </button>
        `;
  }
  renderForm() {
    return x`<ak-form-element-horizontal label=${msg("User")} ?required=${true} name="user">
                <ak-search-select
                    .fetchObjects=${async (query) => {
      const args = {
        ordering: "username"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const users = await new CoreApi(DEFAULT_CONFIG).coreUsersList(args);
      return users.results;
    }}
                    .renderElement=${(user) => {
      return user.username;
    }}
                    .renderDescription=${(user) => {
      return x`${user.name}`;
    }}
                    .value=${(user) => {
      return user?.pk;
    }}
                    .selected=${(user) => {
      return this.request?.user.toString() === user.pk.toString();
    }}
                >
                </ak-search-select>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Context")} name="context">
                <ak-codemirror
                    mode=${"yaml" /* YAML */}
                    value=${browser_default.stringify(first(this.request?.context, {}))}
                >
                </ak-codemirror>
                <p class="pf-c-form__helper-text">${this.renderExampleButtons()}</p>
            </ak-form-element-horizontal>
            ${this.result ? this.renderResult() : x``}`;
  }
};
__decorateClass([
  n({ attribute: false })
], PolicyTestForm.prototype, "mapping", 2);
__decorateClass([
  n({ attribute: false })
], PolicyTestForm.prototype, "result", 2);
__decorateClass([
  n({ attribute: false })
], PolicyTestForm.prototype, "request", 2);
PolicyTestForm = __decorateClass([
  t("ak-property-mapping-test-form")
], PolicyTestForm);

// src/admin/property-mappings/PropertyMappingWizard.ts
var InitialPropertyMappingWizardPage = class extends WithLicenseSummary(WizardPage) {
  constructor() {
    super(...arguments);
    this.mappingTypes = [];
    this.sidebarLabel = () => msg("Select type");
    this.activeCallback = async () => {
      this.host.isValid = false;
      this.shadowRoot?.querySelectorAll("input[type=radio]").forEach((radio) => {
        if (radio.checked) {
          radio.dispatchEvent(new CustomEvent("change"));
        }
      });
    };
  }
  static get styles() {
    return [patternfly_base_default, form_default, button_default, radio_default];
  }
  render() {
    return x`<form class="pf-c-form pf-m-horizontal">
            ${this.mappingTypes.map((type) => {
      const requiresEnteprise = type.requiresEnterprise && !this.hasEnterpriseLicense;
      return x`<div class="pf-c-radio">
                    <input
                        class="pf-c-radio__input"
                        type="radio"
                        name="type"
                        id=${`${type.component}-${type.modelName}`}
                        @change=${() => {
        this.host.steps = [
          "initial",
          `type-${type.component}-${type.modelName}`
        ];
        this.host.isValid = true;
      }}
                        ?disabled=${type.requiresEnterprise ? this.hasEnterpriseLicense : false}
                    />
                    <label class="pf-c-radio__label" for=${`${type.component}-${type.modelName}`}
                        >${type.name}</label
                    >
                    <span class="pf-c-radio__description"
                        >${type.description}
                        ${requiresEnteprise ? x`<ak-license-notice></ak-license-notice>` : T}</span
                    >
                </div>`;
    })}
        </form>`;
  }
};
__decorateClass([
  n({ attribute: false })
], InitialPropertyMappingWizardPage.prototype, "mappingTypes", 2);
InitialPropertyMappingWizardPage = __decorateClass([
  t("ak-property-mapping-wizard-initial")
], InitialPropertyMappingWizardPage);
var PropertyMappingWizard = class extends AKElement {
  constructor() {
    super(...arguments);
    this.mappingTypes = [];
  }
  static get styles() {
    return [patternfly_base_default, button_default, radio_default];
  }
  async firstUpdated() {
    this.mappingTypes = await new PropertymappingsApi(
      DEFAULT_CONFIG
    ).propertymappingsAllTypesList();
  }
  render() {
    return x`
            <ak-wizard
                .steps=${["initial"]}
                header=${msg("New property mapping")}
                description=${msg("Create a new property mapping.")}
            >
                <ak-property-mapping-wizard-initial
                    slot="initial"
                    .mappingTypes=${this.mappingTypes}
                >
                </ak-property-mapping-wizard-initial>
                ${this.mappingTypes.map((type) => {
      return x`
                        <ak-wizard-page-form
                            slot=${`type-${type.component}-${type.modelName}`}
                            .sidebarLabel=${() => msg(str`Create ${type.name}`)}
                        >
                            <ak-proxy-form type=${type.component}></ak-proxy-form>
                        </ak-wizard-page-form>
                    `;
    })}
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-wizard>
        `;
  }
};
__decorateClass([
  n({ attribute: false })
], PropertyMappingWizard.prototype, "mappingTypes", 2);
PropertyMappingWizard = __decorateClass([
  t("ak-property-mapping-wizard")
], PropertyMappingWizard);

// src/admin/property-mappings/PropertyMappingListPage.ts
var PropertyMappingListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
    this.hideManaged = getURLParam("hideManaged", true);
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Property Mappings");
  }
  pageDescription() {
    return msg("Control how authentik exposes and interprets information.");
  }
  pageIcon() {
    return "pf-icon pf-icon-blueprint";
  }
  async apiEndpoint(page) {
    return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsAllList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || "",
      managedIsnull: this.hideManaged ? true : void 0
    });
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Type"), "type"),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Property Mapping(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsAllUsedByList({
        pmUuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsAllDestroy({
        pmUuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    return [
      x`${item.name}`,
      x`${item.verboseName}`,
      x` <ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg(str`Update ${item.verboseName}`)} </span>
                    <ak-proxy-form
                        slot="form"
                        .args=${{
        instancePk: item.pk
      }}
                        type=${o(item.component)}
                    >
                    </ak-proxy-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                <ak-rbac-object-permission-modal model=${item.metaModelName} objectPk=${item.pk}>
                </ak-rbac-object-permission-modal>
                <ak-forms-modal .closeAfterSuccessfulSubmit=${false}>
                    <span slot="submit"> ${msg("Test")} </span>
                    <span slot="header"> ${msg("Test Property Mapping")} </span>
                    <ak-property-mapping-test-form slot="form" .mapping=${item}>
                    </ak-property-mapping-test-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Test")}>
                            <i class="fas fa-vial" aria-hidden="true"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>`
    ];
  }
  renderObjectCreate() {
    return x`<ak-property-mapping-wizard></ak-property-mapping-wizard> `;
  }
  renderToolbarAfter() {
    return x`&nbsp;
            <div class="pf-c-toolbar__group pf-m-filter-group">
                <div class="pf-c-toolbar__item pf-m-search-filter">
                    <div class="pf-c-input-group">
                        <label class="pf-c-switch">
                            <input
                                class="pf-c-switch__input"
                                type="checkbox"
                                ?checked=${this.hideManaged}
                                @change=${() => {
      this.hideManaged = !this.hideManaged;
      this.page = 1;
      this.fetch();
      updateURLParams({
        hideManaged: this.hideManaged
      });
    }}
                            />
                            <span class="pf-c-switch__toggle">
                                <span class="pf-c-switch__toggle-icon">
                                    <i class="fas fa-check" aria-hidden="true"></i>
                                </span>
                            </span>
                            <span class="pf-c-switch__label">${msg("Hide managed mappings")}</span>
                        </label>
                    </div>
                </div>
            </div>`;
  }
};
__decorateClass([
  n()
], PropertyMappingListPage.prototype, "order", 2);
__decorateClass([
  r()
], PropertyMappingListPage.prototype, "hideManaged", 2);
PropertyMappingListPage = __decorateClass([
  t("ak-property-mapping-list")
], PropertyMappingListPage);
export {
  PropertyMappingListPage
};
//# sourceMappingURL=PropertyMappingListPage-IXUYWQYE.js.map
