import {
  getCountryFlag
} from "./chunk-7PVVYFAP.js";
import "./chunk-GOSS526A.js";
import {
  PoliciesApi
} from "./chunk-JSMKLBKU.js";
import "./chunk-KAVSWSBX.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-EALY7PEX.js";
import "./chunk-Z7XVYGD6.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-XCEM2TDB.js";
import {
  TablePage
} from "./chunk-R63EXIDN.js";
import "./chunk-O7KILHL6.js";
import "./chunk-DP47YJ62.js";
import "./chunk-4TARICXF.js";
import "./chunk-SACHAYPZ.js";
import "./chunk-CZGYCY4V.js";
import "./chunk-ZVKXJXN6.js";
import "./chunk-PSPR3SUN.js";
import "./chunk-KNLDGZQ5.js";
import "./chunk-6KRH5U5H.js";
import "./chunk-GOIBY4UW.js";
import "./chunk-WPHOZTKQ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-7XZT6QXJ.js";
import {
  TableColumn,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  DEFAULT_CONFIG,
  getRelativeTime,
  n,
  t
} from "./chunk-EOF5OWT7.js";
import {
  msg,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/policies/reputation/ReputationListPage.ts
var ReputationListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.order = "identifier";
    this.checkbox = true;
    this.clearOnRefresh = true;
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Reputation scores");
  }
  pageDescription() {
    return msg(
      "Reputation for IP and user identifiers. Scores are decreased for each failed login and increased for each successful login."
    );
  }
  pageIcon() {
    return "fa fa-ban";
  }
  async apiEndpoint(page) {
    return new PoliciesApi(DEFAULT_CONFIG).policiesReputationScoresList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || ""
    });
  }
  columns() {
    return [
      new TableColumn(msg("Identifier"), "identifier"),
      new TableColumn(msg("IP"), "ip"),
      new TableColumn(msg("Score"), "score"),
      new TableColumn(msg("Updated"), "updated"),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Reputation")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new PoliciesApi(DEFAULT_CONFIG).policiesReputationScoresUsedByList({
        reputationUuid: item.pk || ""
      });
    }}
            .delete=${(item) => {
      return new PoliciesApi(DEFAULT_CONFIG).policiesReputationScoresDestroy({
        reputationUuid: item.pk || ""
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    return [
      x`${item.identifier}`,
      x`${item.ipGeoData?.country ? x` ${getCountryFlag(item.ipGeoData.country)} ` : x``}
            ${item.ip}`,
      x`${item.score}`,
      x`<div>${getRelativeTime(item.updated)}</div>
                <small>${item.updated.toLocaleString()}</small>`,
      x`
                <ak-rbac-object-permission-modal
                    model=${RbacPermissionsAssignedByUsersListModelEnum.PoliciesReputationReputationpolicy}
                    objectPk=${item.pk || ""}
                >
                </ak-rbac-object-permission-modal>
            `
    ];
  }
};
__decorateClass([
  n()
], ReputationListPage.prototype, "order", 2);
ReputationListPage = __decorateClass([
  t("ak-policy-reputation-list")
], ReputationListPage);
export {
  ReputationListPage
};
//# sourceMappingURL=ReputationListPage-VHPDESUP.js.map
