import "./chunk-HJY726A2.js";
import {
  RbacApi
} from "./chunk-EALY7PEX.js";
import {
  banner_default
} from "./chunk-WJSRKCWV.js";
import {
  TablePage
} from "./chunk-R63EXIDN.js";
import "./chunk-CZGYCY4V.js";
import "./chunk-ZVKXJXN6.js";
import "./chunk-PSPR3SUN.js";
import "./chunk-GOIBY4UW.js";
import "./chunk-WPHOZTKQ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-7XZT6QXJ.js";
import {
  TableColumn,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  DEFAULT_CONFIG,
  n,
  t
} from "./chunk-EOF5OWT7.js";
import {
  msg,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/roles/RoleListPage.ts
var RoleListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Roles");
  }
  pageDescription() {
    return msg("Manage roles which grant permissions to objects within authentik.");
  }
  pageIcon() {
    return "fa fa-lock";
  }
  static get styles() {
    return [...super.styles, banner_default];
  }
  async apiEndpoint(page) {
    return new RbacApi(DEFAULT_CONFIG).rbacRolesList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || ""
    });
  }
  columns() {
    return [new TableColumn(msg("Name"), "name"), new TableColumn(msg("Actions"))];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Role(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new RbacApi(DEFAULT_CONFIG).rbacRolesUsedByList({
        uuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new RbacApi(DEFAULT_CONFIG).rbacRolesDestroy({
        uuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  render() {
    return x`<ak-page-header
                icon=${this.pageIcon()}
                header=${this.pageTitle()}
                description=${o(this.pageDescription())}
            >
            </ak-page-header>
            <div class="pf-c-banner pf-m-info">
                ${msg("RBAC is in preview.")}
                <a href="mailto:hello@goauthentik.io">${msg("Send us feedback!")}</a>
            </div>
            <section class="pf-c-page__main-section pf-m-no-padding-mobile">
                <div class="pf-c-card">${this.renderTable()}</div>
            </section>`;
  }
  row(item) {
    return [
      x`<a href="#/identity/roles/${item.pk}">${item.name}</a>`,
      x`<ak-forms-modal>
                <span slot="submit"> ${msg("Update")} </span>
                <span slot="header"> ${msg("Update Role")} </span>
                <ak-role-form slot="form" .instancePk=${item.pk}> </ak-role-form>
                <button slot="trigger" class="pf-c-button pf-m-plain">
                    <pf-tooltip position="top" content=${msg("Edit")}>
                        <i class="fas fa-edit"></i>
                    </pf-tooltip>
                </button>
            </ak-forms-modal>`
    ];
  }
  renderObjectCreate() {
    return x`
            <ak-forms-modal>
                <span slot="submit"> ${msg("Create")} </span>
                <span slot="header"> ${msg("Create Role")} </span>
                <ak-role-form slot="form"> </ak-role-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-forms-modal>
        `;
  }
};
__decorateClass([
  n()
], RoleListPage.prototype, "order", 2);
RoleListPage = __decorateClass([
  t("ak-role-list")
], RoleListPage);
export {
  RoleListPage
};
//# sourceMappingURL=RoleListPage-POYW72OE.js.map
