import "./chunk-GOSS526A.js";
import "./chunk-RYAWZLUH.js";
import "./chunk-G5F4IS6Y.js";
import "./chunk-TESI44EG.js";
import "./chunk-JUAKJGB5.js";
import "./chunk-JSMKLBKU.js";
import "./chunk-KAVSWSBX.js";
import "./chunk-6CKD6XNN.js";
import "./chunk-7V5SMFL5.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-EALY7PEX.js";
import {
  severityToLabel
} from "./chunk-BEFPUR3G.js";
import "./chunk-AP5GHUBV.js";
import "./chunk-Z7XVYGD6.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-XX4MPIVG.js";
import "./chunk-WGDMKZIG.js";
import {
  TablePage
} from "./chunk-R63EXIDN.js";
import "./chunk-4L2VSKMK.js";
import "./chunk-O7KILHL6.js";
import "./chunk-IZQSSDOF.js";
import "./chunk-DP47YJ62.js";
import "./chunk-KANCX4AI.js";
import "./chunk-ZKRIRKRW.js";
import "./chunk-4TARICXF.js";
import "./chunk-SACHAYPZ.js";
import "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import {
  ModelForm
} from "./chunk-ZVKXJXN6.js";
import "./chunk-PSPR3SUN.js";
import "./chunk-KNLDGZQ5.js";
import "./chunk-6KRH5U5H.js";
import "./chunk-GOIBY4UW.js";
import "./chunk-WPHOZTKQ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-7XZT6QXJ.js";
import {
  TableColumn,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  CoreApi,
  DEFAULT_CONFIG,
  EventsApi,
  SeverityEnum,
  n,
  t
} from "./chunk-EOF5OWT7.js";
import {
  msg,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/events/RuleForm.ts
var RuleForm = class extends ModelForm {
  loadInstance(pk) {
    return new EventsApi(DEFAULT_CONFIG).eventsRulesRetrieve({
      pbmUuid: pk
    });
  }
  async load() {
    this.eventTransports = await new EventsApi(DEFAULT_CONFIG).eventsTransportsList({
      ordering: "name"
    });
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated rule.") : msg("Successfully created rule.");
  }
  async send(data) {
    if (this.instance) {
      return new EventsApi(DEFAULT_CONFIG).eventsRulesUpdate({
        pbmUuid: this.instance.pk || "",
        notificationRuleRequest: data
      });
    } else {
      return new EventsApi(DEFAULT_CONFIG).eventsRulesCreate({
        notificationRuleRequest: data
      });
    }
  }
  renderForm() {
    return x` <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${o(this.instance?.name)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Group")} name="group">
                <ak-search-select
                    .fetchObjects=${async (query) => {
      const args = {
        ordering: "name"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const groups = await new CoreApi(DEFAULT_CONFIG).coreGroupsList(args);
      return groups.results;
    }}
                    .renderElement=${(group) => {
      return group.name;
    }}
                    .value=${(group) => {
      return group?.pk;
    }}
                    .selected=${(group) => {
      return group.pk === this.instance?.group;
    }}
                    ?blankable=${true}
                >
                </ak-search-select>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Select the group of users which the alerts are sent to. If no group is selected the rule is disabled."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Transports")}
                ?required=${true}
                name="transports"
            >
                <select class="pf-c-form-control" multiple>
                    ${this.eventTransports?.results.map((transport) => {
      const selected = Array.from(this.instance?.transports || []).some((su) => {
        return su == transport.pk;
      });
      return x`<option value=${o(transport.pk)} ?selected=${selected}>
                            ${transport.name}
                        </option>`;
    })}
                </select>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Select which transports should be used to notify the user. If none are selected, the notification will only be shown in the authentik UI."
    )}
                </p>
                <p class="pf-c-form__helper-text">
                    ${msg("Hold control/command to select multiple items.")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Severity")} ?required=${true} name="severity">
                <ak-radio
                    .options=${[
      {
        label: severityToLabel(SeverityEnum.Alert),
        value: SeverityEnum.Alert,
        default: true
      },
      {
        label: severityToLabel(SeverityEnum.Warning),
        value: SeverityEnum.Warning
      },
      {
        label: severityToLabel(SeverityEnum.Notice),
        value: SeverityEnum.Notice
      }
    ]}
                    .value=${this.instance?.severity}
                >
                </ak-radio>
            </ak-form-element-horizontal>`;
  }
};
RuleForm = __decorateClass([
  t("ak-event-rule-form")
], RuleForm);

// src/admin/events/RuleListPage.ts
var RuleListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.expandable = true;
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Notification Rules");
  }
  pageDescription() {
    return msg(
      "Send notifications whenever a specific Event is created and matched by policies."
    );
  }
  pageIcon() {
    return "pf-icon pf-icon-attention-bell";
  }
  async apiEndpoint(page) {
    return new EventsApi(DEFAULT_CONFIG).eventsRulesList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || ""
    });
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Severity"), "severity"),
      new TableColumn(msg("Sent to group"), "group"),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Notification rule(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new EventsApi(DEFAULT_CONFIG).eventsRulesUsedByList({
        pbmUuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new EventsApi(DEFAULT_CONFIG).eventsRulesDestroy({
        pbmUuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    return [
      x`${item.name}`,
      x`${severityToLabel(item.severity)}`,
      x`${item.groupObj ? x`<a href="#/identity/groups/${item.groupObj.pk}">${item.groupObj.name}</a>` : msg("None (rule disabled)")}`,
      x`<ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg("Update Notification Rule")} </span>
                    <ak-event-rule-form slot="form" .instancePk=${item.pk}> </ak-event-rule-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>

                <ak-rbac-object-permission-modal
                    model=${RbacPermissionsAssignedByUsersListModelEnum.EventsNotificationrule}
                    objectPk=${item.pk}
                >
                </ak-rbac-object-permission-modal>`
    ];
  }
  renderObjectCreate() {
    return x`
            <ak-forms-modal>
                <span slot="submit"> ${msg("Create")} </span>
                <span slot="header"> ${msg("Create Notification Rule")} </span>
                <ak-event-rule-form slot="form"> </ak-event-rule-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-forms-modal>
        `;
  }
  renderExpanded(item) {
    return x` <td role="cell" colspan="4">
            <div class="pf-c-table__expandable-row-content">
                <p>
                    ${msg(
      `These bindings control upon which events this rule triggers.
Bindings to groups/users are checked against the user of the event.`
    )}
                </p>
                <ak-bound-policies-list .target=${item.pk}> </ak-bound-policies-list>
            </div>
        </td>`;
  }
};
__decorateClass([
  n()
], RuleListPage.prototype, "order", 2);
RuleListPage = __decorateClass([
  t("ak-event-rule-list")
], RuleListPage);
export {
  RuleListPage
};
//# sourceMappingURL=RuleListPage-MO4Q4IJB.js.map
