import "./chunk-CRCFAAYI.js";
import {
  OutpostsApi
} from "./chunk-VVP3K3IZ.js";
import "./chunk-GOSS526A.js";
import "./chunk-KAVSWSBX.js";
import "./chunk-EALY7PEX.js";
import "./chunk-Z7XVYGD6.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-XX4MPIVG.js";
import "./chunk-DJQHOO67.js";
import {
  WizardPage
} from "./chunk-WGDMKZIG.js";
import "./chunk-Y5HTBO47.js";
import {
  TablePage
} from "./chunk-R63EXIDN.js";
import "./chunk-O7KILHL6.js";
import "./chunk-DP47YJ62.js";
import "./chunk-TGYIXJOL.js";
import "./chunk-FOQO4NRV.js";
import "./chunk-KANCX4AI.js";
import {
  radio_default
} from "./chunk-SACHAYPZ.js";
import {
  browser_default
} from "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import {
  ModelForm
} from "./chunk-ZVKXJXN6.js";
import "./chunk-PSPR3SUN.js";
import "./chunk-6KRH5U5H.js";
import {
  form_default
} from "./chunk-GOIBY4UW.js";
import "./chunk-WPHOZTKQ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-7XZT6QXJ.js";
import {
  TableColumn,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  button_default,
  first,
  n,
  patternfly_base_default,
  r,
  t
} from "./chunk-EOF5OWT7.js";
import {
  msg,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/outposts/ServiceConnectionDockerForm.ts
var ServiceConnectionDockerForm = class extends ModelForm {
  loadInstance(pk) {
    return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsDockerRetrieve({
      uuid: pk
    });
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated integration.") : msg("Successfully created integration.");
  }
  async send(data) {
    if (this.instance) {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsDockerUpdate({
        uuid: this.instance.pk || "",
        dockerServiceConnectionRequest: data
      });
    } else {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsDockerCreate({
        dockerServiceConnectionRequest: data
      });
    }
  }
  renderForm() {
    return x` <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${o(this.instance?.name)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal name="local">
                <label class="pf-c-switch">
                    <input
                        class="pf-c-switch__input"
                        type="checkbox"
                        ?checked=${first(this.instance?.local, false)}
                    />
                    <span class="pf-c-switch__toggle">
                        <span class="pf-c-switch__toggle-icon">
                            <i class="fas fa-check" aria-hidden="true"></i>
                        </span>
                    </span>
                    <span class="pf-c-switch__label">${msg("Local")}</span>
                </label>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "If enabled, use the local connection. Required Docker socket/Kubernetes Integration."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Docker URL")} ?required=${true} name="url">
                <input
                    type="text"
                    value="${o(this.instance?.url)}"
                    class="pf-c-form-control"
                    required
                />
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Can be in the format of 'unix://' when connecting to a local docker daemon, using 'ssh://' to connect via SSH, or 'https://:2376' when connecting to a remote system."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("TLS Verification Certificate")}
                name="tlsVerification"
            >
                <ak-crypto-certificate-search
                    .certificate=${this.instance?.tlsVerification}
                ></ak-crypto-certificate-search>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "CA which the endpoint's Certificate is verified against. Can be left empty for no validation."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("TLS Authentication Certificate/SSH Keypair")}
                name="tlsAuthentication"
            >
                <ak-crypto-certificate-search
                    .certificate=${this.instance?.tlsAuthentication}
                ></ak-crypto-certificate-search>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Certificate/Key used for authentication. Can be left empty for no authentication."
    )}
                </p>
                <p class="pf-c-form__helper-text">
                    ${msg("When connecting via SSH, this keypair is used for authentication.")}
                </p>
            </ak-form-element-horizontal>`;
  }
};
ServiceConnectionDockerForm = __decorateClass([
  t("ak-service-connection-docker-form")
], ServiceConnectionDockerForm);

// src/admin/outposts/ServiceConnectionKubernetesForm.ts
var ServiceConnectionKubernetesForm = class extends ModelForm {
  loadInstance(pk) {
    return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsKubernetesRetrieve({
      uuid: pk
    });
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated integration.") : msg("Successfully created integration.");
  }
  async send(data) {
    if (this.instance) {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsKubernetesUpdate({
        uuid: this.instance.pk || "",
        kubernetesServiceConnectionRequest: data
      });
    } else {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsKubernetesCreate({
        kubernetesServiceConnectionRequest: data
      });
    }
  }
  renderForm() {
    return x` <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${o(this.instance?.name)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal name="local">
                <label class="pf-c-switch">
                    <input
                        class="pf-c-switch__input"
                        type="checkbox"
                        ?checked=${first(this.instance?.local, false)}
                    />
                    <span class="pf-c-switch__toggle">
                        <span class="pf-c-switch__toggle-icon">
                            <i class="fas fa-check" aria-hidden="true"></i>
                        </span>
                    </span>
                    <span class="pf-c-switch__label">${msg("Local")}</span>
                </label>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "If enabled, use the local connection. Required Docker socket/Kubernetes Integration."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Kubeconfig")} name="kubeconfig">
                <ak-codemirror
                    mode=${"yaml" /* YAML */}
                    value="${browser_default.stringify(first(this.instance?.kubeconfig, {}))}"
                >
                </ak-codemirror>
                <p class="pf-c-form__helper-text">
                    ${msg("Set custom attributes using YAML or JSON.")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal name="verifySsl">
                <label class="pf-c-switch">
                    <input
                        class="pf-c-switch__input"
                        type="checkbox"
                        ?checked=${first(this.instance?.verifySsl, true)}
                    />
                    <span class="pf-c-switch__toggle">
                        <span class="pf-c-switch__toggle-icon">
                            <i class="fas fa-check" aria-hidden="true"></i>
                        </span>
                    </span>
                    <span class="pf-c-switch__label"
                        >${msg("Verify Kubernetes API SSL Certificate")}</span
                    >
                </label>
            </ak-form-element-horizontal>`;
  }
};
ServiceConnectionKubernetesForm = __decorateClass([
  t("ak-service-connection-kubernetes-form")
], ServiceConnectionKubernetesForm);

// src/admin/outposts/ServiceConnectionWizard.ts
var InitialServiceConnectionWizardPage = class extends WizardPage {
  constructor() {
    super(...arguments);
    this.connectionTypes = [];
    this.sidebarLabel = () => msg("Select type");
    this.activeCallback = async () => {
      this.host.isValid = false;
      this.shadowRoot?.querySelectorAll("input[type=radio]").forEach((radio) => {
        if (radio.checked) {
          radio.dispatchEvent(new CustomEvent("change"));
        }
      });
    };
  }
  static get styles() {
    return [patternfly_base_default, form_default, button_default, radio_default];
  }
  render() {
    return x`<form class="pf-c-form pf-m-horizontal">
            ${this.connectionTypes.map((type) => {
      return x`<div class="pf-c-radio">
                    <input
                        class="pf-c-radio__input"
                        type="radio"
                        name="type"
                        id=${`${type.component}-${type.modelName}`}
                        @change=${() => {
        this.host.steps = [
          "initial",
          `type-${type.component}-${type.modelName}`
        ];
        this.host.isValid = true;
      }}
                    />
                    <label class="pf-c-radio__label" for=${`${type.component}-${type.modelName}`}
                        >${type.name}</label
                    >
                    <span class="pf-c-radio__description">${type.description}</span>
                </div>`;
    })}
        </form>`;
  }
};
__decorateClass([
  n({ attribute: false })
], InitialServiceConnectionWizardPage.prototype, "connectionTypes", 2);
InitialServiceConnectionWizardPage = __decorateClass([
  t("ak-service-connection-wizard-initial")
], InitialServiceConnectionWizardPage);
var ServiceConnectionWizard = class extends AKElement {
  constructor() {
    super(...arguments);
    this.createText = msg("Create");
    this.connectionTypes = [];
  }
  static get styles() {
    return [patternfly_base_default, button_default, radio_default];
  }
  firstUpdated() {
    new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsAllTypesList().then((types) => {
      this.connectionTypes = types;
    });
  }
  render() {
    return x`
            <ak-wizard
                .steps=${["initial"]}
                header=${msg("New outpost integration")}
                description=${msg("Create a new outpost integration.")}
            >
                <ak-service-connection-wizard-initial
                    slot="initial"
                    .connectionTypes=${this.connectionTypes}
                >
                </ak-service-connection-wizard-initial>
                ${this.connectionTypes.map((type) => {
      return x`
                        <ak-wizard-page-form
                            slot=${`type-${type.component}-${type.modelName}`}
                            .sidebarLabel=${() => msg(str`Create ${type.name}`)}
                        >
                            <ak-proxy-form type=${type.component}></ak-proxy-form>
                        </ak-wizard-page-form>
                    `;
    })}
                <button slot="trigger" class="pf-c-button pf-m-primary">${this.createText}</button>
            </ak-wizard>
        `;
  }
};
__decorateClass([
  n()
], ServiceConnectionWizard.prototype, "createText", 2);
__decorateClass([
  n({ attribute: false })
], ServiceConnectionWizard.prototype, "connectionTypes", 2);
ServiceConnectionWizard = __decorateClass([
  t("ak-service-connection-wizard")
], ServiceConnectionWizard);

// src/admin/outposts/ServiceConnectionListPage.ts
var OutpostServiceConnectionListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.state = {};
    this.order = "name";
  }
  pageTitle() {
    return "Outpost integrations";
  }
  pageDescription() {
    return "Outpost integrations define how authentik connects to external platforms to manage and deploy Outposts.";
  }
  pageIcon() {
    return "pf-icon pf-icon-integration";
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint(page) {
    const connections = await new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsAllList(
      {
        ordering: this.order,
        page,
        pageSize: (await uiConfig()).pagination.perPage,
        search: this.search || ""
      }
    );
    Promise.all(
      connections.results.map((connection) => {
        return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsAllStateRetrieve({
          uuid: connection.pk
        }).then((state) => {
          this.state[connection.pk] = state;
        });
      })
    );
    return connections;
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Type")),
      new TableColumn(msg("Local"), "local"),
      new TableColumn(msg("State")),
      new TableColumn(msg("Actions"))
    ];
  }
  row(item) {
    const itemState = this.state[item.pk];
    return [
      x`${item.name}`,
      x`${item.verboseName}`,
      x`<ak-status-label type="info" ?good=${item.local}></ak-status-label>`,
      x`${itemState?.healthy ? x`<ak-label color=${"pf-m-green" /* Green */}>${o(itemState.version)}</ak-label>` : x`<ak-label color=${"pf-m-red" /* Red */}>${msg("Unhealthy")}</ak-label>`}`,
      x`
                <ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg(str`Update ${item.verboseName}`)} </span>
                    <ak-proxy-form
                        slot="form"
                        .args=${{
        instancePk: item.pk
      }}
                        type=${o(item.component)}
                    >
                    </ak-proxy-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                <ak-rbac-object-permission-modal model=${item.metaModelName} objectPk=${item.pk}>
                </ak-rbac-object-permission-modal>
            `
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Outpost integration(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsAllUsedByList({
        uuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsAllDestroy({
        uuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  renderObjectCreate() {
    return x`<ak-service-connection-wizard></ak-service-connection-wizard> `;
  }
};
__decorateClass([
  r()
], OutpostServiceConnectionListPage.prototype, "state", 2);
__decorateClass([
  n()
], OutpostServiceConnectionListPage.prototype, "order", 2);
OutpostServiceConnectionListPage = __decorateClass([
  t("ak-outpost-service-connection-list")
], OutpostServiceConnectionListPage);
export {
  OutpostServiceConnectionListPage
};
//# sourceMappingURL=ServiceConnectionListPage-YHOZL2NY.js.map
