import {
  Diagram
} from "./chunk-I4DDVBVK.js";
import "./chunk-ZAJ4I4EK.js";
import "./chunk-QPYNOECS.js";
import {
  UserMatchingModeToLabel
} from "./chunk-ZF4XK2A3.js";
import "./chunk-CQKVQBLB.js";
import "./chunk-TEDVXOVK.js";
import "./chunk-RYAWZLUH.js";
import "./chunk-G5F4IS6Y.js";
import "./chunk-SFKV34FB.js";
import "./chunk-TESI44EG.js";
import "./chunk-JUAKJGB5.js";
import "./chunk-JSMKLBKU.js";
import "./chunk-KAVSWSBX.js";
import "./chunk-6CKD6XNN.js";
import "./chunk-7V5SMFL5.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-EALY7PEX.js";
import "./chunk-YNQN4LE7.js";
import "./chunk-ME2U4GBS.js";
import "./chunk-BEFPUR3G.js";
import "./chunk-AP5GHUBV.js";
import "./chunk-Z7XVYGD6.js";
import {
  banner_default
} from "./chunk-WJSRKCWV.js";
import "./chunk-FNV26V2B.js";
import {
  grid_default
} from "./chunk-XCEM2TDB.js";
import "./chunk-EGRHWZRV.js";
import "./chunk-XX4MPIVG.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import "./chunk-WGDMKZIG.js";
import "./chunk-4L2VSKMK.js";
import "./chunk-O7KILHL6.js";
import "./chunk-IZQSSDOF.js";
import "./chunk-DP47YJ62.js";
import "./chunk-AX3TXADI.js";
import "./chunk-G6FYWANS.js";
import "./chunk-TGYIXJOL.js";
import "./chunk-FOQO4NRV.js";
import "./chunk-JMBXTRNL.js";
import "./chunk-ZZAG5J6S.js";
import "./chunk-2XSPVNET.js";
import "./chunk-KANCX4AI.js";
import "./chunk-ZKRIRKRW.js";
import "./chunk-4TARICXF.js";
import "./chunk-SACHAYPZ.js";
import "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import "./chunk-ZVKXJXN6.js";
import "./chunk-PSPR3SUN.js";
import {
  ProviderTypeEnum,
  SourcesApi,
  UserMatchingModeEnum
} from "./chunk-XSB422CX.js";
import "./chunk-X5TC2QXY.js";
import "./chunk-ZBQTYGSF.js";
import "./chunk-3CKWSC2S.js";
import "./chunk-2G3GM457.js";
import "./chunk-OATKFZXF.js";
import "./chunk-KNLDGZQ5.js";
import "./chunk-6KRH5U5H.js";
import {
  form_default
} from "./chunk-GOIBY4UW.js";
import {
  list_default
} from "./chunk-WPHOZTKQ.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import "./chunk-XPFXHVQV.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-7XZT6QXJ.js";
import {
  Table,
  TableColumn,
  form_control_default,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  EVENT_REFRESH,
  SystemTaskStatusEnum,
  button_default,
  content_default,
  n,
  page_default,
  patternfly_base_default,
  r,
  t
} from "./chunk-EOF5OWT7.js";
import {
  msg,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/sources/ldap/LDAPSourceConnectivity.ts
var LDAPSourceConnectivity = class extends AKElement {
  static get styles() {
    return [patternfly_base_default, list_default];
  }
  render() {
    if (!this.connectivity) {
      return x``;
    }
    return x`<ul class="pf-c-list">
            ${Object.keys(this.connectivity).map((serverKey) => {
      let serverLabel = x`${serverKey}`;
      if (serverKey === "__all__") {
        serverLabel = x`<b>${msg("Global status")}</b>`;
      }
      const server = this.connectivity[serverKey];
      const content = x`${serverLabel}: ${server.status}`;
      let tooltip = x`${content}`;
      if (server.status === "ok") {
        tooltip = x`<pf-tooltip position="top">
                        <ul slot="content" class="pf-c-list">
                            <li>${msg("Vendor")}: ${server.vendor}</li>
                            <li>${msg("Version")}: ${server.version}</li>
                        </ul>
                        ${content}
                    </pf-tooltip>`;
      }
      return x`<li>${tooltip}</li>`;
    })}
        </ul>`;
  }
};
__decorateClass([
  n()
], LDAPSourceConnectivity.prototype, "connectivity", 2);
LDAPSourceConnectivity = __decorateClass([
  t("ak-source-ldap-connectivity")
], LDAPSourceConnectivity);

// src/admin/sources/ldap/LDAPSourceViewPage.ts
var LDAPSourceViewPage = class extends AKElement {
  set sourceSlug(slug) {
    new SourcesApi(DEFAULT_CONFIG).sourcesLdapRetrieve({
      slug
    }).then((source) => {
      this.source = source;
    });
  }
  static get styles() {
    return [patternfly_base_default, page_default, button_default, grid_default, content_default, card_default, description_list_default, list_default];
  }
  constructor() {
    super();
    this.addEventListener(EVENT_REFRESH, () => {
      if (!this.source?.slug)
        return;
      this.sourceSlug = this.source?.slug;
    });
  }
  renderSyncStatus() {
    if (!this.syncState) {
      return x`${msg("No sync status.")}`;
    }
    if (this.syncState.isRunning) {
      return x`${msg("Sync currently running.")}`;
    }
    if (this.syncState.tasks.length < 1) {
      return x`${msg("Not synced yet.")}`;
    }
    return x`
            <ul class="pf-c-list">
                ${this.syncState.tasks.map((task) => {
      let header = "";
      if (task.status === SystemTaskStatusEnum.Warning) {
        header = msg("Task finished with warnings");
      } else if (task.status === SystemTaskStatusEnum.Error) {
        header = msg("Task finished with errors");
      } else {
        header = msg(str`Last sync: ${task.finishTimestamp.toLocaleString()}`);
      }
      return x`<li>
                        <p>${task.name}</p>
                        <ul class="pf-c-list">
                            <li>${header}</li>
                            ${task.messages.map((m) => {
        return x`<li>${m}</li>`;
      })}
                        </ul>
                    </li> `;
    })}
            </ul>
        `;
  }
  load() {
    new SourcesApi(DEFAULT_CONFIG).sourcesLdapSyncStatusRetrieve({
      slug: this.source.slug
    }).then((state) => {
      this.syncState = state;
    });
  }
  render() {
    if (!this.source) {
      return x``;
    }
    return x`<ak-tabs>
            <section
                slot="page-overview"
                data-tab-title="${msg("Overview")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
                @activate=${() => {
      this.load();
    }}
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <dl class="pf-c-description-list pf-m-2-col-on-lg">
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Name")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.name}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Server URI")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.serverUri}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Base DN")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            <ul>
                                                <li>${this.source.baseDn}</li>
                                            </ul>
                                        </div>
                                    </dd>
                                </div>
                            </dl>
                        </div>
                        <div class="pf-c-card__footer">
                            <ak-forms-modal>
                                <span slot="submit"> ${msg("Update")} </span>
                                <span slot="header"> ${msg("Update LDAP Source")} </span>
                                <ak-source-ldap-form slot="form" .instancePk=${this.source.slug}>
                                </ak-source-ldap-form>
                                <button slot="trigger" class="pf-c-button pf-m-primary">
                                    ${msg("Edit")}
                                </button>
                            </ak-forms-modal>
                        </div>
                    </div>
                    <div class="pf-c-card pf-l-grid__item pf-m-2-col">
                        <div class="pf-c-card__title">
                            <p>${msg("Connectivity")}</p>
                        </div>
                        <div class="pf-c-card__body">
                            <ak-source-ldap-connectivity
                                .connectivity=${this.source.connectivity}
                            ></ak-source-ldap-connectivity>
                        </div>
                    </div>
                    <div class="pf-c-card pf-l-grid__item pf-m-10-col">
                        <div class="pf-c-card__title">
                            <p>${msg("Sync status")}</p>
                        </div>
                        <div class="pf-c-card__body">${this.renderSyncStatus()}</div>
                        <div class="pf-c-card__footer">
                            <ak-action-button
                                class="pf-m-secondary"
                                ?disabled=${this.syncState?.isRunning}
                                .apiRequest=${() => {
      return new SourcesApi(DEFAULT_CONFIG).sourcesLdapPartialUpdate({
        slug: this.source?.slug || "",
        patchedLDAPSourceRequest: this.source
      }).then(() => {
        this.dispatchEvent(
          new CustomEvent(EVENT_REFRESH, {
            bubbles: true,
            composed: true
          })
        );
        this.load();
      });
    }}
                            >
                                ${msg("Run sync again")}
                            </ak-action-button>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-changelog"
                data-tab-title="${msg("Changelog")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this.source.pk || ""}
                                targetModelApp="authentik_sources_ldap"
                                targetModelName="ldapsource"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.SourcesLdapLdapsource}
                objectPk=${this.source.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], LDAPSourceViewPage.prototype, "sourceSlug", 1);
__decorateClass([
  n({ attribute: false })
], LDAPSourceViewPage.prototype, "source", 2);
__decorateClass([
  r()
], LDAPSourceViewPage.prototype, "syncState", 2);
LDAPSourceViewPage = __decorateClass([
  t("ak-source-ldap-view")
], LDAPSourceViewPage);

// src/admin/sources/oauth/OAuthSourceDiagram.ts
var OAuthSourceDiagram = class extends Diagram {
  constructor() {
    super(...arguments);
    this.refreshHandler = () => {
      if (!this.source)
        return;
      const graph = ["graph LR"];
      graph.push(`source[${msg(str`OAuth Source ${this.source.name}`)}]`);
      graph.push(
        `source --> flow_manager["${UserMatchingModeToLabel(
          this.source.userMatchingMode || UserMatchingModeEnum.Identifier
        )}"]`
      );
      if (this.source.enrollmentFlow) {
        graph.push("flow_manager --> flow_enroll[Enrollment flow]");
      }
      if (this.source.authenticationFlow) {
        graph.push("flow_manager --> flow_auth[Authentication flow]");
      }
      this.diagram = graph.join("\n");
    };
  }
};
__decorateClass([
  n({ attribute: false })
], OAuthSourceDiagram.prototype, "source", 2);
OAuthSourceDiagram = __decorateClass([
  t("ak-source-oauth-diagram")
], OAuthSourceDiagram);

// src/admin/sources/oauth/OAuthSourceViewPage.ts
function ProviderToLabel(provider) {
  switch (provider) {
    case void 0:
      return "";
    case ProviderTypeEnum.Apple:
      return "Apple";
    case ProviderTypeEnum.Azuread:
      return "Azure Active Directory";
    case ProviderTypeEnum.Discord:
      return "Discord";
    case ProviderTypeEnum.Facebook:
      return "Facebook";
    case ProviderTypeEnum.Github:
      return "GitHub";
    case ProviderTypeEnum.Gitlab:
      return "GitLab";
    case ProviderTypeEnum.Google:
      return "Google";
    case ProviderTypeEnum.Mailcow:
      return "Mailcow";
    case ProviderTypeEnum.Openidconnect:
      return msg("Generic OpenID Connect");
    case ProviderTypeEnum.Okta:
      return "Okta";
    case ProviderTypeEnum.Patreon:
      return "Patreon";
    case ProviderTypeEnum.Reddit:
      return "Reddit";
    case ProviderTypeEnum.Twitter:
      return "Twitter";
    case ProviderTypeEnum.Twitch:
      return "Twitch";
    case ProviderTypeEnum.UnknownDefaultOpenApi:
      return msg("Unknown provider type");
  }
}
var OAuthSourceViewPage = class extends AKElement {
  set sourceSlug(value) {
    new SourcesApi(DEFAULT_CONFIG).sourcesOauthRetrieve({
      slug: value
    }).then((source) => {
      this.source = source;
    });
  }
  static get styles() {
    return [patternfly_base_default, page_default, button_default, grid_default, content_default, card_default, description_list_default];
  }
  constructor() {
    super();
    this.addEventListener(EVENT_REFRESH, () => {
      if (!this.source?.pk)
        return;
      this.sourceSlug = this.source?.slug;
    });
  }
  render() {
    if (!this.source) {
      return x``;
    }
    return x`<ak-tabs>
            <section
                slot="page-overview"
                data-tab-title="${msg("Overview")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__title">${msg("Details")}</div>
                        <div class="pf-c-card__body">
                            <dl class="pf-c-description-list pf-m-2-col-on-lg">
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Name")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.name}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Provider Type")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${ProviderToLabel(this.source.providerType)}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Callback URL")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <code class="pf-c-description-list__text"
                                            >${this.source.callbackUrl}</code
                                        >
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Access Key")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.consumerKey}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Authorization URL")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.type?.authorizationUrl || this.source.authorizationUrl}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Token URL")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.type?.accessTokenUrl || this.source.accessTokenUrl}
                                        </div>
                                    </dd>
                                </div>
                            </dl>
                        </div>
                        <div class="pf-c-card__footer">
                            <ak-forms-modal>
                                <span slot="submit"> ${msg("Update")} </span>
                                <span slot="header"> ${msg("Update OAuth Source")} </span>
                                <ak-source-oauth-form slot="form" .instancePk=${this.source.slug}>
                                </ak-source-oauth-form>
                                <button slot="trigger" class="pf-c-button pf-m-primary">
                                    ${msg("Edit")}
                                </button>
                            </ak-forms-modal>
                        </div>
                    </div>
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__title">${msg("Diagram")}</div>
                        <div class="pf-c-card__body">
                            <ak-source-oauth-diagram
                                .source=${this.source}
                            ></ak-source-oauth-diagram>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-changelog"
                data-tab-title="${msg("Changelog")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this.source.pk || ""}
                                targetModelApp="authentik_sources_oauth"
                                targetModelName="oauthsource"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <div
                slot="page-policy-binding"
                data-tab-title="${msg("Policy Bindings")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__title">
                            ${msg(
      `These bindings control which users can access this source.
            You can only use policies here as access is checked before the user is authenticated.`
    )}
                        </div>
                        <div class="pf-c-card__body">
                            <ak-bound-policies-list .target=${this.source.pk} ?policyOnly=${true}>
                            </ak-bound-policies-list>
                        </div>
                    </div>
                </div>
            </div>
            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.SourcesOauthOauthsource}
                objectPk=${this.source.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], OAuthSourceViewPage.prototype, "sourceSlug", 1);
__decorateClass([
  n({ attribute: false })
], OAuthSourceViewPage.prototype, "source", 2);
OAuthSourceViewPage = __decorateClass([
  t("ak-source-oauth-view")
], OAuthSourceViewPage);

// src/admin/sources/plex/PlexSourceViewPage.ts
var PlexSourceViewPage = class extends AKElement {
  set sourceSlug(value) {
    new SourcesApi(DEFAULT_CONFIG).sourcesPlexRetrieve({
      slug: value
    }).then((source) => {
      this.source = source;
    });
  }
  static get styles() {
    return [patternfly_base_default, page_default, button_default, grid_default, content_default, card_default, description_list_default];
  }
  constructor() {
    super();
    this.addEventListener(EVENT_REFRESH, () => {
      if (!this.source?.pk)
        return;
      this.sourceSlug = this.source?.slug;
    });
  }
  render() {
    if (!this.source) {
      return x``;
    }
    return x`<ak-tabs>
            <section
                slot="page-overview"
                data-tab-title="${msg("Overview")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <dl class="pf-c-description-list pf-m-2-col-on-lg">
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Name")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.name}
                                        </div>
                                    </dd>
                                </div>
                            </dl>
                        </div>
                        <div class="pf-c-card__footer">
                            <ak-forms-modal>
                                <span slot="submit"> ${msg("Update")} </span>
                                <span slot="header"> ${msg("Update Plex Source")} </span>
                                <ak-source-plex-form slot="form" .instancePk=${this.source.slug}>
                                </ak-source-plex-form>
                                <button slot="trigger" class="pf-c-button pf-m-primary">
                                    ${msg("Edit")}
                                </button>
                            </ak-forms-modal>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-changelog"
                data-tab-title="${msg("Changelog")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this.source.pk || ""}
                                targetModelApp="authentik_sources_plex"
                                targetModelName="plexsource"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <div
                slot="page-policy-binding"
                data-tab-title="${msg("Policy Bindings")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__title">
                            ${msg(
      `These bindings control which users can access this source.
            You can only use policies here as access is checked before the user is authenticated.`
    )}
                        </div>
                        <div class="pf-c-card__body">
                            <ak-bound-policies-list .target=${this.source.pk} ?policyOnly=${true}>
                            </ak-bound-policies-list>
                        </div>
                    </div>
                </div>
            </div>
            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.SourcesPlexPlexsource}
                objectPk=${this.source.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], PlexSourceViewPage.prototype, "sourceSlug", 1);
__decorateClass([
  n({ attribute: false })
], PlexSourceViewPage.prototype, "source", 2);
PlexSourceViewPage = __decorateClass([
  t("ak-source-plex-view")
], PlexSourceViewPage);

// src/admin/sources/saml/SAMLSourceViewPage.ts
var SAMLSourceViewPage = class extends AKElement {
  set sourceSlug(slug) {
    new SourcesApi(DEFAULT_CONFIG).sourcesSamlRetrieve({
      slug
    }).then((source) => {
      this.source = source;
    });
  }
  static get styles() {
    return [patternfly_base_default, page_default, grid_default, button_default, content_default, card_default, description_list_default];
  }
  constructor() {
    super();
    this.addEventListener(EVENT_REFRESH, () => {
      if (!this.source?.pk)
        return;
      this.sourceSlug = this.source?.slug;
    });
  }
  render() {
    if (!this.source) {
      return x``;
    }
    return x`<ak-tabs>
            <section
                slot="page-overview"
                data-tab-title="${msg("Overview")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <dl class="pf-c-description-list pf-m-3-col-on-lg">
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Name")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.name}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("SSO URL")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.ssoUrl}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("SLO URL")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.sloUrl}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Issuer")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.issuer}
                                        </div>
                                    </dd>
                                </div>
                            </dl>
                        </div>
                        <div class="pf-c-card__footer">
                            <ak-forms-modal>
                                <span slot="submit"> ${msg("Update")} </span>
                                <span slot="header"> ${msg("Update SAML Source")} </span>
                                <ak-source-saml-form slot="form" .instancePk=${this.source.slug}>
                                </ak-source-saml-form>
                                <button slot="trigger" class="pf-c-button pf-m-primary">
                                    ${msg("Edit")}
                                </button>
                            </ak-forms-modal>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-changelog"
                data-tab-title="${msg("Changelog")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this.source.pk || ""}
                                targetModelApp="authentik_sources_saml"
                                targetModelName="samlsource"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-metadata"
                data-tab-title="${msg("Metadata")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
                @activate=${() => {
      new SourcesApi(DEFAULT_CONFIG).sourcesSamlMetadataRetrieve({
        slug: this.source?.slug || ""
      }).then((metadata) => {
        this.metadata = metadata;
      });
    }}
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <ak-codemirror
                                mode=${"xml" /* XML */}
                                ?readOnly=${true}
                                value="${o(this.metadata?.metadata)}"
                            ></ak-codemirror>
                        </div>
                        <div class="pf-c-card__footer">
                            <a
                                class="pf-c-button pf-m-primary"
                                target="_blank"
                                href=${o(this.metadata?.downloadUrl)}
                            >
                                ${msg("Download")}
                            </a>
                        </div>
                    </div>
                </div>
            </section>
            <div
                slot="page-policy-bindings"
                data-tab-title="${msg("Policy Bindings")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__title">
                            ${msg(
      `These bindings control which users can access this source.
            You can only use policies here as access is checked before the user is authenticated.`
    )}
                        </div>
                        <div class="pf-c-card__body">
                            <ak-bound-policies-list .target=${this.source.pk} ?policyOnly=${true}>
                            </ak-bound-policies-list>
                        </div>
                    </div>
                </div>
            </div>
            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.SourcesSamlSamlsource}
                objectPk=${this.source.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], SAMLSourceViewPage.prototype, "sourceSlug", 1);
__decorateClass([
  n({ attribute: false })
], SAMLSourceViewPage.prototype, "source", 2);
__decorateClass([
  r()
], SAMLSourceViewPage.prototype, "metadata", 2);
SAMLSourceViewPage = __decorateClass([
  t("ak-source-saml-view")
], SAMLSourceViewPage);

// src/admin/sources/scim/SCIMSourceGroups.ts
var SCIMSourceGroupList = class extends Table {
  constructor() {
    super(...arguments);
    this.expandable = true;
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint(page) {
    return new SourcesApi(DEFAULT_CONFIG).sourcesScimGroupsList({
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      ordering: this.order,
      search: this.search || "",
      sourceSlug: this.sourceSlug
    });
  }
  columns() {
    return [new TableColumn(msg("Name")), new TableColumn(msg("ID"))];
  }
  renderExpanded(item) {
    return x`<td role="cell" colspan="4">
            <div class="pf-c-table__expandable-row-content">
                <pre>${JSON.stringify(item.attributes, null, 4)}</pre>
            </div>
        </td>`;
  }
  row(item) {
    return [
      x`<a href="#/identity/groups/${item.groupObj.pk}">
                <div>${item.groupObj.name}</div>
            </a>`,
      x`${item.id}`
    ];
  }
};
__decorateClass([
  n()
], SCIMSourceGroupList.prototype, "sourceSlug", 2);
SCIMSourceGroupList = __decorateClass([
  t("ak-source-scim-groups-list")
], SCIMSourceGroupList);

// src/admin/sources/scim/SCIMSourceUsers.ts
var SCIMSourceUserList = class extends Table {
  constructor() {
    super(...arguments);
    this.expandable = true;
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint(page) {
    return new SourcesApi(DEFAULT_CONFIG).sourcesScimUsersList({
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      ordering: this.order,
      search: this.search || "",
      sourceSlug: this.sourceSlug
    });
  }
  columns() {
    return [new TableColumn(msg("Username")), new TableColumn(msg("ID"))];
  }
  renderExpanded(item) {
    return x`<td role="cell" colspan="4">
            <div class="pf-c-table__expandable-row-content">
                <pre>${JSON.stringify(item.attributes, null, 4)}</pre>
            </div>
        </td>`;
  }
  row(item) {
    return [
      x`<a href="#/identity/users/${item.userObj.pk}">
                <div>${item.userObj.username}</div>
                <small>${item.userObj.name}</small>
            </a>`,
      x`${item.id}`
    ];
  }
};
__decorateClass([
  n()
], SCIMSourceUserList.prototype, "sourceSlug", 2);
SCIMSourceUserList = __decorateClass([
  t("ak-source-scim-users-list")
], SCIMSourceUserList);

// src/admin/sources/scim/SCIMSourceViewPage.ts
var SCIMSourceViewPage = class extends AKElement {
  set sourceSlug(value) {
    new SourcesApi(DEFAULT_CONFIG).sourcesScimRetrieve({
      slug: value
    }).then((source) => {
      this.source = source;
    });
  }
  static get styles() {
    return [
      patternfly_base_default,
      page_default,
      button_default,
      form_default,
      form_control_default,
      grid_default,
      content_default,
      card_default,
      description_list_default,
      banner_default
    ];
  }
  constructor() {
    super();
    this.addEventListener(EVENT_REFRESH, () => {
      if (!this.source?.pk)
        return;
      this.sourceSlug = this.source?.slug;
    });
  }
  render() {
    if (!this.source) {
      return x``;
    }
    return x`<ak-tabs>
            <section slot="page-overview" data-tab-title="${msg("Overview")}">
                <div slot="header" class="pf-c-banner pf-m-info">
                    ${msg("SCIM Source is in preview.")}
                    <a href="mailto:hello+feature/scim-source@goauthentik.io"
                        >${msg("Send us feedback!")}</a
                    >
                </div>
                <div class="pf-c-page__main-section pf-m-no-padding-mobile pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <dl class="pf-c-description-list pf-m-2-col-on-lg">
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Name")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.name}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Slug")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.source.slug}
                                        </div>
                                    </dd>
                                </div>
                            </dl>
                        </div>
                        <div class="pf-c-card__footer">
                            <ak-forms-modal>
                                <span slot="submit"> ${msg("Update")} </span>
                                <span slot="header"> ${msg("Update SCIM Source")} </span>
                                <ak-source-scim-form slot="form" .instancePk=${this.source.slug}>
                                </ak-source-scim-form>
                                <button slot="trigger" class="pf-c-button pf-m-primary">
                                    ${msg("Edit")}
                                </button>
                            </ak-forms-modal>
                        </div>
                    </div>
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card">
                            <div class="pf-c-card__body">
                                <form class="pf-c-form">
                                    <div class="pf-c-form__group">
                                        <label class="pf-c-form__label">
                                            <span class="pf-c-form__label-text"
                                                >${msg("SCIM Base URL")}</span
                                            >
                                        </label>
                                        <input
                                            class="pf-c-form-control"
                                            readonly
                                            type="text"
                                            value="${this.source.rootUrl}"
                                        />
                                    </div>
                                    <div class="pf-c-form__group">
                                        <label class="pf-c-form__label">
                                            <span class="pf-c-form__label-text"
                                                >${msg("Token")}</span
                                            >
                                        </label>
                                        <div>
                                            <ak-token-copy-button
                                                class="pf-m-primary"
                                                identifier="${this.source?.tokenObj.identifier}"
                                            >
                                                ${msg("Click to copy token")}
                                            </ak-token-copy-button>
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-changelog"
                data-tab-title="${msg("Changelog")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this.source.pk || ""}
                                targetModelApp="authentik_sources_scim"
                                targetModelName="scimsource"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-users"
                data-tab-title="${msg("Provisioned Users")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <ak-source-scim-users-list
                        sourceSlug=${this.source.slug}
                    ></ak-source-scim-users-list>
                </div>
            </section>
            <section
                slot="page-groups"
                data-tab-title="${msg("Provisioned Groups")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <ak-source-scim-groups-list
                        sourceSlug=${this.source.slug}
                    ></ak-source-scim-groups-list>
                </div>
            </section>
            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.SourcesScimScimsource}
                objectPk=${this.source.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], SCIMSourceViewPage.prototype, "sourceSlug", 1);
__decorateClass([
  n({ attribute: false })
], SCIMSourceViewPage.prototype, "source", 2);
SCIMSourceViewPage = __decorateClass([
  t("ak-source-scim-view")
], SCIMSourceViewPage);

// src/admin/sources/SourceViewPage.ts
var SourceViewPage = class extends AKElement {
  set sourceSlug(slug) {
    new SourcesApi(DEFAULT_CONFIG).sourcesAllRetrieve({
      slug
    }).then((source) => {
      this.source = source;
    });
  }
  renderSource() {
    if (!this.source) {
      return x`<ak-empty-state ?loading=${true} ?fullHeight=${true}></ak-empty-state>`;
    }
    switch (this.source?.component) {
      case "ak-source-ldap-form":
        return x`<ak-source-ldap-view
                    sourceSlug=${this.source.slug}
                ></ak-source-ldap-view>`;
      case "ak-source-oauth-form":
        return x`<ak-source-oauth-view
                    sourceSlug=${this.source.slug}
                ></ak-source-oauth-view>`;
      case "ak-source-saml-form":
        return x`<ak-source-saml-view
                    sourceSlug=${this.source.slug}
                ></ak-source-saml-view>`;
      case "ak-source-plex-form":
        return x`<ak-source-plex-view
                    sourceSlug=${this.source.slug}
                ></ak-source-plex-view>`;
      case "ak-source-scim-form":
        return x`<ak-source-scim-view
                    sourceSlug=${this.source.slug}
                ></ak-source-scim-view>`;
      default:
        return x`<p>Invalid source type ${this.source.component}</p>`;
    }
  }
  render() {
    return x`<ak-page-header
                icon="pf-icon pf-icon-middleware"
                header=${o(this.source?.name)}
                description=${o(this.source?.verboseName)}
            >
            </ak-page-header>
            ${this.renderSource()}`;
  }
};
__decorateClass([
  n({ type: String })
], SourceViewPage.prototype, "sourceSlug", 1);
__decorateClass([
  n({ attribute: false })
], SourceViewPage.prototype, "source", 2);
SourceViewPage = __decorateClass([
  t("ak-source-view")
], SourceViewPage);
export {
  SourceViewPage
};
//# sourceMappingURL=SourceViewPage-743ARIDC.js.map
