import "./chunk-VEOO3EVI.js";
import "./chunk-NXBNBE6T.js";
import {
  StagesApi
} from "./chunk-6L2VIJJF.js";
import "./chunk-P6KUVHV4.js";
import "./chunk-LKZJBMFY.js";
import "./chunk-GOSS526A.js";
import "./chunk-JSMKLBKU.js";
import "./chunk-KAVSWSBX.js";
import "./chunk-7V5SMFL5.js";
import "./chunk-EALY7PEX.js";
import "./chunk-Z7XVYGD6.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-EGRHWZRV.js";
import "./chunk-WGDMKZIG.js";
import "./chunk-HDTBIKDJ.js";
import "./chunk-W4RSYEXS.js";
import {
  TablePage
} from "./chunk-R63EXIDN.js";
import "./chunk-4L2VSKMK.js";
import "./chunk-DIMKLXAP.js";
import "./chunk-MCK5P3JY.js";
import "./chunk-O7KILHL6.js";
import "./chunk-IZQSSDOF.js";
import "./chunk-DP47YJ62.js";
import "./chunk-AX3TXADI.js";
import "./chunk-G6FYWANS.js";
import "./chunk-JMBXTRNL.js";
import "./chunk-ZZAG5J6S.js";
import "./chunk-KANCX4AI.js";
import "./chunk-ZKRIRKRW.js";
import "./chunk-4TARICXF.js";
import "./chunk-SACHAYPZ.js";
import "./chunk-CH5LDOJ6.js";
import "./chunk-CZGYCY4V.js";
import {
  ModelForm
} from "./chunk-ZVKXJXN6.js";
import "./chunk-PSPR3SUN.js";
import "./chunk-XSB422CX.js";
import "./chunk-X5TC2QXY.js";
import "./chunk-ZBQTYGSF.js";
import "./chunk-3CKWSC2S.js";
import "./chunk-2G3GM457.js";
import "./chunk-OATKFZXF.js";
import "./chunk-KNLDGZQ5.js";
import "./chunk-6KRH5U5H.js";
import "./chunk-GOIBY4UW.js";
import "./chunk-WPHOZTKQ.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-XPFXHVQV.js";
import {
  showMessage
} from "./chunk-7XZT6QXJ.js";
import {
  TableColumn,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  CoreApi,
  DEFAULT_CONFIG,
  n,
  t
} from "./chunk-EOF5OWT7.js";
import {
  msg,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/stages/authenticator_duo/DuoDeviceImportForm.ts
var DuoDeviceImportForm = class extends ModelForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorDuoRetrieve({
      stageUuid: pk
    });
  }
  getSuccessMessage() {
    return msg("Successfully imported device.");
  }
  async send(data) {
    const importData = data;
    return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorDuoImportDeviceManualCreate({
      stageUuid: this.instance?.pk || "",
      authenticatorDuoStageManualDeviceImportRequest: importData
    });
  }
  renderForm() {
    return x` ${this.instance?.adminIntegrationKey !== "" ? this.renderFormAutomatic() : x``}
        ${this.renderFormManual()}`;
  }
  renderFormManual() {
    return x`<ak-form-element-horizontal
                label=${msg("User")}
                ?required=${true}
                name="username"
            >
                <ak-search-select
                    .fetchObjects=${async (query) => {
      const args = {
        ordering: "username"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const users = await new CoreApi(DEFAULT_CONFIG).coreUsersList(args);
      return users.results;
    }}
                    .renderElement=${(user) => {
      return user.username;
    }}
                    .renderDescription=${(user) => {
      return x`${user.name}`;
    }}
                    .value=${(user) => {
      return user?.username;
    }}
                >
                </ak-search-select>

                <p class="pf-c-form__helper-text">
                    ${msg("The user in authentik this device will be assigned to.")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Duo User ID")}
                ?required=${true}
                name="duoUserId"
            >
                <input type="text" class="pf-c-form-control" required />
                <p class="pf-c-form__helper-text">
                    ${msg("The user ID in Duo, can be found in the URL after clicking on a user.")}
                </p>
            </ak-form-element-horizontal>`;
  }
  renderFormAutomatic() {
    return x`
            <ak-form-element-horizontal label=${msg("Automatic import")}>
                <ak-action-button
                    class="pf-m-primary"
                    .apiRequest=${() => {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorDuoImportDevicesAutomaticCreate({
        stageUuid: this.instance?.pk || ""
      }).then((res) => {
        showMessage({
          level: "info" /* info */,
          message: msg(str`Successfully imported ${res.count} devices.`)
        });
        const modal = this.parentElement;
        modal.open = false;
      });
    }}
                >
                    ${msg("Start automatic import")}
                </ak-action-button>
            </ak-form-element-horizontal>
            <ak-divider>${msg("Or manually import")}</ak-divider>
            <br />
        `;
  }
};
DuoDeviceImportForm = __decorateClass([
  t("ak-stage-authenticator-duo-device-import-form")
], DuoDeviceImportForm);

// src/admin/stages/StageListPage.ts
var StageListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  pageTitle() {
    return msg("Stages");
  }
  pageDescription() {
    return msg(
      "Stages are single steps of a Flow that a user is guided through. A stage can only be executed from within a flow."
    );
  }
  pageIcon() {
    return "pf-icon pf-icon-plugged";
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint(page) {
    return new StagesApi(DEFAULT_CONFIG).stagesAllList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || ""
    });
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Flows")),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Stage(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new StagesApi(DEFAULT_CONFIG).stagesAllUsedByList({
        stageUuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new StagesApi(DEFAULT_CONFIG).stagesAllDestroy({
        stageUuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  renderStageActions(stage) {
    switch (stage.component) {
      case "ak-stage-authenticator-duo-form":
        return x`<ak-forms-modal>
                    <span slot="submit">${msg("Import")}</span>
                    <span slot="header">${msg("Import Duo device")}</span>
                    <ak-stage-authenticator-duo-device-import-form
                        slot="form"
                        .instancePk=${stage.pk}
                    >
                    </ak-stage-authenticator-duo-device-import-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Import devices")}>
                            <i class="fas fa-file-import" aria-hidden="true"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>`;
      default:
        return x``;
    }
  }
  row(item) {
    return [
      x`<div>${item.name}</div>
                <small>${item.verboseName}</small>`,
      x`<ul class="pf-c-list">
                ${item.flowSet?.map((flow) => {
        return x`<li>
                        <a href="#/flow/flows/${flow.slug}">
                            <code>${flow.slug}</code>
                        </a>
                    </li>`;
      })}
            </ul>`,
      x`<ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg(str`Update ${item.verboseName}`)} </span>
                    <ak-proxy-form
                        slot="form"
                        .args=${{
        instancePk: item.pk
      }}
                        type=${o(item.component)}
                    >
                    </ak-proxy-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                <ak-rbac-object-permission-modal model=${item.metaModelName} objectPk=${item.pk}>
                </ak-rbac-object-permission-modal>
                ${this.renderStageActions(item)}`
    ];
  }
  renderObjectCreate() {
    return x`<ak-stage-wizard></ak-stage-wizard> `;
  }
};
__decorateClass([
  n()
], StageListPage.prototype, "order", 2);
StageListPage = __decorateClass([
  t("ak-stage-list")
], StageListPage);
export {
  StageListPage
};
//# sourceMappingURL=StageListPage-F5HBII6V.js.map
