import {
  BaseAPI,
  CoordinateFromJSON,
  JSONApiResponse,
  exists
} from "./chunk-EOF5OWT7.js";

// node_modules/@goauthentik/api/dist/esm/models/App.js
function AppFromJSON(json) {
  return AppFromJSONTyped(json, false);
}
function AppFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "name": json["name"],
    "label": json["label"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/LoginMetrics.js
function LoginMetricsFromJSON(json) {
  return LoginMetricsFromJSONTyped(json, false);
}
function LoginMetricsFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "logins": json["logins"].map(CoordinateFromJSON),
    "loginsFailed": json["logins_failed"].map(CoordinateFromJSON),
    "authorizations": json["authorizations"].map(CoordinateFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSettingsRequest.js
function PatchedSettingsRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "avatars": value.avatars,
    "default_user_change_name": value.defaultUserChangeName,
    "default_user_change_email": value.defaultUserChangeEmail,
    "default_user_change_username": value.defaultUserChangeUsername,
    "event_retention": value.eventRetention,
    "footer_links": value.footerLinks,
    "gdpr_compliance": value.gdprCompliance,
    "impersonation": value.impersonation,
    "default_token_duration": value.defaultTokenDuration,
    "default_token_length": value.defaultTokenLength
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Settings.js
function SettingsFromJSON(json) {
  return SettingsFromJSONTyped(json, false);
}
function SettingsFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "avatars": !exists(json, "avatars") ? void 0 : json["avatars"],
    "defaultUserChangeName": !exists(json, "default_user_change_name") ? void 0 : json["default_user_change_name"],
    "defaultUserChangeEmail": !exists(json, "default_user_change_email") ? void 0 : json["default_user_change_email"],
    "defaultUserChangeUsername": !exists(json, "default_user_change_username") ? void 0 : json["default_user_change_username"],
    "eventRetention": !exists(json, "event_retention") ? void 0 : json["event_retention"],
    "footerLinks": !exists(json, "footer_links") ? void 0 : json["footer_links"],
    "gdprCompliance": !exists(json, "gdpr_compliance") ? void 0 : json["gdpr_compliance"],
    "impersonation": !exists(json, "impersonation") ? void 0 : json["impersonation"],
    "defaultTokenDuration": !exists(json, "default_token_duration") ? void 0 : json["default_token_duration"],
    "defaultTokenLength": !exists(json, "default_token_length") ? void 0 : json["default_token_length"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SettingsRequest.js
function SettingsRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "avatars": value.avatars,
    "default_user_change_name": value.defaultUserChangeName,
    "default_user_change_email": value.defaultUserChangeEmail,
    "default_user_change_username": value.defaultUserChangeUsername,
    "event_retention": value.eventRetention,
    "footer_links": value.footerLinks,
    "gdpr_compliance": value.gdprCompliance,
    "impersonation": value.impersonation,
    "default_token_duration": value.defaultTokenDuration,
    "default_token_length": value.defaultTokenLength
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SystemInfoRuntime.js
function SystemInfoRuntimeFromJSON(json) {
  return SystemInfoRuntimeFromJSONTyped(json, false);
}
function SystemInfoRuntimeFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pythonVersion": json["python_version"],
    "gunicornVersion": json["gunicorn_version"],
    "environment": json["environment"],
    "architecture": json["architecture"],
    "platform": json["platform"],
    "uname": json["uname"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SystemInfo.js
function SystemInfoFromJSON(json) {
  return SystemInfoFromJSONTyped(json, false);
}
function SystemInfoFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "httpHeaders": json["http_headers"],
    "httpHost": json["http_host"],
    "httpIsSecure": json["http_is_secure"],
    "runtime": SystemInfoRuntimeFromJSON(json["runtime"]),
    "brand": json["brand"],
    "serverTime": new Date(json["server_time"]),
    "embeddedOutpostDisabled": json["embedded_outpost_disabled"],
    "embeddedOutpostHost": json["embedded_outpost_host"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Version.js
function VersionFromJSON(json) {
  return VersionFromJSONTyped(json, false);
}
function VersionFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "versionCurrent": json["version_current"],
    "versionLatest": json["version_latest"],
    "versionLatestValid": json["version_latest_valid"],
    "buildHash": json["build_hash"],
    "outdated": json["outdated"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Workers.js
function WorkersFromJSON(json) {
  return WorkersFromJSONTyped(json, false);
}
function WorkersFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "count": json["count"]
  };
}

// node_modules/@goauthentik/api/dist/esm/apis/AdminApi.js
var __awaiter = function(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var AdminApi = class extends BaseAPI {
  /**
   * Read-only view list all installed apps
   */
  adminAppsListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/apps/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(AppFromJSON));
    });
  }
  /**
   * Read-only view list all installed apps
   */
  adminAppsList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminAppsListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Login Metrics per 1h
   */
  adminMetricsRetrieveRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/metrics/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LoginMetricsFromJSON(jsonValue));
    });
  }
  /**
   * Login Metrics per 1h
   */
  adminMetricsRetrieve(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminMetricsRetrieveRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Read-only view list all installed models
   */
  adminModelsListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/models/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(AppFromJSON));
    });
  }
  /**
   * Read-only view list all installed models
   */
  adminModelsList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminModelsListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Settings view
   */
  adminSettingsPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/settings/`,
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSettingsRequestToJSON(requestParameters.patchedSettingsRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SettingsFromJSON(jsonValue));
    });
  }
  /**
   * Settings view
   */
  adminSettingsPartialUpdate(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminSettingsPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Settings view
   */
  adminSettingsRetrieveRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/settings/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SettingsFromJSON(jsonValue));
    });
  }
  /**
   * Settings view
   */
  adminSettingsRetrieve(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminSettingsRetrieveRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Settings view
   */
  adminSettingsUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/settings/`,
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SettingsRequestToJSON(requestParameters.settingsRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SettingsFromJSON(jsonValue));
    });
  }
  /**
   * Settings view
   */
  adminSettingsUpdate(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminSettingsUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get system information.
   */
  adminSystemCreateRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/system/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SystemInfoFromJSON(jsonValue));
    });
  }
  /**
   * Get system information.
   */
  adminSystemCreate(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminSystemCreateRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get system information.
   */
  adminSystemRetrieveRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/system/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SystemInfoFromJSON(jsonValue));
    });
  }
  /**
   * Get system information.
   */
  adminSystemRetrieve(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminSystemRetrieveRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get running and latest version.
   */
  adminVersionRetrieveRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/version/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => VersionFromJSON(jsonValue));
    });
  }
  /**
   * Get running and latest version.
   */
  adminVersionRetrieve(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminVersionRetrieveRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get currently connected worker count.
   */
  adminWorkersRetrieveRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/workers/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => WorkersFromJSON(jsonValue));
    });
  }
  /**
   * Get currently connected worker count.
   */
  adminWorkersRetrieve(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminWorkersRetrieveRaw(initOverrides);
      return yield response.value();
    });
  }
};

export {
  AdminApi
};
//# sourceMappingURL=chunk-AP5GHUBV.js.map
