import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import {
  RACProviderFromJSON
} from "./chunk-SFAGFFHP.js";
import {
  Table,
  TableColumn,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import {
  BaseAPI,
  DEFAULT_CONFIG,
  GroupMemberFromJSON,
  JSONApiResponse,
  PaginationFromJSON,
  RequiredError,
  UsedByFromJSON,
  VoidApiResponse,
  exists,
  n,
  t
} from "./chunk-EOF5OWT7.js";
import {
  msg,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// node_modules/@goauthentik/api/dist/esm/models/AuthModeEnum.js
var AuthModeEnum = {
  Static: "static",
  Prompt: "prompt",
  UnknownDefaultOpenApi: "11184809"
};
function AuthModeEnumFromJSON(json) {
  return AuthModeEnumFromJSONTyped(json, false);
}
function AuthModeEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function AuthModeEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/ProtocolEnum.js
var ProtocolEnum = {
  Rdp: "rdp",
  Vnc: "vnc",
  Ssh: "ssh",
  UnknownDefaultOpenApi: "11184809"
};
function ProtocolEnumFromJSON(json) {
  return ProtocolEnumFromJSONTyped(json, false);
}
function ProtocolEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function ProtocolEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/Endpoint.js
function EndpointFromJSON(json) {
  return EndpointFromJSONTyped(json, false);
}
function EndpointFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "provider": json["provider"],
    "providerObj": RACProviderFromJSON(json["provider_obj"]),
    "protocol": ProtocolEnumFromJSON(json["protocol"]),
    "host": json["host"],
    "settings": !exists(json, "settings") ? void 0 : json["settings"],
    "propertyMappings": !exists(json, "property_mappings") ? void 0 : json["property_mappings"],
    "authMode": AuthModeEnumFromJSON(json["auth_mode"]),
    "launchUrl": json["launch_url"],
    "maximumConnections": !exists(json, "maximum_connections") ? void 0 : json["maximum_connections"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ConnectionToken.js
function ConnectionTokenFromJSON(json) {
  return ConnectionTokenFromJSONTyped(json, false);
}
function ConnectionTokenFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": !exists(json, "pk") ? void 0 : json["pk"],
    "provider": json["provider"],
    "providerObj": RACProviderFromJSON(json["provider_obj"]),
    "endpoint": json["endpoint"],
    "endpointObj": EndpointFromJSON(json["endpoint_obj"]),
    "user": GroupMemberFromJSON(json["user"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ConnectionTokenRequest.js
function ConnectionTokenRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "pk": value.pk,
    "provider": value.provider,
    "endpoint": value.endpoint
  };
}

// node_modules/@goauthentik/api/dist/esm/models/EndpointRequest.js
function EndpointRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "provider": value.provider,
    "protocol": ProtocolEnumToJSON(value.protocol),
    "host": value.host,
    "settings": value.settings,
    "property_mappings": value.propertyMappings,
    "auth_mode": AuthModeEnumToJSON(value.authMode),
    "maximum_connections": value.maximumConnections
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedConnectionTokenList.js
function PaginatedConnectionTokenListFromJSON(json) {
  return PaginatedConnectionTokenListFromJSONTyped(json, false);
}
function PaginatedConnectionTokenListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ConnectionTokenFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedEndpointList.js
function PaginatedEndpointListFromJSON(json) {
  return PaginatedEndpointListFromJSONTyped(json, false);
}
function PaginatedEndpointListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(EndpointFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedConnectionTokenRequest.js
function PatchedConnectionTokenRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "pk": value.pk,
    "provider": value.provider,
    "endpoint": value.endpoint
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedEndpointRequest.js
function PatchedEndpointRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "provider": value.provider,
    "protocol": ProtocolEnumToJSON(value.protocol),
    "host": value.host,
    "settings": value.settings,
    "property_mappings": value.propertyMappings,
    "auth_mode": AuthModeEnumToJSON(value.authMode),
    "maximum_connections": value.maximumConnections
  };
}

// node_modules/@goauthentik/api/dist/esm/apis/RacApi.js
var __awaiter = function(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var RacApi = class extends BaseAPI {
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.connectionTokenUuid === null || requestParameters.connectionTokenUuid === void 0) {
        throw new RequiredError("connectionTokenUuid", "Required parameter requestParameters.connectionTokenUuid was null or undefined when calling racConnectionTokensDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/connection_tokens/{connection_token_uuid}/`.replace(`{${"connection_token_uuid"}}`, encodeURIComponent(String(requestParameters.connectionTokenUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.racConnectionTokensDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.endpoint !== void 0) {
        queryParameters["endpoint"] = requestParameters.endpoint;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.provider !== void 0) {
        queryParameters["provider"] = requestParameters.provider;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.sessionUser !== void 0) {
        queryParameters["session__user"] = requestParameters.sessionUser;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/connection_tokens/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedConnectionTokenListFromJSON(jsonValue));
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.racConnectionTokensListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.connectionTokenUuid === null || requestParameters.connectionTokenUuid === void 0) {
        throw new RequiredError("connectionTokenUuid", "Required parameter requestParameters.connectionTokenUuid was null or undefined when calling racConnectionTokensPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/connection_tokens/{connection_token_uuid}/`.replace(`{${"connection_token_uuid"}}`, encodeURIComponent(String(requestParameters.connectionTokenUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedConnectionTokenRequestToJSON(requestParameters.patchedConnectionTokenRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ConnectionTokenFromJSON(jsonValue));
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.racConnectionTokensPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.connectionTokenUuid === null || requestParameters.connectionTokenUuid === void 0) {
        throw new RequiredError("connectionTokenUuid", "Required parameter requestParameters.connectionTokenUuid was null or undefined when calling racConnectionTokensRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/connection_tokens/{connection_token_uuid}/`.replace(`{${"connection_token_uuid"}}`, encodeURIComponent(String(requestParameters.connectionTokenUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ConnectionTokenFromJSON(jsonValue));
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.racConnectionTokensRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.connectionTokenUuid === null || requestParameters.connectionTokenUuid === void 0) {
        throw new RequiredError("connectionTokenUuid", "Required parameter requestParameters.connectionTokenUuid was null or undefined when calling racConnectionTokensUpdate.");
      }
      if (requestParameters.connectionTokenRequest === null || requestParameters.connectionTokenRequest === void 0) {
        throw new RequiredError("connectionTokenRequest", "Required parameter requestParameters.connectionTokenRequest was null or undefined when calling racConnectionTokensUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/connection_tokens/{connection_token_uuid}/`.replace(`{${"connection_token_uuid"}}`, encodeURIComponent(String(requestParameters.connectionTokenUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: ConnectionTokenRequestToJSON(requestParameters.connectionTokenRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ConnectionTokenFromJSON(jsonValue));
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.racConnectionTokensUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  racConnectionTokensUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.connectionTokenUuid === null || requestParameters.connectionTokenUuid === void 0) {
        throw new RequiredError("connectionTokenUuid", "Required parameter requestParameters.connectionTokenUuid was null or undefined when calling racConnectionTokensUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/connection_tokens/{connection_token_uuid}/used_by/`.replace(`{${"connection_token_uuid"}}`, encodeURIComponent(String(requestParameters.connectionTokenUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  racConnectionTokensUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.racConnectionTokensUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.endpointRequest === null || requestParameters.endpointRequest === void 0) {
        throw new RequiredError("endpointRequest", "Required parameter requestParameters.endpointRequest was null or undefined when calling racEndpointsCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/endpoints/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: EndpointRequestToJSON(requestParameters.endpointRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EndpointFromJSON(jsonValue));
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.racEndpointsCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pbmUuid === null || requestParameters.pbmUuid === void 0) {
        throw new RequiredError("pbmUuid", "Required parameter requestParameters.pbmUuid was null or undefined when calling racEndpointsDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/endpoints/{pbm_uuid}/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters.pbmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.racEndpointsDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * List accessible endpoints
   */
  racEndpointsListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.provider !== void 0) {
        queryParameters["provider"] = requestParameters.provider;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.superuserFullList !== void 0) {
        queryParameters["superuser_full_list"] = requestParameters.superuserFullList;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/endpoints/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedEndpointListFromJSON(jsonValue));
    });
  }
  /**
   * List accessible endpoints
   */
  racEndpointsList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.racEndpointsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pbmUuid === null || requestParameters.pbmUuid === void 0) {
        throw new RequiredError("pbmUuid", "Required parameter requestParameters.pbmUuid was null or undefined when calling racEndpointsPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/endpoints/{pbm_uuid}/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters.pbmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedEndpointRequestToJSON(requestParameters.patchedEndpointRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EndpointFromJSON(jsonValue));
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.racEndpointsPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pbmUuid === null || requestParameters.pbmUuid === void 0) {
        throw new RequiredError("pbmUuid", "Required parameter requestParameters.pbmUuid was null or undefined when calling racEndpointsRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/endpoints/{pbm_uuid}/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters.pbmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EndpointFromJSON(jsonValue));
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.racEndpointsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pbmUuid === null || requestParameters.pbmUuid === void 0) {
        throw new RequiredError("pbmUuid", "Required parameter requestParameters.pbmUuid was null or undefined when calling racEndpointsUpdate.");
      }
      if (requestParameters.endpointRequest === null || requestParameters.endpointRequest === void 0) {
        throw new RequiredError("endpointRequest", "Required parameter requestParameters.endpointRequest was null or undefined when calling racEndpointsUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/endpoints/{pbm_uuid}/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters.pbmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: EndpointRequestToJSON(requestParameters.endpointRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EndpointFromJSON(jsonValue));
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.racEndpointsUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  racEndpointsUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pbmUuid === null || requestParameters.pbmUuid === void 0) {
        throw new RequiredError("pbmUuid", "Required parameter requestParameters.pbmUuid was null or undefined when calling racEndpointsUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/endpoints/{pbm_uuid}/used_by/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters.pbmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  racEndpointsUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.racEndpointsUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
};

// src/admin/providers/rac/ConnectionTokenList.ts
var ConnectionTokenListPage = class extends Table {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  searchEnabled() {
    return true;
  }
  static get styles() {
    return super.styles.concat(description_list_default);
  }
  async apiEndpoint(page) {
    return new RacApi(DEFAULT_CONFIG).racConnectionTokensList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || "",
      provider: this.provider?.pk,
      sessionUser: this.userId
    });
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return x`<ak-forms-delete-bulk
            objectLabel=${msg("Connection Token(s)")}
            .objects=${this.selectedElements}
            .metadata=${(item) => {
      return [
        { key: msg("Endpoint"), value: item.endpointObj.name },
        { key: msg("User"), value: item.user.username }
      ];
    }}
            .usedBy=${(item) => {
      return new RacApi(DEFAULT_CONFIG).racConnectionTokensUsedByList({
        connectionTokenUuid: item.pk || ""
      });
    }}
            .delete=${(item) => {
      return new RacApi(DEFAULT_CONFIG).racConnectionTokensDestroy({
        connectionTokenUuid: item.pk || ""
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  columns() {
    if (this.provider) {
      return [
        new TableColumn(msg("Endpoint"), "endpoint__name"),
        new TableColumn(msg("User"), "session__user")
      ];
    }
    return [
      new TableColumn(msg("Provider"), "provider__name"),
      new TableColumn(msg("Endpoint"), "endpoint__name")
    ];
  }
  row(item) {
    if (this.provider) {
      return [x`${item.endpointObj.name}`, x`${item.user.username}`];
    }
    return [x`${item.providerObj.name}`, x`${item.endpointObj.name}`];
  }
};
__decorateClass([
  n()
], ConnectionTokenListPage.prototype, "order", 2);
__decorateClass([
  n({ attribute: false })
], ConnectionTokenListPage.prototype, "provider", 2);
__decorateClass([
  n({ type: Number })
], ConnectionTokenListPage.prototype, "userId", 2);
ConnectionTokenListPage = __decorateClass([
  t("ak-rac-connection-token-list")
], ConnectionTokenListPage);

export {
  AuthModeEnum,
  ProtocolEnum,
  RacApi
};
//# sourceMappingURL=chunk-CRJYPNIM.js.map
