import {
  MODAL_BUTTON_STYLES,
  ModalShowEvent,
  backdrop_default,
  modal_box_default
} from "./chunk-GOIBY4UW.js";
import {
  Table,
  bullseye_default
} from "./chunk-OOB7B3ZK.js";
import {
  content_default,
  n,
  page_default
} from "./chunk-EOF5OWT7.js";
import {
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// node_modules/@patternfly/patternfly/layouts/Stack/stack.css
var stack_default = ".pf-l-stack {\n  --pf-l-stack--m-gutter--MarginBottom: var(--pf-global--gutter);\n  display: flex;\n  flex-direction: column;\n  height: 100%;\n}\n\n.pf-l-stack__item.pf-m-fill {\n  flex-grow: 1;\n}\n\n.pf-l-stack.pf-m-gutter > *:not(:last-child) {\n  margin-bottom: var(--pf-l-stack--m-gutter--MarginBottom);\n}";

// src/elements/table/TableModal.ts
var TableModal = class extends Table {
  constructor() {
    super(...arguments);
    this.size = "pf-m-lg" /* Large */;
    this._open = false;
  }
  set open(value) {
    this._open = value;
    if (value) {
      this.fetch();
    }
  }
  get open() {
    return this._open;
  }
  static get styles() {
    return super.styles.concat(
      modal_box_default,
      bullseye_default,
      content_default,
      backdrop_default,
      page_default,
      stack_default,
      MODAL_BUTTON_STYLES
    );
  }
  async fetch() {
    if (!this.open) {
      return;
    }
    return super.fetch();
  }
  closeModal() {
    this.resetForms();
    this.open = false;
  }
  resetForms() {
    this.querySelectorAll("[slot=form]").forEach((form) => {
      if ("resetForm" in form) {
        form?.resetForm();
      }
    });
  }
  onClick() {
    this.open = true;
    this.dispatchEvent(new ModalShowEvent(this));
    this.querySelectorAll("*").forEach((child) => {
      if ("requestUpdate" in child) {
        child.requestUpdate();
      }
    });
  }
  renderModalInner() {
    return this.renderTable();
  }
  renderModal() {
    return x`<div
            class="pf-c-backdrop"
            @click=${(e) => {
      e.stopPropagation();
    }}
        >
            <div class="pf-l-bullseye">
                <div class="pf-c-modal-box ${this.size}" role="dialog" aria-modal="true">
                    <button
                        @click=${() => this.open = false}
                        class="pf-c-button pf-m-plain"
                        type="button"
                        aria-label="Close dialog"
                    >
                        <i class="fas fa-times" aria-hidden="true"></i>
                    </button>
                    ${this.renderModalInner()}
                </div>
            </div>
        </div>`;
  }
  render() {
    return x` <slot name="trigger" @click=${() => this.onClick()}></slot>
            ${this.open ? this.renderModal() : ""}`;
  }
};
__decorateClass([
  n()
], TableModal.prototype, "size", 2);
__decorateClass([
  n({ type: Boolean })
], TableModal.prototype, "open", 1);

export {
  stack_default,
  TableModal
};
//# sourceMappingURL=chunk-DP47YJ62.js.map
