import {
  PolicyTestRequestToJSON
} from "./chunk-4TARICXF.js";
import {
  BaseAPI,
  JSONApiResponse,
  PaginationFromJSON,
  RequiredError,
  TypeCreateFromJSON,
  UsedByFromJSON,
  VoidApiResponse,
  exists
} from "./chunk-EOF5OWT7.js";

// node_modules/@goauthentik/api/dist/esm/models/LDAPPropertyMapping.js
function LDAPPropertyMappingFromJSON(json) {
  return LDAPPropertyMappingFromJSONTyped(json, false);
}
function LDAPPropertyMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "objectField": json["object_field"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/LDAPPropertyMappingRequest.js
function LDAPPropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression,
    "object_field": value.objectField
  };
}

// node_modules/@goauthentik/api/dist/esm/models/NotificationWebhookMapping.js
function NotificationWebhookMappingFromJSON(json) {
  return NotificationWebhookMappingFromJSONTyped(json, false);
}
function NotificationWebhookMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "expression": json["expression"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/NotificationWebhookMappingRequest.js
function NotificationWebhookMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedLDAPPropertyMappingList.js
function PaginatedLDAPPropertyMappingListFromJSON(json) {
  return PaginatedLDAPPropertyMappingListFromJSONTyped(json, false);
}
function PaginatedLDAPPropertyMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(LDAPPropertyMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedNotificationWebhookMappingList.js
function PaginatedNotificationWebhookMappingListFromJSON(json) {
  return PaginatedNotificationWebhookMappingListFromJSONTyped(json, false);
}
function PaginatedNotificationWebhookMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(NotificationWebhookMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PropertyMapping.js
function PropertyMappingFromJSON(json) {
  return PropertyMappingFromJSONTyped(json, false);
}
function PropertyMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPropertyMappingList.js
function PaginatedPropertyMappingListFromJSON(json) {
  return PaginatedPropertyMappingListFromJSONTyped(json, false);
}
function PaginatedPropertyMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PropertyMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/RACPropertyMapping.js
function RACPropertyMappingFromJSON(json) {
  return RACPropertyMappingFromJSONTyped(json, false);
}
function RACPropertyMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": !exists(json, "expression") ? void 0 : json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "staticSettings": json["static_settings"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedRACPropertyMappingList.js
function PaginatedRACPropertyMappingListFromJSON(json) {
  return PaginatedRACPropertyMappingListFromJSONTyped(json, false);
}
function PaginatedRACPropertyMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(RACPropertyMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SAMLPropertyMapping.js
function SAMLPropertyMappingFromJSON(json) {
  return SAMLPropertyMappingFromJSONTyped(json, false);
}
function SAMLPropertyMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "samlName": json["saml_name"],
    "friendlyName": !exists(json, "friendly_name") ? void 0 : json["friendly_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSAMLPropertyMappingList.js
function PaginatedSAMLPropertyMappingListFromJSON(json) {
  return PaginatedSAMLPropertyMappingListFromJSONTyped(json, false);
}
function PaginatedSAMLPropertyMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SAMLPropertyMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMMapping.js
function SCIMMappingFromJSON(json) {
  return SCIMMappingFromJSONTyped(json, false);
}
function SCIMMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSCIMMappingList.js
function PaginatedSCIMMappingListFromJSON(json) {
  return PaginatedSCIMMappingListFromJSONTyped(json, false);
}
function PaginatedSCIMMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SCIMMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ScopeMapping.js
function ScopeMappingFromJSON(json) {
  return ScopeMappingFromJSONTyped(json, false);
}
function ScopeMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "scopeName": json["scope_name"],
    "description": !exists(json, "description") ? void 0 : json["description"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedScopeMappingList.js
function PaginatedScopeMappingListFromJSON(json) {
  return PaginatedScopeMappingListFromJSONTyped(json, false);
}
function PaginatedScopeMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ScopeMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedLDAPPropertyMappingRequest.js
function PatchedLDAPPropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression,
    "object_field": value.objectField
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedNotificationWebhookMappingRequest.js
function PatchedNotificationWebhookMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedRACPropertyMappingRequest.js
function PatchedRACPropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression,
    "static_settings": value.staticSettings
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSAMLPropertyMappingRequest.js
function PatchedSAMLPropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression,
    "saml_name": value.samlName,
    "friendly_name": value.friendlyName
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSCIMMappingRequest.js
function PatchedSCIMMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedScopeMappingRequest.js
function PatchedScopeMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression,
    "scope_name": value.scopeName,
    "description": value.description
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PropertyMappingTestResult.js
function PropertyMappingTestResultFromJSON(json) {
  return PropertyMappingTestResultFromJSONTyped(json, false);
}
function PropertyMappingTestResultFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "result": json["result"],
    "successful": json["successful"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/RACPropertyMappingRequest.js
function RACPropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression,
    "static_settings": value.staticSettings
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SAMLPropertyMappingRequest.js
function SAMLPropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression,
    "saml_name": value.samlName,
    "friendly_name": value.friendlyName
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMMappingRequest.js
function SCIMMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ScopeMappingRequest.js
function ScopeMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression,
    "scope_name": value.scopeName,
    "description": value.description
  };
}

// node_modules/@goauthentik/api/dist/esm/apis/PropertymappingsApi.js
var __awaiter = function(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var PropertymappingsApi = class extends BaseAPI {
  /**
   * PropertyMapping Viewset
   */
  propertymappingsAllDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsAllDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/all/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * PropertyMapping Viewset
   */
  propertymappingsAllDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsAllDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * PropertyMapping Viewset
   */
  propertymappingsAllListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managedIsnull !== void 0) {
        queryParameters["managed__isnull"] = requestParameters.managedIsnull;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/all/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPropertyMappingListFromJSON(jsonValue));
    });
  }
  /**
   * PropertyMapping Viewset
   */
  propertymappingsAllList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsAllListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PropertyMapping Viewset
   */
  propertymappingsAllRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsAllRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/all/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * PropertyMapping Viewset
   */
  propertymappingsAllRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsAllRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Test Property Mapping
   */
  propertymappingsAllTestCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsAllTestCreate.");
      }
      if (requestParameters.policyTestRequest === null || requestParameters.policyTestRequest === void 0) {
        throw new RequiredError("policyTestRequest", "Required parameter requestParameters.policyTestRequest was null or undefined when calling propertymappingsAllTestCreate.");
      }
      const queryParameters = {};
      if (requestParameters.formatResult !== void 0) {
        queryParameters["format_result"] = requestParameters.formatResult;
      }
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/all/{pm_uuid}/test/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PolicyTestRequestToJSON(requestParameters.policyTestRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PropertyMappingTestResultFromJSON(jsonValue));
    });
  }
  /**
   * Test Property Mapping
   */
  propertymappingsAllTestCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsAllTestCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get all creatable property-mapping types
   */
  propertymappingsAllTypesListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/all/types/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(TypeCreateFromJSON));
    });
  }
  /**
   * Get all creatable property-mapping types
   */
  propertymappingsAllTypesList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsAllTypesListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsAllUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsAllUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/all/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsAllUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsAllUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsLdapCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.lDAPPropertyMappingRequest === null || requestParameters.lDAPPropertyMappingRequest === void 0) {
        throw new RequiredError("lDAPPropertyMappingRequest", "Required parameter requestParameters.lDAPPropertyMappingRequest was null or undefined when calling propertymappingsLdapCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/ldap/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: LDAPPropertyMappingRequestToJSON(requestParameters.lDAPPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsLdapCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsLdapCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsLdapDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsLdapDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/ldap/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsLdapDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsLdapDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsLdapListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.expression !== void 0) {
        queryParameters["expression"] = requestParameters.expression;
      }
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.objectField !== void 0) {
        queryParameters["object_field"] = requestParameters.objectField;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.pmUuid !== void 0) {
        queryParameters["pm_uuid"] = requestParameters.pmUuid;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/ldap/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedLDAPPropertyMappingListFromJSON(jsonValue));
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsLdapList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsLdapListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsLdapPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsLdapPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/ldap/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedLDAPPropertyMappingRequestToJSON(requestParameters.patchedLDAPPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsLdapPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsLdapPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsLdapRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsLdapRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/ldap/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsLdapRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsLdapRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsLdapUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsLdapUpdate.");
      }
      if (requestParameters.lDAPPropertyMappingRequest === null || requestParameters.lDAPPropertyMappingRequest === void 0) {
        throw new RequiredError("lDAPPropertyMappingRequest", "Required parameter requestParameters.lDAPPropertyMappingRequest was null or undefined when calling propertymappingsLdapUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/ldap/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: LDAPPropertyMappingRequestToJSON(requestParameters.lDAPPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsLdapUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsLdapUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsLdapUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsLdapUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/ldap/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsLdapUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsLdapUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.notificationWebhookMappingRequest === null || requestParameters.notificationWebhookMappingRequest === void 0) {
        throw new RequiredError("notificationWebhookMappingRequest", "Required parameter requestParameters.notificationWebhookMappingRequest was null or undefined when calling propertymappingsNotificationCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/notification/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: NotificationWebhookMappingRequestToJSON(requestParameters.notificationWebhookMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationWebhookMappingFromJSON(jsonValue));
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsNotificationCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsNotificationDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/notification/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsNotificationDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/notification/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedNotificationWebhookMappingListFromJSON(jsonValue));
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsNotificationListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsNotificationPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/notification/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedNotificationWebhookMappingRequestToJSON(requestParameters.patchedNotificationWebhookMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationWebhookMappingFromJSON(jsonValue));
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsNotificationPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsNotificationRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/notification/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationWebhookMappingFromJSON(jsonValue));
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsNotificationRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsNotificationUpdate.");
      }
      if (requestParameters.notificationWebhookMappingRequest === null || requestParameters.notificationWebhookMappingRequest === void 0) {
        throw new RequiredError("notificationWebhookMappingRequest", "Required parameter requestParameters.notificationWebhookMappingRequest was null or undefined when calling propertymappingsNotificationUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/notification/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: NotificationWebhookMappingRequestToJSON(requestParameters.notificationWebhookMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationWebhookMappingFromJSON(jsonValue));
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsNotificationUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsNotificationUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsNotificationUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/notification/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsNotificationUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsNotificationUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsRacCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.rACPropertyMappingRequest === null || requestParameters.rACPropertyMappingRequest === void 0) {
        throw new RequiredError("rACPropertyMappingRequest", "Required parameter requestParameters.rACPropertyMappingRequest was null or undefined when calling propertymappingsRacCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/rac/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: RACPropertyMappingRequestToJSON(requestParameters.rACPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RACPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsRacCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsRacCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsRacDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsRacDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/rac/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsRacDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsRacDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsRacListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/rac/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedRACPropertyMappingListFromJSON(jsonValue));
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsRacList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsRacListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsRacPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsRacPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/rac/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedRACPropertyMappingRequestToJSON(requestParameters.patchedRACPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RACPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsRacPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsRacPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsRacRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsRacRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/rac/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RACPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsRacRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsRacRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsRacUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsRacUpdate.");
      }
      if (requestParameters.rACPropertyMappingRequest === null || requestParameters.rACPropertyMappingRequest === void 0) {
        throw new RequiredError("rACPropertyMappingRequest", "Required parameter requestParameters.rACPropertyMappingRequest was null or undefined when calling propertymappingsRacUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/rac/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: RACPropertyMappingRequestToJSON(requestParameters.rACPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RACPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsRacUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsRacUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsRacUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsRacUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/rac/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsRacUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsRacUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsSamlCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sAMLPropertyMappingRequest === null || requestParameters.sAMLPropertyMappingRequest === void 0) {
        throw new RequiredError("sAMLPropertyMappingRequest", "Required parameter requestParameters.sAMLPropertyMappingRequest was null or undefined when calling propertymappingsSamlCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/saml/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SAMLPropertyMappingRequestToJSON(requestParameters.sAMLPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsSamlCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSamlCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsSamlDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSamlDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/saml/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsSamlDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsSamlDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsSamlListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.expression !== void 0) {
        queryParameters["expression"] = requestParameters.expression;
      }
      if (requestParameters.friendlyName !== void 0) {
        queryParameters["friendly_name"] = requestParameters.friendlyName;
      }
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.pmUuid !== void 0) {
        queryParameters["pm_uuid"] = requestParameters.pmUuid;
      }
      if (requestParameters.samlName !== void 0) {
        queryParameters["saml_name"] = requestParameters.samlName;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/saml/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSAMLPropertyMappingListFromJSON(jsonValue));
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsSamlList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSamlListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsSamlPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSamlPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/saml/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSAMLPropertyMappingRequestToJSON(requestParameters.patchedSAMLPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsSamlPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSamlPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsSamlRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSamlRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/saml/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsSamlRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSamlRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsSamlUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSamlUpdate.");
      }
      if (requestParameters.sAMLPropertyMappingRequest === null || requestParameters.sAMLPropertyMappingRequest === void 0) {
        throw new RequiredError("sAMLPropertyMappingRequest", "Required parameter requestParameters.sAMLPropertyMappingRequest was null or undefined when calling propertymappingsSamlUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/saml/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SAMLPropertyMappingRequestToJSON(requestParameters.sAMLPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsSamlUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSamlUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsSamlUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSamlUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/saml/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsSamlUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSamlUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsScimCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sCIMMappingRequest === null || requestParameters.sCIMMappingRequest === void 0) {
        throw new RequiredError("sCIMMappingRequest", "Required parameter requestParameters.sCIMMappingRequest was null or undefined when calling propertymappingsScimCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/scim/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMMappingRequestToJSON(requestParameters.sCIMMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMMappingFromJSON(jsonValue));
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsScimCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsScimCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsScimDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsScimDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/scim/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsScimDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsScimDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsScimListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.expression !== void 0) {
        queryParameters["expression"] = requestParameters.expression;
      }
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.pmUuid !== void 0) {
        queryParameters["pm_uuid"] = requestParameters.pmUuid;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/scim/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSCIMMappingListFromJSON(jsonValue));
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsScimList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsScimListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsScimPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsScimPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/scim/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSCIMMappingRequestToJSON(requestParameters.patchedSCIMMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMMappingFromJSON(jsonValue));
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsScimPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsScimPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsScimRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsScimRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/scim/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMMappingFromJSON(jsonValue));
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsScimRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsScimRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsScimUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsScimUpdate.");
      }
      if (requestParameters.sCIMMappingRequest === null || requestParameters.sCIMMappingRequest === void 0) {
        throw new RequiredError("sCIMMappingRequest", "Required parameter requestParameters.sCIMMappingRequest was null or undefined when calling propertymappingsScimUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/scim/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMMappingRequestToJSON(requestParameters.sCIMMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMMappingFromJSON(jsonValue));
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsScimUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsScimUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsScimUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsScimUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/scim/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsScimUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsScimUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsScopeCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.scopeMappingRequest === null || requestParameters.scopeMappingRequest === void 0) {
        throw new RequiredError("scopeMappingRequest", "Required parameter requestParameters.scopeMappingRequest was null or undefined when calling propertymappingsScopeCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/scope/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: ScopeMappingRequestToJSON(requestParameters.scopeMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ScopeMappingFromJSON(jsonValue));
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsScopeCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsScopeCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsScopeDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsScopeDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/scope/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsScopeDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsScopeDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsScopeListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.scopeName !== void 0) {
        queryParameters["scope_name"] = requestParameters.scopeName;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/scope/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedScopeMappingListFromJSON(jsonValue));
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsScopeList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsScopeListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsScopePartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsScopePartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/scope/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedScopeMappingRequestToJSON(requestParameters.patchedScopeMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ScopeMappingFromJSON(jsonValue));
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsScopePartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsScopePartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsScopeRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsScopeRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/scope/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ScopeMappingFromJSON(jsonValue));
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsScopeRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsScopeRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsScopeUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsScopeUpdate.");
      }
      if (requestParameters.scopeMappingRequest === null || requestParameters.scopeMappingRequest === void 0) {
        throw new RequiredError("scopeMappingRequest", "Required parameter requestParameters.scopeMappingRequest was null or undefined when calling propertymappingsScopeUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/scope/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: ScopeMappingRequestToJSON(requestParameters.scopeMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ScopeMappingFromJSON(jsonValue));
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsScopeUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsScopeUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsScopeUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsScopeUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/scope/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsScopeUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsScopeUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
};

export {
  PropertymappingsApi
};
//# sourceMappingURL=chunk-G6FYWANS.js.map
