import {
  o
} from "./chunk-6KRH5U5H.js";
import {
  e3 as e,
  first
} from "./chunk-EOF5OWT7.js";
import {
  T,
  x
} from "./chunk-MDYFRBOX.js";

// src/components/DescriptionList.ts
var isDescriptionRecordCollection = (v) => v.length > 0 && typeof v[0] === "object" && !Array.isArray(v[0]);
function renderDescriptionGroup([term, description]) {
  return x` <div class="pf-c-description-list__group">
        <dt class="pf-c-description-list__term">
            <span class="pf-c-description-list__text">${term}</span>
        </dt>
        <dd class="pf-c-description-list__description">
            <div class="pf-c-description-list__text">${description ?? T}</div>
        </dd>
    </div>`;
}
function recordToPair({ term, desc }) {
  return [term, desc];
}
function alignTermType(terms = []) {
  if (isDescriptionRecordCollection(terms)) {
    return terms.map(recordToPair);
  }
  return terms ?? [];
}
var defaultConfig = {
  horizontal: false,
  compact: false,
  twocolumn: false,
  threecolumn: false
};
function renderDescriptionList(terms = [], config = defaultConfig) {
  const checkedTerms = alignTermType(terms);
  const classes = e({
    "pf-m-horizontal": first(config.horizontal, false),
    "pf-m-compact": first(config.compact, false),
    "pf-m-2-col-on-lg": first(config.twocolumn, false),
    "pf-m-3-col-on-lg": first(config.threecolumn, false)
  });
  return x`
        <dl class="pf-c-description-list ${classes}">
            ${o(checkedTerms, renderDescriptionGroup)}
        </dl>
    `;
}
var DescriptionList_default = renderDescriptionList;

export {
  renderDescriptionList,
  DescriptionList_default
};
//# sourceMappingURL=chunk-HATV2UC6.js.map
