import {
  mermaid,
  require_dayjs_min,
  require_dist,
  require_purify
} from "./chunk-TEDVXOVK.js";
import {
  o
} from "./chunk-4L2VSKMK.js";
import {
  m
} from "./chunk-WPHOZTKQ.js";
import {
  AKElement,
  EVENT_REFRESH,
  EVENT_THEME_CHANGE,
  UiThemeEnum,
  n,
  t
} from "./chunk-EOF5OWT7.js";
import {
  i,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass,
  __toESM
} from "./chunk-6IFWU6BM.js";

// node_modules/mermaid/dist/mermaid.core.mjs
var import_dayjs = __toESM(require_dayjs_min(), 1);
var import_sanitize_url = __toESM(require_dist(), 1);
var import_dompurify = __toESM(require_purify(), 1);

// src/elements/Diagram.ts
var Diagram = class extends AKElement {
  constructor() {
    super();
    this.refreshHandler = () => {
      if (!this.textContent)
        return;
      this.diagram = this.textContent;
    };
    this.handlerBound = false;
    this.config = {
      // The type definition for this says number
      // but the example use strings
      // and numbers don't work
      logLevel: "fatal",
      startOnLoad: false,
      flowchart: {
        curve: "linear"
      },
      htmlLabels: false
    };
    mermaid.initialize(this.config);
  }
  static get styles() {
    return [
      i`
                :host {
                    display: flex;
                    justify-content: center;
                }
            `
    ];
  }
  firstUpdated() {
    if (this.handlerBound)
      return;
    window.addEventListener(EVENT_REFRESH, this.refreshHandler);
    this.addEventListener(EVENT_THEME_CHANGE, (ev) => {
      if (ev.detail === UiThemeEnum.Dark) {
        this.config.theme = "dark";
      } else {
        this.config.theme = "default";
      }
      mermaid.initialize(this.config);
    });
    this.handlerBound = true;
    this.refreshHandler();
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    window.removeEventListener(EVENT_REFRESH, this.refreshHandler);
  }
  render() {
    this.querySelectorAll("*").forEach((el) => {
      try {
        el.remove();
      } catch {
        console.debug(`authentik/diagram: failed to remove element ${el}`);
      }
    });
    if (!this.diagram) {
      return x`<ak-empty-state ?loading=${true}></ak-empty-state>`;
    }
    return x`${m(
      mermaid.render("graph", this.diagram).then((r) => {
        r.bindFunctions?.(this.shadowRoot);
        return o(r.svg);
      })
    )}`;
  }
};
__decorateClass([
  n({ attribute: false })
], Diagram.prototype, "diagram", 2);
Diagram = __decorateClass([
  t("ak-diagram")
], Diagram);

export {
  Diagram
};
//# sourceMappingURL=chunk-I4DDVBVK.js.map
