import {
  ModelEnumFromJSON,
  ModelEnumToJSON
} from "./chunk-EALY7PEX.js";
import {
  PolicyTestRequestToJSON
} from "./chunk-4TARICXF.js";
import {
  CacheFromJSON
} from "./chunk-KNLDGZQ5.js";
import {
  BaseAPI,
  EventActionsFromJSON,
  EventActionsToJSON,
  GroupFromJSON,
  JSONApiResponse,
  PaginationFromJSON,
  PolicyTestResultFromJSON,
  RequiredError,
  TypeCreateFromJSON,
  UsedByFromJSON,
  UserFromJSON,
  VoidApiResponse,
  exists
} from "./chunk-EOF5OWT7.js";

// node_modules/@goauthentik/api/dist/esm/models/AppEnum.js
function AppEnumFromJSON(json) {
  return AppEnumFromJSONTyped(json, false);
}
function AppEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function AppEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/DummyPolicy.js
function DummyPolicyFromJSON(json) {
  return DummyPolicyFromJSONTyped(json, false);
}
function DummyPolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": !exists(json, "execution_logging") ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"],
    "result": !exists(json, "result") ? void 0 : json["result"],
    "waitMin": !exists(json, "wait_min") ? void 0 : json["wait_min"],
    "waitMax": !exists(json, "wait_max") ? void 0 : json["wait_max"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/DummyPolicyRequest.js
function DummyPolicyRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "execution_logging": value.executionLogging,
    "result": value.result,
    "wait_min": value.waitMin,
    "wait_max": value.waitMax
  };
}

// node_modules/@goauthentik/api/dist/esm/models/EventMatcherPolicy.js
function EventMatcherPolicyFromJSON(json) {
  return EventMatcherPolicyFromJSONTyped(json, false);
}
function EventMatcherPolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": !exists(json, "execution_logging") ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"],
    "action": !exists(json, "action") ? void 0 : EventActionsFromJSON(json["action"]),
    "clientIp": !exists(json, "client_ip") ? void 0 : json["client_ip"],
    "app": !exists(json, "app") ? void 0 : AppEnumFromJSON(json["app"]),
    "model": !exists(json, "model") ? void 0 : ModelEnumFromJSON(json["model"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/EventMatcherPolicyRequest.js
function EventMatcherPolicyRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "execution_logging": value.executionLogging,
    "action": EventActionsToJSON(value.action),
    "client_ip": value.clientIp,
    "app": AppEnumToJSON(value.app),
    "model": ModelEnumToJSON(value.model)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ExpressionPolicy.js
function ExpressionPolicyFromJSON(json) {
  return ExpressionPolicyFromJSONTyped(json, false);
}
function ExpressionPolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": !exists(json, "execution_logging") ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"],
    "expression": json["expression"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ExpressionPolicyRequest.js
function ExpressionPolicyRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "execution_logging": value.executionLogging,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedDummyPolicyList.js
function PaginatedDummyPolicyListFromJSON(json) {
  return PaginatedDummyPolicyListFromJSONTyped(json, false);
}
function PaginatedDummyPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(DummyPolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedEventMatcherPolicyList.js
function PaginatedEventMatcherPolicyListFromJSON(json) {
  return PaginatedEventMatcherPolicyListFromJSONTyped(json, false);
}
function PaginatedEventMatcherPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(EventMatcherPolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedExpressionPolicyList.js
function PaginatedExpressionPolicyListFromJSON(json) {
  return PaginatedExpressionPolicyListFromJSONTyped(json, false);
}
function PaginatedExpressionPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ExpressionPolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PasswordExpiryPolicy.js
function PasswordExpiryPolicyFromJSON(json) {
  return PasswordExpiryPolicyFromJSONTyped(json, false);
}
function PasswordExpiryPolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": !exists(json, "execution_logging") ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"],
    "days": json["days"],
    "denyOnly": !exists(json, "deny_only") ? void 0 : json["deny_only"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPasswordExpiryPolicyList.js
function PaginatedPasswordExpiryPolicyListFromJSON(json) {
  return PaginatedPasswordExpiryPolicyListFromJSONTyped(json, false);
}
function PaginatedPasswordExpiryPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PasswordExpiryPolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PasswordPolicy.js
function PasswordPolicyFromJSON(json) {
  return PasswordPolicyFromJSONTyped(json, false);
}
function PasswordPolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": !exists(json, "execution_logging") ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"],
    "passwordField": !exists(json, "password_field") ? void 0 : json["password_field"],
    "amountDigits": !exists(json, "amount_digits") ? void 0 : json["amount_digits"],
    "amountUppercase": !exists(json, "amount_uppercase") ? void 0 : json["amount_uppercase"],
    "amountLowercase": !exists(json, "amount_lowercase") ? void 0 : json["amount_lowercase"],
    "amountSymbols": !exists(json, "amount_symbols") ? void 0 : json["amount_symbols"],
    "lengthMin": !exists(json, "length_min") ? void 0 : json["length_min"],
    "symbolCharset": !exists(json, "symbol_charset") ? void 0 : json["symbol_charset"],
    "errorMessage": !exists(json, "error_message") ? void 0 : json["error_message"],
    "checkStaticRules": !exists(json, "check_static_rules") ? void 0 : json["check_static_rules"],
    "checkHaveIBeenPwned": !exists(json, "check_have_i_been_pwned") ? void 0 : json["check_have_i_been_pwned"],
    "checkZxcvbn": !exists(json, "check_zxcvbn") ? void 0 : json["check_zxcvbn"],
    "hibpAllowedCount": !exists(json, "hibp_allowed_count") ? void 0 : json["hibp_allowed_count"],
    "zxcvbnScoreThreshold": !exists(json, "zxcvbn_score_threshold") ? void 0 : json["zxcvbn_score_threshold"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPasswordPolicyList.js
function PaginatedPasswordPolicyListFromJSON(json) {
  return PaginatedPasswordPolicyListFromJSONTyped(json, false);
}
function PaginatedPasswordPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PasswordPolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Policy.js
function PolicyFromJSON(json) {
  return PolicyFromJSONTyped(json, false);
}
function PolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": !exists(json, "execution_logging") ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PolicyBinding.js
function PolicyBindingFromJSON(json) {
  return PolicyBindingFromJSONTyped(json, false);
}
function PolicyBindingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "policy": !exists(json, "policy") ? void 0 : json["policy"],
    "group": !exists(json, "group") ? void 0 : json["group"],
    "user": !exists(json, "user") ? void 0 : json["user"],
    "policyObj": PolicyFromJSON(json["policy_obj"]),
    "groupObj": GroupFromJSON(json["group_obj"]),
    "userObj": UserFromJSON(json["user_obj"]),
    "target": json["target"],
    "negate": !exists(json, "negate") ? void 0 : json["negate"],
    "enabled": !exists(json, "enabled") ? void 0 : json["enabled"],
    "order": json["order"],
    "timeout": !exists(json, "timeout") ? void 0 : json["timeout"],
    "failureResult": !exists(json, "failure_result") ? void 0 : json["failure_result"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPolicyBindingList.js
function PaginatedPolicyBindingListFromJSON(json) {
  return PaginatedPolicyBindingListFromJSONTyped(json, false);
}
function PaginatedPolicyBindingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PolicyBindingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPolicyList.js
function PaginatedPolicyListFromJSON(json) {
  return PaginatedPolicyListFromJSONTyped(json, false);
}
function PaginatedPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Reputation.js
function ReputationFromJSON(json) {
  return ReputationFromJSONTyped(json, false);
}
function ReputationFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": !exists(json, "pk") ? void 0 : json["pk"],
    "identifier": json["identifier"],
    "ip": json["ip"],
    "ipGeoData": !exists(json, "ip_geo_data") ? void 0 : json["ip_geo_data"],
    "ipAsnData": !exists(json, "ip_asn_data") ? void 0 : json["ip_asn_data"],
    "score": !exists(json, "score") ? void 0 : json["score"],
    "updated": new Date(json["updated"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedReputationList.js
function PaginatedReputationListFromJSON(json) {
  return PaginatedReputationListFromJSONTyped(json, false);
}
function PaginatedReputationListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ReputationFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ReputationPolicy.js
function ReputationPolicyFromJSON(json) {
  return ReputationPolicyFromJSONTyped(json, false);
}
function ReputationPolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": !exists(json, "execution_logging") ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"],
    "checkIp": !exists(json, "check_ip") ? void 0 : json["check_ip"],
    "checkUsername": !exists(json, "check_username") ? void 0 : json["check_username"],
    "threshold": !exists(json, "threshold") ? void 0 : json["threshold"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedReputationPolicyList.js
function PaginatedReputationPolicyListFromJSON(json) {
  return PaginatedReputationPolicyListFromJSONTyped(json, false);
}
function PaginatedReputationPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ReputationPolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PasswordExpiryPolicyRequest.js
function PasswordExpiryPolicyRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "execution_logging": value.executionLogging,
    "days": value.days,
    "deny_only": value.denyOnly
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PasswordPolicyRequest.js
function PasswordPolicyRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "execution_logging": value.executionLogging,
    "password_field": value.passwordField,
    "amount_digits": value.amountDigits,
    "amount_uppercase": value.amountUppercase,
    "amount_lowercase": value.amountLowercase,
    "amount_symbols": value.amountSymbols,
    "length_min": value.lengthMin,
    "symbol_charset": value.symbolCharset,
    "error_message": value.errorMessage,
    "check_static_rules": value.checkStaticRules,
    "check_have_i_been_pwned": value.checkHaveIBeenPwned,
    "check_zxcvbn": value.checkZxcvbn,
    "hibp_allowed_count": value.hibpAllowedCount,
    "zxcvbn_score_threshold": value.zxcvbnScoreThreshold
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedDummyPolicyRequest.js
function PatchedDummyPolicyRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "execution_logging": value.executionLogging,
    "result": value.result,
    "wait_min": value.waitMin,
    "wait_max": value.waitMax
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedEventMatcherPolicyRequest.js
function PatchedEventMatcherPolicyRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "execution_logging": value.executionLogging,
    "action": EventActionsToJSON(value.action),
    "client_ip": value.clientIp,
    "app": AppEnumToJSON(value.app),
    "model": ModelEnumToJSON(value.model)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedExpressionPolicyRequest.js
function PatchedExpressionPolicyRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "execution_logging": value.executionLogging,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedPasswordExpiryPolicyRequest.js
function PatchedPasswordExpiryPolicyRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "execution_logging": value.executionLogging,
    "days": value.days,
    "deny_only": value.denyOnly
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedPasswordPolicyRequest.js
function PatchedPasswordPolicyRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "execution_logging": value.executionLogging,
    "password_field": value.passwordField,
    "amount_digits": value.amountDigits,
    "amount_uppercase": value.amountUppercase,
    "amount_lowercase": value.amountLowercase,
    "amount_symbols": value.amountSymbols,
    "length_min": value.lengthMin,
    "symbol_charset": value.symbolCharset,
    "error_message": value.errorMessage,
    "check_static_rules": value.checkStaticRules,
    "check_have_i_been_pwned": value.checkHaveIBeenPwned,
    "check_zxcvbn": value.checkZxcvbn,
    "hibp_allowed_count": value.hibpAllowedCount,
    "zxcvbn_score_threshold": value.zxcvbnScoreThreshold
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedPolicyBindingRequest.js
function PatchedPolicyBindingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "policy": value.policy,
    "group": value.group,
    "user": value.user,
    "target": value.target,
    "negate": value.negate,
    "enabled": value.enabled,
    "order": value.order,
    "timeout": value.timeout,
    "failure_result": value.failureResult
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedReputationPolicyRequest.js
function PatchedReputationPolicyRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "execution_logging": value.executionLogging,
    "check_ip": value.checkIp,
    "check_username": value.checkUsername,
    "threshold": value.threshold
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PolicyBindingRequest.js
function PolicyBindingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "policy": value.policy,
    "group": value.group,
    "user": value.user,
    "target": value.target,
    "negate": value.negate,
    "enabled": value.enabled,
    "order": value.order,
    "timeout": value.timeout,
    "failure_result": value.failureResult
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ReputationPolicyRequest.js
function ReputationPolicyRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "execution_logging": value.executionLogging,
    "check_ip": value.checkIp,
    "check_username": value.checkUsername,
    "threshold": value.threshold
  };
}

// node_modules/@goauthentik/api/dist/esm/apis/PoliciesApi.js
var __awaiter = function(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var PoliciesApi = class extends BaseAPI {
  /**
   * Clear policy cache
   */
  policiesAllCacheClearCreateRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/cache_clear/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Clear policy cache
   */
  policiesAllCacheClearCreate(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesAllCacheClearCreateRaw(initOverrides);
    });
  }
  /**
   * Info about cached policies
   */
  policiesAllCacheInfoRetrieveRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/cache_info/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => CacheFromJSON(jsonValue));
    });
  }
  /**
   * Info about cached policies
   */
  policiesAllCacheInfoRetrieve(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesAllCacheInfoRetrieveRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Policy Viewset
   */
  policiesAllDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesAllDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Policy Viewset
   */
  policiesAllDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesAllDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Policy Viewset
   */
  policiesAllListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.bindingsIsnull !== void 0) {
        queryParameters["bindings__isnull"] = requestParameters.bindingsIsnull;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.promptstageIsnull !== void 0) {
        queryParameters["promptstage__isnull"] = requestParameters.promptstageIsnull;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * Policy Viewset
   */
  policiesAllList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesAllListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Policy Viewset
   */
  policiesAllRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesAllRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PolicyFromJSON(jsonValue));
    });
  }
  /**
   * Policy Viewset
   */
  policiesAllRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesAllRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Test policy
   */
  policiesAllTestCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesAllTestCreate.");
      }
      if (requestParameters.policyTestRequest === null || requestParameters.policyTestRequest === void 0) {
        throw new RequiredError("policyTestRequest", "Required parameter requestParameters.policyTestRequest was null or undefined when calling policiesAllTestCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/{policy_uuid}/test/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PolicyTestRequestToJSON(requestParameters.policyTestRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PolicyTestResultFromJSON(jsonValue));
    });
  }
  /**
   * Test policy
   */
  policiesAllTestCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesAllTestCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get all creatable policy types
   */
  policiesAllTypesListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/types/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(TypeCreateFromJSON));
    });
  }
  /**
   * Get all creatable policy types
   */
  policiesAllTypesList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesAllTypesListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesAllUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesAllUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesAllUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesAllUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyBindingRequest === null || requestParameters.policyBindingRequest === void 0) {
        throw new RequiredError("policyBindingRequest", "Required parameter requestParameters.policyBindingRequest was null or undefined when calling policiesBindingsCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/bindings/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PolicyBindingRequestToJSON(requestParameters.policyBindingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PolicyBindingFromJSON(jsonValue));
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesBindingsCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyBindingUuid === null || requestParameters.policyBindingUuid === void 0) {
        throw new RequiredError("policyBindingUuid", "Required parameter requestParameters.policyBindingUuid was null or undefined when calling policiesBindingsDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/bindings/{policy_binding_uuid}/`.replace(`{${"policy_binding_uuid"}}`, encodeURIComponent(String(requestParameters.policyBindingUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesBindingsDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.enabled !== void 0) {
        queryParameters["enabled"] = requestParameters.enabled;
      }
      if (requestParameters.order !== void 0) {
        queryParameters["order"] = requestParameters.order;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.policy !== void 0) {
        queryParameters["policy"] = requestParameters.policy;
      }
      if (requestParameters.policyIsnull !== void 0) {
        queryParameters["policy__isnull"] = requestParameters.policyIsnull;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.target !== void 0) {
        queryParameters["target"] = requestParameters.target;
      }
      if (requestParameters.targetIn) {
        queryParameters["target_in"] = requestParameters.targetIn;
      }
      if (requestParameters.timeout !== void 0) {
        queryParameters["timeout"] = requestParameters.timeout;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/bindings/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPolicyBindingListFromJSON(jsonValue));
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesBindingsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyBindingUuid === null || requestParameters.policyBindingUuid === void 0) {
        throw new RequiredError("policyBindingUuid", "Required parameter requestParameters.policyBindingUuid was null or undefined when calling policiesBindingsPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/bindings/{policy_binding_uuid}/`.replace(`{${"policy_binding_uuid"}}`, encodeURIComponent(String(requestParameters.policyBindingUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedPolicyBindingRequestToJSON(requestParameters.patchedPolicyBindingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PolicyBindingFromJSON(jsonValue));
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesBindingsPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyBindingUuid === null || requestParameters.policyBindingUuid === void 0) {
        throw new RequiredError("policyBindingUuid", "Required parameter requestParameters.policyBindingUuid was null or undefined when calling policiesBindingsRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/bindings/{policy_binding_uuid}/`.replace(`{${"policy_binding_uuid"}}`, encodeURIComponent(String(requestParameters.policyBindingUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PolicyBindingFromJSON(jsonValue));
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesBindingsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyBindingUuid === null || requestParameters.policyBindingUuid === void 0) {
        throw new RequiredError("policyBindingUuid", "Required parameter requestParameters.policyBindingUuid was null or undefined when calling policiesBindingsUpdate.");
      }
      if (requestParameters.policyBindingRequest === null || requestParameters.policyBindingRequest === void 0) {
        throw new RequiredError("policyBindingRequest", "Required parameter requestParameters.policyBindingRequest was null or undefined when calling policiesBindingsUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/bindings/{policy_binding_uuid}/`.replace(`{${"policy_binding_uuid"}}`, encodeURIComponent(String(requestParameters.policyBindingUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: PolicyBindingRequestToJSON(requestParameters.policyBindingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PolicyBindingFromJSON(jsonValue));
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesBindingsUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesBindingsUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyBindingUuid === null || requestParameters.policyBindingUuid === void 0) {
        throw new RequiredError("policyBindingUuid", "Required parameter requestParameters.policyBindingUuid was null or undefined when calling policiesBindingsUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/bindings/{policy_binding_uuid}/used_by/`.replace(`{${"policy_binding_uuid"}}`, encodeURIComponent(String(requestParameters.policyBindingUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesBindingsUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesBindingsUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.dummyPolicyRequest === null || requestParameters.dummyPolicyRequest === void 0) {
        throw new RequiredError("dummyPolicyRequest", "Required parameter requestParameters.dummyPolicyRequest was null or undefined when calling policiesDummyCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/dummy/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: DummyPolicyRequestToJSON(requestParameters.dummyPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DummyPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesDummyCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesDummyDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/dummy/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesDummyDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.created !== void 0) {
        queryParameters["created"] = requestParameters.created.toISOString();
      }
      if (requestParameters.executionLogging !== void 0) {
        queryParameters["execution_logging"] = requestParameters.executionLogging;
      }
      if (requestParameters.lastUpdated !== void 0) {
        queryParameters["last_updated"] = requestParameters.lastUpdated.toISOString();
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.policyUuid !== void 0) {
        queryParameters["policy_uuid"] = requestParameters.policyUuid;
      }
      if (requestParameters.result !== void 0) {
        queryParameters["result"] = requestParameters.result;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.waitMax !== void 0) {
        queryParameters["wait_max"] = requestParameters.waitMax;
      }
      if (requestParameters.waitMin !== void 0) {
        queryParameters["wait_min"] = requestParameters.waitMin;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/dummy/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedDummyPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesDummyListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesDummyPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/dummy/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedDummyPolicyRequestToJSON(requestParameters.patchedDummyPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DummyPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesDummyPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesDummyRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/dummy/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DummyPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesDummyRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesDummyUpdate.");
      }
      if (requestParameters.dummyPolicyRequest === null || requestParameters.dummyPolicyRequest === void 0) {
        throw new RequiredError("dummyPolicyRequest", "Required parameter requestParameters.dummyPolicyRequest was null or undefined when calling policiesDummyUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/dummy/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: DummyPolicyRequestToJSON(requestParameters.dummyPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DummyPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesDummyUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesDummyUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesDummyUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/dummy/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesDummyUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesDummyUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.eventMatcherPolicyRequest === null || requestParameters.eventMatcherPolicyRequest === void 0) {
        throw new RequiredError("eventMatcherPolicyRequest", "Required parameter requestParameters.eventMatcherPolicyRequest was null or undefined when calling policiesEventMatcherCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/event_matcher/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: EventMatcherPolicyRequestToJSON(requestParameters.eventMatcherPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EventMatcherPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesEventMatcherCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesEventMatcherDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/event_matcher/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesEventMatcherDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.action !== void 0) {
        queryParameters["action"] = requestParameters.action;
      }
      if (requestParameters.app !== void 0) {
        queryParameters["app"] = requestParameters.app;
      }
      if (requestParameters.clientIp !== void 0) {
        queryParameters["client_ip"] = requestParameters.clientIp;
      }
      if (requestParameters.created !== void 0) {
        queryParameters["created"] = requestParameters.created.toISOString();
      }
      if (requestParameters.executionLogging !== void 0) {
        queryParameters["execution_logging"] = requestParameters.executionLogging;
      }
      if (requestParameters.lastUpdated !== void 0) {
        queryParameters["last_updated"] = requestParameters.lastUpdated.toISOString();
      }
      if (requestParameters.model !== void 0) {
        queryParameters["model"] = requestParameters.model;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.policyUuid !== void 0) {
        queryParameters["policy_uuid"] = requestParameters.policyUuid;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/event_matcher/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedEventMatcherPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesEventMatcherListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesEventMatcherPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/event_matcher/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedEventMatcherPolicyRequestToJSON(requestParameters.patchedEventMatcherPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EventMatcherPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesEventMatcherPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesEventMatcherRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/event_matcher/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EventMatcherPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesEventMatcherRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesEventMatcherUpdate.");
      }
      if (requestParameters.eventMatcherPolicyRequest === null || requestParameters.eventMatcherPolicyRequest === void 0) {
        throw new RequiredError("eventMatcherPolicyRequest", "Required parameter requestParameters.eventMatcherPolicyRequest was null or undefined when calling policiesEventMatcherUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/event_matcher/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: EventMatcherPolicyRequestToJSON(requestParameters.eventMatcherPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EventMatcherPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesEventMatcherUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesEventMatcherUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesEventMatcherUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/event_matcher/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesEventMatcherUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesEventMatcherUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.expressionPolicyRequest === null || requestParameters.expressionPolicyRequest === void 0) {
        throw new RequiredError("expressionPolicyRequest", "Required parameter requestParameters.expressionPolicyRequest was null or undefined when calling policiesExpressionCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/expression/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: ExpressionPolicyRequestToJSON(requestParameters.expressionPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ExpressionPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesExpressionCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesExpressionDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/expression/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesExpressionDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.created !== void 0) {
        queryParameters["created"] = requestParameters.created.toISOString();
      }
      if (requestParameters.executionLogging !== void 0) {
        queryParameters["execution_logging"] = requestParameters.executionLogging;
      }
      if (requestParameters.expression !== void 0) {
        queryParameters["expression"] = requestParameters.expression;
      }
      if (requestParameters.lastUpdated !== void 0) {
        queryParameters["last_updated"] = requestParameters.lastUpdated.toISOString();
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.policyUuid !== void 0) {
        queryParameters["policy_uuid"] = requestParameters.policyUuid;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/expression/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedExpressionPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesExpressionListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesExpressionPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/expression/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedExpressionPolicyRequestToJSON(requestParameters.patchedExpressionPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ExpressionPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesExpressionPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesExpressionRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/expression/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ExpressionPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesExpressionRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesExpressionUpdate.");
      }
      if (requestParameters.expressionPolicyRequest === null || requestParameters.expressionPolicyRequest === void 0) {
        throw new RequiredError("expressionPolicyRequest", "Required parameter requestParameters.expressionPolicyRequest was null or undefined when calling policiesExpressionUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/expression/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: ExpressionPolicyRequestToJSON(requestParameters.expressionPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ExpressionPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesExpressionUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesExpressionUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesExpressionUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/expression/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesExpressionUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesExpressionUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.passwordPolicyRequest === null || requestParameters.passwordPolicyRequest === void 0) {
        throw new RequiredError("passwordPolicyRequest", "Required parameter requestParameters.passwordPolicyRequest was null or undefined when calling policiesPasswordCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PasswordPolicyRequestToJSON(requestParameters.passwordPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesPasswordDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesPasswordDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.passwordExpiryPolicyRequest === null || requestParameters.passwordExpiryPolicyRequest === void 0) {
        throw new RequiredError("passwordExpiryPolicyRequest", "Required parameter requestParameters.passwordExpiryPolicyRequest was null or undefined when calling policiesPasswordExpiryCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password_expiry/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PasswordExpiryPolicyRequestToJSON(requestParameters.passwordExpiryPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordExpiryPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordExpiryCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesPasswordExpiryDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password_expiry/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesPasswordExpiryDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.created !== void 0) {
        queryParameters["created"] = requestParameters.created.toISOString();
      }
      if (requestParameters.days !== void 0) {
        queryParameters["days"] = requestParameters.days;
      }
      if (requestParameters.denyOnly !== void 0) {
        queryParameters["deny_only"] = requestParameters.denyOnly;
      }
      if (requestParameters.executionLogging !== void 0) {
        queryParameters["execution_logging"] = requestParameters.executionLogging;
      }
      if (requestParameters.lastUpdated !== void 0) {
        queryParameters["last_updated"] = requestParameters.lastUpdated.toISOString();
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.policyUuid !== void 0) {
        queryParameters["policy_uuid"] = requestParameters.policyUuid;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password_expiry/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPasswordExpiryPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordExpiryListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesPasswordExpiryPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password_expiry/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedPasswordExpiryPolicyRequestToJSON(requestParameters.patchedPasswordExpiryPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordExpiryPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordExpiryPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesPasswordExpiryRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password_expiry/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordExpiryPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordExpiryRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesPasswordExpiryUpdate.");
      }
      if (requestParameters.passwordExpiryPolicyRequest === null || requestParameters.passwordExpiryPolicyRequest === void 0) {
        throw new RequiredError("passwordExpiryPolicyRequest", "Required parameter requestParameters.passwordExpiryPolicyRequest was null or undefined when calling policiesPasswordExpiryUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password_expiry/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: PasswordExpiryPolicyRequestToJSON(requestParameters.passwordExpiryPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordExpiryPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordExpiryUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesPasswordExpiryUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesPasswordExpiryUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password_expiry/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesPasswordExpiryUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordExpiryUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.amountDigits !== void 0) {
        queryParameters["amount_digits"] = requestParameters.amountDigits;
      }
      if (requestParameters.amountLowercase !== void 0) {
        queryParameters["amount_lowercase"] = requestParameters.amountLowercase;
      }
      if (requestParameters.amountSymbols !== void 0) {
        queryParameters["amount_symbols"] = requestParameters.amountSymbols;
      }
      if (requestParameters.amountUppercase !== void 0) {
        queryParameters["amount_uppercase"] = requestParameters.amountUppercase;
      }
      if (requestParameters.checkHaveIBeenPwned !== void 0) {
        queryParameters["check_have_i_been_pwned"] = requestParameters.checkHaveIBeenPwned;
      }
      if (requestParameters.checkStaticRules !== void 0) {
        queryParameters["check_static_rules"] = requestParameters.checkStaticRules;
      }
      if (requestParameters.checkZxcvbn !== void 0) {
        queryParameters["check_zxcvbn"] = requestParameters.checkZxcvbn;
      }
      if (requestParameters.created !== void 0) {
        queryParameters["created"] = requestParameters.created.toISOString();
      }
      if (requestParameters.errorMessage !== void 0) {
        queryParameters["error_message"] = requestParameters.errorMessage;
      }
      if (requestParameters.executionLogging !== void 0) {
        queryParameters["execution_logging"] = requestParameters.executionLogging;
      }
      if (requestParameters.hibpAllowedCount !== void 0) {
        queryParameters["hibp_allowed_count"] = requestParameters.hibpAllowedCount;
      }
      if (requestParameters.lastUpdated !== void 0) {
        queryParameters["last_updated"] = requestParameters.lastUpdated.toISOString();
      }
      if (requestParameters.lengthMin !== void 0) {
        queryParameters["length_min"] = requestParameters.lengthMin;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.passwordField !== void 0) {
        queryParameters["password_field"] = requestParameters.passwordField;
      }
      if (requestParameters.policyUuid !== void 0) {
        queryParameters["policy_uuid"] = requestParameters.policyUuid;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.symbolCharset !== void 0) {
        queryParameters["symbol_charset"] = requestParameters.symbolCharset;
      }
      if (requestParameters.zxcvbnScoreThreshold !== void 0) {
        queryParameters["zxcvbn_score_threshold"] = requestParameters.zxcvbnScoreThreshold;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPasswordPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesPasswordPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedPasswordPolicyRequestToJSON(requestParameters.patchedPasswordPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesPasswordRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesPasswordUpdate.");
      }
      if (requestParameters.passwordPolicyRequest === null || requestParameters.passwordPolicyRequest === void 0) {
        throw new RequiredError("passwordPolicyRequest", "Required parameter requestParameters.passwordPolicyRequest was null or undefined when calling policiesPasswordUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: PasswordPolicyRequestToJSON(requestParameters.passwordPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesPasswordUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesPasswordUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesPasswordUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.reputationPolicyRequest === null || requestParameters.reputationPolicyRequest === void 0) {
        throw new RequiredError("reputationPolicyRequest", "Required parameter requestParameters.reputationPolicyRequest was null or undefined when calling policiesReputationCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: ReputationPolicyRequestToJSON(requestParameters.reputationPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ReputationPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesReputationDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesReputationDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.checkIp !== void 0) {
        queryParameters["check_ip"] = requestParameters.checkIp;
      }
      if (requestParameters.checkUsername !== void 0) {
        queryParameters["check_username"] = requestParameters.checkUsername;
      }
      if (requestParameters.created !== void 0) {
        queryParameters["created"] = requestParameters.created.toISOString();
      }
      if (requestParameters.executionLogging !== void 0) {
        queryParameters["execution_logging"] = requestParameters.executionLogging;
      }
      if (requestParameters.lastUpdated !== void 0) {
        queryParameters["last_updated"] = requestParameters.lastUpdated.toISOString();
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.policyUuid !== void 0) {
        queryParameters["policy_uuid"] = requestParameters.policyUuid;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.threshold !== void 0) {
        queryParameters["threshold"] = requestParameters.threshold;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedReputationPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesReputationPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedReputationPolicyRequestToJSON(requestParameters.patchedReputationPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ReputationPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesReputationRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ReputationPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Reputation Viewset
   */
  policiesReputationScoresDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.reputationUuid === null || requestParameters.reputationUuid === void 0) {
        throw new RequiredError("reputationUuid", "Required parameter requestParameters.reputationUuid was null or undefined when calling policiesReputationScoresDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/scores/{reputation_uuid}/`.replace(`{${"reputation_uuid"}}`, encodeURIComponent(String(requestParameters.reputationUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Reputation Viewset
   */
  policiesReputationScoresDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesReputationScoresDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Reputation Viewset
   */
  policiesReputationScoresListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.identifier !== void 0) {
        queryParameters["identifier"] = requestParameters.identifier;
      }
      if (requestParameters.ip !== void 0) {
        queryParameters["ip"] = requestParameters.ip;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.score !== void 0) {
        queryParameters["score"] = requestParameters.score;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/scores/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedReputationListFromJSON(jsonValue));
    });
  }
  /**
   * Reputation Viewset
   */
  policiesReputationScoresList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationScoresListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Reputation Viewset
   */
  policiesReputationScoresRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.reputationUuid === null || requestParameters.reputationUuid === void 0) {
        throw new RequiredError("reputationUuid", "Required parameter requestParameters.reputationUuid was null or undefined when calling policiesReputationScoresRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/scores/{reputation_uuid}/`.replace(`{${"reputation_uuid"}}`, encodeURIComponent(String(requestParameters.reputationUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ReputationFromJSON(jsonValue));
    });
  }
  /**
   * Reputation Viewset
   */
  policiesReputationScoresRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationScoresRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesReputationScoresUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.reputationUuid === null || requestParameters.reputationUuid === void 0) {
        throw new RequiredError("reputationUuid", "Required parameter requestParameters.reputationUuid was null or undefined when calling policiesReputationScoresUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/scores/{reputation_uuid}/used_by/`.replace(`{${"reputation_uuid"}}`, encodeURIComponent(String(requestParameters.reputationUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesReputationScoresUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationScoresUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesReputationUpdate.");
      }
      if (requestParameters.reputationPolicyRequest === null || requestParameters.reputationPolicyRequest === void 0) {
        throw new RequiredError("reputationPolicyRequest", "Required parameter requestParameters.reputationPolicyRequest was null or undefined when calling policiesReputationUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: ReputationPolicyRequestToJSON(requestParameters.reputationPolicyRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ReputationPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesReputationUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.policyUuid === null || requestParameters.policyUuid === void 0) {
        throw new RequiredError("policyUuid", "Required parameter requestParameters.policyUuid was null or undefined when calling policiesReputationUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters.policyUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesReputationUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
};

export {
  PoliciesApi
};
//# sourceMappingURL=chunk-JSMKLBKU.js.map
