import {
  AKElement,
  EVENT_SIDEBAR_TOGGLE,
  UiThemeEnum,
  WithBrandConfig,
  button_default,
  page_default,
  patternfly_base_default,
  t
} from "./chunk-EOF5OWT7.js";
import {
  i,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/elements/sidebar/SidebarBrand.ts
var MIN_WIDTH = 1200;
var DefaultBrand = {
  brandingLogo: "/static/dist/assets/icons/icon_left_brand.svg",
  brandingFavicon: "/static/dist/assets/icons/icon.png",
  brandingTitle: "authentik",
  uiFooterLinks: [],
  uiTheme: UiThemeEnum.Automatic,
  matchedDomain: "",
  defaultLocale: ""
};
var SidebarBrand = class extends WithBrandConfig(AKElement) {
  static get styles() {
    return [
      patternfly_base_default,
      patternfly_base_default,
      page_default,
      button_default,
      i`
                :host {
                    display: flex;
                    flex-direction: row;
                    align-items: center;
                    height: 114px;
                    min-height: 114px;
                }
                .pf-c-brand img {
                    padding: 0 0.5rem;
                    height: 42px;
                }
                button.pf-c-button.sidebar-trigger {
                    background-color: transparent;
                    border-radius: 0px;
                    height: 100%;
                    color: var(--ak-dark-foreground);
                }
            `
    ];
  }
  constructor() {
    super();
    window.addEventListener("resize", () => {
      this.requestUpdate();
    });
  }
  render() {
    return x` ${window.innerWidth <= MIN_WIDTH ? x`
                      <button
                          class="sidebar-trigger pf-c-button"
                          @click=${() => {
      this.dispatchEvent(
        new CustomEvent(EVENT_SIDEBAR_TOGGLE, {
          bubbles: true,
          composed: true
        })
      );
    }}
                      >
                          <i class="fas fa-bars"></i>
                      </button>
                  ` : x``}
            <a href="#/" class="pf-c-page__header-brand-link">
                <div class="pf-c-brand ak-brand">
                    <img
                        src=${this.brand?.brandingLogo ?? DefaultBrand.brandingLogo}
                        alt="authentik Logo"
                        loading="lazy"
                    />
                </div>
            </a>`;
  }
};
SidebarBrand = __decorateClass([
  t("ak-sidebar-brand")
], SidebarBrand);

export {
  DefaultBrand
};
//# sourceMappingURL=chunk-KSSYYYDR.js.map
