import {
  WithLicenseSummary
} from "./chunk-W4RSYEXS.js";
import {
  clientTypeOptions,
  issuerModeOptions,
  redirectUriHelp,
  subjectModeOptions
} from "./chunk-EINGTETQ.js";
import {
  policyOptions
} from "./chunk-YMC5UCEC.js";
import {
  HorizontalLightComponent
} from "./chunk-FH6YELOW.js";
import {
  e as e3,
  n as n3
} from "./chunk-IZQSSDOF.js";
import {
  PropertymappingsApi
} from "./chunk-G6FYWANS.js";
import {
  progress_stepper_default,
  wizard_default
} from "./chunk-KANCX4AI.js";
import {
  radio_default
} from "./chunk-SACHAYPZ.js";
import {
  serializeForm
} from "./chunk-PSPR3SUN.js";
import {
  SourcesApi
} from "./chunk-XSB422CX.js";
import {
  FlowsInstancesListDesignationEnum
} from "./chunk-2G3GM457.js";
import {
  o as o2
} from "./chunk-6KRH5U5H.js";
import {
  ModalButton,
  form_default
} from "./chunk-GOIBY4UW.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import {
  label_default
} from "./chunk-EEANTJCZ.js";
import {
  alert_default
} from "./chunk-7XZT6QXJ.js";
import {
  CustomEmitterElement,
  CustomListenerElement,
  bullseye_default,
  form_control_default,
  getURLParam,
  input_group_default,
  switch_default
} from "./chunk-OOB7B3ZK.js";
import {
  empty_state_default,
  o,
  title_default
} from "./chunk-5MMRTU65.js";
import {
  AKElement,
  ClientTypeEnum,
  CoreApi,
  DEFAULT_CONFIG,
  DigestAlgorithmEnum,
  EVENT_REFRESH,
  LDAPAPIAccessMode,
  LOCALSTORAGE_AUTHENTIK_KEY,
  ProviderModelEnum,
  ProxyMode,
  SignatureAlgorithmEnum,
  SpBindingEnum,
  ValidationErrorFromJSON,
  WithBrandConfig,
  ascii_letters,
  button_default,
  c,
  content_default,
  convertToSlug,
  digits,
  e,
  e3 as e2,
  first,
  i2,
  n,
  n2,
  o as o3,
  page_default,
  patternfly_base_default,
  r,
  randomString,
  t
} from "./chunk-EOF5OWT7.js";
import {
  T,
  i,
  msg,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/components/ak-wizard-main/ak-wizard-frame.ts
var AkWizardFrame = class extends CustomEmitterElement(ModalButton) {
  constructor() {
    super();
    this.buttons = [];
    this.canCancel = false;
    this.renderButtons = this.renderButtons.bind(this);
  }
  static get styles() {
    return [...super.styles, wizard_default];
  }
  renderModalInner() {
    return x`<div class="pf-c-wizard">
            ${this.renderHeader()}
            <div class="pf-c-wizard__outer-wrap">
                <div class="pf-c-wizard__inner-wrap">
                    ${this.renderNavigation()} 
                    ${this.renderMainSection()}
                </div>
                ${this.renderFooter()}
            </div>
        </div>`;
  }
  renderHeader() {
    return x`<div class="pf-c-wizard__header">
            ${this.canCancel ? this.renderHeaderCancelIcon() : T}
            <h1 class="pf-c-title pf-m-3xl pf-c-wizard__title">${this.header}</h1>
            <p class="pf-c-wizard__description">${this.description}</p>
        </div>`;
  }
  renderHeaderCancelIcon() {
    return x`<button
            class="pf-c-button pf-m-plain pf-c-wizard__close"
            type="button"
            aria-label="${msg("Close")}"
            @click=${() => this.dispatchCustomEvent("ak-wizard-nav", { command: "close" })}
        >
            <i class="fas fa-times" aria-hidden="true"></i>
        </button>`;
  }
  renderNavigation() {
    return x`<nav class="pf-c-wizard__nav">
            <ol class="pf-c-wizard__nav-list">
                ${this.stepLabels.map((step) => {
      return this.renderNavigationStep(step);
    })}
            </ol>
        </nav>`;
  }
  renderNavigationStep(step) {
    const buttonClasses = {
      "pf-c-wizard__nav-link": true,
      "pf-m-current": step.active
    };
    return x`
            <li class="pf-c-wizard__nav-item">
                <button
                    class=${e2(buttonClasses)}
                    ?disabled=${step.disabled}
                    @click=${() => this.dispatchCustomEvent("ak-wizard-nav", {
      command: "goto",
      step: step.index
    })}
                >
                    ${step.label}
                </button>
            </li>
        `;
  }
  // This is where the panel is shown. We expect the panel to get its information from an
  // independent context.
  renderMainSection() {
    return x`<main class="pf-c-wizard__main">
            <div id="main-content" class="pf-c-wizard__main-body">${this.form()}</div>
        </main>`;
  }
  renderFooter() {
    return x`
            <footer class="pf-c-wizard__footer">${o2(this.buttons, this.renderButtons)}</footer>
        `;
  }
  renderButtons([label, command]) {
    switch (command.command) {
      case "next":
        return this.renderButton(label, "pf-m-primary", command.command);
      case "back":
        return this.renderButton(label, "pf-m-secondary", command.command);
      case "close":
        return this.renderLink(label, "pf-m-link");
      default:
        throw new Error(`Button type not understood: ${command} for ${label}`);
    }
  }
  renderButton(label, classname, command) {
    const buttonClasses = { "pf-c-button": true, [classname]: true };
    return x`<button
            class=${e2(buttonClasses)}
            type="button"
            @click=${() => {
      this.dispatchCustomEvent("ak-wizard-nav", { command });
    }}
        >
            ${label}
        </button>`;
  }
  renderLink(label, classname) {
    const buttonClasses = { "pf-c-button": true, [classname]: true };
    return x`<div class="pf-c-wizard__footer-cancel">
            <button
                class=${e2(buttonClasses)}
                type="button"
                @click=${() => this.dispatchCustomEvent("ak-wizard-nav", { command: "close" })}
            >
                ${label}
            </button>
        </div>`;
  }
};
__decorateClass([
  n()
], AkWizardFrame.prototype, "header", 2);
__decorateClass([
  n()
], AkWizardFrame.prototype, "description", 2);
__decorateClass([
  n({ attribute: false, type: Array })
], AkWizardFrame.prototype, "stepLabels", 2);
__decorateClass([
  n({ attribute: false, type: Array })
], AkWizardFrame.prototype, "buttons", 2);
__decorateClass([
  n({ type: Boolean, attribute: "can-cancel" })
], AkWizardFrame.prototype, "canCancel", 2);
__decorateClass([
  n({ type: Object })
], AkWizardFrame.prototype, "form", 2);
__decorateClass([
  e("#main-content *:first-child")
], AkWizardFrame.prototype, "content", 2);
AkWizardFrame = __decorateClass([
  t("ak-wizard-frame")
], AkWizardFrame);

// src/components/ak-wizard-main/AkWizardController.ts
var isCustomEvent = (v) => v instanceof CustomEvent && "detail" in v;
var isNavEvent = (v) => isCustomEvent(v) && "command" in v.detail;
var AkWizardController = class {
  constructor(host) {
    this.host = host;
    this.handleNavRequest = this.handleNavRequest.bind(this);
    this.handleUpdateRequest = this.handleUpdateRequest.bind(this);
    host.addController(this);
  }
  get maxStep() {
    return this.host.steps.length - 1;
  }
  get nextStep() {
    return this.host.currentStep < this.maxStep ? this.host.currentStep + 1 : void 0;
  }
  get backStep() {
    return this.host.currentStep > 0 ? this.host.currentStep - 1 : void 0;
  }
  get step() {
    return this.host.steps[this.host.currentStep];
  }
  hostConnected() {
    this.host.addEventListener("ak-wizard-nav", this.handleNavRequest);
    this.host.addEventListener("ak-wizard-update", this.handleUpdateRequest);
    this.host.addEventListener("ak-wizard-closed", this.handleCloseRequest);
  }
  hostDisconnected() {
    this.host.removeEventListener("ak-wizard-nav", this.handleNavRequest);
    this.host.removeEventListener("ak-wizard-update", this.handleUpdateRequest);
    this.host.removeEventListener("ak-wizard-closed", this.handleCloseRequest);
  }
  handleNavRequest(event) {
    if (!isNavEvent(event)) {
      throw new Error(`Unexpected event received by nav handler: ${event}`);
    }
    if (event.detail.command === "close") {
      this.host.close();
      return;
    }
    const navigate = () => {
      switch (event.detail.command) {
        case "next":
          return this.nextStep;
        case "back":
          return this.backStep;
        case "goto":
          return event.detail.step;
        default:
          throw new Error(
            `Unrecognized command passed to ak-wizard-controller:handleNavRequest: ${event.detail.command}`
          );
      }
    };
    this.host.handleNav(navigate());
  }
  handleUpdateRequest(event) {
    if (!isCustomEvent(event)) {
      throw new Error(`Unexpected event received by nav handler: ${event}`);
    }
    this.host.handleUpdate(event.detail);
  }
  handleCloseRequest() {
    this.host.close();
  }
};

// src/components/ak-wizard-main/AkWizard.ts
var AkWizard = class extends AKElement {
  constructor(prompt, header, description) {
    super();
    this.steps = [];
    this.currentStep = 0;
    /**
     * A reference to the frame.  Since the frame implements and inherits from ModalButton,
     * you will need either a reference to or query to the frame in order to call
     * `.close()` on it.
     */
    this.frame = e3();
    this.prompt = msg("Create");
    this.header = header;
    this.prompt = prompt;
    this.description = description;
    this.wizard = new AkWizardController(this);
  }
  // prettier-ignore
  static get styles() {
    return [patternfly_base_default, button_default];
  }
  get step() {
    return this.steps[this.currentStep];
  }
  /**
   * Derive the labels used by the frame's Breadcrumbs display.
   */
  get stepLabels() {
    let disabled = false;
    return this.steps.map((step, index) => {
      disabled = disabled || step.disabled;
      return {
        label: step.label,
        active: index === this.currentStep,
        index,
        disabled
      };
    });
  }
  /**
   * You should still consider overriding this if you need to consider details like "Is the step
   * requested valid?"
   */
  handleNav(stepId) {
    if (stepId === void 0 || this.steps[stepId] === void 0) {
      throw new Error(`Attempt to navigate to undefined step: ${stepId}`);
    }
    this.currentStep = stepId;
    this.requestUpdate();
  }
  close() {
    throw new Error("This function must be overridden in the child class.");
  }
  /**
   * This is where all the business logic and special cases go. The Wizard Controller intercepts
   * updates tagged `ak-wizard-update` and forwards the event content here. Business logic about
   * "is the current step valid?" and "should the Next button be made enabled" are controlled
   * here. (Any step implementing WizardStep can do it anyhow it pleases, putting "is the current
   * form valid" and so forth into the step object itself.)
   */
  handleUpdate(_detail) {
    throw new Error("This function must be overridden in the child class.");
  }
  render() {
    return x`
            <ak-wizard-frame
                ${n3(this.frame)}
                header=${this.header}
                description=${o(this.description)}
                prompt=${this.prompt}
                .buttons=${this.step.buttons}
                .stepLabels=${this.stepLabels}
                .form=${this.step.render.bind(this.step)}
            >
                <button slot="trigger" class="pf-c-button pf-m-primary">${this.prompt}</button>
            </ak-wizard-frame>
        `;
  }
};
__decorateClass([
  r()
], AkWizard.prototype, "steps", 2);
__decorateClass([
  r()
], AkWizard.prototype, "currentStep", 2);

// src/admin/applications/wizard/ContextIdentity.ts
var applicationWizardContext = n2(
  Symbol("ak-application-wizard-state-context")
);

// src/components/ak-wizard-main/commonWizardButtons.ts
var NextStep = [msg("Next"), { command: "next" }];
var BackStep = [msg("Back"), { command: "back" }];
var SubmitStep = [msg("Submit"), { command: "next" }];
var CancelWizard = [msg("Cancel"), { command: "close" }];
var CloseWizard = [msg("Close"), { command: "close" }];
var DisabledNextStep = [msg("Next"), { command: "next" }, true];

// src/components/ak-slug-input.ts
var AkSlugInput = class extends HorizontalLightComponent {
  constructor() {
    super();
    this.value = "";
    this.source = "";
    this.touched = false;
    this.slugify = this.slugify.bind(this);
    this.handleTouch = this.handleTouch.bind(this);
  }
  firstUpdated() {
    this.input.addEventListener("input", this.handleTouch);
  }
  // Do not stop propagation of this event; it must be sent up the tree so that a parent
  // component, such as a custom forms manager, may receive it.
  handleTouch(ev) {
    this.input.value = convertToSlug(this.input.value);
    this.value = this.input.value;
    if (this.origin && this.origin.value === "" && this.input.value === "") {
      this.touched = false;
      return;
    }
    if (ev && ev.target && ev.target instanceof HTMLInputElement) {
      this.touched = true;
    }
  }
  slugify(ev) {
    if (!(ev && ev.target && ev.target instanceof HTMLInputElement)) {
      return;
    }
    if (ev.target.value === "" && this.input.value === "") {
      this.touched = false;
    }
    if (this.touched) {
      return;
    }
    const newSlug = convertToSlug(ev.target.value);
    const oldSlug = this.input.value;
    const [shorter, longer] = newSlug.length < oldSlug.length ? [newSlug, oldSlug] : [oldSlug, newSlug];
    if (longer.substring(0, shorter.length) !== shorter) {
      return;
    }
    this.value = this.input.value = newSlug;
    this.dispatchEvent(
      new Event("input", {
        bubbles: true,
        cancelable: true
      })
    );
  }
  connectedCallback() {
    super.connectedCallback();
    setTimeout(() => {
      if (this.source) {
        const rootNode = this.getRootNode();
        if (rootNode instanceof ShadowRoot || rootNode instanceof Document) {
          this.origin = rootNode.querySelector(this.source);
        }
        if (this.origin) {
          this.origin.addEventListener("input", this.slugify);
        }
      }
    }, 0);
  }
  disconnectedCallback() {
    if (this.origin) {
      this.origin.removeEventListener("input", this.slugify);
    }
    super.disconnectedCallback();
  }
  renderControl() {
    return x`<input
            type="text"
            value=${o(this.value)}
            class="pf-c-form-control"
            ?required=${this.required}
        />`;
  }
};
__decorateClass([
  n({ type: String, reflect: true })
], AkSlugInput.prototype, "value", 2);
__decorateClass([
  n({ type: String })
], AkSlugInput.prototype, "source", 2);
__decorateClass([
  e("input")
], AkSlugInput.prototype, "input", 2);
AkSlugInput = __decorateClass([
  t("ak-slug-input")
], AkSlugInput);

// src/admin/applications/wizard/BasePanel.css.ts
var styles = [
  patternfly_base_default,
  card_default,
  button_default,
  form_default,
  alert_default,
  radio_default,
  input_group_default,
  form_control_default,
  switch_default,
  i`
        select[multiple] {
            height: 15em;
        }
    `
];

// src/admin/applications/wizard/BasePanel.ts
var ApplicationWizardPageBase = class extends CustomEmitterElement(AKElement) {
  constructor() {
    super(...arguments);
    this.rendered = false;
  }
  static get styles() {
    return styles;
  }
  /**
   * Provide access to the values on the current form. Child implementations use this to craft the
   * update that will be sent using `dispatchWizardUpdate` below.
   */
  get formValues() {
    const elements = [
      ...Array.from(
        this.form.querySelectorAll("ak-form-element-horizontal")
      ),
      ...Array.from(this.form.querySelectorAll("[data-ak-control=true]"))
    ];
    return serializeForm(elements);
  }
  /**
   * Provide access to the validity of the current form. Child implementations use this to craft
   * the update that will be sent using `dispatchWizardUpdate` below.
   */
  get valid() {
    return this.form.checkValidity();
  }
  /**
   * Provide a single source of truth for the token used to notify the orchestrator that an event
   * happens. The token `ak-wizard-update` is used by the Wizard framework's reactive controller
   * to route "data on the current step has changed" events to the orchestrator.
   */
  dispatchWizardUpdate(update) {
    this.dispatchCustomEvent("ak-wizard-update", update);
  }
};
__decorateClass([
  c({ context: applicationWizardContext })
], ApplicationWizardPageBase.prototype, "wizard", 2);
__decorateClass([
  e("form")
], ApplicationWizardPageBase.prototype, "form", 2);
var BasePanel_default = ApplicationWizardPageBase;

// src/admin/applications/wizard/application/ak-application-wizard-application-details.ts
var ApplicationWizardApplicationDetails = class extends BasePanel_default {
  handleChange(_ev) {
    const formValues = this.formValues;
    if (!formValues) {
      throw new Error("No application values on form?");
    }
    this.dispatchWizardUpdate({
      update: {
        ...this.wizard,
        app: formValues
      },
      status: this.valid ? "valid" : "invalid"
    });
  }
  render() {
    return x` <form class="pf-c-form pf-m-horizontal" @input=${this.handleChange}>
            <ak-text-input
                name="name"
                value=${o(this.wizard.app?.name)}
                label=${msg("Name")}
                required
                help=${msg("Application's display Name.")}
                id="ak-application-wizard-details-name"
                .errorMessages=${this.wizard.errors.app?.name ?? []}
            ></ak-text-input>
            <ak-slug-input
                name="slug"
                value=${o(this.wizard.app?.slug)}
                label=${msg("Slug")}
                source="#ak-application-wizard-details-name"
                required
                help=${msg("Internal application name used in URLs.")}
                .errorMessages=${this.wizard.errors.app?.slug ?? []}
            ></ak-slug-input>
            <ak-text-input
                name="group"
                value=${o(this.wizard.app?.group)}
                label=${msg("Group")}
                .errorMessages=${this.wizard.errors.app?.group ?? []}
                help=${msg(
      "Optionally enter a group name. Applications with identical groups are shown grouped together."
    )}
            ></ak-text-input>
            <ak-radio-input
                label=${msg("Policy engine mode")}
                required
                name="policyEngineMode"
                .options=${policyOptions}
                .value=${this.wizard.app?.policyEngineMode}
                .errorMessages=${this.wizard.errors.app?.policyEngineMode ?? []}
            ></ak-radio-input>
            <ak-form-group aria-label="UI Settings">
                <span slot="header"> ${msg("UI Settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-text-input
                        name="metaLaunchUrl"
                        label=${msg("Launch URL")}
                        value=${o(this.wizard.app?.metaLaunchUrl)}
                        help=${msg(
      "If left empty, authentik will try to extract the launch URL based on the selected provider."
    )}
                        .errorMessages=${this.wizard.errors.app?.metaLaunchUrl ?? []}
                    ></ak-text-input>
                    <ak-switch-input
                        name="openInNewTab"
                        ?checked=${first(this.wizard.app?.openInNewTab, false)}
                        label=${msg("Open in new tab")}
                        help=${msg(
      "If checked, the launch URL will open in a new browser tab or window from the user's application library."
    )}
                    >
                    </ak-switch-input>
                </div>
            </ak-form-group>
        </form>`;
  }
};
ApplicationWizardApplicationDetails = __decorateClass([
  t("ak-application-wizard-application-details")
], ApplicationWizardApplicationDetails);

// src/admin/applications/wizard/auth-method-choice/ak-application-wizard-authentication-method-choice.choices.ts
var _providerModelsTable = [
  [
    "oauth2provider",
    msg("OAuth2/OIDC (Open Authorization/OpenID Connect)"),
    msg("Modern applications, APIs and Single-page applications."),
    () => x`<ak-application-wizard-authentication-by-oauth></ak-application-wizard-authentication-by-oauth>`,
    ProviderModelEnum.Oauth2Oauth2provider,
    (provider) => ({
      providerModel: ProviderModelEnum.Oauth2Oauth2provider,
      ...provider
    })
  ],
  [
    "ldapprovider",
    msg("LDAP (Lightweight Directory Access Protocol)"),
    msg("Provide an LDAP interface for applications and users to authenticate against."),
    () => x`<ak-application-wizard-authentication-by-ldap></ak-application-wizard-authentication-by-ldap>`,
    ProviderModelEnum.LdapLdapprovider,
    (provider) => ({
      providerModel: ProviderModelEnum.LdapLdapprovider,
      ...provider
    })
  ],
  [
    "proxyprovider-proxy",
    msg("Transparent Reverse Proxy"),
    msg("For transparent reverse proxies with required authentication"),
    () => x`<ak-application-wizard-authentication-for-reverse-proxy></ak-application-wizard-authentication-for-reverse-proxy>`,
    ProviderModelEnum.ProxyProxyprovider,
    (provider) => ({
      providerModel: ProviderModelEnum.ProxyProxyprovider,
      ...provider,
      mode: ProxyMode.Proxy
    })
  ],
  [
    "proxyprovider-forwardsingle",
    msg("Forward Auth (Single Application)"),
    msg("For nginx's auth_request or traefik's forwardAuth"),
    () => x`<ak-application-wizard-authentication-for-single-forward-proxy></ak-application-wizard-authentication-for-single-forward-proxy>`,
    ProviderModelEnum.ProxyProxyprovider,
    (provider) => ({
      providerModel: ProviderModelEnum.ProxyProxyprovider,
      ...provider,
      mode: ProxyMode.ForwardSingle
    })
  ],
  [
    "proxyprovider-forwarddomain",
    msg("Forward Auth (Domain Level)"),
    msg("For nginx's auth_request or traefik's forwardAuth per root domain"),
    () => x`<ak-application-wizard-authentication-for-forward-proxy-domain></ak-application-wizard-authentication-for-forward-proxy-domain>`,
    ProviderModelEnum.ProxyProxyprovider,
    (provider) => ({
      providerModel: ProviderModelEnum.ProxyProxyprovider,
      ...provider,
      mode: ProxyMode.ForwardDomain
    })
  ],
  [
    "racprovider",
    msg("Remote Access Provider"),
    msg("Remotely access computers/servers via RDP/SSH/VNC"),
    () => x`<ak-application-wizard-authentication-for-rac></ak-application-wizard-authentication-for-rac>`,
    ProviderModelEnum.RacRacprovider,
    (provider) => ({
      providerModel: ProviderModelEnum.RacRacprovider,
      ...provider
    }),
    () => x`<ak-license-notice></ak-license-notice>`
  ],
  [
    "samlprovider",
    msg("SAML (Security Assertion Markup Language)"),
    msg("Configure SAML provider manually"),
    () => x`<ak-application-wizard-authentication-by-saml-configuration></ak-application-wizard-authentication-by-saml-configuration>`,
    ProviderModelEnum.SamlSamlprovider,
    (provider) => ({
      providerModel: ProviderModelEnum.SamlSamlprovider,
      ...provider
    })
  ],
  [
    "radiusprovider",
    msg("RADIUS (Remote Authentication Dial-In User Service)"),
    msg("Configure RADIUS provider manually"),
    () => x`<ak-application-wizard-authentication-by-radius></ak-application-wizard-authentication-by-radius>`,
    ProviderModelEnum.RadiusRadiusprovider,
    (provider) => ({
      providerModel: ProviderModelEnum.RadiusRadiusprovider,
      ...provider
    })
  ],
  [
    "scimprovider",
    msg("SCIM (System for Cross-domain Identity Management)"),
    msg("Configure SCIM provider manually"),
    () => x`<ak-application-wizard-authentication-by-scim></ak-application-wizard-authentication-by-scim>`,
    ProviderModelEnum.ScimScimprovider,
    (provider) => ({
      providerModel: ProviderModelEnum.ScimScimprovider,
      ...provider
    })
  ]
];
function mapProviders([
  formName,
  name,
  description,
  _,
  modelName,
  converter,
  note
]) {
  return {
    formName,
    name,
    description,
    component: "",
    modelName,
    converter,
    note
  };
}
var providerModelsList = _providerModelsTable.map(mapProviders);
var providerRendererList = new Map(
  _providerModelsTable.map(([modelName, _0, _1, renderer]) => [modelName, renderer])
);
var ak_application_wizard_authentication_method_choice_choices_default = providerModelsList;

// src/admin/applications/wizard/auth-method-choice/ak-application-wizard-authentication-method-choice.ts
var ApplicationWizardAuthenticationMethodChoice = class extends WithLicenseSummary(BasePanel_default) {
  constructor() {
    super();
    this.handleChoice = this.handleChoice.bind(this);
    this.renderProvider = this.renderProvider.bind(this);
  }
  handleChoice(ev) {
    const target = ev.target;
    this.dispatchWizardUpdate({
      update: {
        ...this.wizard,
        providerModel: target.value,
        errors: {}
      },
      status: this.valid ? "valid" : "invalid"
    });
  }
  renderProvider(type) {
    const method = this.wizard.providerModel;
    return x`<div class="pf-c-radio">
            <input
                class="pf-c-radio__input"
                type="radio"
                name="type"
                id="provider-${type.formName}"
                ?disabled=${type.formName === "racprovider" && !this.hasEnterpriseLicense}
                value=${type.formName}
                ?checked=${type.formName === method}
                @change=${this.handleChoice}
            />
            <label class="pf-c-radio__label" for="provider-${type.formName}">${type.name}</label>
            <span class="pf-c-radio__description"
                >${type.description}${type.note ? type.note() : T}</span
            >
        </div>`;
  }
  render() {
    return ak_application_wizard_authentication_method_choice_choices_default.length > 0 ? x`<form class="pf-c-form pf-m-horizontal">
                  ${o2(ak_application_wizard_authentication_method_choice_choices_default, this.renderProvider)}
              </form>` : x`<ak-empty-state loading header=${msg("Loading")}></ak-empty-state>`;
  }
};
ApplicationWizardAuthenticationMethodChoice = __decorateClass([
  t("ak-application-wizard-authentication-method-choice")
], ApplicationWizardAuthenticationMethodChoice);

// src/admin/applications/wizard/commit/ak-application-wizard-commit-application.ts
function cleanApplication(app) {
  return {
    name: "",
    slug: "",
    ...app
  };
}
var idleState = {
  state: "idle",
  label: "",
  icon: ["fa-cogs", "pf-m-pending"]
};
var runningState = {
  state: "running",
  label: msg("Saving Application..."),
  icon: ["fa-cogs", "pf-m-info"]
};
var errorState = {
  state: "error",
  label: msg("Authentik was unable to save this application:"),
  icon: ["fa-times-circle", "pf-m-danger"]
};
var successState = {
  state: "success",
  label: msg("Your application has been saved"),
  icon: ["fa-check-circle", "pf-m-success"]
};
var ApplicationWizardCommitApplication = class extends BasePanel_default {
  constructor() {
    super(...arguments);
    this.commitState = idleState;
  }
  static get styles() {
    return [
      ...super.styles,
      bullseye_default,
      empty_state_default,
      title_default,
      progress_stepper_default,
      i`
                .pf-c-title {
                    padding-bottom: var(--pf-global--spacer--md);
                }
            `
    ];
  }
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  willUpdate(_changedProperties) {
    if (this.commitState === idleState) {
      this.response = void 0;
      this.commitState = runningState;
      const providerModel = ak_application_wizard_authentication_method_choice_choices_default.find(
        ({ formName }) => formName === this.wizard.providerModel
      );
      if (!providerModel) {
        throw new Error(
          `Could not determine provider model from user request: ${JSON.stringify(
            this.wizard,
            null,
            2
          )}`
        );
      }
      const request = {
        providerModel: providerModel.modelName,
        app: cleanApplication(this.wizard.app),
        provider: providerModel.converter(this.wizard.provider)
      };
      this.send(request);
      return;
    }
  }
  async send(data) {
    this.errors = void 0;
    new CoreApi(DEFAULT_CONFIG).coreTransactionalApplicationsUpdate({
      transactionApplicationRequest: data
    }).then((response) => {
      this.response = response;
      this.dispatchCustomEvent(EVENT_REFRESH);
      this.dispatchWizardUpdate({ status: "submitted" });
      this.commitState = successState;
    }).catch(async (resolution) => {
      const errors = this.errors = ValidationErrorFromJSON(
        await resolution.response.json()
      );
      this.dispatchWizardUpdate({
        update: {
          ...this.wizard,
          errors
        },
        status: "failed"
      });
      this.commitState = errorState;
    });
  }
  renderErrors(errors) {
    if (!errors) {
      return T;
    }
    const navTo = (step) => () => this.dispatchCustomEvent("ak-wizard-nav", {
      command: "goto",
      step
    });
    if (errors.app) {
      return x`<p>${msg("There was an error in the application.")}</p>
                <p><a @click=${navTo(0)}>${msg("Review the application.")}</a></p>`;
    }
    if (errors.provider) {
      return x`<p>${msg("There was an error in the provider.")}</p>
                <p><a @click=${navTo(2)}>${msg("Review the provider.")}</a></p>`;
    }
    if (errors.detail) {
      return x`<p>${msg("There was an error")}: ${errors.detail}</p>`;
    }
    if ((errors?.nonFieldErrors ?? []).length > 0) {
      return x`<p>$(msg("There was an error")}:</p>
                <ul>
                    ${(errors.nonFieldErrors ?? []).map((e4) => x`<li>${e4}</li>`)}
                </ul>`;
    }
    return x`<p>
            ${msg(
      "There was an error creating the application, but no error message was sent. Please review the server logs."
    )}
        </p>`;
  }
  render() {
    const icon = e2(
      this.commitState.icon.reduce((acc, icon2) => ({ ...acc, [icon2]: true }), {})
    );
    return x`
            <div>
                <div class="pf-l-bullseye">
                    <div class="pf-c-empty-state pf-m-lg">
                        <div class="pf-c-empty-state__content">
                            <i
                                class="fas fa- ${icon} pf-c-empty-state__icon"
                                aria-hidden="true"
                            ></i>
                            <h1
                                data-commit-state=${this.commitState.state}
                                class="pf-c-title pf-m-lg"
                            >
                                ${this.commitState.label}
                            </h1>
                            ${this.renderErrors(this.errors)}
                        </div>
                    </div>
                </div>
            </div>
        `;
  }
};
__decorateClass([
  r()
], ApplicationWizardCommitApplication.prototype, "commitState", 2);
__decorateClass([
  r()
], ApplicationWizardCommitApplication.prototype, "errors", 2);
ApplicationWizardCommitApplication = __decorateClass([
  t("ak-application-wizard-commit-application")
], ApplicationWizardCommitApplication);

// src/admin/applications/wizard/ak-wizard-title.ts
var AkWizardTitle = class extends AKElement {
  static get styles() {
    return [
      content_default,
      title_default,
      i`
                .ak-bottom-spacing {
                    padding-bottom: var(--pf-global--spacer--lg);
                }
            `
    ];
  }
  render() {
    return x`<div class="ak-bottom-spacing pf-c-content">
            <h3><slot></slot></h3>
        </div>`;
  }
};
AkWizardTitle = __decorateClass([
  t("ak-wizard-title")
], AkWizardTitle);

// src/admin/common/ak-core-group-search.ts
async function fetchObjects(query) {
  const args = {
    ordering: "name"
  };
  if (query !== void 0) {
    args.search = query;
  }
  const groups = await new CoreApi(DEFAULT_CONFIG).coreGroupsList(args);
  return groups.results;
}
var renderElement = (group) => group.name;
var renderValue = (group) => group?.pk;
var CoreGroupSearch = class extends CustomListenerElement(AKElement) {
  constructor() {
    super();
    this.selected = this.selected.bind(this);
    this.handleSearchUpdate = this.handleSearchUpdate.bind(this);
  }
  get value() {
    return this.selectedGroup ? renderValue(this.selectedGroup) : void 0;
  }
  connectedCallback() {
    super.connectedCallback();
    const horizontalContainer = this.closest("ak-form-element-horizontal[name]");
    if (!horizontalContainer) {
      throw new Error("This search can only be used in a named ak-form-element-horizontal");
    }
    const name = horizontalContainer.getAttribute("name");
    const myName = this.getAttribute("name");
    if (name !== null && name !== myName) {
      this.setAttribute("name", name);
    }
  }
  handleSearchUpdate(ev) {
    ev.stopPropagation();
    this.selectedGroup = ev.detail.value;
    this.dispatchEvent(new InputEvent("input", { bubbles: true, composed: true }));
  }
  selected(group) {
    return this.group === group.pk;
  }
  render() {
    return x`
            <ak-search-select
                .fetchObjects=${fetchObjects}
                .renderElement=${renderElement}
                .value=${renderValue}
                .selected=${this.selected}
                @ak-change=${this.handleSearchUpdate}
                ?blankable=${true}
            >
            </ak-search-select>
        `;
  }
};
__decorateClass([
  n({ type: String, reflect: true })
], CoreGroupSearch.prototype, "group", 2);
__decorateClass([
  e("ak-search-select")
], CoreGroupSearch.prototype, "search", 2);
__decorateClass([
  n({ type: String })
], CoreGroupSearch.prototype, "name", 2);
CoreGroupSearch = __decorateClass([
  t("ak-core-group-search")
], CoreGroupSearch);

// src/admin/applications/wizard/methods/BaseProviderPanel.ts
var ApplicationWizardProviderPageBase = class extends BasePanel_default {
  handleChange(_ev) {
    const formValues = this.formValues;
    if (!formValues) {
      throw new Error("No provider values on form?");
    }
    this.dispatchWizardUpdate({
      update: {
        ...this.wizard,
        provider: formValues
      },
      status: this.valid ? "valid" : "invalid"
    });
  }
};
var BaseProviderPanel_default = ApplicationWizardProviderPageBase;

// src/admin/applications/wizard/methods/ldap/LDAPOptionsAndHelp.ts
var bindModeOptions = [
  {
    label: msg("Cached binding"),
    value: LDAPAPIAccessMode.Cached,
    default: true,
    description: x`${msg(
      "Flow is executed and session is cached in memory. Flow is executed when session expires"
    )}`
  },
  {
    label: msg("Direct binding"),
    value: LDAPAPIAccessMode.Direct,
    description: x`${msg(
      "Always execute the configured bind flow to authenticate the user"
    )}`
  }
];
var searchModeOptions = [
  {
    label: msg("Cached querying"),
    value: LDAPAPIAccessMode.Cached,
    default: true,
    description: x`${msg(
      "The outpost holds all users and groups in-memory and will refresh every 5 Minutes"
    )}`
  },
  {
    label: msg("Direct querying"),
    value: LDAPAPIAccessMode.Direct,
    description: x`${msg(
      "Always returns the latest data, but slower than cached querying"
    )}`
  }
];
var mfaSupportHelp = msg(
  "When enabled, code-based multi-factor authentication can be used by appending a semicolon and the TOTP code to the password. This should only be enabled if all users that will bind to this provider have a TOTP device configured, as otherwise a password may incorrectly be rejected if it contains a semicolon."
);
var groupHelp = msg(
  "The start for gidNumbers, this number is added to a number generated from the group.Pk to make sure that the numbers aren't too low for POSIX groups. Default is 4000 to ensure that we don't collide with local groups or users primary groups gidNumber"
);
var cryptoCertificateHelp = msg(
  "The certificate for the above configured Base DN. As a fallback, the provider uses a self-signed certificate."
);
var tlsServerNameHelp = msg(
  "DNS name for which the above configured certificate should be used. The certificate cannot be detected based on the base DN, as the SSL/TLS negotiation happens before such data is exchanged."
);
var uidStartNumberHelp = msg(
  "The start for uidNumbers, this number is added to the user.Pk to make sure that the numbers aren't too low for POSIX users. Default is 2000 to ensure that we don't collide with local users uidNumber"
);
var gidStartNumberHelp = msg(
  "The start for gidNumbers, this number is added to a number generated from the group.Pk to make sure that the numbers aren't too low for POSIX groups. Default is 4000 to ensure that we don't collide with local groups or users primary groups gidNumber"
);

// src/admin/applications/wizard/methods/ldap/ak-application-wizard-authentication-by-ldap.ts
var ApplicationWizardApplicationDetails2 = class extends WithBrandConfig(BaseProviderPanel_default) {
  render() {
    const provider = this.wizard.provider;
    const errors = this.wizard.errors.provider;
    return x` <ak-wizard-title>${msg("Configure LDAP Provider")}</ak-wizard-title>
            <form class="pf-c-form pf-m-horizontal" @input=${this.handleChange}>
                <ak-text-input
                    name="name"
                    value=${o(provider?.name)}
                    label=${msg("Name")}
                    .errorMessages=${errors?.name ?? []}
                    required
                    help=${msg("Method's display Name.")}
                ></ak-text-input>

                <ak-form-element-horizontal
                    label=${msg("Bind flow")}
                    ?required=${true}
                    name="authorizationFlow"
                    .errorMessages=${errors?.authorizationFlow ?? []}
                >
                    <ak-branded-flow-search
                        flowType=${FlowsInstancesListDesignationEnum.Authentication}
                        .currentFlow=${provider?.authorizationFlow}
                        .brandFlow=${this.brand.flowAuthentication}
                        required
                    ></ak-branded-flow-search>
                    <p class="pf-c-form__helper-text">
                        ${msg("Flow used for users to authenticate.")}
                    </p>
                </ak-form-element-horizontal>

                <ak-form-element-horizontal
                    label=${msg("Search group")}
                    name="searchGroup"
                    .errorMessages=${errors?.searchGroup ?? []}
                >
                    <ak-core-group-search
                        name="searchGroup"
                        group=${o(provider?.searchGroup ?? T)}
                    ></ak-core-group-search>
                    <p class="pf-c-form__helper-text">${groupHelp}</p>
                </ak-form-element-horizontal>

                <ak-radio-input
                    label=${msg("Bind mode")}
                    name="bindMode"
                    .options=${bindModeOptions}
                    .value=${provider?.bindMode}
                    help=${msg("Configure how the outpost authenticates requests.")}
                >
                </ak-radio-input>

                <ak-radio-input
                    label=${msg("Search mode")}
                    name="searchMode"
                    .options=${searchModeOptions}
                    .value=${provider?.searchMode}
                    help=${msg(
      "Configure how the outpost queries the core authentik server's users."
    )}
                >
                </ak-radio-input>

                <ak-switch-input
                    name="openInNewTab"
                    label=${msg("Code-based MFA Support")}
                    ?checked=${provider?.mfaSupport ?? true}
                    help=${mfaSupportHelp}
                >
                </ak-switch-input>

                <ak-form-group .expanded=${true}>
                    <span slot="header"> ${msg("Protocol settings")} </span>
                    <div slot="body" class="pf-c-form">
                        <ak-text-input
                            name="baseDn"
                            label=${msg("Base DN")}
                            required
                            value="${first(provider?.baseDn, "DC=ldap,DC=goauthentik,DC=io")}"
                            .errorMessages=${errors?.baseDn ?? []}
                            help=${msg(
      "LDAP DN under which bind requests and search requests can be made."
    )}
                        >
                        </ak-text-input>

                        <ak-form-element-horizontal
                            label=${msg("Certificate")}
                            name="certificate"
                            .errorMessages=${errors?.certificate ?? []}
                        >
                            <ak-crypto-certificate-search
                                certificate=${o(provider?.certificate ?? T)}
                                name="certificate"
                            >
                            </ak-crypto-certificate-search>
                            <p class="pf-c-form__helper-text">${cryptoCertificateHelp}</p>
                        </ak-form-element-horizontal>

                        <ak-text-input
                            label=${msg("TLS Server name")}
                            name="tlsServerName"
                            value="${first(provider?.tlsServerName, "")}"
                            .errorMessages=${errors?.tlsServerName ?? []}
                            help=${tlsServerNameHelp}
                        ></ak-text-input>

                        <ak-number-input
                            label=${msg("UID start number")}
                            required
                            name="uidStartNumber"
                            value="${first(provider?.uidStartNumber, 2e3)}"
                            .errorMessages=${errors?.uidStartNumber ?? []}
                            help=${uidStartNumberHelp}
                        ></ak-number-input>

                        <ak-number-input
                            label=${msg("GID start number")}
                            required
                            name="gidStartNumber"
                            value="${first(provider?.gidStartNumber, 4e3)}"
                            .errorMessages=${errors?.gidStartNumber ?? []}
                            help=${gidStartNumberHelp}
                        ></ak-number-input>
                    </div>
                </ak-form-group>
            </form>`;
  }
};
ApplicationWizardApplicationDetails2 = __decorateClass([
  t("ak-application-wizard-authentication-by-ldap")
], ApplicationWizardApplicationDetails2);

// src/admin/applications/wizard/methods/oauth/ak-application-wizard-authentication-by-oauth.ts
var ApplicationWizardAuthenticationByOauth = class extends BaseProviderPanel_default {
  constructor() {
    super();
    this.showClientSecret = true;
    new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsScopeList({
      ordering: "scope_name"
    }).then((propertyMappings) => {
      this.propertyMappings = propertyMappings;
    });
    new SourcesApi(DEFAULT_CONFIG).sourcesOauthList({
      ordering: "name",
      hasJwks: true
    }).then((oauthSources) => {
      this.oauthSources = oauthSources;
    });
  }
  render() {
    const provider = this.wizard.provider;
    const errors = this.wizard.errors.provider;
    return x`<ak-wizard-title>${msg("Configure OAuth2/OpenId Provider")}</ak-wizard-title>
            <form class="pf-c-form pf-m-horizontal" @input=${this.handleChange}>
                <ak-text-input
                    name="name"
                    label=${msg("Name")}
                    value=${o(provider?.name)}
                    .errorMessages=${errors?.name ?? []}
                    required
                ></ak-text-input>

                <ak-form-element-horizontal
                    name="authenticationFlow"
                    label=${msg("Authentication flow")}
                    .errorMessages=${errors?.authenticationFlow ?? []}
                >
                    <ak-flow-search
                        flowType=${FlowsInstancesListDesignationEnum.Authentication}
                        .currentFlow=${provider?.authenticationFlow}
                        required
                    ></ak-flow-search>
                    <p class="pf-c-form__helper-text">
                        ${msg(
      "Flow used when a user access this provider and is not authenticated."
    )}
                    </p>
                </ak-form-element-horizontal>
                <ak-form-element-horizontal
                    name="authorizationFlow"
                    label=${msg("Authorization flow")}
                    .errorMessages=${errors?.authorizationFlow ?? []}
                    ?required=${true}
                >
                    <ak-flow-search
                        flowType=${FlowsInstancesListDesignationEnum.Authorization}
                        .currentFlow=${provider?.authorizationFlow}
                        required
                    ></ak-flow-search>
                    <p class="pf-c-form__helper-text">
                        ${msg("Flow used when authorizing this provider.")}
                    </p>
                </ak-form-element-horizontal>

                <ak-form-group .expanded=${true}>
                    <span slot="header"> ${msg("Protocol settings")} </span>
                    <div slot="body" class="pf-c-form">
                        <ak-radio-input
                            name="clientType"
                            label=${msg("Client type")}
                            .value=${provider?.clientType}
                            required
                            @change=${(ev) => {
      this.showClientSecret = ev.detail.value !== ClientTypeEnum.Public;
    }}
                            .options=${clientTypeOptions}
                        >
                        </ak-radio-input>

                        <ak-text-input
                            name="clientId"
                            label=${msg("Client ID")}
                            value=${provider?.clientId ?? randomString(40, ascii_letters + digits)}
                            .errorMessages=${errors?.clientId ?? []}
                            required
                        >
                        </ak-text-input>

                        <ak-text-input
                            name="clientSecret"
                            label=${msg("Client Secret")}
                            value=${provider?.clientSecret ?? randomString(128, ascii_letters + digits)}
                            .errorMessages=${errors?.clientSecret ?? []}
                            ?hidden=${!this.showClientSecret}
                        >
                        </ak-text-input>

                        <ak-textarea-input
                            name="redirectUris"
                            label=${msg("Redirect URIs/Origins (RegEx)")}
                            .value=${provider?.redirectUris}
                            .errorMessages=${errors?.redirectUriHelp ?? []}
                            .bighelp=${redirectUriHelp}
                        >
                        </ak-textarea-input>

                        <ak-form-element-horizontal
                            label=${msg("Signing Key")}
                            name="signingKey"
                            .errorMessages=${errors?.signingKey ?? []}
                        >
                            <ak-crypto-certificate-search
                                certificate=${o(provider?.signingKey ?? T)}
                                name="certificate"
                                singleton
                            >
                            </ak-crypto-certificate-search>
                            <p class="pf-c-form__helper-text">
                                ${msg("Key used to sign the tokens.")}
                            </p>
                        </ak-form-element-horizontal>
                    </div>
                </ak-form-group>

                <ak-form-group>
                    <span slot="header"> ${msg("Advanced protocol settings")} </span>
                    <div slot="body" class="pf-c-form">
                        <ak-text-input
                            name="accessCodeValidity"
                            label=${msg("Access code validity")}
                            required
                            value="${first(provider?.accessCodeValidity, "minutes=1")}"
                            .errorMessages=${errors?.accessCodeValidity ?? []}
                            .bighelp=${x`<p class="pf-c-form__helper-text">
                                    ${msg("Configure how long access codes are valid for.")}
                                </p>
                                <ak-utils-time-delta-help></ak-utils-time-delta-help>`}
                        >
                        </ak-text-input>

                        <ak-text-input
                            name="accessTokenValidity"
                            label=${msg("Access Token validity")}
                            value="${first(provider?.accessTokenValidity, "minutes=5")}"
                            required
                            .errorMessages=${errors?.accessTokenValidity ?? []}
                            .bighelp=${x` <p class="pf-c-form__helper-text">
                                    ${msg("Configure how long access tokens are valid for.")}
                                </p>
                                <ak-utils-time-delta-help></ak-utils-time-delta-help>`}
                        >
                        </ak-text-input>

                        <ak-text-input
                            name="refreshTokenValidity"
                            label=${msg("Refresh Token validity")}
                            value="${first(provider?.refreshTokenValidity, "days=30")}"
                            .errorMessages=${errors?.refreshTokenValidity ?? []}
                            ?required=${true}
                            .bighelp=${x` <p class="pf-c-form__helper-text">
                                    ${msg("Configure how long refresh tokens are valid for.")}
                                </p>
                                <ak-utils-time-delta-help></ak-utils-time-delta-help>`}
                        >
                        </ak-text-input>

                        <ak-form-element-horizontal
                            label=${msg("Scopes")}
                            name="propertyMappings"
                            .errorMessages=${errors?.propertyMappings ?? []}
                        >
                            <select class="pf-c-form-control" multiple>
                                ${this.propertyMappings?.results.map((scope) => {
      let selected = false;
      if (!provider?.propertyMappings) {
        selected = scope.managed?.startsWith(
          "goauthentik.io/providers/oauth2/scope-"
        ) || false;
      } else {
        selected = Array.from(provider?.propertyMappings).some(
          (su) => {
            return su == scope.pk;
          }
        );
      }
      return x`<option
                                        value=${o(scope.pk)}
                                        ?selected=${selected}
                                    >
                                        ${scope.name}
                                    </option>`;
    })}
                            </select>
                            <p class="pf-c-form__helper-text">
                                ${msg(
      "Select which scopes can be used by the client. The client still has to specify the scope to access the data."
    )}
                            </p>
                            <p class="pf-c-form__helper-text">
                                ${msg("Hold control/command to select multiple items.")}
                            </p>
                        </ak-form-element-horizontal>

                        <ak-radio-input
                            name="subMode"
                            label=${msg("Subject mode")}
                            required
                            .options=${subjectModeOptions}
                            .value=${provider?.subMode}
                            help=${msg(
      "Configure what data should be used as unique User Identifier. For most cases, the default should be fine."
    )}
                        >
                        </ak-radio-input>
                        <ak-switch-input
                            name="includeClaimsInIdToken"
                            label=${msg("Include claims in id_token")}
                            ?checked=${first(provider?.includeClaimsInIdToken, true)}
                            help=${msg(
      "Include User claims from scopes in the id_token, for applications that don't access the userinfo endpoint."
    )}
                        ></ak-switch-input>
                        <ak-radio-input
                            name="issuerMode"
                            label=${msg("Issuer mode")}
                            required
                            .options=${issuerModeOptions}
                            .value=${provider?.issuerMode}
                            help=${msg(
      "Configure how the issuer field of the ID Token should be filled."
    )}
                        >
                        </ak-radio-input>
                    </div>
                </ak-form-group>

                <ak-form-group>
                    <span slot="header">${msg("Machine-to-Machine authentication settings")}</span>
                    <div slot="body" class="pf-c-form">
                        <ak-form-element-horizontal
                            label=${msg("Trusted OIDC Sources")}
                            name="jwksSources"
                            .errorMessages=${errors?.jwksSources ?? []}
                        >
                            <select class="pf-c-form-control" multiple>
                                ${this.oauthSources?.results.map((source) => {
      const selected = (provider?.jwksSources || []).some((su) => {
        return su == source.pk;
      });
      return x`<option value=${source.pk} ?selected=${selected}>
                                        ${source.name} (${source.slug})
                                    </option>`;
    })}
                            </select>
                            <p class="pf-c-form__helper-text">
                                ${msg(
      "JWTs signed by certificates configured in the selected sources can be used to authenticate to this provider."
    )}
                            </p>
                            <p class="pf-c-form__helper-text">
                                ${msg("Hold control/command to select multiple items.")}
                            </p>
                        </ak-form-element-horizontal>
                    </div>
                </ak-form-group>
            </form>`;
  }
};
__decorateClass([
  r()
], ApplicationWizardAuthenticationByOauth.prototype, "showClientSecret", 2);
__decorateClass([
  r()
], ApplicationWizardAuthenticationByOauth.prototype, "propertyMappings", 2);
__decorateClass([
  r()
], ApplicationWizardAuthenticationByOauth.prototype, "oauthSources", 2);
ApplicationWizardAuthenticationByOauth = __decorateClass([
  t("ak-application-wizard-authentication-by-oauth")
], ApplicationWizardAuthenticationByOauth);

// src/admin/applications/wizard/methods/proxy/AuthenticationByProxyPage.ts
var AkTypeProxyApplicationWizardPage = class extends BaseProviderPanel_default {
  constructor() {
    super();
    this.showHttpBasic = true;
    this.mode = ProxyMode.Proxy;
    new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsScopeList({ ordering: "scope_name" }).then((propertyMappings) => {
      this.propertyMappings = propertyMappings;
    });
    new SourcesApi(DEFAULT_CONFIG).sourcesOauthList({
      ordering: "name",
      hasJwks: true
    }).then((oauthSources) => {
      this.oauthSources = oauthSources;
    });
  }
  get instance() {
    return this.wizard.provider;
  }
  renderModeDescription() {
    return T;
  }
  renderProxyMode() {
    throw new Error("Must be implemented in a child class.");
  }
  renderHttpBasic() {
    return x`<ak-text-input
                name="basicAuthUserAttribute"
                label=${msg("HTTP-Basic Username Key")}
                value="${o(this.instance?.basicAuthUserAttribute)}"
                help=${msg(
      "User/Group Attribute used for the user part of the HTTP-Basic Header. If not set, the user's Email address is used."
    )}
            >
            </ak-text-input>

            <ak-text-input
                name="basicAuthPasswordAttribute"
                label=${msg("HTTP-Basic Password Key")}
                value="${o(this.instance?.basicAuthPasswordAttribute)}"
                help=${msg(
      "User/Group Attribute used for the password part of the HTTP-Basic Header."
    )}
            >
            </ak-text-input>`;
  }
  scopeMappingConfiguration(provider) {
    const propertyMappings = this.propertyMappings?.results ?? [];
    const defaultScopes = () => propertyMappings.filter((scope) => !(scope?.managed ?? "").startsWith("goauthentik.io/providers")).map((pm) => pm.pk);
    const configuredScopes = (providerMappings) => propertyMappings.map((scope) => scope.pk).filter((pk) => providerMappings.includes(pk));
    const scopeValues = provider?.propertyMappings ? configuredScopes(provider?.propertyMappings ?? []) : defaultScopes();
    const scopePairs = propertyMappings.map((scope) => [scope.pk, scope.name]);
    return { scopePairs, scopeValues };
  }
  render() {
    const errors = this.wizard.errors.provider;
    const { scopePairs, scopeValues } = this.scopeMappingConfiguration(this.instance);
    return x` <ak-wizard-title>${msg("Configure Proxy Provider")}</ak-wizard-title>
            <form class="pf-c-form pf-m-horizontal" @input=${this.handleChange}>
                ${this.renderModeDescription()}
                <ak-text-input
                    name="name"
                    value=${o(this.instance?.name)}
                    required
                    .errorMessages=${errors?.name ?? []}
                    label=${msg("Name")}
                ></ak-text-input>

                <ak-form-element-horizontal
                    label=${msg("Authentication flow")}
                    ?required=${false}
                    .errorMessages=${errors?.authenticationFlow ?? []}
                    name="authenticationFlow"
                >
                    <ak-flow-search
                        flowType=${FlowsInstancesListDesignationEnum.Authentication}
                        .currentFlow=${this.instance?.authenticationFlow}
                        required
                    ></ak-flow-search>
                    <p class="pf-c-form__helper-text">
                        ${msg(
      "Flow used when a user access this provider and is not authenticated."
    )}
                    </p>
                </ak-form-element-horizontal>

                <ak-form-element-horizontal
                    label=${msg("Authorization flow")}
                    ?required=${true}
                    name="authorizationFlow"
                    .errorMessages=${errors?.authorizationFlow ?? []}
                >
                    <ak-flow-search
                        flowType=${FlowsInstancesListDesignationEnum.Authorization}
                        .currentFlow=${this.instance?.authorizationFlow}
                        required
                    ></ak-flow-search>
                    <p class="pf-c-form__helper-text">
                        ${msg("Flow used when authorizing this provider.")}
                    </p>
                </ak-form-element-horizontal>

                ${this.renderProxyMode()}

                <ak-text-input
                    name="accessTokenValidity"
                    value=${first(this.instance?.accessTokenValidity, "hours=24")}
                    label=${msg("Token validity")}
                    help=${msg("Configure how long tokens are valid for.")}
                    .errorMessages=${errors?.accessTokenValidity ?? []}
                ></ak-text-input>

                <ak-form-group>
                    <span slot="header">${msg("Advanced protocol settings")}</span>
                    <div slot="body" class="pf-c-form">
                        <ak-form-element-horizontal
                            label=${msg("Certificate")}
                            name="certificate"
                            .errorMessages=${errors?.certificate ?? []}
                        >
                            <ak-crypto-certificate-search
                                certificate=${o(this.instance?.certificate ?? void 0)}
                            ></ak-crypto-certificate-search>
                        </ak-form-element-horizontal>

                        <ak-multi-select
                            label=${msg("AdditionalScopes")}
                            name="propertyMappings"
                            .options=${scopePairs}
                            .values=${scopeValues}
                            .errorMessages=${errors?.propertyMappings ?? []}
                            .richhelp=${x`
                                <p class="pf-c-form__helper-text">
                                    ${msg(
      "Additional scope mappings, which are passed to the proxy."
    )}
                                </p>
                                <p class="pf-c-form__helper-text">
                                    ${msg("Hold control/command to select multiple items.")}
                                </p>
                            `}
                        ></ak-multi-select>

                        <ak-textarea-input
                            name="skipPathRegex"
                            label=${this.mode === ProxyMode.ForwardDomain ? msg("Unauthenticated URLs") : msg("Unauthenticated Paths")}
                            value=${o(this.instance?.skipPathRegex)}
                            .errorMessages=${errors?.skipPathRegex ?? []}
                            .bighelp=${x` <p class="pf-c-form__helper-text">
                                    ${msg(
      "Regular expressions for which authentication is not required. Each new line is interpreted as a new expression."
    )}
                                </p>
                                <p class="pf-c-form__helper-text">
                                    ${msg(
      "When using proxy or forward auth (single application) mode, the requested URL Path is checked against the regular expressions. When using forward auth (domain mode), the full requested URL including scheme and host is matched against the regular expressions."
    )}
                                </p>`}
                        >
                        </ak-textarea-input>
                    </div>
                </ak-form-group>
                <ak-form-group>
                    <span slot="header">${msg("Authentication settings")}</span>
                    <div slot="body" class="pf-c-form">
                        <ak-switch-input
                            name="interceptHeaderAuth"
                            ?checked=${first(this.instance?.interceptHeaderAuth, true)}
                            label=${msg("Intercept header authentication")}
                            help=${msg(
      "When enabled, authentik will intercept the Authorization header to authenticate the request."
    )}
                        ></ak-switch-input>

                        <ak-switch-input
                            name="basicAuthEnabled"
                            ?checked=${first(this.instance?.basicAuthEnabled, false)}
                            @change=${(ev) => {
      const el = ev.target;
      this.showHttpBasic = el.checked;
    }}
                            label=${msg("Send HTTP-Basic Authentication")}
                            help=${msg(
      "Send a custom HTTP-Basic Authentication header based on values from authentik."
    )}
                        ></ak-switch-input>

                        ${this.showHttpBasic ? this.renderHttpBasic() : x``}

                        <ak-form-element-horizontal
                            label=${msg("Trusted OIDC Sources")}
                            name="jwksSources"
                            .errorMessages=${errors?.jwksSources ?? []}
                        >
                            <select class="pf-c-form-control" multiple>
                                ${this.oauthSources?.results.map((source) => {
      const selected = (this.instance?.jwksSources || []).some(
        (su) => {
          return su == source.pk;
        }
      );
      return x`<option value=${source.pk} ?selected=${selected}>
                                        ${source.name} (${source.slug})
                                    </option>`;
    })}
                            </select>
                            <p class="pf-c-form__helper-text">
                                ${msg(
      "JWTs signed by certificates configured in the selected sources can be used to authenticate to this provider."
    )}
                            </p>
                            <p class="pf-c-form__helper-text">
                                ${msg("Hold control/command to select multiple items.")}
                            </p>
                        </ak-form-element-horizontal>
                    </div>
                </ak-form-group>
            </form>`;
  }
};
__decorateClass([
  r()
], AkTypeProxyApplicationWizardPage.prototype, "showHttpBasic", 2);
__decorateClass([
  r()
], AkTypeProxyApplicationWizardPage.prototype, "mode", 2);
var AuthenticationByProxyPage_default = AkTypeProxyApplicationWizardPage;

// src/admin/applications/wizard/methods/proxy/ak-application-wizard-authentication-for-forward-domain-proxy.ts
var AkForwardDomainProxyApplicationWizardPage = class extends AuthenticationByProxyPage_default {
  renderModeDescription() {
    return x`<p class="pf-u-mb-xl">
                ${msg(
      "Use this provider with nginx's auth_request or traefik's forwardAuth. Only a single provider is required per root domain. You can't do per-application authorization, but you don't have to create a provider for each application."
    )}
            </p>
            <div class="pf-u-mb-xl">
                ${msg("An example setup can look like this:")}
                <ul class="pf-c-list">
                    <li>${msg("authentik running on auth.example.com")}</li>
                    <li>${msg("app1 running on app1.example.com")}</li>
                </ul>
                ${msg(
      "In this case, you'd set the Authentication URL to auth.example.com and Cookie domain to example.com."
    )}
            </div>`;
  }
  renderProxyMode() {
    const provider = this.wizard.provider;
    const errors = this.wizard.errors.provider;
    return x`
            <ak-text-input
                name="externalHost"
                label=${msg("External host")}
                value=${o(provider?.externalHost)}
                .errorMessages=${errors?.externalHost ?? []}
                required
                help=${msg(
      "The external URL you'll authenticate at. The authentik core server should be reachable under this URL."
    )}
            >
            </ak-text-input>
            <ak-text-input
                name="cookieDomain"
                label=${msg("Cookie domain")}
                value="${o(provider?.cookieDomain)}"
                .errorMessages=${errors?.cookieDomain ?? []}
                required
                help=${msg(
      "Set this to the domain you wish the authentication to be valid for. Must be a parent domain of the URL above. If you're running applications as app1.domain.tld, app2.domain.tld, set this to 'domain.tld'."
    )}
            ></ak-text-input>
        `;
  }
};
AkForwardDomainProxyApplicationWizardPage = __decorateClass([
  t("ak-application-wizard-authentication-for-forward-proxy-domain")
], AkForwardDomainProxyApplicationWizardPage);

// src/admin/applications/wizard/methods/proxy/ak-application-wizard-authentication-for-reverse-proxy.ts
var AkReverseProxyApplicationWizardPage = class extends AuthenticationByProxyPage_default {
  renderModeDescription() {
    return x`<p class="pf-u-mb-xl">
            ${msg(
      "This provider will behave like a transparent reverse-proxy, except requests must be authenticated. If your upstream application uses HTTPS, make sure to connect to the outpost using HTTPS as well."
    )}
        </p>`;
  }
  renderProxyMode() {
    const provider = this.wizard.provider;
    const errors = this.wizard.errors.provider;
    return x` <ak-text-input
                name="externalHost"
                value=${o(provider?.externalHost)}
                required
                label=${msg("External host")}
                .errorMessages=${errors?.externalHost ?? []}
                help=${msg(
      "The external URL you'll access the application at. Include any non-standard port."
    )}
            ></ak-text-input>
            <ak-text-input
                name="internalHost"
                value=${o(provider?.internalHost)}
                .errorMessages=${errors?.internalHost ?? []}
                required
                label=${msg("Internal host")}
                help=${msg("Upstream host that the requests are forwarded to.")}
            ></ak-text-input>
            <ak-switch-input
                name="internalHostSslValidation"
                ?checked=${first(provider?.internalHostSslValidation, true)}
                label=${msg("Internal host SSL Validation")}
                help=${msg("Validate SSL Certificates of upstream servers.")}
            >
            </ak-switch-input>`;
  }
};
AkReverseProxyApplicationWizardPage = __decorateClass([
  t("ak-application-wizard-authentication-for-reverse-proxy")
], AkReverseProxyApplicationWizardPage);

// src/admin/applications/wizard/methods/proxy/ak-application-wizard-authentication-for-single-forward-proxy.ts
var AkForwardSingleProxyApplicationWizardPage = class extends AuthenticationByProxyPage_default {
  renderModeDescription() {
    return x`<p class="pf-u-mb-xl">
            ${msg(
      x`Use this provider with nginx's <code>auth_request</code> or traefik's
                    <code>forwardAuth</code>. Each application/domain needs its own provider.
                    Additionally, on each domain, <code>/outpost.goauthentik.io</code> must be
                    routed to the outpost (when using a managed outpost, this is done for you).`
    )}
        </p>`;
  }
  renderProxyMode() {
    const provider = this.wizard.provider;
    const errors = this.wizard.errors.provider;
    return x`<ak-text-input
            name="externalHost"
            value=${o(provider?.externalHost)}
            required
            label=${msg("External host")}
            .errorMessages=${errors?.externalHost ?? []}
            help=${msg(
      "The external URL you'll access the application at. Include any non-standard port."
    )}
        ></ak-text-input>`;
  }
};
AkForwardSingleProxyApplicationWizardPage = __decorateClass([
  t("ak-application-wizard-authentication-for-single-forward-proxy")
], AkForwardSingleProxyApplicationWizardPage);

// src/admin/applications/wizard/methods/rac/ak-application-wizard-authentication-for-rac.ts
var ApplicationWizardAuthenticationByRAC = class extends BaseProviderPanel_default {
  constructor() {
    super();
    new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsRacList({
      ordering: "name"
    }).then((propertyMappings) => {
      this.propertyMappings = propertyMappings;
    });
  }
  render() {
    const provider = this.wizard.provider;
    const selected = new Set(Array.from(provider?.propertyMappings ?? []));
    const errors = this.wizard.errors.provider;
    return x`<ak-wizard-title
                >${msg("Configure Remote Access Provider Provider")}</ak-wizard-title
            >
            <form class="pf-c-form pf-m-horizontal" @input=${this.handleChange}>
                <ak-text-input
                    name="name"
                    label=${msg("Name")}
                    value=${o(provider?.name)}
                    .errorMessages=${errors?.name ?? []}
                    required
                ></ak-text-input>

                <ak-form-element-horizontal
                    name="authorizationFlow"
                    label=${msg("Authorization flow")}
                    ?required=${true}
                >
                    <ak-flow-search
                        flowType=${FlowsInstancesListDesignationEnum.Authorization}
                        .currentFlow=${provider?.authorizationFlow}
                        required
                    ></ak-flow-search>
                    <p class="pf-c-form__helper-text">
                        ${msg("Flow used when authorizing this provider.")}
                    </p>
                </ak-form-element-horizontal>

                <ak-text-input
                    name="connectionExpiry"
                    label=${msg("Connection expiry")}
                    required
                    value="${provider?.connectionExpiry ?? "hours=8"}"
                    help=${msg(
      "Determines how long a session lasts before being disconnected and requiring re-authorization."
    )}
                ></ak-text-input>

                <ak-form-group .expanded=${true}>
                    <span slot="header"> ${msg("Protocol settings")} </span>
                    <div slot="body" class="pf-c-form">
                        <ak-form-element-horizontal
                            label=${msg("Property mappings")}
                            name="propertyMappings"
                        >
                            <select class="pf-c-form-control" multiple>
                                ${this.propertyMappings?.results.map(
      (mapping) => x`<option
                                            value=${o(mapping.pk)}
                                            ?selected=${selected.has(mapping.pk)}
                                        >
                                            ${mapping.name}
                                        </option>`
    )}
                            </select>
                            <p class="pf-c-form__helper-text">
                                ${msg("Hold control/command to select multiple items.")}
                            </p>
                        </ak-form-element-horizontal>
                    </div>
                </ak-form-group>
            </form>`;
  }
};
__decorateClass([
  r()
], ApplicationWizardAuthenticationByRAC.prototype, "propertyMappings", 2);
ApplicationWizardAuthenticationByRAC = __decorateClass([
  t("ak-application-wizard-authentication-for-rac")
], ApplicationWizardAuthenticationByRAC);

// src/admin/applications/wizard/methods/radius/ak-application-wizard-authentication-by-radius.ts
var ApplicationWizardAuthenticationByRadius = class extends WithBrandConfig(BaseProviderPanel_default) {
  render() {
    const provider = this.wizard.provider;
    const errors = this.wizard.errors.provider;
    return x`<ak-wizard-title>${msg("Configure Radius Provider")}</ak-wizard-title>
            <form class="pf-c-form pf-m-horizontal" @input=${this.handleChange}>
                <ak-text-input
                    name="name"
                    label=${msg("Name")}
                    value=${o(provider?.name)}
                    .errorMessages=${errors?.name ?? []}
                    required
                >
                </ak-text-input>

                <ak-form-element-horizontal
                    label=${msg("Authentication flow")}
                    ?required=${true}
                    name="authorizationFlow"
                    .errorMessages=${errors?.authorizationFlow ?? []}
                >
                    <ak-branded-flow-search
                        flowType=${FlowsInstancesListDesignationEnum.Authentication}
                        .currentFlow=${provider?.authorizationFlow}
                        .brandFlow=${this.brand.flowAuthentication}
                        required
                    ></ak-branded-flow-search>
                    <p class="pf-c-form__helper-text">
                        ${msg("Flow used for users to authenticate.")}
                    </p>
                </ak-form-element-horizontal>

                <ak-form-group expanded>
                    <span slot="header"> ${msg("Protocol settings")} </span>
                    <div slot="body" class="pf-c-form">
                        <ak-text-input
                            name="sharedSecret"
                            label=${msg("Shared secret")}
                            .errorMessages=${errors?.sharedSecret ?? []}
                            value=${first(
      provider?.sharedSecret,
      randomString(128, ascii_letters + digits)
    )}
                            required
                        ></ak-text-input>
                        <ak-text-input
                            name="clientNetworks"
                            label=${msg("Client Networks")}
                            value=${first(provider?.clientNetworks, "0.0.0.0/0, ::/0")}
                            .errorMessages=${errors?.clientNetworks ?? []}
                            required
                            help=${msg(`List of CIDRs (comma-seperated) that clients can connect from. A more specific
                            CIDR will match before a looser one. Clients connecting from a non-specified CIDR
                            will be dropped.`)}
                        ></ak-text-input>
                    </div>
                </ak-form-group>
            </form>`;
  }
};
ApplicationWizardAuthenticationByRadius = __decorateClass([
  t("ak-application-wizard-authentication-by-radius")
], ApplicationWizardAuthenticationByRadius);

// src/components/ak-multi-select.ts
var selectStyles = i`
    select[multiple] {
        min-height: 15rem;
    }
`;
var AkMultiSelect = class extends AKElement {
  constructor() {
    super();
    this.label = "";
    this.options = [];
    this.required = false;
    this.help = "";
    this.values = [];
    this.selectRef = e3();
    this.dataset.akControl = "true";
  }
  static get styles() {
    return [patternfly_base_default, form_default, form_control_default, selectStyles];
  }
  /**
   * Helper accessor for older code
   */
  get value() {
    return this.values;
  }
  /**
   * One of two criteria (the other being the data-ak-control flag) that specifies this as a
   * control that produces values of specific interest to our REST API. This is our modern
   * accessor name.
   */
  json() {
    return this.values;
  }
  renderHelp() {
    return [
      this.help ? x`<p class="pf-c-form__helper-text">${this.help}</p>` : T,
      this.bighelp ? this.bighelp : T
    ];
  }
  handleChange(ev) {
    if (ev.type === "change") {
      this.values = Array.from(this.selectRef.value.querySelectorAll("option")).filter((option) => option.selected).map((option) => option.value);
      this.dispatchEvent(
        new CustomEvent("ak-select", {
          detail: this.values,
          composed: true,
          bubbles: true
        })
      );
    }
  }
  render() {
    return x` <div class="pf-c-form">
            <ak-form-element-horizontal
                label=${this.label}
                ?required=${this.required}
                name=${this.name}
            >
                <select
                    part="select"
                    class="pf-c-form-control"
                    name=${o(this.name)}
                    multiple
                    ${n3(this.selectRef)}
                    @change=${this.handleChange}
                >
                    ${o2(
      this.options,
      ([value, label]) => x`<option value=${value} ?selected=${this.values.includes(value)}>
                                ${label}
                            </option>`
    )}
                </select>
                ${this.renderHelp()}
            </ak-form-element-horizontal>
        </div>`;
  }
};
__decorateClass([
  n({ type: String })
], AkMultiSelect.prototype, "name", 2);
__decorateClass([
  n({ type: String })
], AkMultiSelect.prototype, "label", 2);
__decorateClass([
  n({ attribute: false })
], AkMultiSelect.prototype, "options", 2);
__decorateClass([
  n({ type: Boolean })
], AkMultiSelect.prototype, "required", 2);
__decorateClass([
  n({ type: String })
], AkMultiSelect.prototype, "help", 2);
__decorateClass([
  n({ type: Object })
], AkMultiSelect.prototype, "bighelp", 2);
__decorateClass([
  n({ type: Array })
], AkMultiSelect.prototype, "values", 2);
AkMultiSelect = __decorateClass([
  t("ak-multi-select")
], AkMultiSelect);

// src/admin/applications/wizard/methods/saml/SamlProviderOptions.ts
function toOptions(options) {
  return options.map(([label, value, isDefault]) => ({
    label,
    value,
    default: isDefault ?? false
  }));
}
var spBindingOptions = toOptions([
  [msg("Redirect"), SpBindingEnum.Redirect, true],
  [msg("Post"), SpBindingEnum.Post]
]);
var digestAlgorithmOptions = toOptions([
  ["SHA1", DigestAlgorithmEnum._200009Xmldsigsha1],
  ["SHA256", DigestAlgorithmEnum._200104Xmlencsha256, true],
  ["SHA384", DigestAlgorithmEnum._200104XmldsigMoresha384],
  ["SHA512", DigestAlgorithmEnum._200104Xmlencsha512]
]);
var signatureAlgorithmOptions = toOptions([
  ["RSA-SHA1", SignatureAlgorithmEnum._200009XmldsigrsaSha1],
  ["RSA-SHA256", SignatureAlgorithmEnum._200104XmldsigMorersaSha256, true],
  ["RSA-SHA384", SignatureAlgorithmEnum._200104XmldsigMorersaSha384],
  ["RSA-SHA512", SignatureAlgorithmEnum._200104XmldsigMorersaSha512],
  ["ECDSA-SHA1", SignatureAlgorithmEnum._200104XmldsigMoreecdsaSha1],
  ["ECDSA-SHA256", SignatureAlgorithmEnum._200104XmldsigMoreecdsaSha256],
  ["ECDSA-SHA384", SignatureAlgorithmEnum._200104XmldsigMoreecdsaSha384],
  ["ECDSA-SHA512", SignatureAlgorithmEnum._200104XmldsigMoreecdsaSha512],
  ["DSA-SHA1", SignatureAlgorithmEnum._200009XmldsigdsaSha1]
]);

// src/admin/applications/wizard/methods/saml/saml-property-mappings-search.ts
async function fetchObjects2(query) {
  const args = {
    ordering: "saml_name"
  };
  if (query !== void 0) {
    args.search = query;
  }
  const items = await new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsSamlList(args);
  return items.results;
}
function renderElement2(item) {
  return item.name;
}
function renderValue2(item) {
  return item?.pk;
}
var SAMLPropertyMappingSearch = class extends CustomListenerElement(AKElement) {
  constructor() {
    super();
    this.selected = this.selected.bind(this);
    this.handleSearchUpdate = this.handleSearchUpdate.bind(this);
  }
  get value() {
    return this.selectedPropertyMapping ? renderValue2(this.selectedPropertyMapping) : void 0;
  }
  connectedCallback() {
    super.connectedCallback();
    const horizontalContainer = this.closest("ak-form-element-horizontal[name]");
    if (!horizontalContainer) {
      throw new Error("This search can only be used in a named ak-form-element-horizontal");
    }
    const name = horizontalContainer.getAttribute("name");
    const myName = this.getAttribute("name");
    if (name !== null && name !== myName) {
      this.setAttribute("name", name);
    }
  }
  handleSearchUpdate(ev) {
    ev.stopPropagation();
    this.selectedPropertyMapping = ev.detail.value;
    this.dispatchEvent(new InputEvent("input", { bubbles: true, composed: true }));
  }
  selected(item) {
    return this.propertyMapping === item.pk;
  }
  render() {
    return x`
            <ak-search-select
                .fetchObjects=${fetchObjects2}
                .renderElement=${renderElement2}
                .value=${renderValue2}
                .selected=${this.selected}
                @ak-change=${this.handleSearchUpdate}
                blankable
            >
            </ak-search-select>
        `;
  }
};
__decorateClass([
  n({ type: String, reflect: true, attribute: "propertymapping" })
], SAMLPropertyMappingSearch.prototype, "propertyMapping", 2);
__decorateClass([
  e("ak-search-select")
], SAMLPropertyMappingSearch.prototype, "search", 2);
__decorateClass([
  n({ type: String })
], SAMLPropertyMappingSearch.prototype, "name", 2);
SAMLPropertyMappingSearch = __decorateClass([
  t("ak-saml-property-mapping-search")
], SAMLPropertyMappingSearch);

// src/admin/applications/wizard/methods/saml/ak-application-wizard-authentication-by-saml-configuration.ts
var ApplicationWizardProviderSamlConfiguration = class extends BaseProviderPanel_default {
  constructor() {
    super();
    new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsSamlList({
      ordering: "saml_name"
    }).then((propertyMappings) => {
      this.propertyMappings = propertyMappings;
    });
  }
  propertyMappingConfiguration(provider) {
    const propertyMappings = this.propertyMappings?.results ?? [];
    const configuredMappings = (providerMappings) => propertyMappings.map((pm) => pm.pk).filter((pmpk) => providerMappings.includes(pmpk));
    const managedMappings = () => propertyMappings.filter((pm) => (pm?.managed ?? "").startsWith("goauthentik.io/providers/saml")).map((pm) => pm.pk);
    const pmValues = provider?.propertyMappings ? configuredMappings(provider?.propertyMappings ?? []) : managedMappings();
    const propertyPairs = propertyMappings.map((pm) => [pm.pk, pm.name]);
    return { pmValues, propertyPairs };
  }
  render() {
    const provider = this.wizard.provider;
    const errors = this.wizard.errors.provider;
    const { pmValues, propertyPairs } = this.propertyMappingConfiguration(provider);
    return x` <ak-wizard-title>${msg("Configure SAML Provider")}</ak-wizard-title>
            <form class="pf-c-form pf-m-horizontal" @input=${this.handleChange}>
                <ak-text-input
                    name="name"
                    value=${o(provider?.name)}
                    required
                    label=${msg("Name")}
                    .errorMessages=${errors?.name ?? []}
                ></ak-text-input>

                <ak-form-element-horizontal
                    label=${msg("Authentication flow")}
                    ?required=${false}
                    name="authenticationFlow"
                    .errorMessages=${errors?.authenticationFlow ?? []}
                >
                    <ak-flow-search
                        flowType=${FlowsInstancesListDesignationEnum.Authentication}
                        .currentFlow=${provider?.authenticationFlow}
                        required
                    ></ak-flow-search>
                    <p class="pf-c-form__helper-text">
                        ${msg(
      "Flow used when a user access this provider and is not authenticated."
    )}
                    </p>
                </ak-form-element-horizontal>

                <ak-form-element-horizontal
                    label=${msg("Authorization flow")}
                    ?required=${true}
                    name="authorizationFlow"
                    .errorMessages=${errors?.authorizationFlow ?? []}
                >
                    <ak-flow-search
                        flowType=${FlowsInstancesListDesignationEnum.Authorization}
                        .currentFlow=${provider?.authorizationFlow}
                        required
                    ></ak-flow-search>
                    <p class="pf-c-form__helper-text">
                        ${msg("Flow used when authorizing this provider.")}
                    </p>
                </ak-form-element-horizontal>

                <ak-form-group .expanded=${true}>
                    <span slot="header"> ${msg("Protocol settings")} </span>
                    <div slot="body" class="pf-c-form">
                        <ak-text-input
                            name="acsUrl"
                            value=${o(provider?.acsUrl)}
                            required
                            label=${msg("ACS URL")}
                            .errorMessages=${errors?.acsUrl ?? []}
                        ></ak-text-input>

                        <ak-text-input
                            name="issuer"
                            value=${provider?.issuer || "authentik"}
                            required
                            label=${msg("Issuer")}
                            help=${msg("Also known as EntityID.")}
                            .errorMessages=${errors?.issuer ?? []}
                        ></ak-text-input>

                        <ak-radio-input
                            name="spBinding"
                            label=${msg("Service Provider Binding")}
                            required
                            .options=${spBindingOptions}
                            .value=${provider?.spBinding}
                            help=${msg(
      "Determines how authentik sends the response back to the Service Provider."
    )}
                        >
                        </ak-radio-input>

                        <ak-text-input
                            name="audience"
                            value=${o(provider?.audience)}
                            label=${msg("Audience")}
                            .errorMessages=${errors?.audience ?? []}
                        ></ak-text-input>
                    </div>
                </ak-form-group>

                <ak-form-group>
                    <span slot="header"> ${msg("Advanced protocol settings")} </span>
                    <div slot="body" class="pf-c-form">
                        <ak-form-element-horizontal
                            label=${msg("Signing Certificate")}
                            name="signingKp"
                        >
                            <ak-crypto-certificate-search
                                certificate=${o(provider?.signingKp ?? void 0)}
                            ></ak-crypto-certificate-search>
                            <p class="pf-c-form__helper-text">
                                ${msg(
      "Certificate used to sign outgoing Responses going to the Service Provider."
    )}
                            </p>
                        </ak-form-element-horizontal>

                        <ak-form-element-horizontal
                            label=${msg("Verification Certificate")}
                            name="verificationKp"
                        >
                            <ak-crypto-certificate-search
                                certificate=${o(provider?.verificationKp ?? void 0)}
                                nokey
                            ></ak-crypto-certificate-search>
                            <p class="pf-c-form__helper-text">
                                ${msg(
      "When selected, incoming assertion's Signatures will be validated against this certificate. To allow unsigned Requests, leave on default."
    )}
                            </p>
                        </ak-form-element-horizontal>

                        <ak-multi-select
                            label=${msg("Property Mappings")}
                            name="propertyMappings"
                            .options=${propertyPairs}
                            .values=${pmValues}
                            .richhelp=${x` <p class="pf-c-form__helper-text">
                                    ${msg("Property mappings used for user mapping.")}
                                </p>
                                <p class="pf-c-form__helper-text">
                                    ${msg("Hold control/command to select multiple items.")}
                                </p>`}
                        ></ak-multi-select>

                        <ak-form-element-horizontal
                            label=${msg("NameID Property Mapping")}
                            name="nameIdMapping"
                        >
                            <ak-saml-property-mapping-search
                                name="nameIdMapping"
                                propertymapping=${o(provider?.nameIdMapping ?? void 0)}
                            ></ak-saml-property-mapping-search>
                            <p class="pf-c-form__helper-text">
                                ${msg(
      "Configure how the NameID value will be created. When left empty, the NameIDPolicy of the incoming request will be respected."
    )}
                            </p>
                        </ak-form-element-horizontal>

                        <ak-text-input
                            name="assertionValidNotBefore"
                            value=${provider?.assertionValidNotBefore || "minutes=-5"}
                            required
                            label=${msg("Assertion valid not before")}
                            help=${msg(
      "Configure the maximum allowed time drift for an assertion."
    )}
                            .errorMessages=${errors?.assertionValidNotBefore ?? []}
                        ></ak-text-input>

                        <ak-text-input
                            name="assertionValidNotOnOrAfter"
                            value=${provider?.assertionValidNotOnOrAfter || "minutes=5"}
                            required
                            label=${msg("Assertion valid not on or after")}
                            help=${msg(
      "Assertion not valid on or after current time + this value."
    )}
                            .errorMessages=${errors?.assertionValidNotOnOrAfter ?? []}
                        ></ak-text-input>

                        <ak-text-input
                            name="sessionValidNotOnOrAfter"
                            value=${provider?.sessionValidNotOnOrAfter || "minutes=86400"}
                            required
                            label=${msg("Session valid not on or after")}
                            help=${msg("Session not valid on or after current time + this value.")}
                            .errorMessages=${errors?.sessionValidNotOnOrAfter ?? []}
                        ></ak-text-input>

                        <ak-radio-input
                            name="digestAlgorithm"
                            label=${msg("Digest algorithm")}
                            required
                            .options=${digestAlgorithmOptions}
                            .value=${provider?.digestAlgorithm}
                        >
                        </ak-radio-input>

                        <ak-radio-input
                            name="signatureAlgorithm"
                            label=${msg("Signature algorithm")}
                            required
                            .options=${signatureAlgorithmOptions}
                            .value=${provider?.signatureAlgorithm}
                        >
                        </ak-radio-input>
                    </div>
                </ak-form-group>
            </form>`;
  }
};
__decorateClass([
  r()
], ApplicationWizardProviderSamlConfiguration.prototype, "propertyMappings", 2);
ApplicationWizardProviderSamlConfiguration = __decorateClass([
  t("ak-application-wizard-authentication-by-saml-configuration")
], ApplicationWizardProviderSamlConfiguration);

// src/admin/applications/wizard/methods/scim/ak-application-wizard-authentication-by-scim.ts
var ApplicationWizardAuthenticationBySCIM = class extends BaseProviderPanel_default {
  constructor() {
    super();
    new PropertymappingsApi(DEFAULT_CONFIG).propertymappingsScimList({
      ordering: "managed"
    }).then((propertyMappings) => {
      this.propertyMappings = propertyMappings;
    });
  }
  propertyMappingConfiguration(provider) {
    const propertyMappings = this.propertyMappings?.results ?? [];
    const configuredMappings = (providerMappings) => propertyMappings.map((pm) => pm.pk).filter((pmpk) => providerMappings.includes(pmpk));
    const managedMappings = (key) => propertyMappings.filter((pm) => pm.managed === `goauthentik.io/providers/scim/${key}`).map((pm) => pm.pk);
    const pmUserValues = provider?.propertyMappings ? configuredMappings(provider?.propertyMappings ?? []) : managedMappings("user");
    const pmGroupValues = provider?.propertyMappingsGroup ? configuredMappings(provider?.propertyMappingsGroup ?? []) : managedMappings("group");
    const propertyPairs = propertyMappings.map((pm) => [pm.pk, pm.name]);
    return { pmUserValues, pmGroupValues, propertyPairs };
  }
  render() {
    const provider = this.wizard.provider;
    const errors = this.wizard.errors.provider;
    const { pmUserValues, pmGroupValues, propertyPairs } = this.propertyMappingConfiguration(provider);
    return x`<ak-wizard-title>${msg("Configure SCIM Provider")}</ak-wizard-title>
            <form class="pf-c-form pf-m-horizontal" @input=${this.handleChange}>
                <ak-text-input
                    name="name"
                    label=${msg("Name")}
                    value=${o(provider?.name)}
                    .errorMessages=${errors?.name ?? []}
                    required
                ></ak-text-input>
                <ak-form-group expanded>
                    <span slot="header"> ${msg("Protocol settings")} </span>
                    <div slot="body" class="pf-c-form">
                        <ak-text-input
                            name="url"
                            label=${msg("URL")}
                            value="${first(provider?.url, "")}"
                            required
                            help=${msg("SCIM base url, usually ends in /v2.")}
                            .errorMessages=${errors?.url ?? []}
                        >
                        </ak-text-input>
                        <ak-text-input
                            name="token"
                            label=${msg("Token")}
                            value="${first(provider?.token, "")}"
                            .errorMessages=${errors?.token ?? []}
                            required
                            help=${msg(
      "Token to authenticate with. Currently only bearer authentication is supported."
    )}
                        >
                        </ak-text-input>
                    </div>
                </ak-form-group>
                <ak-form-group expanded>
                    <span slot="header">${msg("User filtering")}</span>
                    <div slot="body" class="pf-c-form">
                        <ak-switch-input
                            name="excludeUsersServiceAccount"
                            ?checked=${first(provider?.excludeUsersServiceAccount, true)}
                            label=${msg("Exclude service accounts")}
                        ></ak-switch-input>
                        <ak-form-element-horizontal label=${msg("Group")} name="filterGroup">
                            <ak-core-group-search
                                .group=${provider?.filterGroup}
                            ></ak-core-group-search>
                            <p class="pf-c-form__helper-text">
                                ${msg("Only sync users within the selected group.")}
                            </p>
                        </ak-form-element-horizontal>
                    </div>
                </ak-form-group>
                <ak-form-group ?expanded=${true}>
                    <span slot="header"> ${msg("Attribute mapping")} </span>
                    <div slot="body" class="pf-c-form">
                        <ak-multi-select
                            label=${msg("User Property Mappings")}
                            name="propertyMappings"
                            .options=${propertyPairs}
                            .values=${pmUserValues}
                            .richhelp=${x` <p class="pf-c-form__helper-text">
                                    ${msg("Property mappings used for user mapping.")}
                                </p>
                                <p class="pf-c-form__helper-text">
                                    ${msg("Hold control/command to select multiple items.")}
                                </p>`}
                        ></ak-multi-select>
                        <ak-multi-select
                            label=${msg("Group Property Mappings")}
                            name="propertyMappingsGroup"
                            .options=${propertyPairs}
                            .values=${pmGroupValues}
                            .richhelp=${x` <p class="pf-c-form__helper-text">
                                    ${msg("Property mappings used for group creation.")}
                                </p>
                                <p class="pf-c-form__helper-text">
                                    ${msg("Hold control/command to select multiple items.")}
                                </p>`}
                        ></ak-multi-select>
                    </div>
                </ak-form-group>
            </form>`;
  }
};
__decorateClass([
  r()
], ApplicationWizardAuthenticationBySCIM.prototype, "propertyMappings", 2);
ApplicationWizardAuthenticationBySCIM = __decorateClass([
  t("ak-application-wizard-authentication-by-scim")
], ApplicationWizardAuthenticationBySCIM);

// src/admin/applications/wizard/methods/ak-application-wizard-authentication-method.ts
var ApplicationWizardApplicationDetails3 = class extends BasePanel_default {
  render() {
    const handler = providerRendererList.get(this.wizard.providerModel);
    if (!handler) {
      throw new Error(
        "Unrecognized authentication method in ak-application-wizard-authentication-method"
      );
    }
    return handler();
  }
};
ApplicationWizardApplicationDetails3 = __decorateClass([
  t("ak-application-wizard-authentication-method")
], ApplicationWizardApplicationDetails3);

// src/admin/applications/wizard/steps.ts
var ApplicationStep = class {
  constructor() {
    this.id = "application";
    this.label = "Application Details";
    this.disabled = false;
    this.valid = false;
  }
  get buttons() {
    return [this.valid ? NextStep : DisabledNextStep, CancelWizard];
  }
  render() {
    return x`<ak-application-wizard-application-details></ak-application-wizard-application-details>`;
  }
};
var ProviderMethodStep = class {
  constructor() {
    this.id = "provider-method";
    this.label = "Provider Type";
    this.disabled = false;
    this.valid = false;
  }
  get buttons() {
    return [BackStep, this.valid ? NextStep : DisabledNextStep, CancelWizard];
  }
  render() {
    return x`<ak-application-wizard-authentication-method-choice
          ></ak-application-wizard-authentication-method-choice> `;
  }
};
var ProviderStepDetails = class {
  constructor() {
    this.id = "provider-details";
    this.label = "Provider Configuration";
    this.disabled = true;
    this.valid = false;
  }
  get buttons() {
    return [BackStep, this.valid ? SubmitStep : DisabledNextStep, CancelWizard];
  }
  render() {
    return x`<ak-application-wizard-authentication-method></ak-application-wizard-authentication-method>`;
  }
};
var SubmitApplicationStep = class {
  constructor() {
    this.id = "submit";
    this.label = "Submit Application";
    this.disabled = true;
    this.valid = false;
  }
  get buttons() {
    return this.valid ? [CloseWizard] : [BackStep, CancelWizard];
  }
  render() {
    return x`<ak-application-wizard-commit-application></ak-application-wizard-commit-application>`;
  }
};
var newSteps = () => [
  new ApplicationStep(),
  new ProviderMethodStep(),
  new ProviderStepDetails(),
  new SubmitApplicationStep()
];

// src/admin/applications/wizard/ak-application-wizard.ts
var freshWizardState = () => ({
  providerModel: "",
  app: {},
  provider: {},
  errors: {}
});
var ApplicationWizard = class extends CustomListenerElement(
  AkWizard
) {
  constructor() {
    super(msg("Create With Wizard"), msg("New application"), msg("Create a new application"));
    this.wizardState = freshWizardState();
    this.wizardStateProvider = new i2(this, {
      context: applicationWizardContext,
      initialValue: this.wizardState
    });
    /**
     * One of our steps has multiple display variants, one for each type of service provider. We
     * want to *preserve* a customer's decisions about different providers; never make someone "go
     * back and type it all back in," even if it's probably rare that someone will chose one
     * provider, realize it's the wrong one, and go back to chose a different one, *and then go
     * back*. Nonetheless, strive to *never* lose customer input.
     *
     */
    this.providerCache = /* @__PURE__ */ new Map();
    this.steps = newSteps();
  }
  // And this is where all the special cases go...
  handleUpdate(detail) {
    if (detail.status === "submitted") {
      this.step.valid = true;
      this.requestUpdate();
      return;
    }
    this.step.valid = this.step.valid || detail.status === "valid";
    const update = detail.update;
    if (!update) {
      return;
    }
    if (update.providerModel && update.providerModel !== this.wizardState.providerModel) {
      const requestedProvider = this.providerCache.get(update.providerModel) ?? {
        name: `Provider for ${this.wizardState.app.name}`
      };
      if (this.wizardState.providerModel) {
        this.providerCache.set(this.wizardState.providerModel, this.wizardState.provider);
      }
      update.provider = requestedProvider;
    }
    this.wizardState = update;
    this.wizardStateProvider.setValue(this.wizardState);
    this.requestUpdate();
  }
  close() {
    this.steps = newSteps();
    this.currentStep = 0;
    this.wizardState = freshWizardState();
    this.providerCache = /* @__PURE__ */ new Map();
    this.wizardStateProvider.setValue(this.wizardState);
    this.frame.value.open = false;
  }
  handleNav(stepId) {
    if (stepId === void 0 || this.steps[stepId] === void 0) {
      throw new Error(`Attempt to navigate to undefined step: ${stepId}`);
    }
    if (stepId > this.currentStep && !this.step.valid) {
      return;
    }
    this.currentStep = stepId;
    this.requestUpdate();
  }
};
__decorateClass([
  r()
], ApplicationWizard.prototype, "wizardState", 2);
ApplicationWizard = __decorateClass([
  t("ak-application-wizard")
], ApplicationWizard);

// src/components/ak-hint/ShowHintController.ts
var getCurrentStorageValue = () => {
  try {
    return JSON.parse(window?.localStorage.getItem(LOCALSTORAGE_AUTHENTIK_KEY) ?? "{}");
  } catch (_err) {
    return {};
  }
};
var ShowHintController = class {
  constructor(host, hintToken) {
    (this.host = host).addController(this);
    this.hintToken = hintToken;
    this.hide = this.hide.bind(this);
    this.show = this.show.bind(this);
  }
  setTheHint(state = false) {
    window?.localStorage.setItem(
      LOCALSTORAGE_AUTHENTIK_KEY,
      JSON.stringify({
        ...getCurrentStorageValue(),
        [this.hintToken]: state
      })
    );
    this.host.showHint = state;
  }
  hide() {
    this.setTheHint(false);
  }
  show() {
    this.setTheHint(true);
  }
  hostConnected() {
    const localStores = getCurrentStorageValue();
    if (!(this.hintToken in localStores)) {
      return;
    }
    this.host.showHint = localStores[this.hintToken];
  }
  render() {
    return x`<ak-hint-footer
            ><div style="text-align: right">
                <input type="checkbox" @input=${this.hide} />${msg(
      "Don't show this message again."
    )}
            </div></ak-hint-footer
        >`;
  }
};

// src/components/ak-hint/ak-hint.ts
var styles2 = i`
    :host {
        --ak-hint--GridRowGap: var(--pf-global--spacer--md);
        --ak-hint--PaddingTop: var(--pf-global--spacer--md);
        --ak-hint--PaddingRight: var(--pf-global--spacer--lg);
        --ak-hint--PaddingBottom: var(--pf-global--spacer--md);
        --ak-hint--PaddingLeft: var(--pf-global--spacer--lg);
        --ak-hint--BackgroundColor: var(--pf-global--palette--blue-50);
        --ak-hint--BorderColor: var(--pf-global--palette--blue-100);
        --ak-hint--BorderWidth: var(--pf-global--BorderWidth--sm);
        --ak-hint--BoxShadow: var(--pf-global--BoxShadow--sm);
        --ak-hint--Color: var(--pf-global--Color--100);

        /* Hint Title */
        --ak-hint__title--FontSize: var(--pf-global--FontSize--lg);

        /* Hint Body */
        --ak-hint__body--FontSize: var(--pf-global--FontSize--md);

        /* Hint Footer */
        --ak-hint__footer--child--MarginRight: var(--pf-global--spacer--md);

        /* Hint Actions */
        --ak-hint__actions--MarginLeft: var(--pf-global--spacer--2xl);
        --ak-hint__actions--c-dropdown--MarginTop: calc(
            var(--pf-global--spacer--form-element) * -1
        );
    }

    :host([theme="dark"]) {
        --ak-hint--BackgroundColor: var(--ak-dark-background-darker);
        --ak-hint--BorderColor: var(--ak-dark-background-lighter);
        --ak-hint--Color: var(--ak-dark-foreground);
    }

    div#host {
        display: flex;
        flex-direction: column;
        gap: var(--ak-hint--GridRowGap);
        background-color: var(--ak-hint--BackgroundColor);
        color: var(--ak-hint--Color);
        border: var(--ak-hint--BorderWidth) solid var(--ak-hint--BorderColor);
        box-shadow: var(--ak-hint--BoxShadow);
        padding: var(--ak-hint--PaddingTop) var(--ak-hint--PaddingRight)
            var(--ak-hint--PaddingBottom) var(--ak-hint--PaddingLeft);
    }

    ::slotted(ak-hint-title),
    ::slotted(ak-hint-body) {
        display: grid;
        grid-template-columns: 1fr auto;
        grid-row-gap: var(--ak-hint--GridRowGap);
    }
`;
var AkHint = class extends AKElement {
  static get styles() {
    return [styles2];
  }
  render() {
    return x`<div part="ak-hint" id="host"><slot></slot></div>`;
  }
};
AkHint = __decorateClass([
  t("ak-hint")
], AkHint);

// src/components/ak-hint/ak-hint-body.ts
var style = i`
    div {
        grid-column: 1 / -1;
        font-size: var(--ak-hint__body--FontSize);
    }
`;
var AkHintBody = class extends AKElement {
  static get styles() {
    return [style];
  }
  render() {
    return x`<div part="ak-hint-body"><slot></slot></div>`;
  }
};
AkHintBody = __decorateClass([
  t("ak-hint-body")
], AkHintBody);

// src/admin/applications/ApplicationWizardHint.ts
var closeButtonIcon = x`<svg
    fill="currentColor"
    height="1em"
    width="1em"
    viewBox="0 0 352 512"
    aria-hidden="true"
    role="img"
    style="vertical-align: -0.125em;"
>
    <path
        d="M242.72 256l100.07-100.07c12.28-12.28 12.28-32.19 0-44.48l-22.24-22.24c-12.28-12.28-32.19-12.28-44.48 0L176 189.28 75.93 89.21c-12.28-12.28-32.19-12.28-44.48 0L9.21 111.45c-12.28 12.28-12.28 32.19 0 44.48L109.28 256 9.21 356.07c-12.28 12.28-12.28 32.19 0 44.48l22.24 22.24c12.28 12.28 32.2 12.28 44.48 0L176 322.72l100.07 100.07c12.28 12.28 32.2 12.28 44.48 0l22.24-22.24c12.28-12.28 12.28-32.19 0-44.48L242.72 256z"
    ></path>
</svg>`;
var AkApplicationWizardHint = class extends AKElement {
  constructor() {
    super();
    this.forceHint = false;
    this.showHint = true;
    this.showHintController = new ShowHintController(
      this,
      "202310-application-wizard-announcement"
    );
  }
  static get styles() {
    return [
      button_default,
      page_default,
      label_default,
      i`
                .pf-c-page__main-section {
                    padding-top: 0;
                    padding-bottom: 0;
                }
            `
    ];
  }
  renderReminder() {
    const sectionStyles = {
      paddingBottom: "0",
      marginBottom: "-0.5rem",
      marginRight: "0.0625rem",
      textAlign: "right"
    };
    const textStyle = { maxWidth: "60ch" };
    return x`<section
            class="pf-c-page__main-section pf-m-no-padding-mobile"
            style="${o3(sectionStyles)}"
        >
            <span class="pf-c-label">
                <a class="pf-c-label__content" @click=${this.showHintController.show}>
                    <span class="pf-c-label__text" style="${o3(textStyle)}">
                        ${msg("One hint, 'New Application Wizard', is currently hidden")}
                    </span>
                    <button
                        aria-disabled="false"
                        aria-label="Restore Application Wizard Hint "
                        class="pf-c-button pf-m-plain"
                        type="button"
                        data-ouia-safe="true"
                    >
                        ${closeButtonIcon}
                    </button>
                </a>
            </span>
        </section>`;
  }
  renderHint() {
    return x` <section class="pf-c-page__main-section pf-m-no-padding-mobile">
            <ak-hint>
                <ak-hint-body>
                    <p>
                        You can now configure both an application and its authentication provider at
                        the same time with our new Application Wizard.
                        <!-- <a href="(link to docs)">Learn more about the wizard here.</a> -->
                    </p>

                    <ak-application-wizard
                        .open=${getURLParam("createWizard", false)}
                        .showButton=${false}
                    ></ak-application-wizard>
                </ak-hint-body>
                ${this.showHintController.render()}
            </ak-hint>
        </section>`;
  }
  render() {
    return this.showHint || this.forceHint ? this.renderHint() : this.renderReminder();
  }
};
__decorateClass([
  n({ type: Boolean, attribute: "show-hint" })
], AkApplicationWizardHint.prototype, "forceHint", 2);
__decorateClass([
  r()
], AkApplicationWizardHint.prototype, "showHint", 2);
AkApplicationWizardHint = __decorateClass([
  t("ak-application-wizard-hint")
], AkApplicationWizardHint);
//# sourceMappingURL=chunk-PZUTXYV4.js.map
