import {
  EventGeo,
  EventUser
} from "./chunk-YNQN4LE7.js";
import {
  actionToLabel
} from "./chunk-BEFPUR3G.js";
import {
  Table,
  TableColumn,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import {
  DEFAULT_CONFIG,
  EventsApi,
  getRelativeTime,
  n,
  t
} from "./chunk-EOF5OWT7.js";
import {
  msg,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/components/events/ObjectChangelog.ts
var ObjectChangelog = class extends Table {
  constructor() {
    super(...arguments);
    this.expandable = true;
    this.order = "-created";
    this.targetModelName = "";
  }
  async apiEndpoint(page) {
    let modelName = this.targetModelName;
    let appName = this.targetModelApp;
    if (this.targetModelName.indexOf(".") !== -1) {
      const parts = this.targetModelName.split(".", 1);
      appName = parts[0];
      modelName = parts[1];
    }
    if (this.targetModelName === "") {
      return Promise.reject();
    }
    return new EventsApi(DEFAULT_CONFIG).eventsEventsList({
      action: "model_",
      page,
      ordering: this.order,
      pageSize: (await uiConfig()).pagination.perPage,
      contextModelApp: appName,
      contextModelName: modelName,
      contextModelPk: this.targetModelPk.toString()
    });
  }
  columns() {
    return [
      new TableColumn(msg("Action"), "action"),
      new TableColumn(msg("User"), "enabled"),
      new TableColumn(msg("Creation Date"), "created"),
      new TableColumn(msg("Client IP"), "client_ip")
    ];
  }
  willUpdate(changedProperties) {
    if (changedProperties.has("targetModelName") && this.targetModelName) {
      this.fetch();
    }
  }
  row(item) {
    return [
      x`${actionToLabel(item.action)}`,
      EventUser(item),
      x`<div>${getRelativeTime(item.created)}</div>
                <small>${item.created.toLocaleString()}</small>`,
      x`<div>${item.clientIp || msg("-")}</div>

                <small>${EventGeo(item)}</small>`
    ];
  }
  renderExpanded(item) {
    return x` <td role="cell" colspan="4">
                <div class="pf-c-table__expandable-row-content">
                    <ak-event-info .event=${item}></ak-event-info>
                </div>
            </td>
            <td></td>
            <td></td>
            <td></td>`;
  }
  renderEmpty() {
    return super.renderEmpty(
      x`<ak-empty-state header=${msg("No Events found.")}>
                <div slot="body">${msg("No matching events could be found.")}</div>
            </ak-empty-state>`
    );
  }
};
__decorateClass([
  n()
], ObjectChangelog.prototype, "order", 2);
__decorateClass([
  n()
], ObjectChangelog.prototype, "targetModelPk", 2);
__decorateClass([
  n()
], ObjectChangelog.prototype, "targetModelApp", 2);
__decorateClass([
  n()
], ObjectChangelog.prototype, "targetModelName", 2);
ObjectChangelog = __decorateClass([
  t("ak-object-changelog")
], ObjectChangelog);
//# sourceMappingURL=chunk-SFKV34FB.js.map
