import {
  flex_default
} from "./chunk-FNV26V2B.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import {
  AKElement,
  n,
  patternfly_base_default,
  t
} from "./chunk-EOF5OWT7.js";
import {
  i,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/elements/cards/AggregateCard.ts
var AggregateCard = class extends AKElement {
  constructor() {
    super(...arguments);
    this.isCenter = true;
  }
  static get styles() {
    return [patternfly_base_default, card_default, flex_default].concat([
      i`
                .pf-c-card.pf-c-card-aggregate {
                    height: 100%;
                }
                .pf-c-card__header {
                    flex-wrap: nowrap;
                }
                .center-value {
                    font-size: var(--pf-global--icon--FontSize--lg);
                    text-align: center;
                }
                .subtext {
                    font-size: var(--pf-global--FontSize--sm);
                }
                .pf-c-card__body {
                    overflow-x: scroll;
                    padding-left: calc(var(--pf-c-card--child--PaddingLeft) / 2);
                    padding-right: calc(var(--pf-c-card--child--PaddingRight) / 2);
                }
                .pf-c-card__header,
                .pf-c-card__title,
                .pf-c-card__body,
                .pf-c-card__footer {
                    padding-bottom: 0;
                }
            `
    ]);
  }
  renderInner() {
    return x`<slot></slot>`;
  }
  renderHeaderLink() {
    return x`${this.headerLink ? x`<a href="${this.headerLink}">
                  <i class="fa fa-link"> </i>
              </a>` : ""}`;
  }
  renderHeader() {
    return x`${this.header ? this.header : ""}`;
  }
  render() {
    return x`<div class="pf-c-card pf-c-card-aggregate">
            <div class="pf-c-card__header pf-l-flex pf-m-justify-content-space-between">
                <div class="pf-c-card__title">
                    <i class="${o(this.icon)}"></i>&nbsp;${this.renderHeader()}
                </div>
                ${this.renderHeaderLink()}
            </div>
            <div class="pf-c-card__body ${this.isCenter ? "center-value" : ""}">
                ${this.renderInner()}
                ${this.subtext ? x`<p class="subtext">${this.subtext}</p>` : x``}
            </div>
            <div class="pf-c-card__footer">&nbsp;</div>
        </div>`;
  }
};
__decorateClass([
  n()
], AggregateCard.prototype, "icon", 2);
__decorateClass([
  n()
], AggregateCard.prototype, "header", 2);
__decorateClass([
  n()
], AggregateCard.prototype, "headerLink", 2);
__decorateClass([
  n()
], AggregateCard.prototype, "subtext", 2);
__decorateClass([
  n({ type: Boolean })
], AggregateCard.prototype, "isCenter", 2);
AggregateCard = __decorateClass([
  t("ak-aggregate-card")
], AggregateCard);

export {
  AggregateCard
};
//# sourceMappingURL=chunk-T5SCNNG6.js.map
