import {
  BaseAPI,
  JSONApiResponse,
  LDAPAPIAccessModeFromJSON,
  PaginationFromJSON,
  ProviderFromJSON,
  ProxyModeFromJSON,
  RequiredError,
  TypeCreateFromJSON,
  UsedByFromJSON,
  VoidApiResponse,
  exists
} from "./chunk-EOF5OWT7.js";

// node_modules/@goauthentik/api/dist/esm/models/OutpostTypeEnum.js
var OutpostTypeEnum = {
  Proxy: "proxy",
  Ldap: "ldap",
  Radius: "radius",
  Rac: "rac",
  UnknownDefaultOpenApi: "11184809"
};
function OutpostTypeEnumFromJSON(json) {
  return OutpostTypeEnumFromJSONTyped(json, false);
}
function OutpostTypeEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function OutpostTypeEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/DockerServiceConnection.js
function DockerServiceConnectionFromJSON(json) {
  return DockerServiceConnectionFromJSONTyped(json, false);
}
function DockerServiceConnectionFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "local": !exists(json, "local") ? void 0 : json["local"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "url": json["url"],
    "tlsVerification": !exists(json, "tls_verification") ? void 0 : json["tls_verification"],
    "tlsAuthentication": !exists(json, "tls_authentication") ? void 0 : json["tls_authentication"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/DockerServiceConnectionRequest.js
function DockerServiceConnectionRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "local": value.local,
    "url": value.url,
    "tls_verification": value.tlsVerification,
    "tls_authentication": value.tlsAuthentication
  };
}

// node_modules/@goauthentik/api/dist/esm/models/KubernetesServiceConnection.js
function KubernetesServiceConnectionFromJSON(json) {
  return KubernetesServiceConnectionFromJSONTyped(json, false);
}
function KubernetesServiceConnectionFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "local": !exists(json, "local") ? void 0 : json["local"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "kubeconfig": !exists(json, "kubeconfig") ? void 0 : json["kubeconfig"],
    "verifySsl": !exists(json, "verify_ssl") ? void 0 : json["verify_ssl"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/KubernetesServiceConnectionRequest.js
function KubernetesServiceConnectionRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "local": value.local,
    "kubeconfig": value.kubeconfig,
    "verify_ssl": value.verifySsl
  };
}

// node_modules/@goauthentik/api/dist/esm/models/LDAPOutpostConfig.js
function LDAPOutpostConfigFromJSON(json) {
  return LDAPOutpostConfigFromJSONTyped(json, false);
}
function LDAPOutpostConfigFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "baseDn": !exists(json, "base_dn") ? void 0 : json["base_dn"],
    "bindFlowSlug": json["bind_flow_slug"],
    "applicationSlug": json["application_slug"],
    "searchGroup": !exists(json, "search_group") ? void 0 : json["search_group"],
    "certificate": !exists(json, "certificate") ? void 0 : json["certificate"],
    "tlsServerName": !exists(json, "tls_server_name") ? void 0 : json["tls_server_name"],
    "uidStartNumber": !exists(json, "uid_start_number") ? void 0 : json["uid_start_number"],
    "gidStartNumber": !exists(json, "gid_start_number") ? void 0 : json["gid_start_number"],
    "searchMode": !exists(json, "search_mode") ? void 0 : LDAPAPIAccessModeFromJSON(json["search_mode"]),
    "bindMode": !exists(json, "bind_mode") ? void 0 : LDAPAPIAccessModeFromJSON(json["bind_mode"]),
    "mfaSupport": !exists(json, "mfa_support") ? void 0 : json["mfa_support"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/OpenIDConnectConfiguration.js
function OpenIDConnectConfigurationFromJSON(json) {
  return OpenIDConnectConfigurationFromJSONTyped(json, false);
}
function OpenIDConnectConfigurationFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "issuer": json["issuer"],
    "authorizationEndpoint": json["authorization_endpoint"],
    "tokenEndpoint": json["token_endpoint"],
    "userinfoEndpoint": json["userinfo_endpoint"],
    "endSessionEndpoint": json["end_session_endpoint"],
    "introspectionEndpoint": json["introspection_endpoint"],
    "jwksUri": json["jwks_uri"],
    "responseTypesSupported": json["response_types_supported"],
    "idTokenSigningAlgValuesSupported": json["id_token_signing_alg_values_supported"],
    "subjectTypesSupported": json["subject_types_supported"],
    "tokenEndpointAuthMethodsSupported": json["token_endpoint_auth_methods_supported"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ServiceConnection.js
function ServiceConnectionFromJSON(json) {
  return ServiceConnectionFromJSONTyped(json, false);
}
function ServiceConnectionFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "local": !exists(json, "local") ? void 0 : json["local"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Outpost.js
function OutpostFromJSON(json) {
  return OutpostFromJSONTyped(json, false);
}
function OutpostFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "type": OutpostTypeEnumFromJSON(json["type"]),
    "providers": json["providers"],
    "providersObj": json["providers_obj"].map(ProviderFromJSON),
    "serviceConnection": !exists(json, "service_connection") ? void 0 : json["service_connection"],
    "serviceConnectionObj": ServiceConnectionFromJSON(json["service_connection_obj"]),
    "tokenIdentifier": json["token_identifier"],
    "config": json["config"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/OutpostDefaultConfig.js
function OutpostDefaultConfigFromJSON(json) {
  return OutpostDefaultConfigFromJSONTyped(json, false);
}
function OutpostDefaultConfigFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "config": json["config"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/OutpostHealth.js
function OutpostHealthFromJSON(json) {
  return OutpostHealthFromJSONTyped(json, false);
}
function OutpostHealthFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "uid": json["uid"],
    "lastSeen": new Date(json["last_seen"]),
    "version": json["version"],
    "versionShould": json["version_should"],
    "versionOutdated": json["version_outdated"],
    "buildHash": json["build_hash"],
    "buildHashShould": json["build_hash_should"],
    "hostname": json["hostname"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/OutpostRequest.js
function OutpostRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "type": OutpostTypeEnumToJSON(value.type),
    "providers": value.providers,
    "service_connection": value.serviceConnection,
    "config": value.config,
    "managed": value.managed
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedDockerServiceConnectionList.js
function PaginatedDockerServiceConnectionListFromJSON(json) {
  return PaginatedDockerServiceConnectionListFromJSONTyped(json, false);
}
function PaginatedDockerServiceConnectionListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(DockerServiceConnectionFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedKubernetesServiceConnectionList.js
function PaginatedKubernetesServiceConnectionListFromJSON(json) {
  return PaginatedKubernetesServiceConnectionListFromJSONTyped(json, false);
}
function PaginatedKubernetesServiceConnectionListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(KubernetesServiceConnectionFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedLDAPOutpostConfigList.js
function PaginatedLDAPOutpostConfigListFromJSON(json) {
  return PaginatedLDAPOutpostConfigListFromJSONTyped(json, false);
}
function PaginatedLDAPOutpostConfigListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(LDAPOutpostConfigFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedOutpostList.js
function PaginatedOutpostListFromJSON(json) {
  return PaginatedOutpostListFromJSONTyped(json, false);
}
function PaginatedOutpostListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(OutpostFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ProxyOutpostConfig.js
function ProxyOutpostConfigFromJSON(json) {
  return ProxyOutpostConfigFromJSONTyped(json, false);
}
function ProxyOutpostConfigFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "internalHost": !exists(json, "internal_host") ? void 0 : json["internal_host"],
    "externalHost": json["external_host"],
    "internalHostSslValidation": !exists(json, "internal_host_ssl_validation") ? void 0 : json["internal_host_ssl_validation"],
    "clientId": !exists(json, "client_id") ? void 0 : json["client_id"],
    "clientSecret": !exists(json, "client_secret") ? void 0 : json["client_secret"],
    "oidcConfiguration": OpenIDConnectConfigurationFromJSON(json["oidc_configuration"]),
    "cookieSecret": !exists(json, "cookie_secret") ? void 0 : json["cookie_secret"],
    "certificate": !exists(json, "certificate") ? void 0 : json["certificate"],
    "skipPathRegex": !exists(json, "skip_path_regex") ? void 0 : json["skip_path_regex"],
    "basicAuthEnabled": !exists(json, "basic_auth_enabled") ? void 0 : json["basic_auth_enabled"],
    "basicAuthPasswordAttribute": !exists(json, "basic_auth_password_attribute") ? void 0 : json["basic_auth_password_attribute"],
    "basicAuthUserAttribute": !exists(json, "basic_auth_user_attribute") ? void 0 : json["basic_auth_user_attribute"],
    "mode": !exists(json, "mode") ? void 0 : ProxyModeFromJSON(json["mode"]),
    "cookieDomain": !exists(json, "cookie_domain") ? void 0 : json["cookie_domain"],
    "accessTokenValidity": json["access_token_validity"],
    "interceptHeaderAuth": !exists(json, "intercept_header_auth") ? void 0 : json["intercept_header_auth"],
    "scopesToRequest": json["scopes_to_request"],
    "assignedApplicationSlug": json["assigned_application_slug"],
    "assignedApplicationName": json["assigned_application_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedProxyOutpostConfigList.js
function PaginatedProxyOutpostConfigListFromJSON(json) {
  return PaginatedProxyOutpostConfigListFromJSONTyped(json, false);
}
function PaginatedProxyOutpostConfigListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ProxyOutpostConfigFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/RadiusOutpostConfig.js
function RadiusOutpostConfigFromJSON(json) {
  return RadiusOutpostConfigFromJSONTyped(json, false);
}
function RadiusOutpostConfigFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "applicationSlug": json["application_slug"],
    "authFlowSlug": json["auth_flow_slug"],
    "clientNetworks": !exists(json, "client_networks") ? void 0 : json["client_networks"],
    "sharedSecret": !exists(json, "shared_secret") ? void 0 : json["shared_secret"],
    "mfaSupport": !exists(json, "mfa_support") ? void 0 : json["mfa_support"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedRadiusOutpostConfigList.js
function PaginatedRadiusOutpostConfigListFromJSON(json) {
  return PaginatedRadiusOutpostConfigListFromJSONTyped(json, false);
}
function PaginatedRadiusOutpostConfigListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(RadiusOutpostConfigFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedServiceConnectionList.js
function PaginatedServiceConnectionListFromJSON(json) {
  return PaginatedServiceConnectionListFromJSONTyped(json, false);
}
function PaginatedServiceConnectionListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ServiceConnectionFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedDockerServiceConnectionRequest.js
function PatchedDockerServiceConnectionRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "local": value.local,
    "url": value.url,
    "tls_verification": value.tlsVerification,
    "tls_authentication": value.tlsAuthentication
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedKubernetesServiceConnectionRequest.js
function PatchedKubernetesServiceConnectionRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "local": value.local,
    "kubeconfig": value.kubeconfig,
    "verify_ssl": value.verifySsl
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedOutpostRequest.js
function PatchedOutpostRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "type": OutpostTypeEnumToJSON(value.type),
    "providers": value.providers,
    "service_connection": value.serviceConnection,
    "config": value.config,
    "managed": value.managed
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ServiceConnectionState.js
function ServiceConnectionStateFromJSON(json) {
  return ServiceConnectionStateFromJSONTyped(json, false);
}
function ServiceConnectionStateFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "healthy": json["healthy"],
    "version": json["version"]
  };
}

// node_modules/@goauthentik/api/dist/esm/apis/OutpostsApi.js
var __awaiter = function(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var OutpostsApi = class extends BaseAPI {
  /**
   * Outpost Viewset
   */
  outpostsInstancesCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.outpostRequest === null || requestParameters.outpostRequest === void 0) {
        throw new RequiredError("outpostRequest", "Required parameter requestParameters.outpostRequest was null or undefined when calling outpostsInstancesCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/instances/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: OutpostRequestToJSON(requestParameters.outpostRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OutpostFromJSON(jsonValue));
    });
  }
  /**
   * Outpost Viewset
   */
  outpostsInstancesCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsInstancesCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Global default outpost config
   */
  outpostsInstancesDefaultSettingsRetrieveRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/instances/default_settings/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OutpostDefaultConfigFromJSON(jsonValue));
    });
  }
  /**
   * Global default outpost config
   */
  outpostsInstancesDefaultSettingsRetrieve(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsInstancesDefaultSettingsRetrieveRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Outpost Viewset
   */
  outpostsInstancesDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsInstancesDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/instances/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Outpost Viewset
   */
  outpostsInstancesDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.outpostsInstancesDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Get outposts current health
   */
  outpostsInstancesHealthListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsInstancesHealthList.");
      }
      const queryParameters = {};
      if (requestParameters.managedIcontains !== void 0) {
        queryParameters["managed__icontains"] = requestParameters.managedIcontains;
      }
      if (requestParameters.managedIexact !== void 0) {
        queryParameters["managed__iexact"] = requestParameters.managedIexact;
      }
      if (requestParameters.nameIcontains !== void 0) {
        queryParameters["name__icontains"] = requestParameters.nameIcontains;
      }
      if (requestParameters.nameIexact !== void 0) {
        queryParameters["name__iexact"] = requestParameters.nameIexact;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.providersIsnull !== void 0) {
        queryParameters["providers__isnull"] = requestParameters.providersIsnull;
      }
      if (requestParameters.providersByPk) {
        queryParameters["providers_by_pk"] = requestParameters.providersByPk;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.serviceConnectionNameIcontains !== void 0) {
        queryParameters["service_connection__name__icontains"] = requestParameters.serviceConnectionNameIcontains;
      }
      if (requestParameters.serviceConnectionNameIexact !== void 0) {
        queryParameters["service_connection__name__iexact"] = requestParameters.serviceConnectionNameIexact;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/instances/{uuid}/health/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(OutpostHealthFromJSON));
    });
  }
  /**
   * Get outposts current health
   */
  outpostsInstancesHealthList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsInstancesHealthListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Outpost Viewset
   */
  outpostsInstancesListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managedIcontains !== void 0) {
        queryParameters["managed__icontains"] = requestParameters.managedIcontains;
      }
      if (requestParameters.managedIexact !== void 0) {
        queryParameters["managed__iexact"] = requestParameters.managedIexact;
      }
      if (requestParameters.nameIcontains !== void 0) {
        queryParameters["name__icontains"] = requestParameters.nameIcontains;
      }
      if (requestParameters.nameIexact !== void 0) {
        queryParameters["name__iexact"] = requestParameters.nameIexact;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.providersIsnull !== void 0) {
        queryParameters["providers__isnull"] = requestParameters.providersIsnull;
      }
      if (requestParameters.providersByPk) {
        queryParameters["providers_by_pk"] = requestParameters.providersByPk;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.serviceConnectionNameIcontains !== void 0) {
        queryParameters["service_connection__name__icontains"] = requestParameters.serviceConnectionNameIcontains;
      }
      if (requestParameters.serviceConnectionNameIexact !== void 0) {
        queryParameters["service_connection__name__iexact"] = requestParameters.serviceConnectionNameIexact;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/instances/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedOutpostListFromJSON(jsonValue));
    });
  }
  /**
   * Outpost Viewset
   */
  outpostsInstancesList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsInstancesListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Outpost Viewset
   */
  outpostsInstancesPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsInstancesPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/instances/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedOutpostRequestToJSON(requestParameters.patchedOutpostRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OutpostFromJSON(jsonValue));
    });
  }
  /**
   * Outpost Viewset
   */
  outpostsInstancesPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsInstancesPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Outpost Viewset
   */
  outpostsInstancesRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsInstancesRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/instances/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OutpostFromJSON(jsonValue));
    });
  }
  /**
   * Outpost Viewset
   */
  outpostsInstancesRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsInstancesRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Outpost Viewset
   */
  outpostsInstancesUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsInstancesUpdate.");
      }
      if (requestParameters.outpostRequest === null || requestParameters.outpostRequest === void 0) {
        throw new RequiredError("outpostRequest", "Required parameter requestParameters.outpostRequest was null or undefined when calling outpostsInstancesUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/instances/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: OutpostRequestToJSON(requestParameters.outpostRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OutpostFromJSON(jsonValue));
    });
  }
  /**
   * Outpost Viewset
   */
  outpostsInstancesUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsInstancesUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  outpostsInstancesUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsInstancesUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/instances/{uuid}/used_by/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  outpostsInstancesUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsInstancesUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAPProvider Viewset
   */
  outpostsLdapListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/ldap/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedLDAPOutpostConfigListFromJSON(jsonValue));
    });
  }
  /**
   * LDAPProvider Viewset
   */
  outpostsLdapList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsLdapListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAPProvider Viewset
   */
  outpostsLdapRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling outpostsLdapRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/ldap/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPOutpostConfigFromJSON(jsonValue));
    });
  }
  /**
   * LDAPProvider Viewset
   */
  outpostsLdapRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsLdapRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ProxyProvider Viewset
   */
  outpostsProxyListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/proxy/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedProxyOutpostConfigListFromJSON(jsonValue));
    });
  }
  /**
   * ProxyProvider Viewset
   */
  outpostsProxyList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsProxyListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ProxyProvider Viewset
   */
  outpostsProxyRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling outpostsProxyRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/proxy/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ProxyOutpostConfigFromJSON(jsonValue));
    });
  }
  /**
   * ProxyProvider Viewset
   */
  outpostsProxyRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsProxyRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RadiusProvider Viewset
   */
  outpostsRadiusListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/radius/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedRadiusOutpostConfigListFromJSON(jsonValue));
    });
  }
  /**
   * RadiusProvider Viewset
   */
  outpostsRadiusList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsRadiusListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RadiusProvider Viewset
   */
  outpostsRadiusRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling outpostsRadiusRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/radius/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RadiusOutpostConfigFromJSON(jsonValue));
    });
  }
  /**
   * RadiusProvider Viewset
   */
  outpostsRadiusRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsRadiusRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ServiceConnection Viewset
   */
  outpostsServiceConnectionsAllDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsServiceConnectionsAllDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/all/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * ServiceConnection Viewset
   */
  outpostsServiceConnectionsAllDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.outpostsServiceConnectionsAllDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * ServiceConnection Viewset
   */
  outpostsServiceConnectionsAllListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/all/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedServiceConnectionListFromJSON(jsonValue));
    });
  }
  /**
   * ServiceConnection Viewset
   */
  outpostsServiceConnectionsAllList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsAllListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ServiceConnection Viewset
   */
  outpostsServiceConnectionsAllRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsServiceConnectionsAllRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/all/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ServiceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * ServiceConnection Viewset
   */
  outpostsServiceConnectionsAllRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsAllRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get the service connection\'s state
   */
  outpostsServiceConnectionsAllStateRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsServiceConnectionsAllStateRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/all/{uuid}/state/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ServiceConnectionStateFromJSON(jsonValue));
    });
  }
  /**
   * Get the service connection\'s state
   */
  outpostsServiceConnectionsAllStateRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsAllStateRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get all creatable service connection types
   */
  outpostsServiceConnectionsAllTypesListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/all/types/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(TypeCreateFromJSON));
    });
  }
  /**
   * Get all creatable service connection types
   */
  outpostsServiceConnectionsAllTypesList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsAllTypesListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  outpostsServiceConnectionsAllUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsServiceConnectionsAllUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/all/{uuid}/used_by/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  outpostsServiceConnectionsAllUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsAllUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DockerServiceConnection Viewset
   */
  outpostsServiceConnectionsDockerCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.dockerServiceConnectionRequest === null || requestParameters.dockerServiceConnectionRequest === void 0) {
        throw new RequiredError("dockerServiceConnectionRequest", "Required parameter requestParameters.dockerServiceConnectionRequest was null or undefined when calling outpostsServiceConnectionsDockerCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/docker/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: DockerServiceConnectionRequestToJSON(requestParameters.dockerServiceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DockerServiceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * DockerServiceConnection Viewset
   */
  outpostsServiceConnectionsDockerCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsDockerCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DockerServiceConnection Viewset
   */
  outpostsServiceConnectionsDockerDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsServiceConnectionsDockerDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/docker/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * DockerServiceConnection Viewset
   */
  outpostsServiceConnectionsDockerDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.outpostsServiceConnectionsDockerDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * DockerServiceConnection Viewset
   */
  outpostsServiceConnectionsDockerListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.local !== void 0) {
        queryParameters["local"] = requestParameters.local;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.tlsAuthentication !== void 0) {
        queryParameters["tls_authentication"] = requestParameters.tlsAuthentication;
      }
      if (requestParameters.tlsVerification !== void 0) {
        queryParameters["tls_verification"] = requestParameters.tlsVerification;
      }
      if (requestParameters.url !== void 0) {
        queryParameters["url"] = requestParameters.url;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/docker/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedDockerServiceConnectionListFromJSON(jsonValue));
    });
  }
  /**
   * DockerServiceConnection Viewset
   */
  outpostsServiceConnectionsDockerList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsDockerListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DockerServiceConnection Viewset
   */
  outpostsServiceConnectionsDockerPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsServiceConnectionsDockerPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/docker/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedDockerServiceConnectionRequestToJSON(requestParameters.patchedDockerServiceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DockerServiceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * DockerServiceConnection Viewset
   */
  outpostsServiceConnectionsDockerPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsDockerPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DockerServiceConnection Viewset
   */
  outpostsServiceConnectionsDockerRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsServiceConnectionsDockerRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/docker/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DockerServiceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * DockerServiceConnection Viewset
   */
  outpostsServiceConnectionsDockerRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsDockerRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DockerServiceConnection Viewset
   */
  outpostsServiceConnectionsDockerUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsServiceConnectionsDockerUpdate.");
      }
      if (requestParameters.dockerServiceConnectionRequest === null || requestParameters.dockerServiceConnectionRequest === void 0) {
        throw new RequiredError("dockerServiceConnectionRequest", "Required parameter requestParameters.dockerServiceConnectionRequest was null or undefined when calling outpostsServiceConnectionsDockerUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/docker/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: DockerServiceConnectionRequestToJSON(requestParameters.dockerServiceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DockerServiceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * DockerServiceConnection Viewset
   */
  outpostsServiceConnectionsDockerUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsDockerUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  outpostsServiceConnectionsDockerUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsServiceConnectionsDockerUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/docker/{uuid}/used_by/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  outpostsServiceConnectionsDockerUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsDockerUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * KubernetesServiceConnection Viewset
   */
  outpostsServiceConnectionsKubernetesCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.kubernetesServiceConnectionRequest === null || requestParameters.kubernetesServiceConnectionRequest === void 0) {
        throw new RequiredError("kubernetesServiceConnectionRequest", "Required parameter requestParameters.kubernetesServiceConnectionRequest was null or undefined when calling outpostsServiceConnectionsKubernetesCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/kubernetes/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: KubernetesServiceConnectionRequestToJSON(requestParameters.kubernetesServiceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => KubernetesServiceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * KubernetesServiceConnection Viewset
   */
  outpostsServiceConnectionsKubernetesCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsKubernetesCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * KubernetesServiceConnection Viewset
   */
  outpostsServiceConnectionsKubernetesDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsServiceConnectionsKubernetesDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/kubernetes/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * KubernetesServiceConnection Viewset
   */
  outpostsServiceConnectionsKubernetesDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.outpostsServiceConnectionsKubernetesDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * KubernetesServiceConnection Viewset
   */
  outpostsServiceConnectionsKubernetesListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.local !== void 0) {
        queryParameters["local"] = requestParameters.local;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/kubernetes/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedKubernetesServiceConnectionListFromJSON(jsonValue));
    });
  }
  /**
   * KubernetesServiceConnection Viewset
   */
  outpostsServiceConnectionsKubernetesList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsKubernetesListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * KubernetesServiceConnection Viewset
   */
  outpostsServiceConnectionsKubernetesPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsServiceConnectionsKubernetesPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/kubernetes/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedKubernetesServiceConnectionRequestToJSON(requestParameters.patchedKubernetesServiceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => KubernetesServiceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * KubernetesServiceConnection Viewset
   */
  outpostsServiceConnectionsKubernetesPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsKubernetesPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * KubernetesServiceConnection Viewset
   */
  outpostsServiceConnectionsKubernetesRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsServiceConnectionsKubernetesRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/kubernetes/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => KubernetesServiceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * KubernetesServiceConnection Viewset
   */
  outpostsServiceConnectionsKubernetesRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsKubernetesRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * KubernetesServiceConnection Viewset
   */
  outpostsServiceConnectionsKubernetesUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsServiceConnectionsKubernetesUpdate.");
      }
      if (requestParameters.kubernetesServiceConnectionRequest === null || requestParameters.kubernetesServiceConnectionRequest === void 0) {
        throw new RequiredError("kubernetesServiceConnectionRequest", "Required parameter requestParameters.kubernetesServiceConnectionRequest was null or undefined when calling outpostsServiceConnectionsKubernetesUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/kubernetes/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: KubernetesServiceConnectionRequestToJSON(requestParameters.kubernetesServiceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => KubernetesServiceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * KubernetesServiceConnection Viewset
   */
  outpostsServiceConnectionsKubernetesUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsKubernetesUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  outpostsServiceConnectionsKubernetesUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.uuid === null || requestParameters.uuid === void 0) {
        throw new RequiredError("uuid", "Required parameter requestParameters.uuid was null or undefined when calling outpostsServiceConnectionsKubernetesUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/outposts/service_connections/kubernetes/{uuid}/used_by/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters.uuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  outpostsServiceConnectionsKubernetesUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.outpostsServiceConnectionsKubernetesUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
};

export {
  OutpostTypeEnum,
  OutpostsApi
};
//# sourceMappingURL=chunk-VVP3K3IZ.js.map
