import {
  UserSettingFromJSON
} from "./chunk-X5TC2QXY.js";
import {
  SAMLMetadataFromJSON
} from "./chunk-ZBQTYGSF.js";
import {
  RedirectChallengeFromJSON
} from "./chunk-2G3GM457.js";
import {
  BaseAPI,
  DigestAlgorithmEnumFromJSON,
  DigestAlgorithmEnumToJSON,
  FilePathRequestToJSON,
  GroupMemberFromJSON,
  JSONApiResponse,
  PaginationFromJSON,
  PolicyEngineModeFromJSON,
  PolicyEngineModeToJSON,
  RequiredError,
  SignatureAlgorithmEnumFromJSON,
  SignatureAlgorithmEnumToJSON,
  SystemTaskFromJSON,
  TokenFromJSON,
  TypeCreateFromJSON,
  UsedByFromJSON,
  UserGroupFromJSON,
  VoidApiResponse,
  canConsumeForm,
  exists
} from "./chunk-EOF5OWT7.js";

// node_modules/@goauthentik/api/dist/esm/models/BindingTypeEnum.js
var BindingTypeEnum = {
  Redirect: "REDIRECT",
  Post: "POST",
  PostAuto: "POST_AUTO",
  UnknownDefaultOpenApi: "11184809"
};
function BindingTypeEnumFromJSON(json) {
  return BindingTypeEnumFromJSONTyped(json, false);
}
function BindingTypeEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function BindingTypeEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/LDAPDebug.js
function LDAPDebugFromJSON(json) {
  return LDAPDebugFromJSONTyped(json, false);
}
function LDAPDebugFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "user": json["user"],
    "group": json["group"],
    "membership": json["membership"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserMatchingModeEnum.js
var UserMatchingModeEnum = {
  Identifier: "identifier",
  EmailLink: "email_link",
  EmailDeny: "email_deny",
  UsernameLink: "username_link",
  UsernameDeny: "username_deny",
  UnknownDefaultOpenApi: "11184809"
};
function UserMatchingModeEnumFromJSON(json) {
  return UserMatchingModeEnumFromJSONTyped(json, false);
}
function UserMatchingModeEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function UserMatchingModeEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/LDAPSource.js
function LDAPSourceFromJSON(json) {
  return LDAPSourceFromJSONTyped(json, false);
}
function LDAPSourceFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "slug": json["slug"],
    "enabled": !exists(json, "enabled") ? void 0 : json["enabled"],
    "authenticationFlow": !exists(json, "authentication_flow") ? void 0 : json["authentication_flow"],
    "enrollmentFlow": !exists(json, "enrollment_flow") ? void 0 : json["enrollment_flow"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "policyEngineMode": !exists(json, "policy_engine_mode") ? void 0 : PolicyEngineModeFromJSON(json["policy_engine_mode"]),
    "userMatchingMode": !exists(json, "user_matching_mode") ? void 0 : UserMatchingModeEnumFromJSON(json["user_matching_mode"]),
    "managed": json["managed"],
    "userPathTemplate": !exists(json, "user_path_template") ? void 0 : json["user_path_template"],
    "icon": json["icon"],
    "serverUri": json["server_uri"],
    "peerCertificate": !exists(json, "peer_certificate") ? void 0 : json["peer_certificate"],
    "clientCertificate": !exists(json, "client_certificate") ? void 0 : json["client_certificate"],
    "bindCn": !exists(json, "bind_cn") ? void 0 : json["bind_cn"],
    "startTls": !exists(json, "start_tls") ? void 0 : json["start_tls"],
    "sni": !exists(json, "sni") ? void 0 : json["sni"],
    "baseDn": json["base_dn"],
    "additionalUserDn": !exists(json, "additional_user_dn") ? void 0 : json["additional_user_dn"],
    "additionalGroupDn": !exists(json, "additional_group_dn") ? void 0 : json["additional_group_dn"],
    "userObjectFilter": !exists(json, "user_object_filter") ? void 0 : json["user_object_filter"],
    "groupObjectFilter": !exists(json, "group_object_filter") ? void 0 : json["group_object_filter"],
    "groupMembershipField": !exists(json, "group_membership_field") ? void 0 : json["group_membership_field"],
    "objectUniquenessField": !exists(json, "object_uniqueness_field") ? void 0 : json["object_uniqueness_field"],
    "passwordLoginUpdateInternalPassword": !exists(json, "password_login_update_internal_password") ? void 0 : json["password_login_update_internal_password"],
    "syncUsers": !exists(json, "sync_users") ? void 0 : json["sync_users"],
    "syncUsersPassword": !exists(json, "sync_users_password") ? void 0 : json["sync_users_password"],
    "syncGroups": !exists(json, "sync_groups") ? void 0 : json["sync_groups"],
    "syncParentGroup": !exists(json, "sync_parent_group") ? void 0 : json["sync_parent_group"],
    "propertyMappings": !exists(json, "property_mappings") ? void 0 : json["property_mappings"],
    "propertyMappingsGroup": !exists(json, "property_mappings_group") ? void 0 : json["property_mappings_group"],
    "connectivity": json["connectivity"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/LDAPSourceRequest.js
function LDAPSourceRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "slug": value.slug,
    "enabled": value.enabled,
    "authentication_flow": value.authenticationFlow,
    "enrollment_flow": value.enrollmentFlow,
    "policy_engine_mode": PolicyEngineModeToJSON(value.policyEngineMode),
    "user_matching_mode": UserMatchingModeEnumToJSON(value.userMatchingMode),
    "user_path_template": value.userPathTemplate,
    "server_uri": value.serverUri,
    "peer_certificate": value.peerCertificate,
    "client_certificate": value.clientCertificate,
    "bind_cn": value.bindCn,
    "bind_password": value.bindPassword,
    "start_tls": value.startTls,
    "sni": value.sni,
    "base_dn": value.baseDn,
    "additional_user_dn": value.additionalUserDn,
    "additional_group_dn": value.additionalGroupDn,
    "user_object_filter": value.userObjectFilter,
    "group_object_filter": value.groupObjectFilter,
    "group_membership_field": value.groupMembershipField,
    "object_uniqueness_field": value.objectUniquenessField,
    "password_login_update_internal_password": value.passwordLoginUpdateInternalPassword,
    "sync_users": value.syncUsers,
    "sync_users_password": value.syncUsersPassword,
    "sync_groups": value.syncGroups,
    "sync_parent_group": value.syncParentGroup,
    "property_mappings": value.propertyMappings,
    "property_mappings_group": value.propertyMappingsGroup
  };
}

// node_modules/@goauthentik/api/dist/esm/models/LDAPSyncStatus.js
function LDAPSyncStatusFromJSON(json) {
  return LDAPSyncStatusFromJSONTyped(json, false);
}
function LDAPSyncStatusFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "isRunning": json["is_running"],
    "tasks": json["tasks"].map(SystemTaskFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/NameIdPolicyEnum.js
var NameIdPolicyEnum = {
  _11nameidFormatemailAddress: "urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress",
  _20nameidFormatpersistent: "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent",
  _20nameidFormatX509SubjectName: "urn:oasis:names:tc:SAML:2.0:nameid-format:X509SubjectName",
  _20nameidFormatWindowsDomainQualifiedName: "urn:oasis:names:tc:SAML:2.0:nameid-format:WindowsDomainQualifiedName",
  _20nameidFormattransient: "urn:oasis:names:tc:SAML:2.0:nameid-format:transient",
  UnknownDefaultOpenApi: "11184809"
};
function NameIdPolicyEnumFromJSON(json) {
  return NameIdPolicyEnumFromJSONTyped(json, false);
}
function NameIdPolicyEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function NameIdPolicyEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/ProviderTypeEnum.js
var ProviderTypeEnum = {
  Apple: "apple",
  Openidconnect: "openidconnect",
  Azuread: "azuread",
  Discord: "discord",
  Facebook: "facebook",
  Github: "github",
  Gitlab: "gitlab",
  Google: "google",
  Mailcow: "mailcow",
  Okta: "okta",
  Patreon: "patreon",
  Reddit: "reddit",
  Twitch: "twitch",
  Twitter: "twitter",
  UnknownDefaultOpenApi: "11184809"
};
function ProviderTypeEnumFromJSON(json) {
  return ProviderTypeEnumFromJSONTyped(json, false);
}
function ProviderTypeEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function ProviderTypeEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/SourceType.js
function SourceTypeFromJSON(json) {
  return SourceTypeFromJSONTyped(json, false);
}
function SourceTypeFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "name": json["name"],
    "verboseName": json["verbose_name"],
    "urlsCustomizable": json["urls_customizable"],
    "requestTokenUrl": json["request_token_url"],
    "authorizationUrl": json["authorization_url"],
    "accessTokenUrl": json["access_token_url"],
    "profileUrl": json["profile_url"],
    "oidcWellKnownUrl": json["oidc_well_known_url"],
    "oidcJwksUrl": json["oidc_jwks_url"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/OAuthSource.js
function OAuthSourceFromJSON(json) {
  return OAuthSourceFromJSONTyped(json, false);
}
function OAuthSourceFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "slug": json["slug"],
    "enabled": !exists(json, "enabled") ? void 0 : json["enabled"],
    "authenticationFlow": !exists(json, "authentication_flow") ? void 0 : json["authentication_flow"],
    "enrollmentFlow": !exists(json, "enrollment_flow") ? void 0 : json["enrollment_flow"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "policyEngineMode": !exists(json, "policy_engine_mode") ? void 0 : PolicyEngineModeFromJSON(json["policy_engine_mode"]),
    "userMatchingMode": !exists(json, "user_matching_mode") ? void 0 : UserMatchingModeEnumFromJSON(json["user_matching_mode"]),
    "managed": json["managed"],
    "userPathTemplate": !exists(json, "user_path_template") ? void 0 : json["user_path_template"],
    "icon": json["icon"],
    "providerType": ProviderTypeEnumFromJSON(json["provider_type"]),
    "requestTokenUrl": !exists(json, "request_token_url") ? void 0 : json["request_token_url"],
    "authorizationUrl": !exists(json, "authorization_url") ? void 0 : json["authorization_url"],
    "accessTokenUrl": !exists(json, "access_token_url") ? void 0 : json["access_token_url"],
    "profileUrl": !exists(json, "profile_url") ? void 0 : json["profile_url"],
    "consumerKey": json["consumer_key"],
    "callbackUrl": json["callback_url"],
    "additionalScopes": !exists(json, "additional_scopes") ? void 0 : json["additional_scopes"],
    "type": SourceTypeFromJSON(json["type"]),
    "oidcWellKnownUrl": !exists(json, "oidc_well_known_url") ? void 0 : json["oidc_well_known_url"],
    "oidcJwksUrl": !exists(json, "oidc_jwks_url") ? void 0 : json["oidc_jwks_url"],
    "oidcJwks": !exists(json, "oidc_jwks") ? void 0 : json["oidc_jwks"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/OAuthSourceRequest.js
function OAuthSourceRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "slug": value.slug,
    "enabled": value.enabled,
    "authentication_flow": value.authenticationFlow,
    "enrollment_flow": value.enrollmentFlow,
    "policy_engine_mode": PolicyEngineModeToJSON(value.policyEngineMode),
    "user_matching_mode": UserMatchingModeEnumToJSON(value.userMatchingMode),
    "user_path_template": value.userPathTemplate,
    "provider_type": ProviderTypeEnumToJSON(value.providerType),
    "request_token_url": value.requestTokenUrl,
    "authorization_url": value.authorizationUrl,
    "access_token_url": value.accessTokenUrl,
    "profile_url": value.profileUrl,
    "consumer_key": value.consumerKey,
    "consumer_secret": value.consumerSecret,
    "additional_scopes": value.additionalScopes,
    "oidc_well_known_url": value.oidcWellKnownUrl,
    "oidc_jwks_url": value.oidcJwksUrl,
    "oidc_jwks": value.oidcJwks
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedLDAPSourceList.js
function PaginatedLDAPSourceListFromJSON(json) {
  return PaginatedLDAPSourceListFromJSONTyped(json, false);
}
function PaginatedLDAPSourceListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(LDAPSourceFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedOAuthSourceList.js
function PaginatedOAuthSourceListFromJSON(json) {
  return PaginatedOAuthSourceListFromJSONTyped(json, false);
}
function PaginatedOAuthSourceListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(OAuthSourceFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Source.js
function SourceFromJSON(json) {
  return SourceFromJSONTyped(json, false);
}
function SourceFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "slug": json["slug"],
    "enabled": !exists(json, "enabled") ? void 0 : json["enabled"],
    "authenticationFlow": !exists(json, "authentication_flow") ? void 0 : json["authentication_flow"],
    "enrollmentFlow": !exists(json, "enrollment_flow") ? void 0 : json["enrollment_flow"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "policyEngineMode": !exists(json, "policy_engine_mode") ? void 0 : PolicyEngineModeFromJSON(json["policy_engine_mode"]),
    "userMatchingMode": !exists(json, "user_matching_mode") ? void 0 : UserMatchingModeEnumFromJSON(json["user_matching_mode"]),
    "managed": json["managed"],
    "userPathTemplate": !exists(json, "user_path_template") ? void 0 : json["user_path_template"],
    "icon": json["icon"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PlexSourceConnection.js
function PlexSourceConnectionFromJSON(json) {
  return PlexSourceConnectionFromJSONTyped(json, false);
}
function PlexSourceConnectionFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "user": json["user"],
    "source": SourceFromJSON(json["source"]),
    "identifier": json["identifier"],
    "plexToken": json["plex_token"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPlexSourceConnectionList.js
function PaginatedPlexSourceConnectionListFromJSON(json) {
  return PaginatedPlexSourceConnectionListFromJSONTyped(json, false);
}
function PaginatedPlexSourceConnectionListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PlexSourceConnectionFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PlexSource.js
function PlexSourceFromJSON(json) {
  return PlexSourceFromJSONTyped(json, false);
}
function PlexSourceFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "slug": json["slug"],
    "enabled": !exists(json, "enabled") ? void 0 : json["enabled"],
    "authenticationFlow": !exists(json, "authentication_flow") ? void 0 : json["authentication_flow"],
    "enrollmentFlow": !exists(json, "enrollment_flow") ? void 0 : json["enrollment_flow"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "policyEngineMode": !exists(json, "policy_engine_mode") ? void 0 : PolicyEngineModeFromJSON(json["policy_engine_mode"]),
    "userMatchingMode": !exists(json, "user_matching_mode") ? void 0 : UserMatchingModeEnumFromJSON(json["user_matching_mode"]),
    "managed": json["managed"],
    "userPathTemplate": !exists(json, "user_path_template") ? void 0 : json["user_path_template"],
    "icon": json["icon"],
    "clientId": !exists(json, "client_id") ? void 0 : json["client_id"],
    "allowedServers": !exists(json, "allowed_servers") ? void 0 : json["allowed_servers"],
    "allowFriends": !exists(json, "allow_friends") ? void 0 : json["allow_friends"],
    "plexToken": json["plex_token"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPlexSourceList.js
function PaginatedPlexSourceListFromJSON(json) {
  return PaginatedPlexSourceListFromJSONTyped(json, false);
}
function PaginatedPlexSourceListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PlexSourceFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SAMLSource.js
function SAMLSourceFromJSON(json) {
  return SAMLSourceFromJSONTyped(json, false);
}
function SAMLSourceFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "slug": json["slug"],
    "enabled": !exists(json, "enabled") ? void 0 : json["enabled"],
    "authenticationFlow": !exists(json, "authentication_flow") ? void 0 : json["authentication_flow"],
    "enrollmentFlow": !exists(json, "enrollment_flow") ? void 0 : json["enrollment_flow"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "policyEngineMode": !exists(json, "policy_engine_mode") ? void 0 : PolicyEngineModeFromJSON(json["policy_engine_mode"]),
    "userMatchingMode": !exists(json, "user_matching_mode") ? void 0 : UserMatchingModeEnumFromJSON(json["user_matching_mode"]),
    "managed": json["managed"],
    "userPathTemplate": !exists(json, "user_path_template") ? void 0 : json["user_path_template"],
    "icon": json["icon"],
    "preAuthenticationFlow": json["pre_authentication_flow"],
    "issuer": !exists(json, "issuer") ? void 0 : json["issuer"],
    "ssoUrl": json["sso_url"],
    "sloUrl": !exists(json, "slo_url") ? void 0 : json["slo_url"],
    "allowIdpInitiated": !exists(json, "allow_idp_initiated") ? void 0 : json["allow_idp_initiated"],
    "nameIdPolicy": !exists(json, "name_id_policy") ? void 0 : NameIdPolicyEnumFromJSON(json["name_id_policy"]),
    "bindingType": !exists(json, "binding_type") ? void 0 : BindingTypeEnumFromJSON(json["binding_type"]),
    "verificationKp": !exists(json, "verification_kp") ? void 0 : json["verification_kp"],
    "signingKp": !exists(json, "signing_kp") ? void 0 : json["signing_kp"],
    "digestAlgorithm": !exists(json, "digest_algorithm") ? void 0 : DigestAlgorithmEnumFromJSON(json["digest_algorithm"]),
    "signatureAlgorithm": !exists(json, "signature_algorithm") ? void 0 : SignatureAlgorithmEnumFromJSON(json["signature_algorithm"]),
    "temporaryUserDeleteAfter": !exists(json, "temporary_user_delete_after") ? void 0 : json["temporary_user_delete_after"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSAMLSourceList.js
function PaginatedSAMLSourceListFromJSON(json) {
  return PaginatedSAMLSourceListFromJSONTyped(json, false);
}
function PaginatedSAMLSourceListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SAMLSourceFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMSourceGroup.js
function SCIMSourceGroupFromJSON(json) {
  return SCIMSourceGroupFromJSONTyped(json, false);
}
function SCIMSourceGroupFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "id": json["id"],
    "group": json["group"],
    "groupObj": UserGroupFromJSON(json["group_obj"]),
    "source": json["source"],
    "attributes": !exists(json, "attributes") ? void 0 : json["attributes"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSCIMSourceGroupList.js
function PaginatedSCIMSourceGroupListFromJSON(json) {
  return PaginatedSCIMSourceGroupListFromJSONTyped(json, false);
}
function PaginatedSCIMSourceGroupListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SCIMSourceGroupFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMSource.js
function SCIMSourceFromJSON(json) {
  return SCIMSourceFromJSONTyped(json, false);
}
function SCIMSourceFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "slug": json["slug"],
    "enabled": !exists(json, "enabled") ? void 0 : json["enabled"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "userMatchingMode": !exists(json, "user_matching_mode") ? void 0 : UserMatchingModeEnumFromJSON(json["user_matching_mode"]),
    "managed": json["managed"],
    "userPathTemplate": !exists(json, "user_path_template") ? void 0 : json["user_path_template"],
    "rootUrl": json["root_url"],
    "tokenObj": TokenFromJSON(json["token_obj"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSCIMSourceList.js
function PaginatedSCIMSourceListFromJSON(json) {
  return PaginatedSCIMSourceListFromJSONTyped(json, false);
}
function PaginatedSCIMSourceListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SCIMSourceFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMSourceUser.js
function SCIMSourceUserFromJSON(json) {
  return SCIMSourceUserFromJSONTyped(json, false);
}
function SCIMSourceUserFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "id": json["id"],
    "user": json["user"],
    "userObj": GroupMemberFromJSON(json["user_obj"]),
    "source": json["source"],
    "attributes": !exists(json, "attributes") ? void 0 : json["attributes"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSCIMSourceUserList.js
function PaginatedSCIMSourceUserListFromJSON(json) {
  return PaginatedSCIMSourceUserListFromJSONTyped(json, false);
}
function PaginatedSCIMSourceUserListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SCIMSourceUserFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSourceList.js
function PaginatedSourceListFromJSON(json) {
  return PaginatedSourceListFromJSONTyped(json, false);
}
function PaginatedSourceListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SourceFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserOAuthSourceConnection.js
function UserOAuthSourceConnectionFromJSON(json) {
  return UserOAuthSourceConnectionFromJSONTyped(json, false);
}
function UserOAuthSourceConnectionFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "user": json["user"],
    "source": SourceFromJSON(json["source"]),
    "identifier": json["identifier"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedUserOAuthSourceConnectionList.js
function PaginatedUserOAuthSourceConnectionListFromJSON(json) {
  return PaginatedUserOAuthSourceConnectionListFromJSONTyped(json, false);
}
function PaginatedUserOAuthSourceConnectionListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(UserOAuthSourceConnectionFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserSAMLSourceConnection.js
function UserSAMLSourceConnectionFromJSON(json) {
  return UserSAMLSourceConnectionFromJSONTyped(json, false);
}
function UserSAMLSourceConnectionFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "user": json["user"],
    "source": SourceFromJSON(json["source"]),
    "identifier": json["identifier"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedUserSAMLSourceConnectionList.js
function PaginatedUserSAMLSourceConnectionListFromJSON(json) {
  return PaginatedUserSAMLSourceConnectionListFromJSONTyped(json, false);
}
function PaginatedUserSAMLSourceConnectionListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(UserSAMLSourceConnectionFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserSourceConnection.js
function UserSourceConnectionFromJSON(json) {
  return UserSourceConnectionFromJSONTyped(json, false);
}
function UserSourceConnectionFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "user": json["user"],
    "source": SourceFromJSON(json["source"]),
    "created": new Date(json["created"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedUserSourceConnectionList.js
function PaginatedUserSourceConnectionListFromJSON(json) {
  return PaginatedUserSourceConnectionListFromJSONTyped(json, false);
}
function PaginatedUserSourceConnectionListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(UserSourceConnectionFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedLDAPSourceRequest.js
function PatchedLDAPSourceRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "slug": value.slug,
    "enabled": value.enabled,
    "authentication_flow": value.authenticationFlow,
    "enrollment_flow": value.enrollmentFlow,
    "policy_engine_mode": PolicyEngineModeToJSON(value.policyEngineMode),
    "user_matching_mode": UserMatchingModeEnumToJSON(value.userMatchingMode),
    "user_path_template": value.userPathTemplate,
    "server_uri": value.serverUri,
    "peer_certificate": value.peerCertificate,
    "client_certificate": value.clientCertificate,
    "bind_cn": value.bindCn,
    "bind_password": value.bindPassword,
    "start_tls": value.startTls,
    "sni": value.sni,
    "base_dn": value.baseDn,
    "additional_user_dn": value.additionalUserDn,
    "additional_group_dn": value.additionalGroupDn,
    "user_object_filter": value.userObjectFilter,
    "group_object_filter": value.groupObjectFilter,
    "group_membership_field": value.groupMembershipField,
    "object_uniqueness_field": value.objectUniquenessField,
    "password_login_update_internal_password": value.passwordLoginUpdateInternalPassword,
    "sync_users": value.syncUsers,
    "sync_users_password": value.syncUsersPassword,
    "sync_groups": value.syncGroups,
    "sync_parent_group": value.syncParentGroup,
    "property_mappings": value.propertyMappings,
    "property_mappings_group": value.propertyMappingsGroup
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedOAuthSourceRequest.js
function PatchedOAuthSourceRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "slug": value.slug,
    "enabled": value.enabled,
    "authentication_flow": value.authenticationFlow,
    "enrollment_flow": value.enrollmentFlow,
    "policy_engine_mode": PolicyEngineModeToJSON(value.policyEngineMode),
    "user_matching_mode": UserMatchingModeEnumToJSON(value.userMatchingMode),
    "user_path_template": value.userPathTemplate,
    "provider_type": ProviderTypeEnumToJSON(value.providerType),
    "request_token_url": value.requestTokenUrl,
    "authorization_url": value.authorizationUrl,
    "access_token_url": value.accessTokenUrl,
    "profile_url": value.profileUrl,
    "consumer_key": value.consumerKey,
    "consumer_secret": value.consumerSecret,
    "additional_scopes": value.additionalScopes,
    "oidc_well_known_url": value.oidcWellKnownUrl,
    "oidc_jwks_url": value.oidcJwksUrl,
    "oidc_jwks": value.oidcJwks
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedPlexSourceConnectionRequest.js
function PatchedPlexSourceConnectionRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "identifier": value.identifier,
    "plex_token": value.plexToken
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedPlexSourceRequest.js
function PatchedPlexSourceRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "slug": value.slug,
    "enabled": value.enabled,
    "authentication_flow": value.authenticationFlow,
    "enrollment_flow": value.enrollmentFlow,
    "policy_engine_mode": PolicyEngineModeToJSON(value.policyEngineMode),
    "user_matching_mode": UserMatchingModeEnumToJSON(value.userMatchingMode),
    "user_path_template": value.userPathTemplate,
    "client_id": value.clientId,
    "allowed_servers": value.allowedServers,
    "allow_friends": value.allowFriends,
    "plex_token": value.plexToken
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSAMLSourceRequest.js
function PatchedSAMLSourceRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "slug": value.slug,
    "enabled": value.enabled,
    "authentication_flow": value.authenticationFlow,
    "enrollment_flow": value.enrollmentFlow,
    "policy_engine_mode": PolicyEngineModeToJSON(value.policyEngineMode),
    "user_matching_mode": UserMatchingModeEnumToJSON(value.userMatchingMode),
    "user_path_template": value.userPathTemplate,
    "pre_authentication_flow": value.preAuthenticationFlow,
    "issuer": value.issuer,
    "sso_url": value.ssoUrl,
    "slo_url": value.sloUrl,
    "allow_idp_initiated": value.allowIdpInitiated,
    "name_id_policy": NameIdPolicyEnumToJSON(value.nameIdPolicy),
    "binding_type": BindingTypeEnumToJSON(value.bindingType),
    "verification_kp": value.verificationKp,
    "signing_kp": value.signingKp,
    "digest_algorithm": DigestAlgorithmEnumToJSON(value.digestAlgorithm),
    "signature_algorithm": SignatureAlgorithmEnumToJSON(value.signatureAlgorithm),
    "temporary_user_delete_after": value.temporaryUserDeleteAfter
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSCIMSourceGroupRequest.js
function PatchedSCIMSourceGroupRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "id": value.id,
    "group": value.group,
    "source": value.source,
    "attributes": value.attributes
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSCIMSourceRequest.js
function PatchedSCIMSourceRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "slug": value.slug,
    "enabled": value.enabled,
    "user_matching_mode": UserMatchingModeEnumToJSON(value.userMatchingMode),
    "user_path_template": value.userPathTemplate
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSCIMSourceUserRequest.js
function PatchedSCIMSourceUserRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "id": value.id,
    "user": value.user,
    "source": value.source,
    "attributes": value.attributes
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedUserOAuthSourceConnectionRequest.js
function PatchedUserOAuthSourceConnectionRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "user": value.user,
    "identifier": value.identifier,
    "access_token": value.accessToken
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedUserSAMLSourceConnectionRequest.js
function PatchedUserSAMLSourceConnectionRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "user": value.user,
    "identifier": value.identifier
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PlexSourceConnectionRequest.js
function PlexSourceConnectionRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "identifier": value.identifier,
    "plex_token": value.plexToken
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PlexSourceRequest.js
function PlexSourceRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "slug": value.slug,
    "enabled": value.enabled,
    "authentication_flow": value.authenticationFlow,
    "enrollment_flow": value.enrollmentFlow,
    "policy_engine_mode": PolicyEngineModeToJSON(value.policyEngineMode),
    "user_matching_mode": UserMatchingModeEnumToJSON(value.userMatchingMode),
    "user_path_template": value.userPathTemplate,
    "client_id": value.clientId,
    "allowed_servers": value.allowedServers,
    "allow_friends": value.allowFriends,
    "plex_token": value.plexToken
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PlexTokenRedeemRequest.js
function PlexTokenRedeemRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "plex_token": value.plexToken
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SAMLSourceRequest.js
function SAMLSourceRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "slug": value.slug,
    "enabled": value.enabled,
    "authentication_flow": value.authenticationFlow,
    "enrollment_flow": value.enrollmentFlow,
    "policy_engine_mode": PolicyEngineModeToJSON(value.policyEngineMode),
    "user_matching_mode": UserMatchingModeEnumToJSON(value.userMatchingMode),
    "user_path_template": value.userPathTemplate,
    "pre_authentication_flow": value.preAuthenticationFlow,
    "issuer": value.issuer,
    "sso_url": value.ssoUrl,
    "slo_url": value.sloUrl,
    "allow_idp_initiated": value.allowIdpInitiated,
    "name_id_policy": NameIdPolicyEnumToJSON(value.nameIdPolicy),
    "binding_type": BindingTypeEnumToJSON(value.bindingType),
    "verification_kp": value.verificationKp,
    "signing_kp": value.signingKp,
    "digest_algorithm": DigestAlgorithmEnumToJSON(value.digestAlgorithm),
    "signature_algorithm": SignatureAlgorithmEnumToJSON(value.signatureAlgorithm),
    "temporary_user_delete_after": value.temporaryUserDeleteAfter
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMSourceGroupRequest.js
function SCIMSourceGroupRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "id": value.id,
    "group": value.group,
    "source": value.source,
    "attributes": value.attributes
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMSourceRequest.js
function SCIMSourceRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "slug": value.slug,
    "enabled": value.enabled,
    "user_matching_mode": UserMatchingModeEnumToJSON(value.userMatchingMode),
    "user_path_template": value.userPathTemplate
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMSourceUserRequest.js
function SCIMSourceUserRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "id": value.id,
    "user": value.user,
    "source": value.source,
    "attributes": value.attributes
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserOAuthSourceConnectionRequest.js
function UserOAuthSourceConnectionRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "user": value.user,
    "identifier": value.identifier,
    "access_token": value.accessToken
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserSAMLSourceConnectionRequest.js
function UserSAMLSourceConnectionRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "user": value.user,
    "identifier": value.identifier
  };
}

// node_modules/@goauthentik/api/dist/esm/apis/SourcesApi.js
var __awaiter = function(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var SourcesApi = class extends BaseAPI {
  /**
   * Source Viewset
   */
  sourcesAllDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesAllDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/all/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Source Viewset
   */
  sourcesAllDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesAllDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Source Viewset
   */
  sourcesAllListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managed !== void 0) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.slug !== void 0) {
        queryParameters["slug"] = requestParameters.slug;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/all/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSourceListFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesAllList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesAllListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesAllRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesAllRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/all/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SourceFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesAllRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesAllRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Set source icon
   */
  sourcesAllSetIconCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesAllSetIconCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const consumes = [
        { contentType: "multipart/form-data" }
      ];
      const canConsumeForm2 = canConsumeForm(consumes);
      let formParams;
      let useForm = false;
      useForm = canConsumeForm2;
      if (useForm) {
        formParams = new FormData();
      } else {
        formParams = new URLSearchParams();
      }
      if (requestParameters.file !== void 0) {
        formParams.append("file", requestParameters.file);
      }
      if (requestParameters.clear !== void 0) {
        formParams.append("clear", requestParameters.clear);
      }
      const response = yield this.request({
        path: `/sources/all/{slug}/set_icon/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: formParams
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Set source icon
   */
  sourcesAllSetIconCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesAllSetIconCreateRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Set source icon (as URL)
   */
  sourcesAllSetIconUrlCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesAllSetIconUrlCreate.");
      }
      if (requestParameters.filePathRequest === null || requestParameters.filePathRequest === void 0) {
        throw new RequiredError("filePathRequest", "Required parameter requestParameters.filePathRequest was null or undefined when calling sourcesAllSetIconUrlCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/all/{slug}/set_icon_url/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: FilePathRequestToJSON(requestParameters.filePathRequest)
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Set source icon (as URL)
   */
  sourcesAllSetIconUrlCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesAllSetIconUrlCreateRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Get all creatable source types
   */
  sourcesAllTypesListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/all/types/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(TypeCreateFromJSON));
    });
  }
  /**
   * Get all creatable source types
   */
  sourcesAllTypesList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesAllTypesListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesAllUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesAllUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/all/{slug}/used_by/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesAllUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesAllUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get all sources the user can configure
   */
  sourcesAllUserSettingsListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/all/user_settings/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UserSettingFromJSON));
    });
  }
  /**
   * Get all sources the user can configure
   */
  sourcesAllUserSettingsList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesAllUserSettingsListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP Source Viewset
   */
  sourcesLdapCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.lDAPSourceRequest === null || requestParameters.lDAPSourceRequest === void 0) {
        throw new RequiredError("lDAPSourceRequest", "Required parameter requestParameters.lDAPSourceRequest was null or undefined when calling sourcesLdapCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/ldap/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: LDAPSourceRequestToJSON(requestParameters.lDAPSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPSourceFromJSON(jsonValue));
    });
  }
  /**
   * LDAP Source Viewset
   */
  sourcesLdapCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesLdapCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get raw LDAP data to debug
   */
  sourcesLdapDebugRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesLdapDebugRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/ldap/{slug}/debug/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPDebugFromJSON(jsonValue));
    });
  }
  /**
   * Get raw LDAP data to debug
   */
  sourcesLdapDebugRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesLdapDebugRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP Source Viewset
   */
  sourcesLdapDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesLdapDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/ldap/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * LDAP Source Viewset
   */
  sourcesLdapDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesLdapDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * LDAP Source Viewset
   */
  sourcesLdapListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.additionalGroupDn !== void 0) {
        queryParameters["additional_group_dn"] = requestParameters.additionalGroupDn;
      }
      if (requestParameters.additionalUserDn !== void 0) {
        queryParameters["additional_user_dn"] = requestParameters.additionalUserDn;
      }
      if (requestParameters.baseDn !== void 0) {
        queryParameters["base_dn"] = requestParameters.baseDn;
      }
      if (requestParameters.bindCn !== void 0) {
        queryParameters["bind_cn"] = requestParameters.bindCn;
      }
      if (requestParameters.clientCertificate !== void 0) {
        queryParameters["client_certificate"] = requestParameters.clientCertificate;
      }
      if (requestParameters.enabled !== void 0) {
        queryParameters["enabled"] = requestParameters.enabled;
      }
      if (requestParameters.groupMembershipField !== void 0) {
        queryParameters["group_membership_field"] = requestParameters.groupMembershipField;
      }
      if (requestParameters.groupObjectFilter !== void 0) {
        queryParameters["group_object_filter"] = requestParameters.groupObjectFilter;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.objectUniquenessField !== void 0) {
        queryParameters["object_uniqueness_field"] = requestParameters.objectUniquenessField;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.passwordLoginUpdateInternalPassword !== void 0) {
        queryParameters["password_login_update_internal_password"] = requestParameters.passwordLoginUpdateInternalPassword;
      }
      if (requestParameters.peerCertificate !== void 0) {
        queryParameters["peer_certificate"] = requestParameters.peerCertificate;
      }
      if (requestParameters.propertyMappings) {
        queryParameters["property_mappings"] = requestParameters.propertyMappings;
      }
      if (requestParameters.propertyMappingsGroup) {
        queryParameters["property_mappings_group"] = requestParameters.propertyMappingsGroup;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.serverUri !== void 0) {
        queryParameters["server_uri"] = requestParameters.serverUri;
      }
      if (requestParameters.slug !== void 0) {
        queryParameters["slug"] = requestParameters.slug;
      }
      if (requestParameters.sni !== void 0) {
        queryParameters["sni"] = requestParameters.sni;
      }
      if (requestParameters.startTls !== void 0) {
        queryParameters["start_tls"] = requestParameters.startTls;
      }
      if (requestParameters.syncGroups !== void 0) {
        queryParameters["sync_groups"] = requestParameters.syncGroups;
      }
      if (requestParameters.syncParentGroup !== void 0) {
        queryParameters["sync_parent_group"] = requestParameters.syncParentGroup;
      }
      if (requestParameters.syncUsers !== void 0) {
        queryParameters["sync_users"] = requestParameters.syncUsers;
      }
      if (requestParameters.syncUsersPassword !== void 0) {
        queryParameters["sync_users_password"] = requestParameters.syncUsersPassword;
      }
      if (requestParameters.userObjectFilter !== void 0) {
        queryParameters["user_object_filter"] = requestParameters.userObjectFilter;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/ldap/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedLDAPSourceListFromJSON(jsonValue));
    });
  }
  /**
   * LDAP Source Viewset
   */
  sourcesLdapList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesLdapListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP Source Viewset
   */
  sourcesLdapPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesLdapPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/ldap/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedLDAPSourceRequestToJSON(requestParameters.patchedLDAPSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPSourceFromJSON(jsonValue));
    });
  }
  /**
   * LDAP Source Viewset
   */
  sourcesLdapPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesLdapPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP Source Viewset
   */
  sourcesLdapRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesLdapRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/ldap/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPSourceFromJSON(jsonValue));
    });
  }
  /**
   * LDAP Source Viewset
   */
  sourcesLdapRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesLdapRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get source\'s sync status
   */
  sourcesLdapSyncStatusRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesLdapSyncStatusRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/ldap/{slug}/sync_status/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPSyncStatusFromJSON(jsonValue));
    });
  }
  /**
   * Get source\'s sync status
   */
  sourcesLdapSyncStatusRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesLdapSyncStatusRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP Source Viewset
   */
  sourcesLdapUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesLdapUpdate.");
      }
      if (requestParameters.lDAPSourceRequest === null || requestParameters.lDAPSourceRequest === void 0) {
        throw new RequiredError("lDAPSourceRequest", "Required parameter requestParameters.lDAPSourceRequest was null or undefined when calling sourcesLdapUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/ldap/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: LDAPSourceRequestToJSON(requestParameters.lDAPSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPSourceFromJSON(jsonValue));
    });
  }
  /**
   * LDAP Source Viewset
   */
  sourcesLdapUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesLdapUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesLdapUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesLdapUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/ldap/{slug}/used_by/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesLdapUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesLdapUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesOauthCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.oAuthSourceRequest === null || requestParameters.oAuthSourceRequest === void 0) {
        throw new RequiredError("oAuthSourceRequest", "Required parameter requestParameters.oAuthSourceRequest was null or undefined when calling sourcesOauthCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/oauth/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: OAuthSourceRequestToJSON(requestParameters.oAuthSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OAuthSourceFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesOauthCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesOauthCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesOauthDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesOauthDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/oauth/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Source Viewset
   */
  sourcesOauthDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesOauthDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Source Viewset
   */
  sourcesOauthListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.accessTokenUrl !== void 0) {
        queryParameters["access_token_url"] = requestParameters.accessTokenUrl;
      }
      if (requestParameters.additionalScopes !== void 0) {
        queryParameters["additional_scopes"] = requestParameters.additionalScopes;
      }
      if (requestParameters.authenticationFlow !== void 0) {
        queryParameters["authentication_flow"] = requestParameters.authenticationFlow;
      }
      if (requestParameters.authorizationUrl !== void 0) {
        queryParameters["authorization_url"] = requestParameters.authorizationUrl;
      }
      if (requestParameters.consumerKey !== void 0) {
        queryParameters["consumer_key"] = requestParameters.consumerKey;
      }
      if (requestParameters.enabled !== void 0) {
        queryParameters["enabled"] = requestParameters.enabled;
      }
      if (requestParameters.enrollmentFlow !== void 0) {
        queryParameters["enrollment_flow"] = requestParameters.enrollmentFlow;
      }
      if (requestParameters.hasJwks !== void 0) {
        queryParameters["has_jwks"] = requestParameters.hasJwks;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.policyEngineMode !== void 0) {
        queryParameters["policy_engine_mode"] = requestParameters.policyEngineMode;
      }
      if (requestParameters.profileUrl !== void 0) {
        queryParameters["profile_url"] = requestParameters.profileUrl;
      }
      if (requestParameters.providerType !== void 0) {
        queryParameters["provider_type"] = requestParameters.providerType;
      }
      if (requestParameters.requestTokenUrl !== void 0) {
        queryParameters["request_token_url"] = requestParameters.requestTokenUrl;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.slug !== void 0) {
        queryParameters["slug"] = requestParameters.slug;
      }
      if (requestParameters.userMatchingMode !== void 0) {
        queryParameters["user_matching_mode"] = requestParameters.userMatchingMode;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/oauth/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedOAuthSourceListFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesOauthList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesOauthListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesOauthPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesOauthPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/oauth/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedOAuthSourceRequestToJSON(requestParameters.patchedOAuthSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OAuthSourceFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesOauthPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesOauthPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesOauthRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesOauthRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/oauth/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OAuthSourceFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesOauthRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesOauthRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get all creatable source types. If ?name is set, only returns the type for <name>. If <name> isn\'t found, returns the default type.
   */
  sourcesOauthSourceTypesListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/oauth/source_types/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(SourceTypeFromJSON));
    });
  }
  /**
   * Get all creatable source types. If ?name is set, only returns the type for <name>. If <name> isn\'t found, returns the default type.
   */
  sourcesOauthSourceTypesList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesOauthSourceTypesListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesOauthUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesOauthUpdate.");
      }
      if (requestParameters.oAuthSourceRequest === null || requestParameters.oAuthSourceRequest === void 0) {
        throw new RequiredError("oAuthSourceRequest", "Required parameter requestParameters.oAuthSourceRequest was null or undefined when calling sourcesOauthUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/oauth/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: OAuthSourceRequestToJSON(requestParameters.oAuthSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OAuthSourceFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesOauthUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesOauthUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesOauthUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesOauthUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/oauth/{slug}/used_by/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesOauthUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesOauthUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Plex source Viewset
   */
  sourcesPlexCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.plexSourceRequest === null || requestParameters.plexSourceRequest === void 0) {
        throw new RequiredError("plexSourceRequest", "Required parameter requestParameters.plexSourceRequest was null or undefined when calling sourcesPlexCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/plex/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PlexSourceRequestToJSON(requestParameters.plexSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PlexSourceFromJSON(jsonValue));
    });
  }
  /**
   * Plex source Viewset
   */
  sourcesPlexCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesPlexCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Plex source Viewset
   */
  sourcesPlexDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesPlexDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/plex/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Plex source Viewset
   */
  sourcesPlexDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesPlexDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Plex source Viewset
   */
  sourcesPlexListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.allowFriends !== void 0) {
        queryParameters["allow_friends"] = requestParameters.allowFriends;
      }
      if (requestParameters.authenticationFlow !== void 0) {
        queryParameters["authentication_flow"] = requestParameters.authenticationFlow;
      }
      if (requestParameters.clientId !== void 0) {
        queryParameters["client_id"] = requestParameters.clientId;
      }
      if (requestParameters.enabled !== void 0) {
        queryParameters["enabled"] = requestParameters.enabled;
      }
      if (requestParameters.enrollmentFlow !== void 0) {
        queryParameters["enrollment_flow"] = requestParameters.enrollmentFlow;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.policyEngineMode !== void 0) {
        queryParameters["policy_engine_mode"] = requestParameters.policyEngineMode;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.slug !== void 0) {
        queryParameters["slug"] = requestParameters.slug;
      }
      if (requestParameters.userMatchingMode !== void 0) {
        queryParameters["user_matching_mode"] = requestParameters.userMatchingMode;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/plex/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPlexSourceListFromJSON(jsonValue));
    });
  }
  /**
   * Plex source Viewset
   */
  sourcesPlexList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesPlexListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Plex source Viewset
   */
  sourcesPlexPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesPlexPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/plex/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedPlexSourceRequestToJSON(requestParameters.patchedPlexSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PlexSourceFromJSON(jsonValue));
    });
  }
  /**
   * Plex source Viewset
   */
  sourcesPlexPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesPlexPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Redeem a plex token for an authenticated user, creating a connection
   */
  sourcesPlexRedeemTokenAuthenticatedCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.plexTokenRedeemRequest === null || requestParameters.plexTokenRedeemRequest === void 0) {
        throw new RequiredError("plexTokenRedeemRequest", "Required parameter requestParameters.plexTokenRedeemRequest was null or undefined when calling sourcesPlexRedeemTokenAuthenticatedCreate.");
      }
      const queryParameters = {};
      if (requestParameters.slug !== void 0) {
        queryParameters["slug"] = requestParameters.slug;
      }
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/plex/redeem_token_authenticated/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PlexTokenRedeemRequestToJSON(requestParameters.plexTokenRedeemRequest)
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Redeem a plex token for an authenticated user, creating a connection
   */
  sourcesPlexRedeemTokenAuthenticatedCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesPlexRedeemTokenAuthenticatedCreateRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Redeem a plex token, check it\'s access to resources against what\'s allowed for the source, and redirect to an authentication/enrollment flow.
   */
  sourcesPlexRedeemTokenCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.plexTokenRedeemRequest === null || requestParameters.plexTokenRedeemRequest === void 0) {
        throw new RequiredError("plexTokenRedeemRequest", "Required parameter requestParameters.plexTokenRedeemRequest was null or undefined when calling sourcesPlexRedeemTokenCreate.");
      }
      const queryParameters = {};
      if (requestParameters.slug !== void 0) {
        queryParameters["slug"] = requestParameters.slug;
      }
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/plex/redeem_token/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PlexTokenRedeemRequestToJSON(requestParameters.plexTokenRedeemRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RedirectChallengeFromJSON(jsonValue));
    });
  }
  /**
   * Redeem a plex token, check it\'s access to resources against what\'s allowed for the source, and redirect to an authentication/enrollment flow.
   */
  sourcesPlexRedeemTokenCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesPlexRedeemTokenCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Plex source Viewset
   */
  sourcesPlexRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesPlexRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/plex/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PlexSourceFromJSON(jsonValue));
    });
  }
  /**
   * Plex source Viewset
   */
  sourcesPlexRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesPlexRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Plex source Viewset
   */
  sourcesPlexUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesPlexUpdate.");
      }
      if (requestParameters.plexSourceRequest === null || requestParameters.plexSourceRequest === void 0) {
        throw new RequiredError("plexSourceRequest", "Required parameter requestParameters.plexSourceRequest was null or undefined when calling sourcesPlexUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/plex/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: PlexSourceRequestToJSON(requestParameters.plexSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PlexSourceFromJSON(jsonValue));
    });
  }
  /**
   * Plex source Viewset
   */
  sourcesPlexUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesPlexUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesPlexUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesPlexUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/plex/{slug}/used_by/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesPlexUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesPlexUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLSource Viewset
   */
  sourcesSamlCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sAMLSourceRequest === null || requestParameters.sAMLSourceRequest === void 0) {
        throw new RequiredError("sAMLSourceRequest", "Required parameter requestParameters.sAMLSourceRequest was null or undefined when calling sourcesSamlCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/saml/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SAMLSourceRequestToJSON(requestParameters.sAMLSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLSourceFromJSON(jsonValue));
    });
  }
  /**
   * SAMLSource Viewset
   */
  sourcesSamlCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesSamlCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLSource Viewset
   */
  sourcesSamlDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesSamlDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/saml/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SAMLSource Viewset
   */
  sourcesSamlDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesSamlDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SAMLSource Viewset
   */
  sourcesSamlListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.allowIdpInitiated !== void 0) {
        queryParameters["allow_idp_initiated"] = requestParameters.allowIdpInitiated;
      }
      if (requestParameters.authenticationFlow !== void 0) {
        queryParameters["authentication_flow"] = requestParameters.authenticationFlow;
      }
      if (requestParameters.bindingType !== void 0) {
        queryParameters["binding_type"] = requestParameters.bindingType;
      }
      if (requestParameters.digestAlgorithm !== void 0) {
        queryParameters["digest_algorithm"] = requestParameters.digestAlgorithm;
      }
      if (requestParameters.enabled !== void 0) {
        queryParameters["enabled"] = requestParameters.enabled;
      }
      if (requestParameters.enrollmentFlow !== void 0) {
        queryParameters["enrollment_flow"] = requestParameters.enrollmentFlow;
      }
      if (requestParameters.issuer !== void 0) {
        queryParameters["issuer"] = requestParameters.issuer;
      }
      if (requestParameters.managed !== void 0) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.nameIdPolicy !== void 0) {
        queryParameters["name_id_policy"] = requestParameters.nameIdPolicy;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.policyEngineMode !== void 0) {
        queryParameters["policy_engine_mode"] = requestParameters.policyEngineMode;
      }
      if (requestParameters.preAuthenticationFlow !== void 0) {
        queryParameters["pre_authentication_flow"] = requestParameters.preAuthenticationFlow;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.signatureAlgorithm !== void 0) {
        queryParameters["signature_algorithm"] = requestParameters.signatureAlgorithm;
      }
      if (requestParameters.signingKp !== void 0) {
        queryParameters["signing_kp"] = requestParameters.signingKp;
      }
      if (requestParameters.sloUrl !== void 0) {
        queryParameters["slo_url"] = requestParameters.sloUrl;
      }
      if (requestParameters.slug !== void 0) {
        queryParameters["slug"] = requestParameters.slug;
      }
      if (requestParameters.ssoUrl !== void 0) {
        queryParameters["sso_url"] = requestParameters.ssoUrl;
      }
      if (requestParameters.temporaryUserDeleteAfter !== void 0) {
        queryParameters["temporary_user_delete_after"] = requestParameters.temporaryUserDeleteAfter;
      }
      if (requestParameters.userMatchingMode !== void 0) {
        queryParameters["user_matching_mode"] = requestParameters.userMatchingMode;
      }
      if (requestParameters.verificationKp !== void 0) {
        queryParameters["verification_kp"] = requestParameters.verificationKp;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/saml/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSAMLSourceListFromJSON(jsonValue));
    });
  }
  /**
   * SAMLSource Viewset
   */
  sourcesSamlList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesSamlListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Return metadata as XML string
   */
  sourcesSamlMetadataRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesSamlMetadataRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/saml/{slug}/metadata/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLMetadataFromJSON(jsonValue));
    });
  }
  /**
   * Return metadata as XML string
   */
  sourcesSamlMetadataRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesSamlMetadataRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLSource Viewset
   */
  sourcesSamlPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesSamlPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/saml/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSAMLSourceRequestToJSON(requestParameters.patchedSAMLSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLSourceFromJSON(jsonValue));
    });
  }
  /**
   * SAMLSource Viewset
   */
  sourcesSamlPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesSamlPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLSource Viewset
   */
  sourcesSamlRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesSamlRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/saml/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLSourceFromJSON(jsonValue));
    });
  }
  /**
   * SAMLSource Viewset
   */
  sourcesSamlRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesSamlRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLSource Viewset
   */
  sourcesSamlUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesSamlUpdate.");
      }
      if (requestParameters.sAMLSourceRequest === null || requestParameters.sAMLSourceRequest === void 0) {
        throw new RequiredError("sAMLSourceRequest", "Required parameter requestParameters.sAMLSourceRequest was null or undefined when calling sourcesSamlUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/saml/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SAMLSourceRequestToJSON(requestParameters.sAMLSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLSourceFromJSON(jsonValue));
    });
  }
  /**
   * SAMLSource Viewset
   */
  sourcesSamlUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesSamlUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesSamlUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesSamlUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/saml/{slug}/used_by/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesSamlUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesSamlUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSource Viewset
   */
  sourcesScimCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sCIMSourceRequest === null || requestParameters.sCIMSourceRequest === void 0) {
        throw new RequiredError("sCIMSourceRequest", "Required parameter requestParameters.sCIMSourceRequest was null or undefined when calling sourcesScimCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMSourceRequestToJSON(requestParameters.sCIMSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourceFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSource Viewset
   */
  sourcesScimCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSource Viewset
   */
  sourcesScimDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesScimDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SCIMSource Viewset
   */
  sourcesScimDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesScimDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SCIMSourceGroup Viewset
   */
  sourcesScimGroupsCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sCIMSourceGroupRequest === null || requestParameters.sCIMSourceGroupRequest === void 0) {
        throw new RequiredError("sCIMSourceGroupRequest", "Required parameter requestParameters.sCIMSourceGroupRequest was null or undefined when calling sourcesScimGroupsCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim_groups/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMSourceGroupRequestToJSON(requestParameters.sCIMSourceGroupRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourceGroupFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourceGroup Viewset
   */
  sourcesScimGroupsCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimGroupsCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSourceGroup Viewset
   */
  sourcesScimGroupsDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesScimGroupsDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim_groups/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SCIMSourceGroup Viewset
   */
  sourcesScimGroupsDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesScimGroupsDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SCIMSourceGroup Viewset
   */
  sourcesScimGroupsListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.groupGroupUuid !== void 0) {
        queryParameters["group__group_uuid"] = requestParameters.groupGroupUuid;
      }
      if (requestParameters.groupName !== void 0) {
        queryParameters["group__name"] = requestParameters.groupName;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.sourceSlug !== void 0) {
        queryParameters["source__slug"] = requestParameters.sourceSlug;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim_groups/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSCIMSourceGroupListFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourceGroup Viewset
   */
  sourcesScimGroupsList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimGroupsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSourceGroup Viewset
   */
  sourcesScimGroupsPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesScimGroupsPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim_groups/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSCIMSourceGroupRequestToJSON(requestParameters.patchedSCIMSourceGroupRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourceGroupFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourceGroup Viewset
   */
  sourcesScimGroupsPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimGroupsPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSourceGroup Viewset
   */
  sourcesScimGroupsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesScimGroupsRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim_groups/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourceGroupFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourceGroup Viewset
   */
  sourcesScimGroupsRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimGroupsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSourceGroup Viewset
   */
  sourcesScimGroupsUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesScimGroupsUpdate.");
      }
      if (requestParameters.sCIMSourceGroupRequest === null || requestParameters.sCIMSourceGroupRequest === void 0) {
        throw new RequiredError("sCIMSourceGroupRequest", "Required parameter requestParameters.sCIMSourceGroupRequest was null or undefined when calling sourcesScimGroupsUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim_groups/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMSourceGroupRequestToJSON(requestParameters.sCIMSourceGroupRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourceGroupFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourceGroup Viewset
   */
  sourcesScimGroupsUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimGroupsUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesScimGroupsUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesScimGroupsUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim_groups/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesScimGroupsUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimGroupsUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSource Viewset
   */
  sourcesScimListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.slug !== void 0) {
        queryParameters["slug"] = requestParameters.slug;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSCIMSourceListFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSource Viewset
   */
  sourcesScimList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSource Viewset
   */
  sourcesScimPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesScimPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSCIMSourceRequestToJSON(requestParameters.patchedSCIMSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourceFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSource Viewset
   */
  sourcesScimPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSource Viewset
   */
  sourcesScimRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesScimRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourceFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSource Viewset
   */
  sourcesScimRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSource Viewset
   */
  sourcesScimUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesScimUpdate.");
      }
      if (requestParameters.sCIMSourceRequest === null || requestParameters.sCIMSourceRequest === void 0) {
        throw new RequiredError("sCIMSourceRequest", "Required parameter requestParameters.sCIMSourceRequest was null or undefined when calling sourcesScimUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim/{slug}/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMSourceRequestToJSON(requestParameters.sCIMSourceRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourceFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSource Viewset
   */
  sourcesScimUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesScimUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.slug === null || requestParameters.slug === void 0) {
        throw new RequiredError("slug", "Required parameter requestParameters.slug was null or undefined when calling sourcesScimUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim/{slug}/used_by/`.replace(`{${"slug"}}`, encodeURIComponent(String(requestParameters.slug))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesScimUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSourceUser Viewset
   */
  sourcesScimUsersCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sCIMSourceUserRequest === null || requestParameters.sCIMSourceUserRequest === void 0) {
        throw new RequiredError("sCIMSourceUserRequest", "Required parameter requestParameters.sCIMSourceUserRequest was null or undefined when calling sourcesScimUsersCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim_users/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMSourceUserRequestToJSON(requestParameters.sCIMSourceUserRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourceUserFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourceUser Viewset
   */
  sourcesScimUsersCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimUsersCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSourceUser Viewset
   */
  sourcesScimUsersDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesScimUsersDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim_users/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SCIMSourceUser Viewset
   */
  sourcesScimUsersDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesScimUsersDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SCIMSourceUser Viewset
   */
  sourcesScimUsersListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.sourceSlug !== void 0) {
        queryParameters["source__slug"] = requestParameters.sourceSlug;
      }
      if (requestParameters.userId !== void 0) {
        queryParameters["user__id"] = requestParameters.userId;
      }
      if (requestParameters.userUsername !== void 0) {
        queryParameters["user__username"] = requestParameters.userUsername;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim_users/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSCIMSourceUserListFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourceUser Viewset
   */
  sourcesScimUsersList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimUsersListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSourceUser Viewset
   */
  sourcesScimUsersPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesScimUsersPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim_users/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSCIMSourceUserRequestToJSON(requestParameters.patchedSCIMSourceUserRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourceUserFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourceUser Viewset
   */
  sourcesScimUsersPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimUsersPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSourceUser Viewset
   */
  sourcesScimUsersRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesScimUsersRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim_users/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourceUserFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourceUser Viewset
   */
  sourcesScimUsersRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimUsersRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSourceUser Viewset
   */
  sourcesScimUsersUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesScimUsersUpdate.");
      }
      if (requestParameters.sCIMSourceUserRequest === null || requestParameters.sCIMSourceUserRequest === void 0) {
        throw new RequiredError("sCIMSourceUserRequest", "Required parameter requestParameters.sCIMSourceUserRequest was null or undefined when calling sourcesScimUsersUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim_users/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMSourceUserRequestToJSON(requestParameters.sCIMSourceUserRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourceUserFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourceUser Viewset
   */
  sourcesScimUsersUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimUsersUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesScimUsersUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesScimUsersUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/scim_users/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesScimUsersUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesScimUsersUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * User-source connection Viewset
   */
  sourcesUserConnectionsAllDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsAllDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/all/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * User-source connection Viewset
   */
  sourcesUserConnectionsAllDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesUserConnectionsAllDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * User-source connection Viewset
   */
  sourcesUserConnectionsAllListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.user !== void 0) {
        queryParameters["user"] = requestParameters.user;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/all/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedUserSourceConnectionListFromJSON(jsonValue));
    });
  }
  /**
   * User-source connection Viewset
   */
  sourcesUserConnectionsAllList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsAllListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * User-source connection Viewset
   */
  sourcesUserConnectionsAllPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsAllPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/all/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * User-source connection Viewset
   */
  sourcesUserConnectionsAllPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsAllPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * User-source connection Viewset
   */
  sourcesUserConnectionsAllRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsAllRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/all/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * User-source connection Viewset
   */
  sourcesUserConnectionsAllRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsAllRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * User-source connection Viewset
   */
  sourcesUserConnectionsAllUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsAllUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/all/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * User-source connection Viewset
   */
  sourcesUserConnectionsAllUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsAllUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesUserConnectionsAllUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsAllUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/all/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesUserConnectionsAllUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsAllUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsOauthCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.userOAuthSourceConnectionRequest === null || requestParameters.userOAuthSourceConnectionRequest === void 0) {
        throw new RequiredError("userOAuthSourceConnectionRequest", "Required parameter requestParameters.userOAuthSourceConnectionRequest was null or undefined when calling sourcesUserConnectionsOauthCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/oauth/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: UserOAuthSourceConnectionRequestToJSON(requestParameters.userOAuthSourceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserOAuthSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsOauthCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsOauthCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsOauthDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsOauthDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/oauth/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsOauthDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesUserConnectionsOauthDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsOauthListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.sourceSlug !== void 0) {
        queryParameters["source__slug"] = requestParameters.sourceSlug;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/oauth/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedUserOAuthSourceConnectionListFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsOauthList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsOauthListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsOauthPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsOauthPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/oauth/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedUserOAuthSourceConnectionRequestToJSON(requestParameters.patchedUserOAuthSourceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserOAuthSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsOauthPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsOauthPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsOauthRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsOauthRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/oauth/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserOAuthSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsOauthRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsOauthRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsOauthUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsOauthUpdate.");
      }
      if (requestParameters.userOAuthSourceConnectionRequest === null || requestParameters.userOAuthSourceConnectionRequest === void 0) {
        throw new RequiredError("userOAuthSourceConnectionRequest", "Required parameter requestParameters.userOAuthSourceConnectionRequest was null or undefined when calling sourcesUserConnectionsOauthUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/oauth/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: UserOAuthSourceConnectionRequestToJSON(requestParameters.userOAuthSourceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserOAuthSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsOauthUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsOauthUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesUserConnectionsOauthUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsOauthUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/oauth/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesUserConnectionsOauthUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsOauthUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Plex Source connection Serializer
   */
  sourcesUserConnectionsPlexCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.plexSourceConnectionRequest === null || requestParameters.plexSourceConnectionRequest === void 0) {
        throw new RequiredError("plexSourceConnectionRequest", "Required parameter requestParameters.plexSourceConnectionRequest was null or undefined when calling sourcesUserConnectionsPlexCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/plex/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PlexSourceConnectionRequestToJSON(requestParameters.plexSourceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PlexSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * Plex Source connection Serializer
   */
  sourcesUserConnectionsPlexCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsPlexCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Plex Source connection Serializer
   */
  sourcesUserConnectionsPlexDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsPlexDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/plex/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Plex Source connection Serializer
   */
  sourcesUserConnectionsPlexDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesUserConnectionsPlexDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Plex Source connection Serializer
   */
  sourcesUserConnectionsPlexListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.sourceSlug !== void 0) {
        queryParameters["source__slug"] = requestParameters.sourceSlug;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/plex/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPlexSourceConnectionListFromJSON(jsonValue));
    });
  }
  /**
   * Plex Source connection Serializer
   */
  sourcesUserConnectionsPlexList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsPlexListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Plex Source connection Serializer
   */
  sourcesUserConnectionsPlexPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsPlexPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/plex/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedPlexSourceConnectionRequestToJSON(requestParameters.patchedPlexSourceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PlexSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * Plex Source connection Serializer
   */
  sourcesUserConnectionsPlexPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsPlexPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Plex Source connection Serializer
   */
  sourcesUserConnectionsPlexRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsPlexRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/plex/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PlexSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * Plex Source connection Serializer
   */
  sourcesUserConnectionsPlexRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsPlexRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Plex Source connection Serializer
   */
  sourcesUserConnectionsPlexUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsPlexUpdate.");
      }
      if (requestParameters.plexSourceConnectionRequest === null || requestParameters.plexSourceConnectionRequest === void 0) {
        throw new RequiredError("plexSourceConnectionRequest", "Required parameter requestParameters.plexSourceConnectionRequest was null or undefined when calling sourcesUserConnectionsPlexUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/plex/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: PlexSourceConnectionRequestToJSON(requestParameters.plexSourceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PlexSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * Plex Source connection Serializer
   */
  sourcesUserConnectionsPlexUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsPlexUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesUserConnectionsPlexUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsPlexUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/plex/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesUserConnectionsPlexUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsPlexUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsSamlCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.userSAMLSourceConnectionRequest === null || requestParameters.userSAMLSourceConnectionRequest === void 0) {
        throw new RequiredError("userSAMLSourceConnectionRequest", "Required parameter requestParameters.userSAMLSourceConnectionRequest was null or undefined when calling sourcesUserConnectionsSamlCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/saml/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: UserSAMLSourceConnectionRequestToJSON(requestParameters.userSAMLSourceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserSAMLSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsSamlCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsSamlCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsSamlDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsSamlDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/saml/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsSamlDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.sourcesUserConnectionsSamlDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsSamlListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.sourceSlug !== void 0) {
        queryParameters["source__slug"] = requestParameters.sourceSlug;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/saml/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedUserSAMLSourceConnectionListFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsSamlList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsSamlListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsSamlPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsSamlPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/saml/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedUserSAMLSourceConnectionRequestToJSON(requestParameters.patchedUserSAMLSourceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserSAMLSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsSamlPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsSamlPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsSamlRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsSamlRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/saml/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserSAMLSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsSamlRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsSamlRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsSamlUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsSamlUpdate.");
      }
      if (requestParameters.userSAMLSourceConnectionRequest === null || requestParameters.userSAMLSourceConnectionRequest === void 0) {
        throw new RequiredError("userSAMLSourceConnectionRequest", "Required parameter requestParameters.userSAMLSourceConnectionRequest was null or undefined when calling sourcesUserConnectionsSamlUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/saml/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: UserSAMLSourceConnectionRequestToJSON(requestParameters.userSAMLSourceConnectionRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserSAMLSourceConnectionFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  sourcesUserConnectionsSamlUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsSamlUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesUserConnectionsSamlUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling sourcesUserConnectionsSamlUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/sources/user_connections/saml/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  sourcesUserConnectionsSamlUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.sourcesUserConnectionsSamlUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
};

export {
  BindingTypeEnum,
  UserMatchingModeEnum,
  NameIdPolicyEnum,
  ProviderTypeEnum,
  SourcesApi
};
//# sourceMappingURL=chunk-XSB422CX.js.map
