import {
  label_default
} from "./chunk-EEANTJCZ.js";
import {
  AKElement,
  n,
  patternfly_base_default,
  t
} from "./chunk-EOF5OWT7.js";
import {
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/elements/Label.ts
var Label = class extends AKElement {
  constructor() {
    super(...arguments);
    this.color = "" /* Grey */;
    this.compact = false;
  }
  static get styles() {
    return [patternfly_base_default, label_default];
  }
  getDefaultIcon() {
    switch (this.color) {
      case "pf-m-green" /* Green */:
        return "fa-check";
      case "pf-m-orange" /* Orange */:
        return "fa-exclamation-triangle";
      case "pf-m-red" /* Red */:
        return "fa-times";
      case "" /* Grey */:
        return "fa-info-circle";
      default:
        return "";
    }
  }
  render() {
    return x`<span class="pf-c-label ${this.color} ${this.compact ? "pf-m-compact" : ""}">
            <span class="pf-c-label__content">
                <span class="pf-c-label__icon">
                    <i
                        class="fas fa-fw ${this.icon || this.getDefaultIcon()}"
                        aria-hidden="true"
                    ></i>
                </span>
                <slot></slot>
            </span>
        </span>`;
  }
};
__decorateClass([
  n()
], Label.prototype, "color", 2);
__decorateClass([
  n()
], Label.prototype, "icon", 2);
__decorateClass([
  n({ type: Boolean })
], Label.prototype, "compact", 2);
Label = __decorateClass([
  t("ak-label")
], Label);
//# sourceMappingURL=chunk-Y5HTBO47.js.map
