import {
  HorizontalLightComponent
} from "./chunk-FH6YELOW.js";
import {
  TableModal
} from "./chunk-DP47YJ62.js";
import {
  iconHelperText
} from "./chunk-2XSPVNET.js";
import {
  ModelForm
} from "./chunk-ZVKXJXN6.js";
import {
  ProvidersApi
} from "./chunk-SFAGFFHP.js";
import {
  WithCapabilitiesConfig
} from "./chunk-3CKWSC2S.js";
import {
  o as o2
} from "./chunk-6KRH5U5H.js";
import {
  TableColumn,
  uiConfig
} from "./chunk-OOB7B3ZK.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import {
  AKElement,
  CapabilitiesEnum,
  CoreApi,
  DEFAULT_CONFIG,
  PolicyEngineMode,
  e,
  first,
  groupBy,
  n,
  r,
  t
} from "./chunk-EOF5OWT7.js";
import {
  T,
  msg,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/applications/ProviderSelectModal.ts
var ProviderSelectModal = class extends TableModal {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.checkboxChip = true;
    this.backchannelOnly = false;
    this.order = "name";
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint(page) {
    return new ProvidersApi(DEFAULT_CONFIG).providersAllList({
      ordering: this.order,
      page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.search || "",
      backchannelOnly: this.backchannelOnly
    });
  }
  columns() {
    return [new TableColumn(msg("Name"), "username"), new TableColumn(msg("Type"))];
  }
  row(item) {
    return [
      x`<div>
                <div>${item.name}</div>
            </div>`,
      x`${item.verboseName}`
    ];
  }
  renderSelectedChip(item) {
    return x`${item.name}`;
  }
  renderModalInner() {
    return x`<section class="pf-c-modal-box__header pf-c-page__main-section pf-m-light">
                <div class="pf-c-content">
                    <h1 class="pf-c-title pf-m-2xl">
                        ${msg("Select providers to add to application")}
                    </h1>
                </div>
            </section>
            <section class="pf-c-modal-box__body pf-m-light">${this.renderTable()}</section>
            <footer class="pf-c-modal-box__footer">
                <ak-spinner-button
                    .callAction=${async () => {
      await this.confirm(this.selectedElements);
      this.open = false;
    }}
                    class="pf-m-primary"
                >
                    ${msg("Add")} </ak-spinner-button
                >&nbsp;
                <ak-spinner-button
                    .callAction=${async () => {
      this.open = false;
    }}
                    class="pf-m-secondary"
                >
                    ${msg("Cancel")}
                </ak-spinner-button>
            </footer>`;
  }
};
__decorateClass([
  n({ type: Boolean })
], ProviderSelectModal.prototype, "backchannelOnly", 2);
__decorateClass([
  n()
], ProviderSelectModal.prototype, "confirm", 2);
ProviderSelectModal = __decorateClass([
  t("ak-provider-select-table")
], ProviderSelectModal);

// src/components/ak-file-input.ts
var AkFileInput = class extends AKElement {
  constructor() {
    super(...arguments);
    this.label = "";
    this.current = msg("Currently set to:");
    this.value = "";
    this.required = false;
    this.help = "";
  }
  // Render into the lightDOM. This effectively erases the shadowDOM nature of this component, but
  // we're not actually using that and, for the meantime, we need the form handlers to be able to
  // find the children of this component.
  //
  // TODO: This abstraction is wrong; it's putting *more* layers in as a way of managing the
  // visual clutter and legibility issues of ak-form-elemental-horizontal and patternfly in
  // general.
  createRenderRoot() {
    return this;
  }
  get files() {
    return this.input.files;
  }
  render() {
    const currentMsg = this.value && this.current ? x` <p class="pf-c-form__helper-text">${this.current} ${this.value}</p> ` : T;
    return x`<ak-form-element-horizontal
            ?required="${this.required}"
            label=${this.label}
            name=${this.name}
        >
            <input type="file" value="" class="pf-c-form-control" />
            ${currentMsg}
            ${this.help.trim() ? x`<p class="pf-c-form__helper-text">${this.help}</p>` : T}
        </ak-form-element-horizontal>`;
  }
};
__decorateClass([
  n({ type: String })
], AkFileInput.prototype, "name", 2);
__decorateClass([
  n({ type: String })
], AkFileInput.prototype, "label", 2);
__decorateClass([
  n({ type: String })
], AkFileInput.prototype, "current", 2);
__decorateClass([
  n({ type: String })
], AkFileInput.prototype, "value", 2);
__decorateClass([
  n({ type: Boolean })
], AkFileInput.prototype, "required", 2);
__decorateClass([
  n({ type: String })
], AkFileInput.prototype, "help", 2);
__decorateClass([
  e('input[type="file"]')
], AkFileInput.prototype, "input", 2);
AkFileInput = __decorateClass([
  t("ak-file-input")
], AkFileInput);

// src/components/ak-radio-input.ts
var AkRadioInput = class extends HorizontalLightComponent {
  constructor() {
    super(...arguments);
    this.options = [];
  }
  handleInput(ev) {
    if ("detail" in ev) {
      this.value = ev.detail.value;
    }
  }
  renderHelp() {
    return [T];
  }
  renderControl() {
    return x`<ak-radio
                .options=${this.options}
                .value=${this.value}
                @input=${this.handleInput}
            ></ak-radio>
            ${this.help.trim() ? x`<p class="pf-c-form__helper-radio">${this.help}</p>` : T}`;
  }
};
__decorateClass([
  n({ type: Object })
], AkRadioInput.prototype, "value", 2);
__decorateClass([
  n({ type: Array })
], AkRadioInput.prototype, "options", 2);
AkRadioInput = __decorateClass([
  t("ak-radio-input")
], AkRadioInput);

// src/components/ak-textarea-input.ts
var AkTextareaInput = class extends HorizontalLightComponent {
  constructor() {
    super(...arguments);
    this.value = "";
  }
  renderControl() {
    return x`<textarea
            class="pf-c-form-control"
            ?required=${this.required}
            name=${this.name}
        >${this.value !== void 0 ? this.value : ""}</textarea
        > `;
  }
};
__decorateClass([
  n({ type: String, reflect: true })
], AkTextareaInput.prototype, "value", 2);
AkTextareaInput = __decorateClass([
  t("ak-textarea-input")
], AkTextareaInput);

// src/admin/applications/components/ak-backchannel-input.ts
var AkBackchannelProvidersInput = class extends AKElement {
  constructor() {
    super(...arguments);
    this.label = "";
    this.providers = [];
    this.value = "";
    this.required = false;
    this.help = "";
  }
  // Render into the lightDOM. This effectively erases the shadowDOM nature of this component, but
  // we're not actually using that and, for the meantime, we need the form handlers to be able to
  // find the children of this component.
  //
  // This field is so highly specialized that it would make more sense if we put the API and the
  // fetcher here.
  //
  // TODO: This abstraction is wrong; it's putting *more* layers in as a way of managing the
  // visual clutter and legibility issues of ak-form-elemental-horizontal and patternfly in
  // general.
  createRenderRoot() {
    return this;
  }
  render() {
    const renderOneChip = (provider) => x`<ak-chip
                .removable=${true}
                value=${o(provider.pk)}
                @remove=${this.remover(provider)}
                >${provider.name}</ak-chip
            >`;
    return x`
            <ak-form-element-horizontal label=${this.label} name=${this.name}>
                <div class="pf-c-input-group">
                    <ak-provider-select-table ?backchannelOnly=${true} .confirm=${this.confirm}>
                        <button slot="trigger" class="pf-c-button pf-m-control" type="button">
                            ${this.tooltip ? this.tooltip : T}
                            <i class="fas fa-plus" aria-hidden="true"></i>
                        </button>
                    </ak-provider-select-table>
                    <div class="pf-c-form-control">
                        <ak-chip-group> ${o2(this.providers, renderOneChip)} </ak-chip-group>
                    </div>
                </div>
                ${this.help ? x`<p class="pf-c-form__helper-text">${this.help}</p>` : T}
            </ak-form-element-horizontal>
        `;
  }
};
__decorateClass([
  n({ type: String })
], AkBackchannelProvidersInput.prototype, "name", 2);
__decorateClass([
  n({ type: String })
], AkBackchannelProvidersInput.prototype, "label", 2);
__decorateClass([
  n({ type: Array })
], AkBackchannelProvidersInput.prototype, "providers", 2);
__decorateClass([
  n({ type: Object })
], AkBackchannelProvidersInput.prototype, "tooltip", 2);
__decorateClass([
  n({ attribute: false, type: Object })
], AkBackchannelProvidersInput.prototype, "confirm", 2);
__decorateClass([
  n({ attribute: false, type: Object })
], AkBackchannelProvidersInput.prototype, "remover", 2);
__decorateClass([
  n({ type: String })
], AkBackchannelProvidersInput.prototype, "value", 2);
__decorateClass([
  n({ type: Boolean })
], AkBackchannelProvidersInput.prototype, "required", 2);
__decorateClass([
  n({ type: String })
], AkBackchannelProvidersInput.prototype, "help", 2);
AkBackchannelProvidersInput = __decorateClass([
  t("ak-backchannel-providers-input")
], AkBackchannelProvidersInput);

// src/admin/applications/components/ak-provider-search-input.ts
var renderElement = (item) => item.name;
var renderValue = (item) => item?.pk;
var doGroupBy = (items) => groupBy(items, (item) => item.verboseName);
async function fetch(query) {
  const args = {
    ordering: "name"
  };
  if (query !== void 0) {
    args.search = query;
  }
  const items = await new ProvidersApi(DEFAULT_CONFIG).providersAllList(args);
  return items.results;
}
var AkProviderInput = class extends AKElement {
  constructor() {
    super();
    this.label = "";
    this.required = false;
    this.blankable = false;
    this.help = "";
    this.selected = this.selected.bind(this);
  }
  // Render into the lightDOM. This effectively erases the shadowDOM nature of this component, but
  // we're not actually using that and, for the meantime, we need the form handlers to be able to
  // find the children of this component.
  //
  // TODO: This abstraction is wrong; it's putting *more* layers in as a way of managing the
  // visual clutter and legibility issues of ak-form-elemental-horizontal and patternfly in
  // general.
  createRenderRoot() {
    return this;
  }
  selected(item) {
    return this.value !== void 0 && this.value === item.pk;
  }
  render() {
    return x` <ak-form-element-horizontal label=${this.label} name=${this.name}>
            <ak-search-select
                .selected=${this.selected}
                .fetchObjects=${fetch}
                .renderElement=${renderElement}
                .value=${renderValue}
                .groupBy=${doGroupBy}
                ?blankable=${this.blankable}
            >
            </ak-search-select>
            ${this.help ? x`<p class="pf-c-form__helper-text">${this.help}</p>` : T}
        </ak-form-element-horizontal>`;
  }
};
__decorateClass([
  n({ type: String })
], AkProviderInput.prototype, "name", 2);
__decorateClass([
  n({ type: String })
], AkProviderInput.prototype, "label", 2);
__decorateClass([
  n({ type: Number })
], AkProviderInput.prototype, "value", 2);
__decorateClass([
  n({ type: Boolean })
], AkProviderInput.prototype, "required", 2);
__decorateClass([
  n({ type: Boolean })
], AkProviderInput.prototype, "blankable", 2);
__decorateClass([
  n({ type: String })
], AkProviderInput.prototype, "help", 2);
AkProviderInput = __decorateClass([
  t("ak-provider-search-input")
], AkProviderInput);

// src/admin/applications/ApplicationForm.ts
var policyOptions = [
  {
    label: "any",
    value: PolicyEngineMode.Any,
    default: true,
    description: x`${msg("Any policy must match to grant access")}`
  },
  {
    label: "all",
    value: PolicyEngineMode.All,
    description: x`${msg("All policies must match to grant access")}`
  }
];
var ApplicationForm = class extends WithCapabilitiesConfig(ModelForm) {
  constructor() {
    super();
    this.backchannelProviders = [];
    this.clearIcon = false;
    this.handleConfirmBackchannelProviders = this.handleConfirmBackchannelProviders.bind(this);
    this.makeRemoveBackchannelProviderHandler = this.makeRemoveBackchannelProviderHandler.bind(this);
  }
  async loadInstance(pk) {
    const app = await new CoreApi(DEFAULT_CONFIG).coreApplicationsRetrieve({
      slug: pk
    });
    this.clearIcon = false;
    this.backchannelProviders = app.backchannelProvidersObj || [];
    return app;
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated application.") : msg("Successfully created application.");
  }
  async send(data) {
    let app;
    data.backchannelProviders = this.backchannelProviders.map((p) => p.pk);
    if (this.instance) {
      app = await new CoreApi(DEFAULT_CONFIG).coreApplicationsUpdate({
        slug: this.instance.slug,
        applicationRequest: data
      });
    } else {
      app = await new CoreApi(DEFAULT_CONFIG).coreApplicationsCreate({
        applicationRequest: data
      });
    }
    if (this.can(CapabilitiesEnum.CanSaveMedia)) {
      const icon = this.getFormFiles()["metaIcon"];
      if (icon || this.clearIcon) {
        await new CoreApi(DEFAULT_CONFIG).coreApplicationsSetIconCreate({
          slug: app.slug,
          file: icon,
          clear: this.clearIcon
        });
      }
    } else {
      await new CoreApi(DEFAULT_CONFIG).coreApplicationsSetIconUrlCreate({
        slug: app.slug,
        filePathRequest: {
          url: data.metaIcon || ""
        }
      });
    }
    return app;
  }
  handleConfirmBackchannelProviders(items) {
    this.backchannelProviders = items;
    this.requestUpdate();
    return Promise.resolve();
  }
  makeRemoveBackchannelProviderHandler(provider) {
    return () => {
      const idx = this.backchannelProviders.indexOf(provider);
      this.backchannelProviders.splice(idx, 1);
      this.requestUpdate();
    };
  }
  handleClearIcon(ev) {
    ev.stopPropagation();
    if (!(ev instanceof InputEvent) || !ev.target) {
      return;
    }
    this.clearIcon = !!ev.target.checked;
  }
  renderForm() {
    return x`<form class="pf-c-form pf-m-horizontal">
            <ak-text-input
                name="name"
                value=${o(this.instance?.name)}
                label=${msg("Name")}
                required
                help=${msg("Application's display Name.")}
            ></ak-text-input>
            <ak-text-input
                name="slug"
                value=${o(this.instance?.slug)}
                label=${msg("Slug")}
                required
                help=${msg("Internal application name used in URLs.")}
            ></ak-text-input>
            <ak-text-input
                name="group"
                value=${o(this.instance?.group)}
                label=${msg("Group")}
                help=${msg(
      "Optionally enter a group name. Applications with identical groups are shown grouped together."
    )}
            ></ak-text-input>
            <ak-provider-search-input
                name="provider"
                label=${msg("Provider")}
                value=${o(this.instance?.provider ?? void 0)}
                help=${msg("Select a provider that this application should use.")}
                blankable
            ></ak-provider-search-input>
            <ak-backchannel-providers-input
                name="backchannelProviders"
                label=${msg("Backchannel Providers")}
                help=${msg(
      "Select backchannel providers which augment the functionality of the main provider."
    )}
                .providers=${this.backchannelProviders}
                .confirm=${this.handleConfirmBackchannelProviders}
                .remover=${this.makeRemoveBackchannelProviderHandler}
                .tooltip=${x`<pf-tooltip
                    position="top"
                    content=${msg("Add provider")}
                ></pf-tooltip>`}
            >
            </ak-backchannel-providers-input>
            <ak-radio-input
                label=${msg("Policy engine mode")}
                required
                name="policyEngineMode"
                .options=${policyOptions}
                .value=${this.instance?.policyEngineMode}
            ></ak-radio-input>
            <ak-form-group>
                <span slot="header"> ${msg("UI settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-text-input
                        name="metaLaunchUrl"
                        label=${msg("Launch URL")}
                        value=${o(this.instance?.metaLaunchUrl)}
                        help=${msg(
      "If left empty, authentik will try to extract the launch URL based on the selected provider."
    )}
                    ></ak-text-input>
                    <ak-switch-input
                        name="openInNewTab"
                        ?checked=${first(this.instance?.openInNewTab, false)}
                        label=${msg("Open in new tab")}
                        help=${msg(
      "If checked, the launch URL will open in a new browser tab or window from the user's application library."
    )}
                    >
                    </ak-switch-input>
                    ${this.can(CapabilitiesEnum.CanSaveMedia) ? x`<ak-file-input
                                  label="${msg("Icon")}"
                                  name="metaIcon"
                                  value=${o(this.instance?.metaIcon ?? void 0)}
                                  current=${msg("Currently set to:")}
                              ></ak-file-input>
                              ${this.instance?.metaIcon ? x`
                                        <ak-switch-input
                                            name=""
                                            label=${msg("Clear icon")}
                                            help=${msg("Delete currently set icon.")}
                                            @change=${this.handleClearIcon}
                                        ></ak-switch-input>
                                    ` : x``}` : x` <ak-text-input
                              label=${msg("Icon")}
                              name="metaIcon"
                              value=${first(this.instance?.metaIcon, "")}
                              help=${iconHelperText}
                          >
                          </ak-text-input>`}
                    <ak-text-input
                        label=${msg("Publisher")}
                        name="metaPublisher"
                        value="${o(this.instance?.metaPublisher)}"
                    ></ak-text-input>
                    <ak-textarea-input
                        label=${msg("Description")}
                        name="metaDescription"
                        value=${o(this.instance?.metaDescription)}
                    ></ak-textarea-input>
                </div>
            </ak-form-group>
        </form>`;
  }
};
__decorateClass([
  n({ attribute: false })
], ApplicationForm.prototype, "provider", 2);
__decorateClass([
  r()
], ApplicationForm.prototype, "backchannelProviders", 2);
__decorateClass([
  n({ type: Boolean })
], ApplicationForm.prototype, "clearIcon", 2);
ApplicationForm = __decorateClass([
  t("ak-application-form")
], ApplicationForm);

export {
  policyOptions
};
//# sourceMappingURL=chunk-YMC5UCEC.js.map
