import {
  form_default
} from "./chunk-GOIBY4UW.js";
import {
  form_control_default
} from "./chunk-OOB7B3ZK.js";
import {
  AKElement,
  button_default,
  n,
  patternfly_base_default,
  t
} from "./chunk-EOF5OWT7.js";
import {
  i,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/elements/forms/FormGroup.ts
var FormGroup = class extends AKElement {
  constructor() {
    super(...arguments);
    this.expanded = false;
    this.ariaLabel = "Details";
  }
  static get styles() {
    return [
      patternfly_base_default,
      form_default,
      button_default,
      form_control_default,
      i`
                slot[name="body"][hidden] {
                    display: none !important;
                }
            `
    ];
  }
  render() {
    return x`<div class="pf-c-form__field-group ${this.expanded ? "pf-m-expanded" : ""}">
            <div class="pf-c-form__field-group-toggle">
                <div class="pf-c-form__field-group-toggle-button">
                    <button
                        class="pf-c-button pf-m-plain"
                        type="button"
                        aria-expanded="${this.expanded}"
                        aria-label=${this.ariaLabel}
                        @click=${() => {
      this.expanded = !this.expanded;
    }}
                    >
                        <span class="pf-c-form__field-group-toggle-icon">
                            <i class="fas fa-angle-right" aria-hidden="true"></i>
                        </span>
                    </button>
                </div>
            </div>
            <div class="pf-c-form__field-group-header">
                <div class="pf-c-form__field-group-header-main">
                    <div class="pf-c-form__field-group-header-title">
                        <div class="pf-c-form__field-group-header-title-text">
                            <slot name="header"></slot>
                        </div>
                    </div>
                    <div class="pf-c-form__field-group-header-description">
                        <slot name="description"></slot>
                    </div>
                </div>
            </div>
            <slot ?hidden=${!this.expanded} class="pf-c-form__field-group-body" name="body"></slot>
        </div>`;
  }
};
__decorateClass([
  n({ type: Boolean, reflect: true })
], FormGroup.prototype, "expanded", 2);
__decorateClass([
  n({ type: String, attribute: "aria-label", reflect: true })
], FormGroup.prototype, "ariaLabel", 2);
FormGroup = __decorateClass([
  t("ak-form-group")
], FormGroup);
//# sourceMappingURL=chunk-ZKRIRKRW.js.map
