import "./chunk-WY5WRESY.js";
import {
  button_default
} from "./chunk-E4FQAZYR.js";
import "./chunk-AVL64ZZC.js";
import {
  form_control_default,
  form_default,
  login_default
} from "./chunk-RVW7F5SR.js";
import {
  BaseStage,
  title_default
} from "./chunk-FP6OVRLA.js";
import {
  patternfly_base_default,
  t
} from "./chunk-DOEX53UY.js";
import {
  msg,
  x
} from "./chunk-QY7RAEC6.js";
import {
  __decorateClass
} from "./chunk-PNTXHIFL.js";

// src/flow/providers/oauth2/DeviceCode.ts
var OAuth2DeviceCode = class extends BaseStage {
  static get styles() {
    return [patternfly_base_default, login_default, form_default, form_control_default, title_default, button_default];
  }
  render() {
    if (!this.challenge) {
      return x`<ak-empty-state ?loading="${true}" header=${msg("Loading")}>
            </ak-empty-state>`;
    }
    return x`<header class="pf-c-login__main-header">
                <h1 class="pf-c-title pf-m-3xl">${this.challenge.flowInfo?.title}</h1>
            </header>
            <div class="pf-c-login__main-body">
                <form
                    class="pf-c-form"
                    @submit=${(e) => {
      this.submitForm(e);
    }}
                >
                    <p>${msg("Enter the code shown on your device.")}</p>
                    <ak-form-element
                        label="${msg("Code")}"
                        ?required="${true}"
                        class="pf-c-form__group"
                        .errors=${(this.challenge?.responseErrors || {})["code"]}
                    >
                        <input
                            type="text"
                            name="code"
                            inputmode="numeric"
                            pattern="[0-9]*"
                            placeholder="${msg("Please enter your Code")}"
                            autofocus=""
                            autocomplete="off"
                            class="pf-c-form-control"
                            value=""
                            required
                        />
                    </ak-form-element>

                    <div class="pf-c-form__group pf-m-action">
                        <button type="submit" class="pf-c-button pf-m-primary pf-m-block">
                            ${msg("Continue")}
                        </button>
                    </div>
                </form>
            </div>
            <footer class="pf-c-login__main-footer">
                <ul class="pf-c-login__main-footer-links"></ul>
            </footer>`;
  }
};
OAuth2DeviceCode = __decorateClass([
  t("ak-flow-provider-oauth2-code")
], OAuth2DeviceCode);
export {
  OAuth2DeviceCode
};
//# sourceMappingURL=DeviceCode-ELZKQCKA.js.map
