import {
  LOCALES,
  authentikConfigContext,
  c,
  o
} from "./chunk-D7TS6SJR.js";
import {
  CapabilitiesEnum,
  PromptTypeEnum
} from "./chunk-JAXJ5P3M.js";
import "./chunk-3FZXISAD.js";
import {
  alert_default
} from "./chunk-DVT5R7IG.js";
import "./chunk-WY5WRESY.js";
import {
  button_default
} from "./chunk-E4FQAZYR.js";
import {
  form_control_default,
  form_default,
  login_default
} from "./chunk-RVW7F5SR.js";
import {
  BaseStage,
  title_default
} from "./chunk-FP6OVRLA.js";
import {
  patternfly_base_default,
  t
} from "./chunk-DOEX53UY.js";
import "./chunk-OM7VEK6J.js";
import {
  i,
  msg,
  x
} from "./chunk-QY7RAEC6.js";
import {
  __decorateClass
} from "./chunk-PNTXHIFL.js";

// src/elements/Interface/capabilitiesProvider.ts
var WCC = class {
  static {
    this.capabilitiesConfig = Symbol();
  }
};
function WithCapabilitiesConfig(superclass, subscribe = true) {
  var _a;
  class CapabilitiesContext extends superclass {
    static {
      _a = WCC.capabilitiesConfig;
    }
    can(c2) {
      if (!this[WCC.capabilitiesConfig]) {
        throw new Error(
          "ConfigContext: Attempted to access site configuration before initialization."
        );
      }
      return this[WCC.capabilitiesConfig].capabilities.includes(c2);
    }
  }
  __decorateClass([
    c({ context: authentikConfigContext, subscribe })
  ], CapabilitiesContext.prototype, _a, 2);
  return CapabilitiesContext;
}

// node_modules/@patternfly/patternfly/components/Check/check.css
var check_default = ".pf-c-check {\n  --pf-c-check--GridGap: var(--pf-global--spacer--xs) var(--pf-global--spacer--sm);\n  --pf-c-check__label--disabled--Color: var(--pf-global--disabled-color--100);\n  --pf-c-check__label--Color: var(--pf-global--Color--100);\n  --pf-c-check__label--FontWeight: var(--pf-global--FontWeight--normal);\n  --pf-c-check__label--FontSize: var(--pf-global--FontSize--md);\n  --pf-c-check__label--LineHeight: var(--pf-global--LineHeight--sm);\n  --pf-c-check__input--Height: var(--pf-c-check__label--FontSize);\n  --pf-c-check__input--MarginTop: calc(((var(--pf-c-check__label--FontSize) * var(--pf-c-check__label--LineHeight)) - var(--pf-c-check__input--Height)) / 2);\n  --pf-c-check__description--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-check__description--Color: var(--pf-global--Color--200);\n  --pf-c-check__body--MarginTop: var(--pf-global--spacer--sm);\n  --pf-c-check__label-required--MarginLeft: var(--pf-global--spacer--xs);\n  --pf-c-check__label-required--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-check__label-required--Color: var(--pf-global--danger-color--100);\n  display: grid;\n  grid-template-columns: auto 1fr;\n  grid-gap: var(--pf-c-check--GridGap);\n  align-items: start;\n  justify-items: start;\n}\n.pf-c-check.pf-m-standalone {\n  --pf-c-check--GridGap: 0;\n  --pf-c-check__input--Height: auto;\n  --pf-c-check__input--MarginTop: 0;\n  display: inline-grid;\n  line-height: 1;\n}\n\n.pf-c-check__label {\n  font-size: var(--pf-c-check__label--FontSize);\n  font-weight: var(--pf-c-check__label--FontWeight);\n  line-height: var(--pf-c-check__label--LineHeight);\n  color: var(--pf-c-check__label--Color);\n}\n\n.pf-c-check__input {\n  height: var(--pf-c-check__input--Height);\n  margin-top: var(--pf-c-check__input--MarginTop);\n}\n\n.pf-c-check__description {\n  grid-column: 2;\n  font-size: var(--pf-c-check__description--FontSize);\n  color: var(--pf-c-check__description--Color);\n}\n\n.pf-c-check__body {\n  grid-column: 2;\n  margin-top: var(--pf-c-check__body--MarginTop);\n}\n\nlabel.pf-c-check, .pf-c-check__label,\n.pf-c-check__input {\n  cursor: pointer;\n}\n\n.pf-c-check__label:disabled, .pf-c-check__label.pf-m-disabled,\n.pf-c-check__input:disabled,\n.pf-c-check__input.pf-m-disabled {\n  --pf-c-check__label--Color: var(--pf-c-check__label--disabled--Color);\n  cursor: not-allowed;\n}\n\n.pf-c-check__label-required {\n  margin-left: var(--pf-c-check__label-required--MarginLeft);\n  font-size: var(--pf-c-check__label-required--FontSize);\n  color: var(--pf-c-check__label-required--Color);\n}";

// src/flow/stages/prompt/PromptStage.ts
var PromptStage = class extends WithCapabilitiesConfig(
  BaseStage
) {
  static get styles() {
    return [
      patternfly_base_default,
      login_default,
      alert_default,
      form_default,
      form_control_default,
      title_default,
      button_default,
      check_default,
      i`
                textarea {
                    min-height: 4em;
                    max-height: 15em;
                    resize: vertical;
                }
            `
    ];
  }
  renderPromptInner(prompt) {
    switch (prompt.type) {
      case PromptTypeEnum.Text:
        return x`<input
                    type="text"
                    name="${prompt.fieldKey}"
                    placeholder="${prompt.placeholder}"
                    autocomplete="off"
                    class="pf-c-form-control"
                    ?required=${prompt.required}
                    value="${prompt.initialValue}"
                />`;
      case PromptTypeEnum.TextArea:
        return x`<textarea
                    name="${prompt.fieldKey}"
                    placeholder="${prompt.placeholder}"
                    autocomplete="off"
                    class="pf-c-form-control"
                    ?required=${prompt.required}
                >
${prompt.initialValue}</textarea
                >`;
      case PromptTypeEnum.TextReadOnly:
        return x`<input
                    type="text"
                    name="${prompt.fieldKey}"
                    placeholder="${prompt.placeholder}"
                    class="pf-c-form-control"
                    ?readonly=${true}
                    value="${prompt.initialValue}"
                />`;
      case PromptTypeEnum.TextAreaReadOnly:
        return x`<textarea
                    name="${prompt.fieldKey}"
                    placeholder="${prompt.placeholder}"
                    class="pf-c-form-control"
                    readonly
                >
${prompt.initialValue}</textarea
                >`;
      case PromptTypeEnum.Username:
        return x`<input
                    type="text"
                    name="${prompt.fieldKey}"
                    placeholder="${prompt.placeholder}"
                    autocomplete="username"
                    class="pf-c-form-control"
                    ?required=${prompt.required}
                    value="${prompt.initialValue}"
                />`;
      case PromptTypeEnum.Email:
        return x`<input
                    type="email"
                    name="${prompt.fieldKey}"
                    placeholder="${prompt.placeholder}"
                    class="pf-c-form-control"
                    ?required=${prompt.required}
                    value="${prompt.initialValue}"
                />`;
      case PromptTypeEnum.Password:
        return x`<input
                    type="password"
                    name="${prompt.fieldKey}"
                    placeholder="${prompt.placeholder}"
                    autocomplete="new-password"
                    class="pf-c-form-control"
                    ?required=${prompt.required}
                />`;
      case PromptTypeEnum.Number:
        return x`<input
                    type="number"
                    name="${prompt.fieldKey}"
                    placeholder="${prompt.placeholder}"
                    class="pf-c-form-control"
                    ?required=${prompt.required}
                    value="${prompt.initialValue}"
                />`;
      case PromptTypeEnum.Date:
        return x`<input
                    type="date"
                    name="${prompt.fieldKey}"
                    placeholder="${prompt.placeholder}"
                    class="pf-c-form-control"
                    ?required=${prompt.required}
                    value="${prompt.initialValue}"
                />`;
      case PromptTypeEnum.DateTime:
        return x`<input
                    type="datetime"
                    name="${prompt.fieldKey}"
                    placeholder="${prompt.placeholder}"
                    class="pf-c-form-control"
                    ?required=${prompt.required}
                    value="${prompt.initialValue}"
                />`;
      case PromptTypeEnum.File:
        return x`<input
                    type="file"
                    name="${prompt.fieldKey}"
                    placeholder="${prompt.placeholder}"
                    class="pf-c-form-control"
                    ?required=${prompt.required}
                    value="${prompt.initialValue}"
                />`;
      case PromptTypeEnum.Separator:
        return x`<ak-divider>${prompt.placeholder}</ak-divider>`;
      case PromptTypeEnum.Hidden:
        return x`<input
                    type="hidden"
                    name="${prompt.fieldKey}"
                    value="${prompt.initialValue}"
                    class="pf-c-form-control"
                    ?required=${prompt.required}
                />`;
      case PromptTypeEnum.Static:
        return x`<p>${o(prompt.initialValue)}</p>`;
      case PromptTypeEnum.Dropdown:
        return x`<select class="pf-c-form-control" name="${prompt.fieldKey}">
                    ${prompt.choices?.map((choice) => {
          return x`<option
                            value="${choice}"
                            ?selected=${prompt.initialValue === choice}
                        >
                            ${choice}
                        </option>`;
        })}
                </select>`;
      case PromptTypeEnum.RadioButtonGroup:
        return x`${(prompt.choices || []).map((choice) => {
          const id = `${prompt.fieldKey}-${choice}`;
          return x`<div class="pf-c-check">
                        <input
                            type="radio"
                            class="pf-c-check__input"
                            name="${prompt.fieldKey}"
                            id="${id}"
                            ?checked="${prompt.initialValue === choice}"
                            ?required="${prompt.required}"
                            value="${choice}"
                        />
                        <label class="pf-c-check__label" for=${id}>${choice}</label>
                    </div> `;
        })}`;
      case PromptTypeEnum.AkLocale: {
        const locales = this.can(CapabilitiesEnum.CanDebug) ? LOCALES : LOCALES.filter((locale) => locale.code !== "debug");
        const options = locales.map(
          (locale) => x`<option
                            value=${locale.code}
                            ?selected=${locale.code === prompt.initialValue}
                        >
                            ${locale.code.toUpperCase()} - ${locale.label()}
                        </option> `
        );
        return x`<select class="pf-c-form-control" name="${prompt.fieldKey}">
                    <option value="" ?selected=${prompt.initialValue === ""}>
                        ${msg("Auto-detect (based on your browser)")}
                    </option>
                    ${options}
                </select>`;
      }
      default:
        return x`<p>invalid type '${prompt.type}'</p>`;
    }
  }
  renderPromptHelpText(prompt) {
    if (prompt.subText === "") {
      return x``;
    }
    return x`<p class="pf-c-form__helper-text">${o(prompt.subText)}</p>`;
  }
  shouldRenderInWrapper(prompt) {
    if (prompt.type === PromptTypeEnum.Static || prompt.type === PromptTypeEnum.Hidden || prompt.type === PromptTypeEnum.Separator) {
      return false;
    }
    return true;
  }
  renderField(prompt) {
    if (prompt.type === PromptTypeEnum.Checkbox) {
      return x`<div class="pf-c-check">
                <input
                    type="checkbox"
                    class="pf-c-check__input"
                    id="${prompt.fieldKey}"
                    name="${prompt.fieldKey}"
                    ?checked=${prompt.initialValue !== ""}
                    ?required=${prompt.required}
                />
                <label class="pf-c-check__label" for="${prompt.fieldKey}">${prompt.label}</label>
                ${prompt.required ? x`<p class="pf-c-form__helper-text">${msg("Required.")}</p>` : x``}
                <p class="pf-c-form__helper-text">${o(prompt.subText)}</p>
            </div>`;
    }
    if (this.shouldRenderInWrapper(prompt)) {
      return x`<ak-form-element
                label="${prompt.label}"
                ?required="${prompt.required}"
                class="pf-c-form__group"
                .errors=${(this.challenge?.responseErrors || {})[prompt.fieldKey]}
            >
                ${this.renderPromptInner(prompt)} ${this.renderPromptHelpText(prompt)}
            </ak-form-element>`;
    }
    return x` ${this.renderPromptInner(prompt)} ${this.renderPromptHelpText(prompt)}`;
  }
  renderContinue() {
    return x` <div class="pf-c-form__group pf-m-action">
            <button type="submit" class="pf-c-button pf-m-primary pf-m-block">
                ${msg("Continue")}
            </button>
        </div>`;
  }
  render() {
    if (!this.challenge) {
      return x`<ak-empty-state ?loading="${true}" header=${msg("Loading")}>
            </ak-empty-state>`;
    }
    return x`<header class="pf-c-login__main-header">
                <h1 class="pf-c-title pf-m-3xl">${this.challenge.flowInfo?.title}</h1>
            </header>
            <div class="pf-c-login__main-body">
                <form
                    class="pf-c-form"
                    @submit=${(e) => {
      this.submitForm(e);
    }}
                >
                    ${this.challenge.fields.map((prompt) => {
      return this.renderField(prompt);
    })}
                    ${"non_field_errors" in (this.challenge?.responseErrors || {}) ? this.renderNonFieldErrors(
      this.challenge?.responseErrors?.non_field_errors || []
    ) : x``}
                    ${this.renderContinue()}
                </form>
            </div>
            <footer class="pf-c-login__main-footer">
                <ul class="pf-c-login__main-footer-links"></ul>
            </footer>`;
  }
};
PromptStage = __decorateClass([
  t("ak-stage-prompt")
], PromptStage);
export {
  PromptStage
};
//# sourceMappingURL=PromptStage-HWJ5GQCZ.js.map
