import {
  form_control_default,
  form_default,
  login_default
} from "./chunk-RVW7F5SR.js";
import {
  BaseStage,
  o
} from "./chunk-FP6OVRLA.js";
import {
  patternfly_base_default,
  t
} from "./chunk-DOEX53UY.js";
import {
  T,
  msg,
  x
} from "./chunk-QY7RAEC6.js";
import {
  __decorateClass
} from "./chunk-PNTXHIFL.js";

// src/flow/stages/access_denied/AccessDeniedStage.ts
var AccessDeniedStage = class extends BaseStage {
  static get styles() {
    return [patternfly_base_default, login_default, form_default, form_control_default];
  }
  render() {
    if (!this.challenge) {
      return x`<ak-empty-state ?loading="${true}" header=${msg("Loading")}>
            </ak-empty-state>`;
    }
    return x`<header class="pf-c-login__main-header">
                <h1 class="pf-c-title pf-m-3xl">${this.challenge.flowInfo?.title}</h1>
            </header>
            <div class="pf-c-login__main-body">
                <form class="pf-c-form">
                    <ak-form-static
                        class="pf-c-form__group"
                        userAvatar="${this.challenge.pendingUserAvatar}"
                        user=${this.challenge.pendingUser}
                    >
                        <div slot="link">
                            <a href="${o(this.challenge.flowInfo?.cancelUrl)}"
                                >${msg("Not you?")}</a
                            >
                        </div>
                    </ak-form-static>
                    <ak-empty-state icon="fa-times" header=${msg("Request has been denied.")}>
                        ${this.challenge.errorMessage ? x`
                                  <div slot="body">
                                      <p>${this.challenge.errorMessage}</p>
                                  </div>
                              ` : T}
                    </ak-empty-state>
                </form>
            </div>
            <footer class="pf-c-login__main-footer">
                <ul class="pf-c-login__main-footer-links"></ul>
            </footer>`;
  }
};
AccessDeniedStage = __decorateClass([
  t("ak-stage-access-denied")
], AccessDeniedStage);

export {
  AccessDeniedStage
};
//# sourceMappingURL=chunk-CI5JDDIK.js.map
