import {
  button_default
} from "./chunk-E4FQAZYR.js";
import {
  form_control_default,
  form_default,
  login_default
} from "./chunk-RVW7F5SR.js";
import {
  BaseStage,
  title_default
} from "./chunk-FP6OVRLA.js";
import {
  patternfly_base_default,
  t
} from "./chunk-DOEX53UY.js";
import {
  msg,
  x
} from "./chunk-QY7RAEC6.js";
import {
  __decorateClass
} from "./chunk-PNTXHIFL.js";

// src/flow/stages/autosubmit/AutosubmitStage.ts
var AutosubmitStage = class extends BaseStage {
  static get styles() {
    return [patternfly_base_default, login_default, form_default, form_control_default, button_default, title_default];
  }
  updated() {
    this.shadowRoot?.querySelectorAll("form").forEach((form) => {
      form.submit();
    });
  }
  render() {
    if (!this.challenge) {
      return x`<ak-empty-state ?loading="${true}" header=${msg("Loading")}>
            </ak-empty-state>`;
    }
    let title = this.challenge.flowInfo?.title;
    if (this.challenge.title && this.challenge.title !== "") {
      title = this.challenge.title;
    }
    return x`<header class="pf-c-login__main-header">
                <h1 class="pf-c-title pf-m-3xl">${title}</h1>
            </header>
            <div class="pf-c-login__main-body">
                <form class="pf-c-form" action="${this.challenge.url}" method="POST">
                    ${Object.entries(this.challenge.attrs).map(([key, value]) => {
      return x`<input
                            type="hidden"
                            name="${key}"
                            value="${value}"
                        />`;
    })}
                    <ak-empty-state ?loading="${true}"> </ak-empty-state>
                    <div class="pf-c-form__group pf-m-action">
                        <button type="submit" class="pf-c-button pf-m-primary pf-m-block">
                            ${msg("Continue")}
                        </button>
                    </div>
                </form>
            </div>
            <footer class="pf-c-login__main-footer">
                <ul class="pf-c-login__main-footer-links"></ul>
            </footer>`;
  }
};
AutosubmitStage = __decorateClass([
  t("ak-stage-autosubmit")
], AutosubmitStage);

export {
  AutosubmitStage
};
//# sourceMappingURL=chunk-UIQILL7E.js.map
