import {
  form_control_default,
  form_default
} from "./chunk-RVW7F5SR.js";
import {
  AKElement,
  n,
  patternfly_base_default,
  t
} from "./chunk-DOEX53UY.js";
import {
  x
} from "./chunk-QY7RAEC6.js";
import {
  __decorateClass
} from "./chunk-PNTXHIFL.js";

// src/elements/forms/FormElement.ts
var FormElement = class extends AKElement {
  constructor() {
    super(...arguments);
    this.required = false;
  }
  static get styles() {
    return [patternfly_base_default, form_default, form_control_default];
  }
  set errors(value) {
    this._errors = value;
    const hasError = (value || []).length > 0;
    this.querySelectorAll("input").forEach((input) => {
      input.setAttribute("aria-invalid", hasError.toString());
    });
    this.requestUpdate();
  }
  updated() {
    this.querySelectorAll("input[autofocus]").forEach((input) => {
      input.focus();
    });
  }
  render() {
    return x`<div class="pf-c-form__group">
            <label class="pf-c-form__label">
                <span class="pf-c-form__label-text">${this.label}</span>
                ${this.required ? x`<span class="pf-c-form__label-required" aria-hidden="true">*</span>` : x``}
            </label>
            <slot></slot>
            ${(this._errors || []).map((error) => {
      return x`<p class="pf-c-form__helper-text pf-m-error">
                    <span class="pf-c-form__helper-text-icon">
                        <i class="fas fa-exclamation-circle" aria-hidden="true"></i> </span
                    >${error.string}
                </p>`;
    })}
        </div>`;
  }
};
__decorateClass([
  n()
], FormElement.prototype, "label", 2);
__decorateClass([
  n({ type: Boolean })
], FormElement.prototype, "required", 2);
__decorateClass([
  n({ attribute: false })
], FormElement.prototype, "errors", 1);
FormElement = __decorateClass([
  t("ak-form-element")
], FormElement);
//# sourceMappingURL=chunk-WY5WRESY.js.map
