import {
  EnterpriseApi
} from "./chunk-DLC2SRWI.js";
import {
  LOCALES,
  enLocale
} from "./chunk-P6KUVHV4.js";
import "./chunk-LKZJBMFY.js";
import "./chunk-KSSYYYDR.js";
import "./chunk-RJXXGELO.js";
import {
  OutpostsApi
} from "./chunk-VVP3K3IZ.js";
import "./chunk-PCJKD5YD.js";
import {
  AggregateCard
} from "./chunk-T5SCNNG6.js";
import {
  AKChart,
  RGBAColor
} from "./chunk-RQ6FKJAX.js";
import {
  ID_REGEX,
  Route,
  SLUG_REGEX,
  UUID_REGEX,
  paramURL
} from "./chunk-4AZTJNGY.js";
import {
  EventGeo,
  EventUser
} from "./chunk-YNQN4LE7.js";
import "./chunk-ME2U4GBS.js";
import {
  actionToLabel
} from "./chunk-BEFPUR3G.js";
import {
  AdminApi
} from "./chunk-AP5GHUBV.js";
import "./chunk-Z7XVYGD6.js";
import {
  banner_default
} from "./chunk-WJSRKCWV.js";
import {
  divider_default
} from "./chunk-DV6AH32P.js";
import "./chunk-FNV26V2B.js";
import {
  grid_default
} from "./chunk-XCEM2TDB.js";
import "./chunk-DJQHOO67.js";
import {
  avatar_default
} from "./chunk-PEOJM4G4.js";
import {
  WithLicenseSummary
} from "./chunk-W4RSYEXS.js";
import {
  ProvidersApi
} from "./chunk-SFAGFFHP.js";
import {
  SourcesApi
} from "./chunk-XSB422CX.js";
import "./chunk-X5TC2QXY.js";
import "./chunk-ZBQTYGSF.js";
import {
  WithCapabilitiesConfig
} from "./chunk-3CKWSC2S.js";
import "./chunk-2G3GM457.js";
import "./chunk-OATKFZXF.js";
import "./chunk-KNLDGZQ5.js";
import {
  o as o2
} from "./chunk-6KRH5U5H.js";
import {
  ModalOrchestrationController
} from "./chunk-GOIBY4UW.js";
import {
  f,
  list_default,
  m
} from "./chunk-WPHOZTKQ.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import {
  showMessage
} from "./chunk-7XZT6QXJ.js";
import {
  Table,
  TableColumn,
  dropdown_default,
  getURLParam,
  uiConfig,
  updateURLParams
} from "./chunk-OOB7B3ZK.js";
import {
  table_default
} from "./chunk-K3AR7TXW.js";
import {
  o
} from "./chunk-5MMRTU65.js";
import "./chunk-QN67UQKM.js";
import {
  AKElement,
  CapabilitiesEnum,
  CoreApi,
  DEFAULT_CONFIG,
  EVENT_API_DRAWER_TOGGLE,
  EVENT_LOCALE_CHANGE,
  EVENT_LOCALE_REQUEST,
  EVENT_MESSAGE,
  EVENT_NOTIFICATION_DRAWER_TOGGLE,
  EVENT_REFRESH,
  EVENT_REFRESH_ENTERPRISE,
  EVENT_REQUEST_POST,
  EVENT_SIDEBAR_TOGGLE,
  EVENT_WS_MESSAGE,
  EventsApi,
  ROUTE_SEPARATOR,
  RootApi,
  SystemTaskStatusEnum,
  UiThemeEnum,
  VERSION,
  WithBrandConfig,
  authentikBrandContext,
  authentikConfigContext,
  authentikEnterpriseContext,
  button_default,
  configureSentry,
  content_default,
  e2 as e,
  e3 as e2,
  ensureCSSStyleSheet,
  getRelativeTime,
  globalAK,
  i2,
  me,
  n,
  page_default,
  patternfly_base_default,
  r,
  t
} from "./chunk-EOF5OWT7.js";
import {
  T,
  configureLocalization,
  i,
  msg,
  s,
  str,
  x
} from "./chunk-MDYFRBOX.js";
import {
  __decorateClass
} from "./chunk-6IFWU6BM.js";

// src/admin/admin-overview/TopApplicationsTable.ts
var TopApplicationsTable = class extends AKElement {
  static get styles() {
    return [table_default];
  }
  firstUpdated() {
    new EventsApi(DEFAULT_CONFIG).eventsEventsTopPerUserList({
      action: "authorize_application",
      topN: 11
    }).then((events) => {
      this.topN = events;
    });
  }
  renderRow(event) {
    return x`<tr role="row">
            <td role="cell">${event.application.name}</td>
            <td role="cell">${event.countedEvents}</td>
            <td role="cell">
                <progress
                    value="${event.countedEvents}"
                    max="${this.topN ? this.topN[0].countedEvents : 0}"
                ></progress>
            </td>
        </tr>`;
  }
  render() {
    return x`<table class="pf-c-table pf-m-compact" role="grid">
            <thead>
                <tr role="row">
                    <th role="columnheader" scope="col">${msg("Application")}</th>
                    <th role="columnheader" scope="col">${msg("Logins")}</th>
                    <th role="columnheader" scope="col"></th>
                </tr>
            </thead>
            <tbody role="rowgroup">
                ${this.topN ? this.topN.map((e3) => this.renderRow(e3)) : x`<ak-spinner></ak-spinner>`}
            </tbody>
        </table>`;
  }
};
__decorateClass([
  n({ attribute: false })
], TopApplicationsTable.prototype, "topN", 2);
TopApplicationsTable = __decorateClass([
  t("ak-top-applications-table")
], TopApplicationsTable);

// src/admin/admin-overview/cards/AdminStatusCard.ts
var AdminStatusCard = class extends AggregateCard {
  constructor() {
    super();
    this.addEventListener(EVENT_REFRESH, () => {
      this.requestUpdate();
    });
  }
  renderValue() {
    return x`${this.value}`;
  }
  renderInner() {
    return x`<p class="center-value">
            ${m(
      this.getPrimaryValue().then((v) => {
        this.value = v;
        return this.getStatus(v);
      }).then((status) => {
        return x`<p><i class="${status.icon}"></i>&nbsp;${this.renderValue()}</p>
                            ${status.message ? x`<p class="subtext">${status.message}</p>` : x``}`;
      }).catch((exc) => {
        return x` <p>
                                <i class="fa fa-times"></i>&nbsp;${exc.response.statusText}
                            </p>
                            <p class="subtext">${msg("Failed to fetch")}</p>`;
      }),
      x`<ak-spinner size="${"pf-m-lg" /* Large */}"></ak-spinner>`
    )}
        </p>`;
  }
};

// src/admin/admin-overview/cards/RecentEventsCard.ts
var RecentEventsCard = class extends Table {
  constructor() {
    super(...arguments);
    this.order = "-created";
    this.pageSize = 10;
  }
  async apiEndpoint(page) {
    return new EventsApi(DEFAULT_CONFIG).eventsEventsList({
      ordering: this.order,
      page,
      pageSize: this.pageSize,
      search: this.search || ""
    });
  }
  static get styles() {
    return super.styles.concat(
      card_default,
      i`
                .pf-c-card__title {
                    --pf-c-card__title--FontFamily: var(
                        --pf-global--FontFamily--heading--sans-serif
                    );
                    --pf-c-card__title--FontSize: var(--pf-global--FontSize--md);
                    --pf-c-card__title--FontWeight: var(--pf-global--FontWeight--bold);
                }
                * {
                    word-break: break-all;
                }
            `
    );
  }
  columns() {
    return [
      new TableColumn(msg("Action"), "action"),
      new TableColumn(msg("User"), "user"),
      new TableColumn(msg("Creation Date"), "created"),
      new TableColumn(msg("Client IP"), "client_ip"),
      new TableColumn(msg("Brand"), "brand_name")
    ];
  }
  renderToolbar() {
    return x`<div class="pf-c-card__title">
            <i class="pf-icon pf-icon-catalog"></i>&nbsp;${msg("Recent events")}
        </div>`;
  }
  row(item) {
    return [
      x`<div><a href="${`#/events/log/${item.pk}`}">${actionToLabel(item.action)}</a></div>
                <small>${item.app}</small>`,
      EventUser(item),
      x`<div>${getRelativeTime(item.created)}</div>
                <small>${item.created.toLocaleString()}</small>`,
      x` <div>${item.clientIp || msg("-")}</div>
                <small>${EventGeo(item)}</small>`,
      x`<span>${item.brand?.name || msg("-")}</span>`
    ];
  }
  renderEmpty() {
    return super.renderEmpty(
      x`<ak-empty-state header=${msg("No Events found.")}>
                <div slot="body">${msg("No matching events could be found.")}</div>
            </ak-empty-state>`
    );
  }
};
__decorateClass([
  n()
], RecentEventsCard.prototype, "order", 2);
__decorateClass([
  n({ type: Number })
], RecentEventsCard.prototype, "pageSize", 2);
RecentEventsCard = __decorateClass([
  t("ak-recent-events")
], RecentEventsCard);

// src/admin/admin-overview/cards/SystemStatusCard.ts
var SystemStatusCard = class extends AdminStatusCard {
  constructor() {
    super(...arguments);
    this.icon = "pf-icon pf-icon-server";
  }
  async getPrimaryValue() {
    this.now = /* @__PURE__ */ new Date();
    let status = await new AdminApi(DEFAULT_CONFIG).adminSystemRetrieve();
    if (!status.embeddedOutpostDisabled && (status.embeddedOutpostHost === "" || !status.embeddedOutpostHost.includes("http"))) {
      await this.setOutpostHost();
      status = await new AdminApi(DEFAULT_CONFIG).adminSystemRetrieve();
    }
    return status;
  }
  // Called on fresh installations and whenever the embedded outpost is deleted
  // automatically send the login URL when the user first visits the admin dashboard.
  async setOutpostHost() {
    const outposts = await new OutpostsApi(DEFAULT_CONFIG).outpostsInstancesList({
      managedIexact: "goauthentik.io/outposts/embedded"
    });
    if (outposts.results.length < 1) {
      return;
    }
    const outpost = outposts.results[0];
    outpost.config["authentik_host"] = window.location.origin;
    await new OutpostsApi(DEFAULT_CONFIG).outpostsInstancesUpdate({
      uuid: outpost.pk,
      outpostRequest: outpost
    });
  }
  getStatus(value) {
    if (!value.embeddedOutpostDisabled && value.embeddedOutpostHost === "") {
      this.statusSummary = msg("Warning");
      return Promise.resolve({
        icon: "fa fa-exclamation-triangle pf-m-warning",
        message: x`${msg("Embedded outpost is not configured correctly.")}
                    <a href="#/outpost/outposts">${msg("Check outposts.")}</a>`
      });
    }
    if (!value.httpIsSecure && document.location.protocol === "https:") {
      this.statusSummary = msg("Warning");
      return Promise.resolve({
        icon: "fa fa-exclamation-triangle pf-m-warning",
        message: x`${msg("HTTPS is not detected correctly")}`
      });
    }
    const timeDiff = value.serverTime.getTime() - (this.now || /* @__PURE__ */ new Date()).getTime();
    if (timeDiff > 5e3 || timeDiff < -5e3) {
      this.statusSummary = msg("Warning");
      return Promise.resolve({
        icon: "fa fa-exclamation-triangle pf-m-warning",
        message: x`${msg("Server and client are further than 5 seconds apart.")}`
      });
    }
    this.statusSummary = msg("OK");
    return Promise.resolve({
      icon: "fa fa-check-circle pf-m-success",
      message: x`${msg("Everything is ok.")}`
    });
  }
  renderHeader() {
    return x`${msg("System status")}`;
  }
  renderValue() {
    return x`${this.statusSummary}`;
  }
};
__decorateClass([
  r()
], SystemStatusCard.prototype, "statusSummary", 2);
SystemStatusCard = __decorateClass([
  t("ak-admin-status-system")
], SystemStatusCard);

// src/admin/admin-overview/cards/VersionStatusCard.ts
var VersionStatusCard = class extends AdminStatusCard {
  constructor() {
    super(...arguments);
    this.icon = "pf-icon pf-icon-bundle";
  }
  getPrimaryValue() {
    return new AdminApi(DEFAULT_CONFIG).adminVersionRetrieve();
  }
  getStatus(value) {
    if (value.buildHash) {
      return Promise.resolve({
        icon: "fa fa-check-circle pf-m-success",
        message: x`${msg(str`Based on ${value.versionCurrent}`)}`
      });
    }
    if (value.outdated) {
      return Promise.resolve({
        icon: "fa fa-exclamation-triangle pf-m-warning",
        message: x`${msg(str`${value.versionLatest} is available!`)}`
      });
    }
    if (value.versionLatestValid) {
      return Promise.resolve({
        icon: "fa fa-check-circle pf-m-success",
        message: x`${msg("Up-to-date!")}`
      });
    }
    return Promise.resolve({
      icon: "fa fa-question-circle",
      message: x`${msg("Latest version unknown")}`
    });
  }
  renderHeader() {
    return x`${msg("Version")}`;
  }
  renderValue() {
    let text = this.value?.versionCurrent;
    const versionFamily2 = this.value?.versionCurrent.split(".");
    versionFamily2?.pop();
    let link = `https://goauthentik.io/docs/releases/${versionFamily2?.join(".")}`;
    if (this.value?.buildHash) {
      text = this.value.buildHash?.substring(0, 7);
      link = `https://github.com/goauthentik/authentik/commit/${this.value.buildHash}`;
    }
    return x`<a href=${link} target="_blank">${text}</a>`;
  }
};
VersionStatusCard = __decorateClass([
  t("ak-admin-status-version")
], VersionStatusCard);

// src/admin/admin-overview/cards/WorkerStatusCard.ts
var WorkersStatusCard = class extends AdminStatusCard {
  constructor() {
    super(...arguments);
    this.icon = "pf-icon pf-icon-server";
  }
  getPrimaryValue() {
    return new AdminApi(DEFAULT_CONFIG).adminWorkersRetrieve().then((workers) => {
      return workers.count;
    });
  }
  renderHeader() {
    return x`${msg("Workers")}`;
  }
  getStatus(value) {
    if (value < 1) {
      return Promise.resolve({
        icon: "fa fa-times-circle pf-m-danger",
        message: x`${msg("No workers connected. Background tasks will not run.")}`
      });
    } else {
      return Promise.resolve({
        icon: "fa fa-check-circle pf-m-success"
      });
    }
  }
};
WorkersStatusCard = __decorateClass([
  t("ak-admin-status-card-workers")
], WorkersStatusCard);

// src/admin/admin-overview/charts/AdminLoginAuthorizeChart.ts
var AdminLoginAuthorizeChart = class extends AKChart {
  async apiRequest() {
    return new AdminApi(DEFAULT_CONFIG).adminMetricsRetrieve();
  }
  getChartData(data) {
    return {
      datasets: [
        {
          label: msg("Authorizations"),
          backgroundColor: new RGBAColor(43, 154, 243, 0.5).toString(),
          borderColor: new RGBAColor(43, 154, 243, 1).toString(),
          spanGaps: true,
          fill: "origin",
          cubicInterpolationMode: "monotone",
          tension: 0.4,
          data: data.authorizations.map((cord) => {
            return {
              x: cord.xCord,
              y: cord.yCord
            };
          })
        },
        {
          label: msg("Failed Logins"),
          backgroundColor: new RGBAColor(201, 24, 11, 0.5).toString(),
          borderColor: new RGBAColor(201, 24, 11, 1).toString(),
          spanGaps: true,
          fill: "origin",
          cubicInterpolationMode: "monotone",
          tension: 0.4,
          data: data.loginsFailed.map((cord) => {
            return {
              x: cord.xCord,
              y: cord.yCord
            };
          })
        },
        {
          label: msg("Successful Logins"),
          backgroundColor: new RGBAColor(62, 134, 53, 0.5).toString(),
          borderColor: new RGBAColor(62, 134, 53, 1).toString(),
          spanGaps: true,
          fill: "origin",
          cubicInterpolationMode: "monotone",
          tension: 0.4,
          data: data.logins.map((cord) => {
            return {
              x: cord.xCord,
              y: cord.yCord
            };
          })
        }
      ]
    };
  }
};
AdminLoginAuthorizeChart = __decorateClass([
  t("ak-charts-admin-login-authorization")
], AdminLoginAuthorizeChart);

// src/admin/admin-overview/charts/OutpostStatusChart.ts
var OutpostStatusChart = class extends AKChart {
  getChartType() {
    return "doughnut";
  }
  getOptions() {
    return {
      plugins: {
        legend: {
          display: false
        }
      },
      maintainAspectRatio: false
    };
  }
  async apiRequest() {
    const api = new OutpostsApi(DEFAULT_CONFIG);
    const outposts = await api.outpostsInstancesList({});
    const outpostStats = [];
    await Promise.all(
      outposts.results.map(async (element) => {
        const health = await api.outpostsInstancesHealthList({
          uuid: element.pk || ""
        });
        const singleStats = {
          unsynced: 0,
          healthy: 0,
          failed: 0,
          total: health.length,
          label: element.name
        };
        if (health.length === 0) {
          singleStats.unsynced += 1;
        }
        health.forEach((h) => {
          if (h.versionOutdated) {
            singleStats.failed += 1;
          } else {
            singleStats.healthy += 1;
          }
        });
        outpostStats.push(singleStats);
      })
    );
    this.centerText = outposts.pagination.count.toString();
    return outpostStats;
  }
  getChartData(data) {
    return {
      labels: [msg("Healthy outposts"), msg("Outdated outposts"), msg("Unhealthy outposts")],
      datasets: data.map((d) => {
        return {
          backgroundColor: ["#3e8635", "#C9190B", "#2b9af3"],
          spanGaps: true,
          data: [d.healthy, d.failed, d.unsynced],
          label: d.label
        };
      })
    };
  }
};
OutpostStatusChart = __decorateClass([
  t("ak-admin-status-chart-outpost")
], OutpostStatusChart);

// src/admin/admin-overview/charts/SyncStatusChart.ts
var LDAPSyncStatusChart = class extends AKChart {
  getChartType() {
    return "doughnut";
  }
  getOptions() {
    return {
      plugins: {
        legend: {
          display: false
        }
      },
      maintainAspectRatio: false
    };
  }
  async ldapStatus() {
    const api = new SourcesApi(DEFAULT_CONFIG);
    const sources = await api.sourcesLdapList({});
    const metrics = {
      healthy: 0,
      failed: 0,
      unsynced: 0
    };
    await Promise.all(
      sources.results.map(async (element) => {
        try {
          const health = await api.sourcesLdapSyncStatusRetrieve({
            slug: element.slug
          });
          health.tasks.forEach((task) => {
            if (task.status !== SystemTaskStatusEnum.Successful) {
              metrics.failed += 1;
            }
            const now = (/* @__PURE__ */ new Date()).getTime();
            const maxDelta = 36e5;
            if (!health || now - task.finishTimestamp.getTime() > maxDelta) {
              metrics.unsynced += 1;
            } else {
              metrics.healthy += 1;
            }
          });
          if (health.tasks.length < 1) {
            metrics.unsynced += 1;
          }
        } catch {
          metrics.unsynced += 1;
        }
      })
    );
    return {
      healthy: metrics.healthy,
      failed: metrics.failed,
      unsynced: sources.pagination.count === 0 ? 1 : metrics.unsynced,
      total: sources.pagination.count,
      label: msg("LDAP Source")
    };
  }
  async scimStatus() {
    const api = new ProvidersApi(DEFAULT_CONFIG);
    const providers = await api.providersScimList({});
    const metrics = {
      healthy: 0,
      failed: 0,
      unsynced: 0
    };
    await Promise.all(
      providers.results.map(async (element) => {
        let sourceKey = "healthy";
        try {
          const health = await api.providersScimSyncStatusRetrieve({
            id: element.pk
          });
          health.tasks.forEach((task) => {
            if (task.status !== SystemTaskStatusEnum.Successful) {
              sourceKey = "failed";
            }
            const now = (/* @__PURE__ */ new Date()).getTime();
            const maxDelta = 36e5;
            if (!health || now - task.finishTimestamp.getTime() > maxDelta) {
              sourceKey = "unsynced";
            }
          });
        } catch {
          sourceKey = "unsynced";
        }
        metrics[sourceKey] += 1;
      })
    );
    return {
      healthy: metrics.healthy,
      failed: metrics.failed,
      unsynced: providers.pagination.count === 0 ? 1 : metrics.unsynced,
      total: providers.pagination.count,
      label: msg("SCIM Provider")
    };
  }
  async apiRequest() {
    const ldapStatus = await this.ldapStatus();
    const scimStatus = await this.scimStatus();
    this.centerText = (ldapStatus.total + scimStatus.total).toString();
    return [ldapStatus, scimStatus];
  }
  getChartData(data) {
    return {
      labels: [msg("Healthy"), msg("Failed"), msg("Unsynced / N/A")],
      datasets: data.map((d) => {
        return {
          backgroundColor: ["#3e8635", "#C9190B", "#2b9af3"],
          spanGaps: true,
          data: [d.healthy, d.failed, d.unsynced],
          label: d.label
        };
      })
    };
  }
};
LDAPSyncStatusChart = __decorateClass([
  t("ak-admin-status-chart-sync")
], LDAPSyncStatusChart);

// src/admin/admin-overview/AdminOverviewPage.ts
function versionFamily() {
  const parts = VERSION.split(".");
  parts.pop();
  return parts.join(".");
}
var AdminOverviewPage = class extends AKElement {
  static get styles() {
    return [
      patternfly_base_default,
      grid_default,
      page_default,
      content_default,
      list_default,
      divider_default,
      i`
                .pf-l-grid__item {
                    height: 100%;
                }
                .pf-l-grid__item.big-graph-container {
                    height: 35em;
                }
                .card-container {
                    max-height: 10em;
                }
                .ak-external-link {
                    display: inline-block;
                    margin-left: 0.175rem;
                    vertical-align: super;
                    line-height: normal;
                    font-size: var(--pf-global--icon--FontSize--sm);
                }
            `
    ];
  }
  async firstUpdated() {
    this.user = await me();
  }
  render() {
    const name = this.user?.user.name ?? this.user?.user.username;
    return x`<ak-page-header icon="" header="" description=${msg("General system status")}>
                <span slot="header"> ${msg(str`Welcome, ${name}.`)} </span>
            </ak-page-header>
            <section class="pf-c-page__main-section">
                <div class="pf-l-grid pf-m-gutter">
                    <!-- row 1 -->
                    <div
                        class="pf-l-grid__item pf-m-12-col pf-m-6-col-on-xl pf-m-6-col-on-2xl pf-l-grid pf-m-gutter"
                    >
                        <div class="pf-l-grid__item pf-m-12-col pf-m-6-col-on-xl pf-m-4-col-on-2xl">
                            <ak-aggregate-card
                                icon="fa fa-share"
                                header=${msg("Quick actions")}
                                .isCenter=${false}
                            >
                                <ul class="pf-c-list">
                                    <li>
                                        <a
                                            class="pf-u-mb-xl"
                                            href=${paramURL("/core/applications", {
      createForm: true
    })}
                                            >${msg("Create a new application")}</a
                                        >
                                    </li>
                                    <li>
                                        <a class="pf-u-mb-xl" href=${paramURL("/events/log")}
                                            >${msg("Check the logs")}</a
                                        >
                                    </li>
                                    <li>
                                        <a
                                            class="pf-u-mb-xl"
                                            target="_blank"
                                            href="https://goauthentik.io/integrations/"
                                            >${msg("Explore integrations")}<i
                                                class="fas fa-external-link-alt ak-external-link"
                                            ></i
                                        ></a>
                                    </li>
                                    <li>
                                        <a class="pf-u-mb-xl" href=${paramURL("/identity/users")}
                                            >${msg("Manage users")}</a
                                        >
                                    </li>
                                    <li>
                                        <a
                                            class="pf-u-mb-xl"
                                            target="_blank"
                                            href="https://goauthentik.io/docs/releases/${versionFamily()}#fixed-in-${VERSION.replaceAll(
      ".",
      ""
    )}"
                                            >${msg("Check the release notes")}<i
                                                class="fas fa-external-link-alt ak-external-link"
                                            ></i
                                        ></a>
                                    </li>
                                </ul>
                            </ak-aggregate-card>
                        </div>
                        <div class="pf-l-grid__item pf-m-12-col pf-m-6-col-on-xl pf-m-4-col-on-2xl">
                            <ak-aggregate-card
                                icon="pf-icon pf-icon-zone"
                                header=${msg("Outpost status")}
                                headerLink="#/outpost/outposts"
                            >
                                <ak-admin-status-chart-outpost></ak-admin-status-chart-outpost>
                            </ak-aggregate-card>
                        </div>
                        <div
                            class="pf-l-grid__item pf-m-12-col pf-m-12-col-on-xl pf-m-4-col-on-2xl"
                        >
                            <ak-aggregate-card icon="fa fa-sync-alt" header=${msg("Sync status")}>
                                <ak-admin-status-chart-sync></ak-admin-status-chart-sync>
                            </ak-aggregate-card>
                        </div>
                        <div class="pf-l-grid__item pf-m-12-col">
                            <hr class="pf-c-divider" />
                        </div>
                        <div
                            class="pf-l-grid__item pf-m-6-col pf-m-4-col-on-md pf-m-4-col-on-xl card-container"
                        >
                            <ak-admin-status-system> </ak-admin-status-system>
                        </div>
                        <div
                            class="pf-l-grid__item pf-m-6-col pf-m-4-col-on-md pf-m-4-col-on-xl card-container"
                        >
                            <ak-admin-status-version> </ak-admin-status-version>
                        </div>
                        <div
                            class="pf-l-grid__item pf-m-6-col pf-m-4-col-on-md pf-m-4-col-on-xl card-container"
                        >
                            <ak-admin-status-card-workers> </ak-admin-status-card-workers>
                        </div>
                    </div>
                    <div class="pf-l-grid__item pf-m-12-col pf-m-6-col-on-xl">
                        <ak-recent-events pageSize="6"></ak-recent-events>
                    </div>
                    <div class="pf-l-grid__item pf-m-12-col">
                        <hr class="pf-c-divider" />
                    </div>
                    <!-- row 3 -->
                    <div
                        class="pf-l-grid__item pf-m-12-col pf-m-6-col-on-xl pf-m-8-col-on-2xl big-graph-container"
                    >
                        <ak-aggregate-card
                            icon="pf-icon pf-icon-server"
                            header=${msg(
      "Logins and authorizations over the last week (per 8 hours)"
    )}
                        >
                            <ak-charts-admin-login-authorization></ak-charts-admin-login-authorization>
                        </ak-aggregate-card>
                    </div>
                    <div
                        class="pf-l-grid__item pf-m-12-col pf-m-6-col-on-xl pf-m-4-col-on-2xl big-graph-container"
                    >
                        <ak-aggregate-card
                            icon="pf-icon pf-icon-server"
                            header=${msg("Apps with most usage")}
                        >
                            <ak-top-applications-table></ak-top-applications-table>
                        </ak-aggregate-card>
                    </div>
                </div>
            </section>`;
  }
};
__decorateClass([
  r()
], AdminOverviewPage.prototype, "user", 2);
AdminOverviewPage = __decorateClass([
  t("ak-admin-overview")
], AdminOverviewPage);

// src/admin/Routes.ts
var ROUTES = [
  // Prevent infinite Shell loops
  new Route(new RegExp("^/$")).redirect("/administration/overview"),
  new Route(new RegExp("^#.*")).redirect("/administration/overview"),
  new Route(new RegExp("^/library$")).redirect("/if/user/", true),
  // statically imported since this is the default route
  new Route(new RegExp("^/administration/overview$"), async () => {
    return x`<ak-admin-overview></ak-admin-overview>`;
  }),
  new Route(new RegExp("^/administration/dashboard/users$"), async () => {
    await import("./DashboardUserPage-JH7O5SCP.js");
    return x`<ak-admin-dashboard-users></ak-admin-dashboard-users>`;
  }),
  new Route(new RegExp("^/administration/system-tasks$"), async () => {
    await import("./SystemTaskListPage-X73L5VTH.js");
    return x`<ak-system-task-list></ak-system-task-list>`;
  }),
  new Route(new RegExp("^/core/providers$"), async () => {
    await import("./ProviderListPage-IDKXEB5S.js");
    return x`<ak-provider-list></ak-provider-list>`;
  }),
  new Route(new RegExp(`^/core/providers/(?<id>${ID_REGEX})$`), async (args) => {
    await import("./ProviderViewPage-6JXT2L6N.js");
    return x`<ak-provider-view .providerID=${parseInt(args.id, 10)}></ak-provider-view>`;
  }),
  new Route(new RegExp("^/core/applications$"), async () => {
    await import("./ApplicationListPage-CYJQ73LV.js");
    return x`<ak-application-list></ak-application-list>`;
  }),
  new Route(new RegExp(`^/core/applications/(?<slug>${SLUG_REGEX})$`), async (args) => {
    await import("./ApplicationViewPage-7R7HWNZ2.js");
    return x`<ak-application-view .applicationSlug=${args.slug}></ak-application-view>`;
  }),
  new Route(new RegExp("^/core/sources$"), async () => {
    await import("./SourceListPage-W7HSJALU.js");
    return x`<ak-source-list></ak-source-list>`;
  }),
  new Route(new RegExp(`^/core/sources/(?<slug>${SLUG_REGEX})$`), async (args) => {
    await import("./SourceViewPage-743ARIDC.js");
    return x`<ak-source-view .sourceSlug=${args.slug}></ak-source-view>`;
  }),
  new Route(new RegExp("^/core/property-mappings$"), async () => {
    await import("./PropertyMappingListPage-IXUYWQYE.js");
    return x`<ak-property-mapping-list></ak-property-mapping-list>`;
  }),
  new Route(new RegExp("^/core/tokens$"), async () => {
    await import("./TokenListPage-YASE3S73.js");
    return x`<ak-token-list></ak-token-list>`;
  }),
  new Route(new RegExp("^/core/brands"), async () => {
    await import("./BrandListPage-FVUEVY66.js");
    return x`<ak-brand-list></ak-brand-list>`;
  }),
  new Route(new RegExp("^/policy/policies$"), async () => {
    await import("./PolicyListPage-HYVFJ3K3.js");
    return x`<ak-policy-list></ak-policy-list>`;
  }),
  new Route(new RegExp("^/policy/reputation$"), async () => {
    await import("./ReputationListPage-VHPDESUP.js");
    return x`<ak-policy-reputation-list></ak-policy-reputation-list>`;
  }),
  new Route(new RegExp("^/identity/groups$"), async () => {
    await import("./GroupListPage-FC57LKTN.js");
    return x`<ak-group-list></ak-group-list>`;
  }),
  new Route(new RegExp(`^/identity/groups/(?<uuid>${UUID_REGEX})$`), async (args) => {
    await import("./GroupViewPage-O3QRCFMU.js");
    return x`<ak-group-view .groupId=${args.uuid}></ak-group-view>`;
  }),
  new Route(new RegExp("^/identity/users$"), async () => {
    await import("./UserListPage-J6AZTJ2T.js");
    return x`<ak-user-list></ak-user-list>`;
  }),
  new Route(new RegExp(`^/identity/users/(?<id>${ID_REGEX})$`), async (args) => {
    await import("./UserViewPage-6LPKM5WB.js");
    return x`<ak-user-view .userId=${parseInt(args.id, 10)}></ak-user-view>`;
  }),
  new Route(new RegExp("^/identity/roles$"), async () => {
    await import("./RoleListPage-POYW72OE.js");
    return x`<ak-role-list></ak-role-list>`;
  }),
  new Route(new RegExp(`^/identity/roles/(?<id>${UUID_REGEX})$`), async (args) => {
    await import("./RoleViewPage-LXJWS2M5.js");
    return x`<ak-role-view roleId=${args.id}></ak-role-view>`;
  }),
  new Route(new RegExp("^/flow/stages/invitations$"), async () => {
    await import("./InvitationListPage-JHGZ5K3V.js");
    return x`<ak-stage-invitation-list></ak-stage-invitation-list>`;
  }),
  new Route(new RegExp("^/flow/stages/prompts$"), async () => {
    await import("./PromptListPage-FHJQR4SH.js");
    return x`<ak-stage-prompt-list></ak-stage-prompt-list>`;
  }),
  new Route(new RegExp("^/flow/stages$"), async () => {
    await import("./StageListPage-F5HBII6V.js");
    return x`<ak-stage-list></ak-stage-list>`;
  }),
  new Route(new RegExp("^/flow/flows$"), async () => {
    await import("./FlowListPage-FA6ELLKI.js");
    return x`<ak-flow-list></ak-flow-list>`;
  }),
  new Route(new RegExp(`^/flow/flows/(?<slug>${SLUG_REGEX})$`), async (args) => {
    await import("./FlowViewPage-YWGHCSVP.js");
    return x`<ak-flow-view .flowSlug=${args.slug}></ak-flow-view>`;
  }),
  new Route(new RegExp("^/events/log$"), async () => {
    await import("./EventListPage-AI3HCR57.js");
    return x`<ak-event-list></ak-event-list>`;
  }),
  new Route(new RegExp(`^/events/log/(?<id>${UUID_REGEX})$`), async (args) => {
    await import("./EventViewPage-TGB2ULRM.js");
    return x`<ak-event-view .eventID=${args.id}></ak-event-view>`;
  }),
  new Route(new RegExp("^/events/transports$"), async () => {
    await import("./TransportListPage-OLMHA3V3.js");
    return x`<ak-event-transport-list></ak-event-transport-list>`;
  }),
  new Route(new RegExp("^/events/rules$"), async () => {
    await import("./RuleListPage-MO4Q4IJB.js");
    return x`<ak-event-rule-list></ak-event-rule-list>`;
  }),
  new Route(new RegExp("^/outpost/outposts$"), async () => {
    await import("./OutpostListPage-FUYGTFLU.js");
    return x`<ak-outpost-list></ak-outpost-list>`;
  }),
  new Route(new RegExp("^/outpost/integrations$"), async () => {
    await import("./ServiceConnectionListPage-YHOZL2NY.js");
    return x`<ak-outpost-service-connection-list></ak-outpost-service-connection-list>`;
  }),
  new Route(new RegExp("^/crypto/certificates$"), async () => {
    await import("./CertificateKeyPairListPage-FMZHMCUX.js");
    return x`<ak-crypto-certificate-list></ak-crypto-certificate-list>`;
  }),
  new Route(new RegExp("^/admin/settings$"), async () => {
    await import("./AdminSettingsPage-U6MZZMAS.js");
    return x`<ak-admin-settings></ak-admin-settings>`;
  }),
  new Route(new RegExp("^/blueprints/instances$"), async () => {
    await import("./BlueprintListPage-KA33GR4I.js");
    return x`<ak-blueprint-list></ak-blueprint-list>`;
  }),
  new Route(new RegExp("^/debug$"), async () => {
    await import("./DebugPage-XOW3U475.js");
    return x`<ak-admin-debug-page></ak-admin-debug-page>`;
  }),
  new Route(new RegExp("^/enterprise/licenses$"), async () => {
    await import("./EnterpriseLicenseListPage-HXHEZVPX.js");
    return x`<ak-enterprise-license-list></ak-enterprise-license-list>`;
  })
];

// src/common/ws.ts
var WebsocketClient = class {
  constructor() {
    this.retryDelay = 200;
    try {
      this.connect();
    } catch (error) {
      console.warn(`authentik/ws: failed to connect to ws ${error}`);
    }
  }
  connect() {
    if (navigator.webdriver)
      return;
    const wsUrl = `${window.location.protocol.replace("http", "ws")}//${window.location.host}/ws/client/`;
    this.messageSocket = new WebSocket(wsUrl);
    this.messageSocket.addEventListener("open", () => {
      console.debug(`authentik/ws: connected to ${wsUrl}`);
      this.retryDelay = 200;
    });
    this.messageSocket.addEventListener("close", (e3) => {
      console.debug("authentik/ws: closed ws connection", e3);
      if (this.retryDelay > 6e3) {
        window.dispatchEvent(
          new CustomEvent(EVENT_MESSAGE, {
            bubbles: true,
            composed: true,
            detail: {
              level: "error" /* error */,
              message: msg("Connection error, reconnecting...")
            }
          })
        );
      }
      setTimeout(() => {
        console.debug(`authentik/ws: reconnecting ws in ${this.retryDelay}ms`);
        this.connect();
      }, this.retryDelay);
      this.retryDelay = this.retryDelay * 2;
    });
    this.messageSocket.addEventListener("message", (e3) => {
      const data = JSON.parse(e3.data);
      window.dispatchEvent(
        new CustomEvent(EVENT_WS_MESSAGE, {
          bubbles: true,
          composed: true,
          detail: data
        })
      );
    });
    this.messageSocket.addEventListener("error", () => {
      this.retryDelay = this.retryDelay * 2;
    });
  }
};

// src/elements/Interface/BrandContextController.ts
var BrandContextController = class {
  constructor(host) {
    this.host = host;
    this.context = new i2(this.host, {
      context: authentikBrandContext,
      initialValue: void 0
    });
    this.fetch = this.fetch.bind(this);
    this.fetch();
  }
  fetch() {
    new CoreApi(DEFAULT_CONFIG).coreBrandsCurrentRetrieve().then((brand) => {
      this.context.setValue(brand);
      this.host.brand = brand;
    });
  }
  hostConnected() {
    window.addEventListener(EVENT_REFRESH, this.fetch);
  }
  hostDisconnected() {
    window.removeEventListener(EVENT_REFRESH, this.fetch);
  }
  hostUpdate() {
    if (this.host.brand !== this.context.value) {
      this.context.setValue(this.host.brand);
    }
  }
};

// src/elements/Interface/ConfigContextController.ts
var ConfigContextController = class {
  constructor(host) {
    this.host = host;
    this.context = new i2(this.host, {
      context: authentikConfigContext,
      initialValue: void 0
    });
    this.context.setValue(globalAK().config);
    this.host.config = globalAK().config;
    this.fetch = this.fetch.bind(this);
    this.fetch();
  }
  fetch() {
    new RootApi(DEFAULT_CONFIG).rootConfigRetrieve().then((config) => {
      this.context.setValue(config);
      this.host.config = config;
    });
  }
  hostConnected() {
    window.addEventListener(EVENT_REFRESH, this.fetch);
  }
  hostDisconnected() {
    window.removeEventListener(EVENT_REFRESH, this.fetch);
  }
  hostUpdate() {
    if (this.host.config !== this.context.value) {
      this.context.setValue(this.host.config);
    }
  }
};

// src/elements/Interface/EnterpriseContextController.ts
var EnterpriseContextController = class {
  constructor(host) {
    this.host = host;
    this.context = new i2(this.host, {
      context: authentikEnterpriseContext,
      initialValue: void 0
    });
    this.fetch = this.fetch.bind(this);
    this.fetch();
  }
  fetch() {
    new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseSummaryRetrieve().then((enterprise) => {
      this.context.setValue(enterprise);
      this.host.licenseSummary = enterprise;
    });
  }
  hostConnected() {
    window.addEventListener(EVENT_REFRESH_ENTERPRISE, this.fetch);
  }
  hostDisconnected() {
    window.removeEventListener(EVENT_REFRESH_ENTERPRISE, this.fetch);
  }
  hostUpdate() {
    if (this.host.licenseSummary !== this.context.value) {
      this.context.setValue(this.host.licenseSummary);
    }
  }
};

// src/elements/Interface/Interface.ts
var brandContext = Symbol("brandContext");
var configContext = Symbol("configContext");
var modalController = Symbol("modalController");
var Interface = class extends AKElement {
  static {
    brandContext, configContext, modalController;
  }
  constructor() {
    super();
    document.adoptedStyleSheets = [...document.adoptedStyleSheets, ensureCSSStyleSheet(patternfly_base_default)];
    this[brandContext] = new BrandContextController(this);
    this[configContext] = new ConfigContextController(this);
    this[modalController] = new ModalOrchestrationController(this);
    this.dataset.akInterfaceRoot = "true";
  }
  _activateTheme(root, theme) {
    super._activateTheme(root, theme);
    super._activateTheme(document, theme);
  }
  async getTheme() {
    if (!this.uiConfig) {
      this.uiConfig = await uiConfig();
    }
    return this.uiConfig.theme?.base || UiThemeEnum.Automatic;
  }
};
__decorateClass([
  r()
], Interface.prototype, "uiConfig", 2);
__decorateClass([
  r()
], Interface.prototype, "config", 2);
__decorateClass([
  r()
], Interface.prototype, "brand", 2);
var enterpriseContext = Symbol("enterpriseContext");
var EnterpriseAwareInterface = class extends Interface {
  static {
    enterpriseContext;
  }
  constructor() {
    super();
    this[enterpriseContext] = new EnterpriseContextController(this);
  }
};
__decorateClass([
  r()
], EnterpriseAwareInterface.prototype, "licenseSummary", 2);

// src/elements/utils/customEvents.ts
var customEvent = (name, details = {}) => new CustomEvent(name, {
  composed: true,
  bubbles: true,
  detail: details
});

// src/locale-codes.ts
var sourceLocale = `en`;
var targetLocales = [
  `de`,
  `en`,
  `es`,
  `fr`,
  `ko`,
  `nl`,
  `pl`,
  `pseudo-LOCALE`,
  `tr`,
  `zh_TW`,
  `zh-CN`,
  `zh-Hans`,
  `zh-Hant`
];

// src/elements/ak-locale-context/helpers.ts
var DEFAULT_LOCALE = "en";
var TOMBSTONE = "\u26FC\u26FCtombstone\u26FC\u26FC";
var LOCALES2 = LOCALES.map(
  (locale) => locale.code === "en" ? { ...locale, locale: async () => enLocale } : locale
);
function getBestMatchLocale(locale) {
  return LOCALES2.find((l) => l.match.test(locale));
}
function findSupportedLocale(candidates) {
  const candidate = candidates.find((candidate2) => getBestMatchLocale(candidate2));
  return candidate ? getBestMatchLocale(candidate) : void 0;
}
function localeCodeFromUrl(param = "locale") {
  const url = new URL(window.location.href);
  return url.searchParams.get(param) || "";
}
var isLocaleCandidate = (v) => typeof v === "string" && v !== "" && v !== TOMBSTONE;
function autoDetectLanguage(userReq = TOMBSTONE, brandReq = TOMBSTONE) {
  const localeCandidates = [
    localeCodeFromUrl("locale"),
    userReq,
    window.navigator?.language ?? TOMBSTONE,
    brandReq,
    globalAK()?.locale ?? TOMBSTONE,
    DEFAULT_LOCALE
  ].filter(isLocaleCandidate);
  const firstSupportedLocale = findSupportedLocale(localeCandidates);
  if (!firstSupportedLocale) {
    console.debug(
      `authentik/locale: No locale found for '[${localeCandidates}.join(',')]', falling back to ${DEFAULT_LOCALE}`
    );
    return DEFAULT_LOCALE;
  }
  return firstSupportedLocale.code;
}

// src/elements/ak-locale-context/configureLocale.ts
var getLocale = void 0;
var setLocale = void 0;
function initializeLocalization() {
  if (getLocale && setLocale) {
    return [getLocale, setLocale];
  }
  ({ getLocale, setLocale } = configureLocalization({
    sourceLocale,
    targetLocales,
    loadLocale: async (locale) => {
      const localeDef = getBestMatchLocale(locale);
      if (!localeDef) {
        console.warn(`Unrecognized locale: ${localeDef}`);
        return Promise.reject("");
      }
      return localeDef.locale();
    }
  }));
  return [getLocale, setLocale];
}

// src/elements/ak-locale-context/ak-locale-context.ts
var LocaleContextBase = WithBrandConfig(s);
var LocaleContext = class extends LocaleContextBase {
  constructor(code = DEFAULT_LOCALE) {
    super();
    this.locale = DEFAULT_LOCALE;
    this.param = "locale";
    this.notifyApplication = this.notifyApplication.bind(this);
    this.updateLocaleHandler = this.updateLocaleHandler.bind(this);
    try {
      const [getLocale2, setLocale2] = initializeLocalization();
      this.getLocale = getLocale2;
      this.setLocale = setLocale2;
      this.setLocale(code).then(() => {
        window.setTimeout(this.notifyApplication, 0);
      });
    } catch (e3) {
      throw new Error(`Developer error: Must have only one locale context per session: ${e3}`);
    }
  }
  connectedCallback() {
    super.connectedCallback();
    this.updateLocale();
    window.addEventListener(EVENT_LOCALE_REQUEST, this.updateLocaleHandler);
  }
  disconnectedCallback() {
    window.removeEventListener(EVENT_LOCALE_REQUEST, this.updateLocaleHandler);
    super.disconnectedCallback();
  }
  updateLocaleHandler(ev) {
    console.debug("authentik/locale: Locale update request received.");
    this.updateLocale(ev.detail.locale);
  }
  updateLocale(requestedLocale = void 0) {
    const localeRequest = autoDetectLanguage(requestedLocale, this.brand?.defaultLocale);
    const locale = getBestMatchLocale(localeRequest);
    if (!locale) {
      console.warn(`authentik/locale: failed to find locale for code ${localeRequest}`);
      return;
    }
    locale.locale().then(() => {
      console.debug(`Setting Locale to ... ${locale.label()} (${locale.code})`);
      this.setLocale(locale.code).then(() => {
        window.setTimeout(this.notifyApplication, 0);
      });
    });
  }
  notifyApplication() {
    this.dispatchEvent(customEvent(EVENT_LOCALE_CHANGE));
  }
  render() {
    return x`<slot></slot>`;
  }
};
__decorateClass([
  n({ attribute: true, type: String })
], LocaleContext.prototype, "locale", 2);
__decorateClass([
  n({ attribute: true, type: String })
], LocaleContext.prototype, "param", 2);
LocaleContext = __decorateClass([
  t("ak-locale-context")
], LocaleContext);

// src/elements/enterprise/EnterpriseStatusBanner.ts
var EnterpriseStatusBanner = class extends WithLicenseSummary(AKElement) {
  constructor() {
    super(...arguments);
    this.interface = "";
  }
  static get styles() {
    return [banner_default];
  }
  renderBanner() {
    return x`<div
            class="pf-c-banner ${this.licenseSummary?.readOnly ? "pf-m-red" : "pf-m-gold"}"
        >
            ${msg("Warning: The current user count has exceeded the configured licenses.")}
            <a href="/if/admin/#/enterprise/licenses"> ${msg("Click here for more info.")} </a>
        </div>`;
  }
  render() {
    switch (this.interface.toLowerCase()) {
      case "admin":
        if (this.licenseSummary?.showAdminWarning || this.licenseSummary?.readOnly) {
          return this.renderBanner();
        }
        break;
      case "user":
        if (this.licenseSummary?.showUserWarning || this.licenseSummary?.readOnly) {
          return this.renderBanner();
        }
        break;
    }
    return x``;
  }
};
__decorateClass([
  n()
], EnterpriseStatusBanner.prototype, "interface", 2);
EnterpriseStatusBanner = __decorateClass([
  t("ak-enterprise-status")
], EnterpriseStatusBanner);

// node_modules/@patternfly/patternfly/components/NotificationDrawer/notification-drawer.css
var notification_drawer_default = '.pf-c-notification-drawer {\n  --pf-c-notification-drawer--BackgroundColor: var(--pf-global--BackgroundColor--200);\n  --pf-c-notification-drawer__header--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__header--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__header--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__header--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__header--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-notification-drawer__header--BoxShadow: var(--pf-global--BoxShadow--sm-bottom);\n  --pf-c-notification-drawer__header--ZIndex: var(--pf-global--ZIndex--sm);\n  --pf-c-notification-drawer__header-title--FontSize: var(--pf-global--FontSize--xl);\n  --pf-c-notification-drawer__header-status--MarginLeft: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__body--ZIndex: var(--pf-global--ZIndex--xs);\n  --pf-c-notification-drawer__list-item--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__list-item--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__list-item--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__list-item--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__list-item--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-notification-drawer__list-item--BoxShadow: inset var(--pf-global--BoxShadow--sm-bottom);\n  --pf-c-notification-drawer__list-item--BorderBottomWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-notification-drawer__list-item--BorderBottomColor: transparent;\n  --pf-c-notification-drawer__list-item--OutlineOffset: -0.25rem;\n  --pf-c-notification-drawer__list-item--before--Width: var(--pf-global--BorderWidth--lg);\n  --pf-c-notification-drawer__list-item--before--Top: 0;\n  --pf-c-notification-drawer__list-item--before--Bottom: calc(var(--pf-c-notification-drawer__list-item--BorderBottomWidth) * -1);\n  --pf-c-notification-drawer__list-item--m-info__list-item-header-icon--Color: var(--pf-global--info-color--100);\n  --pf-c-notification-drawer__list-item--m-info__list-item--before--BackgroundColor: var(--pf-global--info-color--100);\n  --pf-c-notification-drawer__list-item--m-warning__list-item-header-icon--Color: var(--pf-global--warning-color--100);\n  --pf-c-notification-drawer__list-item--m-warning__list-item--before--BackgroundColor: var(--pf-global--warning-color--100);\n  --pf-c-notification-drawer__list-item--m-danger__list-item-header-icon--Color: var(--pf-global--danger-color--100);\n  --pf-c-notification-drawer__list-item--m-danger__list-item--before--BackgroundColor: var(--pf-global--danger-color--100);\n  --pf-c-notification-drawer__list-item--m-success__list-item-header-icon--Color: var(--pf-global--success-color--100);\n  --pf-c-notification-drawer__list-item--m-success__list-item--before--BackgroundColor: var(--pf-global--success-color--100);\n  --pf-c-notification-drawer__list-item--m-default__list-item-header-icon--Color: var(--pf-global--default-color--200);\n  --pf-c-notification-drawer__list-item--m-default__list-item--before--BackgroundColor: var(--pf-global--default-color--200);\n  --pf-c-notification-drawer__list-item--m-read--BackgroundColor: var(--pf-global--BackgroundColor--200);\n  --pf-c-notification-drawer__list-item--m-read--BorderBottomColor: var(--pf-global--BorderColor--100);\n  --pf-c-notification-drawer__list-item--m-read--before--Top: calc(var(--pf-c-notification-drawer__list-item--BorderBottomWidth) * -1);\n  --pf-c-notification-drawer__list-item--m-read--before--Bottom: 0;\n  --pf-c-notification-drawer__list-item--m-read--before--BackgroundColor: transparent;\n  --pf-c-notification-drawer__list-item--list-item--m-read--before--Top: 0;\n  --pf-c-notification-drawer__list-item--list-item--m-read--BoxShadow: inset var(--pf-global--BoxShadow--sm-bottom);\n  --pf-c-notification-drawer__list-item--m-hoverable--hover--ZIndex: var(--pf-global--ZIndex--xs);\n  --pf-c-notification-drawer__list-item--m-hoverable--hover--BoxShadow: var(--pf-global--BoxShadow--md-top), var(--pf-global--BoxShadow--md-bottom);\n  --pf-c-notification-drawer__list-item-header--MarginBottom: var(--pf-global--spacer--xs);\n  --pf-c-notification-drawer__list-item-header-icon--Color: inherit;\n  --pf-c-notification-drawer__list-item-header-icon--MarginRight: var(--pf-global--spacer--sm);\n  --pf-c-notification-drawer__list-item-header-title--FontWeight: var(--pf-global--FontWeight--bold);\n  --pf-c-notification-drawer__list-item-header-title--max-lines: 1;\n  --pf-c-notification-drawer__list-item--m-read__list-item-header-title--FontWeight: var(--pf-global--FontWeight--normal);\n  --pf-c-notification-drawer__list-item-description--MarginBottom: var(--pf-global--spacer--sm);\n  --pf-c-notification-drawer__list-item-timestamp--Color: var(--pf-global--Color--200);\n  --pf-c-notification-drawer__list-item-timestamp--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-notification-drawer__group--m-expanded--group--BorderTopWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-notification-drawer__group--m-expanded--group--BorderTopColor: var(--pf-global--BorderColor--100);\n  --pf-c-notification-drawer__group--m-expanded--MinHeight: 0;\n  --pf-c-notification-drawer__group-toggle--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__group-toggle--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__group-toggle--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__group-toggle--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__group-toggle--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-notification-drawer__group-toggle--BorderColor: var(--pf-global--BorderColor--100);\n  --pf-c-notification-drawer__group-toggle--BorderBottomWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-notification-drawer__group-toggle--OutlineOffset: -0.25rem;\n  --pf-c-notification-drawer__group-toggle-title--MarginRight: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__group-toggle-title--max-lines: 1;\n  --pf-c-notification-drawer__group-toggle-count--MarginRight: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__group-toggle-icon--MarginRight: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__group-toggle-icon--Color: var(--pf-global--Color--200);\n  --pf-c-notification-drawer__group-toggle-icon--Transition: .2s ease-in 0s;\n  --pf-c-notification-drawer__group--m-expanded__group-toggle-icon--Rotate: 90deg;\n  display: flex;\n  flex-direction: column;\n  height: 100%;\n  background-color: var(--pf-c-notification-drawer--BackgroundColor);\n}\n\n.pf-c-notification-drawer__header {\n  position: relative;\n  z-index: var(--pf-c-notification-drawer__header--ZIndex);\n  display: flex;\n  flex-shrink: 0;\n  align-items: baseline;\n  padding: var(--pf-c-notification-drawer__header--PaddingTop) var(--pf-c-notification-drawer__header--PaddingRight) var(--pf-c-notification-drawer__header--PaddingBottom) var(--pf-c-notification-drawer__header--PaddingLeft);\n  background-color: var(--pf-c-notification-drawer__header--BackgroundColor);\n  box-shadow: var(--pf-c-notification-drawer__header--BoxShadow);\n}\n\n.pf-c-notification-drawer__header-title {\n  font-size: var(--pf-c-notification-drawer__header-title--FontSize);\n}\n\n.pf-c-notification-drawer__header-status {\n  margin-left: var(--pf-c-notification-drawer__header-status--MarginLeft);\n}\n\n.pf-c-notification-drawer__header-action {\n  display: flex;\n  align-items: center;\n  margin-left: auto;\n}\n\n.pf-c-notification-drawer__body {\n  overflow-y: auto;\n  box-shadow: var(--pf-c-notification-drawer__body--ZIndex);\n}\n\n.pf-c-notification-drawer__list-item {\n  position: relative;\n  display: grid;\n  grid-template-columns: 1fr auto;\n  padding: var(--pf-c-notification-drawer__list-item--PaddingTop) var(--pf-c-notification-drawer__list-item--PaddingRight) var(--pf-c-notification-drawer__list-item--PaddingBottom) var(--pf-c-notification-drawer__list-item--PaddingLeft);\n  background-color: var(--pf-c-notification-drawer__list-item--BackgroundColor);\n  border-bottom: var(--pf-c-notification-drawer__list-item--BorderBottomWidth) solid var(--pf-c-notification-drawer__list-item--BorderBottomColor);\n  outline-offset: var(--pf-c-notification-drawer__list-item--OutlineOffset);\n  box-shadow: var(--pf-c-notification-drawer__list-item--BoxShadow);\n}\n.pf-c-notification-drawer__list-item.pf-m-read, .pf-c-notification-drawer__list-item:first-child {\n  --pf-c-notification-drawer__list-item--BoxShadow: none;\n}\n.pf-c-notification-drawer__list-item:not(.pf-m-read) + .pf-c-notification-drawer__list-item.pf-m-read {\n  --pf-c-notification-drawer__list-item--BoxShadow: var(--pf-c-notification-drawer__list-item--list-item--m-read--BoxShadow);\n  --pf-c-notification-drawer__list-item--before--Top: var(--pf-c-notification-drawer__list-item--list-item--m-read--before--Top);\n}\n.pf-c-notification-drawer__list-item::before {\n  position: absolute;\n  top: var(--pf-c-notification-drawer__list-item--before--Top);\n  bottom: var(--pf-c-notification-drawer__list-item--before--Bottom);\n  width: var(--pf-c-notification-drawer__list-item--before--Width);\n  content: "";\n  background-color: var(--pf-c-notification-drawer__list-item--before--BackgroundColor);\n}\n.pf-c-notification-drawer__list-item.pf-m-info {\n  --pf-c-notification-drawer__list-item--before--BackgroundColor: var(--pf-c-notification-drawer__list-item--m-info__list-item--before--BackgroundColor);\n  --pf-c-notification-drawer__list-item-header-icon--Color: var(--pf-c-notification-drawer__list-item--m-info__list-item-header-icon--Color);\n}\n.pf-c-notification-drawer__list-item.pf-m-warning {\n  --pf-c-notification-drawer__list-item--before--BackgroundColor: var(--pf-c-notification-drawer__list-item--m-warning__list-item--before--BackgroundColor);\n  --pf-c-notification-drawer__list-item-header-icon--Color: var(--pf-c-notification-drawer__list-item--m-warning__list-item-header-icon--Color);\n}\n.pf-c-notification-drawer__list-item.pf-m-danger {\n  --pf-c-notification-drawer__list-item--before--BackgroundColor: var(--pf-c-notification-drawer__list-item--m-danger__list-item--before--BackgroundColor);\n  --pf-c-notification-drawer__list-item-header-icon--Color: var(--pf-c-notification-drawer__list-item--m-danger__list-item-header-icon--Color);\n}\n.pf-c-notification-drawer__list-item.pf-m-success {\n  --pf-c-notification-drawer__list-item--before--BackgroundColor: var(--pf-c-notification-drawer__list-item--m-success__list-item--before--BackgroundColor);\n  --pf-c-notification-drawer__list-item-header-icon--Color: var(--pf-c-notification-drawer__list-item--m-success__list-item-header-icon--Color);\n}\n.pf-c-notification-drawer__list-item.pf-m-default {\n  --pf-c-notification-drawer__list-item--before--BackgroundColor: var(--pf-c-notification-drawer__list-item--m-default__list-item--before--BackgroundColor);\n  --pf-c-notification-drawer__list-item-header-icon--Color: var(--pf-c-notification-drawer__list-item--m-default__list-item-header-icon--Color);\n}\n.pf-c-notification-drawer__list-item.pf-m-read {\n  --pf-c-notification-drawer__list-item--BorderBottomColor: var(--pf-c-notification-drawer__list-item--m-read--BorderBottomColor);\n  --pf-c-notification-drawer__list-item--BackgroundColor: var(--pf-c-notification-drawer__list-item--m-read--BackgroundColor);\n  --pf-c-notification-drawer__list-item--before--Top: var(--pf-c-notification-drawer__list-item--m-read--before--Top);\n  --pf-c-notification-drawer__list-item--before--Bottom: var(--pf-c-notification-drawer__list-item--m-read--before--Bottom);\n  --pf-c-notification-drawer__list-item--before--BackgroundColor: var(--pf-c-notification-drawer__list-item--m-read--before--BackgroundColor);\n  --pf-c-notification-drawer__list-item-header-title--FontWeight: var(--pf-c-notification-drawer__list-item--m-read__list-item-header-title--FontWeight);\n  position: relative;\n}\n.pf-c-notification-drawer__list-item.pf-m-hoverable {\n  cursor: pointer;\n}\n.pf-c-notification-drawer__list-item.pf-m-hoverable:hover {\n  z-index: var(--pf-c-notification-drawer__list-item--m-hoverable--hover--ZIndex);\n  box-shadow: var(--pf-c-notification-drawer__list-item--m-hoverable--hover--BoxShadow);\n}\n\n.pf-c-notification-drawer__list-item-header {\n  display: flex;\n  align-items: baseline;\n  grid-column: 1/2;\n  grid-row: 1/2;\n  margin-bottom: var(--pf-c-notification-drawer__list-item-header--MarginBottom);\n}\n\n.pf-c-notification-drawer__list-item-header-icon {\n  margin-right: var(--pf-c-notification-drawer__list-item-header-icon--MarginRight);\n  color: var(--pf-c-notification-drawer__list-item-header-icon--Color);\n}\n\n.pf-c-notification-drawer__list-item-header-title {\n  font-weight: var(--pf-c-notification-drawer__list-item-header-title--FontWeight);\n  word-break: break-word;\n}\n.pf-c-notification-drawer__list-item-header-title.pf-m-truncate {\n  display: -webkit-box;\n  -webkit-box-orient: vertical;\n  -webkit-line-clamp: var(--pf-c-notification-drawer__list-item-header-title--max-lines);\n  overflow: hidden;\n}\n\n.pf-c-notification-drawer__list-item-action {\n  grid-column: 2/3;\n  grid-row: 1/3;\n}\n\n.pf-c-notification-drawer__list-item-description {\n  grid-row: 2/3;\n  grid-column: 1/2;\n  margin-bottom: var(--pf-c-notification-drawer__list-item-description--MarginBottom);\n  word-break: break-word;\n}\n\n.pf-c-notification-drawer__list-item-timestamp {\n  grid-row: 3/4;\n  grid-column: 1/2;\n  font-size: var(--pf-c-notification-drawer__list-item-timestamp--FontSize);\n  color: var(--pf-c-notification-drawer__list-item-timestamp--Color);\n}\n\n.pf-c-notification-drawer__group-list {\n  display: flex;\n  flex-direction: column;\n}\n\n.pf-c-notification-drawer__group.pf-m-expanded {\n  min-height: var(--pf-c-notification-drawer__group--m-expanded--MinHeight);\n}\n.pf-c-notification-drawer__group.pf-m-expanded + .pf-c-notification-drawer__group {\n  border-top: var(--pf-c-notification-drawer__group--m-expanded--group--BorderTopWidth) solid var(--pf-c-notification-drawer__group--m-expanded--group--BorderTopColor);\n}\n.pf-c-notification-drawer__group .pf-c-notification-drawer__list-item:last-child {\n  --pf-c-notification-drawer__list-item--BorderBottomWidth: 0;\n  --pf-c-notification-drawer__list-item--before--Bottom: 0;\n}\n\n.pf-c-notification-drawer__group-toggle {\n  display: flex;\n  align-items: baseline;\n  width: 100%;\n  padding: var(--pf-c-notification-drawer__group-toggle--PaddingTop) var(--pf-c-notification-drawer__group-toggle--PaddingRight) var(--pf-c-notification-drawer__group-toggle--PaddingBottom) var(--pf-c-notification-drawer__group-toggle--PaddingLeft);\n  background-color: var(--pf-c-notification-drawer__group-toggle--BackgroundColor);\n  border: solid var(--pf-c-notification-drawer__group-toggle--BorderColor);\n  border-width: 0 0 var(--pf-c-notification-drawer__group-toggle--BorderBottomWidth) 0;\n  outline-offset: var(--pf-c-notification-drawer__group-toggle--OutlineOffset);\n}\n\n.pf-c-notification-drawer__group-toggle-title {\n  display: -webkit-box;\n  -webkit-box-orient: vertical;\n  -webkit-line-clamp: var(--pf-c-notification-drawer__group-toggle-title--max-lines);\n  overflow: hidden;\n  flex: 1;\n  margin-right: var(--pf-c-notification-drawer__group-toggle-title--MarginRight);\n  text-align: left;\n  word-break: break-word;\n}\n\n.pf-c-notification-drawer__group-toggle-count {\n  margin-right: var(--pf-c-notification-drawer__group-toggle-count--MarginRight);\n  margin-left: auto;\n}\n\n.pf-c-notification-drawer__group-toggle-icon {\n  margin-right: var(--pf-c-notification-drawer__group-toggle-icon--MarginRight);\n  color: var(--pf-c-notification-drawer__group-toggle-icon--Color);\n  transition: var(--pf-c-notification-drawer__group-toggle-icon--Transition);\n}\n.pf-c-notification-drawer__group.pf-m-expanded .pf-c-notification-drawer__group-toggle-icon {\n  transform: rotate(var(--pf-c-notification-drawer__group--m-expanded__group-toggle-icon--Rotate));\n}\n\n:where(.pf-theme-dark) .pf-c-notification-drawer {\n  --pf-c-notification-drawer--BackgroundColor: var(--pf-global--BackgroundColor--300);\n  --pf-c-notification-drawer__header--BackgroundColor: var(--pf-global--BackgroundColor--300);\n  --pf-c-notification-drawer__list-item--BackgroundColor: var(--pf-global--BackgroundColor--300);\n  --pf-c-notification-drawer__list-item--BoxShadow: none;\n  --pf-c-notification-drawer__list-item--BorderBottomColor: var(--pf-global--BorderColor--100);\n  --pf-c-notification-drawer__list-item--m-read--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-notification-drawer__list-item--list-item--m-read--BoxShadow: none;\n  --pf-c-notification-drawer__group-toggle--BackgroundColor: var(--pf-global--BackgroundColor--300);\n}';

// src/elements/notifications/APIDrawer.ts
var APIDrawer = class extends AKElement {
  constructor() {
    super();
    this.requests = [];
    window.addEventListener(EVENT_REQUEST_POST, (e3) => {
      this.requests.splice(0, 0, e3.detail);
      if (this.requests.length > 50) {
        this.requests.shift();
      }
      this.requestUpdate();
    });
  }
  static get styles() {
    return [
      patternfly_base_default,
      notification_drawer_default,
      button_default,
      content_default,
      dropdown_default,
      i`
                :host {
                    --header-height: 114px;
                }
                .pf-c-notification-drawer__header {
                    height: var(--header-height);
                    align-items: center;
                }
                .pf-c-notification-drawer__header-action,
                .pf-c-notification-drawer__header-action-close,
                .pf-c-notification-drawer__header-action-close > .pf-c-button.pf-m-plain {
                    height: 100%;
                }
                .pf-c-notification-drawer__list-item-description {
                    white-space: pre-wrap;
                    font-family: monospace;
                }
                .pf-c-notification-drawer__body {
                    overflow-x: hidden;
                }
                .pf-c-notification-drawer__list {
                    max-height: calc(100vh - var(--header-height));
                }
            `
    ];
  }
  renderItem(item) {
    return x`<li class="pf-c-notification-drawer__list-item pf-m-read">
            <div class="pf-c-notification-drawer__list-item-header">
                <h2 class="pf-c-notification-drawer__list-item-header-title">
                    ${item.method}: ${item.status}
                </h2>
            </div>
            <a
                class="pf-c-notification-drawer__list-item-description"
                target="_blank"
                href=${item.path}
                >${item.path}</a
            >
        </li>`;
  }
  render() {
    return x`<div class="pf-c-drawer__body pf-m-no-padding">
            <div class="pf-c-notification-drawer">
                <div class="pf-c-notification-drawer__header">
                    <div class="text">
                        <h1 class="pf-c-notification-drawer__header-title">
                            ${msg("API Requests")}
                        </h1>
                        <a href="/api/v3/" target="_blank">${msg("Open API Browser")}</a>
                    </div>
                    <div class="pf-c-notification-drawer__header-action">
                        <div class="pf-c-notification-drawer__header-action-close">
                            <button
                                @click=${() => {
      this.dispatchEvent(
        new CustomEvent(EVENT_API_DRAWER_TOGGLE, {
          bubbles: true,
          composed: true
        })
      );
    }}
                                class="pf-c-button pf-m-plain"
                                type="button"
                                aria-label="Close"
                            >
                                <i class="fas fa-times" aria-hidden="true"></i>
                            </button>
                        </div>
                    </div>
                </div>
                <div class="pf-c-notification-drawer__body">
                    <ul class="pf-c-notification-drawer__list">
                        ${this.requests.map((n2) => this.renderItem(n2))}
                    </ul>
                </div>
            </div>
        </div>`;
  }
};
__decorateClass([
  n({ attribute: false })
], APIDrawer.prototype, "requests", 2);
APIDrawer = __decorateClass([
  t("ak-api-drawer")
], APIDrawer);

// src/elements/notifications/NotificationDrawer.ts
var NotificationDrawer = class extends AKElement {
  constructor() {
    super(...arguments);
    this.unread = 0;
  }
  static get styles() {
    return [patternfly_base_default, button_default, notification_drawer_default, content_default, dropdown_default].concat(i`
            .pf-c-drawer__body {
                height: 100%;
            }
            .pf-c-notification-drawer__body {
                flex-grow: 1;
                overflow-x: hidden;
            }
            .pf-c-notification-drawer__header {
                height: 114px;
                align-items: center;
            }
            .pf-c-notification-drawer__header-action,
            .pf-c-notification-drawer__header-action-close,
            .pf-c-notification-drawer__header-action-close > .pf-c-button.pf-m-plain {
                height: 100%;
            }
            .pf-c-notification-drawer__list-item-description {
                white-space: pre-wrap;
            }
            .pf-c-notification-drawer__footer {
                margin: 1rem;
            }
        `);
  }
  firstUpdated() {
    me().then((user) => {
      new EventsApi(DEFAULT_CONFIG).eventsNotificationsList({
        seen: false,
        ordering: "-created",
        user: user.user.pk
      }).then((r2) => {
        this.notifications = r2;
        this.unread = r2.results.length;
      });
    });
  }
  renderItem(item) {
    let level = "";
    switch (item.severity) {
      case "notice":
        level = "pf-m-info";
        break;
      case "warning":
        level = "pf-m-warning";
        break;
      case "alert":
        level = "pf-m-danger";
        break;
      default:
        break;
    }
    return x`<li class="pf-c-notification-drawer__list-item">
            <div class="pf-c-notification-drawer__list-item-header">
                <span class="pf-c-notification-drawer__list-item-header-icon ${level}">
                    <i class="fas fa-info-circle" aria-hidden="true"></i>
                </span>
                <h2 class="pf-c-notification-drawer__list-item-header-title">
                    ${actionToLabel(item.event?.action)}
                </h2>
            </div>
            <div class="pf-c-notification-drawer__list-item-action">
                ${item.event && x`
                    <a
                        class="pf-c-dropdown__toggle pf-m-plain"
                        href="/if/admin/#/events/log/${item.event?.pk}"
                    >
                        <pf-tooltip position="top" content=${msg("Show details")}>
                            <i class="fas fa-share-square"></i>
                        </pf-tooltip>
                    </a>
                `}
                <button
                    class="pf-c-dropdown__toggle pf-m-plain"
                    type="button"
                    @click=${() => {
      new EventsApi(DEFAULT_CONFIG).eventsNotificationsPartialUpdate({
        uuid: item.pk || "",
        patchedNotificationRequest: {
          seen: true
        }
      }).then(() => {
        this.firstUpdated();
        this.dispatchEvent(
          new CustomEvent(EVENT_REFRESH, {
            bubbles: true,
            composed: true
          })
        );
      });
    }}
                >
                    <i class="fas fa-times"></i>
                </button>
            </div>
            <p class="pf-c-notification-drawer__list-item-description">${item.body}</p>
            <small class="pf-c-notification-drawer__list-item-timestamp"
                ><pf-tooltip position="top" .content=${item.created?.toLocaleString()}>
                    ${getRelativeTime(item.created)}
                </pf-tooltip></small
            >
        </li>`;
  }
  render() {
    if (!this.notifications) {
      return x``;
    }
    return x`<div class="pf-c-drawer__body pf-m-no-padding">
            <div class="pf-c-notification-drawer">
                <div class="pf-c-notification-drawer__header">
                    <div class="text">
                        <h1 class="pf-c-notification-drawer__header-title">
                            ${msg("Notifications")}
                        </h1>
                        <span> ${msg(str`${this.unread} unread`)} </span>
                    </div>
                    <div class="pf-c-notification-drawer__header-action">
                        <div class="pf-c-notification-drawer__header-action-close">
                            <button
                                @click=${() => {
      this.dispatchEvent(
        new CustomEvent(EVENT_NOTIFICATION_DRAWER_TOGGLE, {
          bubbles: true,
          composed: true
        })
      );
    }}
                                class="pf-c-button pf-m-plain"
                                type="button"
                                aria-label=${msg("Close")}
                            >
                                <i class="fas fa-times" aria-hidden="true"></i>
                            </button>
                        </div>
                    </div>
                </div>
                <div class="pf-c-notification-drawer__body">
                    <ul class="pf-c-notification-drawer__list">
                        ${this.notifications.results.map((n2) => this.renderItem(n2))}
                    </ul>
                </div>
                <div class="pf-c-notification-drawer__footer">
                    <button
                        @click=${() => {
      new EventsApi(DEFAULT_CONFIG).eventsNotificationsMarkAllSeenCreate().then(() => {
        showMessage({
          level: "success" /* success */,
          message: msg("Successfully cleared notifications")
        });
        this.firstUpdated();
        this.dispatchEvent(
          new CustomEvent(EVENT_REFRESH, {
            bubbles: true,
            composed: true
          })
        );
        this.dispatchEvent(
          new CustomEvent(EVENT_NOTIFICATION_DRAWER_TOGGLE, {
            bubbles: true,
            composed: true
          })
        );
      });
    }}
                        class="pf-c-button pf-m-primary pf-m-block"
                        type="button"
                        aria-label=${msg("Clear all")}
                    >
                        ${msg("Clear all")}
                    </button>
                </div>
            </div>
        </div>`;
  }
};
__decorateClass([
  n({ attribute: false })
], NotificationDrawer.prototype, "notifications", 2);
__decorateClass([
  n({ type: Number })
], NotificationDrawer.prototype, "unread", 2);
NotificationDrawer = __decorateClass([
  t("ak-notification-drawer")
], NotificationDrawer);

// node_modules/@patternfly/patternfly/components/Nav/nav.css
var nav_default = '.pf-c-nav {\n  --pf-c-nav--Transition: var(--pf-global--Transition);\n  --pf-c-nav--m-light__item--before--BorderColor: var(--pf-global--BorderColor--300);\n  --pf-c-nav--m-light__item--m-current--not--m-expanded__link--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-nav--m-light__link--Color: var(--pf-global--Color--dark-100);\n  --pf-c-nav--m-light__link--hover--Color: var(--pf-global--Color--dark-100);\n  --pf-c-nav--m-light__link--focus--Color: var(--pf-global--Color--dark-100);\n  --pf-c-nav--m-light__link--active--Color: var(--pf-global--Color--dark-100);\n  --pf-c-nav--m-light__link--m-current--Color: var(--pf-global--Color--dark-100);\n  --pf-c-nav--m-light__link--hover--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-nav--m-light__link--focus--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-nav--m-light__link--active--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-nav--m-light__link--m-current--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-nav--m-light__link--before--BorderColor: var(--pf-global--BorderColor--300);\n  --pf-c-nav--m-light__link--after--BorderColor: var(--pf-global--active-color--100);\n  --pf-c-nav--m-light__link--m-current--after--BorderColor: var(--pf-global--active-color--100);\n  --pf-c-nav--m-light__section-title--Color: var(--pf-global--Color--dark-200);\n  --pf-c-nav--m-light__section-title--BorderBottomColor: var(--pf-global--BorderColor--300);\n  --pf-c-nav--m-light--c-divider--BackgroundColor: var(--pf-global--BorderColor--300);\n  --pf-c-nav--m-light__subnav__link--hover--after--BorderColor: var(--pf-global--BorderColor--dark-100);\n  --pf-c-nav--m-light__subnav__link--focus--after--BorderColor: var(--pf-global--BorderColor--dark-100);\n  --pf-c-nav--m-light__subnav__link--active--after--BorderColor: var(--pf-global--BorderColor--dark-100);\n  --pf-c-nav--m-light__subnav__link--m-current--after--BorderColor: var(--pf-global--active-color--100);\n  --pf-c-nav__item--MarginTop: 0;\n  --pf-c-nav__item--m-current--not--m-expanded__link--BackgroundColor: var(--pf-global--BackgroundColor--dark-400);\n  --pf-c-nav__link--m-current--not--m-expanded__link--after--BorderWidth: var(--pf-global--BorderWidth--xl);\n  --pf-c-nav__item__item__link--PaddingRight: var(--pf-global--spacer--xl);\n  --pf-c-nav__item__item__toggle--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-nav__item__toggle-icon--Rotate: 0;\n  --pf-c-nav__item--m-expanded__toggle-icon--Rotate: 90deg;\n  --pf-c-nav__item--before--BorderColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__item--before--BorderWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__link--FontSize: var(--pf-global--FontSize--md);\n  --pf-c-nav__link--FontWeight: var(--pf-global--FontWeight--normal);\n  --pf-c-nav__link--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-nav__link--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-nav__link--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-nav__link--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav__link--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav__link--xl--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav__link--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav__link--hover--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav__link--focus--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav__link--active--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav__link--m-current--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav__link--BackgroundColor: transparent;\n  --pf-c-nav__link--hover--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__link--focus--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__link--active--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__link--m-current--BackgroundColor: var(--pf-global--BackgroundColor--dark-400);\n  --pf-c-nav__link--OutlineOffset: calc(var(--pf-global--spacer--xs) * -1);\n  --pf-c-nav__link--before--BorderColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__link--before--BorderBottomWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__link--hover--before--BorderBottomWidth: 0;\n  --pf-c-nav__link--focus--before--BorderBottomWidth: 0;\n  --pf-c-nav__link--active--before--BorderBottomWidth: 0;\n  --pf-c-nav__link--m-current--before--BorderBottomWidth: 0;\n  --pf-c-nav__link--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav__link--hover--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav__link--focus--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav__link--active--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav__link--m-current--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav__link--after--BorderLeftWidth: 0;\n  --pf-c-nav__link--hover--after--BorderLeftWidth: 0;\n  --pf-c-nav__link--focus--after--BorderLeftWidth: 0;\n  --pf-c-nav__link--active--after--BorderLeftWidth: 0;\n  --pf-c-nav__link--m-current--after--BorderLeftWidth: var(--pf-global--BorderWidth--xl);\n  --pf-c-nav--m-horizontal__link--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav--m-horizontal__link--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal__link--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav--m-horizontal__link--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal__link--lg--PaddingTop: var(--pf-global--spacer--lg);\n  --pf-c-nav--m-horizontal__link--lg--PaddingBottom: var(--pf-global--spacer--lg);\n  --pf-c-nav--m-horizontal__link--Right: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal__link--Left: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal__link--Color: var(--pf-global--Color--light-300);\n  --pf-c-nav--m-horizontal__link--hover--Color: var(--pf-global--active-color--400);\n  --pf-c-nav--m-horizontal__link--focus--Color: var(--pf-global--active-color--400);\n  --pf-c-nav--m-horizontal__link--active--Color: var(--pf-global--active-color--400);\n  --pf-c-nav--m-horizontal__link--m-current--Color: var(--pf-global--active-color--400);\n  --pf-c-nav--m-horizontal__link--BackgroundColor: transparent;\n  --pf-c-nav--m-horizontal__link--hover--BackgroundColor: transparent;\n  --pf-c-nav--m-horizontal__link--focus--BackgroundColor: transparent;\n  --pf-c-nav--m-horizontal__link--active--BackgroundColor: transparent;\n  --pf-c-nav--m-horizontal__link--m-current--BackgroundColor: transparent;\n  --pf-c-nav--m-horizontal__link--before--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav--m-horizontal__link--before--BorderWidth: 0;\n  --pf-c-nav--m-horizontal__link--hover--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-horizontal__link--focus--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-horizontal__link--active--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-horizontal__link--m-current--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-tertiary__link--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav--m-tertiary__link--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-nav--m-tertiary__link--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav--m-tertiary__link--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav--m-tertiary__link--Right: var(--pf-global--spacer--md);\n  --pf-c-nav--m-tertiary__link--Left: var(--pf-global--spacer--md);\n  --pf-c-nav--m-tertiary__link--Color: var(--pf-global--Color--dark-100);\n  --pf-c-nav--m-tertiary__link--hover--Color: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__link--focus--Color: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__link--active--Color: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__link--m-current--Color: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__link--BackgroundColor: transparent;\n  --pf-c-nav--m-tertiary__link--hover--BackgroundColor: transparent;\n  --pf-c-nav--m-tertiary__link--focus--BackgroundColor: transparent;\n  --pf-c-nav--m-tertiary__link--active--BackgroundColor: transparent;\n  --pf-c-nav--m-tertiary__link--m-current--BackgroundColor: transparent;\n  --pf-c-nav--m-tertiary__link--before--BorderColor: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__link--before--BorderWidth: 0;\n  --pf-c-nav--m-tertiary__link--hover--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-tertiary__link--focus--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-tertiary__link--active--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-tertiary__link--m-current--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-tertiary__scroll-button--Color: var(--pf-global--Color--dark-100);\n  --pf-c-nav--m-tertiary__scroll-button--hover--Color: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__scroll-button--focus--Color: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__scroll-button--active--Color: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__scroll-button--disabled--Color: var(--pf-global--disabled-color--200);\n  --pf-c-nav--m-tertiary__scroll-button--before--BorderColor: var(--pf-global--BorderColor--300);\n  --pf-c-nav--m-tertiary__scroll-button--disabled--before--BorderColor: var(--pf-global--disabled-color--300);\n  --pf-c-nav--m-horizontal-subnav__link--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav--m-horizontal-subnav__link--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal-subnav__link--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav--m-horizontal-subnav__link--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal-subnav__link--xl--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal-subnav__link--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav--m-horizontal-subnav__link--xl--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal-subnav__link--xl--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav--m-horizontal-subnav__link--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-nav--m-horizontal-subnav__link--Color: var(--pf-global--Color--light-200);\n  --pf-c-nav--m-horizontal-subnav__link--hover--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--m-horizontal-subnav__link--focus--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--m-horizontal-subnav__link--active--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--m-horizontal-subnav__link--m-current--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--m-horizontal-subnav__link--BackgroundColor: transparent;\n  --pf-c-nav--m-horizontal-subnav__link--hover--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav--m-horizontal-subnav__link--focus--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav--m-horizontal-subnav__link--active--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav--m-horizontal-subnav__link--m-current--BackgroundColor: var(--pf-global--BackgroundColor--dark-400);\n  --pf-c-nav--m-horizontal-subnav__link--before--BorderColor: transparent;\n  --pf-c-nav--m-horizontal-subnav__link--after--BorderColor: var(--pf-global--palette--black-800);\n  --pf-c-nav--m-horizontal-subnav__link--hover--after--BorderColor: var(--pf-global--palette--black-800);\n  --pf-c-nav--m-horizontal-subnav__link--active--after--BorderColor: var(--pf-global--palette--black-800);\n  --pf-c-nav--m-horizontal-subnav__link--m-current--after--BorderColor: var(--pf-global--palette--black-800);\n  --pf-c-nav--m-horizontal-subnav__link--after--BorderLeftWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav--m-horizontal-subnav__link--hover--after--BorderLeftWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav--m-horizontal-subnav__link--active--after--BorderLeftWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav--m-horizontal-subnav__link--m-current--after--BorderLeftWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__subnav--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-nav__subnav--xl--PaddingLeft: var(--pf-c-nav__link--PaddingLeft);\n  --pf-c-nav__subnav__link--MarginTop: 0;\n  --pf-c-nav__subnav__link--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav__subnav__link--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav__subnav__link--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav__subnav__link--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav__subnav__link--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-nav__subnav__link--hover--after--BorderColor: var(--pf-global--BorderColor--200);\n  --pf-c-nav__subnav__link--focus--after--BorderColor: var(--pf-global--BorderColor--200);\n  --pf-c-nav__subnav__link--active--after--BorderColor: var(--pf-global--BorderColor--200);\n  --pf-c-nav__subnav__link--m-current--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav__subnav__link--hover--after--BorderWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__subnav__link--focus--after--BorderWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__subnav__link--active--after--BorderWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__subnav__link--m-current--after--BorderWidth: var(--pf-global--BorderWidth--xl);\n  --pf-c-nav__subnav--MaxHeight: 0;\n  --pf-c-nav__subnav__subnav--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav__subnav__subnav__link--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav__subnav__subnav__link--FontSize: var(--pf-global--FontSize--xs);\n  --pf-c-nav__item--m-expanded__subnav--MaxHeight: 100%;\n  --pf-c-nav__subnav--c-divider--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav__subnav--c-divider--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav__section--MarginTop: var(--pf-global--spacer--sm);\n  --pf-c-nav__section__item--MarginTop: var(--pf-global--spacer--sm);\n  --pf-c-nav__section__link--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav__section__link--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-nav__section__link--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav__section__link--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav__section__link--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav__section__link--xl--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav__section__link--FontSize: var(--pf-global--FontSize--md);\n  --pf-c-nav__section__link--before--BorderBottomWidth: 0;\n  --pf-c-nav__section__link--hover--after--BorderColor: transparent;\n  --pf-c-nav__section__link--focus--after--BorderColor: transparent;\n  --pf-c-nav__section__link--active--after--BorderColor: transparent;\n  --pf-c-nav__section__link--m-current--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav__section__link--hover--after--BorderWidth: 0;\n  --pf-c-nav__section__link--focus--after--BorderWidth: 0;\n  --pf-c-nav__section__link--active--after--BorderWidth: 0;\n  --pf-c-nav__section__link--m-current--after--BorderWidth: var(--pf-global--BorderWidth--xl);\n  --pf-c-nav__section--section--MarginTop: var(--pf-global--spacer--xl);\n  --pf-c-nav__section-title--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav__section-title--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-nav__section-title--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav__section-title--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav__section-title--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav__section-title--xl--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav__section-title--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-nav__section-title--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav__section-title--BorderBottomColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__section-title--BorderBottomWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__scroll-button--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav__scroll-button--hover--Color: var(--pf-global--active-color--400);\n  --pf-c-nav__scroll-button--focus--Color: var(--pf-global--active-color--400);\n  --pf-c-nav__scroll-button--active--Color: var(--pf-global--active-color--400);\n  --pf-c-nav__scroll-button--disabled--Color: var(--pf-global--disabled-color--100);\n  --pf-c-nav__scroll-button--BackgroundColor: transparent;\n  --pf-c-nav__scroll-button--Width: var(--pf-global--target-size--MinWidth);\n  --pf-c-nav__scroll-button--OutlineOffset: calc(-1 * var(--pf-global--spacer--xs));\n  --pf-c-nav__scroll-button--Transition: margin .125s, transform .125s, opacity .125s;\n  --pf-c-nav__scroll-button--before--BorderColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__scroll-button--before--BorderWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__scroll-button--before--BorderRightWidth: 0;\n  --pf-c-nav__scroll-button--before--BorderLeftWidth: 0;\n  --pf-c-nav__scroll-button--disabled--before--BorderColor: transparent;\n  --pf-c-nav__toggle--PaddingRight: var(--pf-global--spacer--sm);\n  --pf-c-nav__toggle--PaddingLeft: var(--pf-global--spacer--sm);\n  --pf-c-nav__toggle--FontSize: var(--pf-global--icon--FontSize--md);\n  --pf-c-nav__toggle-icon--Transition: var(--pf-global--TransitionDuration);\n  --pf-c-nav--c-divider--MarginTop: var(--pf-global--spacer--sm);\n  --pf-c-nav--c-divider--MarginBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav--c-divider--PaddingRight: 0;\n  --pf-c-nav--c-divider--PaddingLeft: 0;\n  --pf-c-nav--c-divider--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__list--ScrollSnapTypeAxis: x;\n  --pf-c-nav__list--ScrollSnapTypeStrictness: proximity;\n  --pf-c-nav__list--ScrollSnapType: var(--pf-c-nav__list--ScrollSnapTypeAxis) var(--pf-c-nav__list--ScrollSnapTypeStrictness);\n  --pf-c-nav__item--ScrollSnapAlign: end;\n  --pf-c-nav__item--m-flyout--c-menu--top-offset: 0px;\n  --pf-c-nav__item--m-flyout--c-menu--left-offset: 0.25rem;\n  --pf-c-nav__item--m-flyout--c-menu--m-top--bottom-offset: 0px;\n  --pf-c-nav__item--m-flyout--c-menu--m-left--right-offset: 0.25rem;\n  --pf-c-nav__item--m-flyout--MarginTop: 0;\n  --pf-c-nav__item--m-flyout--hover__link--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__item--m-flyout--focus__link--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__item--m-flyout--active__link--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__item--m-flyout--hover__link--before--BorderWidth: 0;\n  --pf-c-nav__item--m-flyout--focus__link--before--BorderWidth: 0;\n  --pf-c-nav__item--m-flyout--active__link--before--BorderWidth: 0;\n  --pf-c-nav__item--m-flyout__item--last-child__link--before--BorderBottomWidth: 0;\n  --pf-c-nav__item--m-flyout--c-menu--Top: calc(0px + var(--pf-c-nav__item--m-flyout--c-menu--top-offset));\n  --pf-c-nav__item--m-flyout--c-menu--c-menu--Top: calc(var(--pf-c-nav__item--m-flyout--c-menu--Top) - var(--pf-c-nav__item--before--BorderWidth));\n  --pf-c-nav__item--m-flyout--c-menu__list-item--first-child--c-menu--Top: 0;\n  --pf-c-nav__item--m-flyout--c-menu--Left: calc(100% - var(--pf-c-nav__item--m-flyout--c-menu--left-offset));\n  --pf-c-nav__item--m-flyout--c-menu--m-left--Right: calc(100% - var(--pf-c-nav__item--m-flyout--c-menu--m-left--right-offset));\n  --pf-c-nav__item--m-flyout--c-menu--m-top--Bottom: calc(0 + var(--pf-c-nav__item--m-flyout--c-menu--m-top--bottom-offset));\n  --pf-c-nav__item--m-flyout--c-menu--BackgroundColor: var(--pf-global--BackgroundColor--dark-300);\n  --pf-c-nav__item--m-flyout--c-menu__item--Color: var(--pf-c-nav__link--Color);\n  --pf-c-nav__item--m-flyout--c-menu__item--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav__item--m-flyout--c-menu__item--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav__item--m-flyout--c-menu__item--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav__item--m-flyout--c-menu__item--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav__item--m-flyout--c-menu__item-description--Color: var(--pf-global--Color--light-200);\n  --pf-c-nav__item--m-flyout--c-menu__item--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-nav__item--m-flyout--c-menu__item--OutlineOffset: var(--pf-c-nav__link--OutlineOffset);\n  --pf-c-nav__item--m-flyout--c-menu__item--before--BorderBottomWidth: var(--pf-c-nav__item--before--BorderWidth);\n  --pf-c-nav__item--m-flyout--c-menu__item--before--BorderBottomColor: var(--pf-c-nav__item--before--BorderColor);\n  --pf-c-nav__item--m-flyout--c-menu__item--hover--after--BorderLeftWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__item--m-flyout--c-menu__item--hover--after--BorderLeftColor: var(--pf-global--BorderColor--200);\n  --pf-c-nav__item--m-flyout--c-menu__item--hover--after--Top: calc(-1 * var(--pf-c-nav__item--m-flyout--c-menu__item--before--BorderBottomWidth));\n  --pf-c-nav__item--m-flyout--c-menu__list-item--hover--BackgroundColor: var(--pf-c-nav__link--hover--BackgroundColor);\n  --pf-c-nav__item--m-flyout--c-menu__list-item--focus-within--BackgroundColor: var(--pf-c-nav__link--focus--BackgroundColor);\n  --pf-c-nav__item--m-flyout--c-menu__list-item--active--BackgroundColor: var(--pf-c-nav__link--active--BackgroundColor);\n  --pf-c-nav__item--m-flyout--c-menu__list-item--first-child__item--hover--after--Top: 0;\n  --pf-c-nav__item--m-flyout--c-menu--BoxShadow: var(--pf-global--BoxShadow--lg);\n  --pf-c-nav--c-menu--BackgroundColor: var(--pf-global--BackgroundColor--dark-300);\n  --pf-c-nav--c-menu__list--PaddingTop: 0;\n  --pf-c-nav--c-menu__list--PaddingBottom: 0;\n  --pf-c-nav--c-menu__list-item--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--c-menu__list-item--hover--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--c-menu__list-item--active--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--c-menu__list-item--focus-within--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--c-menu__list-item--hover--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav--c-menu__list-item--focus-within--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav--c-menu__list-item--m-drill-up--before--BorderBottomWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--c-menu__list-item--m-drill-up__item--FontWeight: var(--pf-global--FontWeight--bold);\n  --pf-c-nav--c-menu__item--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-nav--c-menu__item--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-nav--c-menu__item--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-nav--c-menu__item--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav--c-menu__item--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav--c-menu__item--xl--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav--c-menu__item--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-nav--c-menu__item--OutlineOffset: calc(var(--pf-global--spacer--xs) * -1);\n  --pf-c-nav--c-menu__item--before--BorderBottomWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav--c-menu__item--before--BorderBottomColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav--c-menu__item--after--BorderLeftWidth: 0;\n  --pf-c-nav--c-menu__item--after--BorderLeftColor: transparent;\n  --pf-c-nav--c-menu__item--m-current--BackgroundColor: var(--pf-global--BackgroundColor--dark-400);\n  --pf-c-nav--c-menu__item--m-current--after--BorderLeftWidth: var(--pf-global--BorderWidth--xl);\n  --pf-c-nav--c-menu__item--m-current--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav--c-menu__item-description--Color: var(--pf-global--Color--400);\n  --pf-c-nav--c-menu--m-flyout--left-offset: 0.25rem;\n  --pf-c-nav--c-menu--m-flyout--m-left--right-offset: 0.25rem;\n  --pf-c-nav--c-menu--m-flyout--Top: 0;\n  --pf-c-nav--c-menu--m-flyout--c-menu--Top: calc(var(--pf-c-nav--c-menu--m-flyout--Top) * -1);\n  --pf-c-nav--c-menu--m-flyout--c-menu--Right: auto;\n  --pf-c-nav--c-menu--m-flyout--c-menu--Bottom: auto;\n  --pf-c-nav--c-menu--m-flyout--c-menu--Left: calc(100% - var(--pf-c-nav--c-menu--m-flyout--left-offset));\n  --pf-c-nav--c-menu--m-flyout--m-left--Right: calc(100% - var(--pf-c-nav--c-menu--m-flyout--m-left--right-offset));\n  --pf-c-nav--c-menu--m-flyout--m-top--Bottom: 0;\n  --pf-c-nav--c-menu--m-flyout--BoxShadow: var(--pf-global--BoxShadow--lg);\n  --pf-c-nav--c-menu--m-flyout__item--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav--c-menu--m-flyout__item--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav--c-menu--m-flyout__item--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav--c-menu--m-flyout__item--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav--c-menu--m-flyout__item--hover--after--BorderLeftWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav--c-menu--m-flyout__item--hover--after--BorderLeftColor: var(--pf-global--BorderColor--200);\n  --pf-c-nav__toggle--m-start--MarginRight: var(--pf-global--spacer--sm);\n  position: relative;\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-nav {\n    --pf-c-nav__link--PaddingRight: var(--pf-c-nav__link--xl--PaddingRight);\n    --pf-c-nav__link--PaddingLeft: var(--pf-c-nav__link--xl--PaddingLeft);\n    --pf-c-nav--m-horizontal-subnav__link--PaddingTop: var(--pf-c-nav--m-horizontal-subnav__link--xl--PaddingTop);\n    --pf-c-nav--m-horizontal-subnav__link--PaddingRight: var(--pf-c-nav--m-horizontal-subnav__link--xl--PaddingRight);\n    --pf-c-nav--m-horizontal-subnav__link--PaddingBottom: var(--pf-c-nav--m-horizontal-subnav__link--xl--PaddingBottom);\n    --pf-c-nav--m-horizontal-subnav__link--PaddingLeft: var(--pf-c-nav--m-horizontal-subnav__link--xl--PaddingLeft);\n    --pf-c-nav__section__link--PaddingRight: var(--pf-c-nav__section__link--xl--PaddingRight);\n    --pf-c-nav__section__link--PaddingLeft: var(--pf-c-nav__section__link--xl--PaddingLeft);\n    --pf-c-nav__section-title--PaddingRight: var(--pf-c-nav__section-title--xl--PaddingRight);\n    --pf-c-nav__section-title--PaddingLeft: var(--pf-c-nav__section-title--xl--PaddingLeft);\n    --pf-c-nav__subnav--PaddingLeft: var(--pf-c-nav__subnav--xl--PaddingLeft);\n    --pf-c-nav--c-menu__item--PaddingRight: var(--pf-c-nav--c-menu__item--xl--PaddingRight);\n    --pf-c-nav--c-menu__item--PaddingLeft: var(--pf-c-nav--c-menu__item--xl--PaddingLeft);\n  }\n}\n.pf-c-nav .pf-c-menu {\n  --pf-c-menu--MinWidth: 100%;\n  --pf-c-menu--BackgroundColor: var(--pf-c-nav--c-menu--BackgroundColor);\n  --pf-c-menu__list--PaddingTop: var(--pf-c-nav--c-menu__list--PaddingTop);\n  --pf-c-menu__list--PaddingBottom: var(--pf-c-nav--c-menu__list--PaddingBottom);\n  --pf-c-menu__item--PaddingTop: var(--pf-c-nav--c-menu__item--PaddingTop);\n  --pf-c-menu__item--PaddingRight: var(--pf-c-nav--c-menu__item--PaddingRight);\n  --pf-c-menu__item--PaddingBottom: var(--pf-c-nav--c-menu__item--PaddingBottom);\n  --pf-c-menu__item--PaddingLeft: var(--pf-c-nav--c-menu__item--PaddingLeft);\n  --pf-c-menu__list-item--Color: var(--pf-c-nav--c-menu__list-item--Color);\n  --pf-c-menu__list-item--hover--Color: var(--pf-c-nav--c-menu__list-item--hover--Color);\n  --pf-c-menu__list-item--active--Color: var(--pf-c-nav--c-menu__list-item--active--Color);\n  --pf-c-menu__list-item--focus-within--Color: var(--pf-c-nav--c-menu__list-item--focus-within--Color);\n  --pf-c-menu__list-item--hover--BackgroundColor: var(--pf-c-nav--c-menu__list-item--hover--BackgroundColor);\n  --pf-c-menu__list-item--focus-within--BackgroundColor: var(--pf-c-nav--c-menu__list-item--focus-within--BackgroundColor);\n  --pf-c-menu__item-description--Color: var(--pf-c-nav--c-menu__item-description--Color);\n}\n.pf-c-nav .pf-c-menu:first-child > .pf-c-menu__content {\n  border-bottom: var(--pf-c-nav--c-menu__item--before--BorderBottomWidth) solid var(--pf-c-nav--c-menu__item--before--BorderBottomColor);\n}\n.pf-c-nav .pf-c-menu.pf-m-flyout, .pf-c-nav .pf-c-menu.pf-m-flyout .pf-c-menu {\n  --pf-c-menu--BoxShadow: var(--pf-c-nav--c-menu--m-flyout--BoxShadow);\n  --pf-c-menu__list--PaddingTop: 0;\n  --pf-c-menu__list--PaddingBottom: 0;\n  --pf-c-menu__item--FontSize: var(--pf-c-nav--c-menu__item--FontSize);\n  --pf-c-menu__item--Color: var(--pf-c-nav--c-menu__item--Color, inherit);\n  --pf-c-menu__item--PaddingTop: var(--pf-c-nav--c-menu--m-flyout__item--PaddingTop);\n  --pf-c-menu__item--PaddingRight: var(--pf-c-nav--c-menu--m-flyout__item--PaddingRight);\n  --pf-c-menu__item--PaddingBottom: var(--pf-c-nav--c-menu--m-flyout__item--PaddingBottom);\n  --pf-c-menu__item--PaddingLeft: var(--pf-c-nav--c-menu--m-flyout__item--PaddingLeft);\n  top: var(--pf-c-nav--c-menu--m-flyout--c-menu--Top);\n  right: var(--pf-c-nav--c-menu--m-flyout--c-menu--Right);\n  bottom: var(--pf-c-nav--c-menu--m-flyout--c-menu--Bottom);\n  left: var(--pf-c-nav--c-menu--m-flyout--c-menu--Left);\n}\n.pf-c-nav .pf-c-menu.pf-m-flyout .pf-c-menu__item:hover {\n  --pf-c-nav--c-menu__item--after--BorderLeftWidth: var(--pf-c-nav--c-menu--m-flyout__item--hover--after--BorderLeftWidth);\n  --pf-c-nav--c-menu__item--after--BorderLeftColor: var(--pf-c-nav--c-menu--m-flyout__item--hover--after--BorderLeftColor);\n}\n.pf-c-nav .pf-c-menu.pf-m-top {\n  --pf-c-nav--c-menu--m-flyout--c-menu--Top: auto;\n  --pf-c-nav--c-menu--m-flyout--c-menu--Bottom: var(--pf-c-nav--c-menu--m-flyout--m-top--Bottom);\n}\n.pf-c-nav .pf-c-menu.pf-m-left {\n  --pf-c-nav--c-menu--m-flyout--c-menu--Right: var(--pf-c-nav--c-menu--m-flyout--m-left--Right);\n  --pf-c-nav--c-menu--m-flyout--c-menu--Left: auto;\n}\n.pf-c-nav .pf-c-menu .pf-c-divider {\n  margin-top: 0;\n  margin-bottom: 0;\n}\n.pf-c-nav .pf-c-menu__item {\n  position: relative;\n  outline-offset: var(--pf-c-nav--c-menu__item--OutlineOffset);\n}\n.pf-c-nav .pf-c-menu__item::before, .pf-c-nav .pf-c-menu__item::after {\n  position: absolute;\n  top: 0;\n  content: "";\n}\n.pf-c-nav .pf-c-menu__item::before {\n  right: 0;\n  bottom: calc(var(--pf-c-nav--c-menu__item--before--BorderBottomWidth) * -1);\n  left: 0;\n  border-bottom: var(--pf-c-nav--c-menu__item--before--BorderBottomWidth) solid var(--pf-c-nav--c-menu__item--before--BorderBottomColor);\n}\n.pf-c-nav .pf-c-menu__item::after {\n  bottom: 0;\n  left: 0;\n  border-left: var(--pf-c-nav--c-menu__item--after--BorderLeftWidth) solid var(--pf-c-nav--c-menu__item--after--BorderLeftColor);\n}\n.pf-c-nav .pf-c-menu__item.pf-m-current {\n  --pf-c-nav--c-menu__item--after--BorderLeftWidth: var(--pf-c-nav--c-menu__item--m-current--after--BorderLeftWidth);\n  --pf-c-nav--c-menu__item--after--BorderLeftColor: var(--pf-c-nav--c-menu__item--m-current--after--BorderColor);\n  background-color: var(--pf-c-nav--c-menu__item--m-current--BackgroundColor);\n}\n.pf-c-nav .pf-c-menu__list-item:where(.pf-m-drill-up) {\n  --pf-c-nav--c-menu__item--before--BorderBottomWidth: var(--pf-c-nav--c-menu__list-item--m-drill-up--before--BorderBottomWidth);\n}\n.pf-c-nav .pf-c-menu__list-item:where(.pf-m-drill-up) > .pf-c-menu__item {\n  --pf-c-menu__item--FontWeight: var(--pf-c-nav--c-menu__list-item--m-drill-up__item--FontWeight);\n}\n.pf-c-nav .pf-c-menu__item-toggle-icon {\n  margin-left: calc(var(--pf-c-menu__item-toggle-icon--PaddingLeft) * -1);\n}\n.pf-c-nav.pf-m-horizontal .pf-c-nav__link::after, .pf-c-nav.pf-m-tertiary .pf-c-nav__link::after {\n  content: none;\n}\n.pf-c-nav.pf-m-horizontal, .pf-c-nav.pf-m-tertiary, .pf-c-nav.pf-m-horizontal-subnav {\n  overflow: hidden;\n}\n.pf-c-nav.pf-m-horizontal,\n.pf-c-nav.pf-m-horizontal .pf-c-nav__list, .pf-c-nav.pf-m-tertiary,\n.pf-c-nav.pf-m-tertiary .pf-c-nav__list, .pf-c-nav.pf-m-horizontal-subnav,\n.pf-c-nav.pf-m-horizontal-subnav .pf-c-nav__list {\n  position: relative;\n  display: flex;\n}\n.pf-c-nav.pf-m-horizontal .pf-c-nav__list, .pf-c-nav.pf-m-tertiary .pf-c-nav__list, .pf-c-nav.pf-m-horizontal-subnav .pf-c-nav__list {\n  flex: 1;\n  max-width: 100%;\n  overflow-x: auto;\n  white-space: nowrap;\n  scroll-snap-type: var(--pf-c-nav__list--ScrollSnapType);\n  -webkit-overflow-scrolling: touch;\n  scrollbar-width: none;\n  -ms-overflow-style: -ms-autohiding-scrollbar;\n}\n.pf-c-nav.pf-m-horizontal .pf-c-nav__list::-webkit-scrollbar, .pf-c-nav.pf-m-tertiary .pf-c-nav__list::-webkit-scrollbar, .pf-c-nav.pf-m-horizontal-subnav .pf-c-nav__list::-webkit-scrollbar {\n  display: none;\n}\n.pf-c-nav.pf-m-horizontal .pf-c-nav__item, .pf-c-nav.pf-m-tertiary .pf-c-nav__item, .pf-c-nav.pf-m-horizontal-subnav .pf-c-nav__item {\n  display: flex;\n  scroll-snap-align: var(--pf-c-nav__item--ScrollSnapAlign);\n}\n.pf-c-nav.pf-m-horizontal .pf-c-nav__link, .pf-c-nav.pf-m-tertiary .pf-c-nav__link, .pf-c-nav.pf-m-horizontal-subnav .pf-c-nav__link {\n  align-items: center;\n  align-self: stretch;\n  white-space: nowrap;\n}\n.pf-c-nav.pf-m-horizontal .pf-c-nav__link::before, .pf-c-nav.pf-m-tertiary .pf-c-nav__link::before, .pf-c-nav.pf-m-horizontal-subnav .pf-c-nav__link::before {\n  top: auto;\n  bottom: 0;\n}\n.pf-c-nav.pf-m-horizontal .pf-c-nav__link::before {\n  right: var(--pf-c-nav--m-horizontal__link--Right);\n  left: var(--pf-c-nav--m-horizontal__link--Left);\n}\n.pf-c-nav.pf-m-tertiary .pf-c-nav__link::before {\n  right: var(--pf-c-nav--m-tertiary__link--Right);\n  left: var(--pf-c-nav--m-tertiary__link--Left);\n}\n.pf-c-nav.pf-m-light {\n  --pf-c-nav__item--before--BorderColor: var(--pf-c-nav--m-light__item--before--BorderColor);\n  --pf-c-nav__item--m-current--not--m-expanded__link--BackgroundColor: var(--pf-c-nav--m-light__item--m-current--not--m-expanded__link--BackgroundColor);\n  --pf-c-nav__link--Color: var(--pf-c-nav--m-light__link--Color);\n  --pf-c-nav__link--hover--Color: var(--pf-c-nav--m-light__link--hover--Color);\n  --pf-c-nav__link--focus--Color: var(--pf-c-nav--m-light__link--focus--Color);\n  --pf-c-nav__link--active--Color: var(--pf-c-nav--m-light__link--active--Color);\n  --pf-c-nav__link--m-current--Color: var(--pf-c-nav--m-light__link--m-current--Color);\n  --pf-c-nav__link--hover--BackgroundColor: var(--pf-c-nav--m-light__link--hover--BackgroundColor);\n  --pf-c-nav__link--focus--BackgroundColor: var(--pf-c-nav--m-light__link--focus--BackgroundColor);\n  --pf-c-nav__link--active--BackgroundColor: var(--pf-c-nav--m-light__link--active--BackgroundColor);\n  --pf-c-nav__link--m-current--BackgroundColor: var(--pf-c-nav--m-light__link--m-current--BackgroundColor);\n  --pf-c-nav__link--before--BorderColor: var(--pf-c-nav--m-light__link--before--BorderColor);\n  --pf-c-nav__link--after--BorderColor: var(--pf-c-nav--m-light__link--after--BorderColor);\n  --pf-c-nav__link--m-current--after--BorderColor: var(--pf-c-nav--m-light__link--m-current--after--BorderColor);\n  --pf-c-nav__subnav__link--hover--after--BorderColor: var(--pf-c-nav--m-light__subnav__link--hover--after--BorderColor);\n  --pf-c-nav__subnav__link--focus--after--BorderColor: var(--pf-c-nav--m-light__subnav__link--focus--after--BorderColor);\n  --pf-c-nav__subnav__link--active--after--BorderColor: var(--pf-c-nav--m-light__subnav__link--active--after--BorderColor);\n  --pf-c-nav__subnav__link--m-current--after--BorderColor: var(--pf-c-nav--m-light__subnav__link--m-current--after--BorderColor);\n  --pf-c-nav__section-title--Color: var(--pf-c-nav--m-light__section-title--Color);\n  --pf-c-nav__section-title--BorderBottomColor: var(--pf-c-nav--m-light__section-title--BorderBottomColor);\n}\n.pf-c-nav.pf-m-light .pf-c-divider {\n  --pf-c-divider--after--BackgroundColor: var(--pf-c-nav--m-light--c-divider--BackgroundColor);\n}\n.pf-c-nav.pf-m-horizontal {\n  --pf-c-nav__link--PaddingTop: var(--pf-c-nav--m-horizontal__link--PaddingTop);\n  --pf-c-nav__link--PaddingRight: var(--pf-c-nav--m-horizontal__link--PaddingRight);\n  --pf-c-nav__link--PaddingBottom: var(--pf-c-nav--m-horizontal__link--PaddingBottom);\n  --pf-c-nav__link--PaddingLeft: var(--pf-c-nav--m-horizontal__link--PaddingLeft);\n  --pf-c-nav__link--Right: var(--pf-c-nav--m-horizontal__link--Right);\n  --pf-c-nav__link--Left: var(--pf-c-nav--m-horizontal__link--Left);\n  --pf-c-nav__link--Color: var(--pf-c-nav--m-horizontal__link--Color);\n  --pf-c-nav__link--hover--Color: var(--pf-c-nav--m-horizontal__link--hover--Color);\n  --pf-c-nav__link--active--Color: var(--pf-c-nav--m-horizontal__link--active--Color);\n  --pf-c-nav__link--focus--Color: var(--pf-c-nav--m-horizontal__link--focus--Color);\n  --pf-c-nav__link--m-current--Color: var(--pf-c-nav--m-horizontal__link--m-current--Color);\n  --pf-c-nav__link--BackgroundColor: var(--pf-c-nav--m-horizontal__link--BackgroundColor);\n  --pf-c-nav__link--hover--BackgroundColor: var(--pf-c-nav--m-horizontal__link--hover--BackgroundColor);\n  --pf-c-nav__link--focus--BackgroundColor: var(--pf-c-nav--m-horizontal__link--focus--BackgroundColor);\n  --pf-c-nav__link--active--BackgroundColor: var(--pf-c-nav--m-horizontal__link--active--BackgroundColor);\n  --pf-c-nav__link--m-current--BackgroundColor: var(--pf-c-nav--m-horizontal__link--m-current--BackgroundColor);\n  --pf-c-nav__link--before--BorderColor: var(--pf-c-nav--m-horizontal__link--before--BorderColor);\n  --pf-c-nav__link--before--BorderBottomWidth: var(--pf-c-nav--m-horizontal__link--before--BorderWidth);\n  --pf-c-nav__link--hover--before--BorderBottomWidth: var(--pf-c-nav--m-horizontal__link--hover--before--BorderWidth);\n  --pf-c-nav__link--focus--before--BorderBottomWidth: var(--pf-c-nav--m-horizontal__link--focus--before--BorderWidth);\n  --pf-c-nav__link--active--before--BorderBottomWidth: var(--pf-c-nav--m-horizontal__link--active--before--BorderWidth);\n  --pf-c-nav__link--m-current--before--BorderBottomWidth: var(--pf-c-nav--m-horizontal__link--m-current--before--BorderWidth);\n}\n.pf-c-nav.pf-m-tertiary {\n  --pf-c-nav__link--PaddingTop: var(--pf-c-nav--m-tertiary__link--PaddingTop);\n  --pf-c-nav__link--PaddingRight: var(--pf-c-nav--m-tertiary__link--PaddingRight);\n  --pf-c-nav__link--PaddingBottom: var(--pf-c-nav--m-tertiary__link--PaddingBottom);\n  --pf-c-nav__link--PaddingLeft: var(--pf-c-nav--m-tertiary__link--PaddingLeft);\n  --pf-c-nav__link--Right: var(--pf-c-nav--m-tertiary__link--Right);\n  --pf-c-nav__link--Left: var(--pf-c-nav--m-tertiary__link--Left);\n  --pf-c-nav__link--Color: var(--pf-c-nav--m-tertiary__link--Color);\n  --pf-c-nav__link--hover--Color: var(--pf-c-nav--m-tertiary__link--hover--Color);\n  --pf-c-nav__link--active--Color: var(--pf-c-nav--m-tertiary__link--active--Color);\n  --pf-c-nav__link--focus--Color: var(--pf-c-nav--m-tertiary__link--focus--Color);\n  --pf-c-nav__link--m-current--Color: var(--pf-c-nav--m-tertiary__link--m-current--Color);\n  --pf-c-nav__link--BackgroundColor: var(--pf-c-nav--m-tertiary__link--BackgroundColor);\n  --pf-c-nav__link--hover--BackgroundColor: var(--pf-c-nav--m-tertiary__link--hover--BackgroundColor);\n  --pf-c-nav__link--focus--BackgroundColor: var(--pf-c-nav--m-tertiary__link--focus--BackgroundColor);\n  --pf-c-nav__link--active--BackgroundColor: var(--pf-c-nav--m-tertiary__link--active--BackgroundColor);\n  --pf-c-nav__link--m-current--BackgroundColor: var(--pf-c-nav--m-tertiary__link--m-current--BackgroundColor);\n  --pf-c-nav__link--before--BorderColor: var(--pf-c-nav--m-tertiary__link--before--BorderColor);\n  --pf-c-nav__link--before--BorderBottomWidth: var(--pf-c-nav--m-tertiary__link--before--BorderWidth);\n  --pf-c-nav__link--hover--before--BorderBottomWidth: var(--pf-c-nav--m-tertiary__link--hover--before--BorderWidth);\n  --pf-c-nav__link--focus--before--BorderBottomWidth: var(--pf-c-nav--m-tertiary__link--focus--before--BorderWidth);\n  --pf-c-nav__link--active--before--BorderBottomWidth: var(--pf-c-nav--m-tertiary__link--active--before--BorderWidth);\n  --pf-c-nav__link--m-current--before--BorderBottomWidth: var(--pf-c-nav--m-tertiary__link--m-current--before--BorderWidth);\n  --pf-c-nav__scroll-button--Color: var(--pf-c-nav--m-tertiary__scroll-button--Color);\n  --pf-c-nav__scroll-button--hover--Color: var(--pf-c-nav--m-tertiary__scroll-button--hover--Color);\n  --pf-c-nav__scroll-button--focus--Color: var(--pf-c-nav--m-tertiary__scroll-button--focus--Color);\n  --pf-c-nav__scroll-button--active--Color: var(--pf-c-nav--m-tertiary__scroll-button--active--Color);\n  --pf-c-nav__scroll-button--disabled--Color: var(--pf-c-nav--m-tertiary__scroll-button--disabled--Color);\n  --pf-c-nav__scroll-button--before--BorderColor: var(--pf-c-nav--m-tertiary__scroll-button--before--BorderColor);\n  --pf-c-nav__scroll-button--disabled--before--BorderColor: var(--pf-c-nav--m-tertiary__scroll-button--disabled--before--BorderColor);\n}\n.pf-c-nav.pf-m-horizontal-subnav {\n  --pf-c-nav__link--FontSize: var(--pf-c-nav--m-horizontal-subnav__link--FontSize);\n  --pf-c-nav__link--PaddingTop: var(--pf-c-nav--m-horizontal-subnav__link--PaddingTop);\n  --pf-c-nav__link--PaddingRight: var(--pf-c-nav--m-horizontal-subnav__link--PaddingRight);\n  --pf-c-nav__link--PaddingBottom: var(--pf-c-nav--m-horizontal-subnav__link--PaddingBottom);\n  --pf-c-nav__link--PaddingLeft: var(--pf-c-nav--m-horizontal-subnav__link--PaddingLeft);\n  --pf-c-nav__link--Color: var(--pf-c-nav--m-horizontal-subnav__link--Color);\n  --pf-c-nav__link--Right: var(--pf-c-nav--m-horizontal-subnav__link--Right);\n  --pf-c-nav__link--Left: var(--pf-c-nav--m-horizontal-subnav__link--Left);\n  --pf-c-nav__link--hover--Color: var(--pf-c-nav--m-horizontal-subnav__link--hover--Color);\n  --pf-c-nav__link--active--Color: var(--pf-c-nav--m-horizontal-subnav__link--active--Color);\n  --pf-c-nav__link--focus--Color: var(--pf-c-nav--m-horizontal-subnav__link--focus--Color);\n  --pf-c-nav__link--m-current--Color: var(--pf-c-nav--m-horizontal-subnav__link--m-current--Color);\n  --pf-c-nav__link--BackgroundColor: var(--pf-c-nav--m-horizontal-subnav__link--BackgroundColor);\n  --pf-c-nav__link--hover--BackgroundColor: var(--pf-c-nav--m-horizontal-subnav__link--hover--BackgroundColor);\n  --pf-c-nav__link--focus--BackgroundColor: var(--pf-c-nav--m-horizontal-subnav__link--focus--BackgroundColor);\n  --pf-c-nav__link--active--BackgroundColor: var(--pf-c-nav--m-horizontal-subnav__link--active--BackgroundColor);\n  --pf-c-nav__link--m-current--BackgroundColor: var(--pf-c-nav--m-horizontal-subnav__link--m-current--BackgroundColor);\n  --pf-c-nav__link--before--BorderColor: var(--pf-c-nav--m-horizontal-subnav__link--before--BorderColor);\n  --pf-c-nav__link--after--BorderColor: var(--pf-c-nav--m-horizontal-subnav__link--after--BorderColor);\n  --pf-c-nav__link--hover--after--BorderColor: var(--pf-c-nav--m-horizontal-subnav__link--hover--after--BorderColor);\n  --pf-c-nav__link--active--after--BorderColor: var(--pf-c-nav--m-horizontal-subnav__link--active--after--BorderColor);\n  --pf-c-nav__link--m-current--after--BorderColor: var(--pf-c-nav--m-horizontal-subnav__link--m-current--after--BorderColor);\n  --pf-c-nav__link--after--BorderLeftWidth: var(--pf-c-nav--m-horizontal-subnav__link--after--BorderLeftWidth);\n  --pf-c-nav__link--hover--after--BorderLeftWidth: var(--pf-c-nav--m-horizontal-subnav__link--hover--after--BorderLeftWidth);\n  --pf-c-nav__link--active--after--BorderLeftWidth: var(--pf-c-nav--m-horizontal-subnav__link--active--after--BorderLeftWidth);\n  --pf-c-nav__link--m-current--after--BorderLeftWidth: var(--pf-c-nav--m-horizontal-subnav__link--m-current--after--BorderLeftWidth);\n}\n.pf-c-nav.pf-m-horizontal-subnav.pf-m-scrollable .pf-c-nav__item:first-child {\n  --pf-c-nav__link--after--BorderLeftWidth: 0;\n  --pf-c-nav__link--hover--after--BorderLeftWidth: 0;\n  --pf-c-nav__link--active--after--BorderLeftWidth: 0;\n  --pf-c-nav__link--m-current--after--BorderLeftWidth: 0;\n}\n.pf-c-nav .pf-c-divider {\n  --pf-c-divider--after--BackgroundColor: var(--pf-c-nav--c-divider--BackgroundColor);\n  padding-right: var(--pf-c-nav--c-divider--PaddingRight);\n  padding-left: var(--pf-c-nav--c-divider--PaddingLeft);\n  margin-top: var(--pf-c-nav--c-divider--MarginTop);\n  margin-bottom: var(--pf-c-nav--c-divider--MarginBottom);\n}\n.pf-c-nav.pf-m-scrollable .pf-c-nav__scroll-button {\n  opacity: 1;\n}\n.pf-c-nav.pf-m-scrollable .pf-c-nav__scroll-button:nth-of-type(1) {\n  margin-right: 0;\n  transform: translateX(0);\n}\n.pf-c-nav.pf-m-scrollable .pf-c-nav__scroll-button:nth-of-type(2) {\n  margin-left: 0;\n  transform: translateX(0);\n}\n.pf-c-nav.pf-m-overflow-hidden {\n  overflow: hidden;\n}\n\n.pf-c-nav__list {\n  position: relative;\n  display: block;\n}\n\n.pf-c-nav__item {\n  position: relative;\n  margin-top: var(--pf-c-nav__item--MarginTop);\n}\n.pf-c-nav__item.pf-m-expandable {\n  --pf-c-nav__link--before--BorderBottomWidth: 0;\n}\n.pf-c-nav__item.pf-m-expandable::before {\n  position: absolute;\n  right: 0;\n  bottom: calc(var(--pf-c-nav__item--before--BorderWidth) * -1);\n  left: 0;\n  content: "";\n  border-bottom: var(--pf-c-nav__item--before--BorderWidth) solid var(--pf-c-nav__item--before--BorderColor);\n}\n.pf-c-nav__item .pf-c-nav__item:not(.pf-m-expanded) .pf-c-nav__toggle-icon {\n  transform: rotate(0);\n}\n.pf-c-nav__item .pf-c-nav__item.pf-m-expandable {\n  --pf-c-nav__toggle--FontSize: var(--pf-c-nav__item__item__toggle--FontSize);\n  --pf-c-nav__link--PaddingRight: var(--pf-c-nav__item__item__link--PaddingRight);\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-nav__item .pf-c-nav__item.pf-m-expandable::before {\n    border-bottom: none;\n  }\n}\n.pf-c-nav__item .pf-c-nav__item.pf-m-expandable .pf-c-nav__list::before {\n  position: absolute;\n  top: 0;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  pointer-events: none;\n  content: "";\n  border-left: var(--pf-c-nav__item--before--BorderWidth) solid var(--pf-c-nav__item--before--BorderColor);\n}\n.pf-c-nav__item .pf-c-nav__toggle-icon {\n  transform: rotate(var(--pf-c-nav__item__toggle-icon--Rotate));\n}\n.pf-c-nav__item.pf-m-flyout:hover {\n  --pf-c-nav__link--BackgroundColor: var(--pf-c-nav__item--m-flyout--hover__link--BackgroundColor);\n  --pf-c-nav__link--before--BorderBottomWidth: var(--pf-c-nav__item--m-flyout--hover__link--before--BorderWidth);\n}\n.pf-c-nav__item.pf-m-flyout:focus {\n  --pf-c-nav__link--BackgroundColor: var(--pf-c-nav__item--m-flyout--focus__link--BackgroundColor);\n  --pf-c-nav__link--before--BorderBottomWidth: var(--pf-c-nav__item--m-flyout--focus__link--before--BorderWidth);\n}\n.pf-c-nav__item.pf-m-flyout:active {\n  --pf-c-nav__link--BackgroundColor: var(--pf-c-nav__item--m-flyout--active__link--BackgroundColor);\n  --pf-c-nav__link--before--BorderBottomWidth: var(--pf-c-nav__item--m-flyout--active__link--before--BorderWidth);\n}\n.pf-c-nav__item.pf-m-flyout .pf-c-menu {\n  --pf-c-menu--MinWidth: 100%;\n  --pf-c-menu--BoxShadow: var(--pf-c-nav__item--m-flyout--c-menu--BoxShadow);\n  --pf-c-menu--BackgroundColor: var(--pf-c-nav__item--m-flyout--c-menu--BackgroundColor);\n  --pf-c-menu__list--PaddingTop: 0;\n  --pf-c-menu__list--PaddingBottom: 0;\n  --pf-c-menu__list-item--hover--BackgroundColor: var(--pf-c-nav__item--m-flyout--c-menu__list-item--hover--BackgroundColor);\n  --pf-c-menu__list-item--focus-within--BackgroundColor: var(--pf-c-nav__item--m-flyout--c-menu__list-item--focus-within--BackgroundColor);\n  --pf-c-menu__list-item--active--BackgroundColor: var(--pf-c-nav__item--m-flyout--c-menu__list-item--active--BackgroundColor);\n  --pf-c-menu__item--FontSize: var(--pf-c-nav__item--m-flyout--c-menu__item--FontSize);\n  --pf-c-menu__item--Color: var(--pf-c-nav__item--m-flyout--c-menu__item--Color);\n  --pf-c-menu__item--PaddingTop: var(--pf-c-nav__item--m-flyout--c-menu__item--PaddingTop);\n  --pf-c-menu__item--PaddingRight: var(--pf-c-nav__item--m-flyout--c-menu__item--PaddingRight);\n  --pf-c-menu__item--PaddingBottom: var(--pf-c-nav__item--m-flyout--c-menu__item--PaddingBottom);\n  --pf-c-menu__item--PaddingLeft: var(--pf-c-nav__item--m-flyout--c-menu__item--PaddingLeft);\n  --pf-c-menu__item-description--Color: var(--pf-c-nav__item--m-flyout--c-menu__item-description--Color);\n  --pf-c-nav--c-menu--m-flyout--c-menu--Bottom: var(--pf-c-nav__item--m-flyout--c-menu--m-top--Bottom);\n  --pf-c-nav--c-menu--m-flyout--c-menu--Right: var(--pf-c-nav__item--m-flyout--c-menu--m-left--Right);\n  position: absolute;\n  top: var(--pf-c-nav__item--m-flyout--c-menu--Top);\n  left: var(--pf-c-nav__item--m-flyout--c-menu--Left);\n}\n.pf-c-nav__item.pf-m-flyout .pf-c-menu .pf-c-menu {\n  top: var(--pf-c-nav__item--m-flyout--c-menu--c-menu--Top);\n}\n.pf-c-nav__item.pf-m-flyout .pf-c-menu .pf-c-menu__list-item:first-child {\n  --pf-c-nav__item--m-flyout--c-menu--c-menu--Top: var(--pf-c-nav__item--m-flyout--c-menu__list-item--first-child--c-menu--Top);\n  --pf-c-nav__item--m-flyout--c-menu__item--hover--after--Top: var(--pf-c-nav__item--m-flyout--c-menu__list-item--first-child__item--hover--after--Top);\n}\n.pf-c-nav__item.pf-m-flyout .pf-c-menu .pf-c-menu__item {\n  position: relative;\n  outline-offset: var(--pf-c-nav__item--m-flyout--c-menu__item--OutlineOffset);\n}\n.pf-c-nav__item.pf-m-flyout .pf-c-menu .pf-c-menu__item::before {\n  position: absolute;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  content: "";\n  border-bottom: var(--pf-c-nav__item--m-flyout--c-menu__item--before--BorderBottomWidth) solid var(--pf-c-nav__item--m-flyout--c-menu__item--before--BorderBottomColor);\n}\n.pf-c-nav__item.pf-m-flyout .pf-c-menu .pf-c-menu__item:hover::after {\n  position: absolute;\n  top: var(--pf-c-nav__item--m-flyout--c-menu__item--hover--after--Top);\n  bottom: 0;\n  left: 0;\n  content: "";\n  border-left: var(--pf-c-nav__item--m-flyout--c-menu__item--hover--after--BorderLeftWidth) solid var(--pf-c-nav__item--m-flyout--c-menu__item--hover--after--BorderLeftColor);\n}\n.pf-c-nav__item.pf-m-drilldown.pf-m-expanded > .pf-c-nav__subnav {\n  left: 0;\n  z-index: var(--pf-c-nav__item--m-drilldown--m-expanded__subnav--ZIndex);\n}\n\n.pf-c-nav__link {\n  position: relative;\n  display: flex;\n  align-items: baseline;\n  padding: var(--pf-c-nav__link--PaddingTop) var(--pf-c-nav__link--PaddingRight) var(--pf-c-nav__link--PaddingBottom) var(--pf-c-nav__link--PaddingLeft);\n  font-size: var(--pf-c-nav__link--FontSize);\n  font-weight: var(--pf-c-nav__link--FontWeight);\n  color: var(--pf-c-nav__link--Color);\n  background-color: var(--pf-c-nav__link--BackgroundColor);\n  outline-offset: var(--pf-c-nav__link--OutlineOffset);\n}\n.pf-c-nav__link::after, .pf-c-nav__link::before {\n  position: absolute;\n  content: "";\n  border: 0 solid;\n}\n.pf-c-nav__link::before {\n  right: 0;\n  bottom: calc(var(--pf-c-nav__link--before--BorderBottomWidth) * -1);\n  left: 0;\n  border-color: var(--pf-c-nav__link--before--BorderColor);\n  border-bottom-width: var(--pf-c-nav__link--before--BorderBottomWidth);\n}\n.pf-c-nav__link::after {\n  top: 0;\n  bottom: 0;\n  left: 0;\n  border: 0 solid;\n  border-color: var(--pf-c-nav__link--after--BorderColor);\n  border-left-width: var(--pf-c-nav__link--after--BorderLeftWidth);\n}\n.pf-c-nav__link:hover, .pf-c-nav__link.pf-m-hover {\n  color: var(--pf-c-nav__link--hover--Color);\n  background-color: var(--pf-c-nav__link--hover--BackgroundColor);\n}\n.pf-c-nav__link:hover::before, .pf-c-nav__link.pf-m-hover::before {\n  border-bottom-width: var(--pf-c-nav__link--hover--before--BorderBottomWidth);\n}\n.pf-c-nav__link:hover::after, .pf-c-nav__link.pf-m-hover::after {\n  border-color: var(--pf-c-nav__link--hover--after--BorderColor);\n  border-left-width: var(--pf-c-nav__link--hover--after--BorderLeftWidth);\n}\n.pf-c-nav__link:focus {\n  color: var(--pf-c-nav__link--focus--Color);\n  background-color: var(--pf-c-nav__link--focus--BackgroundColor);\n}\n.pf-c-nav__link:focus::before {\n  border-bottom-width: var(--pf-c-nav__link--focus--before--BorderBottomWidth);\n}\n.pf-c-nav__link:focus::after {\n  border-color: var(--pf-c-nav__link--focus--after--BorderColor);\n  border-left-width: var(--pf-c-nav__link--focus--after--BorderLeftWidth);\n}\n.pf-c-nav__link:active {\n  color: var(--pf-c-nav__link--active--Color);\n  background-color: var(--pf-c-nav__link--active--BackgroundColor);\n}\n.pf-c-nav__link:active::before {\n  border-bottom-width: var(--pf-c-nav__link--active--before--BorderBottomWidth);\n}\n.pf-c-nav__link:active::after {\n  border-color: var(--pf-c-nav__link--active--after--BorderColor);\n  border-left-width: var(--pf-c-nav__link--active--after--BorderLeftWidth);\n}\n.pf-c-nav__link.pf-m-current, .pf-c-nav__link.pf-m-current:hover, .pf-c-nav__item.pf-m-current:not(.pf-m-expanded) .pf-c-nav__link {\n  color: var(--pf-c-nav__link--m-current--Color);\n  background-color: var(--pf-c-nav__link--m-current--BackgroundColor);\n}\n.pf-c-nav__link.pf-m-current::before, .pf-c-nav__link.pf-m-current:hover::before, .pf-c-nav__item.pf-m-current:not(.pf-m-expanded) .pf-c-nav__link::before {\n  border-bottom-width: var(--pf-c-nav__link--m-current--before--BorderBottomWidth);\n}\n.pf-c-nav__link.pf-m-current::after, .pf-c-nav__link.pf-m-current:hover::after, .pf-c-nav__item.pf-m-current:not(.pf-m-expanded) .pf-c-nav__link::after {\n  border-color: var(--pf-c-nav__link--m-current--after--BorderColor);\n  border-left-width: var(--pf-c-nav__link--m-current--after--BorderLeftWidth);\n}\n.pf-c-nav__link, .pf-c-nav__link:hover, .pf-c-nav__link:focus, .pf-c-nav__link:active {\n  width: 100%;\n  text-decoration: none;\n  border: none;\n}\n\n.pf-c-nav__subnav {\n  --pf-c-nav__link--PaddingTop: var(--pf-c-nav__subnav__link--PaddingTop);\n  --pf-c-nav__link--PaddingRight: var(--pf-c-nav__subnav__link--PaddingRight);\n  --pf-c-nav__link--PaddingBottom: var(--pf-c-nav__subnav__link--PaddingBottom);\n  --pf-c-nav__link--PaddingLeft: var(--pf-c-nav__subnav__link--PaddingLeft);\n  --pf-c-nav__link--FontSize: var(--pf-c-nav__subnav__link--FontSize);\n  --pf-c-nav__link--hover--after--BorderColor: var(--pf-c-nav__subnav__link--hover--after--BorderColor);\n  --pf-c-nav__link--focus--after--BorderColor: var(--pf-c-nav__subnav__link--focus--after--BorderColor);\n  --pf-c-nav__link--active--after--BorderColor: var(--pf-c-nav__subnav__link--active--after--BorderColor);\n  --pf-c-nav__link--m-current--after--BorderColor: var(--pf-c-nav__subnav__link--m-current--after--BorderColor);\n  --pf-c-nav__link--hover--after--BorderLeftWidth: var(--pf-c-nav__subnav__link--hover--after--BorderWidth);\n  --pf-c-nav__link--focus--after--BorderLeftWidth: var(--pf-c-nav__subnav__link--focus--after--BorderWidth);\n  --pf-c-nav__link--active--after--BorderLeftWidth: var(--pf-c-nav__subnav__link--active--after--BorderWidth);\n  --pf-c-nav__link--m-current--after--BorderLeftWidth: var(--pf-c-nav__subnav__link--m-current--after--BorderWidth);\n  --pf-c-nav--c-divider--PaddingRight: var(--pf-c-nav__subnav--c-divider--PaddingRight);\n  --pf-c-nav--c-divider--PaddingLeft: var(--pf-c-nav__subnav--c-divider--PaddingLeft);\n  max-height: var(--pf-c-nav__subnav--MaxHeight);\n  padding-bottom: var(--pf-c-nav__subnav--PaddingBottom);\n  padding-left: var(--pf-c-nav__subnav--PaddingLeft);\n  transition: var(--pf-c-nav--Transition);\n  scrollbar-width: none;\n  -ms-overflow-style: -ms-autohiding-scrollbar;\n}\n.pf-c-nav__subnav .pf-c-nav__subnav {\n  --pf-c-nav__link--FontSize: var(--pf-c-nav__subnav__subnav__link--FontSize);\n  --pf-c-nav__link--PaddingLeft: var(--pf-c-nav__subnav__subnav__link--PaddingLeft);\n  --pf-c-nav__subnav--PaddingLeft: var(--pf-c-nav__subnav__subnav--PaddingLeft);\n}\n.pf-c-nav__subnav.pf-m-flyout {\n  width: 100%;\n}\n.pf-c-nav__item.pf-m-expanded .pf-c-nav__subnav {\n  --pf-c-nav__subnav--MaxHeight: var(--pf-c-nav__item--m-expanded__subnav--MaxHeight);\n  overflow-y: auto;\n  opacity: 1;\n}\n.pf-c-nav__subnav::-webkit-scrollbar {\n  display: none;\n}\n\n.pf-c-nav__toggle {\n  flex: none;\n  padding-right: var(--pf-c-nav__toggle--PaddingRight);\n  padding-left: var(--pf-c-nav__toggle--PaddingLeft);\n  margin-left: auto;\n  font-size: var(--pf-c-nav__toggle--FontSize);\n  line-height: 1;\n}\n.pf-c-nav__toggle.pf-m-start {\n  margin-right: var(--pf-c-nav__toggle--m-start--MarginRight);\n  margin-left: calc(var(--pf-c-nav__toggle--PaddingRight) * -1);\n}\n\n.pf-c-nav__toggle-icon {\n  display: inline-block;\n  transition: var(--pf-c-nav__toggle-icon--Transition);\n}\n.pf-c-nav__item.pf-m-expanded .pf-c-nav__toggle-icon {\n  transform: rotate(var(--pf-c-nav__item--m-expanded__toggle-icon--Rotate));\n}\n\n.pf-c-nav__section {\n  --pf-c-nav__item--MarginTop: var(--pf-c-nav__section__item--MarginTop);\n  --pf-c-nav__link--PaddingTop: var(--pf-c-nav__section__link--PaddingTop);\n  --pf-c-nav__link--PaddingRight: var(--pf-c-nav__section__link--PaddingRight);\n  --pf-c-nav__link--PaddingBottom: var(--pf-c-nav__section__link--PaddingBottom);\n  --pf-c-nav__link--PaddingLeft: var(--pf-c-nav__section__link--PaddingLeft);\n  --pf-c-nav__link--FontSize: var(--pf-c-nav__section__link--FontSize);\n  --pf-c-nav__link--before--BorderBottomWidth: var(--pf-c-nav__section__link--before--BorderBottomWidth);\n  --pf-c-nav__link--hover--after--BorderColor: var(--pf-c-nav__section__link--hover--after--BorderColor);\n  --pf-c-nav__link--focus--after--BorderColor: var(--pf-c-nav__section__link--focus--after--BorderColor);\n  --pf-c-nav__link--active--after--BorderColor: var(--pf-c-nav__section__link--active--after--BorderColor);\n  --pf-c-nav__link--m-current--after--BorderColor: var(--pf-c-nav__section__link--m-current--after--BorderColor);\n  --pf-c-nav__link--hover--after--BorderLeftWidth: var(--pf-c-nav__section__link--hover--after--BorderWidth);\n  --pf-c-nav__link--focus--after--BorderLeftWidth: var(--pf-c-nav__section__link--focus--after--BorderWidth);\n  --pf-c-nav__link--active--after--BorderLeftWidth: var(--pf-c-nav__section__link--active--after--BorderWidth);\n  --pf-c-nav__link--m-current--after--BorderLeftWidth: var(--pf-c-nav__section__link--m-current--after--BorderWidth);\n  margin-top: var(--pf-c-nav__section--MarginTop);\n  --pf-c-nav--c-divider--MarginBottom: 0;\n}\n.pf-c-nav__section + .pf-c-nav__section {\n  --pf-c-nav__section--MarginTop: var(--pf-c-nav__section--section--MarginTop);\n}\n.pf-c-nav__section.pf-m-no-title {\n  --pf-c-nav__section--MarginTop: 0;\n}\n\n.pf-c-nav__section-title {\n  padding: var(--pf-c-nav__section-title--PaddingTop) var(--pf-c-nav__section-title--PaddingRight) var(--pf-c-nav__section-title--PaddingBottom) var(--pf-c-nav__section-title--PaddingLeft);\n  font-size: var(--pf-c-nav__section-title--FontSize);\n  color: var(--pf-c-nav__section-title--Color);\n  border-bottom: var(--pf-c-nav__section-title--BorderBottomWidth) solid var(--pf-c-nav__section-title--BorderBottomColor);\n}\n\n.pf-c-nav__scroll-button {\n  flex: none;\n  width: var(--pf-c-nav__scroll-button--Width);\n  color: var(--pf-c-nav__scroll-button--Color);\n  background-color: var(--pf-c-nav__scroll-button--BackgroundColor);\n  border: 0;\n  outline-offset: var(--pf-c-nav__scroll-button--OutlineOffset);\n  opacity: 0;\n  transition: var(--pf-c-nav__scroll-button--Transition);\n}\n.pf-c-nav__scroll-button::before {\n  position: absolute;\n  top: 0;\n  bottom: 0;\n  content: "";\n  border: solid var(--pf-c-nav__scroll-button--before--BorderColor);\n  border-width: 0 var(--pf-c-nav__scroll-button--before--BorderRightWidth) 0 var(--pf-c-nav__scroll-button--before--BorderLeftWidth);\n}\n.pf-c-nav__scroll-button:hover {\n  color: var(--pf-c-nav__scroll-button--hover--Color);\n}\n.pf-c-nav__scroll-button:focus {\n  color: var(--pf-c-nav__scroll-button--focus--Color);\n}\n.pf-c-nav__scroll-button:active {\n  color: var(--pf-c-nav__scroll-button--active--Color);\n}\n.pf-c-nav__scroll-button:disabled {\n  color: var(--pf-c-nav__scroll-button--disabled--Color);\n  border-color: var(--pf-c-nav__scroll-button--disabled--before--BorderColor);\n}\n.pf-c-nav__scroll-button:nth-of-type(1) {\n  --pf-c-nav__scroll-button--before--BorderRightWidth: var(--pf-c-nav__scroll-button--before--BorderWidth);\n  margin-right: calc(var(--pf-c-nav__scroll-button--Width) * -1);\n  transform: translateX(-100%);\n}\n.pf-c-nav__scroll-button:nth-of-type(1)::before {\n  right: 0;\n}\n.pf-c-nav__scroll-button:nth-of-type(2) {\n  --pf-c-nav__scroll-button--before--BorderLeftWidth: var(--pf-c-nav__scroll-button--before--BorderWidth);\n  margin-left: calc(var(--pf-c-nav__scroll-button--Width) * -1);\n  transform: translateX(100%);\n}\n.pf-c-nav__scroll-button:nth-of-type(2)::before {\n  left: 0;\n}\n\n:where(.pf-theme-dark) .pf-c-nav {\n  --pf-c-nav__item--item__link--after--Top: -1px;\n  --pf-c-nav__item--before--BorderColor: var(--pf-global--BorderColor--100);\n  --pf-c-nav__link--hover--BackgroundColor: var(--pf-global--BackgroundColor--300);\n  --pf-c-nav__link--focus--BackgroundColor: var(--pf-global--BackgroundColor--300);\n  --pf-c-nav__link--active--BackgroundColor: var(--pf-global--BackgroundColor--300);\n  --pf-c-nav__link--m-current--BackgroundColor: var(--pf-global--BackgroundColor--300);\n  --pf-c-nav__link--before--BorderColor: var(--pf-global--BorderColor--100);\n  --pf-c-nav--m-tertiary__scroll-button--before--BorderColor: var(--pf-global--BorderColor--100);\n  --pf-c-nav__section-title--Color: var(--pf-global--Color--200);\n  --pf-c-nav__section-title--BorderBottomColor: var(--pf-global--BorderColor--100);\n  --pf-c-nav__scroll-button--before--BorderColor: var(--pf-global--BorderColor--100);\n  --pf-c-nav--c-divider--BackgroundColor: var(--pf-global--BorderColor--100);\n  --pf-c-nav__link--hover--before--BorderBottomWidth: 0;\n  --pf-c-nav__link--focus--before--BorderBottomWidth: 0;\n  --pf-c-nav__link--active--before--BorderBottomWidth: 0;\n  --pf-c-nav__link--m-current--before--BorderBottomWidth: 0;\n}\n:where(.pf-theme-dark) .pf-c-nav__link::before {\n  bottom: 0;\n}\n:where(.pf-theme-dark) .pf-c-nav__link::after {\n  top: var(--pf-c-nav__item--item__link--after--Top);\n}\n:where(.pf-theme-dark) .pf-c-nav__item + .pf-c-nav__item {\n  --pf-c-nav__link--after--Top: var(--pf-c-nav__item--item__link--after--Top);\n}\n:where(.pf-theme-dark) .pf-c-nav__subnav {\n  --pf-c-nav__item--item__link--after--Top: 0;\n}\n:where(.pf-theme-dark) .pf-c-nav__section {\n  --pf-c-nav__item--item__link--after--Top: 0;\n}';

// src/elements/sidebar/SidebarUser.ts
var SidebarUser = class extends AKElement {
  static get styles() {
    return [
      patternfly_base_default,
      nav_default,
      avatar_default,
      i`
                :host {
                    display: flex;
                    width: 100%;
                    flex-direction: row;
                    justify-content: space-between;
                }
                .pf-c-nav__link {
                    align-items: center;
                    display: flex;
                    justify-content: center;
                }
            `
    ];
  }
  render() {
    return x`
            <a href="/if/user/#/settings" class="pf-c-nav__link user-avatar" id="user-settings">
                ${m(
      me().then((u) => {
        return x`<img
                            class="pf-c-avatar"
                            src="${o(u.user.avatar)}"
                            alt=""
                        />`;
      }),
      x``
    )}
            </a>
            <a href="/flows/-/default/invalidation/" class="pf-c-nav__link user-logout" id="logout">
                <i class="fas fa-sign-out-alt" aria-hidden="true"></i>
            </a>
        `;
  }
};
SidebarUser = __decorateClass([
  t("ak-sidebar-user")
], SidebarUser);

// src/elements/sidebar/Sidebar.ts
var Sidebar = class extends AKElement {
  static get styles() {
    return [
      patternfly_base_default,
      page_default,
      nav_default,
      i`
                :host {
                    z-index: 100;
                }
                .pf-c-nav__link.pf-m-current::after,
                .pf-c-nav__link.pf-m-current:hover::after,
                .pf-c-nav__item.pf-m-current:not(.pf-m-expanded) .pf-c-nav__link::after {
                    --pf-c-nav__link--m-current--after--BorderColor: #fd4b2d;
                }
                :host([theme="light"]) {
                    border-right-color: transparent !important;
                }

                .pf-c-nav__section + .pf-c-nav__section {
                    --pf-c-nav__section--section--MarginTop: var(--pf-global--spacer--sm);
                }
                .pf-c-nav__list .sidebar-brand {
                    max-height: 82px;
                    margin-bottom: -0.5rem;
                }
                nav {
                    display: flex;
                    flex-direction: column;
                    max-height: 100vh;
                    height: 100%;
                    overflow-y: hidden;
                }
                .pf-c-nav__list {
                    flex-grow: 1;
                    overflow-y: auto;
                }

                .pf-c-nav__link {
                    --pf-c-nav__link--PaddingTop: 0.5rem;
                    --pf-c-nav__link--PaddingRight: 0.5rem;
                    --pf-c-nav__link--PaddingBottom: 0.5rem;
                }
                .pf-c-nav__section-title {
                    font-size: 12px;
                }
                .pf-c-nav__item {
                    --pf-c-nav__item--MarginTop: 0px;
                }
            `
    ];
  }
  render() {
    return x`<nav
            class="pf-c-nav ${this.activeTheme === UiThemeEnum.Light ? "pf-m-light" : ""}"
            aria-label="Global"
        >
            <ak-sidebar-brand></ak-sidebar-brand>
            <ul class="pf-c-nav__list">
                <slot></slot>
            </ul>
            <ak-sidebar-user></ak-sidebar-user>
        </nav>`;
  }
};
Sidebar = __decorateClass([
  t("ak-sidebar")
], Sidebar);

// src/elements/sidebar/SidebarItem.ts
var SidebarItem = class extends AKElement {
  constructor() {
    super(...arguments);
    this.activeMatchers = [];
    this.expanded = false;
    this.isActive = false;
  }
  static get styles() {
    return [
      patternfly_base_default,
      page_default,
      nav_default,
      i`
                :host {
                    z-index: 100;
                    box-shadow: none !important;
                }
                :host([highlight]) .pf-c-nav__item {
                    background-color: var(--ak-accent);
                    margin: 16px;
                }
                :host([highlight]) .pf-c-nav__item .pf-c-nav__link {
                    padding-left: 0.5rem;
                }
                .pf-c-nav__link.pf-m-current::after,
                .pf-c-nav__link.pf-m-current:hover::after,
                .pf-c-nav__item.pf-m-current:not(.pf-m-expanded) .pf-c-nav__link::after {
                    --pf-c-nav__link--m-current--after--BorderColor: #fd4b2d;
                }

                .pf-c-nav__section + .pf-c-nav__section {
                    --pf-c-nav__section--section--MarginTop: var(--pf-global--spacer--sm);
                }
                .pf-c-nav__list .sidebar-brand {
                    max-height: 82px;
                    margin-bottom: -0.5rem;
                }
                nav {
                    display: flex;
                    flex-direction: column;
                    max-height: 100vh;
                    height: 100%;
                    overflow-y: hidden;
                }
                .pf-c-nav__list {
                    flex-grow: 1;
                    overflow-y: auto;
                }

                .pf-c-nav__link {
                    --pf-c-nav__link--PaddingTop: 0.5rem;
                    --pf-c-nav__link--PaddingRight: 0.5rem;
                    --pf-c-nav__link--PaddingBottom: 0.5rem;
                }
                .pf-c-nav__section-title {
                    font-size: 12px;
                }
                .pf-c-nav__item {
                    --pf-c-nav__item--MarginTop: 0px;
                }
            `
    ];
  }
  get childItems() {
    const children = Array.from(this.querySelectorAll("ak-sidebar-item") || []);
    children.forEach((child) => child.parent = this);
    return children;
  }
  set activeWhen(regexp) {
    regexp.forEach((r2) => {
      this.activeMatchers.push(new RegExp(r2));
    });
  }
  firstUpdated() {
    this.onHashChange();
    window.addEventListener("hashchange", () => this.onHashChange());
  }
  onHashChange() {
    const activePath = window.location.hash.slice(1, Infinity).split(ROUTE_SEPARATOR)[0];
    this.childItems.forEach((item) => {
      this.expandParentRecursive(activePath, item);
    });
    this.isActive = this.matchesPath(activePath);
  }
  matchesPath(path) {
    if (!this.path) {
      return false;
    }
    if (this.path) {
      const ourPath = this.path.split(";")[0];
      if (new RegExp(`^${ourPath}$`).exec(path)) {
        return true;
      }
    }
    return this.activeMatchers.some((v) => {
      const match = v.exec(path);
      if (match !== null) {
        return true;
      }
      return false;
    });
  }
  expandParentRecursive(activePath, item) {
    if (item.matchesPath(activePath) && item.parent) {
      item.parent.expanded = true;
      this.requestUpdate();
    }
    item.childItems.forEach((i3) => this.expandParentRecursive(activePath, i3));
  }
  render() {
    return this.renderInner();
  }
  renderWithChildren() {
    return x`<li
            class="pf-c-nav__item ${this.expanded ? "pf-m-expandable pf-m-expanded" : ""}"
        >
            <button
                class="pf-c-nav__link"
                aria-expanded="true"
                @click=${() => {
      this.expanded = !this.expanded;
    }}
            >
                <slot name="label"></slot>
                <span class="pf-c-nav__toggle">
                    <span class="pf-c-nav__toggle-icon">
                        <i class="fas fa-angle-right" aria-hidden="true"></i>
                    </span>
                </span>
            </button>
            <section class="pf-c-nav__subnav" ?hidden=${!this.expanded}>
                <ul class="pf-c-nav__list">
                    <slot></slot>
                </ul>
            </section>
        </li>`;
  }
  renderWithPathAndChildren() {
    return x`<li
            class="pf-c-nav__item ${this.expanded ? "pf-m-expandable pf-m-expanded" : ""}"
        >
            <slot name="label"></slot>
            <button
                class="pf-c-nav__link"
                aria-expanded="true"
                @click=${() => {
      this.expanded = !this.expanded;
    }}
            >
                <span class="pf-c-nav__toggle">
                    <span class="pf-c-nav__toggle-icon">
                        <i class="fas fa-angle-right" aria-hidden="true"></i>
                    </span>
                </span>
            </button>
            <section class="pf-c-nav__subnav" ?hidden=${!this.expanded}>
                <ul class="pf-c-nav__list">
                    <slot></slot>
                </ul>
            </section>
        </li>`;
  }
  renderWithPath() {
    return x`
            <a
                href="${this.isAbsoluteLink ? "" : "#"}${this.path}"
                class="pf-c-nav__link ${this.isActive ? "pf-m-current" : ""}"
            >
                <slot name="label"></slot>
            </a>
        `;
  }
  renderWithLabel() {
    return x`
            <span class="pf-c-nav__link">
                <slot name="label"></slot>
            </span>
        `;
  }
  renderInner() {
    if (this.childItems.length > 0) {
      return this.path ? this.renderWithPathAndChildren() : this.renderWithChildren();
    }
    return x`<li class="pf-c-nav__item">
            ${this.path ? this.renderWithPath() : this.renderWithLabel()}
        </li>`;
  }
};
__decorateClass([
  n()
], SidebarItem.prototype, "path", 2);
__decorateClass([
  n({ type: Boolean })
], SidebarItem.prototype, "expanded", 2);
__decorateClass([
  n({ type: Boolean })
], SidebarItem.prototype, "isActive", 2);
__decorateClass([
  n({ type: Boolean })
], SidebarItem.prototype, "isAbsoluteLink", 2);
__decorateClass([
  n({ type: Boolean })
], SidebarItem.prototype, "highlight", 2);
__decorateClass([
  n({ attribute: false })
], SidebarItem.prototype, "activeWhen", 1);
SidebarItem = __decorateClass([
  t("ak-sidebar-item")
], SidebarItem);

// node_modules/@patternfly/patternfly/components/Drawer/drawer.css
var drawer_default = '.pf-c-drawer {\n  --pf-c-drawer__section--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-drawer__section--m-light-200--BackgroundColor: var(--pf-global--BackgroundColor--200);\n  --pf-c-drawer__content--FlexBasis: 100%;\n  --pf-c-drawer__content--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-drawer__content--m-light-200--BackgroundColor: var(--pf-global--BackgroundColor--200);\n  --pf-c-drawer__content--ZIndex: var(--pf-global--ZIndex--xs);\n  --pf-c-drawer__panel--MinWidth: 50%;\n  --pf-c-drawer__panel--MaxHeight: auto;\n  --pf-c-drawer__panel--ZIndex: var(--pf-global--ZIndex--sm);\n  --pf-c-drawer__panel--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-drawer__panel--m-light-200--BackgroundColor: var(--pf-global--BackgroundColor--200);\n  --pf-c-drawer__panel--TransitionDuration: var(--pf-global--TransitionDuration);\n  --pf-c-drawer__panel--TransitionProperty: margin, transform, box-shadow, flex-basis;\n  --pf-c-drawer__panel--FlexBasis: 100%;\n  --pf-c-drawer__panel--md--FlexBasis--min: 1.5rem;\n  --pf-c-drawer__panel--md--FlexBasis: 50%;\n  --pf-c-drawer__panel--md--FlexBasis--max: 100%;\n  --pf-c-drawer__panel--xl--MinWidth: 28.125rem;\n  --pf-c-drawer__panel--xl--FlexBasis: 28.125rem;\n  --pf-c-drawer--m-panel-bottom__panel--md--MinHeight: 50%;\n  --pf-c-drawer--m-panel-bottom__panel--xl--MinHeight: 18.75rem;\n  --pf-c-drawer--m-panel-bottom__panel--xl--FlexBasis: 18.75rem;\n  --pf-c-drawer__panel--m-resizable--FlexDirection: row;\n  --pf-c-drawer__panel--m-resizable--md--FlexBasis--min: var(--pf-c-drawer__splitter--m-vertical--Width);\n  --pf-c-drawer__panel--m-resizable--MinWidth: 1.5rem;\n  --pf-c-drawer--m-panel-bottom__panel--m-resizable--FlexDirection: column;\n  --pf-c-drawer--m-panel-bottom__panel--m-resizable--md--FlexBasis--min: 1.5rem;\n  --pf-c-drawer--m-panel-bottom__panel--m-resizable--MinHeight: 1.5rem;\n  --pf-c-drawer--child--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--md--PaddingTop: var(--pf-global--spacer--lg);\n  --pf-c-drawer--child--md--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-drawer--child--md--PaddingBottom: var(--pf-global--spacer--lg);\n  --pf-c-drawer--child--md--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-drawer--child--m-padding--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--m-padding--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--m-padding--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--m-padding--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--m-padding--md--PaddingTop: var(--pf-global--spacer--lg);\n  --pf-c-drawer--child--m-padding--md--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-drawer--child--m-padding--md--PaddingBottom: var(--pf-global--spacer--lg);\n  --pf-c-drawer--child--m-padding--md--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-drawer__content--child--PaddingTop: 0;\n  --pf-c-drawer__content--child--PaddingRight: 0;\n  --pf-c-drawer__content--child--PaddingBottom: 0;\n  --pf-c-drawer__content--child--PaddingLeft: 0;\n  --pf-c-drawer__splitter--Height: 0.5625rem;\n  --pf-c-drawer__splitter--Width: 100%;\n  --pf-c-drawer__splitter--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-drawer__splitter--Cursor: row-resize;\n  --pf-c-drawer__splitter--m-vertical--Height: 100%;\n  --pf-c-drawer__splitter--m-vertical--Width: 0.5625rem;\n  --pf-c-drawer__splitter--m-vertical--Cursor: col-resize;\n  --pf-c-drawer--m-inline__splitter--focus--OutlineOffset: -0.0625rem;\n  --pf-c-drawer__splitter--after--BorderColor: var(--pf-global--BorderColor--100);\n  --pf-c-drawer__splitter--after--border-width--base: var(--pf-global--BorderWidth--sm);\n  --pf-c-drawer__splitter--after--BorderTopWidth: 0;\n  --pf-c-drawer__splitter--after--BorderRightWidth: var(--pf-c-drawer__splitter--after--border-width--base);\n  --pf-c-drawer__splitter--after--BorderBottomWidth: 0;\n  --pf-c-drawer__splitter--after--BorderLeftWidth: 0;\n  --pf-c-drawer--m-panel-left__splitter--after--BorderLeftWidth: var(--pf-c-drawer__splitter--after--border-width--base);\n  --pf-c-drawer--m-panel-bottom__splitter--after--BorderBottomWidth: var(--pf-c-drawer__splitter--after--border-width--base);\n  --pf-c-drawer--m-inline__splitter--m-vertical--Width: 0.625rem;\n  --pf-c-drawer--m-inline__splitter-handle--Left: 50%;\n  --pf-c-drawer--m-inline__splitter--after--BorderRightWidth: var(--pf-c-drawer__splitter--after--border-width--base);\n  --pf-c-drawer--m-inline__splitter--after--BorderLeftWidth: var(--pf-c-drawer__splitter--after--border-width--base);\n  --pf-c-drawer--m-inline--m-panel-bottom__splitter--Height: 0.625rem;\n  --pf-c-drawer--m-inline--m-panel-bottom__splitter-handle--Top: 50%;\n  --pf-c-drawer--m-inline--m-panel-bottom__splitter--after--BorderTopWidth: var(--pf-c-drawer__splitter--after--border-width--base);\n  --pf-c-drawer__splitter-handle--Top: 50%;\n  --pf-c-drawer__splitter-handle--Left: calc(50% - var(--pf-c-drawer__splitter--after--border-width--base));\n  --pf-c-drawer--m-panel-left__splitter-handle--Left: 50%;\n  --pf-c-drawer--m-panel-bottom__splitter-handle--Top: calc(50% - var(--pf-c-drawer__splitter--after--border-width--base));\n  --pf-c-drawer__splitter-handle--after--BorderColor: var(--pf-global--Color--200);\n  --pf-c-drawer__splitter-handle--after--BorderTopWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-drawer__splitter-handle--after--BorderRightWidth: 0;\n  --pf-c-drawer__splitter-handle--after--BorderBottomWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-drawer__splitter-handle--after--BorderLeftWidth: 0;\n  --pf-c-drawer__splitter--hover__splitter-handle--after--BorderColor: var(--pf-global--Color--100);\n  --pf-c-drawer__splitter--focus__splitter-handle--after--BorderColor: var(--pf-global--Color--100);\n  --pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderTopWidth: 0;\n  --pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderRightWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderBottomWidth: 0;\n  --pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderLeftWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-drawer__splitter-handle--after--Width: 0.75rem;\n  --pf-c-drawer__splitter-handle--after--Height: 0.25rem;\n  --pf-c-drawer__splitter--m-vertical__splitter-handle--after--Width: 0.25rem;\n  --pf-c-drawer__splitter--m-vertical__splitter-handle--after--Height: 0.75rem;\n  --pf-c-drawer__actions--MarginTop: calc(var(--pf-global--spacer--form-element) * -1);\n  --pf-c-drawer__actions--MarginRight: calc(var(--pf-global--spacer--form-element) * -1);\n  --pf-c-drawer__panel--BoxShadow: none;\n  --pf-c-drawer--m-expanded__panel--BoxShadow: var(--pf-global--BoxShadow--lg-left);\n  --pf-c-drawer--m-expanded--m-panel-left__panel--BoxShadow: var(--pf-global--BoxShadow--lg-right);\n  --pf-c-drawer--m-expanded--m-panel-bottom__panel--BoxShadow: var(--pf-global--BoxShadow--lg-top);\n  --pf-c-drawer__panel--after--Width: var(--pf-global--BorderWidth--sm);\n  --pf-c-drawer--m-panel-bottom__panel--after--Height: var(--pf-global--BorderWidth--sm);\n  --pf-c-drawer__panel--after--BackgroundColor: transparent;\n  --pf-c-drawer--m-inline--m-expanded__panel--after--BackgroundColor: var(--pf-global--BorderColor--100);\n  --pf-c-drawer--m-inline__panel--PaddingLeft: var(--pf-c-drawer__panel--after--Width);\n  --pf-c-drawer--m-panel-left--m-inline__panel--PaddingRight: var(--pf-c-drawer__panel--after--Width);\n  --pf-c-drawer--m-panel-bottom--m-inline__panel--PaddingTop: var(--pf-c-drawer__panel--after--Width);\n  display: flex;\n  flex-direction: column;\n  height: 100%;\n  overflow-x: hidden;\n}\n@media screen and (min-width: 768px) {\n  .pf-c-drawer {\n    --pf-c-drawer--child--PaddingTop: var(--pf-c-drawer--child--md--PaddingTop);\n    --pf-c-drawer--child--PaddingRight: var(--pf-c-drawer--child--md--PaddingRight);\n    --pf-c-drawer--child--PaddingBottom: var(--pf-c-drawer--child--md--PaddingBottom);\n    --pf-c-drawer--child--PaddingLeft: var(--pf-c-drawer--child--md--PaddingLeft);\n    --pf-c-drawer--child--m-padding--PaddingTop: var(--pf-c-drawer--child--m-padding--md--PaddingTop);\n    --pf-c-drawer--child--m-padding--PaddingRight: var(--pf-c-drawer--child--m-padding--md--PaddingRight);\n    --pf-c-drawer--child--m-padding--PaddingBottom: var(--pf-c-drawer--child--m-padding--md--PaddingBottom);\n    --pf-c-drawer--child--m-padding--PaddingLeft: var(--pf-c-drawer--child--m-padding--md--PaddingLeft);\n  }\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-drawer {\n    --pf-c-drawer__panel--MinWidth: var(--pf-c-drawer__panel--xl--MinWidth);\n  }\n  .pf-c-drawer.pf-m-panel-bottom {\n    --pf-c-drawer__panel--MinWidth: auto;\n    --pf-c-drawer__panel--MinHeight: var(--pf-c-drawer--m-panel-bottom__panel--xl--MinHeight);\n  }\n}\n.pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border, .pf-m-resizable), .pf-c-drawer.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border, .pf-m-resizable) {\n  padding-left: var(--pf-c-drawer--m-inline__panel--PaddingLeft);\n}\n.pf-c-drawer.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n  order: 0;\n  margin-right: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n  transform: translateX(-100%);\n}\n.pf-c-drawer.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__content {\n  order: 1;\n}\n.pf-c-drawer.pf-m-panel-bottom > .pf-c-drawer__main {\n  flex-direction: column;\n}\n.pf-c-drawer.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n  transform: translateX(-100%);\n}\n.pf-c-drawer.pf-m-expanded.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n  transform: translateX(0);\n}\n.pf-c-drawer.pf-m-expanded.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n  transform: translate(0, -100%);\n}\n.pf-c-drawer.pf-m-resizing {\n  --pf-c-drawer__panel--TransitionProperty: none;\n  pointer-events: none;\n}\n.pf-c-drawer.pf-m-resizing .pf-c-drawer__splitter {\n  pointer-events: auto;\n}\n\n.pf-c-drawer__section {\n  flex-grow: 0;\n  background-color: var(--pf-c-drawer__section--BackgroundColor);\n}\n.pf-c-drawer__section.pf-m-no-background {\n  --pf-c-drawer__section--BackgroundColor: transparent;\n}\n.pf-c-drawer__section.pf-m-light-200 {\n  --pf-c-drawer__section--BackgroundColor: var(--pf-c-drawer__section--m-light-200--BackgroundColor);\n}\n\n.pf-c-drawer__main {\n  display: flex;\n  flex: 1;\n  overflow: hidden;\n}\n\n.pf-c-drawer__content,\n.pf-c-drawer__panel,\n.pf-c-drawer__panel-main {\n  display: flex;\n  flex-direction: column;\n  flex-shrink: 0;\n  overflow: auto;\n}\n\n.pf-c-drawer__content {\n  z-index: var(--pf-c-drawer__content--ZIndex);\n  flex-basis: var(--pf-c-drawer__content--FlexBasis);\n  order: 0;\n  background-color: var(--pf-c-drawer__content--BackgroundColor);\n}\n.pf-c-drawer__content.pf-m-no-background {\n  --pf-c-drawer__content--BackgroundColor: transparent;\n}\n.pf-c-drawer__content.pf-m-light-200 {\n  --pf-c-drawer__content--BackgroundColor: var(--pf-c-drawer__content--m-light-200--BackgroundColor);\n}\n.pf-c-drawer__content > .pf-c-drawer__body {\n  padding: var(--pf-c-drawer__content--child--PaddingTop) var(--pf-c-drawer__content--child--PaddingRight) var(--pf-c-drawer__content--child--PaddingBottom) var(--pf-c-drawer__content--child--PaddingLeft);\n}\n\n.pf-c-drawer__panel {\n  position: relative;\n  z-index: var(--pf-c-drawer__panel--ZIndex);\n  flex-basis: var(--pf-c-drawer__panel--FlexBasis);\n  order: 1;\n  max-height: var(--pf-c-drawer__panel--MaxHeight);\n  overflow: auto;\n  background-color: var(--pf-c-drawer__panel--BackgroundColor);\n  box-shadow: var(--pf-c-drawer__panel--BoxShadow);\n  transition-duration: var(--pf-c-drawer__panel--TransitionDuration);\n  transition-property: var(--pf-c-drawer__panel--TransitionProperty);\n  -webkit-overflow-scrolling: touch;\n}\n.pf-c-drawer__panel::after {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: var(--pf-c-drawer__panel--after--Width);\n  height: 100%;\n  content: "";\n  background-color: var(--pf-c-drawer__panel--after--BackgroundColor);\n}\n.pf-c-drawer__panel.pf-m-no-background {\n  --pf-c-drawer__panel--BackgroundColor: transparent;\n}\n.pf-c-drawer__panel.pf-m-light-200 {\n  --pf-c-drawer__panel--BackgroundColor: var(--pf-c-drawer__panel--m-light-200--BackgroundColor);\n}\n@media screen and (min-width: 768px) {\n  .pf-c-drawer__panel {\n    --pf-c-drawer__panel--FlexBasis:\n      max(\n        var(--pf-c-drawer__panel--md--FlexBasis--min),\n        min(var(--pf-c-drawer__panel--md--FlexBasis), var(--pf-c-drawer__panel--md--FlexBasis--max))\n      );\n  }\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-drawer__panel {\n    --pf-c-drawer__panel--md--FlexBasis: var(--pf-c-drawer__panel--xl--FlexBasis);\n  }\n  .pf-c-drawer.pf-m-panel-bottom .pf-c-drawer__panel {\n    --pf-c-drawer__panel--md--FlexBasis: var(--pf-c-drawer--m-panel-bottom__panel--xl--FlexBasis);\n  }\n}\n\n.pf-c-drawer__panel-main {\n  flex-grow: 1;\n}\n\n@keyframes pf-remove-tab-focus {\n  to {\n    visibility: hidden;\n  }\n}\n.pf-c-drawer__panel[hidden] {\n  animation-name: pf-remove-tab-focus;\n  animation-delay: var(--pf-c-drawer__panel--TransitionDuration);\n  animation-fill-mode: forwards;\n}\n\n.pf-c-drawer__head {\n  display: grid;\n  grid-template-columns: auto;\n  grid-auto-columns: max-content;\n}\n.pf-c-drawer__head > * {\n  grid-column: 1;\n}\n\n.pf-c-drawer__actions {\n  grid-column: 2;\n  grid-row: 1;\n  display: flex;\n  align-self: baseline;\n  margin-top: var(--pf-c-drawer__actions--MarginTop);\n  margin-right: var(--pf-c-drawer__actions--MarginRight);\n}\n\n.pf-c-drawer__body {\n  min-height: 0;\n  padding: var(--pf-c-drawer--child--PaddingTop) var(--pf-c-drawer--child--PaddingRight) var(--pf-c-drawer--child--PaddingBottom) var(--pf-c-drawer--child--PaddingLeft);\n}\n.pf-c-drawer__body.pf-m-no-padding {\n  padding: 0;\n}\n.pf-c-drawer__body.pf-m-no-padding > .pf-c-drawer__actions,\n.pf-c-drawer__body.pf-m-no-padding > .pf-c-drawer__head > .pf-c-drawer__actions {\n  margin-top: 0;\n  margin-right: 0;\n}\n.pf-c-drawer__body.pf-m-padding {\n  padding: var(--pf-c-drawer--child--m-padding--PaddingTop) var(--pf-c-drawer--child--m-padding--PaddingRight) var(--pf-c-drawer--child--m-padding--PaddingBottom) var(--pf-c-drawer--child--m-padding--PaddingLeft);\n}\n.pf-c-drawer__body:not(.pf-m-no-padding) + * {\n  padding-top: 0;\n}\n.pf-c-drawer__body:last-child {\n  flex: 1 1;\n}\n\n.pf-c-drawer__body > .pf-c-page__main {\n  height: 100%;\n}\n\n.pf-c-drawer__splitter {\n  position: relative;\n  display: none;\n  width: var(--pf-c-drawer__splitter--Width);\n  height: var(--pf-c-drawer__splitter--Height);\n  cursor: var(--pf-c-drawer__splitter--Cursor);\n  visibility: hidden;\n  background-color: var(--pf-c-drawer__splitter--BackgroundColor);\n}\n.pf-c-drawer__splitter.pf-m-vertical {\n  --pf-c-drawer__splitter--Height: var(--pf-c-drawer__splitter--m-vertical--Height);\n  --pf-c-drawer__splitter--Width: var(--pf-c-drawer__splitter--m-vertical--Width);\n  --pf-c-drawer__splitter--Cursor: var(--pf-c-drawer__splitter--m-vertical--Cursor);\n  --pf-c-drawer__splitter-handle--after--Width: var(--pf-c-drawer__splitter--m-vertical__splitter-handle--after--Width);\n  --pf-c-drawer__splitter-handle--after--Height: var(--pf-c-drawer__splitter--m-vertical__splitter-handle--after--Height);\n  --pf-c-drawer__splitter-handle--after--BorderTopWidth: var(--pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderTopWidth);\n  --pf-c-drawer__splitter-handle--after--BorderRightWidth: var(--pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderRightWidth);\n  --pf-c-drawer__splitter-handle--after--BorderBottomWidth: var(--pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderBottomWidth);\n  --pf-c-drawer__splitter-handle--after--BorderLeftWidth: var(--pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderLeftWidth);\n}\n.pf-c-drawer__splitter:hover {\n  --pf-c-drawer__splitter-handle--after--BorderColor: var(--pf-c-drawer__splitter--hover__splitter-handle--after--BorderColor);\n}\n.pf-c-drawer__splitter:focus {\n  --pf-c-drawer__splitter-handle--after--BorderColor: var(--pf-c-drawer__splitter--focus__splitter-handle--after--BorderColor);\n}\n.pf-c-drawer__splitter::after {\n  position: absolute;\n  top: 0;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  content: "";\n  border: solid var(--pf-c-drawer__splitter--after--BorderColor);\n  border-width: var(--pf-c-drawer__splitter--after--BorderTopWidth) var(--pf-c-drawer__splitter--after--BorderRightWidth) var(--pf-c-drawer__splitter--after--BorderBottomWidth) var(--pf-c-drawer__splitter--after--BorderLeftWidth);\n}\n\n.pf-c-drawer__splitter-handle {\n  position: absolute;\n  top: var(--pf-c-drawer__splitter-handle--Top);\n  left: var(--pf-c-drawer__splitter-handle--Left);\n  transform: translate(-50%, -50%);\n}\n.pf-c-drawer__splitter-handle::after {\n  display: block;\n  width: var(--pf-c-drawer__splitter-handle--after--Width);\n  height: var(--pf-c-drawer__splitter-handle--after--Height);\n  content: "";\n  border-color: var(--pf-c-drawer__splitter-handle--after--BorderColor);\n  border-style: solid;\n  border-width: var(--pf-c-drawer__splitter-handle--after--BorderTopWidth) var(--pf-c-drawer__splitter-handle--after--BorderRightWidth) var(--pf-c-drawer__splitter-handle--after--BorderBottomWidth) var(--pf-c-drawer__splitter-handle--after--BorderLeftWidth);\n}\n\n@media screen and (min-width: 768px) {\n  .pf-c-drawer {\n    min-width: var(--pf-c-drawer__panel--MinWidth);\n  }\n  .pf-c-drawer.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    box-shadow: var(--pf-c-drawer--m-expanded__panel--BoxShadow);\n  }\n  .pf-c-drawer > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable {\n    --pf-c-drawer__panel--md--FlexBasis--min: var(--pf-c-drawer__panel--m-resizable--md--FlexBasis--min);\n    flex-direction: var(--pf-c-drawer__panel--m-resizable--FlexDirection);\n    min-width: var(--pf-c-drawer__panel--m-resizable--MinWidth);\n  }\n  .pf-c-drawer > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable::after {\n    width: 0;\n    height: 0;\n  }\n  .pf-c-drawer > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable > .pf-c-drawer__splitter {\n    flex-shrink: 0;\n  }\n  .pf-c-drawer > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable > .pf-c-drawer__panel-main {\n    flex-shrink: 1;\n  }\n  .pf-c-drawer.pf-m-panel-left {\n    --pf-c-drawer--m-expanded__panel--BoxShadow: var(--pf-c-drawer--m-expanded--m-panel-left__panel--BoxShadow);\n  }\n  .pf-c-drawer.pf-m-panel-left.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border, .pf-m-resizable), .pf-c-drawer.pf-m-panel-left.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border, .pf-m-resizable) {\n    padding-right: var(--pf-c-drawer--m-panel-left--m-inline__panel--PaddingRight);\n    padding-left: 0;\n  }\n  .pf-c-drawer.pf-m-panel-left.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel::after {\n    right: 0;\n    left: auto;\n  }\n  .pf-c-drawer.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable > .pf-c-drawer__splitter {\n    --pf-c-drawer__splitter-handle--Left: var(--pf-c-drawer--m-panel-left__splitter-handle--Left);\n    --pf-c-drawer__splitter--after--BorderRightWidth: 0;\n    --pf-c-drawer__splitter--after--BorderLeftWidth: var(--pf-c-drawer--m-panel-left__splitter--after--BorderLeftWidth);\n    order: 1;\n  }\n  .pf-c-drawer.pf-m-panel-bottom {\n    --pf-c-drawer--m-expanded__panel--BoxShadow: var(--pf-c-drawer--m-expanded--m-panel-bottom__panel--BoxShadow);\n    --pf-c-drawer__panel--MaxHeight: 100%;\n    --pf-c-drawer__panel--FlexBasis--min: var(--pf-c-drawer--m-panel-bottom__panel--FlexBasis--min);\n    min-width: auto;\n    min-height: var(--pf-c-drawer--m-panel-bottom__panel--md--MinHeight);\n  }\n  .pf-c-drawer.pf-m-panel-bottom.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border, .pf-m-resizable), .pf-c-drawer.pf-m-panel-bottom.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border, .pf-m-resizable) {\n    padding-top: var(--pf-c-drawer--m-panel-bottom--m-inline__panel--PaddingTop);\n    padding-left: 0;\n  }\n  .pf-c-drawer.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel::after {\n    top: 0;\n    left: auto;\n    width: 100%;\n    height: var(--pf-c-drawer--m-panel-bottom__panel--after--Height);\n  }\n  .pf-c-drawer.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable {\n    --pf-c-drawer__panel--md--FlexBasis--min: var(--pf-c-drawer--m-panel-bottom__panel--m-resizable--md--FlexBasis--min);\n    --pf-c-drawer__panel--m-resizable--FlexDirection: var(--pf-c-drawer--m-panel-bottom__panel--m-resizable--FlexDirection);\n    --pf-c-drawer__panel--m-resizable--MinWidth: 0;\n    min-height: var(--pf-c-drawer--m-panel-bottom__panel--m-resizable--MinHeight);\n  }\n  .pf-c-drawer.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable > .pf-c-drawer__splitter {\n    --pf-c-drawer__splitter-handle--Top: var(--pf-c-drawer--m-panel-bottom__splitter-handle--Top);\n    --pf-c-drawer__splitter--after--BorderRightWidth: 0;\n    --pf-c-drawer__splitter--after--BorderBottomWidth: var(--pf-c-drawer--m-panel-bottom__splitter--after--BorderBottomWidth);\n  }\n  .pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable > .pf-c-drawer__splitter {\n    --pf-c-drawer__splitter--m-vertical--Width: var(--pf-c-drawer--m-inline__splitter--m-vertical--Width);\n    --pf-c-drawer__splitter-handle--Left: var(--pf-c-drawer--m-inline__splitter-handle--Left);\n    --pf-c-drawer__splitter--after--BorderRightWidth: var(--pf-c-drawer--m-inline__splitter--after--BorderRightWidth);\n    --pf-c-drawer__splitter--after--BorderLeftWidth: var(--pf-c-drawer--m-inline__splitter--after--BorderLeftWidth);\n    outline-offset: var(--pf-c-drawer--m-inline__splitter--focus--OutlineOffset);\n  }\n  .pf-c-drawer.pf-m-inline.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable > .pf-c-drawer__splitter {\n    --pf-c-drawer__splitter--Height: var(--pf-c-drawer--m-inline--m-panel-bottom__splitter--Height);\n    --pf-c-drawer__splitter-handle--Top: var(--pf-c-drawer--m-inline--m-panel-bottom__splitter-handle--Top);\n    --pf-c-drawer__splitter--after--BorderTopWidth: var(--pf-c-drawer--m-inline--m-panel-bottom__splitter--after--BorderTopWidth);\n    --pf-c-drawer__splitter--after--BorderRightWidth: 0;\n    --pf-c-drawer__splitter--after--BorderLeftWidth: 0;\n  }\n  .pf-c-drawer > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-no-border,\n.pf-c-drawer.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-no-border {\n    --pf-c-drawer--m-expanded__panel--BoxShadow: none;\n  }\n  .pf-c-drawer__splitter {\n    display: block;\n    visibility: visible;\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-drawer__panel.pf-m-width-25 {\n    --pf-c-drawer__panel--md--FlexBasis: 25%;\n  }\n  .pf-c-drawer__panel.pf-m-width-33 {\n    --pf-c-drawer__panel--md--FlexBasis: 33%;\n  }\n  .pf-c-drawer__panel.pf-m-width-50 {\n    --pf-c-drawer__panel--md--FlexBasis: 50%;\n  }\n  .pf-c-drawer__panel.pf-m-width-66 {\n    --pf-c-drawer__panel--md--FlexBasis: 66%;\n  }\n  .pf-c-drawer__panel.pf-m-width-75 {\n    --pf-c-drawer__panel--md--FlexBasis: 75%;\n  }\n  .pf-c-drawer__panel.pf-m-width-100 {\n    --pf-c-drawer__panel--md--FlexBasis: 100%;\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-drawer__panel.pf-m-width-25-on-lg {\n    --pf-c-drawer__panel--md--FlexBasis: 25%;\n  }\n  .pf-c-drawer__panel.pf-m-width-33-on-lg {\n    --pf-c-drawer__panel--md--FlexBasis: 33%;\n  }\n  .pf-c-drawer__panel.pf-m-width-50-on-lg {\n    --pf-c-drawer__panel--md--FlexBasis: 50%;\n  }\n  .pf-c-drawer__panel.pf-m-width-66-on-lg {\n    --pf-c-drawer__panel--md--FlexBasis: 66%;\n  }\n  .pf-c-drawer__panel.pf-m-width-75-on-lg {\n    --pf-c-drawer__panel--md--FlexBasis: 75%;\n  }\n  .pf-c-drawer__panel.pf-m-width-100-on-lg {\n    --pf-c-drawer__panel--md--FlexBasis: 100%;\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-drawer__panel.pf-m-width-25-on-xl {\n    --pf-c-drawer__panel--md--FlexBasis: 25%;\n  }\n  .pf-c-drawer__panel.pf-m-width-33-on-xl {\n    --pf-c-drawer__panel--md--FlexBasis: 33%;\n  }\n  .pf-c-drawer__panel.pf-m-width-50-on-xl {\n    --pf-c-drawer__panel--md--FlexBasis: 50%;\n  }\n  .pf-c-drawer__panel.pf-m-width-66-on-xl {\n    --pf-c-drawer__panel--md--FlexBasis: 66%;\n  }\n  .pf-c-drawer__panel.pf-m-width-75-on-xl {\n    --pf-c-drawer__panel--md--FlexBasis: 75%;\n  }\n  .pf-c-drawer__panel.pf-m-width-100-on-xl {\n    --pf-c-drawer__panel--md--FlexBasis: 100%;\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-drawer__panel.pf-m-width-25-on-2xl {\n    --pf-c-drawer__panel--md--FlexBasis: 25%;\n  }\n  .pf-c-drawer__panel.pf-m-width-33-on-2xl {\n    --pf-c-drawer__panel--md--FlexBasis: 33%;\n  }\n  .pf-c-drawer__panel.pf-m-width-50-on-2xl {\n    --pf-c-drawer__panel--md--FlexBasis: 50%;\n  }\n  .pf-c-drawer__panel.pf-m-width-66-on-2xl {\n    --pf-c-drawer__panel--md--FlexBasis: 66%;\n  }\n  .pf-c-drawer__panel.pf-m-width-75-on-2xl {\n    --pf-c-drawer__panel--md--FlexBasis: 75%;\n  }\n  .pf-c-drawer__panel.pf-m-width-100-on-2xl {\n    --pf-c-drawer__panel--md--FlexBasis: 100%;\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__content,\n.pf-c-drawer.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__content {\n    flex-shrink: 1;\n  }\n  .pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel,\n.pf-c-drawer.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__panel {\n    --pf-c-drawer--m-expanded__panel--BoxShadow: none;\n  }\n  .pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after,\n.pf-c-drawer.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after {\n    background-color: var(--pf-c-drawer--m-inline--m-expanded__panel--after--BackgroundColor);\n  }\n  .pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__content {\n    overflow-x: auto;\n  }\n  .pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateX(100%);\n  }\n  .pf-c-drawer.pf-m-inline.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    margin-left: 0;\n    transform: translateX(-100%);\n  }\n  .pf-c-drawer.pf-m-inline.pf-m-panel-left.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateY(100%);\n  }\n  .pf-c-drawer.pf-m-inline.pf-m-panel-bottom.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: 0;\n    transform: translateY(0);\n  }\n  .pf-c-drawer.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: none;\n    visibility: hidden;\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-drawer.pf-m-inline-on-lg > .pf-c-drawer__main > .pf-c-drawer__content,\n.pf-c-drawer.pf-m-static-on-lg > .pf-c-drawer__main > .pf-c-drawer__content {\n    flex-shrink: 1;\n  }\n  .pf-c-drawer.pf-m-inline-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel,\n.pf-c-drawer.pf-m-static-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel {\n    --pf-c-drawer--m-expanded__panel--BoxShadow: none;\n  }\n  .pf-c-drawer.pf-m-inline-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after,\n.pf-c-drawer.pf-m-static-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after {\n    background-color: var(--pf-c-drawer--m-inline--m-expanded__panel--after--BackgroundColor);\n  }\n  .pf-c-drawer.pf-m-inline-on-lg > .pf-c-drawer__main > .pf-c-drawer__content {\n    overflow-x: auto;\n  }\n  .pf-c-drawer.pf-m-inline-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateX(100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-lg.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline-on-lg.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    margin-left: 0;\n    transform: translateX(-100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-lg.pf-m-panel-left.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline-on-lg.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline-on-lg.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateY(100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-lg.pf-m-panel-bottom.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: 0;\n    transform: translateY(0);\n  }\n  .pf-c-drawer.pf-m-static-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-lg.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-lg.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: none;\n    visibility: hidden;\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-drawer.pf-m-inline-on-xl > .pf-c-drawer__main > .pf-c-drawer__content,\n.pf-c-drawer.pf-m-static-on-xl > .pf-c-drawer__main > .pf-c-drawer__content {\n    flex-shrink: 1;\n  }\n  .pf-c-drawer.pf-m-inline-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel,\n.pf-c-drawer.pf-m-static-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel {\n    --pf-c-drawer--m-expanded__panel--BoxShadow: none;\n  }\n  .pf-c-drawer.pf-m-inline-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after,\n.pf-c-drawer.pf-m-static-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after {\n    background-color: var(--pf-c-drawer--m-inline--m-expanded__panel--after--BackgroundColor);\n  }\n  .pf-c-drawer.pf-m-inline-on-xl > .pf-c-drawer__main > .pf-c-drawer__content {\n    overflow-x: auto;\n  }\n  .pf-c-drawer.pf-m-inline-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateX(100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-xl.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline-on-xl.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    margin-left: 0;\n    transform: translateX(-100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-xl.pf-m-panel-left.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline-on-xl.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline-on-xl.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateY(100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-xl.pf-m-panel-bottom.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: 0;\n    transform: translateY(0);\n  }\n  .pf-c-drawer.pf-m-static-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-xl.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-xl.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: none;\n    visibility: hidden;\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-drawer.pf-m-inline-on-2xl > .pf-c-drawer__main > .pf-c-drawer__content,\n.pf-c-drawer.pf-m-static-on-2xl > .pf-c-drawer__main > .pf-c-drawer__content {\n    flex-shrink: 1;\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel,\n.pf-c-drawer.pf-m-static-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel {\n    --pf-c-drawer--m-expanded__panel--BoxShadow: none;\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after,\n.pf-c-drawer.pf-m-static-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after {\n    background-color: var(--pf-c-drawer--m-inline--m-expanded__panel--after--BackgroundColor);\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl > .pf-c-drawer__main > .pf-c-drawer__content {\n    overflow-x: auto;\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateX(100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    margin-left: 0;\n    transform: translateX(-100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl.pf-m-panel-left.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateY(100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl.pf-m-panel-bottom.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: 0;\n    transform: translateY(0);\n  }\n  .pf-c-drawer.pf-m-static-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-2xl.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-2xl.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: none;\n    visibility: hidden;\n  }\n}\n:where(.pf-theme-dark) .pf-c-drawer {\n  --pf-c-drawer__panel--BackgroundColor: var(--pf-global--BackgroundColor--400);\n  --pf-c-drawer__splitter--BackgroundColor: transparent;\n}\n:where(.pf-theme-dark) .pf-c-drawer.pf-m-inline, :where(.pf-theme-dark) .pf-c-drawer.pf-m-static {\n  --pf-c-drawer__panel--BackgroundColor: var(--pf-global--BackgroundColor--100);\n}';

// src/elements/utils/getRootStyle.ts
function getRootStyle(selector, element = document.documentElement) {
  return getComputedStyle(element, null).getPropertyValue(selector);
}

// node_modules/@open-wc/lit-helpers/src/spread.js
var SpreadPropsDirective = class extends f {
  constructor() {
    super(...arguments);
    this.prevData = {};
  }
  render(_spreadData) {
    return T;
  }
  update(part, [spreadData]) {
    var _a;
    if (this.element !== part.element) {
      this.element = part.element;
    }
    this.host = ((_a = part.options) === null || _a === void 0 ? void 0 : _a.host) || this.element;
    this.apply(spreadData);
    this.groom(spreadData);
    this.prevData = { ...spreadData };
  }
  apply(data) {
    if (!data)
      return;
    const { prevData, element } = this;
    for (const key in data) {
      const value = data[key];
      if (value === prevData[key]) {
        continue;
      }
      element[key] = value;
    }
  }
  groom(data) {
    const { prevData, element } = this;
    if (!prevData)
      return;
    for (const key in prevData) {
      if (!data || !(key in data) && element[key] === prevData[key]) {
        element[key] = void 0;
      }
    }
  }
};
var spreadProps = e(SpreadPropsDirective);
var SpreadEventsDirective = class extends SpreadPropsDirective {
  constructor() {
    super(...arguments);
    this.eventData = {};
  }
  apply(data) {
    if (!data)
      return;
    for (const key in data) {
      const value = data[key];
      if (value === this.eventData[key]) {
        continue;
      }
      this.applyEvent(key, value);
    }
  }
  applyEvent(eventName, eventValue) {
    const { prevData, element } = this;
    this.eventData[eventName] = eventValue;
    const prevHandler = prevData[eventName];
    if (prevHandler) {
      element.removeEventListener(eventName, this, eventValue);
    }
    element.addEventListener(eventName, this, eventValue);
  }
  groom(data) {
    const { prevData, element } = this;
    if (!prevData)
      return;
    for (const key in prevData) {
      if (!data || !(key in data) && element[key] === prevData[key]) {
        this.groomEvent(key, prevData[key]);
      }
    }
  }
  groomEvent(eventName, eventValue) {
    const { element } = this;
    delete this.eventData[eventName];
    element.removeEventListener(eventName, this, eventValue);
  }
  handleEvent(event) {
    const value = this.eventData[event.type];
    if (typeof value === "function") {
      value.call(this.host, event);
    } else {
      value.handleEvent(event);
    }
  }
  disconnected() {
    const { eventData, element } = this;
    for (const key in eventData) {
      const name = key.slice(1);
      const value = eventData[key];
      element.removeEventListener(name, this, value);
    }
  }
  reconnected() {
    const { eventData, element } = this;
    for (const key in eventData) {
      const name = key.slice(1);
      const value = eventData[key];
      element.addEventListener(name, this, value);
    }
  }
};
var spreadEvents = e(SpreadEventsDirective);
var SpreadDirective = class extends SpreadEventsDirective {
  apply(data) {
    if (!data)
      return;
    const { prevData, element } = this;
    for (const key in data) {
      const value = data[key];
      if (value === prevData[key]) {
        continue;
      }
      const name = key.slice(1);
      switch (key[0]) {
        case "@":
          this.eventData[name] = value;
          this.applyEvent(name, value);
          break;
        case ".":
          element[name] = value;
          break;
        case "?":
          if (value) {
            element.setAttribute(name, "");
          } else {
            element.removeAttribute(name);
          }
          break;
        default:
          if (value != null) {
            element.setAttribute(key, String(value));
          } else {
            element.removeAttribute(key);
          }
          break;
      }
    }
  }
  groom(data) {
    const { prevData, element } = this;
    if (!prevData)
      return;
    for (const key in prevData) {
      const name = key.slice(1);
      if (!data || !(key in data) && element[name] === prevData[key]) {
        switch (key[0]) {
          case "@":
            this.groomEvent(name, prevData[key]);
            break;
          case ".":
            element[name] = void 0;
            break;
          case "?":
            element.removeAttribute(name);
            break;
          default:
            element.removeAttribute(key);
            break;
        }
      }
    }
  }
};
var spread = e(SpreadDirective);

// src/admin/AdminInterface/AdminSidebar.ts
var AkAdminSidebar = class extends WithCapabilitiesConfig(AKElement) {
  constructor() {
    super();
    this.open = true;
    this.version = null;
    this.impersonation = null;
    new AdminApi(DEFAULT_CONFIG).adminVersionRetrieve().then((version) => {
      this.version = version.versionCurrent;
    });
    me().then((user) => {
      this.impersonation = user.original ? user.user.username : null;
    });
    this.toggleOpen = this.toggleOpen.bind(this);
    this.checkWidth = this.checkWidth.bind(this);
  }
  // This has to be a bound method so the event listener can be removed on disconnection as
  // needed.
  toggleOpen() {
    this.open = !this.open;
  }
  checkWidth() {
    const minWidth = parseFloat(getRootStyle("--ak-sidebar--minimum-auto-width")) * parseFloat(getRootStyle("font-size"));
    this.open = window.innerWidth >= minWidth;
  }
  connectedCallback() {
    super.connectedCallback();
    window.addEventListener(EVENT_SIDEBAR_TOGGLE, this.toggleOpen);
    window.addEventListener("resize", this.checkWidth);
    this.checkWidth();
  }
  // The symmetry (☟, ☝) here is critical in that you want to start adding these handlers after
  // connection, and removing them before disconnection.
  disconnectedCallback() {
    window.removeEventListener(EVENT_SIDEBAR_TOGGLE, this.toggleOpen);
    window.removeEventListener("resize", this.checkWidth);
    super.disconnectedCallback();
  }
  render() {
    return x`
            <ak-sidebar
                class="pf-c-page__sidebar ${this.open ? "pf-m-expanded" : "pf-m-collapsed"} ${this.activeTheme === UiThemeEnum.Light ? "pf-m-light" : ""}"
            >
                ${this.renderSidebarItems()}
            </ak-sidebar>
        `;
  }
  updated() {
    this.classList.remove("pf-m-expanded", "pf-m-collapsed");
    this.classList.add(this.open ? "pf-m-expanded" : "pf-m-collapsed");
  }
  renderSidebarItems() {
    const sidebarContent = [
      ["/if/user/", msg("User interface"), { "?isAbsoluteLink": true, "?highlight": true }],
      [null, msg("Dashboards"), { "?expanded": true }, [
        ["/administration/overview", msg("Overview")],
        ["/administration/dashboard/users", msg("User Statistics")],
        ["/administration/system-tasks", msg("System Tasks")]
      ]],
      [null, msg("Applications"), null, [
        ["/core/applications", msg("Applications"), [`^/core/applications/(?<slug>${SLUG_REGEX})$`]],
        ["/core/providers", msg("Providers"), [`^/core/providers/(?<id>${ID_REGEX})$`]],
        ["/outpost/outposts", msg("Outposts")]
      ]],
      [null, msg("Events"), null, [
        ["/events/log", msg("Logs"), [`^/events/log/(?<id>${UUID_REGEX})$`]],
        ["/events/rules", msg("Notification Rules")],
        ["/events/transports", msg("Notification Transports")]
      ]],
      [null, msg("Customization"), null, [
        ["/policy/policies", msg("Policies")],
        ["/core/property-mappings", msg("Property Mappings")],
        ["/blueprints/instances", msg("Blueprints")],
        ["/policy/reputation", msg("Reputation scores")]
      ]],
      [null, msg("Flows and Stages"), null, [
        ["/flow/flows", msg("Flows"), [`^/flow/flows/(?<slug>${SLUG_REGEX})$`]],
        ["/flow/stages", msg("Stages")],
        ["/flow/stages/prompts", msg("Prompts")]
      ]],
      [null, msg("Directory"), null, [
        ["/identity/users", msg("Users"), [`^/identity/users/(?<id>${ID_REGEX})$`]],
        ["/identity/groups", msg("Groups"), [`^/identity/groups/(?<id>${UUID_REGEX})$`]],
        ["/identity/roles", msg("Roles"), [`^/identity/roles/(?<id>${UUID_REGEX})$`]],
        ["/core/sources", msg("Federation and Social login"), [`^/core/sources/(?<slug>${SLUG_REGEX})$`]],
        ["/core/tokens", msg("Tokens and App passwords")],
        ["/flow/stages/invitations", msg("Invitations")]
      ]],
      [null, msg("System"), null, [
        ["/core/brands", msg("Brands")],
        ["/crypto/certificates", msg("Certificates")],
        ["/outpost/integrations", msg("Outpost Integrations")],
        ["/admin/settings", msg("Settings")]
      ]]
    ];
    const renderOneSidebarItem = ([path, label, attributes, children]) => {
      const properties = Array.isArray(attributes) ? { ".activeWhen": attributes } : attributes ?? {};
      if (path) {
        properties["path"] = path;
      }
      return x`<ak-sidebar-item ${spread(properties)}>
                ${label ? x`<span slot="label">${label}</span>` : T}
                ${o2(children, renderOneSidebarItem)}
            </ak-sidebar-item>`;
    };
    return x`
            ${this.renderNewVersionMessage()}
            ${this.renderImpersonationMessage()}
            ${o2(sidebarContent, renderOneSidebarItem)}
            ${this.renderEnterpriseMenu()}
        `;
  }
  renderNewVersionMessage() {
    return this.version && this.version !== VERSION ? x`
                  <ak-sidebar-item ?highlight=${true}>
                      <span slot="label"
                          >${msg("A newer version of the frontend is available.")}</span
                      >
                  </ak-sidebar-item>
              ` : T;
  }
  renderImpersonationMessage() {
    const reload = () => new CoreApi(DEFAULT_CONFIG).coreUsersImpersonateEndRetrieve().then(() => {
      window.location.reload();
    });
    return this.impersonation ? x`<ak-sidebar-item ?highlight=${true} @click=${reload}>
                  <span slot="label"
                      >${msg(
      str`You're currently impersonating ${this.impersonation}. Click to stop.`
    )}</span
                  >
              </ak-sidebar-item>` : T;
  }
  renderEnterpriseMenu() {
    return this.can(CapabilitiesEnum.IsEnterprise) ? x`
                  <ak-sidebar-item>
                      <span slot="label">${msg("Enterprise")}</span>
                      <ak-sidebar-item path="/enterprise/licenses">
                          <span slot="label">${msg("Licenses")}</span>
                      </ak-sidebar-item>
                  </ak-sidebar-item>
              ` : T;
  }
};
__decorateClass([
  n({ type: Boolean, reflect: true })
], AkAdminSidebar.prototype, "open", 2);
__decorateClass([
  r()
], AkAdminSidebar.prototype, "version", 2);
__decorateClass([
  r()
], AkAdminSidebar.prototype, "impersonation", 2);
AkAdminSidebar = __decorateClass([
  t("ak-admin-sidebar")
], AkAdminSidebar);

// src/admin/AdminInterface/AdminInterface.ts
var AdminInterface = class extends EnterpriseAwareInterface {
  constructor() {
    super();
    this.notificationDrawerOpen = getURLParam("notificationDrawerOpen", false);
    this.apiDrawerOpen = getURLParam("apiDrawerOpen", false);
    this.ws = new WebsocketClient();
    window.addEventListener(EVENT_NOTIFICATION_DRAWER_TOGGLE, () => {
      this.notificationDrawerOpen = !this.notificationDrawerOpen;
      updateURLParams({
        notificationDrawerOpen: this.notificationDrawerOpen
      });
    });
    window.addEventListener(EVENT_API_DRAWER_TOGGLE, () => {
      this.apiDrawerOpen = !this.apiDrawerOpen;
      updateURLParams({
        apiDrawerOpen: this.apiDrawerOpen
      });
    });
  }
  static get styles() {
    return [
      patternfly_base_default,
      page_default,
      button_default,
      drawer_default,
      i`
                .pf-c-page__main,
                .pf-c-drawer__content,
                .pf-c-page__drawer {
                    z-index: auto !important;
                    background-color: transparent;
                }
                .display-none {
                    display: none;
                }
                .pf-c-page {
                    background-color: var(--pf-c-page--BackgroundColor) !important;
                }
                /* Global page background colour */
                :host([theme="dark"]) .pf-c-page {
                    --pf-c-page--BackgroundColor: var(--ak-dark-background);
                }
            `
    ];
  }
  async firstUpdated() {
    configureSentry(true);
    this.version = await new AdminApi(DEFAULT_CONFIG).adminVersionRetrieve();
    this.user = await me();
    const canAccessAdmin = this.user.user.isSuperuser || // TODO: somehow add `access_admin_interface` to the API schema
    this.user.user.systemPermissions.includes("access_admin_interface");
    if (!canAccessAdmin && this.user.user.pk > 0) {
      window.location.assign("/if/user/");
    }
  }
  render() {
    const sidebarClasses = {
      "pf-m-light": this.activeTheme === UiThemeEnum.Light
    };
    const drawerOpen = this.notificationDrawerOpen || this.apiDrawerOpen;
    const drawerClasses = {
      "pf-m-expanded": drawerOpen,
      "pf-m-collapsed": !drawerOpen
    };
    return x` <ak-locale-context>
            <div class="pf-c-page">
                <ak-admin-sidebar
                    class="pf-c-page__sidebar ${e2(sidebarClasses)}"
                ></ak-admin-sidebar>
                <div class="pf-c-page__drawer">
                    <div class="pf-c-drawer ${e2(drawerClasses)}">
                        <div class="pf-c-drawer__main">
                            <div class="pf-c-drawer__content">
                                <div class="pf-c-drawer__body">
                                    <main class="pf-c-page__main">
                                        <ak-router-outlet
                                            role="main"
                                            class="pf-c-page__main"
                                            tabindex="-1"
                                            id="main-content"
                                            defaultUrl="/administration/overview"
                                            .routes=${ROUTES}
                                        >
                                        </ak-router-outlet>
                                    </main>
                                </div>
                            </div>
                            <ak-notification-drawer
                                class="pf-c-drawer__panel pf-m-width-33 ${this.notificationDrawerOpen ? "" : "display-none"}"
                                ?hidden=${!this.notificationDrawerOpen}
                            ></ak-notification-drawer>
                            <ak-api-drawer
                                class="pf-c-drawer__panel pf-m-width-33 ${this.apiDrawerOpen ? "" : "display-none"}"
                                ?hidden=${!this.apiDrawerOpen}
                            ></ak-api-drawer>
                        </div>
                    </div>
                </div></div
        ></ak-locale-context>`;
  }
};
__decorateClass([
  n({ type: Boolean })
], AdminInterface.prototype, "notificationDrawerOpen", 2);
__decorateClass([
  n({ type: Boolean })
], AdminInterface.prototype, "apiDrawerOpen", 2);
__decorateClass([
  r()
], AdminInterface.prototype, "version", 2);
__decorateClass([
  r()
], AdminInterface.prototype, "user", 2);
AdminInterface = __decorateClass([
  t("ak-interface-admin")
], AdminInterface);
export {
  AdminInterface
};
//# sourceMappingURL=AdminInterface.js.map
