import {
  UserSettingFromJSON
} from "./chunk-X5TC2QXY.js";
import {
  DeniedActionEnumToJSON,
  FlowDesignationEnumToJSON,
  FlowFromJSON,
  FlowLayoutEnumToJSON,
  FlowSetFromJSON,
  PromptChallengeFromJSON,
  PromptTypeEnumFromJSON,
  PromptTypeEnumToJSON,
  StageFromJSON
} from "./chunk-OATKFZXF.js";
import {
  BaseAPI,
  GroupMemberFromJSON,
  JSONApiResponse,
  PaginationFromJSON,
  PolicyEngineModeToJSON,
  RequiredError,
  TypeCreateFromJSON,
  UsedByFromJSON,
  UserTypeEnumFromJSON,
  UserTypeEnumToJSON,
  VoidApiResponse,
  exists
} from "./chunk-EOF5OWT7.js";

// node_modules/@goauthentik/api/dist/esm/models/AuthTypeEnum.js
var AuthTypeEnum = {
  Basic: "basic",
  Bearer: "bearer",
  UnknownDefaultOpenApi: "11184809"
};
function AuthTypeEnumFromJSON(json) {
  return AuthTypeEnumFromJSONTyped(json, false);
}
function AuthTypeEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function AuthTypeEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorAttachmentEnum.js
var AuthenticatorAttachmentEnum = {
  Platform: "platform",
  CrossPlatform: "cross-platform",
  UnknownDefaultOpenApi: "11184809"
};
function AuthenticatorAttachmentEnumFromJSON(json) {
  return AuthenticatorAttachmentEnumFromJSONTyped(json, false);
}
function AuthenticatorAttachmentEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function AuthenticatorAttachmentEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorDuoStage.js
function AuthenticatorDuoStageFromJSON(json) {
  return AuthenticatorDuoStageFromJSONTyped(json, false);
}
function AuthenticatorDuoStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "configureFlow": !exists(json, "configure_flow") ? void 0 : json["configure_flow"],
    "friendlyName": !exists(json, "friendly_name") ? void 0 : json["friendly_name"],
    "clientId": json["client_id"],
    "apiHostname": json["api_hostname"],
    "adminIntegrationKey": !exists(json, "admin_integration_key") ? void 0 : json["admin_integration_key"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorDuoStageDeviceImportResponse.js
function AuthenticatorDuoStageDeviceImportResponseFromJSON(json) {
  return AuthenticatorDuoStageDeviceImportResponseFromJSONTyped(json, false);
}
function AuthenticatorDuoStageDeviceImportResponseFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "count": json["count"],
    "error": json["error"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorDuoStageManualDeviceImportRequest.js
function AuthenticatorDuoStageManualDeviceImportRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "duo_user_id": value.duoUserId,
    "username": value.username
  };
}

// node_modules/@goauthentik/api/dist/esm/models/FlowSetRequest.js
function FlowSetRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "slug": value.slug,
    "title": value.title,
    "designation": FlowDesignationEnumToJSON(value.designation),
    "policy_engine_mode": PolicyEngineModeToJSON(value.policyEngineMode),
    "compatibility_mode": value.compatibilityMode,
    "layout": FlowLayoutEnumToJSON(value.layout),
    "denied_action": DeniedActionEnumToJSON(value.deniedAction)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorDuoStageRequest.js
function AuthenticatorDuoStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "configure_flow": value.configureFlow,
    "friendly_name": value.friendlyName,
    "client_id": value.clientId,
    "client_secret": value.clientSecret,
    "api_hostname": value.apiHostname,
    "admin_integration_key": value.adminIntegrationKey,
    "admin_secret_key": value.adminSecretKey
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ProviderEnum.js
var ProviderEnum = {
  Twilio: "twilio",
  Generic: "generic",
  UnknownDefaultOpenApi: "11184809"
};
function ProviderEnumFromJSON(json) {
  return ProviderEnumFromJSONTyped(json, false);
}
function ProviderEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function ProviderEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorSMSStage.js
function AuthenticatorSMSStageFromJSON(json) {
  return AuthenticatorSMSStageFromJSONTyped(json, false);
}
function AuthenticatorSMSStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "configureFlow": !exists(json, "configure_flow") ? void 0 : json["configure_flow"],
    "friendlyName": !exists(json, "friendly_name") ? void 0 : json["friendly_name"],
    "provider": ProviderEnumFromJSON(json["provider"]),
    "fromNumber": json["from_number"],
    "accountSid": json["account_sid"],
    "auth": json["auth"],
    "authPassword": !exists(json, "auth_password") ? void 0 : json["auth_password"],
    "authType": !exists(json, "auth_type") ? void 0 : AuthTypeEnumFromJSON(json["auth_type"]),
    "verifyOnly": !exists(json, "verify_only") ? void 0 : json["verify_only"],
    "mapping": !exists(json, "mapping") ? void 0 : json["mapping"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorSMSStageRequest.js
function AuthenticatorSMSStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "configure_flow": value.configureFlow,
    "friendly_name": value.friendlyName,
    "provider": ProviderEnumToJSON(value.provider),
    "from_number": value.fromNumber,
    "account_sid": value.accountSid,
    "auth": value.auth,
    "auth_password": value.authPassword,
    "auth_type": AuthTypeEnumToJSON(value.authType),
    "verify_only": value.verifyOnly,
    "mapping": value.mapping
  };
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorStaticStage.js
function AuthenticatorStaticStageFromJSON(json) {
  return AuthenticatorStaticStageFromJSONTyped(json, false);
}
function AuthenticatorStaticStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "configureFlow": !exists(json, "configure_flow") ? void 0 : json["configure_flow"],
    "friendlyName": !exists(json, "friendly_name") ? void 0 : json["friendly_name"],
    "tokenCount": !exists(json, "token_count") ? void 0 : json["token_count"],
    "tokenLength": !exists(json, "token_length") ? void 0 : json["token_length"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorStaticStageRequest.js
function AuthenticatorStaticStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "configure_flow": value.configureFlow,
    "friendly_name": value.friendlyName,
    "token_count": value.tokenCount,
    "token_length": value.tokenLength
  };
}

// node_modules/@goauthentik/api/dist/esm/models/DigitsEnum.js
var DigitsEnum = {
  _6: "6",
  _8: "8",
  UnknownDefaultOpenApi: "11184809"
};
function DigitsEnumFromJSON(json) {
  return DigitsEnumFromJSONTyped(json, false);
}
function DigitsEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function DigitsEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorTOTPStage.js
function AuthenticatorTOTPStageFromJSON(json) {
  return AuthenticatorTOTPStageFromJSONTyped(json, false);
}
function AuthenticatorTOTPStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "configureFlow": !exists(json, "configure_flow") ? void 0 : json["configure_flow"],
    "friendlyName": !exists(json, "friendly_name") ? void 0 : json["friendly_name"],
    "digits": DigitsEnumFromJSON(json["digits"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorTOTPStageRequest.js
function AuthenticatorTOTPStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "configure_flow": value.configureFlow,
    "friendly_name": value.friendlyName,
    "digits": DigitsEnumToJSON(value.digits)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/DeviceClassesEnum.js
var DeviceClassesEnum = {
  Static: "static",
  Totp: "totp",
  Webauthn: "webauthn",
  Duo: "duo",
  Sms: "sms",
  UnknownDefaultOpenApi: "11184809"
};
function DeviceClassesEnumFromJSON(json) {
  return DeviceClassesEnumFromJSONTyped(json, false);
}
function DeviceClassesEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function DeviceClassesEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/NotConfiguredActionEnum.js
var NotConfiguredActionEnum = {
  Skip: "skip",
  Deny: "deny",
  Configure: "configure",
  UnknownDefaultOpenApi: "11184809"
};
function NotConfiguredActionEnumFromJSON(json) {
  return NotConfiguredActionEnumFromJSONTyped(json, false);
}
function NotConfiguredActionEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function NotConfiguredActionEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/UserVerificationEnum.js
var UserVerificationEnum = {
  Required: "required",
  Preferred: "preferred",
  Discouraged: "discouraged",
  UnknownDefaultOpenApi: "11184809"
};
function UserVerificationEnumFromJSON(json) {
  return UserVerificationEnumFromJSONTyped(json, false);
}
function UserVerificationEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function UserVerificationEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/WebAuthnDeviceType.js
function WebAuthnDeviceTypeFromJSON(json) {
  return WebAuthnDeviceTypeFromJSONTyped(json, false);
}
function WebAuthnDeviceTypeFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "aaguid": json["aaguid"],
    "description": json["description"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorValidateStage.js
function AuthenticatorValidateStageFromJSON(json) {
  return AuthenticatorValidateStageFromJSONTyped(json, false);
}
function AuthenticatorValidateStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "notConfiguredAction": !exists(json, "not_configured_action") ? void 0 : NotConfiguredActionEnumFromJSON(json["not_configured_action"]),
    "deviceClasses": !exists(json, "device_classes") ? void 0 : json["device_classes"].map(DeviceClassesEnumFromJSON),
    "configurationStages": !exists(json, "configuration_stages") ? void 0 : json["configuration_stages"],
    "lastAuthThreshold": !exists(json, "last_auth_threshold") ? void 0 : json["last_auth_threshold"],
    "webauthnUserVerification": !exists(json, "webauthn_user_verification") ? void 0 : UserVerificationEnumFromJSON(json["webauthn_user_verification"]),
    "webauthnAllowedDeviceTypes": !exists(json, "webauthn_allowed_device_types") ? void 0 : json["webauthn_allowed_device_types"],
    "webauthnAllowedDeviceTypesObj": json["webauthn_allowed_device_types_obj"].map(WebAuthnDeviceTypeFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorValidateStageRequest.js
function AuthenticatorValidateStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "not_configured_action": NotConfiguredActionEnumToJSON(value.notConfiguredAction),
    "device_classes": value.deviceClasses === void 0 ? void 0 : value.deviceClasses.map(DeviceClassesEnumToJSON),
    "configuration_stages": value.configurationStages,
    "last_auth_threshold": value.lastAuthThreshold,
    "webauthn_user_verification": UserVerificationEnumToJSON(value.webauthnUserVerification),
    "webauthn_allowed_device_types": value.webauthnAllowedDeviceTypes
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ResidentKeyRequirementEnum.js
var ResidentKeyRequirementEnum = {
  Discouraged: "discouraged",
  Preferred: "preferred",
  Required: "required",
  UnknownDefaultOpenApi: "11184809"
};
function ResidentKeyRequirementEnumFromJSON(json) {
  return ResidentKeyRequirementEnumFromJSONTyped(json, false);
}
function ResidentKeyRequirementEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function ResidentKeyRequirementEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorWebAuthnStage.js
function AuthenticatorWebAuthnStageFromJSON(json) {
  return AuthenticatorWebAuthnStageFromJSONTyped(json, false);
}
function AuthenticatorWebAuthnStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "configureFlow": !exists(json, "configure_flow") ? void 0 : json["configure_flow"],
    "friendlyName": !exists(json, "friendly_name") ? void 0 : json["friendly_name"],
    "userVerification": !exists(json, "user_verification") ? void 0 : UserVerificationEnumFromJSON(json["user_verification"]),
    "authenticatorAttachment": !exists(json, "authenticator_attachment") ? void 0 : AuthenticatorAttachmentEnumFromJSON(json["authenticator_attachment"]),
    "residentKeyRequirement": !exists(json, "resident_key_requirement") ? void 0 : ResidentKeyRequirementEnumFromJSON(json["resident_key_requirement"]),
    "deviceTypeRestrictions": !exists(json, "device_type_restrictions") ? void 0 : json["device_type_restrictions"],
    "deviceTypeRestrictionsObj": json["device_type_restrictions_obj"].map(WebAuthnDeviceTypeFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticatorWebAuthnStageRequest.js
function AuthenticatorWebAuthnStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "configure_flow": value.configureFlow,
    "friendly_name": value.friendlyName,
    "user_verification": UserVerificationEnumToJSON(value.userVerification),
    "authenticator_attachment": AuthenticatorAttachmentEnumToJSON(value.authenticatorAttachment),
    "resident_key_requirement": ResidentKeyRequirementEnumToJSON(value.residentKeyRequirement),
    "device_type_restrictions": value.deviceTypeRestrictions
  };
}

// node_modules/@goauthentik/api/dist/esm/models/BackendsEnum.js
var BackendsEnum = {
  CoreAuthInbuiltBackend: "authentik.core.auth.InbuiltBackend",
  CoreAuthTokenBackend: "authentik.core.auth.TokenBackend",
  SourcesLdapAuthLdapBackend: "authentik.sources.ldap.auth.LDAPBackend",
  UnknownDefaultOpenApi: "11184809"
};
function BackendsEnumFromJSON(json) {
  return BackendsEnumFromJSONTyped(json, false);
}
function BackendsEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function BackendsEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/CaptchaStage.js
function CaptchaStageFromJSON(json) {
  return CaptchaStageFromJSONTyped(json, false);
}
function CaptchaStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "publicKey": json["public_key"],
    "jsUrl": !exists(json, "js_url") ? void 0 : json["js_url"],
    "apiUrl": !exists(json, "api_url") ? void 0 : json["api_url"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/CaptchaStageRequest.js
function CaptchaStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "public_key": value.publicKey,
    "private_key": value.privateKey,
    "js_url": value.jsUrl,
    "api_url": value.apiUrl
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ConsentStageModeEnum.js
var ConsentStageModeEnum = {
  AlwaysRequire: "always_require",
  Permanent: "permanent",
  Expiring: "expiring",
  UnknownDefaultOpenApi: "11184809"
};
function ConsentStageModeEnumFromJSON(json) {
  return ConsentStageModeEnumFromJSONTyped(json, false);
}
function ConsentStageModeEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function ConsentStageModeEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/ConsentStage.js
function ConsentStageFromJSON(json) {
  return ConsentStageFromJSONTyped(json, false);
}
function ConsentStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "mode": !exists(json, "mode") ? void 0 : ConsentStageModeEnumFromJSON(json["mode"]),
    "consentExpireIn": !exists(json, "consent_expire_in") ? void 0 : json["consent_expire_in"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ConsentStageRequest.js
function ConsentStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "mode": ConsentStageModeEnumToJSON(value.mode),
    "consent_expire_in": value.consentExpireIn
  };
}

// node_modules/@goauthentik/api/dist/esm/models/DenyStage.js
function DenyStageFromJSON(json) {
  return DenyStageFromJSONTyped(json, false);
}
function DenyStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "denyMessage": !exists(json, "deny_message") ? void 0 : json["deny_message"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/DenyStageRequest.js
function DenyStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "deny_message": value.denyMessage
  };
}

// node_modules/@goauthentik/api/dist/esm/models/DummyStage.js
function DummyStageFromJSON(json) {
  return DummyStageFromJSONTyped(json, false);
}
function DummyStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "throwError": !exists(json, "throw_error") ? void 0 : json["throw_error"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/DummyStageRequest.js
function DummyStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "throw_error": value.throwError
  };
}

// node_modules/@goauthentik/api/dist/esm/models/DuoResponseEnum.js
function DuoResponseEnumFromJSON(json) {
  return DuoResponseEnumFromJSONTyped(json, false);
}
function DuoResponseEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}

// node_modules/@goauthentik/api/dist/esm/models/DuoDeviceEnrollmentStatus.js
function DuoDeviceEnrollmentStatusFromJSON(json) {
  return DuoDeviceEnrollmentStatusFromJSONTyped(json, false);
}
function DuoDeviceEnrollmentStatusFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "duoResponse": DuoResponseEnumFromJSON(json["duo_response"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/EmailStage.js
function EmailStageFromJSON(json) {
  return EmailStageFromJSONTyped(json, false);
}
function EmailStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "useGlobalSettings": !exists(json, "use_global_settings") ? void 0 : json["use_global_settings"],
    "host": !exists(json, "host") ? void 0 : json["host"],
    "port": !exists(json, "port") ? void 0 : json["port"],
    "username": !exists(json, "username") ? void 0 : json["username"],
    "useTls": !exists(json, "use_tls") ? void 0 : json["use_tls"],
    "useSsl": !exists(json, "use_ssl") ? void 0 : json["use_ssl"],
    "timeout": !exists(json, "timeout") ? void 0 : json["timeout"],
    "fromAddress": !exists(json, "from_address") ? void 0 : json["from_address"],
    "tokenExpiry": !exists(json, "token_expiry") ? void 0 : json["token_expiry"],
    "subject": !exists(json, "subject") ? void 0 : json["subject"],
    "template": !exists(json, "template") ? void 0 : json["template"],
    "activateUserOnSuccess": !exists(json, "activate_user_on_success") ? void 0 : json["activate_user_on_success"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/EmailStageRequest.js
function EmailStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "use_global_settings": value.useGlobalSettings,
    "host": value.host,
    "port": value.port,
    "username": value.username,
    "password": value.password,
    "use_tls": value.useTls,
    "use_ssl": value.useSsl,
    "timeout": value.timeout,
    "from_address": value.fromAddress,
    "token_expiry": value.tokenExpiry,
    "subject": value.subject,
    "template": value.template,
    "activate_user_on_success": value.activateUserOnSuccess
  };
}

// node_modules/@goauthentik/api/dist/esm/models/GeoipBindingEnum.js
var GeoipBindingEnum = {
  NoBinding: "no_binding",
  BindContinent: "bind_continent",
  BindContinentCountry: "bind_continent_country",
  BindContinentCountryCity: "bind_continent_country_city",
  UnknownDefaultOpenApi: "11184809"
};
function GeoipBindingEnumFromJSON(json) {
  return GeoipBindingEnumFromJSONTyped(json, false);
}
function GeoipBindingEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function GeoipBindingEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/UserFieldsEnum.js
var UserFieldsEnum = {
  Email: "email",
  Username: "username",
  Upn: "upn",
  UnknownDefaultOpenApi: "11184809"
};
function UserFieldsEnumFromJSON(json) {
  return UserFieldsEnumFromJSONTyped(json, false);
}
function UserFieldsEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function UserFieldsEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/IdentificationStage.js
function IdentificationStageFromJSON(json) {
  return IdentificationStageFromJSONTyped(json, false);
}
function IdentificationStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "userFields": !exists(json, "user_fields") ? void 0 : json["user_fields"].map(UserFieldsEnumFromJSON),
    "passwordStage": !exists(json, "password_stage") ? void 0 : json["password_stage"],
    "caseInsensitiveMatching": !exists(json, "case_insensitive_matching") ? void 0 : json["case_insensitive_matching"],
    "showMatchedUser": !exists(json, "show_matched_user") ? void 0 : json["show_matched_user"],
    "enrollmentFlow": !exists(json, "enrollment_flow") ? void 0 : json["enrollment_flow"],
    "recoveryFlow": !exists(json, "recovery_flow") ? void 0 : json["recovery_flow"],
    "passwordlessFlow": !exists(json, "passwordless_flow") ? void 0 : json["passwordless_flow"],
    "sources": !exists(json, "sources") ? void 0 : json["sources"],
    "showSourceLabels": !exists(json, "show_source_labels") ? void 0 : json["show_source_labels"],
    "pretendUserExists": !exists(json, "pretend_user_exists") ? void 0 : json["pretend_user_exists"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/IdentificationStageRequest.js
function IdentificationStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "user_fields": value.userFields === void 0 ? void 0 : value.userFields.map(UserFieldsEnumToJSON),
    "password_stage": value.passwordStage,
    "case_insensitive_matching": value.caseInsensitiveMatching,
    "show_matched_user": value.showMatchedUser,
    "enrollment_flow": value.enrollmentFlow,
    "recovery_flow": value.recoveryFlow,
    "passwordless_flow": value.passwordlessFlow,
    "sources": value.sources,
    "show_source_labels": value.showSourceLabels,
    "pretend_user_exists": value.pretendUserExists
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Invitation.js
function InvitationFromJSON(json) {
  return InvitationFromJSONTyped(json, false);
}
function InvitationFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "expires": !exists(json, "expires") ? void 0 : json["expires"] === null ? null : new Date(json["expires"]),
    "fixedData": !exists(json, "fixed_data") ? void 0 : json["fixed_data"],
    "createdBy": GroupMemberFromJSON(json["created_by"]),
    "singleUse": !exists(json, "single_use") ? void 0 : json["single_use"],
    "flow": !exists(json, "flow") ? void 0 : json["flow"],
    "flowObj": FlowFromJSON(json["flow_obj"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/InvitationRequest.js
function InvitationRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "expires": value.expires === void 0 ? void 0 : value.expires === null ? null : value.expires.toISOString(),
    "fixed_data": value.fixedData,
    "single_use": value.singleUse,
    "flow": value.flow
  };
}

// node_modules/@goauthentik/api/dist/esm/models/InvitationStage.js
function InvitationStageFromJSON(json) {
  return InvitationStageFromJSONTyped(json, false);
}
function InvitationStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "continueFlowWithoutInvitation": !exists(json, "continue_flow_without_invitation") ? void 0 : json["continue_flow_without_invitation"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/InvitationStageRequest.js
function InvitationStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "continue_flow_without_invitation": value.continueFlowWithoutInvitation
  };
}

// node_modules/@goauthentik/api/dist/esm/models/NetworkBindingEnum.js
var NetworkBindingEnum = {
  NoBinding: "no_binding",
  BindAsn: "bind_asn",
  BindAsnNetwork: "bind_asn_network",
  BindAsnNetworkIp: "bind_asn_network_ip",
  UnknownDefaultOpenApi: "11184809"
};
function NetworkBindingEnumFromJSON(json) {
  return NetworkBindingEnumFromJSONTyped(json, false);
}
function NetworkBindingEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function NetworkBindingEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedAuthenticatorDuoStageList.js
function PaginatedAuthenticatorDuoStageListFromJSON(json) {
  return PaginatedAuthenticatorDuoStageListFromJSONTyped(json, false);
}
function PaginatedAuthenticatorDuoStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(AuthenticatorDuoStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedAuthenticatorSMSStageList.js
function PaginatedAuthenticatorSMSStageListFromJSON(json) {
  return PaginatedAuthenticatorSMSStageListFromJSONTyped(json, false);
}
function PaginatedAuthenticatorSMSStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(AuthenticatorSMSStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedAuthenticatorStaticStageList.js
function PaginatedAuthenticatorStaticStageListFromJSON(json) {
  return PaginatedAuthenticatorStaticStageListFromJSONTyped(json, false);
}
function PaginatedAuthenticatorStaticStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(AuthenticatorStaticStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedAuthenticatorTOTPStageList.js
function PaginatedAuthenticatorTOTPStageListFromJSON(json) {
  return PaginatedAuthenticatorTOTPStageListFromJSONTyped(json, false);
}
function PaginatedAuthenticatorTOTPStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(AuthenticatorTOTPStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedAuthenticatorValidateStageList.js
function PaginatedAuthenticatorValidateStageListFromJSON(json) {
  return PaginatedAuthenticatorValidateStageListFromJSONTyped(json, false);
}
function PaginatedAuthenticatorValidateStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(AuthenticatorValidateStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedAuthenticatorWebAuthnStageList.js
function PaginatedAuthenticatorWebAuthnStageListFromJSON(json) {
  return PaginatedAuthenticatorWebAuthnStageListFromJSONTyped(json, false);
}
function PaginatedAuthenticatorWebAuthnStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(AuthenticatorWebAuthnStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedCaptchaStageList.js
function PaginatedCaptchaStageListFromJSON(json) {
  return PaginatedCaptchaStageListFromJSONTyped(json, false);
}
function PaginatedCaptchaStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(CaptchaStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedConsentStageList.js
function PaginatedConsentStageListFromJSON(json) {
  return PaginatedConsentStageListFromJSONTyped(json, false);
}
function PaginatedConsentStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ConsentStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedDenyStageList.js
function PaginatedDenyStageListFromJSON(json) {
  return PaginatedDenyStageListFromJSONTyped(json, false);
}
function PaginatedDenyStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(DenyStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedDummyStageList.js
function PaginatedDummyStageListFromJSON(json) {
  return PaginatedDummyStageListFromJSONTyped(json, false);
}
function PaginatedDummyStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(DummyStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedEmailStageList.js
function PaginatedEmailStageListFromJSON(json) {
  return PaginatedEmailStageListFromJSONTyped(json, false);
}
function PaginatedEmailStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(EmailStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedIdentificationStageList.js
function PaginatedIdentificationStageListFromJSON(json) {
  return PaginatedIdentificationStageListFromJSONTyped(json, false);
}
function PaginatedIdentificationStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(IdentificationStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedInvitationList.js
function PaginatedInvitationListFromJSON(json) {
  return PaginatedInvitationListFromJSONTyped(json, false);
}
function PaginatedInvitationListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(InvitationFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedInvitationStageList.js
function PaginatedInvitationStageListFromJSON(json) {
  return PaginatedInvitationStageListFromJSONTyped(json, false);
}
function PaginatedInvitationStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(InvitationStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PasswordStage.js
function PasswordStageFromJSON(json) {
  return PasswordStageFromJSONTyped(json, false);
}
function PasswordStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "backends": json["backends"].map(BackendsEnumFromJSON),
    "configureFlow": !exists(json, "configure_flow") ? void 0 : json["configure_flow"],
    "failedAttemptsBeforeCancel": !exists(json, "failed_attempts_before_cancel") ? void 0 : json["failed_attempts_before_cancel"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPasswordStageList.js
function PaginatedPasswordStageListFromJSON(json) {
  return PaginatedPasswordStageListFromJSONTyped(json, false);
}
function PaginatedPasswordStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PasswordStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Prompt.js
function PromptFromJSON(json) {
  return PromptFromJSONTyped(json, false);
}
function PromptFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "fieldKey": json["field_key"],
    "label": json["label"],
    "type": PromptTypeEnumFromJSON(json["type"]),
    "required": !exists(json, "required") ? void 0 : json["required"],
    "placeholder": !exists(json, "placeholder") ? void 0 : json["placeholder"],
    "initialValue": !exists(json, "initial_value") ? void 0 : json["initial_value"],
    "order": !exists(json, "order") ? void 0 : json["order"],
    "promptstageSet": !exists(json, "promptstage_set") ? void 0 : json["promptstage_set"].map(StageFromJSON),
    "subText": !exists(json, "sub_text") ? void 0 : json["sub_text"],
    "placeholderExpression": !exists(json, "placeholder_expression") ? void 0 : json["placeholder_expression"],
    "initialValueExpression": !exists(json, "initial_value_expression") ? void 0 : json["initial_value_expression"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPromptList.js
function PaginatedPromptListFromJSON(json) {
  return PaginatedPromptListFromJSONTyped(json, false);
}
function PaginatedPromptListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PromptFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PromptStage.js
function PromptStageFromJSON(json) {
  return PromptStageFromJSONTyped(json, false);
}
function PromptStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "fields": json["fields"],
    "validationPolicies": !exists(json, "validation_policies") ? void 0 : json["validation_policies"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPromptStageList.js
function PaginatedPromptStageListFromJSON(json) {
  return PaginatedPromptStageListFromJSONTyped(json, false);
}
function PaginatedPromptStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PromptStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SourceStage.js
function SourceStageFromJSON(json) {
  return SourceStageFromJSONTyped(json, false);
}
function SourceStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "source": json["source"],
    "resumeTimeout": !exists(json, "resume_timeout") ? void 0 : json["resume_timeout"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSourceStageList.js
function PaginatedSourceStageListFromJSON(json) {
  return PaginatedSourceStageListFromJSONTyped(json, false);
}
function PaginatedSourceStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SourceStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedStageList.js
function PaginatedStageListFromJSON(json) {
  return PaginatedStageListFromJSONTyped(json, false);
}
function PaginatedStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(StageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserDeleteStage.js
function UserDeleteStageFromJSON(json) {
  return UserDeleteStageFromJSONTyped(json, false);
}
function UserDeleteStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedUserDeleteStageList.js
function PaginatedUserDeleteStageListFromJSON(json) {
  return PaginatedUserDeleteStageListFromJSONTyped(json, false);
}
function PaginatedUserDeleteStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(UserDeleteStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserLoginStage.js
function UserLoginStageFromJSON(json) {
  return UserLoginStageFromJSONTyped(json, false);
}
function UserLoginStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "sessionDuration": !exists(json, "session_duration") ? void 0 : json["session_duration"],
    "terminateOtherSessions": !exists(json, "terminate_other_sessions") ? void 0 : json["terminate_other_sessions"],
    "rememberMeOffset": !exists(json, "remember_me_offset") ? void 0 : json["remember_me_offset"],
    "networkBinding": !exists(json, "network_binding") ? void 0 : NetworkBindingEnumFromJSON(json["network_binding"]),
    "geoipBinding": !exists(json, "geoip_binding") ? void 0 : GeoipBindingEnumFromJSON(json["geoip_binding"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedUserLoginStageList.js
function PaginatedUserLoginStageListFromJSON(json) {
  return PaginatedUserLoginStageListFromJSONTyped(json, false);
}
function PaginatedUserLoginStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(UserLoginStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserLogoutStage.js
function UserLogoutStageFromJSON(json) {
  return UserLogoutStageFromJSONTyped(json, false);
}
function UserLogoutStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedUserLogoutStageList.js
function PaginatedUserLogoutStageListFromJSON(json) {
  return PaginatedUserLogoutStageListFromJSONTyped(json, false);
}
function PaginatedUserLogoutStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(UserLogoutStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserCreationModeEnum.js
function UserCreationModeEnumFromJSON(json) {
  return UserCreationModeEnumFromJSONTyped(json, false);
}
function UserCreationModeEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function UserCreationModeEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/UserWriteStage.js
function UserWriteStageFromJSON(json) {
  return UserWriteStageFromJSONTyped(json, false);
}
function UserWriteStageFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": !exists(json, "flow_set") ? void 0 : json["flow_set"].map(FlowSetFromJSON),
    "userCreationMode": !exists(json, "user_creation_mode") ? void 0 : UserCreationModeEnumFromJSON(json["user_creation_mode"]),
    "createUsersAsInactive": !exists(json, "create_users_as_inactive") ? void 0 : json["create_users_as_inactive"],
    "createUsersGroup": !exists(json, "create_users_group") ? void 0 : json["create_users_group"],
    "userType": !exists(json, "user_type") ? void 0 : UserTypeEnumFromJSON(json["user_type"]),
    "userPathTemplate": !exists(json, "user_path_template") ? void 0 : json["user_path_template"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedUserWriteStageList.js
function PaginatedUserWriteStageListFromJSON(json) {
  return PaginatedUserWriteStageListFromJSONTyped(json, false);
}
function PaginatedUserWriteStageListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(UserWriteStageFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedWebAuthnDeviceTypeList.js
function PaginatedWebAuthnDeviceTypeListFromJSON(json) {
  return PaginatedWebAuthnDeviceTypeListFromJSONTyped(json, false);
}
function PaginatedWebAuthnDeviceTypeListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(WebAuthnDeviceTypeFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PasswordStageRequest.js
function PasswordStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "backends": value.backends.map(BackendsEnumToJSON),
    "configure_flow": value.configureFlow,
    "failed_attempts_before_cancel": value.failedAttemptsBeforeCancel
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedAuthenticatorDuoStageRequest.js
function PatchedAuthenticatorDuoStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "configure_flow": value.configureFlow,
    "friendly_name": value.friendlyName,
    "client_id": value.clientId,
    "client_secret": value.clientSecret,
    "api_hostname": value.apiHostname,
    "admin_integration_key": value.adminIntegrationKey,
    "admin_secret_key": value.adminSecretKey
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedAuthenticatorSMSStageRequest.js
function PatchedAuthenticatorSMSStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "configure_flow": value.configureFlow,
    "friendly_name": value.friendlyName,
    "provider": ProviderEnumToJSON(value.provider),
    "from_number": value.fromNumber,
    "account_sid": value.accountSid,
    "auth": value.auth,
    "auth_password": value.authPassword,
    "auth_type": AuthTypeEnumToJSON(value.authType),
    "verify_only": value.verifyOnly,
    "mapping": value.mapping
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedAuthenticatorStaticStageRequest.js
function PatchedAuthenticatorStaticStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "configure_flow": value.configureFlow,
    "friendly_name": value.friendlyName,
    "token_count": value.tokenCount,
    "token_length": value.tokenLength
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedAuthenticatorTOTPStageRequest.js
function PatchedAuthenticatorTOTPStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "configure_flow": value.configureFlow,
    "friendly_name": value.friendlyName,
    "digits": DigitsEnumToJSON(value.digits)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedAuthenticatorValidateStageRequest.js
function PatchedAuthenticatorValidateStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "not_configured_action": NotConfiguredActionEnumToJSON(value.notConfiguredAction),
    "device_classes": value.deviceClasses === void 0 ? void 0 : value.deviceClasses.map(DeviceClassesEnumToJSON),
    "configuration_stages": value.configurationStages,
    "last_auth_threshold": value.lastAuthThreshold,
    "webauthn_user_verification": UserVerificationEnumToJSON(value.webauthnUserVerification),
    "webauthn_allowed_device_types": value.webauthnAllowedDeviceTypes
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedAuthenticatorWebAuthnStageRequest.js
function PatchedAuthenticatorWebAuthnStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "configure_flow": value.configureFlow,
    "friendly_name": value.friendlyName,
    "user_verification": UserVerificationEnumToJSON(value.userVerification),
    "authenticator_attachment": AuthenticatorAttachmentEnumToJSON(value.authenticatorAttachment),
    "resident_key_requirement": ResidentKeyRequirementEnumToJSON(value.residentKeyRequirement),
    "device_type_restrictions": value.deviceTypeRestrictions
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedCaptchaStageRequest.js
function PatchedCaptchaStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "public_key": value.publicKey,
    "private_key": value.privateKey,
    "js_url": value.jsUrl,
    "api_url": value.apiUrl
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedConsentStageRequest.js
function PatchedConsentStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "mode": ConsentStageModeEnumToJSON(value.mode),
    "consent_expire_in": value.consentExpireIn
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedDenyStageRequest.js
function PatchedDenyStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "deny_message": value.denyMessage
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedDummyStageRequest.js
function PatchedDummyStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "throw_error": value.throwError
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedEmailStageRequest.js
function PatchedEmailStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "use_global_settings": value.useGlobalSettings,
    "host": value.host,
    "port": value.port,
    "username": value.username,
    "password": value.password,
    "use_tls": value.useTls,
    "use_ssl": value.useSsl,
    "timeout": value.timeout,
    "from_address": value.fromAddress,
    "token_expiry": value.tokenExpiry,
    "subject": value.subject,
    "template": value.template,
    "activate_user_on_success": value.activateUserOnSuccess
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedIdentificationStageRequest.js
function PatchedIdentificationStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "user_fields": value.userFields === void 0 ? void 0 : value.userFields.map(UserFieldsEnumToJSON),
    "password_stage": value.passwordStage,
    "case_insensitive_matching": value.caseInsensitiveMatching,
    "show_matched_user": value.showMatchedUser,
    "enrollment_flow": value.enrollmentFlow,
    "recovery_flow": value.recoveryFlow,
    "passwordless_flow": value.passwordlessFlow,
    "sources": value.sources,
    "show_source_labels": value.showSourceLabels,
    "pretend_user_exists": value.pretendUserExists
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedInvitationRequest.js
function PatchedInvitationRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "expires": value.expires === void 0 ? void 0 : value.expires === null ? null : value.expires.toISOString(),
    "fixed_data": value.fixedData,
    "single_use": value.singleUse,
    "flow": value.flow
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedInvitationStageRequest.js
function PatchedInvitationStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "continue_flow_without_invitation": value.continueFlowWithoutInvitation
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedPasswordStageRequest.js
function PatchedPasswordStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "backends": value.backends === void 0 ? void 0 : value.backends.map(BackendsEnumToJSON),
    "configure_flow": value.configureFlow,
    "failed_attempts_before_cancel": value.failedAttemptsBeforeCancel
  };
}

// node_modules/@goauthentik/api/dist/esm/models/StageRequest.js
function StageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedPromptRequest.js
function PatchedPromptRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "field_key": value.fieldKey,
    "label": value.label,
    "type": PromptTypeEnumToJSON(value.type),
    "required": value.required,
    "placeholder": value.placeholder,
    "initial_value": value.initialValue,
    "order": value.order,
    "promptstage_set": value.promptstageSet === void 0 ? void 0 : value.promptstageSet.map(StageRequestToJSON),
    "sub_text": value.subText,
    "placeholder_expression": value.placeholderExpression,
    "initial_value_expression": value.initialValueExpression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedPromptStageRequest.js
function PatchedPromptStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "fields": value.fields,
    "validation_policies": value.validationPolicies
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSourceStageRequest.js
function PatchedSourceStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "source": value.source,
    "resume_timeout": value.resumeTimeout
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedUserDeleteStageRequest.js
function PatchedUserDeleteStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedUserLoginStageRequest.js
function PatchedUserLoginStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "session_duration": value.sessionDuration,
    "terminate_other_sessions": value.terminateOtherSessions,
    "remember_me_offset": value.rememberMeOffset,
    "network_binding": NetworkBindingEnumToJSON(value.networkBinding),
    "geoip_binding": GeoipBindingEnumToJSON(value.geoipBinding)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedUserLogoutStageRequest.js
function PatchedUserLogoutStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedUserWriteStageRequest.js
function PatchedUserWriteStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "user_creation_mode": UserCreationModeEnumToJSON(value.userCreationMode),
    "create_users_as_inactive": value.createUsersAsInactive,
    "create_users_group": value.createUsersGroup,
    "user_type": UserTypeEnumToJSON(value.userType),
    "user_path_template": value.userPathTemplate
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PromptRequest.js
function PromptRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "field_key": value.fieldKey,
    "label": value.label,
    "type": PromptTypeEnumToJSON(value.type),
    "required": value.required,
    "placeholder": value.placeholder,
    "initial_value": value.initialValue,
    "order": value.order,
    "promptstage_set": value.promptstageSet === void 0 ? void 0 : value.promptstageSet.map(StageRequestToJSON),
    "sub_text": value.subText,
    "placeholder_expression": value.placeholderExpression,
    "initial_value_expression": value.initialValueExpression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PromptStageRequest.js
function PromptStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "fields": value.fields,
    "validation_policies": value.validationPolicies
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SourceStageRequest.js
function SourceStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "source": value.source,
    "resume_timeout": value.resumeTimeout
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserDeleteStageRequest.js
function UserDeleteStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserLoginStageRequest.js
function UserLoginStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "session_duration": value.sessionDuration,
    "terminate_other_sessions": value.terminateOtherSessions,
    "remember_me_offset": value.rememberMeOffset,
    "network_binding": NetworkBindingEnumToJSON(value.networkBinding),
    "geoip_binding": GeoipBindingEnumToJSON(value.geoipBinding)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserLogoutStageRequest.js
function UserLogoutStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserWriteStageRequest.js
function UserWriteStageRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "flow_set": value.flowSet === void 0 ? void 0 : value.flowSet.map(FlowSetRequestToJSON),
    "user_creation_mode": UserCreationModeEnumToJSON(value.userCreationMode),
    "create_users_as_inactive": value.createUsersAsInactive,
    "create_users_group": value.createUsersGroup,
    "user_type": UserTypeEnumToJSON(value.userType),
    "user_path_template": value.userPathTemplate
  };
}

// node_modules/@goauthentik/api/dist/esm/apis/StagesApi.js
var __awaiter = function(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var StagesApi = class extends BaseAPI {
  /**
   * Stage Viewset
   */
  stagesAllDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAllDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/all/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Stage Viewset
   */
  stagesAllDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesAllDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Stage Viewset
   */
  stagesAllListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/all/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedStageListFromJSON(jsonValue));
    });
  }
  /**
   * Stage Viewset
   */
  stagesAllList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAllListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Stage Viewset
   */
  stagesAllRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAllRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/all/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => StageFromJSON(jsonValue));
    });
  }
  /**
   * Stage Viewset
   */
  stagesAllRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAllRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get all creatable stage types
   */
  stagesAllTypesListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/all/types/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(TypeCreateFromJSON));
    });
  }
  /**
   * Get all creatable stage types
   */
  stagesAllTypesList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAllTypesListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesAllUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAllUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/all/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesAllUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAllUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get all stages the user can configure
   */
  stagesAllUserSettingsListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/all/user_settings/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UserSettingFromJSON));
    });
  }
  /**
   * Get all stages the user can configure
   */
  stagesAllUserSettingsList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAllUserSettingsListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorDuoStage Viewset
   */
  stagesAuthenticatorDuoCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.authenticatorDuoStageRequest === null || requestParameters.authenticatorDuoStageRequest === void 0) {
        throw new RequiredError("authenticatorDuoStageRequest", "Required parameter requestParameters.authenticatorDuoStageRequest was null or undefined when calling stagesAuthenticatorDuoCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/duo/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: AuthenticatorDuoStageRequestToJSON(requestParameters.authenticatorDuoStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorDuoStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorDuoStage Viewset
   */
  stagesAuthenticatorDuoCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorDuoCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorDuoStage Viewset
   */
  stagesAuthenticatorDuoDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorDuoDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/duo/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * AuthenticatorDuoStage Viewset
   */
  stagesAuthenticatorDuoDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesAuthenticatorDuoDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Check enrollment status of user details in current session
   */
  stagesAuthenticatorDuoEnrollmentStatusCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorDuoEnrollmentStatusCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/duo/{stage_uuid}/enrollment_status/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DuoDeviceEnrollmentStatusFromJSON(jsonValue));
    });
  }
  /**
   * Check enrollment status of user details in current session
   */
  stagesAuthenticatorDuoEnrollmentStatusCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorDuoEnrollmentStatusCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Import duo devices into authentik
   */
  stagesAuthenticatorDuoImportDeviceManualCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorDuoImportDeviceManualCreate.");
      }
      if (requestParameters.authenticatorDuoStageManualDeviceImportRequest === null || requestParameters.authenticatorDuoStageManualDeviceImportRequest === void 0) {
        throw new RequiredError("authenticatorDuoStageManualDeviceImportRequest", "Required parameter requestParameters.authenticatorDuoStageManualDeviceImportRequest was null or undefined when calling stagesAuthenticatorDuoImportDeviceManualCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/duo/{stage_uuid}/import_device_manual/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: AuthenticatorDuoStageManualDeviceImportRequestToJSON(requestParameters.authenticatorDuoStageManualDeviceImportRequest)
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Import duo devices into authentik
   */
  stagesAuthenticatorDuoImportDeviceManualCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesAuthenticatorDuoImportDeviceManualCreateRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Import duo devices into authentik
   */
  stagesAuthenticatorDuoImportDevicesAutomaticCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorDuoImportDevicesAutomaticCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/duo/{stage_uuid}/import_devices_automatic/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorDuoStageDeviceImportResponseFromJSON(jsonValue));
    });
  }
  /**
   * Import duo devices into authentik
   */
  stagesAuthenticatorDuoImportDevicesAutomaticCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorDuoImportDevicesAutomaticCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorDuoStage Viewset
   */
  stagesAuthenticatorDuoListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.apiHostname !== void 0) {
        queryParameters["api_hostname"] = requestParameters.apiHostname;
      }
      if (requestParameters.clientId !== void 0) {
        queryParameters["client_id"] = requestParameters.clientId;
      }
      if (requestParameters.configureFlow !== void 0) {
        queryParameters["configure_flow"] = requestParameters.configureFlow;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/duo/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedAuthenticatorDuoStageListFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorDuoStage Viewset
   */
  stagesAuthenticatorDuoList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorDuoListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorDuoStage Viewset
   */
  stagesAuthenticatorDuoPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorDuoPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/duo/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedAuthenticatorDuoStageRequestToJSON(requestParameters.patchedAuthenticatorDuoStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorDuoStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorDuoStage Viewset
   */
  stagesAuthenticatorDuoPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorDuoPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorDuoStage Viewset
   */
  stagesAuthenticatorDuoRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorDuoRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/duo/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorDuoStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorDuoStage Viewset
   */
  stagesAuthenticatorDuoRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorDuoRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorDuoStage Viewset
   */
  stagesAuthenticatorDuoUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorDuoUpdate.");
      }
      if (requestParameters.authenticatorDuoStageRequest === null || requestParameters.authenticatorDuoStageRequest === void 0) {
        throw new RequiredError("authenticatorDuoStageRequest", "Required parameter requestParameters.authenticatorDuoStageRequest was null or undefined when calling stagesAuthenticatorDuoUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/duo/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: AuthenticatorDuoStageRequestToJSON(requestParameters.authenticatorDuoStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorDuoStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorDuoStage Viewset
   */
  stagesAuthenticatorDuoUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorDuoUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesAuthenticatorDuoUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorDuoUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/duo/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesAuthenticatorDuoUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorDuoUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorSMSStage Viewset
   */
  stagesAuthenticatorSmsCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.authenticatorSMSStageRequest === null || requestParameters.authenticatorSMSStageRequest === void 0) {
        throw new RequiredError("authenticatorSMSStageRequest", "Required parameter requestParameters.authenticatorSMSStageRequest was null or undefined when calling stagesAuthenticatorSmsCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/sms/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: AuthenticatorSMSStageRequestToJSON(requestParameters.authenticatorSMSStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorSMSStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorSMSStage Viewset
   */
  stagesAuthenticatorSmsCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorSmsCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorSMSStage Viewset
   */
  stagesAuthenticatorSmsDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorSmsDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/sms/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * AuthenticatorSMSStage Viewset
   */
  stagesAuthenticatorSmsDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesAuthenticatorSmsDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * AuthenticatorSMSStage Viewset
   */
  stagesAuthenticatorSmsListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.accountSid !== void 0) {
        queryParameters["account_sid"] = requestParameters.accountSid;
      }
      if (requestParameters.auth !== void 0) {
        queryParameters["auth"] = requestParameters.auth;
      }
      if (requestParameters.authPassword !== void 0) {
        queryParameters["auth_password"] = requestParameters.authPassword;
      }
      if (requestParameters.authType !== void 0) {
        queryParameters["auth_type"] = requestParameters.authType;
      }
      if (requestParameters.configureFlow !== void 0) {
        queryParameters["configure_flow"] = requestParameters.configureFlow;
      }
      if (requestParameters.friendlyName !== void 0) {
        queryParameters["friendly_name"] = requestParameters.friendlyName;
      }
      if (requestParameters.fromNumber !== void 0) {
        queryParameters["from_number"] = requestParameters.fromNumber;
      }
      if (requestParameters.mapping !== void 0) {
        queryParameters["mapping"] = requestParameters.mapping;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.provider !== void 0) {
        queryParameters["provider"] = requestParameters.provider;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.stageUuid !== void 0) {
        queryParameters["stage_uuid"] = requestParameters.stageUuid;
      }
      if (requestParameters.verifyOnly !== void 0) {
        queryParameters["verify_only"] = requestParameters.verifyOnly;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/sms/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedAuthenticatorSMSStageListFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorSMSStage Viewset
   */
  stagesAuthenticatorSmsList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorSmsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorSMSStage Viewset
   */
  stagesAuthenticatorSmsPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorSmsPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/sms/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedAuthenticatorSMSStageRequestToJSON(requestParameters.patchedAuthenticatorSMSStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorSMSStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorSMSStage Viewset
   */
  stagesAuthenticatorSmsPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorSmsPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorSMSStage Viewset
   */
  stagesAuthenticatorSmsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorSmsRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/sms/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorSMSStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorSMSStage Viewset
   */
  stagesAuthenticatorSmsRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorSmsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorSMSStage Viewset
   */
  stagesAuthenticatorSmsUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorSmsUpdate.");
      }
      if (requestParameters.authenticatorSMSStageRequest === null || requestParameters.authenticatorSMSStageRequest === void 0) {
        throw new RequiredError("authenticatorSMSStageRequest", "Required parameter requestParameters.authenticatorSMSStageRequest was null or undefined when calling stagesAuthenticatorSmsUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/sms/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: AuthenticatorSMSStageRequestToJSON(requestParameters.authenticatorSMSStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorSMSStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorSMSStage Viewset
   */
  stagesAuthenticatorSmsUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorSmsUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesAuthenticatorSmsUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorSmsUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/sms/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesAuthenticatorSmsUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorSmsUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorStaticStage Viewset
   */
  stagesAuthenticatorStaticCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.authenticatorStaticStageRequest === null || requestParameters.authenticatorStaticStageRequest === void 0) {
        throw new RequiredError("authenticatorStaticStageRequest", "Required parameter requestParameters.authenticatorStaticStageRequest was null or undefined when calling stagesAuthenticatorStaticCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/static/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: AuthenticatorStaticStageRequestToJSON(requestParameters.authenticatorStaticStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorStaticStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorStaticStage Viewset
   */
  stagesAuthenticatorStaticCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorStaticCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorStaticStage Viewset
   */
  stagesAuthenticatorStaticDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorStaticDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/static/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * AuthenticatorStaticStage Viewset
   */
  stagesAuthenticatorStaticDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesAuthenticatorStaticDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * AuthenticatorStaticStage Viewset
   */
  stagesAuthenticatorStaticListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.configureFlow !== void 0) {
        queryParameters["configure_flow"] = requestParameters.configureFlow;
      }
      if (requestParameters.friendlyName !== void 0) {
        queryParameters["friendly_name"] = requestParameters.friendlyName;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.stageUuid !== void 0) {
        queryParameters["stage_uuid"] = requestParameters.stageUuid;
      }
      if (requestParameters.tokenCount !== void 0) {
        queryParameters["token_count"] = requestParameters.tokenCount;
      }
      if (requestParameters.tokenLength !== void 0) {
        queryParameters["token_length"] = requestParameters.tokenLength;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/static/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedAuthenticatorStaticStageListFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorStaticStage Viewset
   */
  stagesAuthenticatorStaticList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorStaticListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorStaticStage Viewset
   */
  stagesAuthenticatorStaticPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorStaticPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/static/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedAuthenticatorStaticStageRequestToJSON(requestParameters.patchedAuthenticatorStaticStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorStaticStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorStaticStage Viewset
   */
  stagesAuthenticatorStaticPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorStaticPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorStaticStage Viewset
   */
  stagesAuthenticatorStaticRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorStaticRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/static/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorStaticStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorStaticStage Viewset
   */
  stagesAuthenticatorStaticRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorStaticRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorStaticStage Viewset
   */
  stagesAuthenticatorStaticUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorStaticUpdate.");
      }
      if (requestParameters.authenticatorStaticStageRequest === null || requestParameters.authenticatorStaticStageRequest === void 0) {
        throw new RequiredError("authenticatorStaticStageRequest", "Required parameter requestParameters.authenticatorStaticStageRequest was null or undefined when calling stagesAuthenticatorStaticUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/static/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: AuthenticatorStaticStageRequestToJSON(requestParameters.authenticatorStaticStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorStaticStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorStaticStage Viewset
   */
  stagesAuthenticatorStaticUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorStaticUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesAuthenticatorStaticUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorStaticUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/static/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesAuthenticatorStaticUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorStaticUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorTOTPStage Viewset
   */
  stagesAuthenticatorTotpCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.authenticatorTOTPStageRequest === null || requestParameters.authenticatorTOTPStageRequest === void 0) {
        throw new RequiredError("authenticatorTOTPStageRequest", "Required parameter requestParameters.authenticatorTOTPStageRequest was null or undefined when calling stagesAuthenticatorTotpCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/totp/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: AuthenticatorTOTPStageRequestToJSON(requestParameters.authenticatorTOTPStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorTOTPStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorTOTPStage Viewset
   */
  stagesAuthenticatorTotpCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorTotpCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorTOTPStage Viewset
   */
  stagesAuthenticatorTotpDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorTotpDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/totp/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * AuthenticatorTOTPStage Viewset
   */
  stagesAuthenticatorTotpDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesAuthenticatorTotpDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * AuthenticatorTOTPStage Viewset
   */
  stagesAuthenticatorTotpListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.configureFlow !== void 0) {
        queryParameters["configure_flow"] = requestParameters.configureFlow;
      }
      if (requestParameters.digits !== void 0) {
        queryParameters["digits"] = requestParameters.digits;
      }
      if (requestParameters.friendlyName !== void 0) {
        queryParameters["friendly_name"] = requestParameters.friendlyName;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.stageUuid !== void 0) {
        queryParameters["stage_uuid"] = requestParameters.stageUuid;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/totp/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedAuthenticatorTOTPStageListFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorTOTPStage Viewset
   */
  stagesAuthenticatorTotpList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorTotpListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorTOTPStage Viewset
   */
  stagesAuthenticatorTotpPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorTotpPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/totp/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedAuthenticatorTOTPStageRequestToJSON(requestParameters.patchedAuthenticatorTOTPStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorTOTPStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorTOTPStage Viewset
   */
  stagesAuthenticatorTotpPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorTotpPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorTOTPStage Viewset
   */
  stagesAuthenticatorTotpRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorTotpRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/totp/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorTOTPStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorTOTPStage Viewset
   */
  stagesAuthenticatorTotpRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorTotpRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorTOTPStage Viewset
   */
  stagesAuthenticatorTotpUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorTotpUpdate.");
      }
      if (requestParameters.authenticatorTOTPStageRequest === null || requestParameters.authenticatorTOTPStageRequest === void 0) {
        throw new RequiredError("authenticatorTOTPStageRequest", "Required parameter requestParameters.authenticatorTOTPStageRequest was null or undefined when calling stagesAuthenticatorTotpUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/totp/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: AuthenticatorTOTPStageRequestToJSON(requestParameters.authenticatorTOTPStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorTOTPStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorTOTPStage Viewset
   */
  stagesAuthenticatorTotpUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorTotpUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesAuthenticatorTotpUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorTotpUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/totp/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesAuthenticatorTotpUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorTotpUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorValidateStage Viewset
   */
  stagesAuthenticatorValidateCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.authenticatorValidateStageRequest === null || requestParameters.authenticatorValidateStageRequest === void 0) {
        throw new RequiredError("authenticatorValidateStageRequest", "Required parameter requestParameters.authenticatorValidateStageRequest was null or undefined when calling stagesAuthenticatorValidateCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/validate/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: AuthenticatorValidateStageRequestToJSON(requestParameters.authenticatorValidateStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorValidateStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorValidateStage Viewset
   */
  stagesAuthenticatorValidateCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorValidateCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorValidateStage Viewset
   */
  stagesAuthenticatorValidateDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorValidateDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/validate/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * AuthenticatorValidateStage Viewset
   */
  stagesAuthenticatorValidateDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesAuthenticatorValidateDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * AuthenticatorValidateStage Viewset
   */
  stagesAuthenticatorValidateListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.configurationStages) {
        queryParameters["configuration_stages"] = requestParameters.configurationStages;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.notConfiguredAction !== void 0) {
        queryParameters["not_configured_action"] = requestParameters.notConfiguredAction;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/validate/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedAuthenticatorValidateStageListFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorValidateStage Viewset
   */
  stagesAuthenticatorValidateList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorValidateListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorValidateStage Viewset
   */
  stagesAuthenticatorValidatePartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorValidatePartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/validate/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedAuthenticatorValidateStageRequestToJSON(requestParameters.patchedAuthenticatorValidateStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorValidateStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorValidateStage Viewset
   */
  stagesAuthenticatorValidatePartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorValidatePartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorValidateStage Viewset
   */
  stagesAuthenticatorValidateRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorValidateRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/validate/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorValidateStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorValidateStage Viewset
   */
  stagesAuthenticatorValidateRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorValidateRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorValidateStage Viewset
   */
  stagesAuthenticatorValidateUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorValidateUpdate.");
      }
      if (requestParameters.authenticatorValidateStageRequest === null || requestParameters.authenticatorValidateStageRequest === void 0) {
        throw new RequiredError("authenticatorValidateStageRequest", "Required parameter requestParameters.authenticatorValidateStageRequest was null or undefined when calling stagesAuthenticatorValidateUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/validate/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: AuthenticatorValidateStageRequestToJSON(requestParameters.authenticatorValidateStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorValidateStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorValidateStage Viewset
   */
  stagesAuthenticatorValidateUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorValidateUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesAuthenticatorValidateUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorValidateUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/validate/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesAuthenticatorValidateUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorValidateUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorWebAuthnStage Viewset
   */
  stagesAuthenticatorWebauthnCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.authenticatorWebAuthnStageRequest === null || requestParameters.authenticatorWebAuthnStageRequest === void 0) {
        throw new RequiredError("authenticatorWebAuthnStageRequest", "Required parameter requestParameters.authenticatorWebAuthnStageRequest was null or undefined when calling stagesAuthenticatorWebauthnCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/webauthn/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: AuthenticatorWebAuthnStageRequestToJSON(requestParameters.authenticatorWebAuthnStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorWebAuthnStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorWebAuthnStage Viewset
   */
  stagesAuthenticatorWebauthnCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorWebauthnCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorWebAuthnStage Viewset
   */
  stagesAuthenticatorWebauthnDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorWebauthnDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/webauthn/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * AuthenticatorWebAuthnStage Viewset
   */
  stagesAuthenticatorWebauthnDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesAuthenticatorWebauthnDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * WebAuthnDeviceType Viewset
   */
  stagesAuthenticatorWebauthnDeviceTypesListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.aaguid !== void 0) {
        queryParameters["aaguid"] = requestParameters.aaguid;
      }
      if (requestParameters.description !== void 0) {
        queryParameters["description"] = requestParameters.description;
      }
      if (requestParameters.icon !== void 0) {
        queryParameters["icon"] = requestParameters.icon;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/webauthn_device_types/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedWebAuthnDeviceTypeListFromJSON(jsonValue));
    });
  }
  /**
   * WebAuthnDeviceType Viewset
   */
  stagesAuthenticatorWebauthnDeviceTypesList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorWebauthnDeviceTypesListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * WebAuthnDeviceType Viewset
   */
  stagesAuthenticatorWebauthnDeviceTypesRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.aaguid === null || requestParameters.aaguid === void 0) {
        throw new RequiredError("aaguid", "Required parameter requestParameters.aaguid was null or undefined when calling stagesAuthenticatorWebauthnDeviceTypesRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/webauthn_device_types/{aaguid}/`.replace(`{${"aaguid"}}`, encodeURIComponent(String(requestParameters.aaguid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => WebAuthnDeviceTypeFromJSON(jsonValue));
    });
  }
  /**
   * WebAuthnDeviceType Viewset
   */
  stagesAuthenticatorWebauthnDeviceTypesRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorWebauthnDeviceTypesRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorWebAuthnStage Viewset
   */
  stagesAuthenticatorWebauthnListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.authenticatorAttachment !== void 0) {
        queryParameters["authenticator_attachment"] = requestParameters.authenticatorAttachment;
      }
      if (requestParameters.configureFlow !== void 0) {
        queryParameters["configure_flow"] = requestParameters.configureFlow;
      }
      if (requestParameters.deviceTypeRestrictions) {
        queryParameters["device_type_restrictions"] = requestParameters.deviceTypeRestrictions;
      }
      if (requestParameters.friendlyName !== void 0) {
        queryParameters["friendly_name"] = requestParameters.friendlyName;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.residentKeyRequirement !== void 0) {
        queryParameters["resident_key_requirement"] = requestParameters.residentKeyRequirement;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.stageUuid !== void 0) {
        queryParameters["stage_uuid"] = requestParameters.stageUuid;
      }
      if (requestParameters.userVerification !== void 0) {
        queryParameters["user_verification"] = requestParameters.userVerification;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/webauthn/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedAuthenticatorWebAuthnStageListFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorWebAuthnStage Viewset
   */
  stagesAuthenticatorWebauthnList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorWebauthnListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorWebAuthnStage Viewset
   */
  stagesAuthenticatorWebauthnPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorWebauthnPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/webauthn/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedAuthenticatorWebAuthnStageRequestToJSON(requestParameters.patchedAuthenticatorWebAuthnStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorWebAuthnStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorWebAuthnStage Viewset
   */
  stagesAuthenticatorWebauthnPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorWebauthnPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorWebAuthnStage Viewset
   */
  stagesAuthenticatorWebauthnRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorWebauthnRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/webauthn/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorWebAuthnStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorWebAuthnStage Viewset
   */
  stagesAuthenticatorWebauthnRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorWebauthnRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * AuthenticatorWebAuthnStage Viewset
   */
  stagesAuthenticatorWebauthnUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorWebauthnUpdate.");
      }
      if (requestParameters.authenticatorWebAuthnStageRequest === null || requestParameters.authenticatorWebAuthnStageRequest === void 0) {
        throw new RequiredError("authenticatorWebAuthnStageRequest", "Required parameter requestParameters.authenticatorWebAuthnStageRequest was null or undefined when calling stagesAuthenticatorWebauthnUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/webauthn/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: AuthenticatorWebAuthnStageRequestToJSON(requestParameters.authenticatorWebAuthnStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => AuthenticatorWebAuthnStageFromJSON(jsonValue));
    });
  }
  /**
   * AuthenticatorWebAuthnStage Viewset
   */
  stagesAuthenticatorWebauthnUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorWebauthnUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesAuthenticatorWebauthnUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesAuthenticatorWebauthnUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/authenticator/webauthn/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesAuthenticatorWebauthnUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesAuthenticatorWebauthnUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * CaptchaStage Viewset
   */
  stagesCaptchaCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.captchaStageRequest === null || requestParameters.captchaStageRequest === void 0) {
        throw new RequiredError("captchaStageRequest", "Required parameter requestParameters.captchaStageRequest was null or undefined when calling stagesCaptchaCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/captcha/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: CaptchaStageRequestToJSON(requestParameters.captchaStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => CaptchaStageFromJSON(jsonValue));
    });
  }
  /**
   * CaptchaStage Viewset
   */
  stagesCaptchaCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesCaptchaCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * CaptchaStage Viewset
   */
  stagesCaptchaDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesCaptchaDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/captcha/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * CaptchaStage Viewset
   */
  stagesCaptchaDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesCaptchaDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * CaptchaStage Viewset
   */
  stagesCaptchaListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.publicKey !== void 0) {
        queryParameters["public_key"] = requestParameters.publicKey;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/captcha/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedCaptchaStageListFromJSON(jsonValue));
    });
  }
  /**
   * CaptchaStage Viewset
   */
  stagesCaptchaList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesCaptchaListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * CaptchaStage Viewset
   */
  stagesCaptchaPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesCaptchaPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/captcha/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedCaptchaStageRequestToJSON(requestParameters.patchedCaptchaStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => CaptchaStageFromJSON(jsonValue));
    });
  }
  /**
   * CaptchaStage Viewset
   */
  stagesCaptchaPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesCaptchaPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * CaptchaStage Viewset
   */
  stagesCaptchaRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesCaptchaRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/captcha/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => CaptchaStageFromJSON(jsonValue));
    });
  }
  /**
   * CaptchaStage Viewset
   */
  stagesCaptchaRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesCaptchaRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * CaptchaStage Viewset
   */
  stagesCaptchaUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesCaptchaUpdate.");
      }
      if (requestParameters.captchaStageRequest === null || requestParameters.captchaStageRequest === void 0) {
        throw new RequiredError("captchaStageRequest", "Required parameter requestParameters.captchaStageRequest was null or undefined when calling stagesCaptchaUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/captcha/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: CaptchaStageRequestToJSON(requestParameters.captchaStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => CaptchaStageFromJSON(jsonValue));
    });
  }
  /**
   * CaptchaStage Viewset
   */
  stagesCaptchaUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesCaptchaUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesCaptchaUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesCaptchaUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/captcha/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesCaptchaUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesCaptchaUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ConsentStage Viewset
   */
  stagesConsentCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.consentStageRequest === null || requestParameters.consentStageRequest === void 0) {
        throw new RequiredError("consentStageRequest", "Required parameter requestParameters.consentStageRequest was null or undefined when calling stagesConsentCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/consent/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: ConsentStageRequestToJSON(requestParameters.consentStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ConsentStageFromJSON(jsonValue));
    });
  }
  /**
   * ConsentStage Viewset
   */
  stagesConsentCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesConsentCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ConsentStage Viewset
   */
  stagesConsentDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesConsentDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/consent/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * ConsentStage Viewset
   */
  stagesConsentDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesConsentDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * ConsentStage Viewset
   */
  stagesConsentListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.consentExpireIn !== void 0) {
        queryParameters["consent_expire_in"] = requestParameters.consentExpireIn;
      }
      if (requestParameters.mode !== void 0) {
        queryParameters["mode"] = requestParameters.mode;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.stageUuid !== void 0) {
        queryParameters["stage_uuid"] = requestParameters.stageUuid;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/consent/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedConsentStageListFromJSON(jsonValue));
    });
  }
  /**
   * ConsentStage Viewset
   */
  stagesConsentList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesConsentListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ConsentStage Viewset
   */
  stagesConsentPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesConsentPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/consent/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedConsentStageRequestToJSON(requestParameters.patchedConsentStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ConsentStageFromJSON(jsonValue));
    });
  }
  /**
   * ConsentStage Viewset
   */
  stagesConsentPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesConsentPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ConsentStage Viewset
   */
  stagesConsentRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesConsentRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/consent/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ConsentStageFromJSON(jsonValue));
    });
  }
  /**
   * ConsentStage Viewset
   */
  stagesConsentRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesConsentRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ConsentStage Viewset
   */
  stagesConsentUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesConsentUpdate.");
      }
      if (requestParameters.consentStageRequest === null || requestParameters.consentStageRequest === void 0) {
        throw new RequiredError("consentStageRequest", "Required parameter requestParameters.consentStageRequest was null or undefined when calling stagesConsentUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/consent/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: ConsentStageRequestToJSON(requestParameters.consentStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ConsentStageFromJSON(jsonValue));
    });
  }
  /**
   * ConsentStage Viewset
   */
  stagesConsentUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesConsentUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesConsentUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesConsentUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/consent/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesConsentUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesConsentUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DenyStage Viewset
   */
  stagesDenyCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.denyStageRequest === null || requestParameters.denyStageRequest === void 0) {
        throw new RequiredError("denyStageRequest", "Required parameter requestParameters.denyStageRequest was null or undefined when calling stagesDenyCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/deny/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: DenyStageRequestToJSON(requestParameters.denyStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DenyStageFromJSON(jsonValue));
    });
  }
  /**
   * DenyStage Viewset
   */
  stagesDenyCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesDenyCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DenyStage Viewset
   */
  stagesDenyDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesDenyDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/deny/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * DenyStage Viewset
   */
  stagesDenyDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesDenyDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * DenyStage Viewset
   */
  stagesDenyListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.denyMessage !== void 0) {
        queryParameters["deny_message"] = requestParameters.denyMessage;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.stageUuid !== void 0) {
        queryParameters["stage_uuid"] = requestParameters.stageUuid;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/deny/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedDenyStageListFromJSON(jsonValue));
    });
  }
  /**
   * DenyStage Viewset
   */
  stagesDenyList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesDenyListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DenyStage Viewset
   */
  stagesDenyPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesDenyPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/deny/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedDenyStageRequestToJSON(requestParameters.patchedDenyStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DenyStageFromJSON(jsonValue));
    });
  }
  /**
   * DenyStage Viewset
   */
  stagesDenyPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesDenyPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DenyStage Viewset
   */
  stagesDenyRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesDenyRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/deny/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DenyStageFromJSON(jsonValue));
    });
  }
  /**
   * DenyStage Viewset
   */
  stagesDenyRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesDenyRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DenyStage Viewset
   */
  stagesDenyUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesDenyUpdate.");
      }
      if (requestParameters.denyStageRequest === null || requestParameters.denyStageRequest === void 0) {
        throw new RequiredError("denyStageRequest", "Required parameter requestParameters.denyStageRequest was null or undefined when calling stagesDenyUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/deny/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: DenyStageRequestToJSON(requestParameters.denyStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DenyStageFromJSON(jsonValue));
    });
  }
  /**
   * DenyStage Viewset
   */
  stagesDenyUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesDenyUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesDenyUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesDenyUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/deny/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesDenyUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesDenyUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DummyStage Viewset
   */
  stagesDummyCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.dummyStageRequest === null || requestParameters.dummyStageRequest === void 0) {
        throw new RequiredError("dummyStageRequest", "Required parameter requestParameters.dummyStageRequest was null or undefined when calling stagesDummyCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/dummy/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: DummyStageRequestToJSON(requestParameters.dummyStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DummyStageFromJSON(jsonValue));
    });
  }
  /**
   * DummyStage Viewset
   */
  stagesDummyCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesDummyCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DummyStage Viewset
   */
  stagesDummyDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesDummyDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/dummy/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * DummyStage Viewset
   */
  stagesDummyDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesDummyDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * DummyStage Viewset
   */
  stagesDummyListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.stageUuid !== void 0) {
        queryParameters["stage_uuid"] = requestParameters.stageUuid;
      }
      if (requestParameters.throwError !== void 0) {
        queryParameters["throw_error"] = requestParameters.throwError;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/dummy/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedDummyStageListFromJSON(jsonValue));
    });
  }
  /**
   * DummyStage Viewset
   */
  stagesDummyList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesDummyListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DummyStage Viewset
   */
  stagesDummyPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesDummyPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/dummy/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedDummyStageRequestToJSON(requestParameters.patchedDummyStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DummyStageFromJSON(jsonValue));
    });
  }
  /**
   * DummyStage Viewset
   */
  stagesDummyPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesDummyPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DummyStage Viewset
   */
  stagesDummyRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesDummyRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/dummy/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DummyStageFromJSON(jsonValue));
    });
  }
  /**
   * DummyStage Viewset
   */
  stagesDummyRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesDummyRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * DummyStage Viewset
   */
  stagesDummyUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesDummyUpdate.");
      }
      if (requestParameters.dummyStageRequest === null || requestParameters.dummyStageRequest === void 0) {
        throw new RequiredError("dummyStageRequest", "Required parameter requestParameters.dummyStageRequest was null or undefined when calling stagesDummyUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/dummy/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: DummyStageRequestToJSON(requestParameters.dummyStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DummyStageFromJSON(jsonValue));
    });
  }
  /**
   * DummyStage Viewset
   */
  stagesDummyUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesDummyUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesDummyUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesDummyUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/dummy/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesDummyUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesDummyUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * EmailStage Viewset
   */
  stagesEmailCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.emailStageRequest === null || requestParameters.emailStageRequest === void 0) {
        throw new RequiredError("emailStageRequest", "Required parameter requestParameters.emailStageRequest was null or undefined when calling stagesEmailCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/email/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: EmailStageRequestToJSON(requestParameters.emailStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EmailStageFromJSON(jsonValue));
    });
  }
  /**
   * EmailStage Viewset
   */
  stagesEmailCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesEmailCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * EmailStage Viewset
   */
  stagesEmailDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesEmailDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/email/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * EmailStage Viewset
   */
  stagesEmailDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesEmailDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * EmailStage Viewset
   */
  stagesEmailListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.activateUserOnSuccess !== void 0) {
        queryParameters["activate_user_on_success"] = requestParameters.activateUserOnSuccess;
      }
      if (requestParameters.fromAddress !== void 0) {
        queryParameters["from_address"] = requestParameters.fromAddress;
      }
      if (requestParameters.host !== void 0) {
        queryParameters["host"] = requestParameters.host;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.port !== void 0) {
        queryParameters["port"] = requestParameters.port;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.subject !== void 0) {
        queryParameters["subject"] = requestParameters.subject;
      }
      if (requestParameters.template !== void 0) {
        queryParameters["template"] = requestParameters.template;
      }
      if (requestParameters.timeout !== void 0) {
        queryParameters["timeout"] = requestParameters.timeout;
      }
      if (requestParameters.tokenExpiry !== void 0) {
        queryParameters["token_expiry"] = requestParameters.tokenExpiry;
      }
      if (requestParameters.useGlobalSettings !== void 0) {
        queryParameters["use_global_settings"] = requestParameters.useGlobalSettings;
      }
      if (requestParameters.useSsl !== void 0) {
        queryParameters["use_ssl"] = requestParameters.useSsl;
      }
      if (requestParameters.useTls !== void 0) {
        queryParameters["use_tls"] = requestParameters.useTls;
      }
      if (requestParameters.username !== void 0) {
        queryParameters["username"] = requestParameters.username;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/email/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedEmailStageListFromJSON(jsonValue));
    });
  }
  /**
   * EmailStage Viewset
   */
  stagesEmailList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesEmailListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * EmailStage Viewset
   */
  stagesEmailPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesEmailPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/email/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedEmailStageRequestToJSON(requestParameters.patchedEmailStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EmailStageFromJSON(jsonValue));
    });
  }
  /**
   * EmailStage Viewset
   */
  stagesEmailPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesEmailPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * EmailStage Viewset
   */
  stagesEmailRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesEmailRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/email/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EmailStageFromJSON(jsonValue));
    });
  }
  /**
   * EmailStage Viewset
   */
  stagesEmailRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesEmailRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get all available templates, including custom templates
   */
  stagesEmailTemplatesListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/email/templates/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(TypeCreateFromJSON));
    });
  }
  /**
   * Get all available templates, including custom templates
   */
  stagesEmailTemplatesList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesEmailTemplatesListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * EmailStage Viewset
   */
  stagesEmailUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesEmailUpdate.");
      }
      if (requestParameters.emailStageRequest === null || requestParameters.emailStageRequest === void 0) {
        throw new RequiredError("emailStageRequest", "Required parameter requestParameters.emailStageRequest was null or undefined when calling stagesEmailUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/email/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: EmailStageRequestToJSON(requestParameters.emailStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EmailStageFromJSON(jsonValue));
    });
  }
  /**
   * EmailStage Viewset
   */
  stagesEmailUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesEmailUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesEmailUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesEmailUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/email/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesEmailUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesEmailUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * IdentificationStage Viewset
   */
  stagesIdentificationCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.identificationStageRequest === null || requestParameters.identificationStageRequest === void 0) {
        throw new RequiredError("identificationStageRequest", "Required parameter requestParameters.identificationStageRequest was null or undefined when calling stagesIdentificationCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/identification/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: IdentificationStageRequestToJSON(requestParameters.identificationStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => IdentificationStageFromJSON(jsonValue));
    });
  }
  /**
   * IdentificationStage Viewset
   */
  stagesIdentificationCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesIdentificationCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * IdentificationStage Viewset
   */
  stagesIdentificationDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesIdentificationDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/identification/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * IdentificationStage Viewset
   */
  stagesIdentificationDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesIdentificationDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * IdentificationStage Viewset
   */
  stagesIdentificationListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.caseInsensitiveMatching !== void 0) {
        queryParameters["case_insensitive_matching"] = requestParameters.caseInsensitiveMatching;
      }
      if (requestParameters.enrollmentFlow !== void 0) {
        queryParameters["enrollment_flow"] = requestParameters.enrollmentFlow;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.passwordStage !== void 0) {
        queryParameters["password_stage"] = requestParameters.passwordStage;
      }
      if (requestParameters.passwordlessFlow !== void 0) {
        queryParameters["passwordless_flow"] = requestParameters.passwordlessFlow;
      }
      if (requestParameters.recoveryFlow !== void 0) {
        queryParameters["recovery_flow"] = requestParameters.recoveryFlow;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.showMatchedUser !== void 0) {
        queryParameters["show_matched_user"] = requestParameters.showMatchedUser;
      }
      if (requestParameters.showSourceLabels !== void 0) {
        queryParameters["show_source_labels"] = requestParameters.showSourceLabels;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/identification/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedIdentificationStageListFromJSON(jsonValue));
    });
  }
  /**
   * IdentificationStage Viewset
   */
  stagesIdentificationList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesIdentificationListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * IdentificationStage Viewset
   */
  stagesIdentificationPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesIdentificationPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/identification/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedIdentificationStageRequestToJSON(requestParameters.patchedIdentificationStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => IdentificationStageFromJSON(jsonValue));
    });
  }
  /**
   * IdentificationStage Viewset
   */
  stagesIdentificationPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesIdentificationPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * IdentificationStage Viewset
   */
  stagesIdentificationRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesIdentificationRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/identification/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => IdentificationStageFromJSON(jsonValue));
    });
  }
  /**
   * IdentificationStage Viewset
   */
  stagesIdentificationRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesIdentificationRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * IdentificationStage Viewset
   */
  stagesIdentificationUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesIdentificationUpdate.");
      }
      if (requestParameters.identificationStageRequest === null || requestParameters.identificationStageRequest === void 0) {
        throw new RequiredError("identificationStageRequest", "Required parameter requestParameters.identificationStageRequest was null or undefined when calling stagesIdentificationUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/identification/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: IdentificationStageRequestToJSON(requestParameters.identificationStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => IdentificationStageFromJSON(jsonValue));
    });
  }
  /**
   * IdentificationStage Viewset
   */
  stagesIdentificationUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesIdentificationUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesIdentificationUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesIdentificationUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/identification/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesIdentificationUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesIdentificationUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Invitation Viewset
   */
  stagesInvitationInvitationsCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.invitationRequest === null || requestParameters.invitationRequest === void 0) {
        throw new RequiredError("invitationRequest", "Required parameter requestParameters.invitationRequest was null or undefined when calling stagesInvitationInvitationsCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/invitation/invitations/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: InvitationRequestToJSON(requestParameters.invitationRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => InvitationFromJSON(jsonValue));
    });
  }
  /**
   * Invitation Viewset
   */
  stagesInvitationInvitationsCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesInvitationInvitationsCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Invitation Viewset
   */
  stagesInvitationInvitationsDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.inviteUuid === null || requestParameters.inviteUuid === void 0) {
        throw new RequiredError("inviteUuid", "Required parameter requestParameters.inviteUuid was null or undefined when calling stagesInvitationInvitationsDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/invitation/invitations/{invite_uuid}/`.replace(`{${"invite_uuid"}}`, encodeURIComponent(String(requestParameters.inviteUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Invitation Viewset
   */
  stagesInvitationInvitationsDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesInvitationInvitationsDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Invitation Viewset
   */
  stagesInvitationInvitationsListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.createdByUsername !== void 0) {
        queryParameters["created_by__username"] = requestParameters.createdByUsername;
      }
      if (requestParameters.expires !== void 0) {
        queryParameters["expires"] = requestParameters.expires.toISOString();
      }
      if (requestParameters.flowSlug !== void 0) {
        queryParameters["flow__slug"] = requestParameters.flowSlug;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/invitation/invitations/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedInvitationListFromJSON(jsonValue));
    });
  }
  /**
   * Invitation Viewset
   */
  stagesInvitationInvitationsList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesInvitationInvitationsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Invitation Viewset
   */
  stagesInvitationInvitationsPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.inviteUuid === null || requestParameters.inviteUuid === void 0) {
        throw new RequiredError("inviteUuid", "Required parameter requestParameters.inviteUuid was null or undefined when calling stagesInvitationInvitationsPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/invitation/invitations/{invite_uuid}/`.replace(`{${"invite_uuid"}}`, encodeURIComponent(String(requestParameters.inviteUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedInvitationRequestToJSON(requestParameters.patchedInvitationRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => InvitationFromJSON(jsonValue));
    });
  }
  /**
   * Invitation Viewset
   */
  stagesInvitationInvitationsPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesInvitationInvitationsPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Invitation Viewset
   */
  stagesInvitationInvitationsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.inviteUuid === null || requestParameters.inviteUuid === void 0) {
        throw new RequiredError("inviteUuid", "Required parameter requestParameters.inviteUuid was null or undefined when calling stagesInvitationInvitationsRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/invitation/invitations/{invite_uuid}/`.replace(`{${"invite_uuid"}}`, encodeURIComponent(String(requestParameters.inviteUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => InvitationFromJSON(jsonValue));
    });
  }
  /**
   * Invitation Viewset
   */
  stagesInvitationInvitationsRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesInvitationInvitationsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Invitation Viewset
   */
  stagesInvitationInvitationsUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.inviteUuid === null || requestParameters.inviteUuid === void 0) {
        throw new RequiredError("inviteUuid", "Required parameter requestParameters.inviteUuid was null or undefined when calling stagesInvitationInvitationsUpdate.");
      }
      if (requestParameters.invitationRequest === null || requestParameters.invitationRequest === void 0) {
        throw new RequiredError("invitationRequest", "Required parameter requestParameters.invitationRequest was null or undefined when calling stagesInvitationInvitationsUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/invitation/invitations/{invite_uuid}/`.replace(`{${"invite_uuid"}}`, encodeURIComponent(String(requestParameters.inviteUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: InvitationRequestToJSON(requestParameters.invitationRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => InvitationFromJSON(jsonValue));
    });
  }
  /**
   * Invitation Viewset
   */
  stagesInvitationInvitationsUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesInvitationInvitationsUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesInvitationInvitationsUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.inviteUuid === null || requestParameters.inviteUuid === void 0) {
        throw new RequiredError("inviteUuid", "Required parameter requestParameters.inviteUuid was null or undefined when calling stagesInvitationInvitationsUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/invitation/invitations/{invite_uuid}/used_by/`.replace(`{${"invite_uuid"}}`, encodeURIComponent(String(requestParameters.inviteUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesInvitationInvitationsUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesInvitationInvitationsUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * InvitationStage Viewset
   */
  stagesInvitationStagesCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.invitationStageRequest === null || requestParameters.invitationStageRequest === void 0) {
        throw new RequiredError("invitationStageRequest", "Required parameter requestParameters.invitationStageRequest was null or undefined when calling stagesInvitationStagesCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/invitation/stages/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: InvitationStageRequestToJSON(requestParameters.invitationStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => InvitationStageFromJSON(jsonValue));
    });
  }
  /**
   * InvitationStage Viewset
   */
  stagesInvitationStagesCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesInvitationStagesCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * InvitationStage Viewset
   */
  stagesInvitationStagesDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesInvitationStagesDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/invitation/stages/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * InvitationStage Viewset
   */
  stagesInvitationStagesDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesInvitationStagesDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * InvitationStage Viewset
   */
  stagesInvitationStagesListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.continueFlowWithoutInvitation !== void 0) {
        queryParameters["continue_flow_without_invitation"] = requestParameters.continueFlowWithoutInvitation;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.noFlows !== void 0) {
        queryParameters["no_flows"] = requestParameters.noFlows;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.stageUuid !== void 0) {
        queryParameters["stage_uuid"] = requestParameters.stageUuid;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/invitation/stages/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedInvitationStageListFromJSON(jsonValue));
    });
  }
  /**
   * InvitationStage Viewset
   */
  stagesInvitationStagesList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesInvitationStagesListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * InvitationStage Viewset
   */
  stagesInvitationStagesPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesInvitationStagesPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/invitation/stages/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedInvitationStageRequestToJSON(requestParameters.patchedInvitationStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => InvitationStageFromJSON(jsonValue));
    });
  }
  /**
   * InvitationStage Viewset
   */
  stagesInvitationStagesPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesInvitationStagesPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * InvitationStage Viewset
   */
  stagesInvitationStagesRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesInvitationStagesRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/invitation/stages/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => InvitationStageFromJSON(jsonValue));
    });
  }
  /**
   * InvitationStage Viewset
   */
  stagesInvitationStagesRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesInvitationStagesRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * InvitationStage Viewset
   */
  stagesInvitationStagesUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesInvitationStagesUpdate.");
      }
      if (requestParameters.invitationStageRequest === null || requestParameters.invitationStageRequest === void 0) {
        throw new RequiredError("invitationStageRequest", "Required parameter requestParameters.invitationStageRequest was null or undefined when calling stagesInvitationStagesUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/invitation/stages/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: InvitationStageRequestToJSON(requestParameters.invitationStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => InvitationStageFromJSON(jsonValue));
    });
  }
  /**
   * InvitationStage Viewset
   */
  stagesInvitationStagesUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesInvitationStagesUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesInvitationStagesUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesInvitationStagesUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/invitation/stages/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesInvitationStagesUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesInvitationStagesUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PasswordStage Viewset
   */
  stagesPasswordCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.passwordStageRequest === null || requestParameters.passwordStageRequest === void 0) {
        throw new RequiredError("passwordStageRequest", "Required parameter requestParameters.passwordStageRequest was null or undefined when calling stagesPasswordCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/password/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PasswordStageRequestToJSON(requestParameters.passwordStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordStageFromJSON(jsonValue));
    });
  }
  /**
   * PasswordStage Viewset
   */
  stagesPasswordCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPasswordCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PasswordStage Viewset
   */
  stagesPasswordDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesPasswordDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/password/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * PasswordStage Viewset
   */
  stagesPasswordDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesPasswordDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * PasswordStage Viewset
   */
  stagesPasswordListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.configureFlow !== void 0) {
        queryParameters["configure_flow"] = requestParameters.configureFlow;
      }
      if (requestParameters.failedAttemptsBeforeCancel !== void 0) {
        queryParameters["failed_attempts_before_cancel"] = requestParameters.failedAttemptsBeforeCancel;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/password/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPasswordStageListFromJSON(jsonValue));
    });
  }
  /**
   * PasswordStage Viewset
   */
  stagesPasswordList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPasswordListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PasswordStage Viewset
   */
  stagesPasswordPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesPasswordPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/password/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedPasswordStageRequestToJSON(requestParameters.patchedPasswordStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordStageFromJSON(jsonValue));
    });
  }
  /**
   * PasswordStage Viewset
   */
  stagesPasswordPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPasswordPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PasswordStage Viewset
   */
  stagesPasswordRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesPasswordRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/password/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordStageFromJSON(jsonValue));
    });
  }
  /**
   * PasswordStage Viewset
   */
  stagesPasswordRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPasswordRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PasswordStage Viewset
   */
  stagesPasswordUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesPasswordUpdate.");
      }
      if (requestParameters.passwordStageRequest === null || requestParameters.passwordStageRequest === void 0) {
        throw new RequiredError("passwordStageRequest", "Required parameter requestParameters.passwordStageRequest was null or undefined when calling stagesPasswordUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/password/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: PasswordStageRequestToJSON(requestParameters.passwordStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordStageFromJSON(jsonValue));
    });
  }
  /**
   * PasswordStage Viewset
   */
  stagesPasswordUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPasswordUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesPasswordUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesPasswordUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/password/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesPasswordUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPasswordUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Prompt Viewset
   */
  stagesPromptPromptsCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.promptRequest === null || requestParameters.promptRequest === void 0) {
        throw new RequiredError("promptRequest", "Required parameter requestParameters.promptRequest was null or undefined when calling stagesPromptPromptsCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/prompts/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PromptRequestToJSON(requestParameters.promptRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PromptFromJSON(jsonValue));
    });
  }
  /**
   * Prompt Viewset
   */
  stagesPromptPromptsCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPromptPromptsCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Prompt Viewset
   */
  stagesPromptPromptsDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.promptUuid === null || requestParameters.promptUuid === void 0) {
        throw new RequiredError("promptUuid", "Required parameter requestParameters.promptUuid was null or undefined when calling stagesPromptPromptsDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/prompts/{prompt_uuid}/`.replace(`{${"prompt_uuid"}}`, encodeURIComponent(String(requestParameters.promptUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Prompt Viewset
   */
  stagesPromptPromptsDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesPromptPromptsDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Prompt Viewset
   */
  stagesPromptPromptsListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.fieldKey !== void 0) {
        queryParameters["field_key"] = requestParameters.fieldKey;
      }
      if (requestParameters.label !== void 0) {
        queryParameters["label"] = requestParameters.label;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.placeholder !== void 0) {
        queryParameters["placeholder"] = requestParameters.placeholder;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.type !== void 0) {
        queryParameters["type"] = requestParameters.type;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/prompts/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPromptListFromJSON(jsonValue));
    });
  }
  /**
   * Prompt Viewset
   */
  stagesPromptPromptsList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPromptPromptsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Prompt Viewset
   */
  stagesPromptPromptsPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.promptUuid === null || requestParameters.promptUuid === void 0) {
        throw new RequiredError("promptUuid", "Required parameter requestParameters.promptUuid was null or undefined when calling stagesPromptPromptsPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/prompts/{prompt_uuid}/`.replace(`{${"prompt_uuid"}}`, encodeURIComponent(String(requestParameters.promptUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedPromptRequestToJSON(requestParameters.patchedPromptRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PromptFromJSON(jsonValue));
    });
  }
  /**
   * Prompt Viewset
   */
  stagesPromptPromptsPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPromptPromptsPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Preview a prompt as a challenge, just like a flow would receive
   */
  stagesPromptPromptsPreviewCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.promptRequest === null || requestParameters.promptRequest === void 0) {
        throw new RequiredError("promptRequest", "Required parameter requestParameters.promptRequest was null or undefined when calling stagesPromptPromptsPreviewCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/prompts/preview/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PromptRequestToJSON(requestParameters.promptRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PromptChallengeFromJSON(jsonValue));
    });
  }
  /**
   * Preview a prompt as a challenge, just like a flow would receive
   */
  stagesPromptPromptsPreviewCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPromptPromptsPreviewCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Prompt Viewset
   */
  stagesPromptPromptsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.promptUuid === null || requestParameters.promptUuid === void 0) {
        throw new RequiredError("promptUuid", "Required parameter requestParameters.promptUuid was null or undefined when calling stagesPromptPromptsRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/prompts/{prompt_uuid}/`.replace(`{${"prompt_uuid"}}`, encodeURIComponent(String(requestParameters.promptUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PromptFromJSON(jsonValue));
    });
  }
  /**
   * Prompt Viewset
   */
  stagesPromptPromptsRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPromptPromptsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Prompt Viewset
   */
  stagesPromptPromptsUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.promptUuid === null || requestParameters.promptUuid === void 0) {
        throw new RequiredError("promptUuid", "Required parameter requestParameters.promptUuid was null or undefined when calling stagesPromptPromptsUpdate.");
      }
      if (requestParameters.promptRequest === null || requestParameters.promptRequest === void 0) {
        throw new RequiredError("promptRequest", "Required parameter requestParameters.promptRequest was null or undefined when calling stagesPromptPromptsUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/prompts/{prompt_uuid}/`.replace(`{${"prompt_uuid"}}`, encodeURIComponent(String(requestParameters.promptUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: PromptRequestToJSON(requestParameters.promptRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PromptFromJSON(jsonValue));
    });
  }
  /**
   * Prompt Viewset
   */
  stagesPromptPromptsUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPromptPromptsUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesPromptPromptsUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.promptUuid === null || requestParameters.promptUuid === void 0) {
        throw new RequiredError("promptUuid", "Required parameter requestParameters.promptUuid was null or undefined when calling stagesPromptPromptsUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/prompts/{prompt_uuid}/used_by/`.replace(`{${"prompt_uuid"}}`, encodeURIComponent(String(requestParameters.promptUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesPromptPromptsUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPromptPromptsUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PromptStage Viewset
   */
  stagesPromptStagesCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.promptStageRequest === null || requestParameters.promptStageRequest === void 0) {
        throw new RequiredError("promptStageRequest", "Required parameter requestParameters.promptStageRequest was null or undefined when calling stagesPromptStagesCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/stages/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PromptStageRequestToJSON(requestParameters.promptStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PromptStageFromJSON(jsonValue));
    });
  }
  /**
   * PromptStage Viewset
   */
  stagesPromptStagesCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPromptStagesCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PromptStage Viewset
   */
  stagesPromptStagesDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesPromptStagesDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/stages/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * PromptStage Viewset
   */
  stagesPromptStagesDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesPromptStagesDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * PromptStage Viewset
   */
  stagesPromptStagesListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.fields) {
        queryParameters["fields"] = requestParameters.fields;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.stageUuid !== void 0) {
        queryParameters["stage_uuid"] = requestParameters.stageUuid;
      }
      if (requestParameters.validationPolicies) {
        queryParameters["validation_policies"] = requestParameters.validationPolicies;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/stages/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPromptStageListFromJSON(jsonValue));
    });
  }
  /**
   * PromptStage Viewset
   */
  stagesPromptStagesList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPromptStagesListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PromptStage Viewset
   */
  stagesPromptStagesPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesPromptStagesPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/stages/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedPromptStageRequestToJSON(requestParameters.patchedPromptStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PromptStageFromJSON(jsonValue));
    });
  }
  /**
   * PromptStage Viewset
   */
  stagesPromptStagesPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPromptStagesPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PromptStage Viewset
   */
  stagesPromptStagesRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesPromptStagesRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/stages/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PromptStageFromJSON(jsonValue));
    });
  }
  /**
   * PromptStage Viewset
   */
  stagesPromptStagesRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPromptStagesRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PromptStage Viewset
   */
  stagesPromptStagesUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesPromptStagesUpdate.");
      }
      if (requestParameters.promptStageRequest === null || requestParameters.promptStageRequest === void 0) {
        throw new RequiredError("promptStageRequest", "Required parameter requestParameters.promptStageRequest was null or undefined when calling stagesPromptStagesUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/stages/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: PromptStageRequestToJSON(requestParameters.promptStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PromptStageFromJSON(jsonValue));
    });
  }
  /**
   * PromptStage Viewset
   */
  stagesPromptStagesUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPromptStagesUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesPromptStagesUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesPromptStagesUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/prompt/stages/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesPromptStagesUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesPromptStagesUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SourceStage Viewset
   */
  stagesSourceCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sourceStageRequest === null || requestParameters.sourceStageRequest === void 0) {
        throw new RequiredError("sourceStageRequest", "Required parameter requestParameters.sourceStageRequest was null or undefined when calling stagesSourceCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/source/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SourceStageRequestToJSON(requestParameters.sourceStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SourceStageFromJSON(jsonValue));
    });
  }
  /**
   * SourceStage Viewset
   */
  stagesSourceCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesSourceCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SourceStage Viewset
   */
  stagesSourceDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesSourceDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/source/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SourceStage Viewset
   */
  stagesSourceDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesSourceDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SourceStage Viewset
   */
  stagesSourceListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.resumeTimeout !== void 0) {
        queryParameters["resume_timeout"] = requestParameters.resumeTimeout;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.source !== void 0) {
        queryParameters["source"] = requestParameters.source;
      }
      if (requestParameters.stageUuid !== void 0) {
        queryParameters["stage_uuid"] = requestParameters.stageUuid;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/source/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSourceStageListFromJSON(jsonValue));
    });
  }
  /**
   * SourceStage Viewset
   */
  stagesSourceList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesSourceListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SourceStage Viewset
   */
  stagesSourcePartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesSourcePartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/source/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSourceStageRequestToJSON(requestParameters.patchedSourceStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SourceStageFromJSON(jsonValue));
    });
  }
  /**
   * SourceStage Viewset
   */
  stagesSourcePartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesSourcePartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SourceStage Viewset
   */
  stagesSourceRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesSourceRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/source/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SourceStageFromJSON(jsonValue));
    });
  }
  /**
   * SourceStage Viewset
   */
  stagesSourceRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesSourceRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SourceStage Viewset
   */
  stagesSourceUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesSourceUpdate.");
      }
      if (requestParameters.sourceStageRequest === null || requestParameters.sourceStageRequest === void 0) {
        throw new RequiredError("sourceStageRequest", "Required parameter requestParameters.sourceStageRequest was null or undefined when calling stagesSourceUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/source/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SourceStageRequestToJSON(requestParameters.sourceStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SourceStageFromJSON(jsonValue));
    });
  }
  /**
   * SourceStage Viewset
   */
  stagesSourceUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesSourceUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesSourceUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesSourceUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/source/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesSourceUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesSourceUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserDeleteStage Viewset
   */
  stagesUserDeleteCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.userDeleteStageRequest === null || requestParameters.userDeleteStageRequest === void 0) {
        throw new RequiredError("userDeleteStageRequest", "Required parameter requestParameters.userDeleteStageRequest was null or undefined when calling stagesUserDeleteCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_delete/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: UserDeleteStageRequestToJSON(requestParameters.userDeleteStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserDeleteStageFromJSON(jsonValue));
    });
  }
  /**
   * UserDeleteStage Viewset
   */
  stagesUserDeleteCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserDeleteCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserDeleteStage Viewset
   */
  stagesUserDeleteDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserDeleteDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_delete/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * UserDeleteStage Viewset
   */
  stagesUserDeleteDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesUserDeleteDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * UserDeleteStage Viewset
   */
  stagesUserDeleteListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.stageUuid !== void 0) {
        queryParameters["stage_uuid"] = requestParameters.stageUuid;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_delete/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedUserDeleteStageListFromJSON(jsonValue));
    });
  }
  /**
   * UserDeleteStage Viewset
   */
  stagesUserDeleteList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserDeleteListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserDeleteStage Viewset
   */
  stagesUserDeletePartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserDeletePartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_delete/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedUserDeleteStageRequestToJSON(requestParameters.patchedUserDeleteStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserDeleteStageFromJSON(jsonValue));
    });
  }
  /**
   * UserDeleteStage Viewset
   */
  stagesUserDeletePartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserDeletePartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserDeleteStage Viewset
   */
  stagesUserDeleteRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserDeleteRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_delete/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserDeleteStageFromJSON(jsonValue));
    });
  }
  /**
   * UserDeleteStage Viewset
   */
  stagesUserDeleteRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserDeleteRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserDeleteStage Viewset
   */
  stagesUserDeleteUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserDeleteUpdate.");
      }
      if (requestParameters.userDeleteStageRequest === null || requestParameters.userDeleteStageRequest === void 0) {
        throw new RequiredError("userDeleteStageRequest", "Required parameter requestParameters.userDeleteStageRequest was null or undefined when calling stagesUserDeleteUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_delete/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: UserDeleteStageRequestToJSON(requestParameters.userDeleteStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserDeleteStageFromJSON(jsonValue));
    });
  }
  /**
   * UserDeleteStage Viewset
   */
  stagesUserDeleteUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserDeleteUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesUserDeleteUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserDeleteUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_delete/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesUserDeleteUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserDeleteUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserLoginStage Viewset
   */
  stagesUserLoginCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.userLoginStageRequest === null || requestParameters.userLoginStageRequest === void 0) {
        throw new RequiredError("userLoginStageRequest", "Required parameter requestParameters.userLoginStageRequest was null or undefined when calling stagesUserLoginCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_login/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: UserLoginStageRequestToJSON(requestParameters.userLoginStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserLoginStageFromJSON(jsonValue));
    });
  }
  /**
   * UserLoginStage Viewset
   */
  stagesUserLoginCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserLoginCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserLoginStage Viewset
   */
  stagesUserLoginDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserLoginDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_login/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * UserLoginStage Viewset
   */
  stagesUserLoginDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesUserLoginDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * UserLoginStage Viewset
   */
  stagesUserLoginListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.geoipBinding !== void 0) {
        queryParameters["geoip_binding"] = requestParameters.geoipBinding;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.networkBinding !== void 0) {
        queryParameters["network_binding"] = requestParameters.networkBinding;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.rememberMeOffset !== void 0) {
        queryParameters["remember_me_offset"] = requestParameters.rememberMeOffset;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.sessionDuration !== void 0) {
        queryParameters["session_duration"] = requestParameters.sessionDuration;
      }
      if (requestParameters.stageUuid !== void 0) {
        queryParameters["stage_uuid"] = requestParameters.stageUuid;
      }
      if (requestParameters.terminateOtherSessions !== void 0) {
        queryParameters["terminate_other_sessions"] = requestParameters.terminateOtherSessions;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_login/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedUserLoginStageListFromJSON(jsonValue));
    });
  }
  /**
   * UserLoginStage Viewset
   */
  stagesUserLoginList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserLoginListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserLoginStage Viewset
   */
  stagesUserLoginPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserLoginPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_login/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedUserLoginStageRequestToJSON(requestParameters.patchedUserLoginStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserLoginStageFromJSON(jsonValue));
    });
  }
  /**
   * UserLoginStage Viewset
   */
  stagesUserLoginPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserLoginPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserLoginStage Viewset
   */
  stagesUserLoginRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserLoginRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_login/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserLoginStageFromJSON(jsonValue));
    });
  }
  /**
   * UserLoginStage Viewset
   */
  stagesUserLoginRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserLoginRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserLoginStage Viewset
   */
  stagesUserLoginUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserLoginUpdate.");
      }
      if (requestParameters.userLoginStageRequest === null || requestParameters.userLoginStageRequest === void 0) {
        throw new RequiredError("userLoginStageRequest", "Required parameter requestParameters.userLoginStageRequest was null or undefined when calling stagesUserLoginUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_login/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: UserLoginStageRequestToJSON(requestParameters.userLoginStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserLoginStageFromJSON(jsonValue));
    });
  }
  /**
   * UserLoginStage Viewset
   */
  stagesUserLoginUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserLoginUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesUserLoginUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserLoginUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_login/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesUserLoginUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserLoginUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserLogoutStage Viewset
   */
  stagesUserLogoutCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.userLogoutStageRequest === null || requestParameters.userLogoutStageRequest === void 0) {
        throw new RequiredError("userLogoutStageRequest", "Required parameter requestParameters.userLogoutStageRequest was null or undefined when calling stagesUserLogoutCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_logout/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: UserLogoutStageRequestToJSON(requestParameters.userLogoutStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserLogoutStageFromJSON(jsonValue));
    });
  }
  /**
   * UserLogoutStage Viewset
   */
  stagesUserLogoutCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserLogoutCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserLogoutStage Viewset
   */
  stagesUserLogoutDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserLogoutDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_logout/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * UserLogoutStage Viewset
   */
  stagesUserLogoutDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesUserLogoutDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * UserLogoutStage Viewset
   */
  stagesUserLogoutListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.stageUuid !== void 0) {
        queryParameters["stage_uuid"] = requestParameters.stageUuid;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_logout/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedUserLogoutStageListFromJSON(jsonValue));
    });
  }
  /**
   * UserLogoutStage Viewset
   */
  stagesUserLogoutList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserLogoutListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserLogoutStage Viewset
   */
  stagesUserLogoutPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserLogoutPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_logout/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedUserLogoutStageRequestToJSON(requestParameters.patchedUserLogoutStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserLogoutStageFromJSON(jsonValue));
    });
  }
  /**
   * UserLogoutStage Viewset
   */
  stagesUserLogoutPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserLogoutPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserLogoutStage Viewset
   */
  stagesUserLogoutRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserLogoutRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_logout/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserLogoutStageFromJSON(jsonValue));
    });
  }
  /**
   * UserLogoutStage Viewset
   */
  stagesUserLogoutRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserLogoutRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserLogoutStage Viewset
   */
  stagesUserLogoutUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserLogoutUpdate.");
      }
      if (requestParameters.userLogoutStageRequest === null || requestParameters.userLogoutStageRequest === void 0) {
        throw new RequiredError("userLogoutStageRequest", "Required parameter requestParameters.userLogoutStageRequest was null or undefined when calling stagesUserLogoutUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_logout/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: UserLogoutStageRequestToJSON(requestParameters.userLogoutStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserLogoutStageFromJSON(jsonValue));
    });
  }
  /**
   * UserLogoutStage Viewset
   */
  stagesUserLogoutUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserLogoutUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesUserLogoutUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserLogoutUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_logout/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesUserLogoutUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserLogoutUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserWriteStage Viewset
   */
  stagesUserWriteCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.userWriteStageRequest === null || requestParameters.userWriteStageRequest === void 0) {
        throw new RequiredError("userWriteStageRequest", "Required parameter requestParameters.userWriteStageRequest was null or undefined when calling stagesUserWriteCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_write/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: UserWriteStageRequestToJSON(requestParameters.userWriteStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserWriteStageFromJSON(jsonValue));
    });
  }
  /**
   * UserWriteStage Viewset
   */
  stagesUserWriteCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserWriteCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserWriteStage Viewset
   */
  stagesUserWriteDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserWriteDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_write/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * UserWriteStage Viewset
   */
  stagesUserWriteDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.stagesUserWriteDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * UserWriteStage Viewset
   */
  stagesUserWriteListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.createUsersAsInactive !== void 0) {
        queryParameters["create_users_as_inactive"] = requestParameters.createUsersAsInactive;
      }
      if (requestParameters.createUsersGroup !== void 0) {
        queryParameters["create_users_group"] = requestParameters.createUsersGroup;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.stageUuid !== void 0) {
        queryParameters["stage_uuid"] = requestParameters.stageUuid;
      }
      if (requestParameters.userCreationMode !== void 0) {
        queryParameters["user_creation_mode"] = requestParameters.userCreationMode;
      }
      if (requestParameters.userPathTemplate !== void 0) {
        queryParameters["user_path_template"] = requestParameters.userPathTemplate;
      }
      if (requestParameters.userType !== void 0) {
        queryParameters["user_type"] = requestParameters.userType;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_write/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedUserWriteStageListFromJSON(jsonValue));
    });
  }
  /**
   * UserWriteStage Viewset
   */
  stagesUserWriteList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserWriteListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserWriteStage Viewset
   */
  stagesUserWritePartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserWritePartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_write/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedUserWriteStageRequestToJSON(requestParameters.patchedUserWriteStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserWriteStageFromJSON(jsonValue));
    });
  }
  /**
   * UserWriteStage Viewset
   */
  stagesUserWritePartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserWritePartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserWriteStage Viewset
   */
  stagesUserWriteRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserWriteRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_write/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserWriteStageFromJSON(jsonValue));
    });
  }
  /**
   * UserWriteStage Viewset
   */
  stagesUserWriteRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserWriteRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * UserWriteStage Viewset
   */
  stagesUserWriteUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserWriteUpdate.");
      }
      if (requestParameters.userWriteStageRequest === null || requestParameters.userWriteStageRequest === void 0) {
        throw new RequiredError("userWriteStageRequest", "Required parameter requestParameters.userWriteStageRequest was null or undefined when calling stagesUserWriteUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_write/{stage_uuid}/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: UserWriteStageRequestToJSON(requestParameters.userWriteStageRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => UserWriteStageFromJSON(jsonValue));
    });
  }
  /**
   * UserWriteStage Viewset
   */
  stagesUserWriteUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserWriteUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesUserWriteUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.stageUuid === null || requestParameters.stageUuid === void 0) {
        throw new RequiredError("stageUuid", "Required parameter requestParameters.stageUuid was null or undefined when calling stagesUserWriteUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/stages/user_write/{stage_uuid}/used_by/`.replace(`{${"stage_uuid"}}`, encodeURIComponent(String(requestParameters.stageUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  stagesUserWriteUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.stagesUserWriteUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
};

export {
  AuthTypeEnum,
  AuthenticatorAttachmentEnum,
  ProviderEnum,
  DigitsEnum,
  DeviceClassesEnum,
  NotConfiguredActionEnum,
  UserVerificationEnum,
  WebAuthnDeviceTypeFromJSON,
  ResidentKeyRequirementEnum,
  BackendsEnum,
  ConsentStageModeEnum,
  GeoipBindingEnum,
  UserFieldsEnum,
  NetworkBindingEnum,
  StagesApi
};
//# sourceMappingURL=chunk-6L2VIJJF.js.map
